;	****************************************
;	Routine polling a new abs value from al.
;	****************************************
topabs:
	cmp	al,14h
	je	gio14tct
	cmp	al,16h
	je	gio16b
	cmp	al,17h
	je	gio17b
;
topabs3:			;point to return after a completed command
	mov	di,gio_now1
	mov	byte ptr [di],0 ;reset to zero except shift-reset
	inc	di
	or	byte ptr [di],gio_rb
;	dec	di			;sequence may be vital here
topabs1:
;
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	topabs9 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	topabs1 			;not yet
;
	test	al,gio_abs
	jnz	topabs				;new start
	jmp	topabs3
topabs9:
	jmp	cretvp				;leave the GIO command
;
gio16b:
	jmp	gio16tct
gio17b:
	jmp	gio17
;
;	*************************************************************
;	The condition of gio commands to the slave printer
;	MXF should be latched to this port after the service is over.
;	*************************************************************
;	Check whether TC activated ?
gio14tct:
	mov	di,tc_who
	cmp	byte ptr es:[di],0
	jz	gio14			;Leave TC to care terminal
;	mov	di,flag3		;@@@
;	or	byte ptr [di],0ffh	;0ffh for jump table 04
	jmp	tc04
;
gio14:
;	Tell OS386 this port is ready to accept data
;
	mov	di,rbi
	mov	si,gio_now2
	test	byte ptr [di],prtrb	;buffer full?
	jnz	gio14y			;jump if buffer not full
;
;	Buffer is full! Reset 04 ready bit.
	mov	al,es:rbibus
	or	al,byte ptr [di]
	mov	di,rbimask
	and	al,byte ptr [di]
	and	byte ptr [si],not gio_rb	;Tell OS it's gonna be full
;	testing Dec/17
	mov	si,gio_over
	cmp	byte ptr [si],0ffh
	jz	gio4bye 		;disable is coming
;	test end Dec/17
	jmp	gio14
gio14y:
	or	byte ptr [si],gio_rb		;okay to go on
gio0432:
;
gio14n:
;
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	gio4bye 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	gio14n				;not yet
;
	test	al,gio_obs
	jnz	gio14f				;get the data
	test	al,gio_abs
	jnz	gio14cc 			;new start
;						 discard the rest
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	gio14
gio14cc:
	mov	di,gio_data
	mov	al,[di]
;
	mov	di,gio_now1
	mov	byte ptr [di],0 	;point at gio_now1
	jmp	topabs
;
gio14f: 				;receive the data
	mov	di,gio_data
	mov	al,[di]
	mov	di,gio_now1
	mov	byte ptr [di],0 	;point at gio_now1
	call	putprt
;
	jmp	gio14
gio4bye:
;
;	bugging for pac-man 25/jan
	mov	di,gio_now1
	test	byte ptr [di],gio_obs
	jnz	gio14f				;get the data
;	end for pac-man 25/jan
;
diager: 			;Point entry to end TC error command
	mov	si,gio_over
	mov	byte ptr [si],0
	mov	di,gio_now1
	mov	byte ptr [di],0 	;data had been taken
	mov	si,gio_now2
	mov	byte ptr [si],0 		;reset to ready
	mov	di,gio_sts
	mov	byte ptr [di],0f1h	;acknowledged
	ret
;
;	**************************************************************
;	The condition of gio commands to the CRT
;	MXF should be latched to this port after the service is over.
;	**************************************************************
gio17:
;	Tell OS386 this port is ready to accept data
;
	mov	di,rbi
	mov	si,gio_now2
	test	byte ptr [di],crtrb	;buffer full?
	jnz	gio17y			;jump if buffer not full
;
;	Buffer is full! Reset 07 ready bit.
	mov	al,es:rbibus
	or	al,byte ptr [di]
	mov	di,rbimask
	and	al,byte ptr [di]
	and	byte ptr [si],not gio_rb	;Tell OS it's gonna be full
;	testing Dec/17
	mov	si,gio_over
	cmp	byte ptr [si],0ffh
	jz	gio7bye 		;disable is coming
;	test end Dec/17
	jmp	gio17
gio17y:
	or	byte ptr [si],gio_rb		;okay to go on
gio0732:
;
gio17n:
;
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	gio7bye 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	gio17n				;not yet
;
	test	al,gio_obs
	jnz	gio17f				;get the data
	test	al,gio_abs
	jnz	gio17cc 			;new start
;						 discard the rest
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	gio17
gio17cc:
	mov	di,gio_data
	mov	al,[di]
;
	mov	di,gio_now1
	mov	byte ptr [di],0 	;point at gio_now1
	jmp	topabs
;
gio17f: 				;receive the data
	mov	di,gio_data
	mov	al,[di]
	mov	di,gio_now1
	mov	byte ptr [di],0 	;point at gio_now1
	call	putcrtg
;
	jmp	gio17
gio7bye:
;
;	bugging for pac-man 25/jan
	mov	di,gio_now1
	test	byte ptr [di],gio_obs
	jnz	gio17f				;get the data
;	end for pac-man 25/jan
;
	mov	si,gio_over
	mov	byte ptr [si],0
	mov	di,gio_now1
	mov	byte ptr [di],0 	;data had been taken
	mov	si,gio_now2
	mov	byte ptr [si],0 		;reset to ready
	mov	di,gio_sts
	mov	byte ptr [di],0f1h	;acknowledged
	ret
;
topabsx1:
	jmp	topabs
;
;	**************************************************************
;	The condition of gio commands for the command thru abs 06
;	MXF should be latched to this port after the service is over.
;	**************************************************************
gio16tct:
	mov	di,tc_who
	cmp	byte ptr es:[di],0
	jz	gio16			;Leave TC to care terminal
;	mov	di,flag3		;@@@
;	or	byte ptr [di],0ffh	;0ffh for jump table 04
	jmp	tc06
gio16:
	mov	di,gio_now1
	mov	byte ptr [di],0 	;data had been taken
gio16ny:
	mov	si,gio_now2
	or	byte ptr [si],gio_rb	;reset to ready
gio161:
;
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	cretvp			;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	gio161				;not yet
;
	test	al,gio_cbs
	jnz	gio16f				;get the data
	test	al,gio_abs
	jnz	topabsjj			;new start
;	Discard the rest, and polling next input
	jmp	gio16
;
topabsjj:
	mov	di,gio_data
	mov	al,[di]
	jmp	topabs
;
gio16f: 				;yes, cbs is ready
	mov	di,gio_data
	mov	al,[di] 		;receive the cbs value
	mov	di,gio_now1
	and	byte ptr [di],g_int	;data had been taken
	mov	si,gio_now2
	or	byte ptr [si],gio_rb	;reset to ready
;
	cmp	al,maxcv	;Limit entry within total entries.
	ja	cretvp
	xor	ah,ah
	shl	ax,1
	mov	si,ax
;
;	Check which table to jmup, terminal or TC?
;	 mov	 di,tc_who
;	 cmp	 byte ptr [di],0
;
;	 jz	 tmnalj 		 ;terminal jump table
;	mov	di,flag3
;	cmp	byte ptr [di],0ffh
;	jz	tcgio14
;	jmp	cs:tab06tc[si]		;TC jump table, address 16
;tcgio14:				 ;TC jmup table, address 14
;	 mov	 di,flag3
;	 mov	 byte ptr [di],0
;	 jmp	 cs:tctab04[si]
;
;tmnalj:
	jmp	cs:crtnv[si]
cretvp:
;cretv:
	mov	si,gio_over
	mov	byte ptr [si],0
	mov	di,gio_now1
	mov	byte ptr [di],0 	;data had been taken
	mov	si,gio_now2
	mov	byte ptr [si],0 	;reset to ready
	mov	di,gio_sts
	mov	byte ptr [di],0f1h	;acknowledged
	ret
;
;	**********************************************************************
crtnv	dw	cretvp		;00, no operation
	dw	c0601v		;01, power on, an interrupt command
	dw	c0602v		;02, initialize terminal
	dw	c0603v		;03, delete line request, an interrupt command
	dw	cretvp		;04, not support
	dw	cretvp		;05, not support
	dw	c0606v		;06, get key, an interrupt command
	dw	c0607v		;07, line request
	dw	c0608v		;08, prefill line request
	dw	c0609v		;09, refill line request
	dw	c060av		;0a, end of line request
	dw	c060bv		;0b, Query Line Request
	dw	c060cv		;0c, Accept LR, OS read directly from lr buffer
	dw	cretvp		;0d, request CRT buffer - Not support
	dw	cretvp		;0e, request PRT buffer - Not support
	dw	c060fv		;0f, error line request
	dw	c0610v		;10, terminate line request
	dw	c0611v		;11, not support
	dw	cretvp		;12, not support
	dw	cretvp		;13, not support
	dw	cretvp		;14, not support
	dw	cretvp		;15, undefined
	dw	cretvp		;16, undefined
	dw	cretvp		;17, undefined
	dw	cretvp		;18, undefined
	dw	cretvp		;19, undefined
	dw	cretvp		;1a, undefined
	dw	cretvp		;1b, undefined
	dw	cretvp		;1c, undefined
	dw	cretvp		;1d, undefined
	dw	cretvp		;1e, undefined
	dw	cretvp		;1f, undefined
	dw	c0620v		;20, $MXF command
	dw	c0621v		;21, return results of $MXF command
	dw	c0622v		;22, enable connect
	dw	c0623v		;23, disable connect
	dw	c0624v		;24, enable disconnect
	dw	c0625v		;25, disable disconnect
	dw	c0626v		;26, Alert CS system to all connected ports
	dw	c0627v		;27, clear pending disconnection
	dw	cretvp		;28, get ID of terminal
	dw	c0629v		;29, initiate remote screen dump
	dw	c062av		;2a, abort remote screen dump
	dw	c062bv		;2b, initiate remote screen dump
	dw	c062cv		;2c, reconnect port
	dw	c062dv		;2d, select special package, TC function
	dw	c062ev		;2e, set MXF password
maxcv	equ	($ - crtnv)/2	;Total entries
;
c0601v:
;	********************************************************************
;	Routine issues the power-on command which will restart the machine.
;	Asking the user sure about this !
;	********************************************************************
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h
	mov	si,head_rom
	jmp	dword ptr es:[si]
;
topabsx2:
	jmp	topabs
;
c0602v: 		    ;j*
;	*****************************************
;	Routine initializes the current terminal
;	*****************************************
	call	rstbufk
	call	rstbufc
	call	rstlr
	call	rstterm 	;check?
				;See if prt needs clearing
	call	two386i
	jnz	c0602vi
	jc	topabsx2
	jmp	cretvp
c0602vi:
;	mov	di,gio_data
;	mov	al,[di]
	cmp	al,0		;if 01 then clear CRT only, 00 PRT also
	jnz	c0602vn 	;Leave if not zero
	call	rstbufp
c0602vm:
	mov	al,esccode	;Output escape code
	call	putcrtg
	mov	al,termrst	;terminal reset code
	call	putcrtg
	call	rstterm1	;check? waste time to let terminal reset
;	mov	al,0ffh 	;change al to skip c0602vn
c0602vn:
;	cmp	al,01
;	jz	c0602vm
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0603v: 			;j*
;	*********
;	Delete LR
;	*********
	mov	di,lrbyte
	and	byte ptr [di],not lrbit
	and	byte ptr [di],not lrendbit
	call	lrout
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
;c0604v:		       ;j+
;	**********************************************************************
;	Routine check keyboard buffer, notice OS whether empty or occupied
;	**********************************************************************
;	 sti
;	 mov	 di,key_count
;	 cmp	 byte ptr [di],0
;	 jz	 c0604vc
;;	 mov	 si,sts_byte
;;	 or	 byte ptr [si],01h	 ;means key buffer not empty
;c0604vi:
;	 mov	 al,0ffh
;	 jmp	 c0604vd
;
;c0604vc:
;	 call	 rxin
;	 call	 rxin
;	 mov	 di,key_count
;	 cmp	 byte ptr [di],0
;	 jnz	 c0604vi
;
;c0604vo:
;	%%% testing for disable GIO Dec/16
;	 mov	 si,gio_over
;	 cmp	 byte ptr [si],0ffh	 ;OS disable?
;	 jz	 cretvpi		 ;yes, jump out of GIO
;	%%% End %%%
;
;	Looking for -maybe- ibs
;	 mov	 di,gio_now1
;	 mov	 al,[di]
;	 cmp	 al,0
;	 jz	 c0604vo			 ;not yet
;
;	 test	 al,gio_ibs
;	 jnz	 c060406			 ;to send one byte
;	 test	 al,gio_abs
;	 jnz	 topa64 			;new start
;
;	 jmp	 c0604vo
;c060406:
;	 mov	 al,0
;
;c0604vd:
;	 mov	 di,gio_now2
;	 test	 byte ptr [di],gio_cpb	 ;CPU ready?
;	 jnz	 c0604vd
;
;	 mov	 si,gio_data		 ;Yes
;	 mov	 [si],al
;	 or	 byte ptr [di],gio_cpb	 ;set busy
;
;	 mov	 di,intbyte
;	 or	 byte ptr [di],keyint
;	 jmp	 gio16ny
;
;topa64:
;	 mov	 di,gio_data
;	 mov	 al,[di]
;	 mov	 di,gio_now1
;	 mov	 byte ptr [di],0		 ;point at gio_now1
;
;	 jmp	 topabs
;
c0606v: 			;j*
;	**********************************************************************
;	Routine passes a byte from keyboard to OS, under the waiting condition
;	of OS. So, interrupt OS when the byte is ready.
;	**********************************************************************
	sti
	mov	di,key_count
	cmp	byte ptr [di],0
	jnz	c0606vy 	;Yes, interrupt OS and send the bytes.
;
;	mov	si,sts_byte
;	and	byte ptr [si],0feh	;means key buffer empty
c0606vo:
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	cretvpi 		;yes, jump out of GIO
;	%%% End %%%
;
;	Looking for -maybe- ibs
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	c0606vo 			;not yet
;
	test	al,gio_ibs
	jnz	c060606 			;to send one byte
	test	al,gio_abs
	jnz	topabbs 			;new start
;
;	bugging july/11/91
;	mov	di,gio_now1
;	mov	byte ptr [di],0 		;point at gio_now1
;	end july/11/91
;
	jmp	c0606vo
;
c060606:
	mov	ax,0
	mov	cx,1			;only one data is necessary
	mov	di,gio_now2
	jmp	c0606vt
;
cretvpi:
	jmp	cretvp
;
c0606vy:
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	cretvpi 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	c0606vy 			;not yet
;
	test	al,gio_ibs
	jnz	c0606vl
	test	al,gio_abs
	jnz	topabbs 			;new start
;
;	who-r-u debug, 9/dec/91
;	mov	di,gio_now1
;	mov	byte ptr [di],0 		;point at gio_now1
;	who-r-u debug, 9/dec/91, end
;
	jmp	c0606vy
topabbs:
	mov	di,gio_data
	mov	al,[di]
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	topabs
c0606vl:
	call	getkeyt 	;Now, ah = attribute, al = byte gotten
;	mov	si,sts_byte
;	or	byte ptr [si],01h	;means key buffer not empty
	cmp	ah,01
	jnz	c0606vc
	mov	di,gio_now2
	or	byte ptr [di],gio_ib9
	jmp	c0606v6
c0606vc:
	mov	di,gio_now2
	and	byte ptr [di],not gio_ib9
c0606v6:
	mov	ah,al
	or	al,0ffh
	mov	cx,2
c0606vt:
	test	byte ptr [di],gio_cpb	;CPU ready?
	jnz	c0606vt
;
	mov	si,gio_data		;Yes
	mov	[si],al
	or	byte ptr [di],gio_cpb	;set busy
;	dec	di			;point at gio_now1
;	and	byte ptr [di],g_int	;clear except shift-reset
;
	mov	al,ah
	loop	c0606vt
;
;	may/14/92
	mov	di,flag9
;	mov	di,curnt_sts
	and	byte ptr [di],not keyint
;	may/14/92, end
	mov	di,intbyte
	or	byte ptr [di],keyint
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
topabsx:
	jmp	topabs
;
c0607v: 			;j*
;	******************************************************************
;	There will be formatted data coming as : (17 xxxx yy zz)
;	Access these data in the parameter of command data
;	xxxx = max. byte # of LR, yy = 80 bit/underline LR
;	yy = 04 bit/start in edit mode, yy = 01 bit/flush keybuf before LR
;	zz = column to start LR on.
;	******************************************************************
;
	call	two386i 		;get 2 bytes from OS386
	jnz	c0607vk
	jc	topabsx 		;abs came
	jmp	cretvp			;dis or sh-ret
c0607vk:
	mov	ah,al
	call	two386i
	jnz	c0607vk1
	jc	topabsx 		;abs came
	jmp	cretvp			;dis or sh-ret
c0607vk1:
	mov	di,lrcnt
	mov	[di],ax 		;count
;
	mov	di,lrstop
	mov	[di],ax 		;The absolute end of LR buffer
;
	call	two386i 		;get 2 bytes from OS386
	jnz	c0607vh
	jc	topabsx 		;abs came
	jmp	cretvp			;dis or sh-ret
c0607vh:
	mov	ah,al
	call	two386i
	jnz	c0607vh1
	jc	topabsx 		;abs came
	jmp	cretvp			;dis or sh-ret
c0607vh1:
;
	mov	di,lrinit
	mov	[di],ah
	inc	di			;point at lrstart
	mov	[di],al 		;start position here, current column?
;
	test	ah,flushbit
	jz	c06071v
	call	rstbufk 		;Flush key_buf first
c06071v:
	mov	di,lrinit
	mov	al,[di]
	and	al,underon+editon	;just want underline and edit bit
	mov	di,lrbyte
	mov	[di],al
	test	al,editbit
	jz	c0607zv
	or	byte ptr [di],editbit
c0607zv:
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0608v: 				;j*
;	***********************************************************
;	Routine prefills LR buffer, cursor at the beginning.
;	Desired line should be filled in LR buffer which were put
;	directly by CS386. Count is in lr_count by OS/386.
;	***********************************************************
	mov	di,lrinit
	and	byte ptr [di],not fillbit	;prefill mode
	mov	di,lrwr
	mov	word ptr [di],0 		;beginning of buffer
	mov	di,lrstop
	mov	ax,[di]
;	mov	si,lr_buf
;	sub	ax,si
	mov	di,lrcnt
	mov	[di],ax 		;lrcnt = empty buffer
	call	addlrgio		;Beware! prefill from LR buffer
					;while refill from command parameter.
	jnz	c0608v3
	jc	topabsx5
	jmp	cretvp
c0608v3:
	mov	di,lrwr
	mov	word ptr [di],0
;	Set print flag, addlr already set lrwrp1 to the buffer beginning
;	and lrwrp2 to the end of added string. If in underline mode,
;	Go ahead print the entire buffer.
	mov	di,lrinit
	test	byte ptr [di],underbit
	jz	c0608vz
;	Set lrwrp2 to end of buffer since this is an underlined LR, under
;	lines must be put on screen first.
	mov	di,lrstop
	mov	ax,[di]
	add	di,4			;point at lrwrp2
	mov	[di],ax
c0608vz:
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0609v: 				;j*
;	***********************************************************
;	Routine Refills LR buffer, cursor at the end of buffer.
;	Desired line should be filled in parameter part of command
;	that filled by CS386.
;	***********************************************************
	mov	di,lrinit
	or	byte ptr [di],fillbit	;fillbit = 1/ Refill mode
	call	addlrgio
	jnz	c0609v3
	jc	topabsx5
	jmp	cretvp
c0609v3:
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
topabsx5:
	jmp	topabs
;
c060av: 				;j*
;	**********************************************************************
;	Routine executes the end-of-LR command which will cause termination of
;	the sequence of LR command.
;	**********************************************************************
	sti
	mov	di,lrbyte
	and	byte ptr [di],not lrendbit
;
;	Mask off address 07 so no printing to CRT occur until MXE ready. check???
	mov	di,outblock
	or	byte ptr [di],lrblock
	mov	di,rbimask
	and	byte ptr [di],not crtrb 	;mask CRT
;
	mov	al,curson
	call	putcrtg 		;put one byte to crt_buf
	mov	di,lrbyte
	or	byte ptr [di],prtlr
	or	byte ptr [di],lron
	test	byte ptr [di],editbit
	jz	c060a1v
;
;	push	es
	mov	si,blink		;output messages
	mov	cl,blinks
	xor	ch,ch
	call	putstr
c060a1v:
	mov	di,lrquery
	mov	byte ptr [di],01h
	call	lrout
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c060bv: 				;j*
;	**********************************************
;	MXF should answer this command as following:
;	00 - No line request in progress
;	01 - Line request still in progress
;	0d - Line request terminate by carriage/return
;	ff - Recall key press
;	**********************************************
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	cretvs			;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	c060bv
;
	test	al,gio_ibs
	jnz	c060bvl
	test	al,gio_abs
	jnz	topapps 			;new start
;
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	c060bv
topapps:
	mov	di,gio_data
	mov	al,[di]
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	topabs
;
c060bvl:
	mov	di,lrquery
	mov	al,[di]
	cmp	al,0feh
	jae	c060b2v 		;SF or Recall key?
c060b6v:
	mov	di,gio_now2
	and	byte ptr [di],not gio_ib9
;	mov	di,cmd_parm+1		;Neither !
;	mov	byte ptr [di],0
;	dec	di
;	mov	[di],al
	jmp	c060bzv 		;go back
;
c060b2v:
	jnz	c060b3v 		;jmp if 'ff'
	mov	di,lrsfb
	mov	al,[di]
	mov	di,gio_now2
	or	byte ptr [di],gio_ib9	;endi
;
;	mov	di,cmd_parm+1
;	mov	byte ptr [di],01	;with endi
;	dec	di
;	mov	[di],ah
	jmp	c060bzv
c060b3v:				;recall key pressed
	mov	al,0ffh
	jmp	c060b6v
c060bzv:
	mov	si,gio_now2
	test	byte ptr [si],gio_cpb	;cpu ready?
	jnz	c060bzv
	mov	di,gio_data
	mov	[di],al
	or	byte ptr [si],gio_cpb	;data is ready
c060bzi:
;
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f0h	;return with value
;	may/14/92
	mov	di,flag9
;	mov	di,curnt_sts
	and	byte ptr [di],not lrint
;	may/14/92, end
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
cretvs:
	jmp	cretvp
;
c060cv:
;	****************************************************************
;	OS is ready to accept the data, so compute # of byte in lr_count
;	****************************************************************
;	mov	di,lr_buf
	mov	si,lrwre
	mov	ax,word ptr [si]
;	sub	ax,di
	mov	di,lr_count
	mov	[di],ax
	mov	di,lrbyte
	and	byte ptr [di],not lrendbit
	and	byte ptr [di],not lrbit
	call	lrout
;	mov	di,curnt_sts
;	and	byte ptr [di],not lrint
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
;
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c060fv:
;	************************************
;	Error during LR, beep and continue !
;	************************************
	mov	al,beep
	call	putcrtg
	mov	di,lrbyte
	and	byte ptr [di],not lrendbit
	or	byte ptr [di],lrbit
	mov	di,lradd
	mov	word ptr [di],0ff00h
	add	di,2		      ;point at lrquery
	mov	byte ptr [di],01h     ;Status flag = LR in progress
;
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0610v: 			;j+, same as procedure lrret
;	***********************************************
;	Routine terminates LR as if return is received.
;	***********************************************
	sti
	call	lrret
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0611v:
;	********************************************************
;	Routine returns a code to tell OS whether in ROM or RAM
;	********************************************************
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	cretvps 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	c0611v
;
	test	al,gio_ibs
	jnz	c0611vl
	test	al,gio_abs
	jnz	topabcs 			;new start
;
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	c0611v
topabcs:
	mov	di,gio_data
	mov	al,[di]
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	topabs
;
c0611vl:
	mov	si,gio_now2
	test	byte ptr [si],gio_cpb	;cpu ready?
	jnz	c0611vl
	mov	di,gio_data
	mov	byte ptr [di],0
	or	byte ptr [si],gio_cpb	;data is ready
;	mov	si,cmd_sts
;	mov	byte ptr [si],0f0h	;return with value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
cretvps:
	jmp	cretvp
;
c0620v:
;	**************************************************************
;	Routine gets a special $MXF command from OS386, and parses it.
;	**************************************************************
	call	put_comb
	call	comp2
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0621v: 		      ;Return result of $MXF command
;	**************************************************
;	Routine puts the last $MXF command back to OS 386.
;	**************************************************
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	cretvps 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	c0621v
;
	test	al,gio_ibs
	jnz	c0621vl
	test	al,gio_abs
	jnz	topabds 			;new start
;
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	c0621v
topabds:
	mov	di,gio_data
	mov	al,[di]
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	topabs
;
c0621vl:
	mov	al,es:comerr
	mov	si,gio_now2
c0621a:
	test	byte ptr [si],gio_cpb	;cpu ready?
	jnz	c0621a
	mov	di,gio_data
	mov	byte ptr [di],al
	or	byte ptr [si],gio_cpb	;request to send
;
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f0h	;return with value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0622v:
;	************************************************************
;	Routine enables the connect int system for the current port.
;	************************************************************
	mov	di,dsrbyte
	or	byte ptr [di],conb	   ;set the connect bit
	test	byte ptr [di],curdsr	   ;if the port already connect,
	jz	ret0622v
	mov	cx,es:connect_byte
	mov	di,usermask
	mov	ax,[di]
	test	ax,06h		;port 2 or 3?
	jz	swch9v		;nea!
;
	xor	ax,06h		;yea!
swch9v:
	or	cx,ax		       ;set the status byte
	mov	es:connect_byte,cx
	or	byte ptr es:rbibus,statrb	;chech??
ret0622v:
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0623v: 		      ;j+
;	***************************************************
;	Routine disables the connect system of current port
;	***************************************************
	mov	di,dsrbyte
	and	byte ptr [di],not conb	      ;reset the connect bit
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0624v: 		      ;j+
;	***********************************************************************
;	This routine enables the disconnection detection system for the
;	current port.
;	Two bytes (xxxx) are sent after the command CBS is sent.
;		IF xxxx = 0 then the port is disconnected immediately and
;			the disconnect detection system remains in force
;		IF 0 < xxxx < FFFF then xxxx is set as the current timeout
;			and the port is disconnected when xxxx seconds
;			have passed.
;		IF xxxx = FFFF then the current countdown for this port
;			is reset and disconnect detect reamins active
;	***********************************************************************
	mov	di,dsrbyte
	mov	cl,[di]
	or	cl,disconb
;	mov	si,cmd_parm
;	mov	ah,[si]
;	inc	si
;	mov	al,[si]
	call	two386i 			;get one bytes
	jnz	c0624pp
	jc	topabski
	jmp	cretvp
c0624pp:
	mov	ah,al
	call	two386i 			;get one bytes
	jnz	c0624ppy
	jc	topabski
	jmp	cretvp
c0624ppy:
	or	ax,ax
	jnz	c06242v 			;Not zero, jump
	test	cl,curdsr
	jnz	c06241v 			;jump if connected
	or	cl,discimmb
	mov	[di],cl
	jmp	ret0624v
c06241v:
	call	disconj
	mov	cx,es:disconnect_byte
	mov	di,usermask
	mov	ax,[di]
	test	ax,06h		;port 2 or 3?
	jz	swch90v 	;nea!
;
	xor	ax,06h		;yea!
swch90v:
	or	cx,ax
	mov	es:disconnect_byte,cx
	or	byte ptr es:rbibus,statrb
	jmp	ret0624v
c06242v:
	cmp	ax,0ffffh
	je	c0627v
	mov	si,offset disconj
	call	timeout
ret0624v:
;
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
topabski:
	jmp	topabs
;
c0625v: 		      ;j+
;	************************************************
;	Routine disables the disconnect detection system
;	************************************************
	mov	di,dsrbyte
	and	byte ptr [di],not disconb
	mov	di,timedwn
	mov	word ptr [di],0
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0626v: 		     ;j+
;	*******************************************************
;	Routine sets the connect bits for every port connected.
;	*******************************************************
	mov	cx,es:connect_byte
	or	cx,ax
	mov	es:connect_byte,cx
	or	byte ptr es:rbibus,statrb
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0627v:
;	**********************************************************************
;	Routine clears out any pending int for the current port but leaves the
;	state of the disconnection system unchanged.
;	**********************************************************************
	cli			;disable interrupt
	mov	ax,0
	call	timeout
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c0629v:
;	*********************************************************************
;	OS issues a RSD initial command, Format: 'parameter' 'ENDI(ak/nak)'
;	Where: 'parameters' can be any number of bytes to be sent to the
;		   terminal at the start of RSD.
;	*********************************************************************
	mov	di,lrbyte
	or	byte ptr [di],dtdelay
	and	byte ptr [di],not rsdgob
c06291v:
;				 Send AK or NAK to cs386
	mov	di,gio_now2
	or	byte ptr [di],gio_ib9	;support RSD
;	mov	cl,termbyte
;	test	cl,rsdspurt
;	jnz	c06295
;				 Cancel rsd, not support
;	mov	cl,cmd_sts
;	mov	cl,0		;NAK
;	mov	cl,lrbyte
;	and	cl,not dtdelay
;	mov	lrbyte,cl
;	ret
;c06295v:
	mov	di,rsdbyte
	and	byte ptr [di],not rsdabrtb
	call	rstbfrsd	;clear RSD buffer
	call	rstbufdt	;clear DT buffer
	mov	al,esccode	;0f1h, escaped code for RSD
	call	putdt		;put to DT buffer
	mov	al,rsdstart
	call	putdt
;	mov	di,cmd_parm
;	mov	ch,[di] 	;get the count from rsd_count
;	inc	di
;	xor	ch,ch
;	mov	cl,[di]
;	inc	di
;
c0629vp:
	call	two386i 			;get one bytes
	jnz	c0629ppy
	jc	topaaa
	jmp	c0629vz
;
c0629ppy:
	call	putdt
;	Looking for the end of GIO command
	jmp	c0629vp
;
c0629vz:
	mov	di,lrbyte
	or	byte ptr [di],rsdgob
	test	byte ptr [di],dtdelay
	jnz	c0629zv
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
	call	entx
c0629zv:
	mov	si,sts_byte
	or	byte ptr [si],04h
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
topaaa: 				;return to abs - start of gio
	push	ax
	mov	di,lrbyte
	or	byte ptr [di],rsdgob
	test	byte ptr [di],dtdelay
	jnz	topbbb
	mov	di,dsrbyte
	or	byte ptr [di],dtb	;let dt go
	call	entx
topbbb:
	pop	ax			;abs value
	mov	si,sts_byte
	or	byte ptr [si],04h
	jmp	topabs
;
c062av:
;	****************************
;	Routine aborts a current RSD
;	****************************
	mov	di,dsrbyte
	test	byte ptr [di],rsdb	   ;this bit set is mean user request RSD and in progress now
	jnz	c062a1v
;	mov	cmd_sts,7fh		  ;so, can not abort
	jmp	cretvp
c062a1v:
	mov	al,esccode
	call	putdt
	mov	al,rsdend
	call	putdt
	mov	al,esccode
	call	putdt
	mov	al,rsdgo
	call	putdt
	mov	al,0
	call	putdt
	mov	di,rsdbyte
	or	byte ptr [di],rsdabrtb
	mov	si,sts_byte
	or	byte ptr [si],08h
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c062bv:
;	*******************************************
;	Initialize RSD in response to Term. request
;	*******************************************
;	cli
	mov	di,txbyte
	and	byte ptr [di],not rsdreqb
	jmp	c06291v
;
c062cv:
;	********************************************************
;	Reconnect a port which is inactive, a 5 second countdown
;	is setup at end of dtr is set active.
;	********************************************************
	mov	di,timedwnd
	mov	byte ptr [di],5
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
c062dv: 		     ;2d, select special package, TC function
;	********************************************************
;	This block handles the selection of a special package
;	Format :   CBS(  )  OBS(XX)
;		    WHERE XX = 00	NOP
;			       01	STANDARD WANG TERMINAL
;			       02	TC  (2227B REPLACEMENT)
;	MXE responds with ENDI(00) if selection is legal
;		   or ENDI(NZ) if selection is not legal
;	********************************************************
;
	call	two386i 			;get one bytes
	jnz	c062dppy
	jc	topabsky
	jmp	cretvp
c062dppy:
	cmp	al,0
	jz	c062dmv 	;nop
;
	mov	di,flag2
	and	byte ptr [di],not specpack
	cmp	al,01		;Wang terminal?
	jz	initdv		;jmp if yes
	or	byte ptr [di],specpack
	cmp	al,02		;TC?
;	jz	inittc		;jmp if yes
c062dmv:
	mov	di,gio_now2
	or	byte ptr [di],gio_ib9
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
initdv: 	;Reinitialize a port to support Wang terminal which it was
		;set as Wang terminal previously
	cli			;lock
;	set ready/busy bits
	mov	di,rbi		;points at R/B byte
	mov	byte ptr [di],18	;init crt and prt bits to ready state
	mov	di,rbimask	;special mode ready mask
	mov	byte ptr [di],0ffh	;set to all ready
;	init connect/disconnect variables
	mov	di,dsrbyte
	mov	byte ptr [di],02	;init with connect on
;	init LRBUF and pointers
	call	rstlr
;	init CRT and PRT read/write pointers
	call	rstbufc
	call	rstbufp
	mov	di,txbyte
	or	byte ptr [di],prtstopb	;set prt stop in case no printer
;
	call	port_init_1
	mov	di,dsrbyte
	or	byte ptr [di],curdsr
	mov	di,usermask
	mov	ax,[di]
	not	ax
	and	es:porttype,ax		;reset the porttype of TC
	jmp	c062dmv
;
c062ev:
;	*********************************************************
;	Accept the system password from OS, and set it as MXE psw
;	*********************************************************
	mov	cx,6
	mov	si,psw
c062ev1:
;
	call	two386i 			;get one bytes
	jnz	c062eppy
	jc	topabsky
	jmp	cretvp
c062eppy:
	mov	es:[si],al
	or	al,al
	je	ret062ev
;
	inc	si
	loop	c062ev1
ret062ev:
	jmp	gio16ny 	;wru, feb/8
;	jmp	topabs3
;
topabsky:
	jmp	topabs
;
two386i:
;	**************************************************
;	Receive from 386 (one byte), if Z then disable or
;	shift-reset abs were occurred. C if abs was come.
;	**************************************************
	mov	di,gio_now2
	or	byte ptr [di],gio_rb	;MXF ready to receive
;
two386s:
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	two386z 		;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	two386s 			;not yet
;
	test	al,gio_obs
	jnz	two386g 			;get the data
	test	al,gio_abs
	jnz	two386c 			;new start
;
	mov	di,gio_now1
	mov	byte ptr [di],0 		;point at gio_now1
;
	jmp	two386i
two386z:
	xor	dh,dh			;keep the flags of gio_now1
	clc
	ret				;Z flag
two386c:
	mov	di,gio_data
	mov	al,[di]
;	********* testing *******
	mov	di,gio_now1
	mov	byte ptr [di],0 	;point at gio_now1
;	*********   end   *******
	xor	dh,dh			;keep the flags of gio_now1
	stc
	ret
;
two386g:
;
	mov	di,gio_data
	mov	al,[di]
;	mov	di,gio_now2
;	or	byte ptr [di],gio_rb	;MXF ready to receive
	mov	di,gio_now1
	mov	byte ptr [di],0 	;point at gio_now1
;	clc
	or	ah,0ffh 		;NZ flag
	ret
;
addlrgio	proc	;j+
;	*******************************************
;	Routine to process the line request buffer
;	*******************************************
	cld
	push	es
	push	ds
	pop	es			;Make es = ds
;	sti				;--- testing ---
	mov	di,lradd
	mov	ax,[di]
	cmp	ah,0ffh
	jnz	addgio11
;
	mov	di,lrwr
	mov	ax,[di]
addgio11:				;ax saves lradd or lrwr
	mov	di,lrstop
	mov	bx,[di] 		;Compute # byte
	sub	bx,ax			;max bytes to be added
	jbe	addgioz 		;Error exit
;					;Test for pre- or re-fill mode
;	mov	di,lrinit
;	test	byte ptr [di],fillbit	;Pre- data in LR buffer, re- in
;	jz	addiop			;0/prefill, 1/refill
;
;	Refill condition, looking for data that was filled in command parameter
;
	mov	bx,ax			;index of write pointer
;	mov	di,gio_rb
;	mov	byte ptr [di],0ffh	;ready to accept data
addio15:
	call	two386i
	jnz	addio77
;	jc	topabs
	jmp	addgioz
addio77:
	mov	di,lr_buf
	mov	[di][bx],al
	inc	bx
;	cmp	bx,1ffh 		;over 512?
;	jb	addio16
;	mov	bx,0
;
;addio16:
	mov	dx,bx
;
	pop	es			;return gen_store to es
	add	ax,dx			;current position
	push	ax
	mov	di,lrwre
	cmp	ax,[di] 		;if lrwre < lrwr then set lrwre to lrwr
					;and set lrcnt to new value
	jbe	addlrv5 		;jump if lrwre > = lrwr
;					 Set lrwre and lrcnt
	mov	word ptr [di],ax
;	and	dx,dx			;clear carry
	mov	di,lrstop
	mov	dx,[di]
	sub	dx,ax
	mov	di,lrcnt
	mov	[di],dx 		;lrcnt is updated too
addlrv5:
;	If bytes were added at lradd then the cursor must be moved to lradd
;	before moving it to the end of the added string
	mov	di,lradd
	mov	dx,[di]
	cmp	dh,0ffh 		;Compare high byte
	jz	addlrv6 		;jump if 0ffh
	mov	byte ptr [di],0ffh
	mov	bx,dx
	call	movecur
addlrv6:
	pop	ax
	mov	di,lrwrp2
	mov	[di],ax
	add	di,2			;point at lrwr
	mov	[di],ax
	or	dl,0ffh 		;NZ flag
	clc				;non carry (no abs)
	ret
addgioz:
	pop	es
	ret
addlrgio	endp
;
