;
;int_vec40  proc
;       *****************************************************
;       Interrupt routine from CS386, it is from address 40h
;       *****************************************************
;        cli
;        push    ds
;        push    es
;        pusha
;        mov     ax,60h             ;ds in interrupt segment
;        mov     es,ax
;        mov     di,prt_no
;        mov     bl,[di]
;        sal     bl,1
;        xor     bh,bh
;        mov     si,dataseg
;        mov     ax,[si][bx]             ;Find the data segment of port
;        mov     ds,ax
;                       Not impletement now, later maybe!
;
;        popa
;        pop     es
;        pop     ds
;        sti
;        iret
;int_vec40  endp
;
termint proc                    ;j+
;       ***************************************************
;       These are the entries of interrupts from each port.
;       ***************************************************
int_vec60:                      ;INT service for 1a, 1b
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,0            ;Index of dataseg for ports
        mov     dx,isr_1ab      ;Addressing the Interrupt status register
        jmp     intrtn          ;jump to interrupt service routine
        ;---------------------------------------------------------
;
int_vec61:                      ;INT service for 1c, 1d
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,4            ;Index of dataseg for ports
        mov     dx,isr_1cd      ;Addressing the interrupt status register
        jmp     intrtn          ;jump to interrupt service routine
        ;---------------------------------------------------------
;
int_vec62:                      ;INT service for 1e, 1f
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,8            ;Index of dataseg for ports
        mov     dx,isr_1ef      ;Addressing the interrupt status register
        jmp     intrtn          ;jump to interrupt service routine
        ;---------------------------------------------------------
;
int_vec63:                      ;INT service for 1g, 1h
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,12           ;Index of dataseg for ports
        mov     dx,isr_1gh      ;Addressing the interrupt status register
        jmp     intrtn          ;jump to interrupt service routine
        ;---------------------------------------------------------
;
int_vec64:                      ;INT service for 2a, 2b
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,16           ;Index of dataseg for ports
        mov     dx,isr_2ab      ;Addressing the interrupt status register
        jmp     intrtn          ;jump to interrupt service routine
        ;---------------------------------------------------------
;
int_vec65:                      ;INT service for 2c, 2d
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,20           ;Index of dataseg for ports
        mov     dx,isr_2cd      ;Addressing the interrupt status register
intrtnt:
        in      al,dx           ;These two ports have TC functions
;       test    al,mpichgb      ;we must check DCD, CTS signal change
;       jz      intrtn0         ;jump to interrupt service routine
;       jmp     intret          ;will be implemeted here
        jmp     intrtn1
;
int_vec66:                      ;INT service for 2e, 2f
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,24           ;Index of dataseg for ports
        mov     dx,isr_2ef      ;Addressing the interrupt status register
        jmp     intrtn          ;jump to interrupt service routine
        ;---------------------------------------------------------
;
int_vec67:                      ;INT service for 2g, 2h
        cli
        push    ds
        push    es              ;24/jan
        pusha
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     bx,28           ;Index of dataseg for ports
        mov     dx,isr_2gh      ;Addressing the interrupt status register
        ;---------------------------------------------------------
;
intrtn:
        in      al,dx           ;Input the interrupt status register
intrtn1:
;       testing the TC interrupt, but check either 1a or 1c first
        mov     di,tc_who
        cmp     byte ptr es:[di],0
        jz      nontc
;
        test    al,80h          ;mpi port change
        jnz     yestck          ;Normal interrupt
        jmp     yestc           ;yes, go to TC interrupt handling
;
yestck:
        jmp     rxtcses         ;handle the status of TC interrupt
;
nontc:
        test    al,rxrdya       ;bit 1, receiver ready, a channel
        jz      intrtn0
        jmp     rxrdy
intrtn0:
        test    al,txrdya       ;bit 0, transmission, a channel ready
        jz      intrtn2
        jmp     txrdy
intrtn2:
        test    al,erra         ;bit 2, error condition, a channel
        jz      intrtn3
        jmp     error
intrtn3:
        test    al,pnt1sc       ;bit 3, .1 second int comming
        jz      intrtn4
        jmp     pnt1s
intrtn4:
        add     bx,2            ;must be second (b) port status
        test    al,rxrdyb       ;bit 5, receiver ready, b channel
        jz      intrtn5
        jmp     rxrdy
intrtn5:
        test    al,txrdyb       ;bit 4, Transmission ready, b channel
        jz      intrtn6
        jmp     txrdy
intrtn6:
        test    al,errb         ;bit 6, error condition, b channel
        jnz     error           ;We don't want to use bit 7
        jmp     intret          ;nothing else, go back
        ;--------------------------------------------------------
error:                          ;some error in line
                                ;don't care for that; just ignore it
        mov     ax,es:dataseg[bx]       ;get the data segment
        mov     ds,ax
        mov     di,rthr
        mov     dl,[di]         ;get the code
        xor     dh,dh
        in      al,dx
;       debug for power on/off of 1st port
        mov     di,crport
        mov     dl,[di]
        mov     al,50h          ;reset the break condition bit
        out     dx,al
;
;       debug for power on/off of 1st port, end
;       call    putrx           ;put to buffer
;                                clear the error status
        jmp     intret          ;that's all
        ;---------------------------------------------------------
;
;       Receiver Ready          **check? Re-enable interrupt?**
;
rxrdy:
        mov     ax,es:dataseg[bx]     ;Point to desired data segment
        mov     ds,ax
rxrdyc:
        xor     dh,dh
;       -------- Testing for speed of 01h -----------
;       mov     di,crport
;       mov     dl,[di]
;       mov     al,40h          ;clear error bits
;       out     dx,al
;       -------- Testing for speed of 01h -----------
        mov     di,rthr
        mov     dl,[di]         ;Rx the code
        in      al,dx
        cmp     al,crtstop      ;CRT stop code?
        je      rxrdy2
        cmp     al,prtstop      ;Printer stop code?
        je      rxrdy3
        cmp     al,0f7h         ;waiting for window protocol
        je      rxwindw
rxrdy1:
        call    putrx           ;Simply data, put to buffer
;
rxrdyz0:
        mov     di,crport
        mov     dl,[di]
        xor     dh,dh
        mov     al,40h
        out     dx,al
;
        jmp     intret
;
;       Service CRT stop
;
rxrdy2:
        mov     di,dsrbyte
        test    byte ptr [di],rsdb    ;RSD?
        jnz     rxrdy1
        call    chkfrfc         ;Check 'fc' condition!
        jz      rxrdy1          ;Probably not stop if NZ is returned.
        mov     di,txbyte
        or      byte ptr [di],crtstopb
        mov     di,cstopcnt
        inc     byte ptr [di]
        jmp     rxrdy1
rxrdy3:
        mov     di,dsrbyte
        test    byte ptr [di],rsdb    ;RSD?
        jnz     rxrdy1
        call    chkfrfc         ;Check 'fc' condition
        jz      rxrdy1          ;Probably not stop if NZ is returned.
        mov     di,txbyte
        or      byte ptr [di],prtstopb
        mov     di,pstopcnt
        inc     byte ptr [di]
        jmp     rxrdy1
;
rxwindw:
        mov     di,fbd7
        cmp     byte ptr [di],0ffh
        jnz     rxrdy1
        mov     byte ptr [di],0
        mov     di,d2636
        mov     byte ptr [di],0ffh
        jmp     rxrdyz0
;
;       Transmission Ready
;
txrdy:
        mov     ax,es:dataseg[bx]       ;Point to desired data segment
        mov     ds,ax
;
;       Test Purpose !!!
;       mov     dx,54h
;       mov     al,8ah
;       out     dx,al                   ;turn off the light
;
;       mov     di,srport
;       mov     dl,[di]
;       xor     dh,dh
;txrdyk:
;       in      al,dx
;       test    al,08h                  ;test SR port for empty
;       jz      txrdyk
;
;       mov     dx,54h
;       mov     al,9ah
;       out     dx,al                   ;turn on the light
;       Test is over !!!
;
cyclone1:
        mov     di,dsrbyte
        test    byte ptr [di],dtb       ;RSD in progress?
        jz      txrdy1
        jmp     txrsd
txrdy1:
        test    byte ptr [di],curdsr    ;terminal connected?
        jnz     tx24q                   ;exit if not connected
tx24q1:
        jmp     txdis24
tx24q:
        test    byte ptr [di],timeoutb          ;timeout?
        jnz     tx24q1          ;go disable Tx
        inc     di              ;point to txbyte
        mov     bl,[di]
        and     bl,0fh          ;only want buffer bits
        xor     bh,bh
        shl     bx,1            ;get the offset, byte -> word
        jmp     cs:txtab[bx]
;
txtab   dw      txdis           ;0000  disable transmition
        dw      txout1          ;0001  transmit one character to crt
        dw      swbuf           ;0010  crt buffer went empty - send esc code to switch buffers
        dw      crtchk          ;0011  test for max to crt and possibly sent esc code
        dw      txdis           ;0100  buffers empty - disable transmition
        dw      swbuf           ;0101  prt buffer went empty - send escape code
        dw      txout2          ;0110  transmit one character to prt
        dw      prtchk          ;0111  test for max to prt and possibly send esc code
        dw      prtcode1        ;1000  switch to PRT buffer
        dw      crtcode1        ;1001  switch to CRT buffer
        dw      prtcode1        ;1010  switch to PRT buffer
        dw      prtcode1        ;1011  switch to PRT buffer
        dw      crtcode1        ;1100  switch to CRT buffer
        dw      crtcode1        ;1101  switch to CRT buffer
        dw      prtcode1        ;1110  switch to PRT buffer
        dw      crtcode1        ;1111  switch to CRT buffer
;
cyclone:
;       **************************************************
;       Routine to check status register to see if okay to
;       send next byte.
;       **************************************************
        mov     si,srport
        mov     dl,[si]
        xor     dh,dh
        mov     cx,02h
cyclone3:
;
        in      al,dx           ;get the status from SR
        test    al,01h          ;Is Receiver coming?
        jnz     cyclone6
        test    al,04h          ;Is Transmission ready?
        jnz     cyclone1
;
        loop    cyclone3        ;testing!
;
        jmp     intret
cyclone6:
        jmp     rxrdyc
;
;cyclone7:
;       jmp     intret
;
crtchk:
        mov     di,countout
        cmp     byte ptr [di],crtmax
        jnc     jpsw            ;Yes, countout > crtmax
        inc     byte ptr [di]        ;No, go service crt_buf output
;       put out char from crt_buf
txout1:
        mov     di,txbyte
        test    byte ptr [di],crtstopb ;crt stop is in txbyte?
        jnz     tryprt          ;yes, try printer
        call    getcrt          ;get a byte from crtbuf
        jz      jpint           ;buffer empty; go back
;
        mov     di,rthr
        mov     dl,[di]         ;check? get port address
        xor     dh,dh
        out     dx,al           ;put out character
jpint:
        jmp     cyclone
;
tryprt:
        mov     di,txbyte
        test    byte ptr [di],prtbit   ;test printer buffer
        jz      txdis
        test    byte ptr [di],prtstopb ;if stop bit is set
        jnz     txdis           ;disable transmission
jpsw:
        jmp     swbuf
;
prtchk:
        mov     di,countout
        cmp     byte ptr [di],prtmax
        jnc     swbuf
        inc     byte ptr [di]
;
txout2:
        mov     di,txbyte
        test    byte ptr [di],prtstopb ;prt stop is in txbyte?
        jnz     trycrt          ;yes, try crt
        call    getprt          ;get a byte from prtbuf
        jz      jpint           ;buffer empty; go back
        mov     di,rthr
        mov     dl,[di]
        xor     dh,dh
        out     dx,al           ;put out character
        jmp     cyclone
;
trycrt:
        mov     di,txbyte
        test    byte ptr [di],crtbit   ;test crt buffer
        jz      txdis
        test    byte ptr [di],crtstopb ;if stop bit is set
        jnz     txdis           ;disable transmission
        jmp     swbuf
;
txdis:
        mov     di,flag2
        test    byte ptr [di],modebit   ;command mode bit set?
        jz      txdis211        ;jump if not command mode
        mov     di,rbi
        mov     byte ptr [di],0           ;reset ready bits since we're in command mode
txdis211:
        mov     di,countout
        mov     byte ptr [di],0
txdis24:
        call    distx
;       jmp     cyclone
        jmp     intret
;
crtcode1:
        mov     di,txbyte
        and     byte ptr [di],not switchb
        and     byte ptr [di],not lastbit
        mov     al,crtcode
        jmp     outbyte
;
prtcode1:
        mov     di,txbyte
        and     byte ptr [di],not switchb
        or      byte ptr [di],lastbit
        mov     al,prtcode
        jmp     outbyte
;
swbuf:
        mov     di,countout
        mov     byte ptr [di],0
        mov     di,txbyte
        or      byte ptr [di],switchb
        mov     al,esccode
outbyte:
        mov     di,rthr
        mov     dl,[di]
        xor     dh,dh
        out     dx,al
        jmp     cyclone
;
txrsd:
;       During the RSD, no byte from the CRT and PRT buffers may be sent to the
;       terminal. The DT buffer is used instead to send controls to the terminal.
        mov     di,windw
        test    byte ptr [di],wndw
        jz      txrsds
        test    byte ptr [di],wrtrd
        jz      txrsds
;       *** Under window/write status ***
        call    getrsd
        jz      lastrsds
;
        mov     di,rthr
        mov     dl,[di]
        xor     dh,dh
        out     dx,al
        jmp     cyclone
lastrsds:                       ;The end of windowing WRITE
        mov     di,cmd_parm
        cmp     byte ptr [di],fnlpage
        jz      fnlwrt
        jmp     notfnl
fnlwrt:
        mov     di,windw
        and     byte ptr [di],not wrtrd
;       mov     di,dsrbyte
;       and     byte ptr [di],not dtb          ;let dt stop
        mov     al,esccode
        call    putdt
        mov     al,0ddh                 ;Tell terminal writing is over
        call    putdt
        jmp     intret          ;aug/13/91
notfnl:
        mov     di,windw
        and     byte ptr [di],cntncmd   ;@@@ clear byte except first issue bit
        mov     di,dsrbyte
        and     byte ptr [di],not dtb          ;let dt stop
        and     byte ptr [di],not rsdb         ;normal mode
        mov     di,cmd_sts
        mov     byte ptr [di],0f0h              ;tell OS write OK
;       aug/28/91
        mov     di,curnt_sts
        or      byte ptr [di],windint
;       aug/28/91
        jmp     intret          ;aug/13/91
;       jmp     cyclone
txrsds:                         ;not in window or window/write mode,
        call    getdt           ;output a byte from DT buffer, (no compression!)
        jz      txrsddis        ;jump if last byte
        or      al,al           ;if the byte is zero and abort bit is set
        jnz     txrsd2
        mov     di,rsdbyte
        test    byte ptr [di],rsdabrtb        ;then switch buffer
        jnz     txrsdd3         ;i.e. this is the end of the RSD
txrsd2:
        mov     di,rthr
        mov     dl,[di]
        xor     dh,dh
        out     dx,al
        jmp     cyclone
txrsddis:
        call    distx           ;check? disable transmission
        mov     di,rsdbyte
        test    byte ptr [di],rsdabrtb        ;is end of RSD?
        jz      txrsdj          ;No
;               End of RSD, reset dt flag to allow output from CRT & PRT
txrsdd3:
        mov     di,rsdbyte
        and     byte ptr [di],not rsdabrtb
        or      byte ptr [di],rsdendb
        mov     di,dsrbyte
        and     byte ptr [di],not dtb
txrsdj:
        jmp     cyclone
;
pnt1s:                          ;check? the ds=>data0
        push    es
        pop     ds
        or      byte ptr es:rxbyte0,clock_1i  ;set .1 second bit
        inc     byte ptr es:p1cnt
        cmp     byte ptr es:p1cnt,10          ;one second?
        jb      intretx0                      ;no,
        mov     byte ptr es:p1cnt,0           ;reset count
        or      byte ptr es:rxbyte0,clockint  ;set one second bit
;       26/nov/91, reset timer bit
intretx0:
        mov     dx,stop_2gh
        in      ax,dx
;
        mov     dx,start_2gh
        in      ax,dx
;       26/nov/91, reset timer bit, end
intret:
        popa
        pop     es              ;24/jan
        pop     ds
        sti
        iret
termint endp
;
entx    proc                    ;j+
;       *****************************************************************
;       Routine that enables the transmitter of UART Regs for that port.
;       *****************************************************************
        pushf                   ;save the interrupt enable/disable condition
        cli                     ;disable interrupt
        push    es
        mov     ax,060h
        mov     es,ax
;
;       Test the dtr over here
        in      al,ip_2ab
        mov     ah,al
        in      al,ip_2cd
        mov     di,usermask
        mov     bx,[di]
        test    ax,[di]
        jz      entx_z          ;Connected! go ahead enable it.
;
;       20/nov/91, bugging for other cables
        test    bx,05           ;port 1a, or 1c
        jz      entxw           ;neither, jmp
        test    bx,01
        jz      entx1c
;                        This is port 1a
        in      al,ip_1ab
        test    al,04
        jnz     entxw           ;not connected
        jmp     entx_z          ;connected
;
entx1c:                 ;This is port 1c
        in      al,ip_1cd
        test    al,04
        jz      entx_z          ;connected
;       20/nov/91, bugging for other cables, end
;
entxw:
;
;       mask off sep/20/91
;       mov     ax,es:try_dtr
;       or      ax,bx           ;Mark, this port was disconnected.
;       mov     es:try_dtr,ax
;       mask off sep/20/91, end
        jmp     entx_zz
;                               ;But try to enable it next time.
entx_z:
        mov     di,crport
        mov     dl,[di]
;       mov     di,crdata
;       and     byte ptr [di],not distxb
;       or      byte ptr [di],entxb
;       mov     al,[di]
        mov     al,04           ;enable TX --- testing ---
        xor     dh,dh
        out     dx,al
;       mask off sep/20/91
;       mov     di,usermask
;       mov     bx,[di]
;       not     bx
;       mov     ax,es:try_dtr
;       and     ax,bx
;       mov     es:try_dtr,ax
;       mask off sep/20/91, end
entx_zz:
        pop     es
        popf
        ret
entx    endp
;
distx   proc                    ;j+
;       ****************************************
;       Disable the Transmitter register of UART
;       ****************************************
        pushf                   ;save the interrupt enable/disable condition
;       cli                     ;disable interrupt
        mov     di,crport
        mov     dl,[di]
;       mov     di,crdata
;       and     byte ptr [di],not entxb
;       or      byte ptr [di],distxb
;       mov     al,[di]
        mov     al,08h          ;--- testing ---
        xor     dh,dh
        out     dx,al
;
        call    crtalert
;
        popf
disret:
        ret
distx   endp
;
timeout proc                    ;j+
;       **********************************************************************
;       Routine sets a countdown timeout for the port, the 2-byte count in ax.
;       ax decrements every one second clock, until it reaches zero.
;       **********************************************************************
        mov     di,timedwn
        mov     [di],ax                 ;ax is the count will be decremented at
                                        ;each one second clock int until it
        ; put routine in bx             ;reach zero.
        mov     di,timestrt
;
        mov     [di],si        ;di is the routine pointer if counter
                                        ;reach zero, it will be called.
        mov     di,dsrbyte
        and     byte ptr [di],not discimmb
        ret
timeout endp
;
cntdwn  proc                            ;j+
;       *************************************************************
;       Routine decreases the countdown bytes until it reaches zero.
;       The routine pointed by timestrt will be executed then.
;       *************************************************************
;       Each port has two counters. One counts the timeout at the terminal after
;       a disconnect and the other is a general counter normally used
;       to initiate some action after a given time.  The timeout counter
;       ALWAYS takes precedence!  If the timeout counter is not zero it is
;       decremented (and not the other counter).  When the timeout counter is
;       decremented to zero the routine "CONJ" is called.
        mov     di,timedwnd
        cmp     byte ptr [di],0
        jz      cntdwn3
        cmp     byte ptr [di],0ffh           ;Infinite, do not decrease
        jz      cntdwnz
        dec     byte ptr [di]
        jnz     cntdwnz
        call    conj
cntdwnz:
        ret
cntdwn3:
        inc     di                      ;point at timedwn
        cmp     word ptr [di],0
        jz      cntdwnz
        dec     word ptr [di]
        cmp     word ptr [di],0
        jnz     cntdwnz
;                               Zero count! Call routine pointed by timestrt
        mov     di,timestrt
        mov     bx,[di]
        call    bx
;
        ret
cntdwn  endp
;
disconj proc                            ;j+
;       ********************************************************************
;       This routine disconects the current port. A 5 second timeout is set
;       which will then allow connections at the port
;       ENTRY: ds = point to the data segment of the port
;       EXIT: the uart for the port drops DTR so modems will hang up and
;       TIMEOUTB is set so bytes will be bitbucketed to and from terminal
;       ********************************************************************
        mov     di,dsrbyte
        or      byte ptr [di],timeoutb        ;set timeout flag
        and     byte ptr [di],not curdsr
        mov     ax,0
        call    timeout
        mov     al,0ffh
        mov     di,dsrbyte
        test    byte ptr [di],disconb         ;disconnect system in effect?
        jnz     disconj2
        mov     al,5
disconj2:
        mov     di,timedwnd
        mov     [di],al
;                 ***   Some modem actions   ***
;       First, drop DTR so that modem will hang up on terminal
        mov     si,tc_who
        cmp     byte ptr es:[si],0         ;if tc_who=0 then not TC
        jz      disconj4
        mov     di,usermask
        test    word ptr [di],01h
        jnz     disconj3                ;not the TC's
        mov     dx,0100h
        mov     al,0
        jmp     disconj33
disconj3:
        mov     dx,0110h
        mov     al,0
disconj33:
        out     dx,al                   ;disable dtr
;
disconj4:
        mov     di,txbyte
        and     byte ptr [di],not rsdreqb      ;reset RSD request in progress flag
        mov     di,rsdbyte
        mov     byte ptr [di],0
        mov     di,termbyte
        mov     byte ptr [di],0
;
        mov     di,dsrbyte
        test    byte ptr [di],disconb         ;should we alert 2200?
        jz      disretz                 ;no,
        mov     di,usermask
        mov     ax,[di]
        test    ax,06h          ;port 2 or 3?
        jz      swch2           ;nea!
;
        xor     ax,06h          ;yea!
swch2:
        or      es:disconnect_byte,ax     ;set the status to 2200
disretz:
;       mov     connect_dis,0ffh        ;set disconnect flag
        mov     di,outblock
        or      byte ptr [di],disblock
        mov     di,rbimask
        mov     byte ptr [di],32h
        ret
disconj endp
;
conj    proc                            ;j+
;       ********************************************
;       Reinitalize a port which had been timeouted.
;       ********************************************
        mov     di,dsrbyte
        test    byte ptr [di],discimmb        ;check to see if the terminal is to be
        jz      conj2                   ;disconnected upon connection
        and     byte ptr [di],not discimmb    ;reset the flag
        mov     ax,0
        mov     si,offset disconj
        call    timeout                 ;set up a one second connection
conj2:
        mov     si,tc_who
        cmp     byte ptr es:[si],0         ;if tc_who=0 then not TC
        jz      conj5
        mov     di,usermask
        test    word ptr [di],01h
        jnz     conj4                   ;not the TC's
        mov     dx,010ah
        mov     al,1
        jmp     conj43
conj4:
        mov     dx,011eh
        mov     al,1
conj43:
        out     dx,al                   ;enable dtr
;
conj5:
        mov     di,dsrbyte
        and     byte ptr [di],not timeoutb    ;reset timeout flag
        call    rstbufc                 ;clear the crt buffer
        call    rstbufp                 ;clear the prt buffer
        mov     al,esccode
        call    putcrtg
        mov     al,termrst              ;hard reset to the terminal
        call    putcrtg
        call    rstterm                 ;reset the terminal and wait
        mov     di,outblock
        mov     byte ptr [di],0
        mov     di,rbimask
        mov     byte ptr [di],0ffh
;       mov     connect_dis,0           ;current port is connected
        mov     di,usermask
        mov     ax,[di]
        test    ax,06h          ;port 2 or 3?
        jz      swch3           ;nea!
;
        xor     ax,06h          ;yea!
swch3:
        or      es:connect_byte,ax        ;alert 2200
;       feb/26/92
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
;       feb/26/92, end
;
        ret
conj    endp
;
testdsr proc                    ;j+ @@@
;       *****************************************************************
;       Test current state of the port and alert the condition of Connect
;       or Disconnect. If it's connect, routine will enable tx int's to
;       prevent losses.
;       *****************************************************************
        call    cntdwn
;       Test the dtr over here
;       in      al,ip_2ab
;       mov     ah,al
;       in      al,ip_2cd
        mov     di,connct
        mov     ax,es:[di]              ;record connection condition
;
;       mov     di,es:connect_byte
;       mov     es:[di],ax              ;record connection condition
        mov     di,usermask
        mov     bx,[di]
;       mask off sep/19/91
;        test    bx,06h          ;port 2 or 3?
;        jz      swch4           ;nea!
;
;        xor     bx,06h          ;yea!
;swch4:
;       mask off sep/19/91, end
        test    ax,bx           ;does current port connect?
        jnz     testdsr5        ;no,
        mov     di,dsrbyte
        test    byte ptr [di],timeoutb        ;is timeout in progress?
        jnz     testdsrret      ;exit if port is timeout
        call    entx
        mov     di,dsrbyte
        test    byte ptr [di],rsdb    ;doing RSD?
        jz      testdsr2        ;not RSD
        mov     al,esccode      ;now, in RSD
        call    putdt
        mov     di,rsdbyte
        test    byte ptr [di],rsdwaitb        ;terminal stopped?
        jnz     testdsr1        ;jmp if not wsit state
        mov     al,rsdgo
        jmp     short testdsr11
testdsr1:
        mov     al,rsdstop
testdsr11:
        call    putdt
        mov     di,curnt_sts
;
;       test RSD Dec. 12th
;       or      byte ptr [di],rsdint
;       test RSD end Dec. 12th
testdsr2:
        mov     di,dsrbyte
        test    byte ptr [di],curdsr  ;test connect bit
        jnz     testdsrret
        or      byte ptr [di],curdsr
        test    byte ptr [di],conb    ;connection alert set?
        jz      testdsrret            ;exit if 2200 doesn't want to know
        test    byte ptr [di],disconb ;discon/connection alert on?
        jz      testdsrret            ;if 2200 doesn't want to know
        mov     di,usermask
        mov     ax,[di]
        test    ax,06h          ;port 2 or 3?
        jz      swch6           ;nea!
;
        xor     ax,06h          ;yea!
swch6:
        or      es:connect_byte,ax
        jmp     short testdsrret
testdsr5:
        mov     di,dsrbyte
        test    byte ptr [di],curdsr  ;is new disconnect
        jz      testdsrret            ;if not new disconnect
        call    disconj               ;set up timeout
        mov     di,dsrbyte
        test    byte ptr [di],disconb ;disconnection alert on?
        jz      testdsrret            ;if 2200 doesn't want to know
        mov     di,usermask
        mov     ax,[di]
        test    ax,06h          ;port 2 or 3?
        jz      swch7           ;nea!
;
        xor     ax,06h          ;yea!
swch7:
        or      es:disconnect_byte,ax
testdsrret:
        ret
testdsr endp
;
rxin    proc                    ;j+
;       *******************************************************************
;       Main receiver int service routine THIS ROUTINE IS CALLED!!!
;       (For the service of each buffer of each port)
;       ENTRY: DS points at data segment of current port
;       EXIT: An input char from the currently int ports uart is read and
;             processed (as stated below).
;       DAMAGE: all registers are restored to their preinteruppt state!
;       *******************************************************************
        call    getrx           ;get character, if no char, return zero flag set
        jnz     rxin1           ;al holds the incoming data if any.
        ret
rxin1:
        mov     dl,al           ;dl holds current byte for security
; The input char could be part of a two byte code or could be a special
; control code requiring immediate action.  Flags must be tested here to
; determine what action must be taken.  The following situations
; are possible:
;
; -The last byte was a X'FC' or X'FD' meaning the current byte is part of a
;  2 byte code in which case the current byte is either stored or ignored.
; -The last byte was NOT a X'FC' or X'FD' meaning the current byte COULD be,
;  or the current byte could be a special 1 byte command to the MXF (such as
;  a terminal buffer full code or terminal buffer empty code), or it
;  could be a RESET or HALT/STEP, or it could have no special meaning and
;  is to be stored.
;
; NOTE: For foreign terminals, the above codes will probably be different
;       and this section of code may have to be modified.
;       .............
; test for timeout and bitbucket bytes from timedout port!
;
        mov     di,dsrbyte
        test    byte ptr [di],timeoutb        ;timeout?
        jnz     jprx3                         ;jmp if timeout
        test    byte ptr [di],rsdb            ;RSD in progress?
        jz      rxinq9
        jmp     rsdin
rxinq9:
        xor     cl,cl
        mov     di,flag1
        xchg    cl,[di]         ;get flag1 in al and clear flag1
        and     cl,fdfcmask     ;just want fd and fc bits
                                ;If it set means last byte is either fd or fc.
        jz      rxin1_4         ;jump if either fd, fc is set, so store the byte
        jmp     rxin1_6
rxin1_4:
                                ;Current byte is not second part of 2-byte-code.
                                ;Test first byte of a 2 byte code.
        cmp     al,0f0h         ;f0h or above?
        jae     rxin1_45        ;jmp if above than efh
;       cmp     al,0e4h         ;RSD support code?  check?
;       jnz     rxin1401        ;jmp if not
;       or      termbyte,rsdsuprt       ;rsd supports in MXF always.
;jprx3:
;        jmp     rxin3
;rxin1401:
        cmp     al,0bdh         ;edit key?
        je      rsdcanq         ;go look for RSDREQ pending
        cmp     al,0e5h         ;LINE ERASE?
        jne     rxin14q         ;store byte
rxin4q:
        jmp     rxin2
rsdcanq:
        jmp     rsdcan
rxin14q:
        cmp     al,0e6h         ;STATEMENT #?
        je      rxin4q
        cmp     al,0e0h         ;between 0e0h and 0f8h
        jae     jprx3           ;disregard byte
                                ;Character is less than e0h
        cmp     al,12h          ;RESET code?
        jne     rxin1_42
                                ;RESET received!
                                ;set the reset bit in termstat and set status for 2200
rxin140:
        call    rstbufk         ;reset key buffer
        call    rstbuf          ;reset buffers
        call    moderst         ;go reset command mode
        call    rstlr           ;reset line request
        mov     di,cmd_sts      ;28/jan/92
;       mov     byte ptr [di],0f1h
        mov     byte ptr [di],0f2h ;---- 07-31-92,tsai -------
        mov     di,after0a      ;28/jan/92
        mov     byte ptr [di],0
;
;       This is for gio's reference
;       mov     di,gio_now1
;       or      byte ptr [di],g_int
;
        mov     di,usermask
        mov     bx,[di]
        test    bx,06h          ;port 2 or 3?
        jz      swch1           ;nea!
;
        xor     bx,06h          ;yea!
swch1:
        or      es:reset_byte,bx
;
;       call    int_386         ;interrupt OS386
jprx3:
        jmp     rxin3
rxin1_42:
        cmp     al,13h          ;HALT/STEP code
        jne     rxin4q
        call    rstbufk         ;clear keybuf
        call    moderst         ;go reset command mode
        mov     di,usermask
        mov     bx,[di]
        test    bx,06h          ;port 2 or 3?
        jz      swch91          ;nea!
;
        xor     bx,06h          ;yea!
swch91:
        or      es:halt_step_byte,bx
        jmp     rxin3
rxin1_45:
                                ;char must be f0h or greater
;       sub     al,0f0h
        xor     bx,bx
        mov     bl,al
        and     bl,0fh          ;adjust offset
        shl     bx,1
        jmp     cs:rxtab2[bx]
;
rxtab2  dw      rsdcan          ;F0 - cancel pending RSD request (unescaped RSD)
        dw      rxin3           ;F1 - nothing special (ignore)
        dw      strtrsd         ;F2 - start of RSD bytes
        dw      setfc           ;F3 - request for RSD
        dw      rxin2           ;F4 - nothing special
        dw      rxin2           ;F5 - nothing special
        dw      rxin2           ;F6 - nothing special
        dw      rxin2           ;F7 - nothing special
        dw      gocrt1          ;F8 - terminal crt buffer empty
        dw      goprt1          ;F9 - terminal prt buffer empty
        dw      stopcrt1        ;FA - terminal crt buffer full
        dw      stopprt1        ;FB - terminal prt buffer full
        dw      setfc           ;FC - transparancy code (2 bytes)
        dw      setfd           ;FD - special function or atom (2 bytes)
        dw      dead            ;FE - dead key - translate to X'FF'
        dw      dead            ;FF - treated as dead key
;
;**********************************************************************
rsdcan:
;       A 'bd' or 'fdf0' has been pressed - edit key
;       Cancel pending rsd request if there is one, or store that byte if not.
;
        mov     al,0bdh
        mov     di,txbyte
        test    byte ptr [di],rsdreqb  ;RSD request pending?
        jz      rxin2q2         ;if not, jump to store this byte, otherwise
                                ;request is currently pending - cancel it
        and     byte ptr [di],not rsdreqb      ;cancel request bit
        and     byte ptr [di],not crtstopb     ;allow the crt to go
        mov     di,curnt_sts
        or      byte ptr [di],80h
        inc     di
        mov     byte ptr [di],canrsd
        jmp     rxin3
rxin2q2:
        jmp     rxin2
;**********************************************************************
strtrsd:
;       Start of RSD data stream code! switch input to RSDBUF
;
        mov     di,dsrbyte
        or      byte ptr [di],rsdb    ;route RSD input to RSDBUF
        jmp     rxin3
;**********************************************************************
rsdreq:
;       The terminal is requesting a RSD. Send the request to CS386 and
;       set the appropriate flags
;
        mov     di,txbyte
        or      byte ptr [di],crtstopb ;freeze the CRT
        or      byte ptr [di],rsdreqb  ;set request bit
        mov     di,curnt_sts
        or      byte ptr [di],80h
        inc     di
        mov     byte ptr [di],reqrsd
        jmp     rxin3
;**********************************************************************
gocrt1:
;       F8h received - restart crt transmission
;       if no pending prescanned stop codes
;
        mov     di,cstopcnt
        cmp     byte ptr [di],0      ;is the cnt of stop codes in buffer is 0
        jnz     stopcrt2             ;buffer still has stop code, do nothing
        mov     di,txbyte
        test    byte ptr [di],rsdreqb          ;RSD request pending?
        jnz     stopcrt2                       ;yes,
        and     byte ptr [di],not crtstopb     ;reset the stop bit
        test    byte ptr [di],crtbit
        jnz     gocrt12
;
        mov     di,rbi
        or      byte ptr [di],crtrb
        mov     di,curnt_sts
;       mov     di,flag9
        or      byte ptr [di],crtint
gocrt12:
        call    entx
        jmp     rxin3
;**********************************************************************
stopcrt1:
;       fah received - stop crt transmission
;
        mov     di,txbyte
        or      byte ptr [di],crtstopb ;set the stop bit
        mov     di,cstopcnt
        cmp     byte ptr [di],0
        je      stopcrt2
        cli                     ;disable interrupt
        dec     byte ptr [di]
        sti                     ;enable interrupt
stopcrt2:
        jmp     rxin3
;**********************************************************************
goprt1:
;       f9h received - restart prt transmission if no stop codes in buffer
;
        mov     di,pstopcnt
        cmp     byte ptr [di],0      ;any pending stop codes?
        jnz     stopcrt2        ;yes, ignore this go code
        mov     di,txbyte
        and     byte ptr [di],not prtstopb     ;reset stop bit
        test    byte ptr [di],prtbit
        jnz     goprt12
;
        mov     di,rbi
        or      byte ptr [di],prtrb
        mov     di,curnt_sts
        or      byte ptr [di],prtint
goprt12:
        call    entx
        jmp     rxin3
;**********************************************************************
stopprt1:
;fbh received - stop prt transmission and update count of pending stop codes
;
        mov     di,txbyte
        or      byte ptr [di],prtstopb ;set the stop bit
        mov     di,pstopcnt
        cmp     byte ptr [di],0
        je      stopprt12
        cli                     ;disable interrupt
        dec     byte ptr [di]
        sti                     ;enable interrupt
stopprt12:
        jmp     rxin3
;**********************************************************************
setfc:
;       fch is current char, 'fc''byte' is a 2-byte code denoting that
;       'byte' should not be interpreted as a special code. For example,
;       '12' is reset but 'fc''12' is '12' save in bytesave for storage
;       next time around.
;
        mov     di,bytesave
        mov     [di],al     ;save fc here
        mov     di,flag1
        or      byte ptr [di],fcbit
        jmp     rxin3
;**********************************************************************
setfd:
;       fdh is current char, 'fd''byte' is a 2-byte code denoting that
;       'byte' should not be interpreted as a special code. For example,
;       '12' is reset but 'fd''12' is 'special function 12' save in
;       bytesave for storage next time around.
;
        mov     di,bytesave
        mov     [di],al     ;save fd here
        mov     di,flag1
        or      byte ptr [di],fdbit
        jmp     rxin3
;**********************************************************************
dead:
;       Dead key received. expecting UNDERSCORE+CHAR to follow.
;       Send dead key as 0ffh
;
        mov     di,flag1
        mov     byte ptr [di],fdfcmask  ;set fcfd bit
        mov     di,bytesave
        mov     byte ptr [di],deadkey2
        mov     al,deadkey2
        mov     ah,0            ;store ffh
        jmp     rxin2_03        ;go store byte
;**********************************************************************
rxin1_6:                        ;j+
;       Last byte was 'fd' or 'fc', so we need to store the
;       contents of bytesave before the current byte.
;       Exit: current code in al.
;
        mov     di,bytesave
        mov     ah,[di]
        cmp     ah,0fdh         ;endi escape?
        jne     rxinq1
;       jne     rxin1_7
;                                case of 0fdh, endi/atom + char
        cmp     al,prtstop      ;prt stop code?
        jne     rxin1_62
                                ;This was confused with a stop code in the Rx int
                                ;decrement stop counter
        mov     di,pstopcnt
        dec     byte ptr [di]   ;dec count of prescanned stops
        jnz     rxin1_67        ;jmp if not down to zero
                        ;the count of prescanned stops now decrements to zero
                        ;which means that an escaped byte looked like a stop
                        ;and should not have stopped Tx.
                        ;It is therefor necessary to restart transmission
        mov     di,txbyte
        and     byte ptr [di],not prtstopb     ;allow transmission
        jmp     rxin1_67        ;go store byte
rxin1_62:
        cmp     al,crtstop
        jne     rxin1_67
                        ;look for false CRT stop code. i.e.
                        ;escaped stop codes which were confused  with stop codes
        mov     di,cstopcnt
        dec     byte ptr [di]
        jnz     rxin1_67
        mov     di,txbyte
        and     byte ptr [di],not crtstopb
rxin1_67:
        cmp     al,0f0h         ;is edit keys?
        jnz     rxinq2
        jmp     rsdcan
;       --- Testing for window ---
rxinq2:
        cmp     al,0d6h
        jnz     rxinq3
        jmp     window1         ;without returned data
;
rxinq3:
        cmp     al,0d7h
        jnz     rxinq1
        jmp     window2         ;with returned data
;       --- End testing window ---
rxinq1:
        mov     al,ah           ;ah is last code, al is current (over-written).
rxin1_7:                        ;case of fch, trans + char
        cmp     al,rqrsd        ;RSD request command?
        jne     rxin2_01        ;no, go store it
        jmp     rsdreq          ;init request if so
;       **********************************************************************
window1:                        ;terminal's done with its window request
;       mov     si,windw                ;but without returned data
;       and     byte ptr [si],not wndw  ;tell MXF window is done
;       mov     si,rsd_count            ;window counter
;       mov     word ptr [si],0         ;initial the counter
;       mov     di,d2636
;       mov     byte ptr [di],0ffh
        mov     di,dsrbyte
        and     byte ptr [di],not dtb
;       mov     si,curnt_sts
;       or      byte ptr [si],10h       ;tell OS window is done
;
;       test RSD Dec. 12th
;       or      byte ptr [si],rsdint
;       end Dec. 12th
;
;       call    distx
        jmp     rxin3                   ;### window, not fence
;       **********************************************************************
;
window2:                        ;terminal's done with its window request
;       mov     si,windw                ;with returned data
;       and     byte ptr [si],not wndw  ;tell MXF window is done
;
;       mov     di,d2636
;       mov     byte ptr [di],0ffh
;       mov     di,rsdbyte
;       and     byte ptr [di],not rsdabrtb
;       call    rstbfrsd        ;clear RSD buffer
;
;       mov     di,lrbyte
;       or      byte ptr [di],rsdgob
;       test    byte ptr [di],dtdelay
;       jnz     windowz
        mov     di,dsrbyte
        or      byte ptr [di],dtb          ;let dt go
        call    entx
windowz:
        mov     si,sts_byte
        or      byte ptr [si],04h
;
        jmp     rxin3                   ;### window, not fence
;       **********************************************************************
;
rxin2:
        mov     ah,0            ;store a status code and the current byte next
rxin2_01:
        mov     al,dl           ;ah store status code and al is current byte
        cmp     al,modebyte     ;occurance of modebyte?
        je      modeset         ;if so, go count it
        mov     di,count1
rxin2_02:
        mov     byte ptr [di],0ffh      ;reset count to inactive mode
rxin2_03:
        call    putkeys         ;store byte
        jz      rxin2_2q        ;exit if insertion was not successful
        mov     di,txbyte
;
;       testing for repeated keys Dec/21
;       test    byte ptr [di],keybit    ;test keyboard bit of current buffer
;       jnz     rxin2_2q
;       testing for repeated keys Dec/21
;
        or      byte ptr [di],keybit
        mov     di,lrbyte
        test    byte ptr [di],lrbit     ;LR in progress?
        jz      rxin2_2         ;jmp if not,
        mov     di,usermask
        mov     bx,[di]
        or      es:commode,bx   ;set the current port bit to service
        jmp     rxin3
rxin2_2:                        ;mark
        mov     di,intbyte
        test    byte ptr [di],keyint
        jz      rxin2_2q
;       and     byte ptr [di],not keyint
;
;       testing for non-lr & keyin, feb/11/92
;       mov     di,sts_byte
;       or      byte ptr [di],01
;       testing for non-lr & keyin, feb/11/92, end
rxin2key:
        mov     di,flag9
;       mov     di,curnt_sts
;       test    byte ptr [di],keyint  ;mask off jun/4/92
;       jnz     rxin2key
;       testing for non-lr & keyin, feb/24/92
;       mov     di,curnt_sts
        mov     di,flag9
        or      byte ptr [di],keyint
;
;       f%$! bug, may/13/92
;f0001:
;        test    byte ptr [di],04
;        jnz     f0001
;       f%$! bug, may/13/92, end
;
;       testing for non-lr & keyin, feb/24/92, end
rxin2_2q:
        jmp     rxin3
;
modeset:
                                ;count the occurances of 'modebyte' and
                                ;enter command mode at designated number
        mov     di,count1
        inc     byte ptr [di]          ;count of modebyte
        jz      rxin2_02               ;jmp if bump
;                                       possible entry into command mode
        cmp     byte ptr [di],mdbytep  ;mdbyte is 3
        jne     rxin2_03               ;go store byte if not at count
;                                        Command mode!
        mov     byte ptr [di],0
        dec     di                      ;point at flag2
        or      byte ptr [di],modebit   ;set command mode flag
        mov     si,msgmd1
        mov     cl,msgmd1l
        xor     ch,ch
        call    putstr
        jmp     rxin3
;       *********************************************************************
rsdin:                          ;j+
        ;During Remote Screen Dumps all bytes coming in from the terminal are
        ;stored in the RSD buffer rather than the keyboard buffer.  This
        ;section handles both the storing of those bytes and commands during
        ;RSD.
        ;RSD COMMANDS:
                ;All commands received from the terminal during RSD are
                ;escaped by 'RSDESC' ('F0' for a DW terminal) and are
                ;2 bytes long. The escape byte is discarded as the second
                ;byte has the real meaning.
                ;Allowable commands are:
                        ;'F2' - Start of RSD data. Always sent at the
                               ;beginning of an RSD stream
                        ;'F4' - End of RSD data. Always sent at the end
                               ;of an RSD stream
                        ;'F0' - send the code 'F0' ('F0' must be escaped
                               ;to allow for 'F0' in the data stream.)
                        ;CRTGO - reset STOPCRTB
                        ;CRTSTOP - set STOPCRTB
                        ;Check for second byte of command
;
        mov     di,rsdbyte
        test    byte ptr [di],comb    ;is command?
        jnz     rsdin3          ;jmp if command
                                ;not second byte of command - look for esccode
        cmp     al,rsdesc       ;is escape byte?
        je      rsdin2          ;yes
        cmp     al,reset        ;unescaped reset is reset
        jz      stoprsd1        ;reset code comming
rsdin1:
;                                Store the byte
        mov     di,rsdcomp
        test    byte ptr [di],lastrsd         ;was there a previous byte?
        jnz     rsdin12
        or      byte ptr [di],lastrsd
        mov     di,xorbyte
        mov     [di],al         ;store current byte
        jmp     rxin3
rsdin12:
        mov     di,xorbyte
        xchg    al,[di]         ;get last byte and save current byte
        call    putrsd          ;store last byte first,check?
        jmp     rxin3
;
rsdin2:                         ;Escape code found
        mov     di,rsdbyte
        or      byte ptr [di],comb
        jmp     rxin3
;
rsdin3:                         ;Command condition
        mov     di,rsdbyte
        and     byte ptr [di],not comb
        cmp     al,startrsd     ;beginning of data stream?
        je      strtrsd1        ;yes
        cmp     al,stoprsd      ;end of data stream?
        je      stoprsd1        ;yes
        cmp     al,rsdesc       ;2 escape and therefore esc in data?
        je      rsdin1          ;store byte if yes
        cmp     al,reset
        je      rsdin1
        cmp     al,crtgo
        je      rsdgock
        cmp     al,crtstop
        je      rsdstopc1       ;Otherwise, illegal command, just let go.
        cmp     al,0fdh         ;f1 + fd = continuing rsdgo
        je      rsd0fdk
        cmp     al,0feh         ;f1 + fe = stop temperarily from terminal
        je      rsd0fek
        cmp     al,0f5h         ;f1 + f5 = stop for window buffer full messages
                                ;is acknowledged by terminal
        je      rsd0f5k
strtrsd1:
                                ;Start of rsd stream, disregard for now must be
                                ;processed when data transfer is implemented.
        jmp     rxin3
rsdstopc1:
        jmp     rsdstopc
rsdgock:
        jmp     rsdgoc
rsd0fdk:
        jmp     rsd0fd
rsd0fek:
        jmp     rsd0fe
rsd0f5k:
        jmp     rsd0f5
;
stoprsd1:
                                ;End of data stream, end of RSD
        mov     di,dsrbyte
        and     byte ptr [di],not rsdb         ;reset RSD mode
        mov     di,rsdbyte
        or      byte ptr [di],rsdendb
        and     byte ptr [di],not rsdwaitb
                                ;Allow crt go if it was stopped
        mov     di,txbyte
        and     byte ptr [di],not crtstopb
;
;       bugging aug/5/91
;       mov     di,windw
;       cmp     byte ptr [di],0
;       jz      stoprsdk
;       bugging aug/5/91, end
                                ;reset RSD mode at terminal and let the terminal go
        mov     di,xorbyte      ;july/30/91
        xchg    al,[di]         ;get last byte and save current byte
        call    putrsd          ;store last byte first,july/30/91
;
        mov     di,windw
        cmp     byte ptr [di],0
        jz      stoprsdk
;
        mov     di,dsrbyte
        and     byte ptr [di],not dtb
        mov     di,windw
        mov     byte ptr [di],0
        mov     di,rsdbyte
        mov     byte ptr [di],0
        or      byte ptr [di],rsdendb
        mov     di,cmd_parm
        mov     byte ptr [di],fnlpage   ;final page
        mov     di,cmd_sts
        mov     byte ptr [di],0f0h      ;command complete
;       aug/28/91
        mov     di,curnt_sts
        or      byte ptr [di],windint
;       aug/28/91
;stopkkk:
        jmp     rxin3
;       and     byte ptr [di],not in_prcs
;       and     byte ptr [di],not cntncmd
;
stoprsdk:
        mov     al,esccode
        call    putdt
        mov     al,rsdend       ;Let terminal get back to normal mode
        call    putdt
        mov     al,esccode
        call    putdt
        mov     al,rsdgo
        call    putdt
                                ;Put extra zeros into buffer to signal end of rsd
                                ;Note: End rsd is assumed when byte gotten from
                                ;dt buffer is zero and abort bit was set. Otherwise
                                ;the zero will be sent to the terminal
        mov     di,rsdbyte
        or      byte ptr [di],rsdabrtb        ;flag to end of RSD
        mov     al,0
        call    putdt           ;put out 0 to waste time
        mov     si,int_event
        or      byte ptr [si],04h
        mov     si,curnt_sts
;       mov     si,flag9
;       mov     si,flag10
;       test RSD Dec. 12th
        or      byte ptr [si],rsdint
;       test RSD Dec. 12th end
;
        mov     si,curnt_sts
        or      byte ptr [si],10h       ;rsd is end, let OS take the data
        jmp     rxin3
rsdgoc:
        mov     di,txbyte
        and     byte ptr [di],not crtstopb
        jmp     rxin3
rsd0fd:                         ;Continuing tx window/write data
        call    entx
        jmp     rxin3
;
rsd0fe:                         ;Halt temperarily winndow/write data
        call    distx
        jmp     rxin3
;
rsd0f5:
                                ;End of data stream, rsd buffer temperarily full
;                                               aug/16/91
;       mov     di,dsrbyte
;       and     byte ptr [di],not rsdb         ;reset RSD mode,
;       Shouldn't reset under the multi-page condition, end aug/16/91
        mov     di,rsdbyte
        or      byte ptr [di],rsdendb
        and     byte ptr [di],not rsdwaitb
                                ;Allow crt go if it was stopped
        mov     di,txbyte
        and     byte ptr [di],not crtstopb
;
                                ;reset RSD mode at terminal and let the terminal go
        mov     di,xorbyte      ;july/30/91
        xchg    al,[di]         ;get last byte and save current byte
        call    putrsd          ;store last byte first,july/30/91
        mov     di,cmd_parm
        mov     byte ptr [di],midpage   ;final page
        mov     di,cmd_sts
        mov     byte ptr [di],0f0h      ;command complete
;       aug/28/91
        mov     di,curnt_sts
        or      byte ptr [di],windint
;       aug/28/91
;stopkkk:
        mov     di,windw
        mov     byte ptr [di],0
        or      byte ptr [di],cntncmd
        jmp     rxin3
;
rsdstopc:
        mov     di,txbyte
        or      byte ptr [di],crtstopb
rxin3:
        sti
        or      dh,0ffh         ;NZ flag
        ret
rxin    endp
;
;int_386 proc
;       ********************
;       MXF interrupts OS386
;       ********************
;        mov     dx,8000h        ;Interrupt address to OS386
;        mov     al,0
;        out     dx,al           ;interrupt CS386
;int_386 endp
;
clocki3 proc
;       **********************************
;       Routine handles one second timeout
;       **********************************
        push    ds
;       Test the dtr over here
        in      al,ip_2ab
        mov     ah,al
        in      al,ip_2cd
        mov     di,connct
        mov     es:[di],ax              ;record connection condition
;       mov     di,connct
;       mov     ax,es:[di]              ;connection status
        xor     bx,bx
        mov     dx,ax                   ;save dx for comparison
        mov     cx,10h
;
clocki32:
;
        mov     ax,es:dataseg[bx]
        mov     ds,ax
        push    bx
        push    cx
;       shr     ax,1                    ;connected ?
;       jnc     clocki33
;       connected !
        mov     di,tc_who
        cmp     byte ptr es:[di],0
        jnz     clocki31
;       This is not a TC time out
        call    testdsr
        jmp     clocki33
clocki31:
        call    testtc
;
clocki33:
        pop     cx
        pop     bx
        add     bx,2
        loop    clocki32
;
        pop     ds
        ret
clocki3 endp
;
clk_1   proc
;       **********************************************
;       Routine handles 0.1 second timeout vector.
;       However, it is valid only during TC condition.
;       **********************************************
        mov     di,tc_who
        cmp     byte ptr es:[di],0
        jnz     clk_11
        ret
clk_11:
        push    ds
        mov     bx,0
        cmp     byte ptr es:[di],1      ;port 1a?
        jz      clk_12
        mov     bx,4
clk_12:
        mov     ax,es:dataseg[bx]
        mov     ds,ax
;       call    int_1
        mov     di,statvec+5
        cmp     byte ptr [di],0
        jz      clk_13
        dec     byte ptr [di]
;
clk_13:
        pop     ds
        ret
clk_1   endp
;
