;
lredit	proc		;j+
;*******************************************************************************
;	Routines are used to process input bytes from the keyboard during lr.
;	Rules for processing bytes from the keyboard are:
;	 1) If the byte is escaped by 'TRANS' (foriegn or special character)
;	    then enter it into the buffer at LRWR.
;	 2) If the byte is escaped by 'ENDI/ATOM' then it falls in one of the
;	    following groups:
;
;		a)  00 <= byte <= 7F  -  byte is either a special function
;		    or an edit key.  Process edit keys.  Special function keys
;		    get passed to the 2200 by ending the LR and waiting for
;		    the 2200 to ask for the ending key.
;		b)  80 <= byte <= FF  -  byte is either a special function
;		    or an edit key.  Process edit keys.  Special function keys
;		    get passed to the 2200 by ending the LR and waiting for
;		    the 2200 to ask for the ending key.
;		    The difference between this group and the one above is
;		    that these same codes may be entered without the escape
;		    byte preceeding them.  Also, in addition to special functions
;		    and edit keys, ATOM keys are in this class.  ATOMs generate
;		    a predefined test on the screen.
;	  3) Bytes below 80 which are not escaped.  This group is devided into
;	    two subgroups:
;		a)  14 <= byte	<=7F  -  legal ASCII characters.  These are
;		    to be entered into the LRBUF.
;		b)  00 <= byte	<=13  -  control bytes.  The following are
;		    those controls which are defined:
;				     08  -  Backspace
;				     0D  -  Return
;				     12  -  Reset
;				     13  -  Halt/Step
;		NOTE: 12 and 13 are striped out before bytes get to the keybuf!
;			Any byte not in the list above should be turned into
;			a '#' followed by a beep as these are not legal codes.
;******************************************************************************
;
;	testing for input cursor mar/3/92
	mov	di,lrbyte
	test	byte ptr [di],lrbit
	jnz	lredit05
	ret
lredit05:
;	testing for input cursor mar/3/92, end
;
;	Get a byte from key_buf
	mov	di,key_count
	cmp	byte ptr [di],0
	jz	lredqq			;No byte, error return
;
;	At least one input byte, get it and process it
	call	getkey			;al gets byte, and ah holds status code
	mov	dl,al			;save it for a rainy day.
;	Deadkey ? Keep cursor in same position but display deadkey on screen
	cmp	ah,deadkey2		;Print byte but don't move cursor
	jnz	lredit1 		;jump if not underscore
	cmp	al,larrow		;BS(back space)
	jnz	lredit0
	mov	al,20h
lredit0:
	call	putlr			;put into lr buffer, with al as entry.
	jz	lredqq			;exit if buffer full
	mov	di,lrwr
	dec	word ptr [di]
	mov	bx,[di] 		;point at underscore
	call	movecur 		;position cursor over underscore
	ret
lredit1:
	cmp	ah,trans		;transparency code?
	jnz	lredit2 		;jump if not
;	Byte escaped by trans, so put it into buffer
	call	putlr			;put in buffer, with al as entry.
	ret
lredit2:
;					;byte above 7eh
	cmp	al,80h
	jnc	lreditja		;jump if > 80h -> atom
;	byte less than 80h, -> special function, edit key? or ASCII byte?
	cmp	ah,endiatom
	jnz	lredizq 		 ;jump if ENDI/ATOM
	jmp	lredits
lreditja:
	jmp	lredita
lredizq:
;	Now, byte is Char or return or backspace or illegal?
	cmp	al,larrow		;BS?
	jz	lrbs			;yes
	cmp	al,return		;return?
	jz	lrret			;yes
;	Is it below 14? -> beep and print #
	cmp	al,14h
	jnc	lrascii 		;jump if ascii code
					;illegal!
	mov	al,23h			;ascii of '#' is 23h
	call	putlr
	mov	al,beep
	call	putcrtg
lredqq:
	ret
lrascii:
;					 Legal ascii code, put into buffer
	call	putlr
	ret
;
lrbs:			   ;Backspace, put out 'BS''blank''BS' if lrwr <> lr_buf
	mov	di,lrwr
	cmp	word ptr [di],0 	;At the beginning of buffer?
	jz	lreditz 		;illegal BS, return
;			    If lrwre = lrwr then lrwre must be decremented too.
;	add	di,2			;point at lrwre
	mov	bx,[di]
	mov	si,lrwre
	cmp	bx,[si]
	jnz	lrbs2			;jump if not equal
;					 Equal, decrement both.
	dec	bx
	mov	word ptr [si],bx	;decrement lrwre
	mov	di,lrcnt
	inc	word ptr [di]		;lrcnt = (max count) - (current count)
	jmp	lrbs3
lrbs2:
;	mov	di,lrwr
	dec	bx			;adjust pointer
lrbs3:
;	mov	di,lrwr
;	mov	bx,[di]
	mov	si,lr_buf
	mov	byte ptr [si][bx],blank
;	mov	bx,[di]
	call	movecur
;					;Update screen
	mov	al,blank
	call	putclr
	mov	al,larrow
	call	putcrtg
	ret
lrret:			;Return key received -> end lr and alert 2200
	mov	di,lrquery
	mov	byte ptr [di],return
lrret2:
;
;	testing for repeated keys, mask on mar/24/92
	mov	di,flag9
;	mov	di,curnt_sts
;	test	byte ptr [di],lrint    ;mask off jun/4/92
;	jnz	lrret2
;	testing end repeated keys, mask on end mar/24/92
;
	mov	di,flag9		     ;mark
;	mov	di,curnt_sts		     ;mark
	or	byte ptr [di],lrint	     ;lr complete bit
;
;	f%$! bug, may/13/92
;f0002:
;	 test	 byte ptr [di],04
;	 jnz	 f0002
;	f%$! bug, may/13/92, end
;
;
	mov	di,rbibus
	or	byte ptr [di],statrb
	mov	di,lrbyte
	or	byte ptr [di],lrendbit	     ;set end of lr bit
	and	byte ptr [di],not lrbit      ;turn off the lr bit
	mov	di,int_event
	or	byte ptr [di],01h	     ;Tell CS386 LR complete
;	mov	di,term_stat
;	or	byte ptr [di],01h
;	call	int_386
	ret
;
lreditz:
	ret
lredita:
;	Byte >= 80h, means ATOM or special function
;	For atoms, it doesn't matter if an escape proceeds the ATOM or not.
;	Look for special function key from an older terminal which will be in
;	the range 'c0h' to 'dfh', means translate to '00h' to '1fh' and process
;	as special function key.
	cld				;Make DF be zero
	cmp	al,0c0h 		; < c0h
	jc	lra81			;jump less than c0h
	cmp	al,0e0h 		; >= eoh
	jnc	lra81
;					 This is an older terminal special function key
	sub	al,0c0h 		;Translate
	jmp	lredits 		;al holds the new char
lra81:					;Look for atoms
	cmp	al,81h			;clear atom
	jnz	lra82			;Go check for 82
	mov	si,a81			;Messages, checks
	mov	cl,a81s 		;Length of messages
	xor	ch,ch
	jmp	lrap			;Go enter atom into buffer
lra82:
	cmp	al,82h			;Atom 'run' ?
	jnz	lra84
	mov	si,a82			;messages
	mov	cl,a82s 		;length
	xor	ch,ch
	jmp	lrap
lra84:
	cmp	al,84h			;Atom 'continue' ?
	jnz	lraa0
	mov	si,a84
	mov	cl,a84s
	xor	ch,ch
	jmp	lrap
lraa0:
	cmp	al,0a0h
	jnz	lraa1			;Atom 'print' ?
	mov	si,aa0
	mov	cl,aa0s
	xor	ch,ch
	jmp	lrap
lraa1:
	cmp	al,0a1h
	jnz	lrae6			;Atom 'load' ?
	mov	si,aa1
	mov	cl,aa1s
	xor	ch,ch
	jmp	lrap
lrae6:
	cmp	al,0e6h
	jnz	lrabd			;Atom 'statement # '
	mov	si,ae6
	mov	cl,ae6s
	xor	ch,ch
lrap:					;Print atoms
	call	putlrstr		;check?
	ret
;
lrabd:			;Test for 'bd' or 'f0', both are edit key
	cmp	al,0bdh
	jz	lrabd2			;jump if yes
	cmp	al,0f0h
	jnz	lrae5			;jump if not
lrabd2: 				;Edit key condition
	mov	di,lrbyte
	mov	al,[di]
	xor	al,editon		;toggle edit bit, adjust cursor (blink)
	mov	[di],al
	and	al,editon		;get only edit bit
	jz	lrabd3
;			 edit mode, blink cursor
	mov	si,blink	 ;check?
	mov	cl,blinks
	xor	ch,ch
	call	putstr
	ret
lrabd3: 		;set cursor steady
	mov	si,noblink
	mov	cl,noblinks
	xor	ch,ch
	call	putstr
	ret
lrae5:			;Line erase?
	cmp	al,0e5h
	jnz	lraeq1
	jmp	erasel
lraeq1:
;			 Looking for special key or illegal key.
	cmp	al,0beh 	;< beh ?
	jc	lraends 	;jump if illegal key
	cmp	al,0c0h
	jnc	lraends
;		beh or bfh - translate
	xor	al,0c0h
	jmp	lredits 	;Go to handle special function key
lraends:
	cmp	al,0ffh 	;0ffh should be discarded
	jz	lraendq 	;zero return
;				 Illegal byte
	mov	al,beep
	call	putcrtg
lraendq:
	ret
lredits:
;	Special function key or edit key?
;	Rules:	(1) If 45 <= byte <= 5d then look in table (mixed)
;		(2) If 00 <= byte <= 1f and lreditbit = 1 then look
;		    in table for service routines.
;		(3) All the others are special function keys and end the lr.
;
	cmp	al,42h		;jp if less than 42
	jc	lrsf3
	cmp	al,60h		;jp if special function keys
	jnc	lrsf
;		Looking in the table to get the service
	sub	al,42h
	xor	ah,ah
	shl	ax,1
	mov	si,ax
	jmp	cs:sftab1[si]
;
lrsf3:		;Is it as edit key?
	mov	di,lrbyte
	test	byte ptr [di],editbit
	jz	lrsf	       ;Jump if special function key
	cmp	al,20h
	jnc	lrsf	       ;jump if SF
;		 Real edit key here!
	xor	ah,ah
	shl	ax,1
	mov	si,ax
	jmp	cs:sftab2[si]	;look for table2
;
lrsf:	;Special function pressed, end of lr and notice 386?
	mov	di,lrquery
	mov	byte ptr [di],0feh
	mov	di,lrsfb
	mov	[di],al        ;save the original byte
	jmp	lrret2
;
;	 Special function lookup table - bytes between 45 and 5f
sftab1	dw	ignoresf	     ;SF42 - prev scrn
	dw	ignoresf	     ;SF43 - next scrn
	dw	lrsf		     ;SF44 - special function key
	dw	lrdwn		     ;SF45 - down arrow
	dw	lrup		     ;SF46 - uparrow
	dw	lrsf		     ;SF47 - special function key
	dw	erase		     ;SF48 - erase to end of line
	dw	lrdel		     ;SF49 - delete a byte
	dw	lrin		     ;SF4A - insert a byte
	dw	lrsf		     ;SF4B - special function key
	dw	lrr1		     ;SF4C - right arrow
	dw	lrl1		     ;SF4D - left arrow
	dw	lrsf		     ;SF4E - special function key
	dw	lrrec		     ;SF4F - recall key pressed
	dw	lrsf		     ;SF50 - special function key
	dw	lrsf		     ;SF51 - special function key
	dw	ignoresf	     ;SF52 - shift prev scrn
	dw	ignoresf	     ;SF53 - shift next scrn
	dw	lrsf		     ;SF54 - special function key
	dw	lrcend		     ;SF55 - shift down arrow
	dw	lrbeg		     ;SF56 - shift uparrow
	dw	lrsf		     ;SF57 - special function key
	dw	lrsf		     ;SF58 - special function key
	dw	lrdel		     ;SF59 - shift delete key
	dw	lrins		     ;SF5A - shift insert key
	dw	lrsf		     ;SF5B - special function key
	dw	lrr5		     ;SF5C - 5 right arrows
	dw	lrl5		     ;SF5D - 5 left arrows
	dw	lrsf		     ;SFFE - special function key
	dw	lrrec		     ;SF5F - recall key
;
;	 Edit key lookup table - bytes between 00 and 1f - some illegal
sftab2	dw	lrbeep		     ;SF00 - ILLEGAL KEY
	dw	lrbeep		     ;SF01 - ILLEGAL KEY
	dw	lrbeep		     ;SF02 - ILLEGAL KEY
	dw	lrbeep		     ;SF03 - ILLEGAL KEY
	dw	lrcend		     ;SF04 - cursor to end
	dw	lrdwn		     ;SF05 - down arrow
	dw	lrup		     ;SF06 - up arrow
	dw	lrbeg		     ;SF07 - cursor to begining
	dw	erase		     ;SF08 - erase to end of line
	dw	lrdel		     ;SF09 - delete a byte
	dw	lrin		     ;SF0A - insert a byte
	dw	lrr5		     ;SF0B - 5 right arrows
	dw	lrr1		     ;SF0C - right arrow
	dw	lrl1		     ;SF0D - left arrow
	dw	lrl5		     ;SF0E - 5 left arrows
	dw	lrrec		     ;SF0F - recall key

;	shift of edit keys
	dw	lrbeep		     ;SF10 - ILLEGAL KEY
	dw	lrbeep		     ;SF11 - ILLEGAL KEY
	dw	lrbeep		     ;SF12 - ILLEGAL KEY
	dw	lrbeep		     ;SF13 - ILLEGAL KEY
	dw	lrcend		     ;SF14 - cursor to end
	dw	lrdwn		     ;SF15 - down arrow
	dw	lrup		     ;SF16 - up arrow
	dw	lrbeg		     ;SF17 - cursor to begining
	dw	erase		     ;SF18 - erase to end of line
	dw	lrdel		     ;SF19 - delete a byte
	dw	lrin		     ;SF1A - insert a byte
	dw	lrr5		     ;SF1B - 5 right arrows
	dw	lrr1		     ;SF1C - right arrow
	dw	lrl1		     ;SF1D - left arrow
	dw	lrl5		     ;SF1E - 5 left arrows
	dw	lrrec		     ;SF1F - recall key
;
lrbeep: 		;Illegal byte, beep!
	mov	al,beep
	call	putcrtg
	ret
;
ignoresf:	;Ignore key, some special keys are not treated as SF in lr mode.
	ret
;
lrbeg:		;Set cursor at beginning of lr_buf
	mov	bx,0
	call	movecur
	ret
lrcend: 			;Set cursor at the end of lr_buf
	mov	di,lrwre
	cmp	word ptr [di],0
	jnz	lrcend1 	;any byte in buffer
	ret
lrcend1:
	mov	bx,[di] 	;# of bytes to be tested
	mov	al,blank
	mov	si,lr_buf
lrcend2:
		;Compare until last non-blank byte in buffer is found
	cmp	al,[si][bx]
	jnz	lrcend3
	dec	bx
	loop	lrcend2
	jmp	lrcend4 	;no data to test
lrcend3:
;	inc	bx
	inc	bx
lrcend4:
;	mov	[di],bx
;	mov	bx,cx
	call	movecur
	ret
;
lrr1:			;Move cursor one right
	mov	bx,01h
	jmp	lrcm
lrr5:			;Move cursor five right
	mov	bx,05h
	jmp	lrcm
lrl1:			;Move cursor one left
	mov	bx,-01h
	jmp	lrcm
lrl5:			;Move cursor five left
	mov	bx,-05h
lrcm:			;Compute destination
	mov	di,lrwr
	add	bx,[di]
	call	lrpos	;check?
	call	movecur
	ret
;
lrdwn:				;Move one line forward
	mov	di,lwidth
	mov	bl,[di]
	xor	bh,bh
;	mov	bx,linelen
	jmp	lrlcm
lrup:
	mov	di,lwidth
	mov	bl,[di]
	xor	bh,bh
	neg	bx
;	mov	bx,-linelen	;Move one line backward
lrlcm:
	mov	di,lrwr
	add	bx,[di]
	call	lrpos
	jnz	lrlcmz		;return if out of bounds
	call	movecur
lrlcmz:
	ret
;
lrin:
lrins:				;Insert blank bytes into lr_buf
	call	shftlr		;shift lr_buf to make room
	jz	lrinz		;return if no room, end of lr_buf
	mov	di,lrwr
	mov	bx,[di]
;	mov	bx,dx		;pointer from dx
	mov	si,lr_buf
	mov	byte ptr [si][bx],blank
	mov	di,lrwre	;point at lrwre
	mov	bx,[di]
	mov	di,lrwrp2
	mov	[di],bx 	;check?
;	Looking for another insert key in buffer and process it before printing
;	Note: Special function inserts are not looked here.check?
	mov	di,txbyte
	test	byte ptr [di],keybit
	jz	lrin8
	mov	di,key_rd
	mov	bx,[di] 	     ;read key_buf but do not update the pointer
	mov	si,key_buf
	mov	al,[si][bx]	;Get status code
	cmp	al,endiatom
	jnz	lrin8		;jump if not
	inc	bx
	mov	al,[si][bx]	;Get input byte
	cmp	al,4ah		;Is it input key
	jz	lrin5
	cmp	al,5ah		;Shifted insert key
	jz	lrin5
				;Looking for edit insert key
	mov	di,lrbyte
	test	byte ptr [di],editbit
	jz	lrin8		;jump if not in edit mode
	cmp	al,0ah		;edit insert?
	jz	lrin5		;jump if yes
	cmp	al,1ah		;shift edit insert?
	jnz	lrin8		;jump and print if not
lrin5:
;	Insert in buffer, get the code and do another insert.
	call	getkey
	jmp	lrin
lrin8:				;Starting to print
	call	lrout
lrinz:
	ret
;
lrrec:		;Recall key pressed!
;	End lr with recall key, search all bytes from lrwr to lrwre for
;	non-blank chars. Recall is illegal if non-blank bytes are found.
	mov	di,lrwre
	mov	cx,[di]
	mov	si,lrwr
	sub	cx,[si] 	     ;# of bytes after lrwr
	jz	lrrec3		     ;jp if ok to recall
;				      Do the comparison
	mov	bx,[si] 	     ;start point
	mov	si,lr_buf
lrrec1:
	cmp	byte ptr [si][bx],blank
	jz	lrrec2		;jump if non-blank
	jmp	lrbeep		;Error exit
lrrec2:
	inc	bx
	loop	lrrec1
lrrec3:
	mov	di,lrquery
	mov	byte ptr [di],0ffh    ;set recall destination
	jmp	lrret2
;
erasel: 	;Erase entire content of lr_buf
;	Move cursor to the beginning of buffer and jump to erase, clear edit
;	mode. Note: Shift erase code is in upper 80's, so it's not in jump table.
	mov	di,lrbyte
	and	byte ptr [di],not editbit
	mov	al,curson
	call	putcrtg
	mov	bx,0
	call	movecur
;
erase:		;Erase from cursor position to end of buffer
	mov	di,lrwr
	mov	ax,[di]
;
	mov	di,lrwre
	mov	cx,[di]
	mov	[di],ax
	mov	si,lrwrp2
	mov	[si],cx
	add	si,2		;point at lrwr
	sub	cx,ax
	push	cx
	jz	erasez		;Leave if no byte to be blanked
	mov	bx,[si] 	     ;Start point
	mov	di,lr_buf
erasej:
	mov	byte ptr [di][bx],blank
	inc	bx
	loop	erasej
;
	pop	cx		;restore count
	mov	di,lrcnt
	add	[di],cx 	;lrcnt = lrcnt + # bytes cleared
	call	lrout
	ret
erasez:
	pop	cx
	ret
;
lrdel:		;Delete char currently pointed at by lrwr and shift buffer left.
;	Shift delete key pressed! if lrwr=lrwre then exit.
	mov	di,lrwre
	mov	cx,[di]
	mov	es:scratch6,cx
lrdel1:
	mov	di,lrwr
	sub	cx,[di] 	     ;Find the # of bytes between lrwre and lrwr
	jz	lrdel5		     ;go print if no byte to be deleted
	mov	bx,[di] 	     ;start point
	mov	si,lr_buf
lrdelj:
	mov	dl,[si][bx+1]
	mov	[si][bx],dl
	inc	bx
	loop	lrdelj
;			Update pointers, if lrwrp2 > lrwre then lrwrp2 = lrwrp2
	mov	di,lrwrp2
	cmp	bx,[di] 	     ;lrwre - lrwrp2, (bx is new lrwre)
	jae	lrdel3		;jump if lrwrp2 >= lrwre check?????????
	mov	cx,bx
	inc	cx
	mov	[di],cx
lrdel3:
	dec	bx
	mov	di,lrwre
	mov	[di],bx
	add	di,2		;point at lrcnt
	inc	word ptr [di]
;		Look for more deletes in key_buf and process them when found
	mov	di,txbyte
	test	byte ptr [di],keybit   ;byte in key buffer
	jz	lrdel5
	mov	di,key_rd
	mov	bx,[di] 	     ;read key_buf but do not update the pointer
	mov	si,key_buf
	mov	al,[si][bx]	     ;Get status code
	cmp	al,endiatom
	jnz	lrdel5		     ;go print if not escaped
	inc	bx
	mov	al,[si][bx]	     ;Get input byte
	cmp	al,49h		     ;Is it input key
	jnz	lrdelq1
lrdelq2:
	jmp	lrin5
lrdelq1:
	cmp	al,59h		;Shifted delete key
	jz	lrdelq2
				;Looking for edit delete key
	mov	di,lrbyte
	test	byte ptr [di],editbit
	jz	lrdel4		;jump if not in edit mode
	cmp	al,09h		;edit delete?
	jz	lrdel4		;jump if yes
	cmp	al,19h		;shift edit delete?
	jnz	lrdel5		;jump and print if not
lrdel4: 			;process another delete key
	call	getkey
	jmp	lrdel1
lrdel5: 			;Print buffer from cursor to lrwre (the lrwr
				;that was saved above so that all deletes are
				;shown on screen).
	mov	dx,es:scratch6
	mov	di,lrwrp2
	mov	[di],dx 	;lrwrp2 = original lrwre check?
	call	lrout
	ret			;Go print lr_buf
lredit	endp
;
nxtline proc		;j+
;	Routine puts out a return-linefeed to start a new row on the screen.
	mov	al,return
	call	putcrtg
	mov	al,dwnarrow
	call	putcrtg
	ret
nxtline endp
;
lrpos	proc		;j+
;	********************************************************
;	Routine bounds the pointer in bx by lrwre and lr_buf.
;	Entry:	 bx = pointer in question
;	Return: If bx < lr_buf then bx = lr_buf
;		If bx > lrwre  then bx = lrwre
;		Z,  if lr_buf <= bx <= lrwre when called
;		NZ, if bx had been set to either lr_buf or lrwre
;	********************************************************
	mov	di,lrwre
	cmp	bx,[di]
	jz	lrpos5		;exit if zero, bx = lrwre
	jl	lrpos3		;jump if bx < lrwre
;
				;bx > lrwre, set  bx = lrwre and return NZ
	mov	bx,[di]
lrpos2:
	or	ax,0ffh 	;Set NZ
	ret
lrpos3: 			;bx < lrwre, test the beginning
	cmp	bx,0
	jge	lrpos5		;jump if bx (pointer) is greater or equal zero.
	mov	bx,0
	jmp	lrpos2
lrpos5:
	xor	ax,ax		;set Z flag
	ret
lrpos	endp
;
shftlr	proc			;j+	per
;	************************************************************************
;	Routine shift the contents of lr_buf to the right one byte for inserting
;	into the buffer. The string from lrwr to lrwre is shifted one byte and
;	lrwre is advanced if not at the end of the lr_buf.
;	Return: Z,  unable to shift (i.e. lrwr = lrwre = lrstop)
;		NZ, buffer is shifted, byte at lrwr is not changed.
;	************************************************************************
	mov	di,lrcnt
	cmp	word ptr [di],0 ;lrcnt = 0, means  current_count = max_count
	jz	shftlr4 	;jump if lrwre = lrcnt
	dec	word ptr [di]
;				 Advance lrwre one byte
	mov	di,lrwre
	inc	word ptr [di]
;	mov	dx,[di]
shftlr4:			;Find (lrwre - lrwr)
	mov	si,lrwr
	mov	di,lrwre	;point lrwre
	mov	cx,[di]
	sub	cx,[si] 	;bx holds the difference of bytes
	jz	shftlrz 	;exit if lrwre = lrwr = lrcnt ?
				;Now, move string
	std			;set the direct flag
	push	es
	push	ds
	pop	es				;adjust ds = es
	mov	bx,[di] 	;lrwre <- di
	mov	di,lr_buf
	add	di,bx			;destination
	mov	si,di			;source
	dec	si
;	mov	si,lr_buf[bx-1] 	 ;source
;	mov	di,lr_buf[bx]		 ;destination
	rep	movsb				;move them!
	pop	es				;Return gen_store to es
	mov	di,lr_buf
	mov	byte ptr [di][bx],blank
;	mov	di,lr_buf
	inc	si
	sub	si,di
	mov	bx,si
	or	cx,0ffh 			;Set NZ flag
shftlrz:
	ret
shftlr	endp
;
findcur proc		;j+
;	******************************************************************
;	Routine finds the row/column coordinates of the pointer passed
;	in dx.
;	Entry: dx = buffer pointer.
;	Exit: al holds column coordinate, ah holds row coordinate with
;	respect to the starting row of the lr. (WRT the first byte on the
;	first row of the lr and not the offset on that row.)
;	******************************************************************
;	Calculate: ((pointer + offset) - buffer_start) / line_length
;	Desired results: remainder and dividend
;
	mov	di,lrstart
	mov	al,[di]
	xor	ah,ah
	add	ax,dx			;ax is the position count
	clc				;clear carry flag
	mov	di,lwidth
	mov	cl,[di]
;	mov	cl,linelen
	div	cl			;Find out the row/column
					;al/Quotient, ah/remainder
	xchg	al,ah			;For the sake of MXE, do the exchange.
;	now, after exchange, al is the column coordinate, ah is the row coordinate
	ret
findcur endp
;
movecur proc		;j+
;	******************************************************************
;	Routine moves the cursor from lrwrp1 to bx.
;	lrwrp1 and lrwrp2 are updated. No error checking here!
;	Entry: bx holds the desired position.
;	******************************************************************
	mov	di,lrwrp1
	mov	dx,[di]
	mov	[di],bx
;	lrwrp1 now was updated while dx holds previous value, bx/desired
;	update remaining pointers and then update screen
	add	di,2		;point at lrwrp2
	mov	[di],bx
	add	di,2		;point at lrwr
	mov	[di],bx
;				 update the screen
	call	findcur 	;get pointer coordinate with dx as entry.
	push	ax		;save the current coordinates
	mov	dx,bx		;find desired cursor positions
	call	findcur
	pop	dx		;Now, al / destination column coordinate
				;     ah / destination row coordinate
;	dl / current column coordinate, dh / current row coordinate
;
;	Compute the column displacement first then row and update screen.
	sub	al,dl		;al = col(dest) - col(curr)
;	if col(dist) - col(curr) > 0 output rarrow
				;< 0 output larrow
				;= 0 go update row
	jz	movec5z 	;go update row
	jb	movecur3	;output larrow
	mov	bl,al		;bl is count
	mov	bh,rarrow	;output arrow
	push	ax
	push	dx
	call	putcrtm
	jmp	movecur5	;row next
movecur3:
	neg	al
	mov	bl,al
	mov	bh,larrow
	push	ax
	push	dx
	call	putcrtm
movecur5:			;Row operation
;
;	if row(dist) - row(curr) > 0 output dwnarrow
;				 < 0 output uparrow
;				 = 0 go return
	pop	dx
	pop	ax
movec5z:
	sub	ah,dh		;Row displacement
	jz	movret		;return if zero
	jb	movecur7
	mov	bl,ah		;count
	mov	bh,dwnarrow
	call	putcrtm
movret:
	ret
movecur7:
	neg	ah
	mov	bl,ah
	mov	bh,uparrow
	call	putcrtm
	ret
movecur endp
;
movelr	proc		;j+
;	*******************************************************************
;	Routine moves bytes from lr_buf to crt_buf for printing on screen.
;	It is assumed crt_buf is empty when routine is called.
;	Entry: al = # bytes to be moved
;	Exit: al bytes have been moved (including added escaped 0fbh's)
;	*******************************************************************
;	Move the number of bytes specified by al
	xor	ah,ah
	cmp	al,0
	jz	movelrz 		;exit if no byte at all
	push	ax
	push	ax
	mov	di,lrbyte
	test	byte ptr [di],underbit	       ;underline mode
	jnz	movelr2
	mov	byte ptr es:scratch1,0
	jmp	movelr22
movelr2:
	mov	byte ptr es:scratch1,80h
movelr22:
	mov	cx,ax			;load the count
	mov	di,lrwrp1
	mov	bx,[di]
	mov	dx,0
	cli				;lock before moves
	mov	si,lr_buf
	mov	di,crt_buf
movelr3:	;Move from bx/lrwrp1 to dx/crt_buf with translation and underlining
	mov	al,[si][bx]
	cmp	al,10h			;translation?
	jnc	movelr4
	mov	al,2eh			;under 10h, move period/2eh
movelr4:	;Underlining? Mask with cl which may set underline bit on
	or	al,es:scratch1
;	push	di
;	add	di,dx
	mov	[di],al 		;move to crt_buffer
;	pop	di
	inc	bx
	inc	di			;advance both pointers
	cmp	al,0fbh
	jnz	movelr5
	mov	al,0d0h
;	push	di
;	add	di,dx
	mov	[di],al 	    ;crt_buf
;	pop	di
	inc	di
	pop	ax
	inc	ax			;update actual count for 0d0h
	push	ax
movelr5:				;Another byte?
	loop	movelr3
	pop	ax			;restore byte(count)
	mov	di,txbyte
	or	byte ptr [di],crtbit	       ;set crt bit
	mov	di,crt_wrt
	mov	[di],ax 		;Set write pointer to # of bytes
	add	di,2			;point at crt_rd
	mov	word ptr [di],0
	mov	di,crt_count
	mov	[di],ax 		;set count of buffer
	sti				;unlock
; Update printer write pointers with count requested, Note: d0h's not in lr_buf.
	pop	ax			;count without 0d0h condition
	mov	di,lrwrp1
	add	[di],ax
	call	entx
movelrz:
	ret
movelr	endp
;
lrprt	proc		;j+
;	********************************************************************
;	Routine controls the transfer of bytes from the lr_buf to crt_buf.
;	Each time it is called it directs the movement of up to one line
;	from the lr_buf to the crt_buf.
;	Entry: crt_buf must be empty!!!!!
;	Exit: Some # of bytes are moved to crt_buf for printing on the
;	screen and pointers are updated.
;	Return: Z = lr_buf empty, NZ = lr_buf not empty
;	Error: If crt_buf not empty, bytes in crt_buf will be lost.
;	********************************************************************
;	First compute # of bytes from lrwrp1 to end of line or buffer
;	Get coordinates of lrwrp1 in row/column units
	mov	di,lrwrp1
	mov	dx,[di]
	push	dx		;save the lrwrp1
	call	findcur 	;Find the cursor coordinates
				;Now, ah = row, al = column
	mov	di,lwidth
	sub	al,[di]
;	sub	al,linelen	;get # bytes left on row
	neg	al
	pop	bx		;get 1st pointer
	mov	di,lrwrp2
	mov	cx,[di]
;	clc
	sub	cx,bx
	jnz	lrprt1
	ret			;No more data to print, return with Z flag.
lrprt1:
	xor	ah,ah
	sub	cx,ax		;# bytes left - # bytes to next line
	jb	lrprt3		;go print to end of buffer
	call	movelr
	call	nxtline
	or	ax,0ffh 	;set NZ flag
	ret
lrprt3:
	add	cx,ax		;make leftover positive
	mov	ax,cx		;al = linelen - # bytes to move
	call	movelr
	xor	ax,ax		;set Z flag
	ret
lrprt	endp
;
lrout	proc		;j+
;	**********************************************************************
;	Routine controls the printing of the lr_buf and the positioning of
;	the cursor on the screen and the setting of related flags.
;	Each time it is called it tries to print another line from the lr_buf
;	If it is empty, it resets the printing flags and repositions cursor
;	on the screen.
;	If the lr is finished then the cursor will be positioned at the end
;	of the specified lr field and then put out a return/line_feed to place
;	the cursor after the lr field. If the 2200 has already read the content
;	of the lr_buf then clear the lr_buf.
;	Note: 1. crt_buf must be empty.
;	      2. The screen is updated to reflect the contents of lr_buf. But
;		 updating is not always complete and this routine must be
;		 call again.
;	Return: Z = done updating screen, NZ = still need updating
;	**********************************************************************
;	Set 'printing lr_buf' bit and try to print more of the lr_buf
	mov	di,lrbyte
	or	byte ptr [di],lrprtbit
;
;	Test crt_buf for bytes. If not empty then return and try again later
;	else it is ok to move bytes to the crt_buf now
	cli
	mov	di,crt_count
	cmp	word ptr [di],0
	sti
	jnz	lrover		;Crt_buf is not empty
	call	lrprt		;Print some more data of the buffer check?
	jnz	lrover		;exit if not done moving entire buffer
;
;	lr_buf is completely updated! Reposition cursor and reset flags.
	mov	di,lrbyte
	and	byte ptr [di],not lrprtbit     ;reset prt bit
;
;	### testing for Edit-recall Dec/19 ###
	mov	si,after0a		;Is it under the 060a command?
	cmp	byte ptr [si],0ffh
	jnz	lroutqt 		;exit if not
	mov	byte ptr [si],0 	;clear it
lroutqt:
;	### testing end Edit-recall Dec/18 ###
;
;	If bytes are currently in the key_buf then set the service bit
	mov	di,key_count
	cmp	byte ptr [di],0
	jz	lrout0
	mov	di,usermask
	mov	bx,[di]
	or	es:commode,bx	     ;set the service bit
;
lrout0:
;	Test current lr status, if lr is done then position cursor after lr
;	field and try to clear lr_buf. Note: If not lrbit and not lrendbit
;	then clear lr_buf.
	mov	di,lrbyte
	test	byte ptr [di],lrbit
	jnz	lrout1		;lr still in progress
;	lr is done set lrwr to lrwre so that cursor will be positioned
;	to the end of the text field. Then put cursor on next line
	mov	di,lrwre
	mov	bx,[di]
	jmp	lrout2
lrover:
	ret
;
lrout1:
;	Move cursor to current position (end of lr is lrwr = lrwre)
	mov	di,lrwr
	mov	bx,[di]
lrout2: 				       ;dx (pointer,not address) location wanted
	call	movecur 		       ;Move cursor from wrp1 to wr
lrout7:
;	lr end? if so, then update screen and clear out lr_buf
	mov	di,lrbyte
	test	byte ptr [di],lrbit
	jnz	lroutret		       ;lr is not done
;
;	lr is done, clear lr_buf and set cursor to line after lr field unless
;	the field was underlined. If so, then reprint the entire lr_buf
;	without underlines.
	test	byte ptr [di],underbit	       ;underline mode
	jz	lrout8
	and	byte ptr [di],not underbit     ;reset underline mode
;	Set print pointers so that the entire buffer will be reprinted.
;	mov	di,lr_buf		       ;set to the beginning of buffer
;	mov	bx,di
	xor	bx,bx
	call	movecur
	mov	di,lrstop
	mov	bx,[di]
	mov	di,lrwrp2
	mov	[di],bx
;	Set lwrwe to lrstop so that the cursor will be positioned after
;	the entire lr field after the lr is completed.
	mov	di,lrwre
	mov	[di],bx
	jmp	lrout
lrout8: 			;check?
	mov	al,curson
	call	putcrtg
;	Clear up screen
	call	nxtline
	mov	di,lrbyte
	test	byte ptr [di],lrendbit
	jnz	lroutz
	call	rstlr
lroutz: 				;mark
;
;	testing for repeated keys, mask on mar/24/92
;	mov	di,flag9
;	mov	di,curnt_sts
;	test	byte ptr [di],lrint
;	jnz	lroutz
;	testing end repeated keys, mask on end mar/24/92
;
;	mov	di,flag9
;	mov	di,curnt_sts
;	or	byte ptr [di],lrint
;
;	f%$! bug, may/13/92
;f0003:
;	 test	 byte ptr [di],04
;	 jnz	 f0003
;	f%$! bug, may/13/92, end
;
;
	mov	di,int_event
	or	byte ptr [di],01h
	xor	di,di			;set Z
lroutret:
	ret
lrout	endp
;
addlr	proc	;j+
;	*******************************************
;	Routine to process the line request buffer
;	*******************************************
	cld
	push	es
	push	ds
	pop	es			;Make es = ds
	sti				;--- testing ---
	mov	di,lradd
	mov	ax,[di]
	cmp	ah,0ffh
	jnz	addlr11
;
	mov	di,lrwr
	mov	ax,[di]
addlr11:				;ax saves lradd or lrwr
	mov	di,lrstop
	mov	bx,[di] 		;Compute # byte
	sub	bx,ax			;max bytes to be added
	jbe	addlrz			;Error exit
;					;Test for pre- or re-fill mode
	mov	di,lrinit
	test	byte ptr [di],fillbit	;Pre- data in LR buffer, re- in parameter
	jz	addlrp			;0/prefill, 1/refill
;	Refill condition, looking for data that was filled in command parameter
	mov	si,cmd_parm
	mov	cl,[si] 		;get the count
	xor	ch,ch
	mov	dx,cx			;save the count
	cmp	cx,bx			;Exceed the LR field?
	jc	addlrx1
	mov	cx,bx			;limit within field
	mov	dx,cx			;--- testing --- @@@
addlrx1:
	inc	si			;source, point at cmd_parm
	mov	di,lr_buf
	add	di,ax			;destination, point at lr_buf[bx]
	rep	movsb			;move them!
	jmp	addlrx2
;
addlrp: 				;Prefill condition!
	mov	di,lr_count
	mov	dx,[di]
;	mov	di,lr_buf
;	mov	cx,[di] 		;get the count
;	mov	dx,cx			;save the count
;	mov	si,di
;	add	si,2
;	rep	movsb
addlrx2:
	pop	es			;return gen_store to es
	add	ax,dx			;current position
	push	ax
	mov	di,lrwre
	cmp	ax,[di] 		;if lrwre < lrwr then set lrwre to lrwr
					;and set lrcnt to new value
	jbe	addlr5			;jump if lrwre > = lrwr
;					 Set lrwre and lrcnt
	mov	word ptr [di],ax
;	and	dx,dx			;clear carry
	mov	di,lrstop
	mov	dx,[di]
	sub	dx,ax
	mov	di,lrcnt
	mov	[di],dx 		;lrcnt is updated too
addlr5:
;	If bytes were added at lradd then the cursor must be moved to lradd
;	before moving it to the end of the added string
	mov	di,lradd
	mov	dx,[di]
	cmp	dh,0ffh 		;Compare high byte
	jz	addlr6			;jump if 0ffh
	mov	word ptr [di],0ff00h
	mov	bx,dx
	call	movecur
addlr6:
	pop	ax
	mov	di,lrwrp2
	mov	[di],ax
	add	di,2			;point at lrwr
	mov	[di],ax
	ret
addlrz:
	pop	es
	ret
addlr	endp
;
