;
;	***********************************************
;	 This is the main block for the TC package.
;	 In this block is contained all special data areas needed by the system
;	 and all information pertenent to setting up a port as a TC port.
;
;	 EXTERNAL REFERENCES ARE LOCATED IN THE FOLLOWING FILE
;	 SYMBL	   $SYSSYM	       EXTERNAL REFERENCES
tcvar	equ	stop_area
convec	equ	tcvar			;control vector - 29 bytes
dartreg equ	convec + 29		;dart control reg's - 12 bytes
					;Beginning of status vectors
statvec equ	dartreg + 12		;status vector - 8 bytes
sgnbuf	equ	statvec + 8		;RTS/DTR signal buffer
lockstat  equ	sgnbuf + 2		;lock status of RTS/DTR signals

zerostrt  equ	statvec 		;point at which to begin clearing flags

tranbyte  equ	sgnbuf + 3		;translation flags  (2 SAFTEY BYTES ADDED!)
;* translation flag mapping **
RXTRANON EQU	   1			;Rx translation flag (1 = on)
TXTRANON EQU	   2			;Tx translation flag (1 = on)
TXDELAY  EQU	   4			;Tx delay in progress - do not ENTX!
;** end trangslation mapping

lastcom   equ	tranbyte + 1		;current command at TC port
nxtcom	  equ	lastcom + 1		;place to restart command pointer
nxtcomp   equ	nxtcom + 2		;# bytes left to get in current command
txflag	  equ	nxtcomp + 1		;Tx flags
;**  TXFLAG mapping
taround   equ	1			;Turn around line in half duplex mode
;**  end TXFLAG mapping

shiftmsk  equ	txflag + 1		;Mask to preprocess byte for RX translation
;	 first byte of shiftmsk turns off unwanted received bits
;	 second byte sets shift bit in byte

shifttx   equ	shiftmsk + 2		;Current Tx shift status
savetx	  equ	shifttx + 1		;One byte Tx delay
intt_01   equ	savetx + 1		;.01 sec int pointer
intt_1	  equ	intt_01 + 3		;.1 sec int pointer
intt1_0   equ	intt_1 + 3		;1 sec int pointer

fccdev	  equ	intt1_0 + 3		;flow control from connected device flags
cdevp	  equ	1			;1 or 2 byte sequence (1=1 byte ; 0=2 byte)
escrcv	  equ	2			;escape received on a 2 byte escape sequence
fcmxf	  equ	fccdev + 1		;flow control from MXE flags
mxfp	  equ	1			;1 or 2 byte sequence (1=1 byte ; 0=2 byte)
escsnt	  equ	2			;escape sent on a 2 byte sequence
fcmode	  equ	4			;sending flow control bytes mode
fcbyte	  equ	fcmxf + 1		;Xon or Xoff byte to send to connected device
enddata   equ	fcbyte + 1		;end of data area
zeros	  equ	enddata - zerostrt	;# byte to clear for flag clearing
fnlbf	  equ	enddata + 3		;buffer up
tc_size   equ	fnlbf - tcvar		;total control and masking area
;
;	 Masks for commonly used data areas

rxtran	  equ	   lr_buf		;Rx translation table
txtran	  equ	   lr_buf + 256 	;Tx translation table
rxbuf	  equ	   crt_buf		;Rxbuf maps OVER crtbuf
txbuf	  equ	   prt_buf		;Txbuf maps OVER prtbuf
;
;crt_count  equ     statvec+3		 ;Rxbuf count maps into statvec
;prt_count  equ     statvec+6		 ;Txbuf count maps into statvec
;
