;	******************************************
;	This is the main program of TC part of MXF
;	******************************************
;
inittc	proc				;jj
;	*****************************************
;	Routine initializes a port to TC function
;	Exit: Port is converted to TC port
;	*****************************************
;	Check whether this is 1st, or 3rd port since they are the only TC ports.
	mov	di,usermask
	mov	ax,[di]
	and	ax,05h			;1a or 1c, leaves if neither
	jnz	inittc60		;get out off here
	jmp	c062dmz 		;not legal
inittc60:
	mov	di,tc_who
	or	es:[di],al		;mark TC port on tc_port
;	First, set up data area to defaults
;
;	Turn off the interrupt of this port for TC, both Rx, Tx.
	call	distx
;	call	disrx			;sep/6/91
;
;	Clear out control area and lay mask
	cld
	mov	al,0
	mov	cx,tc_size
	mov	di,tcvar
init0:
	stosb
	loop	init0
;	Put out the mask of each data
	push	es
	push	ds
	mov	ax,cs
	mov	ds,ax
	pop	es
	mov	si,offset deftc
	mov	cx,deftcs
	mov	di,tcvar
	rep	movsb			;Send maskings
	push	es
	pop	ds
	pop	es
;
;	Set ready mask of this port
;
	mov	di,rbi
	mov	byte ptr [di],38h	;ready port
	mov	di,rbimask
	mov	byte ptr [di],0ffh
;	set up entry point		;mask off, sep/6/91
;	mov	ax,offset int_1 	;setup .1 second int routine pointer
;	mov	di,clk_1
;	mov	ax,[si]
;	mov	[di],ax 		;same cs, sep/6/91
;	Init devices according to data area
	call	initcont		;Must handle the dart table into new format
;
	call	rxtcs		;@Flags in status vector, for line signals
;	Set up the interrupt register of SCC2698
;	timer of 0.01 second, Oct/1/10
	mov	dx,0cch 	;port 2ef, port 13/14
	mov	al,04h
	out	dx,al
	mov	dx,0ceh
	mov	al,80h		;480h = 1152, is 0.01 second
	out	dx,al
;
	xor	dh,dh
	mov	di,imrport
	mov	dl,[di]
	mov	al,0bbh
	out	dx,al
;
;	Set current DSR signals.
;	Set dsr flag before outputting status vector to 2200.
;	A changed in dsr does not produce an int!!!
;
	mov	si,statvec+1		;point into status vector
	mov	dx,ip_1ab
	mov	di,tc_who		;Note tc_who=1 the port1a, 1c/tc_who=4
	cmp	es:byte ptr [di],1	;Is it port 1a? Note tc_who=1 then 1a,
	jz	init_ps 		;jump if it is
	mov	dx,ip_1cd		;Port 1c!
init_ps:
	in	al,dx
	test	al,04h
	jz	inittc1 		;jump if dsr is active
;	dsr is not set (sense of bit n portstat is inverted)
	and	byte ptr [si],not 04h	;reset dsr flag in status vector
	mov	si,statvec+7		;point to control signals in status vector
	and	byte ptr [si],not 04h
	jmp	inittc2
inittc1:				;rsd is active, set vectors
	or	byte ptr [si],04h
	mov	si,statvec+7		;point to control signals in status vector
	or	byte ptr [si],04h
;
inittc2:	;Set rts before give OS status vectors
	mov	di,dartreg+dr5
	mov	si,statvec+7
	test	byte ptr [di],04h	;get rts status
	jnz	inittc3 		;jump if set
;	reset rts status bit in status vector
	and	byte ptr [si],not 20h	;reset rts flag
	jmp	inittc4
inittc3:
	or	byte ptr [si],20h	;set rts
inittc4:	;Set dtr flag before hand over to OS
	test	byte ptr [di],20h	;get dtr bit
	jnz	inittc5 		;jump if dtr set
;	reset dtr status bit in status vector
	and	byte ptr [si],not 10h	;reset dtr flag
	jmp	inittc6
inittc5:
	or	byte ptr [si],10h	;set dtr
inittc6:
	jmp	c062dm
;	ret
inittc	endp
;
tc06	proc
;	*******************************************
;	Routine accepts commands from user at cbs06
;	*******************************************
	mov	di,gio_now1
	mov	byte ptr [di],0 	;data had been taken
tc06ny:
	mov	si,gio_now2
	or	byte ptr [si],gio_rb	;reset to ready
tc061:
;
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	tc06vf			;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	tc061			       ;not yet
;
	test	al,gio_cbs
	jnz	tc06f			       ;get the data
	test	al,gio_abs
	jnz	tcabsjj 		       ;new start
;	Discard the rest, and polling next input
	jmp	tc06
;
tcabsjj:
	mov	di,gio_data
	mov	al,[di]
	jmp	topabs
;
tc06f:				       ;yes, cbs is ready
	mov	di,gio_data
	mov	al,[di] 		;receive the cbs value
	mov	di,gio_now1
	and	byte ptr [di],g_int	;data had been taken
	mov	si,gio_now2
	or	byte ptr [si],gio_rb	;reset to ready
;
	cmp	al,maxcv	;Limit entry within total entries.
	ja	tc06v1
	xor	ah,ah
	shl	ax,1
	mov	si,ax
	jmp	cs:tab06tc[si]		;TC jump table, address 16
tc06v1:
;	 cmp	 al,0ffh
;	 jnz	 tc06v2
;	 jmp	 selport
;tc06v2:
	cmp	al,80h
	jnz	tc06vf
	jmp	inittc
tc06vf:
	jmp	cretvp
	ret
tc06	endp
;
tc04	proc
;	*******************************************
;	Routine accepts commands from user at cbs04
;	*******************************************
	mov	di,gio_now1
	mov	byte ptr [di],0 	;data had been taken
tc04ny:
	mov	si,gio_now2
	or	byte ptr [si],gio_rb	;reset to ready
tc041:
;
;	%%% testing for disable GIO Dec/16
	mov	si,gio_over
	cmp	byte ptr [si],0ffh	;OS disable?
	jz	tc06vf			;yes, jump out of GIO
;	%%% End %%%
;
;	Routine to check the OS's next input
	mov	di,gio_now1
	mov	al,[di]
	cmp	al,0
	jz	tc041			       ;not yet
;
	test	al,gio_cbs
	jnz	tc04f			       ;get the data
;	test	al,gio_abs
;	jnz	tcabsjo 		       ;new start
;	Discard the rest, and polling next input
;	jmp	tc06
;
;tcabsjo:
	mov	di,lastcom
	mov	al,[di]
	xor	ah,ah
	shl	ax,1
	mov	si,ax
	jmp	cs:tctab04[si]		;TC jump table, address 16
;
tc04f:				       ;yes, cbs is ready
	mov	di,gio_data
	mov	al,[di] 		;receive the cbs value
	mov	di,gio_now1
	and	byte ptr [di],g_int	;data had been taken
	mov	si,gio_now2
	or	byte ptr [si],gio_rb	;reset to ready
;
	cmp	al,maxcv	;Limit entry within total entries.
	ja	tc04v1
	xor	ah,ah
	shl	ax,1
	mov	si,ax
	jmp	cs:tctab04[si]		;TC jump table, address 16
tc04v1:
	cmp	al,80h
	jnz	tc04vf
	jmp	inittc
tc04vf:
	jmp	cretvp
	ret
tc04	endp
;
