;
;	***********************************
;	Interrupt routines for TC functions
;	***********************************
;
yestc	proc
;	*************************************************************
;	Routine handles the interrupt vectors under the TC functions.
;	*************************************************************
	test	al,rxrdya	;bit 1, receiver ready, a channel
	jz	yestc31
	jmp	rxtc
yestc31:
	test	al,txrdya	;bit 0, transmission, a channel ready
	jz	yestc32
	jmp	txtc
yestc32:
	test	al,erra 	;bit 2, error condition, a channel
	jz	yestc33
	jmp	rxtcp
yestc33:
	test	al,pnt1sc	;bit 3, .1 second int comming
	jz	yestc34
;	timer interrupt is coming !
	cmp	bx,24		;Is it from port 13, 14 (block 6)?
	jz	pps1
	cmp	bx,26
	jz	pps1
	jmp	pnt1s		;leave if not
yestc34:
;
;	mov	dx,ip_1ab
;	mov	di,tc_who		;Note tc_who=1 the port1a, 1c/tc_who=4
;	cmp	es:byte ptr [di],1	;Is it port 1a? Note tc_who=1 then 1a,
;	jz	yestc01 		;jump if it is
;	mov	dx,ip_1cd		;Port 1c!
;yestc01:
;	in	al,dx			;interrupt flag
;	and	al,0fh			;low nibble only
;	test	al,01h			;cts?
;	jz	yestc1
;	mov	al,
;yestc1:
;	test	al,02h			;dcd?
;	jz	yestc2
;
;yestc2:
;	test	al,04			;dsr?
;	jz	yestc3
;
;yestc3:				 ;ri
	jmp	intret
yestc	endp
;
pps1:			    ;handle 0.01 second time out in TC mode
;
	jmp	int_01
;
txtc	proc
;	****************************************************************
;	Routine processes TX interrupt service.
;	This code should be handled by the interrupt routine from ports.
;	****************************************************************
	mov	ax,es:dataseg[bx]     ;Point to desired data segment
	mov	ds,ax
;
	mov	di,fcmxf
	test	byte ptr [di],fcmode	;flow control mode?
	jnz	txtc2f			;no, process as usual
	jmp	txtc2
txtc2f:
	test	byte ptr [di],escsnt	;escape byte sent?
	jnz	txtc1			;jump if yes, send flow control byte
;	Send escape byte
	mov	di,convec+24
	mov	ah,[di]
	mov	si,shiftmsk
	and	ah,[si]
;	check dsr status before transmission
	mov	dx,ip_1ab
	mov	di,tc_who		;Note tc_who=1 the port1a, =4/1c
	cmp	es:byte ptr [di],1	;Is it port 1a? Note tc_who=1 then 1a,
	jz	txtc_ys 		;jump if it is
	mov	dx,ip_1cd		;Port 1c!
txtc_ys:
	in	al,dx
	test	al,04h
	jnz	txtcb2			;dsr not ready! jump
;	dsr is low, and readyyy!
	mov	al,ah
	mov	di,rthr
	mov	dl,[di]
	xor	dh,dh
	out	dx,al			;output escape code
	mov	di,fcmxf
	or	byte ptr [di],escsnt
	jmp	cyclone
;
txtc1:					;send flow control byte
	mov	di,fcbyte
	mov	ah,[di]
	mov	dx,ip_1ab
	mov	di,tc_who		;Note tc_who=1 the port1a, =4/1c
	cmp	es:byte ptr [di],1	;Is it port 1a? Note tc_who=0 then 1a,
	jz	txtc_10 		;jump if it is
	mov	dx,ip_1cd		;Port 1c!
txtc_10:
	in	al,dx
	test	al,04h
	jnz	txtcb2			;dsr not ready! jump
	mov	al,ah
	mov	si,rthr
	mov	dl,[si]
	xor	dh,dh
	out	dx,al			;output flow control code
	mov	si,convec+25
	cmp	al,[si] 		;Xon?
	mov	si,statvec+7		;
	jz	txtc1a
	or	byte ptr [si],80h	;set Xoff sent flag
	jmp	txtc1b
txtc1a:
	and	byte ptr [si],7fh	;reset Xoff sent flag
txtc1b:
	mov	di,fcmxf
	and	byte ptr [di],not escsnt	;reset escape sent flag
	and	byte ptr [di],not fcmode	;reset flow control flag
;
	test	byte ptr [si],40h	;test for bit 6 of statvec+7. Xoff?
	jz	txtc1c			;Tx int already enabled
txtcb2:
	call	distx			;Disable Tx until Xon received
txtc1c:
	jmp	cyclone
;	al = byte to output. Go translate and output it.
txtc2:
	mov	di,convec+20
	test	byte ptr [di],04h	;Xon/Xoff from Conn. device?
	jz	txtc2a			;no, want to make sure Tx is not disabled
	mov	si,statvec+7
	test	byte ptr [si],40h	;Xoff from connected device?
	jz	txtc2a			;go if Xon
	call	distx			;do not transmit
	jmp	cyclone
txtc2a:
	mov	si,prt_count
	cmp	byte ptr [si],0
	jz	txtc3
;	DSR status before transmission
	mov	dx,ip_1ab
	mov	di,tc_who		;Note tc_who=1 the port1a, =4/1c
	cmp	es:byte ptr [di],1	;Is it port 1a? Note tc_who=0 then 1a,
	jz	txtc_cs 		;jump if it is
	mov	dx,ip_1cd		;Port 1c!
txtc_cs:
	in	al,dx
	test	al,04h
	jnz	txtcb2			;dsr not ready! jump
	call	trantx			;translate byte
	jz	txtc3			;no byte at all
	mov	si,rthr
	mov	dl,[si]
	xor	dh,dh
	out	dx,al
	jmp	cyclone
txtc3:					;no byte
	call	distx
;					check??? followings
	mov	di,rbi
	or	byte ptr [di],prtrb	;set printer ready to 2200
	mov	di,curnt_sts
	or	byte ptr [di],prtint	;allow int of prt
	mov	si,txflag
	test	byte ptr [si],taround	;check??? turn around flag
	jz	txtc1c			;exit if no turn around wanted
	and	byte ptr [si],not taround	;reset turn around bit
;	Turn line around by enabling reception and dropping RTS if in
;	half duplex need to drop RTS?
	mov	si,convec+1
	test	byte ptr [si],20h	;test for half duplex mode
	jnz	txtc4			;jump if full duplex
;	Drop RTS if not locked
	mov	si,lockstat
	test	byte ptr [si],20h	;RTS lock?
	jnz	txtc4			;yes, don't change it
	mov	si,dartreg+dr5
	and	byte ptr [si],0bfh	;turn off rts on dart table
;	Turn off the RTS !!
	mov	si,crport
	mov	dl,[si]
	xor	dh,dh
	mov	si,crdata
	mov	al,[si]
	and	al,0fh
	or	al,90h
	cli
	out	dx,al			;negate the RTS
	mov	[si],al
	sti				;check?
txtc4:
	mov	di,convec+4		;timeout value
	mov	al,[di] 		;get value in second
	mov	di,statvec+5		;counter
	mov	[di],al 		;set counter to max value
	mov	si,dartreg+dr3
	or	byte ptr [si],10h	;Set RX enabled on dart table
;	Enable reception  (RX)
	mov	di,crdata
	mov	al,[di]
	or	al,01h
	and	al,0fdh
	mov	di,crport
	mov	dl,[di]
	xor	dh,dh
	out	dx,al			;enable RX
	sti
	jmp	cyclone
	ret
txtc	endp
;
rxtc	proc				;@
;	*****************************************************************
;	Routine handles normal receiver interrupt, flow control character
;	are interrupted through here
;	*****************************************************************
;	Note: ds should be already okay
	mov	ax,es:dataseg[bx]     ;Point to desired data segment
	mov	ds,ax
;
	mov	si,rthr 	;The byte should already be inputted
	mov	dl,[si] 	;from the eraly interrupt
	xor	dh,dh
	in	al,dx
	mov	di,shiftmsk
	and	al,[di] 	;strip extra bits
	mov	si,convec+20	;control option byte
	test	byte ptr [si],04h	;Xon/Xoff selected from Conn. device?
	jz	rxtc99		;No, put character in buffer and continue
;	look for flow control byte
	mov	di,fccdev	;get flow control flags
	test	byte ptr [di],cdevp	;1 or 2 byte sequence?
	jnz	rxtc4		;jump if one
	mov	si,convec+21	;look for escape, two byte sequence
	cmp	al,[si] 	;Is the incoming character is escape?
	jnz	rxtc3		;no, jump
;				 Escape received!
	mov	di,fccdev	;flow control
	test	byte ptr [di],escrcv	;Is last character escape?
	jz	rxtc2		;no, go set flag
	and	byte ptr [di],not escrcv	;two escapes in a row
	push	ax		;save the al
	call	putrxtc 	;put 1st escape in buffer
	pop	ax
rxtc99:
	jmp	rxtc9		;also the second escape
rxtc2:
	or	byte ptr [di],escrcv	;1st escape
	jmp	rxtc10
;
;	Received character is not escape code
rxtc3:
	mov	di,fccdev	;Is last Char escape character?
	test	byte ptr [di],escrcv
	jz	rxtc9		;No, so this is a normal data character. jump
;
rxtc4:		;One byte flow control sequence is selected
	mov	di,convec+22	;last is escape, check Xon or Xoff
	cmp	al,[di] 	;Xon?
	jnz	rxtc5		;jump if no, see Xoff
;	Xon character has been received from connected device
	mov	si,statvec+7
	test	byte ptr [si],40h
	jz	rxtc5
	and	byte ptr [si],not 40h	;reset Xoff from device
	call	entx		;enable Tx interrupt
	jmp	rxtc6
rxtc5:
	inc	di		;point to Xoff
	cmp	al,[di] 	;Xoff?
	jnz	rxtc7		;no, must be data character
	mov	si,statvec+7
	test	byte ptr [si],40h	;Xon pending?
	jnz	rxtc6		;multiple Xoff sequence???
	or	byte ptr [si],40h
	call	distx		;disable Tx interrupt
rxtc6:
	mov	si,fccdev	;N/A for 1 byte sequence
	and	byte ptr [si],not escrcv
	jmp	rxtc10
rxtc7:				;point at Xon selection
	mov	si,convec+22	;Xon selection
	cmp	al,[si] 	;if it is Xon, don't store
	jz	rxtc6
	mov	di,fccdev	;Xon, set flag and return
	test	byte ptr [di],cdevp	;1 or 2 sequence?
	jnz	rxtc8		;one, don't send escape char
	dec	si		;point at 21, escape char
	pop	ax
	mov	al,[si]
	call	putrxtc 	;store in buffer
	pop	ax
rxtc8:
	mov	di,fccdev
	and	byte ptr [di],not escrcv	;reset escape rcvd flag
rxtc9:
	call	putrxtc 	;into buffer
;	restart Rx timeout counter
	mov	di,convec+4	;point at counter start value
	mov	al,[di]
	mov	si,statvec+5	;point at counter location
	mov	[si],al
rxtc10:
;	popa
;	pop	ds
;	iret
	jmp	intret
	ret
rxtc	endp
;
rxtcses proc
;	**************************************************************
;	To handle multi-call of rxtcs, this is an entry for Interrupt.
;	**************************************************************
	call	rxtcs
	popa
	pop	ds
	iret			;get out of interrupt vector
rxtcses endp
;
rxtcs	proc				;jj
;	***************************************
;	Routine handles the status of interrupt
;	Beware of characteristics of 2698's
;	***************************************
	mov	si,srport
	xor	dh,dh
	mov	dl,[si]
;
	in	al,dx			;get the status byte
	mov	ah,al			;save it
;					;According to SR register
	test	al,80h			;test for break interrupt
	jz	rxtcs2			;jump if no break
;	Break set , check is this the beginning or end of break
	push	ax
	mov	di,convec+9
	mov	al,[di] 		;get timeout value in millisecond
	cmp	al,0
	jz	rxtcs1
	mov	di,offset testbrk	;routine to be run after timeout
	call	time_01
rxtcs1:
	pop	ax
;
rxtcs2: 	;check the DCD next!
	mov	dx,ip_1ab
	mov	di,tc_who		;Note tc_who=1 the port1a, =4/1c
	cmp	es:byte ptr [di],1	;Is it port 1a? Note tc_who=0 then 1a,
	jz	rxtcs5s 		;jump if it is
	mov	dx,ip_1cd		;Port 1c!
rxtcs5s:
	in	al,dx
;
;	mov	al,ah
	mov	si,statvec+1
	test	al,02h			;DCD?
	jz	rxtcs3			;jump if set, similarly, 0=on, 1=off
;	reset DCD, its signal = 1, off
	and	byte ptr [si],not 01h	;reset
	mov	di,statvec+7		;control signals
	and	byte ptr [di],not 01h	;reset
	jmp	rxtcs4			;check RI next
rxtcs3:
	or	byte ptr [si],01h	;set
	mov	di,statvec+7		;control signals
	or	byte ptr [di],01h	;set
rxtcs4: 	;RI is the next
;	mov	al,ah			;restore
	test	al,08h			;RI?
	jz	rxtcs5			;jump if on
	and	byte ptr [di],not 02h	;reset RI
	jmp	rxtcs6
rxtcs5:
	or	byte ptr [di],02h	;set RI
rxtcs6:
;	Look at CTS signal first
	mov	si,statvec+7		;point at control signals
	test	al,01h
	jz	rxtcs7			;cts=1/off, cts=0/on (active)
;	CTS is off! reset the flag
	and	byte ptr [si],not 08h
	mov	di,convec+20		;flow control
	test	byte ptr [di],04h	;Xon/Xoff selected?
	jnz	rxtcs8			;exit if so
	test	byte ptr [di],01h	;CTS/DCD selected?
	jz	rxtcs8			;exit if no
	or	byte ptr [si],40h	;Xoff condition
	jmp	rxtcs8
;	set CTS status bit in status byte
rxtcs7:
	or	byte ptr [si],08h	;set CTS
	mov	di,convec+20		;flow control
	test	byte ptr [di],04h	;Xon/Xoff selected?
	jnz	rxtcs8			;exit if so
	test	byte ptr [di],01h	;CTS/DCD selected?
	jz	rxtcs8			;exit if no
	and	byte ptr [si],not 40h	;Xoff condition
rxtcs8:
	ret
rxtcs	endp
;
rxtcp	proc
;	************************************************************************
;	Handle error here, MXF will go through this routine every time RX occurs
;	************************************************************************
	mov	ax,es:dataseg[bx]     ;Point to desired data segment
	mov	ds,ax
;
	mov	di,srport
	mov	dl,[di]
	xor	dh,dh
	in	al,dx		;get the status
	mov	di,statvec+2
	test	al,20h		;test for parity error
	jz	rxtcp2
;				 parity error occurs!
	or	byte ptr [di],01
rxtcp2:
	test	al,10h		;test for overrun error
	jz	rxtcp3
	or	byte ptr [di],02	;overrun occurs
rxtcp3:
	test	al,40h		;test for framing error
	jz	rxtcp4		;jmp if not
	or	byte ptr [di],04	;framing occurs
rxtcp4:
	test	al,70h		;Is error happened?
	jz	rxtcpz		;leave if not
	mov	di,rthr 	;read in the char and discard it
	mov	dl,[di]
	in	al,dx
	mov	di,convec+3
	mov	al,[di] 	;get the replaced char
	call	putrxtc
rxtcpz:
	jmp	intret
rxtcp	endp
;
int_01	proc
;	****************************************
;	This is the .01 second interrupt handler
;	****************************************
	mov	bx,0
	call	int_01p
	mov	bx,4
	call	int_01p
	jmp	intret			;timer service routine over
;
int_01p:
	mov	ax,es:dataseg[bx]     ;Point to desired data segment
	mov	ds,ax
;
	mov	di,flag2
	test	byte ptr [di],specpack
	jz	int_01e 		;leave if not TC
	mov	di,intt_01
	cmp	byte ptr [di],0 	;timer counter=0?
	jz	int_01e
	dec	byte ptr [di]		;decrement counter
	jnz	int_01e 		;leave if not finished
;	counter becomes zero, call service routine
	mov	si,timestrt
	call	[si]
int_01e:
	ret
;	jmp	intret			;timer service routine over
int_01	endp
;
;int_1	 proc		!! Moved to mxfrint.asm already !!
;	**********************************************************************
;	Routine is called every 0.1 second to decrease the Rx timeout counters
;	for the TC ports. 'porttype' is used to point at all TC ports so that
;	no damage will be done to the terminal port.
;	**********************************************************************
;	 push	 ds
;	 mov	 ax,es:dataseg[0]
;	 mov	 ds,ax
;	 mov	 di,statvec+5
;	 test	 byte ptr es:porttype,01h
;	 jz	 int_11 		 ;1a is not used as TC port presently
;	 dec	 byte ptr [di]
;
;int_11:
;	 mov	 ax,es:dataseg[4]
;	 mov	 ds,ax
;	 test	 byte ptr es:porttype,02h	 ;jmp if not set as TC
;	 jz	 int_12
;	 dec	 byte ptr [di]
;int_12:
;	 pop	 ds
;	 ret
;int_1	 endp
;
