;
;	***********************************
;	Tables and Defaults for TC programs
;	***********************************
deftc		equ	$
defconv 	equ	$
	db	1fh		;1 stop, 9600 baud
	db	20h		;full duplex, break disabled
	db	33h		;8 bits, odd parity
	db	'*'             ;error character
	db	0		;no timeout interval
	db	0		;disable record detection
	db	14 dup (0)	;null control byte, 7th - 20th
	db	01		;null, CTS/DCD from connected device
	db	8  dup (0)	;null
;
	org	[dartreg - tcvar] + deftc
;
defdart equ	$
	db	18h		;clear out dart
p4	db	14h		;point at necessary registers for above
dr4	equ	$ - defdart
;	db	45h		;X16, odd, 1 stop
	db	17h		;in my own maskings
;
p3	db	13h		;register for RX
dr3	equ	$ - defdart	;
;	db	60h		;for RX, 7 bits, auto enable, rx disabled
	db	22h
;
p5	db	15h		;register for TX
dr5	equ	$ - defdart
;	db	0a8h		;for TX, 7 bits, not RTS, DTR, tx enabled
	db	32h		;and break/off
;
p1	db	01h		;register
dr1	equ	$ - defdart
;				;???
	db	0d5h		;w/r, int rx, extstat, txdis, stat effect vector
deftcend	equ	$
deftcs		equ	$ - deftc
;
;bustabtc	 equ	 $
;	OS/386 bus service table
;	 dw	 diager 	 ;0 - error
;	 dw	 start_p	 ;1 - restart bootstrap
;	 dw	 sel02		 ;2 - MXF status request
;	 dw	 diager 	 ;3 - error
;	 dw	 tc04		 ;4 - TC control and ID address
;	 dw	 start_p	 ;5 - restart bootstrap
;	 dw	 tc06		 ;6 - MXF control address
;	 dw	 diager 	 ;7 - error
;
;tctab04 equ	 $
tc04max equ	10h
;	address 4 service table
;	NOTE: LASTCOM is loaded with a restart pointer if the command can be
;	broken into parts by the 2200 breakpointing.  The restart pointer
;	will be the original index with the 10 bit on.	This table is therefor
;	broken into to halves: The fisrt half is the 2200 index and the second
;	is the restart index.  The 2200 index may not exceed the halfway point
;	in the table.
;	LASTCOM is zero if the last command cannot be restarted.
tctab04 dw	diager		;0 - nop
	dw	diager		;1 - nop
	dw	setcomm 	;2 - set communications vector,jj
	dw	rdstat		;3 - read status vector
	dw	ldtxtab 	;4 - load Tx translation table
	dw	ldrxtab 	;5 - load Rx translation table
	dw	discon		;6 - disconnect port
	dw	txbreak 	;7 - send break
	dw	rxon		;8 - enable Rx
	dw	input		;9 - give data to 2200 from Rx
	dw	output		;A - get data from 2200 for Tx
	dw	outputh 	;B - output then input (half duplex)
	dw	stoptx		;C - stop Tx (full duplex)
	dw	starttx 	;D - continue Tx (full duplex)
	dw	prtpage 	;E - DEBUG COMMAND!!
	dw	stsign		;F - set RTS/DTR control signals
;	restart addresses
	dw	diager		;10 - nop
	dw	diager		;11 - nop
	dw	setcomm1	;12 - restart set communications vector
	dw	rdstat1 	;13 - restart read status vector
	dw	ldtxtab1	;14 - restart load Tx translation table
	dw	ldrxtab1	;15 - restart load Rx translation table
	dw	diager		;16 - nop
	dw	diager		;17 - nop
	dw	diager		;18 - nop
	dw	input1		;19 - restart give data to 2200 from Rx
	dw	output1 	;1A - restart get data from 2200 for Tx
	dw	output1 	;1B - restart output then input (half duplex)
	dw	diager		;1C - nop
	dw	diager		;1D - nop
	dw	prtpage1	;1E - DEBUG COMMAND
	dw	stsign1 	;1F - restart set RTS/DTR control signals
;
;tctab04c	 equ	 $
tc04difc	equ	10h	;offset for this table
;
;	This table points at the termination blocks for those commands
;	which require a termination.
tctab04c  dw	  cret		  ;10 - nop
	dw	cret		;11 - nop
	dw	setcommc	;12 - restart set communications vector
	dw	rdstatc 	;13 - restart read status vector
	dw	ldtxtabc	;14 - restart load Tx translation table
	dw	ldrxtabc	;15 - restart load Rx translation table
	dw	cret		;16 - nop
	dw	cret		;17 - nop
	dw	cret		;18 - nop
	dw	inputc		;19 - restart give data to 2200 from Rx
	dw	outputc 	;1A - restart get data from 2200 for Tx
	dw	outputhc	;1B - restart output then input (half duplex)
	dw	cret		;1C - nop
	dw	cret		;1D - nop
	dw	main_lop	;1E - illegal
	dw	stsignc 	;1F - restart set RTS/DTR control signals
;
;tab06tc	 equ	 $
tab06off	equ	00h	;offset to subtract from index
tab06max	equ	2fh	;Highest entry + 1
;
tab06tc dw	diager		;00 - nop code
	dw	diager		;01 - restart bootstrap
	dw	diager		;02 - command error
	dw	diager		;03 - command error
	dw	diager		;04 - command error
	dw	diager		;05 - command error
	dw	diager		;06 - command error
	dw	diager		;07 - command error
	dw	diager		;08 - command error
	dw	diager		;09 - command error
	dw	diager		;0A - command error
	dw	diager		;0B - command error
	dw	diager		;0C - command error
	dw	diager		;0D - command error
	dw	diager		;0E - request prt
	dw	diager		;0F - command error
	dw	diager		;10 - command error
	dw	diager		;11 - self ID code
	dw	diager		;12 - ticks from clock
	dw	diager		;13 - download command
;	dw	statid		;11 - self ID code
;	dw	clock		;12 - ticks from clock
;	dw	dwnld		;13 - download command
	dw	diager		;14 - start executing RAM code - ignored in Ram
	dw	diager		;15 - command error
	dw	diager		;16 - command error
	dw	diager		;17 - command error
	dw	diager		;18 - command error
	dw	diager		;19 - command error
	dw	diager		;1a - command error
	dw	diager		;1b - command error
	dw	diager		;1c - command error
	dw	diager		;1d - command error
	dw	diager		;1e - command error
	dw	diager		;1f - command error
;
;	 Commands supported only by the MXE and MXF
;
	dw	c0620		;20 - $MXE command string
	dw	c0621		;21 - $MXE return code
	dw	diager		;22 - command error
	dw	diager		;23 - command error
	dw	diager		;24 - command error
	dw	diager		;25 - command error
	dw	diager		;26 - command error
	dw	diager		;27 - command error
	dw	cret		;28 - output terminal data
	dw	diager		;29 - command error
	dw	diager		;2a - command error
	dw	diager		;2b - command error
	dw	diager		;2c - command error
	dw	c062d		;2D - select special package
	dw	c062e		;2E - set MXE PSW
;
;
