;
;******************************************************************************
;	Equation table for the offset of each data block (structure)
;	and the some mask values.
;******************************************************************************
;
;	*******  Start of Constants or masks  ********
;
	memsize   equ	03ffh
;
	commax	equ	60
	comt_max equ	60
	rsdmax	equ	150
;	keymax	equ	256
;	keybmax equ	256-6	;For flexibility
	prtmax	equ	0ffh
	crtmax	equ	0ffh
;
	cmd_bit equ	10b
				;sts_byte: status byte bit definition
	key_buf_sts equ 01b	;0 is empty, 1 is non empty
	rsd_ready   equ 10b	;0 is non ready, 1 is ready
	rsd_req     equ 100b
	rsd_cncl    equ 1000b
;
;	Reference byte TXBYTE
;******** Bit-map for txbyte ****
	crtbit	  equ	1h	;0 = crt ubffer empty
	prtbit	  equ	2h	;0 = prt buffer empty
	lastbit   equ	4h	;0 = Currently outputting from crtbuf
	switchb   equ	8h	;Currently switching buffer
	keybit	  equ	10h	;0 = Key buffer empty
	crtstopb  equ	20h	;Terminal crtbuf full
	prtstopb  equ	40h	;Terminal prtbuf full
	rsdreqb   equ	80h	;RSD request issued to Cs386
	crtprtof  equ	0fch	;x'11111100'; crt & prt bit off
;** end of mapping txbyte **
;
;*****	gio_now1 Mapping  *****
	gio_abs 	equ	01h
	gio_cbs 	equ	02h
	gio_obs 	equ	04h
	gio_ibs 	equ	08h
	g_dis		equ	10h
	g_int		equ	20h
;*****	End Mappings of gio_now1  *****
;
;*****	gio_now2 Mapping  *****
	gio_cpb 	equ	02h	;0/ready, 1/busy
	gio_ib9 	equ	04h
	gio_rb		equ	08h	;1/ready, 0/busy
;*****	End Mappings of gio_now2  *****
;
;*****	DSRBYTE mapping *****
	CURDSR	 EQU	1b	;current port state (1 = connected)
	CONB	 EQU	10b	;connection system status (1 = endabled)
	DISCONB  EQU	100b	;disconnection system status
	TIMEOUTB EQU	1000b	;timeout in progress
	DISCIMMB EQU	10000b	;disconnect on connection flag
	RSDB	 EQU	100000b ;RSD in progress (don't update CRT)
	dtb	 equ	1000000b  ;byte output from dtbuf
;***** End of Mapping *****
;
;***** Mapping of term_stat *****
	pstatpt  equ	01h	;print buffer empty
	pstatcot equ	02h	;Co buffer empty
	pstatlr  equ	04h	;Line Request complete
;
;***** Mapping tmrbyte ******
	p1secb	equ	01h
	onesecb equ	02h
;****************************
;
;******* mapping for lockk ******
	baudlock  equ	01h
;*******************************
	entxb	equ	04h
	distxb	equ	08h
;*******************************
;***** Mapping for lrbyte ***** check?
	lrbit  equ	01h
	lrendbit  equ	02h
	editbit equ	04h
	inbit	equ	08h
	lrprtbit  equ	10h
	rsdgob	equ	20h
	dtdelay equ	40h
	underbit  equ	80h
				;lrbyte bit definition
	lron	equ	01h	;LR in progress
	notlr	equ	0feh
	editon	equ	04h
	prtlr	equ	10h
	dton	equ	40h
	underon equ	80h
	clockint equ  01h	;Clock service bit on
	clock_1i equ  02h	; .1 second int flag
;
;	*** Mapping for lrinit ***
	flushbit  equ	01h	;flush keybuf before LR
	fillbit   equ	02h	;0 = prefill, 1 = refill
;	Note that editbit defined as lrbyte above
;
;**** Mapping for rsdbyte ****
	rsdendb equ	01h	;end of rsd received
	comb	equ	02h	;esccode received from terminal
	rsdabrtb  equ	04h	;end of rsd command received
	rsdwaitb  equ	08h	;current state of term (wait/go)
;*** End mapping rsd ***
;
;****** Mapping for rsdcomp (also used in crtcomp, prtcomp) *******
	escbit	equ	01h
	compbit equ	02h
	fbbit	equ	04h
	decompb equ	08h
	lastrsd equ	10h
;****** End Mapping ******
;
;*** Mapping for rbi ***	check?
	statrb	equ	02h	;status r/b
	rsdrb	equ	04h	;rsd r/b
	prtrb	equ	08h	;printer r/b
;	contrb	equ	20h	;control address? check?
	crtrb	equ	40h	;crt r/b
;*** End mapping for rbi *** The remaining bits are not used !
;
;	----------- Testing for window -----------
	wndw	equ	01h	;1 = window is processing, 0 otherwise
	wrtrd	equ	02h	;1 = windowing and read status,
				;0 = windowing and write status
	stopbit equ	04h	;1 = MXF issued fb + db to stop terminal
				;0 = MXF did not do it
	cntncmd equ	08h	;0 = First issue of window command
				;1 = continuing page of window command
	in_prcs equ	10h	;1 = window command is processing, skip 0fh
				;0 = command is done
	midpage equ	0ffh	;return code for windowing protocol
	fnlpage equ	0feh	;between MXF and OS
;	----------- For the windw ----------------
;
;*** Mapping for flag1 ***
	rst	equ	10h	;reset received flag
	fdbit	equ	20h	;specified that 'fd'h had been received
	fcbit	equ	40h	;specified that 'fc'h had been received
	deadbit equ	80h	;deadkey received
	fdfcmask equ	60h	;Mask off all but fd & fc bits.
;*** End mapping, 2-4 bits unused ***
;
;*** Mapping for flag2 ***
	specpack equ	01h	;Special package in use (originally in termbyte)
	procbit equ	04h	;'processing command' flag
	modebit equ	08h	;1 = command mode, 0 = normal
	ynbit	equ	10h	;command waiting for an answer
	dwnldbit equ	20h	;download mode (counting incoming 0h, assume dwnld)
	tabb	equ	40h	;print flag, for MXE? check?
;*** Mapping for flag2,where 2,8 bits unused ***
	modebyte equ	0a1h	;command mode byte
	mdbytep  equ	03h	;# times mode bytes must be received
				;to initiate command mode
;
;*** Mapping for termstat ***
	prtint	equ	01h	;prtbuf empty
	crtint	equ	02h	;crtbuf empty
	keyint	equ	04h	;byte in key buf
	lrint	equ	keyint	;line request complete
	rsdint	equ	08h	;rsd request
	windint equ	10h	;window command is done
;*** End mapping ***
;
;*	 After the Termstat byte is sent, a second byte is sent IF the 80 bit
;*	 was set in Termstat.  This byte is a one byte command to the 2200.
;*	 The following commands are allowed:
REQRSD	 EQU	   01			;terminal requests RSD
CANRSD	 EQU	   02			;terminal cancels RSD request
;**  End of possible commands
;
;*** Mapping for outblock ***
	lrblock 	equ	01h	;LR blocks the crt output
	disblock	equ	02h	;terminal is disconnected
	mxfblock	equ	04h	;mxe command blocks the crt output
;*** End of Mapping ***
;
	comtabp 	equ	0ch	;Number of commands in table
;
;* translation flag mapping **
rxtranon equ	01h			;Rx translation flag (1 = on)
txtranon equ	02h			;Tx translation flag (1 = on)
txdelay  equ	04h			;Tx delay in progress - do not ENTX!
;* end trangslation mapping
;
;*  TXFLAG mapping
taround  equ	01h			;Turn around line in half duplex mode
;*  end TXFLAG mapping
;
;	****************************
;	The registers for the UARTs
;	****************************
;
;-------------------   BAUD SETTING PORT   -------------------------
BAUD1AB  EQU	   0180H		    ; channel 1A & 1B, A8=A7=1, A3 - A1= '000 - 111'
BAUD1CD  EQU	   0182H		    ; channel 1C & 1D
BAUD1EF  EQU	   0184H		    ; channel 1E & 1F
BAUD1GH  EQU	   0186H		    ; channel 1G & 1H
BAUD2AB  EQU	   0188H		    ; channel 2A & 2B
BAUD2CD  EQU	   018AH		    ; channel 2C & 2D
BAUD2EF  EQU	   018CH		    ; channel 2E & 2F
BAUD2GH  EQU	   018EH		    ; channel 2G & 2H
;
MR_1A	  EQU	 0H			     ;mode register to set TX/RX format
					     ;two mode registers share one port
SR_1A	  EQU	 2H			     ;Status register
CSR_1A	  EQU	 2H			     ;RXC/TXC source selection
CR_1A	  EQU	 4H			     ;command register
RHR_1A	  EQU	 6H			     ;receiver holding register
THR_1A	  EQU	 6H			     ;transmitter holding register
IPCR_1AB  EQU	 8H			     ;input port change register
ACR_1AB   EQU	 8H			     ;auxilliary control register
					     ;select baudrate set,C/T mode &
					     ;source, MPI cause int?
ISR_1AB   EQU	 0AH			     ;interrupt status register
					     ;check interrupt source
IMR_1AB   EQU	 0AH			     ;interrupt mask register, out only
CTU_1AB   EQU	 0CH			     ;C/T upper byte
CTUR_1AB  EQU	 0CH			     ;C/T upper register
CTL_1AB   EQU	 0EH			     ;C/T lower register
CTLR_1AB  EQU	 0EH			     ;C/T lower register

MR_1B	  EQU	 10H
SR_1B	  EQU	 12H
CSR_1B	  EQU	 12H
CR_1B	  EQU	 14H
RHR_1B	  EQU	 16H
THR_1B	  EQU	 16H
IP_1AB	  EQU	 1AH
OPCR_1AB  EQU	 1AH			     ;O/P port configuration register
START_1AB EQU	 1CH			     ;I/P to start C/T
STOP_1AB  EQU	 1EH			     ;I/P to stop C/T

MR_1C	  EQU	 20H
SR_1C	  EQU	 22H
CSR_1C	  EQU	 22H
CR_1C	  EQU	 24H
RHR_1C	  EQU	 26H
THR_1C	  EQU	 26H
IPCR_1CD  EQU	 28H
ACR_1CD   EQU	 28H
ISR_1CD   EQU	 2AH
IMR_1CD   EQU	 2AH
CTU_1CD   EQU	 2CH			     ;I/P
CTUR_1CD  EQU	 2CH			     ;O/P
CTL_1CD   EQU	 2EH
CTLR_1CD  EQU	 2EH

MR_1D	  EQU	 30H
MR_1D	  EQU	 30H
SR_1D	  EQU	 32H
CSR_1D	  EQU	 32H
CR_1D	  EQU	 34H
RHR_1D	  EQU	 36H
THR_1D	  EQU	 36H
IP_1CD	  EQU	 3AH			     ;I/P port
OPCR_1CD  EQU	 3AH			     ;O/P port configuration register
START_1CD EQU	 3CH			     ;read to start C/T
STOP_1CD  EQU	 3EH			     ;read to stop C/T

MR_1E	  EQU	 40H
SR_1E	  EQU	 42H
CSR_1E	  EQU	 42H
CR_1E	  EQU	 44H			     ;UART green led port
RHR_1E	  EQU	 46H
THR_1E	  EQU	 46H
IPCR_1EF  EQU	 48H			     ;I/P
ACR_1EF   EQU	 48H			     ;O/P
ISR_1EF   EQU	 4AH
IMR_1EF   EQU	 4AH
CTU_1EF   EQU	 4CH
CTUR_1EF  EQU	 4CH
CTL_1EF   EQU	 4EH
CTLR_1EF  EQU	 4EH

MR_1F	  EQU	 50H
SR_1F	  EQU	 52H
CSR_1F	  EQU	 52H
CR_1F	  EQU	 54H			     ;UART red led port
RHR_1F	  EQU	 56H
THR_1F	  EQU	 56H
IP_1EF	  EQU	 5AH			     ;I/P port
OPCR_1EF  EQU	 5AH			     ;O/P port configuration register
START_1EF EQU	 5CH			     ;read to start C/T
STOP_1EF  EQU	 5EH			     ;read to stop C/T

MR_1G	  EQU	 60H
SR_1G	  EQU	 62H
CSR_1G	  EQU	 62H
CR_1G	  EQU	 64H
RHR_1G	  EQU	 66H
THR_1G	  EQU	 66H
IPCR_1GH  EQU	 68H			     ;I/P
ACR_1GH   EQU	 68H			     ;O/P
ISR_1GH   EQU	 6AH
IMR_1GH   EQU	 6AH
CTU_1GH   EQU	 6CH
CTUR_1GH  EQU	 6CH
CTL_1GH   EQU	 6EH
CTLR_1GH  EQU	 6EH

MR_1H	  EQU	 70H
SR_1H	  EQU	 72H
CSR_1H	  EQU	 72H
CR_1H	  EQU	 74H
RHR_1H	  EQU	 76H
THR_1H	  EQU	 76H
IP_1GH	  EQU	 7AH			     ;I/P port
OPCR_1GH  EQU	 7AH			     ;O/P port configuration register
START_1GH EQU	 7CH			     ;read to start C/T
STOP_1GH  EQU	 7EH			     ;read to stop C/T

MR_2A	  EQU	 80H			     ;mode register to set TX/RX format
					     ;two mode registers share one port
SR_2A	  EQU	 82H			     ;status register
CSR_2A	  EQU	 82H			     ;RXC/TXC source selection
CR_2A	  EQU	 84H			     ;command register
RHR_2A	  EQU	 86H			     ;receiver holding register
THR_2A	  EQU	 86H			     ;transmitter holding register
IPCR_2AB  EQU	 88H			     ;input port change register
ACR_2AB   EQU	 88H			     ;auxilliary control register
					     ;select baudrate set,C/T mode &
					     ;source, MPI cause int?
ISR_2AB   EQU	 8AH			     ;interrupt status register
					     ;check interrupt source
IMR_2AB   EQU	 8AH			     ;interrupt mask register, out only
CTU_2AB   EQU	 8CH			     ;C/T upper byte
CTUR_2AB  EQU	 8CH			     ;C/T upper register
CTL_2AB   EQU	 8EH			     ;C/T lower register
CTLR_2AB  EQU	 8EH			     ;C/T lower register

MR_2B	  EQU	 90H
SR_2B	  EQU	 92H
CSR_2B	  EQU	 92H
CR_2B	  EQU	 94H
RHR_2B	  EQU	 96H
THR_2B	  EQU	 96H
IP_2AB	  EQU	 9AH
OPCR_2AB  EQU	 9AH			     ;O/P port configuration register
START_2AB EQU	 9CH			     ;I/P to start C/T
STOP_2AB  EQU	 9EH			     ;I/P to stop C/T

MR_2C	  EQU	 0A0H
SR_2C	  EQU	 0A2H
CSR_2C	  EQU	 0A2H
CR_2C	  EQU	 0A4H
RHR_2C	  EQU	 0A6H
THR_2C	  EQU	 0A6H
IPCR_2CD  EQU	 0A8H
ACR_2CD   EQU	 0A8H
ISR_2CD   EQU	 0AAH
IMR_2CD   EQU	 0AAH
CTU_2CD   EQU	 0ACH			      ;I/P
CTUR_2CD  EQU	 0ACH			      ;O/P
CTL_2CD   EQU	 0AEH
CTLR_2CD  EQU	 0AEH

MR_2D	  EQU	 0B0H
MR_2D	  EQU	 0B0H
SR_2D	  EQU	 0B2H
CSR_2D	  EQU	 0B2H
CR_2D	  EQU	 0B4H
RHR_2D	  EQU	 0B6H
THR_2D	  EQU	 0B6H
IP_2CD	  EQU	 0BAH			      ;I/P port
OPCR_2CD  EQU	 0BAH			      ;O/P port configuration register
START_2CD EQU	 0BCH			      ;read to start C/T
STOP_2CD  EQU	 0BEH			      ;read to stop C/T

MR_2E	  EQU	0C0H
SR_2E	  EQU	0C2H
CSR_2E	  EQU	0C2H
CR_2E	  EQU	0C4H
RHR_2E	  EQU	0C6H
THR_2E	  EQU	0C6H
IPCR_2EF  EQU	0C8H			     ;I/P
ACR_2EF   EQU	0C8H			     ;O/P
ISR_2EF   EQU	0CAH
IMR_2EF   EQU	0CAH
CTU_2EF   EQU	0CCH
CTUR_2EF  EQU	0CCH
CTL_2EF   EQU	0CEH
CTLR_2EF  EQU	0CEH

MR_2F	  EQU	0D0H
SR_2F	  EQU	0D2H
CSR_2F	  EQU	0D2H
CR_2F	  EQU	0D4H
RHR_2F	  EQU	0D6H
THR_2F	  EQU	0D6H
IP_2EF	  EQU	0DAH			     ;I/P port
OPCR_2EF  EQU	0DAH			     ;O/P port configuration register
START_2EF EQU	0DCH			     ;read to start C/T
STOP_2EF  EQU	0DEH			     ;read to stop C/T

MR_2G	  EQU	0E0H
SR_2G	  EQU	0E2H
CSR_2G	  EQU	0E2H
CR_2G	  EQU	0E4H
RHR_2G	  EQU	0E6H
THR_2G	  EQU	0E6H
IPCR_2GH  EQU	0E8H			     ;I/P
ACR_2GH   EQU	0E8H			     ;O/P
ISR_2GH   EQU	0EAH
IMR_2GH   EQU	0EAH
CTU_2GH   EQU	0ECH
CTUR_2GH  EQU	0ECH
CTL_2GH   EQU	0EEH
CTLR_2GH  EQU	0EEH

MR_2H	  EQU	0F0H
SR_2H	  EQU	0F2H
CSR_2H	  EQU	0F2H
CR_2H	  EQU	0F4H
RHR_2H	  EQU	0F6H
THR_2H	  EQU	0F6H
IP_2GH	  EQU	0FAH			     ;I/P port
OPCR_2GH  EQU	0FAH			     ;O/P port configuration register
START_2GH EQU	0FCH			     ;read to start C/T
STOP_2GH  EQU	0FEH			     ;read to stop C/T
;
;	End of registers mapping of UARTs
;	*********************************
;
;	Mapping for isr(interrupt status reg) from UART
	txrdya	equ	01h
	rxrdya	equ	02h
	erra	equ	04h
	pnt1sc	equ	08h
	txrdyb	equ	10h
	rxrdyb	equ	20h
	errb	equ	40h
;
;***********************************************
;	Misc Constants - From MXF to terminal
;
	nopz		equ	00h	;null
	home		equ	01h	;home cursor
	clearsc 	equ	03h	;clear screen and home cursor
	curson		equ	05h	;cursor on
	cursoff 	equ	06h	;cursor off
	beep		equ	07h	;bell
	rarrow		equ	09h	;right arrow
	larrow		equ	08h	;left arrow
	dwnarrow	equ	0ah	;down arrow
	linefeed	equ	0ah	;line feed
	uparrow 	equ	0ch	;up arrow
	return		equ	0dh
	reset		equ	12h
	blank		equ	20h	;blank space
	undrscr 	equ	0a0h	;under score
	rsdstart	equ	0d3h	;init rsd (in rsd mode only)
	rsdend		equ	0d4h	;abort rsd (in rsd mode only)
	rsdgo		equ	0d8h	;rsd go code (in rsd mode only)
	rsdstop 	equ	0dah	;rsd stop code (in rsd mode only)

CRTCODE  EQU	   0F0h 		;switch to crt command (to terminal)
PRTCODE  EQU	   0F1h 		;switch to prt command (te terminal)
TERMRST  EQU	   0F2h
RQRSD	 EQU	   0F3h 		;RSD request code
LA4	 EQU	   0F4h
LA5	 EQU	   0F5h
CRTRST	 EQU	   0F6h 		;reset crt
LA7	 EQU	   0F7h
LA8	 EQU	   0F8h
LA9	 EQU	   0F9h
LAA	 EQU	   0FAh
LAB	 EQU	   0FBh
;
	key_size  equ	60h
	esccode equ	0fbh	 ;code for escape key
	trans	equ	0fch	 ;Transparency code/Foreign Chars'
	endiatom  equ	0fdh	 ;ENDI/ATOM
	deadkey1  equ	0feh	 ;Deadkey, receive from keyboard
	deadkey2  equ	0ffh	 ;Deadkey, send during keyin
;
	crtstop equ	0fah
	prtstop equ	0fbh
	crtgo	equ	0f8h
	prtgo	equ	0f9h

;	Codes from terminal to MXF *!!* during RSD and DT *!!*
	rsdesc		equ	0f1h	 ;rsd command escape byte
	rsddesc 	equ	0ech	 ;rsd compression escape code
	startrsd	equ	0f2h	 ;start of rsd data
	stoprsd 	equ	0f4h	 ;end of rsd data
;	Masc. Value
	linelen 	equ	50h	;Byte length of screen per line
	ascconv 	equ	30h	;convert to ascii
;
;
;	*****************************************
;	Data structure for the commom memory area
;	*****************************************
;
;	reset_byte	equ	0
	head_rom	equ	0
	reset_byte	equ	head_rom + 4
	connect_byte	equ	reset_byte + 2
	halt_step_byte	equ	connect_byte + 2
	disconnect_byte equ	halt_step_byte + 2
;	******** End of status bytes ************
;
			;interrupt command buffer
prt_no		equ	disconnect_byte + 2
sts		equ	prt_no + 1
absz		equ	sts + 1
cbs		equ	absz + 1
parms		equ	cbs + 1
;
	comorg	equ  parms + 10    ;origin of current mxf command
	comerr	equ  comorg + 2    ;command error code
	comerr2 equ  comerr + 1    ; = 0 mean 2200, <> 0 mean port command
				   ;int_even: interrupt event bit definition
	dataseg equ  comerr2 + 1   ;Every two bytes conclude a data segment,
				   ;So, there are 16 data segs for 16 ports.
;	segindx equ  dataseg + 32  ;Index for each segment of each port
	rxbyte	 equ  dataseg + 32 ;bit0/port0,bit1/port1,...,bit15/port15
	rxbyte0  equ  rxbyte + 2   ;bit0/clock ,bit1 /0.1 sec. int flag
;	rxbyte1  equ  rxbyte0 + 2  ;for clock 1 second
	tmrbyte  equ  rxbyte0 + 1
	p1cnt	 equ  tmrbyte + 1
;
	commode  equ  p1cnt + 1        ;service request mode, for $MXE commands
				       ;bit0/port0,...bit15/port15
	commode0 equ  commode + 2      ;service request mode, for LR mode
				       ;bit0/port0,bit1/port1,...,bit15/port15
	fairmask equ  commode0 + 2     ;mask off bits in rxbyte for round robin.
	rbibus	 equ  fairmask + 2
	scratch1   equ rbibus + 2      ;variable for short term usage
	scratch6   equ scratch1 + 2    ;Same as above
	scratch7   equ scratch6 + 2
	porttype   equ scratch7 + 2    ;1a, 1c support TC, others not
	tc_reg	   equ porttype + 1
	tc_who	   equ tc_reg + 1      ;1 = port 1a, otherwise 1c = 2
	try_dtr    equ tc_who + 1      ;0 = no TC currently connected
	alive	   equ try_dtr + 2
	connct	   equ alive + 1       ;for all 16 ports, 1= connected, 0 not
	psw2	   equ connct + 2
;
;	*****************************
;	The data segment for Messages
;	*****************************
;
	ratetbl equ	psw2 + 6       ;the baudrate string
;
;	************************************************************
;	This Module defines the messages for all the other modules.
;	************************************************************
;
;	********** Messages for Text Atom ************
;
a81	equ	ratetbl + last_tbl
a82	equ	a81 + a81s
a83	equ	a82 + a82s
a84	equ	a83 + a83s	;check????????
aa0	equ	a84 + a84s
aa1	equ	aa0 + aa0s
ae6	equ	aa1 + aa1s
;	********* End of Text Atom Messages **********
psw	equ	ae6 + ae6s
verson	equ	psw + 6
;
msgq	equ	verson + 4
msgans	equ	msgq + msgql
msgno	equ	msgans + msgansl
msgc4	equ	msgno + msgnol
msgc1	equ	msgc4 + msgc4l
msgc2	equ	msgc1 + msgc1l
msgc3	equ	msgc2 + msgc2l
msgc7	equ	msgc3 + msgc3l
msgcl	equ	msgc7 + msgc7l
msgcunl equ	msgcl + msgcll
msgml0	equ	msgcunl + msgcunll
;
msgml01 equ	msgml0 + msgml0l
msgml1	equ	msgml01 + 5	;stop flashing
msgml2	equ	msgml1 + 2	;terminal #
msgml3	equ	msgml2 + 4	;terminal status
msgml4	equ	msgml3 + 3	;current baudrate
msgml41 equ	msgml4 + 5	;current baudrate lock status
msgml42 equ	msgml41 + 2	;hardware baudrate setting
msgml44 equ	msgml42 + 7	;
msgml5	equ	msgml44 + 4	;terminal type (currently empty)
;
msgmd1	equ	msgml5 + 12
;
msgmd2	equ	msgmd1 + msgmd1l
msgmd3	equ	msgmd2 + msgmd2l
;
msgtyp1 equ	msgmd3 + msgmd3l
msgtyp2 equ	msgtyp1 + 10
;
msgtc1	equ	msgtyp2 + 10
msgtc2	equ	msgtc1 + 3
;
msger3	equ	msgtc2 + 3
;
msgca	equ	msger3 + msger3l
msgcd	equ	msgca + msgcal
;
msglped equ	msgcd + msgcdl
;
msglper equ	msglped + msglpedl
;
msgm1	equ	msglper + msglperl
;
msgm2	equ	msgm1 + msgm1l
;
blink	equ	msgm2 + msgm2l		;set cursor blinking
noblink equ	blink + blinks		;set cursor steady
;
	end_store  equ noblink + noblinks
	gen_size   equ	end_store - reset_byte
;
;	*** End of Data structure for commom memory area ***
;
;
;	*************************************************
;	Data structure of each port; same for every port
;	*************************************************
;
	int_event	equ	0
;
;	Masking of int_event
;	bit 01 = LR complete
;	bit 02 = CMD complete
;	bit 03 = RSD page ready, OS read it over
;	bit 04 = RSD last page
;	bit 05 = Halt/Step and interrupt CS386
;
	sts_byte	equ	int_event + 1
;	bit 01 = Keyboard buffer status, 0 is empty, 1 is non empty
;	bit 02 = RSD, 0 is not ready, 1 is ready
;	bit 03 = Request RSD
;	bit 04 = Cancel RSD
;
	cmd_sts 	equ	sts_byte + 1
	cmd_abs 	equ	cmd_sts + 1
	cmd_cbs 	equ	cmd_abs + 1
	cmd_parm	equ	cmd_cbs + 1
;
;	--- test of gio ---
;	disbb		equ	cmd_parm + 99
;	--- test of end ---
;
;	Mappings of $GIO commands
;
	gio_sts 	equ	cmd_sts
	gabs		equ	gio_sts + 1
;
;	gio_abs 	equ	gio_sts + 1
;	gio_cbs 	equ	gio_abs + 1
;	gio_obs 	equ	gio_cbs + 1	;from OS to MXF
;	gio_ibs 	equ	gio_obs + 1	;from MXF to OS
;	gio_cpb 	equ	gio_ibs + 1
;	gio_rb		equ	gio_cpb + 1
;	gio_iobs	equ	gio_rb + 1
;	gio_ib9 	equ	gio_iobs + 1
;
	gio_now1	equ	cmd_parm + 100
	gio_now2	equ	gio_now1 + 1
	gio_data	equ	gio_now2 + 1
	gio_over	equ	gio_data + 1
;
;	End mapping of $GIO commands
;
	lr_buf		equ	gio_over + 1
;
	rsd_count	equ	lr_buf + 512
	rsd_buf 	equ	rsd_count + 2
;
	curnt_sts	equ	rsd_buf + 2048
;
	lr_count	equ  curnt_sts + 2   ;included termstat and next byte
	lrinit		equ  lr_count + 2
	lrstart 	equ  lrinit + 1      ;column offset on first line of LR
	lrstop		equ  lrstart + 1     ;absolute end of LR buffer
	lrwrp1		equ  lrstop + 2      ;current print pointer
	lrwrp2		equ  lrwrp1 + 2      ;point to print up to
	lrwr		equ  lrwrp2 + 2      ;current cursor position
	lrwre		equ  lrwr + 2	     ;absolute end of buffer
	lrcnt		equ  lrwre + 2	     ;max count - current count
					     ;(0 on end of buffer)
	lradd		equ  lrcnt + 2	     ;pointer of next location to add at

	lrquery 	equ  lradd + 2	     ;current state of LR
	lrsfb		equ  lrquery + 1
	rsdbyte 	equ  lrsfb + 1
	rsd_wrt 	equ  rsdbyte + 1
	rsd_rd		equ  rsd_wrt + 2
	rsdcomp 	equ  rsd_rd + 2
	rsdp		equ  rsdcomp + 1     ;temp var.
	dsrbyte 	equ  rsdp + 1	     ;control byte for con/discon system
	txbyte		equ  dsrbyte + 1     ;See Mapping above
	lrbyte		equ  txbyte + 1      ;control byte for LR
	lrmax		equ  lrbyte + 1
	timedwnd	equ  lrmax + 2	     ;timeout on TC line
	timedwn 	equ  timedwnd + 1    ;timeout count
	timestrt	equ  timedwn + 2     ;Routine to be run after timeout
	countout	equ  timestrt + 2
	key_wrt 	equ  countout + 1
	key_rd		equ  key_wrt + 2
	key_buf 	equ  key_rd + 2
	key_count	equ  key_buf + 96
	com_len 	equ  key_count + 1
	com_wrt 	equ  com_len + 1
	com_rd		equ  com_wrt + 2
	com_buf 	equ  com_rd + 2
	comt_len	equ  com_buf + 60
	comt_wrt	equ  comt_len + 1
	comt_rd 	equ  comt_wrt + 2
	comt_buf	equ  comt_rd + 2
	crt_wrt 	equ  comt_buf + 60
	crt_rd		equ  crt_wrt + 2
	crt_buf 	equ  crt_rd + 2
	crt_count	equ  crt_buf + 1024
	prt_wrt 	equ  crt_count + 2
	prt_rd		equ  prt_wrt + 2
	prt_buf 	equ  prt_rd + 2
	prt_count	equ  prt_buf + 1024
	dt_wrt		equ  prt_count + 2
	dt_rd		equ  dt_wrt + 2
	dt_buf		equ  dt_rd + 2	       ;Data Transfer buffer for RSD
	dt_count	equ  dt_buf + 256
	rx_wrt		equ  dt_count + 1
	rx_rd		equ  rx_wrt + 2
	rx_buf		equ  rx_rd + 2	       ;Receive-buffer
	rx_count	equ  rx_buf + 256
	pstopcnt	equ  rx_count + 1      ;Counter of prescanned, unprocessed-
	cstopcnt	equ  pstopcnt + 1      ;PRT/CRT stop codes in RXbuf
	rbi		equ  cstopcnt + 1      ;ready/busy byte for buffers
	rbimask 	equ  rbi + 1	       ;special mode ready mask
	flag1		equ  rbimask + 1
	flag2		equ  flag1 + 1
;	flag3		equ  flag2 + 1
	count1		equ  flag2 + 1
	lockk		equ  count1 + 1
	termstat	equ  lockk + 1
	termstatc	equ  termstat + 1      ;command
	outblock	equ  termstatc + 1
	bytesave	equ  outblock + 1
	xorbyte 	equ  bytesave + 1
	intbyte 	equ  xorbyte + 1
	dwncnt		equ  intbyte + 1
	termbyte	equ  dwncnt + 1
	crdata		equ  termbyte + 1
	csr_baud	equ  crdata + 1
	swbrate 	equ  csr_baud + 1	;store the csr value for baud rate
	hwbrate 	equ  swbrate + 2
	mrport		equ  hwbrate + 2
;	total_bk	equ  mrport - int_event
	csrport 	equ  mrport + 1
	crport		equ  csrport + 1
	acrport 	equ  crport + 1
	imrport 	equ  acrport + 1
	rthr		equ  imrport + 1
	cturport	equ  rthr + 1
	ctlrport	equ  cturport + 1
	baudport	equ  ctlrport + 1
	usermask	equ  baudport + 2
	srport		equ  usermask + 2
	isrport 	equ  srport + 1
	breakmk 	equ  isrport + 1
	crtcomp 	equ  breakmk + 1
	prtcomp 	equ  crtcomp + 1
	windw		equ  prtcomp + 1
	after0a 	equ  windw + 1
	acrdata 	equ  after0a + 1
	savepp		equ  acrdata + 1
	lwidth		equ  savepp + 6
	d2636		equ  lwidth + 1 	;0ff = 2636 or emulator
	fbd7		equ  d2636 + 1
	fbdb		equ  fbd7 + 1
	flag3		equ  fbdb + 1
	flag5		equ  flag3 + 2
	flag7		equ  flag5 + 2
	flag9		equ  flag7 + 1
	flag10		equ  flag9 + 1
	flag13		equ  flag10 + 1
	stop_area	equ  flag13 + 10
	total_bk	equ  stop_area - int_event
;
;	End of Data structure for each port
;	***********************************
;
