;
.286c
;	*********************************************************
;	This is the Main program of MXF/PROM of 2200 machine
;		    By J. L. Hong   1th, May. 1990
;	*********************************************************
;
include table.asm
;
code0	segment public
	assume	cs:code0
;
;
begin0: 			;j+
	jmp	begin2
	db	'*** Wang Laboratories, Inc. @2236MXF '
	db	'Micro Code Rev. 1.17 05/20/92 ***'
begin2:
	cli
	mov	ax,0140h	;setup stack
	mov	ss,ax
	mov	ax,1feh
	mov	sp,ax
begin:
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	call	init		;initial
	sti
main_lop:
	mov	di,0
cmd_lop:
	push	di
	mov	ax,es:dataseg[di]  ;point at first user
	mov	ds,ax
	mov	si,cmd_sts
	mov	al,[si]
	cmp	al,0fh		;Is command comming?
	jne	try_next	;no, try next
	call	port_serv
try_next:
;	call	check_dtr
	call	poll_buf	;see if terminal asking for services.
	inc	byte ptr es:alive
	pop	di
	add	di,2
	cmp	di,32
	jae	main_lop
	jmp	cmd_lop
;
;**********************************************************************
;
;	This subroutine try to service commands from CS386.
;	Return error if no command being found on buffer.
;
;**********************************************************************
port_serv	proc
;
	mov	di,tc_who
	cmp	byte ptr es:[di],0
	jnz	port_vtc	;Could be TC $GIO call
;
	mov	di,cmd_abs	;point at cmd_abs
	mov	al,[di]
	cmp	al,4		;CS requires the slave printer?
	je	abs4		;yes,
	cmp	al,6		;CS issue in/out command?
	je	abs60		;yes,
	cmp	al,7		;CS requires the crt?
	je	abs7x		;yes,
				;Do some error messages back to main
port_vtc:
;	Starting to check GIOs commands
;	mov	di,gio_now2
;	and	byte ptr [di],not gio_rb
;	dec	di		;gio_now1
;	mov	byte ptr [di],0
	cmp	al,14h		;$GIO request slave printer?
	je	gio14x
	cmp	al,16h		;$GIO command
	je	gio16x
	cmp	al,17h		;$GIO asking for CRT ?
	je	gio17x
;	Return of gio commands
;
	ret
abs60:
	jmp	abs6
abs7x:
	jmp	abs7
;
gio14x:
	jmp	gio14
gio16x:
	jmp	gio16
gio17x:
	jmp	gio17
;
;	Send a print-line to slave print
abs4:
	mov	si,rbi
	test	byte ptr [si],prtrb
	jnz	abs42
	ret
abs42:
	mov	di,cmd_parm
	mov	bl,[di]
	xor	bh,bh
	mov	si,prt_count
	mov	ax,[si]
	add	ax,bx
	cmp	ax,03ffh
	jb	abs49
	ret
abs49:
	cld
	mov	si,cmd_parm
	mov	cl,[si] 		;get the counter
	cmp	cl,0
	jz	abs417			;leave if counter is zero
	xor	ch,ch
	inc	si
	mov	di,prt_wrt
;
	mov	bx,[di]
	mov	di,prt_buf
abs7u:
	mov	al,[si]
absprt3:
	mov	[di][bx],al
	inc	bx
	cmp	bx,03ffh
	jbe	absv
	mov	bx,0
absv:
	push	di
	mov	di,prt_count
	inc	word ptr [di]
	pop	di
	cmp	al,esccode
	jnz	absprt2
	mov	al,0d0h
	jmp	absprt3
absprt2:
	inc	si
	loop	abs7u
;
	mov	di,prt_wrt
	mov	[di],bx
	mov	di,txbyte
	or	byte ptr [di],prtbit
	mov	si,cmd_sts
	mov	byte ptr [si],0f1h	;command complete without returned value
	call	entx
	ret
abs417:
	mov	si,cmd_sts
	mov	byte ptr [si],0f1h	;command complete without returned value
	ret
;
;	Service the CRT, must take care of $GIO condition
;
abs7:
	mov	si,rbi
	test	byte ptr [si],crtrb
	jnz	abs72
	ret
abs72:
	mov	di,cmd_parm
	mov	bl,[di]
	xor	bh,bh
	mov	si,crt_count
	mov	ax,[si]
	add	ax,bx
	cmp	ax,03ffh
	jb	abs79
	ret
abs79:
	cld
	mov	si,cmd_cbs
	mov	ah,[si]
	cmp	ah,0ffh
	jz	abs77			;if cbs = 0ffh, then simply data
	push	ax
	mov	al,esccode
	call	putcrtg
	pop	ax
	mov	al,ah
	call	putcrtg
;
;	may/12/92
	mov	si,flag13
	mov	byte ptr [si],0ffh
;	may/12/92, end
;
abs77:
	mov	si,cmd_parm
	mov	cl,[si] 		;get the counter
	cmp	cl,0
	jz	abs717
	xor	ch,ch
	inc	si
;
	mov	di,crt_wrt
	mov	bx,[di]
	mov	di,crt_buf
;
abs7m:
	mov	al,[si]
abscrt3:
	mov	[di][bx],al
;
	inc	bx
	cmp	bx,03ffh
	jbe	absv1
	mov	bx,0
absv1:
	push	di
	mov	di,crt_count
	inc	word ptr [di]
	pop	di
;
	cmp	al,esccode
	jnz	abscrt2
	mov	al,0d0h
	jmp	abscrt3
abscrt2:
;
	inc	si
	loop	abs7m
abs71:
	mov	di,crt_wrt
	mov	[di],bx
	mov	di,txbyte
	or	byte ptr [di],crtbit
	mov	si,cmd_sts
	mov	byte ptr [si],0f1h	;command complete without returned value
	call	entx
	ret
abs717:
	mov	si,cmd_sts
	mov	byte ptr [si],0f1h	;command complete without returned value
	ret
;
;	CS386 sends and receives commands with MXF
;
abs6:
	mov	di,cmd_cbs
	mov	al,[di]
	cmp	al,maxc 	;Limit entry within total entries.
	ja	cret
	xor	ah,ah
	shl	ax,1
	mov	si,ax
	jmp	cs:crtn[si]
cret:
	ret
;	**********************************************************************
crtn	dw	cret		;00, no operation
	dw	c0601		;01, power on, an interrupt command
	dw	c0602		;02, initialize terminal
	dw	c0603		;03, delete line request, an interrupt command
	dw	cret		;04, check key buffer
	dw	cret		;05, not support
	dw	c0606		;06, get key, an interrupt command
	dw	c0607		;07, line request
	dw	c0608		;08, prefill line request
	dw	c0609		;09, refill line request
	dw	c060a		;0a, end of line request
	dw	c060b		;0b, Query Line Request
	dw	c060c		;0c, Accept LR, OS read directly from lr buffer
	dw	cret		;0d, request CRT buffer - Not support
	dw	cret		;0e, request PRT buffer - Not support
	dw	c060f		;0f, error line request
	dw	c0610		;10, terminate line request
	dw	c0611		;11, not support
	dw	c0612		;12, Okay to next command after 060a
	dw	cret		;13, not support
	dw	cret		;14, not support
	dw	c0615		;15, Send window parameters (WRITE) by OS
	dw	c0616		;16, Receive data from terminal (READ)
	dw	c0617		;17, Receive data of status (READ)
	dw	c0618		;18, Setting windth of Request line by OS
	dw	cret		;19, undefined
	dw	cret		;1a, undefined
	dw	cret		;1b, undefined
	dw	cret		;1c, undefined
	dw	cret		;1d, undefined
	dw	cret		;1e, undefined
	dw	cret		;1f, status of the port, may/14/92
	dw	c0620		;20, $MXF command
	dw	c0621		;21, return results of $MXF command
	dw	c0622		;22, enable connect
	dw	c0623		;23, disable connect
	dw	c0624		;24, enable disconnect
	dw	c0625		;25, disable disconnect
	dw	c0626		;26, Alert CS system to all connected ports
	dw	c0627		;27, clear pending disconnection
	dw	cret		;28, get ID of terminal
	dw	c0629		;29, initiate remote screen dump
	dw	c062a		;2a, abort remote screen dump
	dw	c062b		;2b, initiate remote screen dump in rewponce to terminal request
	dw	c062c		;2c, reconnect port
	dw	c062d		;2d, select special package, TC function
	dw	c062e		;2e, set MXF password
	dw	c062f		;2f, null command without reply 0f1, feb/26/92
maxc	equ	($ - crtn)/2	;Total entries
;
c0601:				;01,*power on, an interrupt command
;	********************************************************************
;	Routine issues the power-on command which will restart the machine.
;	Asking the user sure about this !
;	********************************************************************
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h
	mov	si,head_rom
	jmp	dword ptr es:[si]
;
c0602:			    ;j+
;	*****************************************
;	Routine initializes the current terminal
;	*****************************************
	call	rstbufk
	call	rstbufc
	call	rstlr
	call	rstterm 	;check?
				;See if prt needs clearing
	mov	di,cmd_parm
;	inc	di
	mov	al,[di] 	;get parameter, only one
	cmp	al,0		;if 01 then clear crt only, 00 then prt also
	jnz	c0602n		;Leave if not zero
	call	rstbufp
c0602m:
	mov	al,esccode	;Output escape code
	call	putcrtg
	mov	al,termrst	;terminal reset code
	call	putcrtg
	call	rstterm1	;check? waste time to let terminal reset
;	mov	al,0ffh 	;change al to skip c0602n
c0602n:
;	cmp	al,01
;	jz	c0602m
	mov	di,intbyte
	and	byte ptr [di],not keyint
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h
	ret
;
c0603:			     ;j+
;	*********
;	Delete LR
;	*********
	mov	di,lrbyte
	and	byte ptr [di],not lrbit
	and	byte ptr [di],not lrendbit
	call	lrout
;	call	cmd_over
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
;c0604: 		      ;j+
;	**********************************************************************
;	Routine check keyboard buffer, notice OS whether empty or occupied
;	**********************************************************************
;	 sti
;	 mov	 di,key_count
;	 cmp	 byte ptr [di],0
;	 jz	 c0604c
;	 mov	 si,sts_byte
;	 or	 byte ptr [si],01h	 ;means key buffer not empty
;	 mov	 di,cmd_sts
;	 mov	 byte ptr [di],0f0h	 ;return with value
;	 jmp	 c0604d
;c0604c:
;	 mov	 si,sts_byte
;	 and	 byte ptr [si],0feh	 ;means key buffer empty
;	 mov	 di,cmd_sts
;	 mov	 byte ptr [di],0f1h	 ;return without value
;c0604d:
;	 mov	 di,intbyte
;	 or	 byte ptr [di],keyint
;	 ret
;
c0606:			     ;j+
;	**********************************************************************
;	Routine passes a byte from keyboard to OS, under the waiting condition
;	of OS. So, interrupt OS when the byte is ready.
;	**********************************************************************
	sti
	mov	di,key_count
	cmp	byte ptr [di],0
;	jnz	c0606a		;Yes, interrupt OS and send the bytes.
	jz	c0606c
	call	getkeyt
	mov	di,cmd_parm
;	inc	di		;skip the counter
	mov	[di],al 	;move byte to parameter part of command
	inc	di
	mov	[di],ah
;	mov	si,sts_byte
;	or	byte ptr [si],01h	;means key buffer not empty
	mov	di,intbyte
	and	byte ptr [di],not keyint
	mov	di,cmd_sts
	mov	byte ptr [di],0f0h	;return with value
	ret
;	jmp	c0606d
c0606c:
;	mov	si,sts_byte
;	and	byte ptr [si],0feh	;means key buffer empty
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
c0606d:
;	may/14/92
	mov	di,flag9
;	mov	di,curnt_sts
	and	byte ptr [di],not keyint
;	may/14/92, end
	mov	di,intbyte
	or	byte ptr [di],keyint
	ret
;
c0607:			     ;Set up for line request
;	******************************************************************
;	There will be formatted data coming as : (07 xxxx yy zz)
;	Access these data in the parameter of command data
;	xxxx = max. byte # of LR, yy = 80 bit/underline LR
;	yy = 04 bit/start in edit mode, yy = 01 bit/flush keybuf before LR
;	zz = column to start LR on.
;	******************************************************************
	mov	si,cmd_parm
	mov	ah,[si] 		;Get a word of length
	inc	si
	mov	al,[si]
;
	mov	di,lrcnt
	mov	[di],ax 		;count
;
;	mov	di,lr_buf
;	add	ax,di
	mov	di,lrstop
	mov	[di],ax 		;The absolute end of LR buffer
;
	inc	si
	inc	si			;point to zz
	mov	al,[si]
	mov	di,lrstart
	mov	[di],al 		;start position here, current column?
	dec	si			;point to yy
	mov	al,[si]
	mov	di,lrinit
	mov	[di],al
	test	al,flushbit
	jz	c06071
	call	rstbufk 		;Flush key_buf first
c06071:
	mov	di,lrinit
	mov	al,[di]
	and	al,underon+editon	;just want underline and edit bit
	mov	di,lrbyte
	mov	[di],al
	test	al,editbit
	jz	c0607z
	or	byte ptr [di],editbit
c0607z:
;	testing Dec/14
	mov	cx,es:commode
	mov	di,usermask
	mov	ax,[di]
	test	cx,ax
	jz	c0607w
	not	ax
	and	cx,ax
	mov	es:commode,cx
c0607w:
;	testing Dec/14
;
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c0608:			     ;j+
;	***********************************************************
;	Routine prefills LR buffer, cursor at the beginning.
;	Desired line should be filled in LR buffer which were put
;	directly by CS386. Count is in lr_count by OS/386.
;	***********************************************************
	mov	di,lrinit
	and	byte ptr [di],not fillbit	;prefill mode
	mov	di,lrwr
	mov	word ptr [di],0 		;beginning of buffer
	mov	di,lrstop
	mov	ax,[di]
;	mov	si,lr_buf
;	sub	ax,si
	mov	di,lrcnt
	mov	[di],ax 		;lrcnt = empty buffer
	call	addlr			;Beware! prefill from LR buffer
					;while refill from command parameter.
	mov	di,lrwr
	mov	word ptr [di],0
;	Set print flag, addlr already set lrwrp1 to the buffer beginning
;	and lrwrp2 to the end of added string. If in underline mode,
;	Go ahead print the entire buffer.
	mov	di,lrinit
	test	byte ptr [di],underbit
	jz	c0608z
;	Set lrwrp2 to end of buffer since this is an underlined LR, under
;	lines must be put on screen first.
	mov	di,lrstop
	mov	ax,[di]
	add	di,4			;point at lrwrp2
	mov	[di],ax
c0608z:
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c0609:
;	***********************************************************
;	Routine Refills LR buffer, cursor at the end of buffer.
;	Desired line should be filled in parameter part of command
;	that filled by CS386. First word is counter of length.
;	***********************************************************
	mov	di,lrinit
	or	byte ptr [di],fillbit	;fillbit = 1/ Refill mode
	call	addlr
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c060a:
;	**********************************************************************
;	Routine executes the end-of-LR command which will cause termination of
;	the sequence of LR command.
;	**********************************************************************
	sti
;
;	testing Dec/19
	mov	di,after0a		;updating not yet
	mov	byte ptr [di],0ffh
;	jz	c060aw			;jump if =0ffh, otherwise new start
;	testing Dec/19
;
	mov	di,lrbyte
	and	byte ptr [di],not lrendbit
;
;	Mask off address 07 so no printing to CRT occur until MXE ready. check???
	mov	di,outblock
	or	byte ptr [di],lrblock
	mov	di,rbimask
	and	byte ptr [di],not crtrb 	;mask CRT
;
	mov	al,curson
	call	putcrtg 		;put one byte to crt_buf
	mov	di,lrbyte
	or	byte ptr [di],prtlr
	or	byte ptr [di],lron
	test	byte ptr [di],editbit
	jz	c060a1
;
;	push	es
	mov	si,blink		;output messages
	mov	cl,blinks
	xor	ch,ch
	call	putstr
c060a1:
	mov	di,lrquery
	mov	byte ptr [di],01h
c060aw:
	call	lrout
;
;	test Dec. 12th
;	jz	c060a7			;Z/updating screen okay jump
;	mov	di,after0a		;updating not yet
;	mov	byte ptr [di],0ffh
;	ret
;
;c060a7:
;	mov	di,after0a		;updating Okay
;	mov	byte ptr [di],0h
;	test Dec. 12th -- end
;
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c060b:
;	**********************************************
;	MXF should answer this command as following:
;	00 - No line request in progress
;	01 - Line request still in progress
;	0d - Line request terminate by carriage/return
;	ff - Recall key press
;	**********************************************
	mov	di,lrquery
	mov	al,[di]
	cmp	al,0feh
	jae	c060b2			;SF or Recall key?
c060b6:
	mov	di,cmd_parm+1		;Neither !
	mov	byte ptr [di],0
	dec	di
	mov	[di],al
	jmp	c060bz			;go back
;
c060b2:
	jnz	c060b3			;jmp if 'ff'
	mov	di,lrsfb
	mov	ah,[di]
;	feb/28/92
;	mov	di,cmd_parm
;	mov	byte ptr [di],al
	mov	di,cmd_parm+1
;	feb/28/92, end
	mov	byte ptr [di],01	;with endi
	dec	di
	mov	[di],ah
	jmp	c060bz
c060b3: 				;recall key pressed
	mov	al,0ffh
	jmp	c060b6
c060bz:
;	may/14/92
	mov	di,flag9
;	mov	di,curnt_sts
	and	byte ptr [di],not lrint
;	may/14/92, end
	mov	di,cmd_sts
	mov	byte ptr [di],0f0h	;return with value
	ret
;
c060c:
;	****************************************************************
;	OS is ready to accept the data, so compute # of byte in lr_count
;	****************************************************************
;	mov	di,lr_buf
	mov	si,lrwre
	mov	ax,word ptr [si]
;	sub	ax,di
	mov	di,lr_count
	mov	[di],ax
	mov	di,lrbyte
	and	byte ptr [di],not lrendbit
	and	byte ptr [di],not lrbit
	call	lrout
;	key bugging 6/june, 1991
;	mov	di,curnt_sts
;	and	byte ptr [di],not lrint
;	bugging end 6/june, 1991
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;
	ret
;
c060f:			     ;j+
;	************************************
;	Error during LR, beep and continue !
;	************************************
	mov	al,beep
	call	putcrtg
	mov	di,lrbyte
	and	byte ptr [di],not lrendbit
	or	byte ptr [di],lrbit
	mov	di,lradd
	mov	word ptr [di],0ff00h
	add	di,2		      ;point at lrquery
	mov	byte ptr [di],01h     ;Status flag = LR in progress
;
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c0610:			     ;j+, same as procedure lrret
;	***********************************************
;	Routine terminates LR as if return is received.
;	***********************************************
	sti
	call	lrret
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0611:
;	********************************************************
;	Routine returns a code to tell OS whether in ROM or RAM
;	********************************************************
	mov	si,cmd_parm
	mov	byte ptr [si],00h
	mov	si,cmd_sts
	mov	byte ptr [si],0f0h	;return with value
	ret
;
c0612:
;	***********************************************
;	Routine to answer OS, if okay for OS to issue
;	next command after the 060a commands of Refill.
;	Return: 0/Okay, 0ffh/not yet in cmd_parm
;	***********************************************
	mov	di,cmd_parm
	mov	si,after0a		;If after0a = 0ffh then not yet
	cmp	byte ptr [si],0ffh	;after0a = 0, go head for next
	jz	c0612a
;	Bugging for multi-users of edit-recall, 23/jan
	mov	si,crt_count
	cmp	word ptr [si],0
	jnz	c0612a
;	End of bugging, 23/jan
	mov	byte ptr [di],0
	jmp	c0612z
c0612a: 				;Not yet
	mov	byte ptr [di],0ffh
c0612z:
	mov	si,cmd_sts
	mov	byte ptr [si],0f0h	;return with value
	ret
;
;c0615:
;	*******************************************
;	Routine sends wondow parameters to terminal
;	First one would be the counter
;	*******************************************
;;	 mov	 di,rsdbyte
;;	 and	 byte ptr [di],not rsdabrtb
;;	 call	 rstbfrsd	 ;clear RSD buffer
;
;	 mov	 al,esccode
;	 call	 putdt
;	 mov	 al,0d5h
;	 call	 putdt
;;
;	 mov	 si,cmd_parm
;	 mov	 cl,[si]		 ;fetch the counter
;	 xor	 ch,ch
;	 inc	 si			 ;point at the data area
;c06151:
;	 push	 si
;	 mov	 al,[si]
;	 call	 putdt
;	 pop	 si
;	 inc	 si
;	 loop	 c06151
;	 mov	 di,windw
;	 or	 byte ptr [di],wndw
;;
;;;	  mov	  di,lrbyte
;	 or	 byte ptr [di],rsdgob
;;	 test	 byte ptr [di],dtdelay
;;	 jnz	 c0615z
;	 mov	 di,dsrbyte
;	 or	 byte ptr [di],dtb	    ;let dt go
;	 call	 entx
;;c0615z:
;;	 mov	 si,sts_byte
;;	 or	 byte ptr [si],04h
;	 mov	 di,cmd_sts
;	 mov	 byte ptr [di],0f1h	 ;return without value
;	 ret
;
c0615:
;	**************************************************************
;	Routine sends wondow parameters to terminal (WRITE)
;	First one would be the command code while data are in rsd_buf.
;	**************************************************************
	mov	di,windw
	test	byte ptr [di],in_prcs
	jz	c0615c
	ret
c0615c:
;	mov	di,windw
	test	byte ptr [di],cntncmd
	jnz	c0615a
	mov	byte ptr [di],0 		;@@@
	or	byte ptr [di],cntncmd
;
;	to isolate from the escaped sequences, aug/5/91
	mov	di,crt_count
c0615w:
	cmp	word ptr [di],0
	jz	c0615x
	jmp	c0615w
c0615x:
;	to isolate from the escaped sequences, aug/5/91 end
;
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
;	or	byte ptr [di],rsdb	   ;let dt go
	mov	di,fbd7
	mov	byte ptr [di],0ffh
	mov	al,esccode
	call	putdt
	mov	al,0d5h
	call	putdt
;
	mov	al,07h		;07 means write
	call	putdt
;
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
	call	entx
;
;	Waiting for responce from terminal, terminate this command
;	if responce isn't received within certain moment aug/1/91
;	debug - taking out of the waiting status, aug/14/92
;	jmp	c0615a
;	debug - taking out of the waiting status, end aug/14/92
	mov	cx,0f000h			 ;longer than 10 ms
;	mov	cx,0
;	mov	dx,0
;
c0615k:
	nop
	nop
	nop
	mov	di,d2636
	cmp	byte ptr [di],0ffh		;2636/emulator or older terminals
	jz	c0615a				;yes!
	nop
	nop
	nop
	mov	di,d2636
	cmp	byte ptr [di],0ffh		;2636/emulator or older terminals
	jz	c0615a				;yes!
;	inc	cx
;	cmp	cx,0ffffh
;	jnz	c0615k
;	inc	dx
;	jmp	c0615k
	loop	c0615k
	mov	di,fbd7
	mov	byte ptr [di],0
	mov	di,windw
	mov	byte ptr [di],0
	mov	di,cmd_parm
	mov	byte ptr [di],0fdh		;error, inform OS
	mov	di,dsrbyte
	and	byte ptr [di],not dtb
	mov	di,d2636
	mov	byte ptr [di],0
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	aug/28/91
	mov	di,curnt_sts
	or	byte ptr [di],windint
;	aug/28/91
	ret
;	End waiting status
;
;
c0615a:
;
	mov	cx,180h
c0615ak:			;delay purpose
	call	rstrsd1 	;clear rsd read/write pointers
;	delay
	loop	c0615ak
	mov	di,windw
	or	byte ptr [di],wndw		;window mode
	or	byte ptr [di],wrtrd	    ;write status
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
	or	byte ptr [di],rsdb	   ;let dt go
;
	mov	di,cmd_parm
	cmp	byte ptr [di],midpage
	jz	c0615b
	mov	di,windw
	and	byte ptr [di],not cntncmd
c0615b:
	mov	di,windw
	or	byte ptr [di],in_prcs
	call	entx
;
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
	ret
;
;c0616:
;	**************************************************************
;	Routine sends wondow parameters to terminal for Continuing
;	Page, a command after the 0615 command (WRITE)
;	First one would be the command code while data are in rsd_buf.
;	**************************************************************
;	 call	 rstrsd1		 ;clear read/write pointers
;	 mov	 di,windw
;	 or	 byte ptr [di],wndw		 ;window mode
;	 and	 byte ptr [di],not wrtrd	 ;write status
;
;	 mov	 di,dsrbyte
;	 or	 byte ptr [di],dtb	    ;let dt go
;	 call	 entx
;;c0616z:
;;	 mov	 si,sts_byte
;;	 or	 byte ptr [si],04h
;	 mov	 di,cmd_sts
;	 mov	 byte ptr [di],0f1h	 ;return without value
;	 ret
;
c0616:
;	**************************************************************
;	Routine that is noticed by OS/386 that window data will be
;	delivered from terminal. (READ)
;	**************************************************************
	mov	di,windw
	test	byte ptr [di],in_prcs
	jz	c0616c
	ret
c0616c:
	mov	di,fbdb
	mov	byte ptr [di],0 		;limit fb+db only once
	mov	di,d2636
	mov	byte ptr [di],0 		;2636/emulator or older terminals
	mov	di,windw
	test	byte ptr [di],cntncmd
	jnz	c0616a
	mov	byte ptr [di],0 		;@@@
;
	or	byte ptr [di],cntncmd
;
;	to isolate from the escaped sequences, aug/5/91
	mov	di,crt_count
c0616w:
	cmp	word ptr [di],0
	jz	c0616x
	jmp	c0616w
c0616x:
;	to isolate from the escaped sequences, aug/5/91 end
;
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
	mov	di,fbd7
	mov	byte ptr [di],0ffh
	mov	al,esccode
	call	putdt
	mov	al,0d5h
	call	putdt
;
	mov	al,06h		;06 means read
	call	putdt
;
;	Waiting for responce from terminal, terminate this command
;	if responce isn't received within certain moment aug/1/91
;	debug - taking out of the waiting status, aug/14/92
;	jmp	c0616a
;	debug - taking out of the waiting status, end aug/14/92
	mov	cx,0f000h			 ;longer than 10 ms
;	mov	cx,0
;	mov	dx,0
;
c0616k:
	nop
	nop
	nop
	mov	di,d2636
	cmp	byte ptr [di],0ffh		;2636/emulator or older terminals
	jz	c0616a				;yes!
	nop
	nop
	nop
	mov	di,d2636
	cmp	byte ptr [di],0ffh		;2636/emulator or older terminals
	jz	c0616a				;yes!
;	inc	cx
;	cmp	cx,0ffffh
;	jnz	c0616k
;	inc	dx
;	jmp	c0616k
	loop	c0616k
	mov	di,fbd7
	mov	byte ptr [di],0
	mov	di,windw
	mov	byte ptr [di],0
	mov	di,dsrbyte
	and	byte ptr [di],not dtb
	mov	di,cmd_parm
	mov	byte ptr [di],0fdh		;error, inform OS
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	aug/28/91
	mov	di,curnt_sts
	or	byte ptr [di],windint
;	aug/28/91
	ret
;	End waiting status
;
c0616a:
;	call	rstrsd1 	;clear rsd read/write pointers
	call	rstbfrsd	;clear rsd read/write pointers
	mov	di,windw
	or	byte ptr [di],wndw	;window mode
	and	byte ptr [di],not wrtrd     ;read status
;
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
;	or	byte ptr [di],rsdb	   ;let dt go
	mov	al,esccode
	call	putdt
	mov	al,0d9h
	call	putdt
	call	entx
;
	mov	di,windw
	or	byte ptr [di],in_prcs
	mov	di,d2636
	mov	byte ptr [di],0 		;2636/emulator or older terminals
;	mov	di,cmd_abs
;	mov	byte ptr [di],0ffh		;please wait for data
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f0h	;return with value
	ret
;
c0617:
;	**************************************************************
;	Routine that is noticed by OS/386 that window data will be
;	delivered from terminal. (READ status)
;	**************************************************************
	mov	di,windw
	test	byte ptr [di],in_prcs
	jz	c0617c
	ret
c0617c:
;
	mov	di,fbdb
	mov	byte ptr [di],0 		;limit fb+db only once
	mov	di,d2636
	mov	byte ptr [di],0 		;2636/emulator or older terminals
	mov	di,windw
	test	byte ptr [di],cntncmd
	jnz	c0617a
	mov	byte ptr [di],0 		;@@@
;
	or	byte ptr [di],cntncmd
;
;	to isolate from the escaped sequences, aug/5/91
	mov	di,crt_count
c0617w:
	cmp	word ptr [di],0
	jz	c0617x
	jmp	c0617w
c0617x:
;	to isolate from the escaped sequences, aug/5/91 end
;
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
	mov	di,fbd7
	mov	byte ptr [di],0ffh
	mov	al,esccode
	call	putdt
	mov	al,0d5h
	call	putdt
;
	mov	al,05h		;05 means read status
	call	putdt
;
;
;	Waiting for responce from terminal, terminate this command
;	if responce isn't received within certain moment aug/1/91
;	debug - taking out of the waiting status, aug/14/92
;	jmp	c0617a
;	debug - taking out of the waiting status, end aug/14/92
	mov	cx,0f000h			 ;longer than 10 ms
;	mov	cx,0
;	mov	dx,0
;
c0617k:
	nop
	nop
	nop
	mov	di,d2636
	cmp	byte ptr [di],0ffh		;2636/emulator or older terminals
	jz	c0617a				;yes!
	nop
	nop
	nop
	mov	di,d2636
	cmp	byte ptr [di],0ffh		;2636/emulator or older terminals
	jz	c0617a				;yes!
;	inc	cx
;	cmp	cx,0ffffh
;	jnz	c0617k
;	inc	dx
;	jmp	c0617k
	loop	c0617k
	mov	di,fbd7
	mov	byte ptr [di],0
	mov	di,windw
	mov	byte ptr [di],0
	mov	di,dsrbyte
	and	byte ptr [di],not dtb
	mov	di,cmd_parm
	mov	byte ptr [di],0fdh		;error, inform OS
	mov	di,d2636
	mov	byte ptr [di],0
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	aug/28/91
	mov	di,curnt_sts
	or	byte ptr [di],windint
;	aug/28/91
	ret
;	End waiting status
;
c0617a:
;	call	rstrsd1 	;clear rsd read/write pointers
	call	rstbfrsd	;clear rsd read/write pointers
	mov	di,windw
	or	byte ptr [di],wndw	;window mode
	and	byte ptr [di],not wrtrd     ;read status
;
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
;	or	byte ptr [di],rsdb	   ;let dt go
	mov	al,esccode
	call	putdt
	mov	al,0d9h
	call	putdt
	call	entx
;
	mov	di,windw
	or	byte ptr [di],in_prcs
	mov	di,d2636
	mov	byte ptr [di],0 		;2636/emulator or older terminals
;	mov	di,cmd_abs
;	mov	byte ptr [di],0ffh		;please wait for data
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f0h	;return with value
	ret
;
c0618:			     ;j+
;	**************************************************************
;	Routine setting the width of request line from OS386, however
;	the maximum is 50h.
;	**************************************************************
	mov	si,lwidth
	mov	di,cmd_parm
	mov	al,[di]
	cmp	al,50h
	jbe	c0618a
	mov	byte ptr [si],linelen
	jmp	c0618b
c0618a:
	mov	byte ptr [si],al
c0618b:
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c061f:			     ;j+
;	********************************************
;	Routine gets a status of this port to OS386.
;	********************************************
	mov	di,flag9
	mov	al,[di]
	and	al,04h
	mov	di,curnt_sts
	or	[di],al
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
	ret
;
c0620:			     ;j+
;	**************************************************************
;	Routine gets a special $MXF command from OS386, and parses it.
;	**************************************************************
	call	put_comb
	call	comp2
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0621:			     ;j+, Return result of $MXF command
;	**************************************************
;	Routine puts the last $MXF command back to OS 386.
;	**************************************************
	mov	di,cmd_parm
	inc	di
	mov	al,es:comerr
	mov	[di],al
	mov	di,cmd_sts
	mov	byte ptr [di],0f0h	;return with value
;	call	cmd_over
	ret
;
c0622:			     ;j+
;	************************************************************
;	Routine enables the connect int system for the current port.
;	************************************************************
	mov	di,dsrbyte
	or	byte ptr [di],conb	   ;set the connect bit
	test	byte ptr [di],curdsr	   ;if the port already connect,
	jz	ret0622
	mov	cx,es:connect_byte
	mov	di,usermask
	mov	ax,[di]
	test	ax,06h		;port 2 or 3?
	jz	swch9		;nea!
;
	xor	ax,06h		;yea!
swch9:
	or	cx,ax		       ;set the status byte
	mov	es:connect_byte,cx
	or	byte ptr es:rbibus,statrb	;chech??
ret0622:
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0623:			     ;j+
;	***************************************************
;	Routine disables the connect system of current port
;	***************************************************
	mov	di,dsrbyte
	and	byte ptr [di],not conb	      ;reset the connect bit
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0624:			     ;j+
;	***********************************************************************
;	This routine enables the disconnection detection system for the
;	current port.
;	Two bytes (xxxx) are sent after the command CBS is sent.
;		IF xxxx = 0 then the port is disconnected immediately and
;			the disconnect detection system remains in force
;		IF 0 < xxxx < FFFF then xxxx is set as the current timeout
;			and the port is disconnected when xxxx seconds
;			have passed.
;		IF xxxx = FFFF then the current countdown for this port
;			is reset and disconnect detect reamins active
;	***********************************************************************
	mov	di,dsrbyte
	mov	cl,[di]
	or	cl,disconb
	or	[di],cl
	mov	si,cmd_parm
	mov	ah,[si]
	inc	si
	mov	al,[si]
	or	ax,ax
	jnz	c06242				;Not zero, jump
;
	test	cl,curdsr
	jnz	c06241				;jump if connected
	or	cl,discimmb
	mov	[di],cl
	jmp	ret0624
c06241:
	call	disconj
;	mov	cx,es:disconnect_byte
;	mov	di,usermask
;	mov	ax,[di]
;	test	ax,06h		;port 2 or 3?
;	jz	swch90		;nea!
;
;	xor	ax,06h		;yea!
;swch90:
;	or	cx,ax
;	mov	es:disconnect_byte,cx
;	or	byte ptr es:rbibus,statrb
	jmp	ret0624
c06242:
	cmp	ax,0ffffh
	je	c0627
	mov	si,offset disconj
	call	timeout
ret0624:
;
;	for testing purpose only, should be omitted
;	mov	di,usermask
;	mov	ax,[di]
;	test	ax,06h		;port 2 or 3?
;	jz	omit2		;nea!
;
;	xor	ax,06h		;yea!
;omit2:
;	or	es:disconnect_byte,ax	  ;set the status to 2200
;	for testing purpose only, should be omitted
;
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0625:			     ;j+
;	************************************************
;	Routine disables the disconnect detection system
;	************************************************
	mov	di,dsrbyte
	and	byte ptr [di],not disconb
	mov	di,timedwn
	mov	word ptr [di],0
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0626:			    ;j+     @@@
;	*******************************************************
;	Routine sets the connect bits for every port connected.
;	*******************************************************
	mov	cx,es:connect_byte
	or	cx,ax
	mov	es:connect_byte,cx
	or	byte ptr es:rbibus,statrb
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0627:			     ;j+
;	**********************************************************************
;	Routine clears out any pending int for the current port but leaves the
;	state of the disconnection system unchanged.
;	**********************************************************************
	cli			;disable interrupt
	mov	ax,0
	call	timeout
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c0629:			     ;j+
;	*********************************************************************
;	OS issues a RSD initial command, Format: 'parameter' 'ENDI(ak/nak)'
;	Where: 'parameters' can be any number of bytes to be sent to the
;		   terminal at the start of RSD.
;	*********************************************************************
	mov	di,lrbyte
	or	byte ptr [di],dtdelay
	and	byte ptr [di],not rsdgob
c06291:
;				 Send AK or NAK to cs386
;	mov	cl,termbyte
;	test	cl,rsdspurt
;	jnz	c06295
;				 Cancel rsd, not support
;	mov	cl,cmd_sts
;	mov	cl,0		;NAK
;	mov	cl,lrbyte
;	and	cl,not dtdelay
;	mov	lrbyte,cl
;	ret
c06295:
	mov	di,rsdbyte
	and	byte ptr [di],not rsdabrtb
	call	rstbfrsd	;clear RSD buffer
	call	rstbufdt	;clear DT buffer
	mov	al,esccode	;0f1h, escaped code for RSD
	call	putdt		;put to DT buffer
	mov	al,rsdstart
	call	putdt
	mov	di,cmd_parm
;	mov	ch,[di] 	;get the count from rsd_count
;	inc	di
	xor	ch,ch
	mov	cl,[di]
	inc	di
c06292:
	mov	al,[di]
	push	di
	call	putdt
	pop	di
	inc	di
	loop	c06292
;
	mov	di,lrbyte
	or	byte ptr [di],rsdgob
	test	byte ptr [di],dtdelay
	jnz	c0629z
	mov	di,dsrbyte
	or	byte ptr [di],dtb	   ;let dt go
	call	entx
c0629z:
	mov	si,sts_byte
	or	byte ptr [si],04h
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c062a:			     ;j+
;	****************************
;	Routine aborts a current RSD
;	****************************
	mov	di,dsrbyte
	test	byte ptr [di],rsdb	   ;this bit set is mean user request RSD and in progress now
	jnz	c062a1
;	mov	cmd_sts,7fh		  ;so, can not abort
	ret
c062a1:
	mov	al,esccode
	call	putdt
	mov	al,rsdend
	call	putdt
	mov	al,esccode
	call	putdt
	mov	al,rsdgo
	call	putdt
	mov	al,0
	call	putdt
	mov	di,rsdbyte
	or	byte ptr [di],rsdabrtb
	mov	si,sts_byte
	or	byte ptr [si],08h
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c062b:			     ;j+
;	*******************************************
;	Initialize RSD in response to Term. request
;	*******************************************
;	cli
	mov	di,txbyte
	and	byte ptr [di],not rsdreqb
	jmp	c06291
;
c062c:			    ;j+, check?
;	********************************************************
;	Reconnect a port which is inactive, a 5 second countdown
;	is setup at end of dtr is set active.
;	********************************************************
	mov	di,timedwnd
	mov	byte ptr [di],5
;	For disocnnection, feb/26/92
;	mov	di,cmd_sts
;	mov	byte ptr [di],0fh
;	mov	di,cmd_abs
;	mov	byte ptr [di],06h	;abs = 06
	mov	di,cmd_cbs
	mov	byte ptr [di],2fh	;obs = 2f, null command
;	For disocnnection, feb/26/92, end
;
;	mov	di,cmd_sts
;	mov	byte ptr [di],0f1h	;return without value
;	call	cmd_over
	ret
;
c062d:			    ;j+ 2d, select special package, TC function
;	********************************************************
;	This block handles the selection of a special package
;	Format :   CBS(  )  OBS(XX)
;		    WHERE XX = 00	NOP
;			       01	STANDARD WANG TERMINAL
;			       02	TC  (2227B REPLACEMENT)
;	MXE responds with ENDI(00) if selection is legal
;		   or ENDI(NZ) if selection is not legal
;	********************************************************
;
	mov	di,cmd_parm
	mov	al,[di]
	cmp	al,0
	jz	c062dmz 	;nop
	mov	di,flag2
	and	byte ptr [di],not specpack
	cmp	al,01		;Wang terminal?
	jz	initdw		;jmp if yes
	or	byte ptr [di],specpack
	cmp	al,02		;TC?
	jz	inittc0 	;jmp if yes
c062dmz:			;selection not legal
	mov	di,cmd_parm
	mov	byte ptr [di],0ffh
	jmp	c062dmm
;
c062dm: 			;selection legal
	mov	di,cmd_parm
	mov	byte ptr [di],0
c062dmm:
	mov	di,cmd_sts
	mov	byte ptr [di],0f0h
	ret
;
inittc0:
	jmp	inittc
;
initdw: 	;Reinitialize a port to support Wang terminal which it was
		;set as Wang terminal previously
	cli			;lock
	mov	di,tc_who
	mov	byte ptr es:[di],0		 ;mark TC port on tc_port
;	set ready/busy bits
	mov	di,rbi		;points at R/B byte
	mov	byte ptr [di],48h	;init crt and prt bits to ready state
	mov	di,rbimask	;special mode ready mask
	mov	byte ptr [di],0ffh	;set to all ready
;	init connect/disconnect variables
	mov	di,dsrbyte
	mov	byte ptr [di],03h	;init with connect on
;	init LRBUF and pointers
	call	rstlr
;	init CRT and PRT read/write pointers
	call	rstbufc
	call	rstbufp
	mov	di,txbyte
	or	byte ptr [di],prtstopb	;set prt stop in case no printer
;
	call	port_init_1
	mov	di,imrport		;turn off TC interrupt
	mov	dl,[di]
	xor	dh,dh
	mov	al,033h 		;turn on only rx and tx
	out	dx,al
;
	mov	di,dsrbyte
	or	byte ptr [di],curdsr
	mov	di,usermask
	mov	ax,[di]
	not	ax
	and	es:porttype,ax		;reset the porttype of TC
	jmp	c062dm
;
;
c062e:				;j+ check?
;	*********************************************************
;	Accept the system password from OS, and set it as MXE psw
;	*********************************************************
	xor	ah,ah
	mov	si,psw
	mov	di,cmd_parm
	inc	di			;counter
c062e1:
	mov	al,[di]
	mov	es:[si],al
	or	al,al
	je	ret062e
	inc	di
	inc	si
	inc	ah
	cmp	ah,6
	jb	c062e1
ret062e:
	mov	di,cmd_sts
	mov	byte ptr [di],0f1h
	ret
;
c062f:				;j+ check?
;	*********************************************************
;	Null command without reply 0f1 to OS, for disconnect sake
;	*********************************************************
	 ret
;
port_serv	endp
;
;**********************************************************************
;	Mask off Sep/19/91
;check_dtr	 proc
;	 mov	 bx,es:try_dtr
;	 mov	 di,usermask
;	 test	 bx,[di]
;	 jz	 port_z
;	 call	 entx
;port_z:
;	 ret
;check_dtr	 endp
;	Mask off Sep/19/91, end
;
poll_buf	proc		;j+
;*******************************************************************************
;	 This block looks for a PORT in need of service.
;	 The byte rxbyte contains flags for all 16 ports and bit16, 17 for clock.
;	 Rxbyte sets one bit at a time and each flag is
;	 serviced as they are found set. Also note that rxbyte in gen_store seg.
;	 rxbyte  -  bit0/port0,bit1/port1,...,bit15/port15
;	 rxbyte0 -  bit0/0.1 second int flag, bit1/1 second int flag
;*******************************************************************************
;
	mov	bx,es:rxbyte0
	test	bx,clock_1i		;one second flag?
	jnz	polclk
	mov	bx,es:rxbyte
	mov	di,usermask
	test	bx,[di] 		;Is port asking for service?
	jz	lr_proc 		;No request, go try lr request?
;
;	For TC purpose, Mar/20/91
	mov	di,tc_who
	test	bl,es:[di]		;exactly, the TC port?
	jz	notrans
	call	tranrx
	jmp	oktrans
notrans:
;	For TC purpose, Mar/20/91 End
;
poltoo:
	call	rxin			;Go handling the received buffer
	jnz	lr_proc
oktrans:
	mov	di,usermask		;no more data, turn off
	mov	bx,[di]
	mov	cx,es:rxbyte
	not	bx
	and	cx,bx
	mov	es:rxbyte,cx
;
;	aug/23/91 for windowing
	mov	di,rx_count
	cmp	byte ptr [di],0
	jnz	poltoo
;	aug/23/91 for windowing, buffer again
;
	jmp	lr_proc 		;Next, polling the lr request
polclk:
	test	bx,clockint		;one second int bit set?
	jz	polclk2 		;jump if not set
	call	clocki3 		;service clock check?
	cli
	mov	cx,es:rxbyte0
	and	cx,not clock_1i
	and	cx,not clockint 	;turn off both clock bits
	mov	es:rxbyte0,cx
	sti
	jmp	polclk3
polclk2:
	cli
	and	cx,not clock_1i
	mov	es:rxbyte0,cx
	sti
polclk3:
	mov	di,tc_who
	cmp	byte ptr es:[di],0
	jz	polclk5
	call	clk_1			;check???
polclk5:
	ret
poll_buf	endp
;
lr_proc 	proc			;j+
;*****************************************************************************
;	The main polling loop checks the service request byte "commode" and
;	jumps to here if a bit is set in that byte.  The bit designates
;	wheather a $MXF command has been entered at the terminal or a byte
;	is ready to be processed for a LINE REQUEST.
;	COMMODE & COMMODE0 is mapped as follows:
;	commode  - service request mode, for LR mode, each bit for each port
;	commode0 - service request mode, for $MXF commands
;	The line request service request (commode) should always be
;	checked first as it is much more important AND occurs much more often.
;*****************************************************************************
	mov	cx,es:commode
	mov	di,usermask
	test	cx,[di] 		;Is port asking for LR
	jz	comp			;go polling $MXF commands
;
;	** LR (line request) condition **
	mov	dx,[di]
	not	dx
	and	cx,dx			;turn off this request
	mov	es:commode,cx
;
;	Three possibilities exit here:
;	1. The lr_buf is being printed and crt_buf just went empty or
;	2. A byte is in the key_buf and needs to be serviced
;	3. Printing is done and LR needs to be reset
;
;	Service the empty crt_buf if that is the case. The lr_buf must be
;	printed completely before servicing more bytes from the keyboard.
;
	mov	di,lrbyte
	test	byte ptr [di],lrprtbit		   ;Currently printing lr_buf?
	jz	lrproc3
;	** Need to move more bytes to crt_buf. **
	call	lrout
	jmp	mlrret
;
lrproc3:
;	** If lrbyte is empty then lr_buf needs to be reset **
	cmp	byte ptr [di],0
	jnz	lrproc4 		;jump is still in lr
	call	rstlr			;reset lr_buf check?
	jmp	mlrret
;
lrproc4:
;	** Processing the input from keyboard if the lr is still in progress **
	test	byte ptr [di],lrendbit		   ;lr ended?
	jnz	mlrret			;End!
	call	lredit
mlrret:
	ret
;
comp:
;	************************************************
;	** Execute an $MXF command from this terminal **
;	************************************************
	mov	cx,es:commode0
	mov	di,usermask
	test	cx,[di] 	;Is port asking for $MXF ?
	jz	comret		;Exit if not requesting
	call	move_com	;get a terminal command in "command"
comp2:				;For 06 command
	call	do_com		;Go execute the command
	mov	di,usermask
	mov	dx,[di]
	not	dx
	and	cx,dx
	mov	es:commode0,cx
;	clear the command buffer
	cld					;DF flag = 0, si, di increments
	push	es
	push	ds
	pop	es				;ds = es = user's block
	mov	di,comt_buf
	mov	al,20h
	mov	cx,comt_max - 2
	rep	stosb				;clear com_buf
	pop	es
;
comret:
	ret
lr_proc 	endp
;
;cmd_over	 proc
;	***************************************************************
;	Routine that set the bit of int_event to show cmd (06) is over.
;	***************************************************************
;	 mov	 di,int_event
;	 or	 byte ptr [di],02h	 ;Notice OS 386 commands complete
;	 ret
;cmd_over	 endp
;
include tempini.asm			;cs f000/1d60
include mxfrbuf.asm
include mxfrcmd.asm
include mxfrint.asm			;test h/w
include mxfrlr.asm
include mxfrdat.asm
include mxfgio.asm
;
;	To include those TC files
include mxftc0.asm
include mxftc1.asm
include mxftct.asm
include mxftcn.asm
include mxftcg.asm
include mxftci.asm
include mxftcb.asm
include mxftcx.asm
;
;	org	0fff0h
;	jmp	begin0
;
	code0	ends
	end
;
