

	 PAGE	   60,132
;---------------------------------------------------------------------------+
;									    !
;  (c) Copyright, Wang Laboratories, Inc.,  1990			    !
;	 All rights reserved.						    !
;									    !
;									    !
;    Program name :  WANG 2200 MXF power up diagnostic program		    !
;    File name :     MXFDG.ASM						    !
;    Support group : Enginerring Service Department			    !
;		     Wang Computer (Taiwan) Ltd.			    !
;		     Taiwan, R.O.C.					    !
;									    !
;									    !
;    Revision History : 						    !
;      Date	  Programmer	   Description		     Revision	    !
;    03/04/91	 Milton Chen	    Creation		       5130	    !
;									    !
;    TEST FLOW : [ 1 ]	80286 CPU test					    !
;		 [ 2 ]	SRAM W/R data pattern				    !
;		 [ 3 ]	SRAM address line test				    !
;		 [ 4 ]	SRAM data bus test				    !
;		 [ 5 ]	Chip 2698 UART local loopback test		    !
;		 [ 6 ]	Chip 2698 external loop back test		    !
;		 [ 7 ]	LED test					    !
;									    !
;---------------------------------------------------------------------------+


CODE0	SEGMENT 			   ;@@
	ASSUME	CS:CODE0,DS:CODE0	   ; @@


START:	 CLI
	 JMP	   AFTER_COPY

COPYRIGHT	   DB	     03H				; clear
		   DB	     '         Copyright, Wang Laboratories, Inc.,1991',06H,'      Rev.5130'
		   DB	     0DH,0AH,0DH,0AH,0DH,0AH
		   DB	     0FBH,9H,' MXF 16-Port External Loop Back Run-in Test: '
		   DB	     0DH,0AH,0Dh,0Ah,0FBh,19H,' Channel -  1 : Console',0DH,0AH,'$'

PATN	 DW	   0000H		    ; memory test pattern
	 DW	   0FFFFH
	 DW	   55AAH
	 DW	   0AA55H
	 DW	   0C3D5H
	 DW	   0000H

BOARDMS  DB	   '2236-MXF',4 DUP(20H)    ; description 12 char.
BOARDMSL EQU	   $-BOARDMS

BOARDST  EQU	   404H 		    ; pass store 'F0'
BOARDID  EQU	   405H 		    ; 2236-MXF =>0 ID

DESADDR  EQU	   406H 		    ; description store addr. 406H-415H
REV	 EQU	   416H 		    ; 416H-417H  EPROM rev.

INTBIT	 EQU	   41FH 		    ; interrupt semaphore bit
RESULT	 EQU	   420H 		    ; test status bit

CLRPORT  EQU	   8002H		    ; clear 386 interrupt port
INTPORT  EQU	   8000H		    ; int 286 port

RONUART  EQU	   9AH			    ; UART board red on data
ROFFUART EQU	   8AH			    ; UART board red on data


CHAN1B	 DB	   0FBH,19H,' Channel -  3 : ','$'
CHAN1C	 DB	   0FBH,19H,' Channel -  2 : ','$'
CHAN1D	 DB	   0FBH,19H,' Channel -  4 : ','$'
CHAN1E	 DB	   0FBH,19H,' Channel -  5 : ','$'     ; 'FB'=> 14 dup(' ')
CHAN1F	 DB	   0FBH,19H,' Channel -  6 : ','$'
CHAN1G	 DB	   0FBH,19H,' Channel -  7 : ','$'
CHAN1H	 DB	   0FBH,19H,' Channel -  8 : ','$'
CHAN2A	 DB	   0FBH,19H,' Channel -  9 : ','$'
CHAN2B	 DB	   0FBH,19H,' Channel - 10 : ','$'
CHAN2C	 DB	   0FBH,19H,' Channel - 11 : ','$'
CHAN2D	 DB	   0FBH,19H,' Channel - 12 : ','$'
CHAN2E	 DB	   0FBH,19H,' Channel - 13 : ','$'
CHAN2F	 DB	   0FBH,19H,' Channel - 14 : ','$'
CHAN2G	 DB	   0FBH,19H,' Channel - 15 : ','$'
CHAN2H	 DB	   0FBH,19H,' Channel - 16 : ','$'

PASS	 DB	   0EH,'PASS',0FH,0DH,0AH,'$'
FAIL	 DB	   'FAIL',0DH,0AH,'$'


;--------------------------   BAUD SETTING PORT   -------------------------------

BAUD1AB  EQU	   0180H		    ; channel 1A & 1B, A8=A7=1, A3 - A1= '000 - 111'
BAUD1CD  EQU	   0182H		    ; channel 1C & 1D,
BAUD1EF  EQU	   0184H		    ; channel 1E & 1F
BAUD1GH  EQU	   0186H		    ; channel 1G & 1H
BAUD2AB  EQU	   0188H		    ; channel 2A & 2B
BAUD2CD  EQU	   018AH		    ; channel 2C & 2D
BAUD2EF  EQU	   018CH		    ; channel 2E & 2F
BAUD2GH  EQU	   018EH		    ; channel 2G & 2H


;----------------------------	UART-2698 PORT	 ----------------------------------------+
;											 |
;  Port:										 |
;					    ; "-" don't care                             |
;     d7  d6  d5  d4  d3  d2  d1  d0	    ; A0 - A3 2698 data sheet, regs addressing	 |
;     B7  B6  B5  A3  A2  A1  A0   -	    ; B5 - B7 program note '000 - 111'           |
;											 |
;----------------------------------------------------------------------------------------+


;=============================	  UART 1A     =============================

MR1A	 EQU	   0H			    ; two mode registers share one port and set TX/RX format
SR1A	 EQU	   2H			    ; status register
CSR1A	 EQU	   2H			    ; RXC/TXC source selection
CR1A	 EQU	   4H			    ; command register
RHR1A	 EQU	   6H			    ; receiver holding register
THR1A	 EQU	   6H			    ; transmitter holding register
IPCR1AB  EQU	   8H			    ; input port change register
ACR1AB	 EQU	   8H			    ; aux. control reg., select baudrate set, MPI cause int
ISR1AB	 EQU	   0AH			    ; interrupt status register, check int source
IMR1AB	 EQU	   0AH			    ; interrupt mask register, out only
CTU1AB	 EQU	   0CH			    ; C/T upper byte
CTUR1AB  EQU	   0CH			    ; C/T upper register
CTL1AB	 EQU	   0EH			    ; C/T lower register
CTLR1AB  EQU	   0EH			    ; C/T lower register

;=============================	  UART 1B     =============================

MR1B	 EQU	   10H
SR1B	 EQU	   12H
CSR1B	 EQU	   12H
CR1B	 EQU	   14H
RHR1B	 EQU	   16H
THR1B	 EQU	   16H
IP1AB	 EQU	   1AH
OPCR1AB  EQU	   1AH			    ; O/P port configuration register
START1AB EQU	   1CH			    ; I/P to start C/T
STOP1AB  EQU	   1EH			    ; I/P to stop C/T

;=============================	  UART 1C     =============================

MR1C	 EQU	   20H
SR1C	 EQU	   22H
CSR1C	 EQU	   22H
CR1C	 EQU	   24H
RHR1C	 EQU	   26H
THR1C	 EQU	   26H
IPCR1CD  EQU	   28H
ACR1CD	 EQU	   28H
ISR1CD	 EQU	   2AH
IMR1CD	 EQU	   2AH
CTU1CD	 EQU	   2CH			    ; I/P
CTUR1CD  EQU	   2CH			    ; O/P
CTL1CD	 EQU	   2EH
CTLR1CD  EQU	   2EH

;=============================	  UART 1D     =============================

MR1D	 EQU	   30H
MR1D	 EQU	   30H
SR1D	 EQU	   32H
CSR1D	 EQU	   32H
CR1D	 EQU	   34H
RHR1D	 EQU	   36H
THR1D	 EQU	   36H
IP1CD	 EQU	   3AH			    ; I/P port
OPCR1CD  EQU	   3AH			    ; O/P port configuration register
START1CD EQU	   3CH			    ; read to start C/T
STOP1CD  EQU	   3EH			    ; read to stop C/T

;=============================	  UART 1E     =============================

MR1E	 EQU	   40H
SR1E	 EQU	   42H
CSR1E	 EQU	   42H
CR1E	 EQU	   44H
RHR1E	 EQU	   46H
THR1E	 EQU	   46H
IPCR1EF  EQU	   48H			    ; I/P
ACR1EF	 EQU	   48H			    ; O/P
ISR1EF	 EQU	   4AH
IMR1EF	 EQU	   4AH
CTU1EF	 EQU	   4CH
CTUR1EF  EQU	   4CH
CTL1EF	 EQU	   4EH
CTLR1EF  EQU	   4EH

;=============================	  UART 1F     =============================

MR1F	 EQU	   50H
SR1F	 EQU	   52H
CSR1F	 EQU	   52H
CR1F	 EQU	   54H			    ; UART LED port
RHR1F	 EQU	   56H
THR1F	 EQU	   56H
IP1EF	 EQU	   5AH			    ; I/P port
OPCR1EF  EQU	   5AH			    ; O/P port configuration register
START1EF EQU	   5CH			    ; read to start C/T
STOP1EF  EQU	   5EH			    ; read to stop C/T

;=============================	  UART 1G     =============================

MR1G	 EQU	   60H
SR1G	 EQU	   62H
CSR1G	 EQU	   62H
CR1G	 EQU	   64H
RHR1G	 EQU	   66H
THR1G	 EQU	   66H
IPCR1GH  EQU	   68H			    ; I/P
ACR1GH	 EQU	   68H			    ; O/P
ISR1GH	 EQU	   6AH
IMR1GH	 EQU	   6AH
CTU1GH	 EQU	   6CH
CTUR1GH  EQU	   6CH
CTL1GH	 EQU	   6EH
CTLR1GH  EQU	   6EH

;=============================	  UART 1H     =============================

MR1H	 EQU	   70H
SR1H	 EQU	   72H
CSR1H	 EQU	   72H
CR1H	 EQU	   74H
RHR1H	 EQU	   76H
THR1H	 EQU	   76H
IP1GH	 EQU	   7AH			    ; I/P port
OPCR1GH  EQU	   7AH			    ; O/P port configuration register
START1GH EQU	   7CH			    ; read to start C/T
STOP1GH  EQU	   7EH			    ; read to stop C/T

;=============================	  UART 2A     =============================

MR2A	 EQU	   80H			    ; mode register to set TX/RX format
SR2A	 EQU	   82H			    ; status register
CSR2A	 EQU	   82H			    ; RXC/TXC source selection
CR2A	 EQU	   84H			    ; command register
RHR2A	 EQU	   86H			    ; receiver holding register
THR2A	 EQU	   86H			    ; transmitter holding register
IPCR2AB  EQU	   88H			    ; input port change register
ACR2AB	 EQU	   88H			    ; aux. control reg., select baudrate, C/T, MPI cause int?
ISR2AB	 EQU	   8AH			    ; interrupt status register, check int source
IMR2AB	 EQU	   8AH			    ; interrupt mask register, out only
CTU2AB	 EQU	   8CH			    ; C/T upper byte
CTUR2AB  EQU	   8CH			    ; C/T upper register
CTL2AB	 EQU	   8EH			    ; C/T lower register
CTLR2AB  EQU	   8EH			    ; C/T lower register

;=============================	  UART 2B     =============================

MR2B	 EQU	   90H
SR2B	 EQU	   92H
CSR2B	 EQU	   92H
CR2B	 EQU	   94H
RHR2B	 EQU	   96H
THR2B	 EQU	   96H
IP2AB	 EQU	   9AH
OPCR2AB  EQU	   9AH			    ; O/P port configuration register
START2AB EQU	   9CH			    ; I/P to start C/T
STOP2AB  EQU	   9EH			    ; I/P to stop C/T

;=============================	  UART 2C     =============================

MR2C	 EQU	   0A0H
SR2C	 EQU	   0A2H
CSR2C	 EQU	   0A2H
CR2C	 EQU	   0A4H
RHR2C	 EQU	   0A6H
THR2C	 EQU	   0A6H
IPCR2CD  EQU	   0A8H
ACR2CD	 EQU	   0A8H
ISR2CD	 EQU	   0AAH
IMR2CD	 EQU	   0AAH
CTU2CD	 EQU	   0ACH 		    ; I/P
CTUR2CD  EQU	   0ACH 		    ; O/P
CTL2CD	 EQU	   0AEH
CTLR2CD  EQU	   0AEH

;=============================	  UART 2D     =============================

MR2D	 EQU	   0B0H
MR2D	 EQU	   0B0H
SR2D	 EQU	   0B2H
CSR2D	 EQU	   0B2H
CR2D	 EQU	   0B4H
RHR2D	 EQU	   0B6H
THR2D	 EQU	   0B6H
IP2CD	 EQU	   0BAH 		    ; I/P port
OPCR2CD  EQU	   0BAH 		    ; O/P port configuration register
START2CD EQU	   0BCH 		    ; read to start C/T
STOP2CD  EQU	   0BEH 		    ; read to stop C/T

;=============================	  UART 2E     =============================

MR2E	 EQU	   0C0H
SR2E	 EQU	   0C2H
CSR2E	 EQU	   0C2H
CR2E	 EQU	   0C4H
RHR2E	 EQU	   0C6H
THR2E	 EQU	   0C6H
IPCR2EF  EQU	   0C8H 		    ; I/P
ACR2EF	 EQU	   0C8H 		    ; O/P
ISR2EF	 EQU	   0CAH
IMR2EF	 EQU	   0CAH
CTU2EF	 EQU	   0CCH
CTUR2EF  EQU	   0CCH
CTL2EF	 EQU	   0CEH
CTLR2EF  EQU	   0CEH

;=============================	  UART 2F     =============================

MR2F	 EQU	   0D0H
SR2F	 EQU	   0D2H
CSR2F	 EQU	   0D2H
CR2F	 EQU	   0D4H
RHR2F	 EQU	   0D6H
THR2F	 EQU	   0D6H
IP2EF	 EQU	   0DAH 		    ; I/P port
OPCR2EF  EQU	   0DAH 		    ; O/P port configuration register
START2EF EQU	   0DCH 		    ; read to start C/T
STOP2EF  EQU	   0DEH 		    ; read to stop C/T

;=============================	  UART 2G     =============================

MR2G	 EQU	   0E0H
SR2G	 EQU	   0E2H
CSR2G	 EQU	   0E2H
CR2G	 EQU	   0E4H
RHR2G	 EQU	   0E6H
THR2G	 EQU	   0E6H
IPCR2GH  EQU	   0E8H 		    ; I/P
ACR2GH	 EQU	   0E8H 		    ; O/P
ISR2GH	 EQU	   0EAH
IMR2GH	 EQU	   0EAH
CTU2GH	 EQU	   0ECH
CTUR2GH  EQU	   0ECH
CTL2GH	 EQU	   0EEH
CTLR2GH  EQU	   0EEH

;=============================	  UART 2H     =============================

MR2H	 EQU	   0F0H
SR2H	 EQU	   0F2H
CSR2H	 EQU	   0F2H
CR2H	 EQU	   0F4H
RHR2H	 EQU	   0F6H
THR2H	 EQU	   0F6H
IP2GH	 EQU	   0FAH 		    ; I/P port
OPCR2GH  EQU	   0FAH 		    ; O/P port configuration register
START2GH EQU	   0FCH 		    ; read to start C/T
STOP2GH  EQU	   0FEH 		    ; read to stop C/T


AFTER_COPY:
	 MOV	   AX,CS		    ; DS <= CS
	 MOV	   DS,AX

LED	 MACRO	   ONOFF,PORT		    ; LED MACRO
	 MOV	   AX,ONOFF
	 MOV	   DX,PORT
	 OUT	   DX,AX
ENDM


;----------------    TEST 1  Semaphore Area Memory Test  ---------------+
;									|
;	Memory test 4KB for semaphore area.				|
;									|
;	     41F => 11H -- 386 interrupt 286				|
;	     420 => 20H -- error					|
;		    40H -- run-in mode, pass				|
;		    80H -- pass 					|
;		    60H -- 1A channel no CRT				|
;									|
;	BEGIN								|
;		 FOR  J = 6  ( six patterns )				|
;		       WRITE memory flood 2k words			|
;		       READ verify data 				|
;		 NEXT  J						|
;	END					    error code : 01	|
;									|
;-----------------------------------------------------------------------+


	 MOV	   DX,0
	 MOV	   ES,DX		    ; ES <= 0100:0000

	 LEA	   BX,PATN		    ; point to test pattern
	 MOV	   SI,6 		    ; test two pattern

NXTPN1:  XOR	   DI,DI		    ; DI <= 0
	 CLD
	 MOV	   CX,800H		    ; 2K words (times), 4K bytes
	 MOV	   AX,[BX]
    REP  STOSW				    ; flood with pattern

	 XOR	   DI,DI		    ; DI <= 0
	 MOV	   CX,800H		    ; counter
RDATA1:
	 MOV	   AX,ES:[DI]		    ; read data
	 XOR	   AX,[BX]
	 JZ	   NEXTWORD1		    ; if equal test next byte

	 JMP	   ERR			    ; nonequal error display

NEXTWORD1:
	 INC	   DI
	 INC	   DI			    ; point next word
	 LOOP	   RDATA1

	 INC	   BX
	 INC	   BX
	 DEC	   SI
	 JNZ	   NXTPN1		    ; point next pattern

	 JMP	   CPUTEST

ERR:	 MOV	   BP,01H
	 MOV	   AL,21H
	 JMP	   ERRST


;------------------    TEST 2	80286 CPU TEST	  -------------------------+
;									   |
;	 CPU 80286 : Flag - SF,CF,ZF,AF,PF test 			   |				       |
;		     General Reg, & Segment test       error code : 02	   |
;									   |
;--------------------------------------------------------------------------+


CPUTEST: MOV	   AH,0D5H		    ; set SF,CF,ZF,AF flags on
	 SAHF				    ; store AH to flag reg.
	 JNC	   FATAL_ERROR		    ; error if CF not set
	 JNZ	   FATAL_ERROR		    ; error if ZF not set
	 JNP	   FATAL_ERROR		    ; error if PF not set
	 JNS	   FATAL_ERROR		    ; error if SF not set
	 LAHF				    ; load flag to AH
	 MOV	   CL,5 		    ; shift count
	 SHR	   AH,CL		    ; shift AF into CARRY bit
	 JNC	   FATAL_ERROR		    ; error if no carry
	 MOV	   AL,40H		    ; set flag on
	 SHL	   AL,1 		    ; set up for test
	 JNO	   FATAL_ERROR		    ; error if overflow
	 XOR	   AH,AH		    ; AH=0
	 SAHF
	 JBE	   FATAL_ERROR		    ; error if CF on

	 JS	   FATAL_ERROR		    ; error if SIGN flag set
	 JP	   FATAL_ERROR		    ; error if EVEN Parity set
	 LAHF				    ; load flag to AH
	 MOV	   CL,5 		    ; shift count
	 SHR	   AH,CL
	 JC	   FATAL_ERROR		    ; error if CF on
	 SHL	   AH,1 		    ; check OF is clear
	 JO	   FATAL_ERROR		    ; error if OF on

	 XOR	   AX,AX		    ; test reset condition & flags
	 JNZ	   FATAL_ERROR		    ; check zero flag off
	 OR	   AX,1
	 JZ	   FATAL_ERROR		    ; check zero flag on
	 AND	   AX,AX
	 JC	   FATAL_ERROR		    ; test carry, error if carry flag not cleared
	 STC				    ; set carry flag
	 JNC	   FATAL_ERROR		    ; error if not carry
	 CLC				    ; clear carry flag
	 JC	   FATAL_ERROR		    ; error if carry flag is not clear
	 CMC				    ; complement carry flag
	 JNC	   FATAL_ERROR		    ; error if no carry

	 MOV	   AX,1 		    ; store 1 to EAX Reg.
	 MOV	   CX,7 		    ; count times
LP1:	 AND	   AX,AX		    ; set flag
	 JZ	   FATAL_ERROR		    ; error if ZERO flag set
	 JS	   FATAL_ERROR		    ; error if SIGN flag set
	 JPE	   FATAL_ERROR		    ; error if EVEN Parity, b0 - b7
	 JC	   FATAL_ERROR		    ; error if CARRY
	 RCL	   AX,1
	 LOOP	   LP1


;----------- R/W GENERAL AND SEGMENT REGS. -------------


	 MOV	   AX,55AAH		    ; AX <= FFFFH, pattern
	 STC				    ; set carry flag
LP2:	 MOV	   DS,AX		    ; write to all regs.
	 MOV	   BX,DS
	 MOV	   ES,BX
	 MOV	   CX,ES
	 MOV	   SS,CX
	 MOV	   DX,SS
	 MOV	   SP,DX
	 MOV	   BP,SP
	 MOV	   SI,BP
	 MOV	   DI,SI
	 MOV	   DI,SI
	 JNC	   LP3
	 XOR	   AX,DI
	 JNZ	   FATAL_ERROR
	 CLC
	 JMP	   LP2

LP3:
	 OR	   AX,DI		    ; zero pattern thru all regs.
	 JZ	   TST2

FATAL_ERROR:
	 MOV	   BP,02H		    ; error code 01 => BP
	 MOV	   AL,22H

ERRST:	 XOR	   SI,SI
	 MOV	   ES,SI
	 MOV	   ES:[RESULT],AL

FERROR:  LED	   RONUART,CR1F 	    ; red led on to inidicate test error
	 XOR	   CX,CX
ON1:	 AAM
	 AAM
	 AAM
	 LOOP	   ON1

	 LED	   ROFFUART,CR1F
	 XOR	   CX,CX
OFF1:	 AAM
	 AAM
	 LOOP	   OFF1

	 JMP	   FERROR


;---------------------	 TEST - 3 SRAM Write/Read TEST	 ---------------------+
;									      |
;	  BEGIN 							      |
;	      FOR I = 6  ( four banks, bank = 64k bytes )		      |
;		FOR  J = 2  ( two pattern 55AA, AA55 )			      |
;		    WRITE memory flood 32K words			      |
;		    READ  verify content data				      |
;		NEXT J	( next pattern )				      |      |
;	      NEXT I   ( next bank 0:0000 - 3:FFFF )			      |
;	  END						  error code : 03     |
;									      |
;-----------------------------------------------------------------------------+


TST2:					    ; @@
	 PUSH	   CS			    ; DS <= CS
	 POP	   DS

	 MOV	   DX,100H
NXTBK:	 MOV	   ES,DX		    ; ES <= 0100:0000

	 LEA	   BX,PATN		    ; point to test pattern
	 MOV	   SI,6 		    ; test two pattern

NXTPN:	 XOR	   DI,DI		    ; DI <= 0
	 CLD
	 MOV	   CX,800H		    ; 2K words (times), 4K bytes
	 MOV	   AX,[BX]
    REP  STOSW				    ; flood with pattern

	 XOR	   DI,DI		    ; DI <= 0
	 MOV	   CX,800H		    ; counter
RDATA:
	 MOV	   AX,ES:[DI]		    ; read data
	 XOR	   AX,[BX]
	 JZ	   NEXTWORD		    ; if equal test next byte

	 JMP	   ERROR2		    ; nonequal error display

NEXTWORD:
	 INC	   DI
	 INC	   DI			    ; point next word
	 LOOP	   RDATA

	 INC	   BX
	 INC	   BX
	 DEC	   SI
	 JNZ	   NXTPN		    ; point next pattern

	 ADD	   DX,100H		    ; check next 4k bank
	 CMP	   DX,4000H		    ; 0100:0000 - 4000:0000
	 JNE	   NXTBK
	 JMP	   INISTAK

ERROR2:
	 MOV	   BP,0003H
	 MOV	   AL,23H
	 JMP	   ERRST


;------------------    INITIAL STACK	  ---------------------

INISTAK: MOV	   AX,40H		    ; setup stack 40:80
	 MOV	   SS,AX

	 MOV	   AX,80H
	 MOV	   SP,AX

	 XOR	   SI,SI		    ; initial message
	 MOV	   DS,SI

	 MOV	   AL,00H		    ; ID: 0 MXF
	 MOV	   BYTE PTR DS:[BOARDID],AL
	 MOV	   BYTE PTR DS:[REV],1	    ; REV 01.00
	 MOV	   BYTE PTR DS:[REV+1],0

	 MOV	   ES,SI		    ; store description
	 MOV	   DI,DESADDR		    ; ES:DI <= DS:SI
	 LEA	   SI,BOARDMS
	 MOV	   AX,CS
	 MOV	   DS,AX
	 MOV	   CL,BOARDMSL
	 REP	 MOVSB

	 XOR	   SI,SI
	 MOV	   DS,SI

	 MOV	   CX,256
LP:	 MOV	   WORD PTR DS:[SI],OFFSET NULRT
	 ADD	   SI,2
	 MOV	   WORD PTR DS:[SI],0F000H
	 ADD	   SI,2
	 LOOP	   LP

	 JMP	   T5

NULRT:	 IRET

;-----------------   TEST - 4  SRAM DATA BUS TEST    --------------------------+
;									       |
;	BEGIN								       |
;	     FOR current bank = first to last				       |
;		    Current address = first in current bank		       |
;		    FOR current pattern = 0000h, 0001h, 0002h, 0004h, ...,     |
;					  8000h, 0ffffh, 0fffeh, 0fffdh,       |
;					  ..., 7fffh			       |
;			Write current pattern to current address	       |
;			  Read/Verify current address			       |
;		    NEXT pattern					       |
;	     NEXT bank							       |
;	END						 error code : 04       |
;									       |
;------------------------------------------------------------------------------+


T5:					    ; test pattern 0000 - 8000
	 XOR	   SI,SI		    ; start address = 100:0000h
	 MOV	   DI,100H

LP51:	 MOV	   AX,DI		    ; start test from the first bank
	 MOV	   DS,AX

	 MOV	   BX,0000H		    ; BX = current test pattern
	 MOV	   AX,0001H		    ; AX = next test pattern
	 MOV	   DX,AX		    ; DX = save next test pattern

	 MOV	   CX,16		    ; CX = pattern counter (0000h - 8000h) = 15
	 MOV	   [SI],BX		    ; write current pattern to current address
LP52:
	 XCHG	   [SI],AX		    ; read current pattern/write next pattern from/to
	 CMP	   AX,BX		    ; current address then verify the pattern
	 JNE	   ERROR4
	 MOV	   BX,DX		    ; update BX (current pattern) = next pattern
	 SHL	   DX,1 		    ; upgrade the next pattern
	 MOV	   AX,DX		    ; upgrade AX (next pattern)
	 DEC	   CX			    ; decrease the pattern counter
	 JNZ	   LP52 		    ; loop back to test next pattern

	 ADD	   DI,100H		    ; point to next bank
	 CMP	   DI,4000H		    ; if 64K memory be tested
	 JNE	   LP51

LP53:					    ; test pattern 0FFFF - 7FFF
	 XOR	   SI,SI		    ; start address = 0:0000h
	 MOV	   DI,100H

LP54:	 MOV	   AX,DI		    ; start test from the first bank
	 MOV	   DS,AX

	 MOV	   BX,0FFFFH		    ; BX = current test pattern
	 MOV	   AX,0FFFEH		    ; AX = next test pattern
	 MOV	   DX,AX		    ; DX = save next test pattern
	 MOV	   CX,16		    ; CX = pattern counter (0FFFFH - 7FFFh) = 15
	 MOV	   [SI],BX		    ; write current pattern to current address

LP55:
	 XCHG	   [SI],AX		    ; read current pattern/write next pattern from/to
	 CMP	   AX,BX		    ; current address then verify the pattern
	 JNE	   ERROR4
	 MOV	   BX,DX		    ; update BX (current pattern) = next pattern
	 SHL	   DX,1 		    ; upgrade the next pattern
	 MOV	   AX,DX		    ; upgrade AX (next pattern)
	 DEC	   CX			    ; decrease the pattern counter
	 JNE	   LP55 		    ; loop back to test next pattern

	 ADD	   DI,100H		    ; point to next bank
	 CMP	   DI,4000H		    ; if 64K memory be tested
	 JNE	   LP54

	 JMP	   T6

ERROR4:
	 MOV	   BP,0004H
	 MOV	   AL,24H
	 JMP	   ERRST



;------------------   TEST - 5	UART 2698 LOCAL LOOP BACK TEST	----------------+
;										|
;	  This is Chip 2698 UART internal loop back test under local loopback	|
;    mode, the transmitter output is internally connected to the receiver	|
;    input. The transmit clock is used for the receiver. The transmitter must	|
;    be enabled.								|
;										|
;	  Macro Initial 							|
;	     MR1 <-- odd parity, 8 bit data.					|
;	     MR2 <-- local loop mode, 1 stop bit.				|
;	     CSR <-- Tx & Rx set 19200bps					|
;	     CR  <-- reset MR, disable Tx,Rx					|
;	     ACR <-- select baud set.						|
;	  End Macro initial							|
;										|
;	  Macro Local loop test 						|
;	     For I = 20H to 80H 						|
;		sent out data							|
;		IF Rx ready							|
;		    then read data						|
;		  ELSE wait again read status					|
;		      IF equal then next data	     1st chip error code : 05	|
;		      ELSE error						|
;		ENDIF				     2nd chip error code : 06	|
;	     Next I								|
;	  End Macro								|
;										|
;-------------------------------------------------------------------------------+

T6:
INILB  MACRO   MR,CSR,CR,ACR		    ; Initial Macro

	 MOV	   AL,07H		    ; RXINT=RXRDY, 8 bit data, odd parity
	 OUT	   MR,AL
	 NOP
	 MOV	   AL,87H		    ; local-loop mode, 1 stop bit
	 OUT	   MR,AL

	 MOV	   AL,0CCH		    ; 19200bps
	 OUT	   CSR,AL		    ; set baud rate

	 MOV	   AL,15H		    ; reset MR pointer, enable TX/RX
	 OUT	   CR,AL

	 MOV	   AL,0F0H
	 OUT	   ACR,AL		    ; select baud rate set = 1

       ENDM


 INILB	   MR1A,CSR1A,CR1A,ACR1AB	    ; initial 1A channel
 INILB	   MR1B,CSR1B,CR1B,ACR1AB	    ; initial 1B channel

 INILB	   MR1C,CSR1C,CR1C,ACR1CD	    ; initial 1C channel
 INILB	   MR1D,CSR1D,CR1D,ACR1CD	    ; initial 1D channel

 INILB	   MR1E,CSR1E,CR1E,ACR1EF	    ; initial 1E channel
 INILB	   MR1F,CSR1F,CR1F,ACR1EF	    ; initial 1F channel

 INILB	   MR1G,CSR1G,CR1G,ACR1GH	    ; initial 1G channel
 INILB	   MR1H,CSR1H,CR1H,ACR1GH	    ; initial 1H channel


 INILB	   MR2A,CSR2A,CR2A,ACR2AB	    ; initial 2A channel
 INILB	   MR2B,CSR2B,CR2B,ACR2AB	    ; initial 2B channel

 INILB	   MR2C,CSR2C,CR2C,ACR2CD	    ; initial 2C channel
 INILB	   MR2D,CSR2D,CR2D,ACR2CD	    ; initial 2D channel

 INILB	   MR2E,CSR2E,CR2E,ACR2EF	    ; initial 2E channel
 INILB	   MR2F,CSR2F,CR2F,ACR2EF	    ; initial 2F channel

 INILB	   MR2G,CSR2G,CR2G,ACR2GH	    ; initial 2G channel
 INILB	   MR2H,CSR2H,CR2H,ACR2GH	    ; initial 2H channel



LOPTEST    MACRO  THR,SR,RHR,ERROR	    ; local loopback test Macro
	   LOCAL  NXT,AG,NXCHAR

	 CLI
	 MOV	   BL,20H		    ; sent data from 20h
NXT:	 MOV	   AL,BL
	 OUT	   THR,AL
	 JMP	   $+2			    ; delay time
AG:	 IN	   AL,SR		    ; read status
	 TEST	   AL,01H		    ; Rx ready ?
	 JZ	   AG			    ; no, wait again
	 IN	   AL,RHR		    ; yes, read data

	 CMP	   AL,0F8H
	 JE	   AG
	 CMP	   AL,BL
	 JE	   NXCHAR
	 CMP	   AL,BL		    ; compare

	 JE	   NXCHAR		    ; next char if equal
	 JMP	   ERROR		    ; error
NXCHAR:  INC	   BL
	 CMP	   BL,80H		    ; til data = 80H
	 JNZ	   NXT

	   ENDM      LOPTEST

;	 CLI
;	 MOV	   BL,20H		    ; sent data from 20h
;NXTT1:  MOV	   AL,BL
;	 OUT	   THR1A,AL
;	 JMP	   $+2			    ; delay time
;AG1:	 IN	   AL,SR1A		    ; read status
;	 TEST	   AL,01H		    ; Rx ready ?
;	 JZ	   AG1			    ; no, wait again
;	 IN	   AL,RHR1A		    ; yes, read data
;	 CMP	   AL,0F8H		    ; compare, F8 crt control code
;	 JE	   AG1
;	 CMP	   AL,BL
;	 JE	   NXCHAR1		    ; next char if equal
;	 JMP	   ERROR5		    ; error
;NXCHAR1: INC	    BL
;	 CMP	   BL,80H		    ; til data = 80H
;	 JNZ	   NXTT1


	 LOPTEST  THR1B,SR1B,RHR1B,ERROR5
	 LOPTEST  THR1C,SR1C,RHR1C,ERROR5
	 LOPTEST  THR1D,SR1D,RHR1D,ERROR5
	 LOPTEST  THR1E,SR1E,RHR1E,ERROR5
	 LOPTEST  THR1F,SR1F,RHR1F,ERROR5
	 LOPTEST  THR1G,SR1G,RHR1G,ERROR5
	 LOPTEST  THR1H,SR1H,RHR1H,ERROR5

	 LOPTEST  THR2A,SR2A,RHR2A,ERROR6   ; test 2nd chip
	 LOPTEST  THR2B,SR2B,RHR2B,ERROR6
	 LOPTEST  THR2C,SR2C,RHR2C,ERROR6
	 LOPTEST  THR2D,SR2D,RHR2D,ERROR6
	 LOPTEST  THR2E,SR2E,RHR2E,ERROR6
	 LOPTEST  THR2F,SR2F,RHR2F,ERROR6
	 LOPTEST  THR2G,SR2G,RHR2G,ERROR6
	 LOPTEST  THR2H,SR2H,RHR2H,ERROR6


;--------------------  Setup Interrupt vector -----------------

	 MOV	   DX,0
	 MOV	   ES,DX

	 MOV	   DI,40H*4		    ; int 40H

	 MOV	   AX,OFFSET INTSR40	    ; IP
	 STOSW
	 MOV	   AX,0F000H		    ; CS
	 STOSW

	 MOV	   DI,60H*4

	 MOV	   AX,OFFSET INTSR60
	 STOSW				    ; 60H*4 => IP
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR61
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR62
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR63
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR64
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR65
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR66
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 MOV	   AX,OFFSET INTSR67
	 STOSW
	 MOV	   AX,0F000H
	 STOSW

	 JMP	   EXTUART

ERROR5:
	 MOV	   BP,0005H		    ; error code 05 => BP
	 MOV	   AL,25H
	 JMP	   ERRST

ERROR6:
	 MOV	   BP,0006H		    ; error code 06 => BP
	 MOV	   AL,26H
	 JMP	   ERRST


;-------------------  Interrupt Service Routine 60 - 67 ---------------------+
;									     |
;     Interrupt 60 - 67 occurs at each channel receieve data.		     |
;	Check interrupt status register to sense interrupt type.	     |
;	   Begin							     |
;	       read status register					     |
;	       if RxRDY 						     |
;		   then check read data 				     |
;		      if correct then return				     |
;			 else error occurrence set carry flag		     |
;	       else read another channel status register		     |
;		   if RxRDY						     |
;		      then check read data				     |
;			 if correct then return 			     |
;			 else error occurrence set carry flag		     |
;		endif							     |
;	   end								     |	       |
;									     |
;----------------------------------------------------------------------------+


INTSR60:
	 PUSH	   AX
	 PUSH	   BX
CHK1A:	 IN	   AL,SR1A		    ; in status, channel 1A
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL		    ; b2=0, TxRDY not ready, chk int source
	 IN	   AL,RHR1A
	 CMP	   AL,BL
	 JNE	   RXERR
	 JMP	   RTN
CHKAL:	 IN	   AL,SR1B		    ; read ISR
	 TEST	   AL,01H		    ; time out int?
	 JZ	   RXERR		    ; error
	 IN	   AL,RHR1B
	 CMP	   AL,BL
	 JNE	   RXERR
RTN:	 POP	   BX
	 POP	   AX
	 IRET

RXERR:
	 POP	   BX
	 POP	   AX
	 STC				    ; set carry flag
	 IRET

;--------------------------------------------------------------------

INTSR61:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR1C		    ; in status, check channel 1C
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL1		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,RHR1C
	 CMP	   AL,BL
	 JNE	   RXERR1
	 JMP	   RTN1
CHKAL1:  IN	   AL,SR1D		    ; check channel 1D.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   RXERR1		    ; b2=0, TxRDY not ready, check int source
	 IN	   AL,RHR1D
	 CMP	   AL,BL
	 JNE	   RXERR1
RTN1:	 POP	   BX
	 POP	   AX
	 IRET

RXERR1:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET

;-----------------------------------------------------------------------------


INTSR62:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR1E		    ; in status, check channel 1E
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL2		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,RHR1E
	 CMP	   AL,BL
	 JNE	   RXERR2
	 JMP	   RTN2

CHKAL2:  IN	   AL,SR1F		    ; check channel 1F.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   RXERR2		    ; b2=0, TxRDY not ready, check int source
	 IN	   AL,RHR1F
	 CMP	   AL,BL
	 JNE	   RXERR2
RTN2:	 POP	   BX
	 POP	   AX
	 IRET

RXERR2:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET

;----------------------------------------------------------------------------

INTSR63:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR1G		    ; in status, check channel 1G
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL3		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,RHR1G
	 CMP	   AL,BL
	 JNE	   RXERR3
	 JMP	   RTN3
CHKAL3:  IN	   AL,SR1H		    ; check channel 1H.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   RXERR3		    ; b2=0, TxRDY not ready, check int source
	 IN	   AL,RHR1H
	 CMP	   AL,BL
	 JNE	   RXERR3
RTN3:	 POP	   BX
	 POP	   AX
	 IRET

RXERR3:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET

;----------------------------------------------------------------------


INTSR64:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR2A		    ; in status, check channel 2A
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL4		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,RHR2A
	 CMP	   AL,BL
	 JNE	   RXERR4
	 JMP	   RTN4

CHKAL4:  IN	   AL,SR2B		    ; check channel 2B.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   RXERR4		    ; b2=0, TxRDY not ready, check int source
	 IN	   AL,RHR2B
	 CMP	   AL,BL
	 JNE	   RXERR4
RTN4:	 POP	   BX
	 POP	   AX
	 IRET

RXERR4:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET


;----------------------------------------------------------------------------


INTSR65:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR2C		    ; in status, check channel 2C
	 TEST	   AL,01H		       ; RxRDY ?
	 JZ	   CHKAL5		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,RHR2C
	 CMP	   AL,BL
	 JNE	   RXERR5
	 JMP	   RTN5

CHKAL5:  IN	   AL,SR2D		    ; check channel 2D.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   RXERR5		   ; b2=0, TxRDY not ready, check int source
	 IN	   AL,RHR2D
	 CMP	   AL,BL
	 JNE	   RXERR5
RTN5:	 POP	   BX
	 POP	   AX
	 IRET

RXERR5:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET


;----------------------------------------------------------------------------


INTSR66:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR2E		    ; in status, check channel 2E
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL6		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,RHR2E
	 CMP	   AL,BL
	 JNE	   RXERR6
	 JMP	   RTN6
CHKAL6:  IN	   AL,SR2F		    ; check channel 2F.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   RXERR6		    ; b2=0, TxRDY not ready, check int source
	 IN	   AL,RHR2F
	 CMP	   AL,BL
	 JNE	   RXERR6
RTN6:	 POP	   BX
	 POP	   AX
	 IRET
RXERR6:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET

;-------------------------------------------------------------------------------


INTSR67:
	 PUSH	   AX
	 PUSH	   BX
	 IN	   AL,SR2G		    ; in status, check channel 2G
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   CHKAL7		    ; b2=0, TxRDY not ready, check channel D
	 IN	   AL,THR2G
	 CMP	   AL,BL
	 JNE	   ERROR7
	 JMP	   RTN7
CHKAL7:  IN	   AL,SR2H		    ; check channel 2H.
	 TEST	   AL,01H		    ; RxRDY ?
	 JZ	   ERROR7		    ; b2=0, TxRDY not ready, check int source
	 IN	   AL,THR2H
	 CMP	   AL,BL
	 JNE	   ERROR7
RTN7:	 POP	   BX
	 POP	   AX
	 IRET

ERROR7:
	 POP	   BX
	 POP	   AX
	 STC
	 IRET

;---------------------------------------------------------------------------

INTSR40:
	 PUSH	   ES
	 PUSH	   SI
	 PUSH	   AX
	 PUSH	   DX

	 XOR	   SI,SI
	 MOV	   ES,SI
	 MOV	   AL,11H
	 MOV	   ES:[INTBIT],AL	    ; 0:0F

	 MOV	   AL,0
	 MOV	   DX,CLRPORT
	 OUT	   DX,AL		    ; clear int from 386

	 MOV	   AX,8000H		    ;  INT 386
	 MOV	   DX,INTPORT
	 OUT	   DX,AX

	 POP	   DX
	 POP	   AX
	 POP	   SI
	 POP	   ES

	 IRET


;------------------  TEST - 6  EXTERNAL LOOP BACK INITIAL MACRO  -----------+
;									    |
;	   Initial Macro						    |
;	     MR1 <-- odd parity, 8 bit data.				    |
;	     MR2 <-- normal mode, 1 stop bit.				    |
;	     CSR <-- sense dip sw to setting baud rate. 		    |
;	     CR  <-- reset MR point, disable Tx & Rx			    |
;	     IMR <-- RxRDY INT						    |
;	   End Macro							    |
;									    |
;	   Open RxINT gate, enable Tx & Rx , only at run-in mode.	    |
;									    |
;---------------------------------------------------------------------------+


EXTUART:

INITST	  MACRO   MR,CSR,CR,ACR,DATA,IMR,MR1,CSR1,CR1

	 MOV	   AL,07H		    ; RXINT=RXRDY, 8 bit data, odd parity
	 OUT	   MR,AL
	 NOP
	 MOV	   AL,07H		    ; normal mode, 1 stop bit
	 OUT	   MR,AL

	 MOV	   AL,0CCH
	 OUT	   CSR,AL

	 MOV	   AL,1AH		    ; reset MR pointer, disable TX/RX
	 OUT	   CR,AL

	 MOV	   AL,0F0H
	 OUT	   ACR,AL

	 MOV	   AL,DATA		    ; DATA=22H, RxRDY INT
	 OUT	   IMR,AL

	 MOV	   AL,07H		    ; RXINT=RXRDY, 8 data bits, odd parity
	 OUT	   MR1,AL
	 NOP
	 MOV	   AL,07H		    ; set normal mode
	 OUT	   MR1,AL

	 MOV	   AL,0CCH
	 OUT	   CSR1,AL

	 MOV	   AL,1AH		    ; reset MR pointer
	 OUT	   CR1,AL

	    ENDM


INITST	  MR1A,CSR1A,CR1A,ACR1AB,22H,IMR1AB,MR1B,CSR1B,CR1B
INITST	  MR1C,CSR1C,CR1C,ACR1CD,22H,IMR1CD,MR1D,CSR1D,CR1D
INITST	  MR1E,CSR1E,CR1E,ACR1EF,22H,IMR1EF,MR1F,CSR1F,CR1F
INITST	  MR1G,CSR1G,CR1G,ACR1GH,22H,IMR1GH,MR1H,CSR1H,CR1H

INITST	  MR2A,CSR2A,CR2A,ACR2AB,22H,IMR2AB,MR2B,CSR2B,CR2B
INITST	  MR2C,CSR2C,CR2C,ACR2CD,22H,IMR2CD,MR2D,CSR2D,CR2D
INITST	  MR2E,CSR2E,CR2E,ACR2EF,22H,IMR2EF,MR2F,CSR2F,CR2F
INITST	  MR2G,CSR2G,CR2G,ACR2GH,22H,IMR2GH,MR2H,CSR2H,CR2H


	 MOV	   AL,15H		    ; control regs. 0001 0101
	 OUT	   CR1A,AL		    ; 0001 -> reset MR point, causes MR pointer to MR1
	 OUT	   CR1B,AL		    ; 0101 -> enable Tx & Rx
	 OUT	   CR1C,AL
	 OUT	   CR1D,AL
	 OUT	   CR1E,AL
	 OUT	   CR1F,AL
	 OUT	   CR1G,AL
	 OUT	   CR1H,AL
	 OUT	   CR2A,AL
	 OUT	   CR2B,AL
	 OUT	   CR2C,AL
	 OUT	   CR2D,AL
	 OUT	   CR2E,AL
	 OUT	   CR2F,AL
	 OUT	   CR2G,AL
	 OUT	   CR2H,AL



;---------------------------------------------------------------------------+
;									    |
;	    Sense DIP switch if dial OFF ('FF') of all then to do RIN-IN    |
;     ripple pattern test.						    |
;									    |
;---------------------------------------------------------------------------+

SKPRUN:  MOV	   DX,BAUD1AB		    ; sense DIP switch
	 CALL	   CHKPORT
	 MOV	   DX,BAUD1CD
	 CALL	   CHKPORT
	 MOV	   DX,BAUD1EF
	 CALL	   CHKPORT
	 MOV	   DX,BAUD1GH
	 CALL	   CHKPORT
	 MOV	   DX,BAUD2AB
	 CALL	   CHKPORT
	 MOV	   DX,BAUD2CD
	 CALL	   CHKPORT
	 MOV	   DX,BAUD2EF
	 CALL	   CHKPORT
	 MOV	   DX,BAUD2GH
	 CALL	   CHKPORT


;----------------------   TEST - 7  EXTERNAL LOOP BACK RUN IN TEST    ------------+				 |
;										  |
;	   This test is external loop back test, using channel-1A connect CRT	  |
;   to display channel 1B,1C,1D,...,1G,1H,2A,2B,...,2G,2H loop back test result.  |
;	   Each channel RS232 connector pin-2 and pin-3 short, sent datas from	  |
;   20H to 7FH, baud rate setting 19200bps, it will display test result PASS	  |		       |
;   or FAIL.									  |
;										  |
;---------------------------------------------------------------------------------+

	 MOV	   CX,0
CRT:	 IN	   AL,IP2CD
	 NOT	   AL
	 TEST	   AL,01H
	 JNZ	   DISY
	 AAM
	 AAM
	 AAM
	 LOOP	   CRT

	 MOV	   SI,0
	 MOV	   ES,SI
	 MOV	   AH,60H		    ; 60H no crt
	 MOV	   ES:[RESULT],AH
	 JMP	   NOCRT

DISY:	 PUSH	   CS
	 POP	   DS			    ; DS <= CS

	 LEA	   SI,DS:COPYRIGHT	    ; display message
	 CALL	   MASG

	 LEA	   SI,DS:CHAN1C 	    ; channel-1C loop-back test
	 CALL	   MASG 		    ; 2
	 MOV	   DX,THR1C
	 MOV	   DI,SR1C
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN1B 	    ; channel-1B
	 CALL	   MASG 		    ; 3
	 MOV	   DX,THR1B
	 MOV	   DI,SR1B
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN1D 	    ; channel-1D
	 CALL	   MASG 		    ; 4
	 MOV	   DX,THR1D
	 MOV	   DI,SR1D
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN1E 	    ; channel-1E
	 CALL	   MASG 		    ; 5
	 MOV	   DX,THR1E
	 MOV	   DI,SR1E
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN1F 	    ; channel-1F
	 CALL	   MASG 		    ; 6
	 MOV	   DX,THR1F
	 MOV	   DI,SR1F
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN1G 	    ; channel-1G
	 CALL	   MASG 		    ; 7
	 MOV	   DX,THR1G
	 MOV	   DI,SR1G
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN1H 	    ; channel-1H
	 CALL	   MASG 		    ; 8
	 MOV	   DX,THR1H
	 MOV	   DI,SR1H
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2A 	    ; channel-2A
	 CALL	   MASG 		    ; 9
	 MOV	   DX,THR2A
	 MOV	   DI,SR2A
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2B 	    ; channel-2B
	 CALL	   MASG 		    ; 10
	 MOV	   DX,THR2B
	 MOV	   DI,SR2B
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2C 	    ; channel-2C
	 CALL	   MASG 		    ; 11
	 MOV	   DX,THR2C
	 MOV	   DI,SR2C
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2D 	    ; channel-2D
	 CALL	   MASG 		    ; 12
	 MOV	   DX,THR2D
	 MOV	   DI,SR2D
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2E 	    ; channel-2E
	 CALL	   MASG 		    ; 13
	 MOV	   DX,THR2E
	 MOV	   DI,SR2E
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2F 	    ; channel-2F
	 CALL	   MASG 		    ; 14
	 MOV	   DX,THR2F
	 MOV	   DI,SR2F
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2G 	    ; channel-2G
	 CALL	   MASG 		    ; 15
	 MOV	   DX,THR2G
	 MOV	   DI,SR2G
	 CALL	   EXLOOP

	 LEA	   SI,DS:CHAN2H 	    ; channel-2H
	 CALL	   MASG 		    ; 16
	 MOV	   DX,THR2H
	 MOV	   DI,SR2H
	 CALL	   EXLOOP

	 MOV	   SI,0
	 MOV	   ES,SI
	 MOV	   AL,40H
	 MOV	   ES:[RESULT],AL	    ; Run-in mode 40H, pass



;------------------   TEST - A	LED TEST   ------------------------------+
;									 |
;	   LED is on, after power up. After completing diagnostic	 |
;     program test, LED will be turned off.				 |
;	   If LED can't be turn off that is error occurence, above all   |
;     is UART 2698 L:**, due to UART port to control LED.		 |
;									 |
;------------------------------------------------------------------------+

NOCRT:	 STI				    ; ###
	 LED	   ROFFUART,CR1F	    ; clear RLED UART
	 XOR	   CX,CX
LEF:	 AAM
	 AAM
	 AAM
	 AAM
	 AAM
	 AAM
	 AAM
	 AAM
	 AAM
	 AAM
	 LOOP	   LEF
	 LED	   RONUART,CR1F

	 CLI
	 JMP	   TST2

;===================   JMP MXF/OS   ==================

MXFOS:
	 STI				    ; wait 386 int
	 XOR	   SI,SI
	 MOV	   ES,SI

	 MOV	   AL,80H
	 MOV	   ES:[RESULT],AL	    ; pass

	 MOV	   CX,20H
DKOS:	 PUSH	   CX
	 MOV	   CX,0
INT386:  MOV	   AL,ES:[INTBIT]	    ; 0:0F
	 CMP	   AL,11H
	 JE	   MXFSYS
	 AAM
	 AAM
	 LOOP	   INT386
	 POP	   CX
	 LOOP	   DKOS


MXFSYS:  LED	   ROFFUART,CR1F
	 CLI

	 XOR	   DI,DI
	 MOV	   BL,0F0H
	 MOV	   DS,DI
	 MOV	   BYTE PTR DS:[BOARDST],BL


	 JMP	   begin0		    ; begin0

;*****************************	  SUBROUTINE	 *****************************

EXLOOP:
	 MOV	   BL,20H		    ; sent data from 20H
NXT1:	 MOV	   AL,BL
	 OUT	   DX,AL		    ; DX: THR port
	 PUSH	   DX			    ; save port

	 MOV	   DX,DI		    ; DI: SR regs.
	 MOV	   CL,0 		    ; set timer
POL:	 IN	   AL,DX		    ; read status
	 TEST	   AL,01H		    ; Rx ready ?
	 JNZ	   READIN		    ; receive
	 LOOP	   POL
	 POP	   DX
	 JMP	   FAILL		    ; time out

READIN:  POP	   DX			    ; retrieve
	 IN	   AL,DX		    ; read data
	 CMP	   AL,BL
	 JNE	   FAILL

	 INC	   BL
	 CMP	   BL,80H
	 JNZ	   NXT1

	 LEA	   SI,DS:PASS		     ; pass
	 CALL	   MASG
	 JMP	   NXLOOP

FAILL:	 LEA	   SI,DS:FAIL		     ; fail
	 CALL	   MASG
NXLOOP:  RET


;------------------------------------------------------------------------

CHKPORT:				    ; check DIP switch dail 'FF'
	 IN	   AL,DX
	 CMP	   AL,0FFH
	 JNE	   MXFOS
	 RET

;----------------------------------------------------------------------------

SETBAUD:				    ; read DIP switch to setting baud rate
	 CMP	   AL,11H		    ; 38400 bps
	 JE	   SET384
	 CMP	   AL,22H		    ; 19200
	 JE	   SET192
	 CMP	   AL,33H		    ; 9600
	 JE	   SET96
	 CMP	   AL,55H		    ; 4800
	 JE	   SET48
	 CMP	   AL,77H		    ; 2400
	 JE	   SET24
	 CMP	   AL,99H		    ; 1200
	 JE	   SET12
	 CMP	   AL,0AAH		    ; 600
	 JE	   SET60
	 CMP	   AL,0BBH		    ; 300
	 JE	   SET30
SET192:  MOV	   AL,0CCH		    ; default 19200 bps
	 RET
SET384:  MOV	   AL,22H
	 RET
SET96:	 MOV	   AL,0BBH
	 RET
SET48:	 MOV	   AL,99H
	 RET
SET24:	 MOV	   AL,88H
	 RET
SET12:	 MOV	   AL,66H
	 RET
SET60:	 MOV	   AL,55H
	 RET
SET30:	 MOV	   AL,44H
	 RET


;-------------------------------------------------------------

MASG:
NXT:	 LODSB				    ; es:si save to AL regs.
	 MOV	   BL,AL
	 CMP	   AL,24H		    ; til '$'
	 JE	   DEND
	 OUT	   THR1A,AL
	 MOV	   CX,1000H
	 LOOP	   $
	 JMP	   NXT
DEND:	 RET


;	      ORG     0FFF0H		    ; include MXF/OS del
;	 JMP	   START		    ; 286 reset, 1st IP
;CODE	 ENDS

;	END    START


