;
put_comt	proc			;j+
;	*********************************************************************
;	Routine puts a byte in the comt_buf string (buffer) in a certain port
;	and update the screen accordingly, meanwhile it sets related flags.
;	Entry: al holds the byte to be entered.
;	*********************************************************************
;	First test for crt buffer, don't overrun the buffer
	mov	di,crt_count
	cmp	word ptr [di],0
	jnz	put_comtz		;CRT buffer not empty, exit
	cmp	al,0dh			;'return' key?
	jz	comtend
	cmp	al,08h			;backspace ?
	jz	comtbck
	cmp	al,7eh			;'tab' key?
	jnz	putqq
	jmp	comttab
putqq:
	mov	di,comt_len
	cmp	byte ptr [di],comt_max	;already full?
	jnc	comterr 		;jump if yes
	inc	byte ptr [di]		;update the length
	inc	di			;point at comt_wrt
	mov	bx,[di]
	inc	word ptr [di]		;update write pointer
	mov	di,comt_buf
	mov	[di][bx],al		;store in the buffer
put_comt1:				;Update screen, but not to print psw
;	Don't print bytes 2 to 7 (from 0) on screen
;	Check tab bit = 1, ok to print psw
	mov	di,flag2
	test	byte ptr [di],tabb
	jnz	put_comt2		;ok to print
	mov	di,comt_wrt
	cmp	word ptr [di],9 	    ;byte 8 or greater
	jnc	put_comt2
	cmp	word ptr [di],3 	     ;less than 2 ?
	jc	put_comt2
; This byte is either within psw or a blank surrounding it, print byte # only.
	mov	ax,[di]
	sub	al,3
	or	al,ascconv		;change to ascii code of number of byte
put_comt2:
;   Print byte on screen if not currently processing a command for this port
	mov	di,flag2
	test	byte ptr[di],procbit	       ;process on ?
	jnz	put_comt4
	call	putcrtg
put_comt4:
	and	bx,00			;Z flag
put_comtz:
	ret
comterr:				;buffer full, beep terminal
	mov	al,07h
	jmp	put_comt2
comtbck:				;backspace, backup 1 byte and update crt
	mov	di,comt_wrt
	cmp	word ptr [di],0
	jz	comterr 		;can't back, beep
	dec	word ptr [di]
	mov	di,comt_len
	dec	byte ptr [di]
	mov	al,08h			;put '082008'H to crt
	call	putcrtg
	mov	al,20h
	call	putcrtg
	mov	al,08h
	jmp	put_comt2
comtend:				;Receiving 0dh, end of command
	mov	si,msgmd2		;output messages
	mov	cl,msgmd2l
	xor	ch,ch
	call	putstr
;	Reset command mode input flag if comt_buf is empty, i.e. return key
	mov	di,comt_len
	cmp	byte ptr [di],0
	jz	comtend2		;not reset if not zero
	mov	di,usermask
	mov	bx,[di]
	or	es:commode0,bx		;mask command byte
	ret
comtend2:
	mov	di,flag2
	and	byte ptr [di],not modebit	;reset command mode flag
	mov	di,rbimask
	or	byte ptr [di],crtrb	;allow CRT to flow
	mov	si,msgmd3		;output exit messages
	mov	cl,msgmd3l
	xor	ch,ch
	call	putstr
;  Clear LR buffer and end current LR so that user will be back to a cleared
;  state and OS will reprompt the user.
	mov	di,lrwre
	mov	word ptr [di],0 		;reset pointer
	mov	di,lrquery
	mov	byte ptr [di],return	      ;terminate LR normally
	mov	di,curnt_sts
;	mov	di,flag9
	or	byte ptr [di],lrint	     ;notice OS
	mov	di,outblock
	mov	byte ptr [di],0
;	call	ready02 		;check????
comtend3:
	or	al,0ffh
	ret
comttab:
	mov	di,flag2
	xor	byte ptr [di],tabb		;toggle tab bit
	ret
put_comt	endp
;
put_comb	proc			;j+
;	*********************************************
;	Routine gets bytes from OS386 thru address 06
;	Exit: bl will hold the # of bytes
;	*********************************************
	cld
	push	es
	push	ds
	pop	es			;Make es = ds
	mov	bl,0			;clear counter
	mov	si,cmd_parm		;source
	mov	di,com_buf		;destination
	mov	cx,commax		;move 60 bytes, change it check??
put_comb1:
	lodsb
	cmp	al,0			;is it 0 ?
	jz	put_combz		;exit if 0, command terminates
	stosb				;store to destination
	inc	bl
	loop	put_comb1
put_combz:
	mov	al,0
	mov	di,com_len
	mov	[di],bl
	mov	di,com_rd
	mov	word ptr [di],0
	pop	es
	mov	word ptr es:comorg,0		 ;this command from OS
	ret
put_comb	endp
;
move_com	proc			;j+
;	*******************************************************************
;	Routine moves a command from a user's comt_buf string to the buffer
;	com_buf, string for processing. 2200 bus set busy?
;	*******************************************************************
	cld					;DF flag = 0, si, di increments
	push	es
	push	ds
	pop	es				;ds = es = user's block
	mov	di,com_buf
	mov	al,20h
	mov	cx,comt_max - 2
	rep	stosb				;clear com_buf
;
	mov	si,comt_buf
	mov	di,com_buf
	mov	cx,comt_max
	rep	movsb				;Move to command buffer
	pop	es
	mov	di,usermask
	mov	bx,[di]
	xor	es:commode0,bx			;mask off
	mov	di,comt_len
	mov	si,com_len
	mov	bl,[di]
	mov	[si],bl
	mov	byte ptr [di],0
	inc	di				;point at comt_wrt
	mov	word ptr [di],0
	add	di,2				;point at comt_rd
	mov	word ptr [di],0
	mov	di,com_rd
	mov	word ptr [di],0 		;set reading at the beginning
	mov	di,usermask
	mov	bx,[di]
	mov	es:comorg,bx			;set comorg
;	Should set 2200 bus busy
;	mov	al,0
;	mov	dl,[di].rbireg
;	out	dl,al
	or	al,0ffh 			;set NZ flag
	ret
move_com	endp
;
do_com		proc
;	*********************************************************************
;	Routine processes the command string in 'com_buf'. The command could
;	have originated from the terminal of address 06 of 2200 bus.
;	Note: Set flag to prevent the printing of next command on the screen
;	if it is typed while this command is being processed. (But only set
;	bit if command origin is not 2200 bus!)
;	*********************************************************************
	cmp	word ptr es:comorg,0
	jz	docom2
	mov	di,flag2
	and	byte ptr [di],not tabb		;Reset not to print psw
	or	byte ptr [di],procbit
	test	byte ptr [di],ynbit
	jnz	ans
docom2: 		  ;Get 1st byte, find service routine in jump table
	call	prs_come		;return in al
	jz	docomer
	cmp	al,'?'
;	jz	mxedata 		;special command '?'
	jz	mxedata
	and	al,01fh
	cmp	al,comtabp		;Limit the offset = 12
	ja	docomer 		;error!
	xor	bh,bh
	mov	bl,al			;offset
	shl	bx,1
	jmp	cs:comtab[bx]
mxedata:
;	call	mxedata0
	jmp	cmdQ
;	********************
;	   Commands Table
;	********************
comtab	dw	docomer 	;0 - command error
	dw	docomer 	;A - command error
	dw	cmdB		;B - set a new baud rate at some port
	dw	cmdC		;C - set new password for MXF
	dw	cmdD		;D - download code through port
	dw	cmdE		;E - analog loopback
	dw	cmdF		;F - digital loopback
	dw	docomer 	;G - error command
	dw	cmdH		;H - Print list of commands
	dw	cmdI		;I - test all of RAM
	dw	docomer 	;J - error command
	dw	docomer 	;K - error command
	dw	cmdL		;L - lock baud rate from change
	dw	cmdQ		;? - query the ports status
;
ans:	;Commands that require answering 'yes' or 'no'. Users now responses
;	 Answer is either 'Y' or 'N'. 'Y' = A jump is performed to the routines
;	 whose addresses were stored in 'ANSYES'. 'N' = A jump is gone to
;	 'enddo2' which will prompt for a new command.
	and	byte ptr [di],not ynbit
	call	prs_come		;Return character code in al
	jz	docomer
	cmp	al,'Y'
	jne	ansno
	jmp	cmdb7			;check?
ansyes	dw	enddo
ansno:
	mov	si,msgno
	mov	cl,msgnol
	xor	ch,ch
	call	putstr
	jmp	enddo
;
docomed:		;Command completed successfully, print messages, flags..
	mov	byte ptr es:comerr2,0		 ;No error here
	cmp	word ptr es:comorg,0
	jz	z2200ret		 ;jump if 2200 condition
	mov	si,msgc2
	mov	cl,msgc2l
	xor	ch,ch
	call	putstr
	jmp	enddo
;
docomer:
	mov	byte ptr es:comerr2,01		 ;error code
docomer2:
	cmp	word ptr es:comorg,0
	jz	z2200ret
	mov	si,msgc1			 ;error message
	mov	cl,msgc1l
	xor	ch,ch
	call	putstr
	jmp	enddo
;
z2200ret:
	mov	al,es:comerr2
	mov	es:comerr,al
	ret
;
enddo0:
	mov	es:comerr2,al
enddo:
	mov	si,msgc4
	mov	cl,msgc4l
	xor	ch,ch
	call	putstr
enddo2:
	mov	di,flag2
	and	byte ptr [di],not procbit
	test	byte ptr [di],modebit
	jz	enddoz
	call	prntcom
enddoz:
	ret
;
enddoq: 			;Ask user to make sure of the command?
	call	mxedata0	;Print current mxe status on screen first
	mov	si,msgq
	mov	cl,msgql
	xor	ch,ch
	call	putstr
	mov	di,flag2
	or	byte ptr [di],ynbit
	jmp	enddo2
do_com	endp
;
prntcom:			;j+
;	**********************************************************************
;	Routine prints the contents of comt_buf on the screen if there is any
;	Note: contents are printed on screen, command input mode may continue
;	**********************************************************************
	mov	di,comt_len
	cmp	byte ptr [di],0
	jne	prntcom1
	ret
prntcom1:
	mov	bx,0
	mov	cl,[di]
	xor	ch,ch
	mov	di,comt_buf
prntcom2:
	mov	al,[di][bx]
	cmp	bx,8
	ja	prntcom3
	cmp	bx,2
	jb	prntcom3
	mov	dl,bl
	sub	dl,2
	mov	al,dl		;psw always display '012345'
	or	al,ascconv
	push	di
	push	bx
prntcom3:
	call	putcrtg
	pop	bx
	pop	di
	inc	bx
	loop	prntcom2
	ret
;
cmdB	proc			;j+
;	************************************************************
;	Set a new baudrate for a specified port
;	Format: 'PSW' 'port designation' 'baudrate'
;	Baudrate must be a legal number and can not contain blank
;	Port designation: 1 to 16 correspond to port 0 - 15,
;			: Zero specified port originated the command
;	************************************************************
	cmp	word ptr es:comorg,0
	jz	cmdb0
	mov	di,lockk
	test	byte ptr [di],baudlock
	jz	cmdb0
	jmp	cmdbz
cmdb0:
	call	chkpsw
	jnz	cmdb01
cmdbz:
	call	docomer 		;NOT match, send error messages
	ret
;
cmdb01: 				;psw passed
	push	ds			;Originator ds
	call	prs_come		;get port designation
	mov	ah,al
	call	prs_com
	cmp	al,20h			;port over 9?
	jnz	cmdb02
	mov	al,ah
	xor	ah,ah
cmdb02:
	call	findport		;which to set?	@@@
	jnz	cmdb8
	pop	ds			;error exit
	jmp	cmdbz
cmdb8:
	call	prs_come		;get first position
	mov	di,com_rd
	mov	bx,[di]
	dec	bx
;	testing
;	mov	si,com_wrt
;	mov	ax,bx
;	add	ax,4
;	cmp	ax,[si]
;	jz	testbu
;	mov	si,com_buf
;	inc	ax
;	mov	[si][ax],30h
;testbu:
;	testing
	cld
	mov	di,ratetbl
cmdb1:
	mov	cx,5
	mov	si,com_buf
	add	si,bx
	repe	cmpsb
	jz	cmdb2
	add	cx,2
	add	di,cx
	cmp	di,a81
	jae	cmdbz1
	jmp	cmdb1
cmdb2:
	mov	ds,dx			;put in current ds
	mov	si,scratch7
	mov	word ptr es:[si],dx
	xor	dh,dh
;
;	for fixed and more baud rate 3/June, 1991
	mov	si,acrport
	mov	dl,[si]
	mov	si,acrdata
	mov	ah,[si]
	inc	di			;point at acr value
	mov	al,es:[di]
	cmp	al,80h
	jz	june3
;	1st set of baud rate
	and	al,ah
	jmp	june3a
june3:			;2nd set of baud rate
	or	al,ah
june3a:
	mov	[si],al ;store back acr value
	mov	si,flag3
	mov	word ptr [si],di
	pop	ds
	jmp	enddoq	;asking for confirmation
;
cmdb7:			;restart point of BaudRate setting command
	push	ds
;
	mov	si,scratch7
	mov	dx,word ptr es:[si]
	mov	ds,dx
	mov	si,flag3
	mov	di,word ptr [si]
;
	mov	si,acrport
	mov	dl,[si]
	mov	si,acrdata
	mov	al,[si]
	xor	dh,dh
;
	out	dx,al
	dec	di			;back to csr value
;	End bugging of baud rate 3/June, 1991
;
	mov	si,csrport
	mov	dl,[si]
	mov	al,es:[di]
	out	dx,al
;	sbb	di,6
	sbb	di,5
;	mov	bl,es:[di]
	mov	si,swbrate
	mov	ax,di
	mov	[si],ax
	pop	ds
	jmp	enddo
;					 command succeeded
cmdbz1:
	pop	ds			;originator
	jmp	cmdbz
cmdB	endp
;
cmdC	proc				;C - set new password for MXF
;	**********************
;	Set new password
;	Format: 'PSW' 'NEWPSW'
;	**********************
	cmp	word ptr es:comorg,0
	jz	cmdc1			;No messages
	mov	si,msgc3		;error message
	mov	cl,msgc3l
	xor	ch,ch
	call	putstr
cmdc1:
	call	chkpsw
	jnz	cmdc01
	call	docomer 		;NOT match, send error messages
	ret
cmdc01: 				;psw passed
	mov	cx,6			;6 at most
	mov	si,psw2
	call	prs_come		;get 1st byte to eliminate blank
	jmp	cmdc03
cmdc02:
	call	prs_com 		;embedded spaces are allowed
cmdc03:
	mov	es:[si],al
	inc	si
	loop	cmdc02
	mov	cx,6
	mov	si,psw
	mov	di,psw2
cmdc07:
	mov	al,es:[di]
	mov	es:[si],al
	inc	di
	inc	si
	loop	cmdc07
	jmp	enddo
cmdC	endp
;
cmdD	proc				;D - download code through port
;	**********************************************************************
;	Routine downloads codes from port
;	Format: 'PSW' 'port designator'
;	DATA FORMAT: Code is inputted as 'DESTINATION' 'COUNT' 'CODE'
;		 a count of 0 ends the cycle.  When the download command
;		 is received the MXF will respond with an 'FF' when ready to
;		 receive.  The MXF then expects to receive strings of code
;		 in the above mentioned form until a count of 0 is received.
;		 All other MXF activity is stopped while this command is in
;		 process.  At the end of this command the MXF will proceed
;		 where it left off provided the internal data structure is
;		 not destroyed, in which case all is lost (!!!), the MXF
;		 bombs and could need to be repowered.
;	**********************************************************************
	call	chkpsw
	jnz	cmdd01
cmddz:
	call	docomer 		;NOT match, send error messages
	ret
cmdd01: 				;psw passed
	push	ds			;save the original data segment
	call	prs_come		;get port designation
	mov	ah,al
	call	prs_com
	cmp	al,20h			;port over 9?
	jnz	cmdd02
	mov	al,ah
	xor	ah,ah
cmdd02:
;
	call	findport		;decode port designator, ds in dx
;	jz	cmddz1			;pop back ds, send message and return
; Print infomation on all the ports, ask user if he is sure about this command
; if it isn't from OS386. If it is from OS, proceeds.   check??? no asking now!!
;
dwnload4:



	pop	ds
	jmp	enddo
cmdD	endp
;
cmdE	proc
;	************************************************************
;	Routine performs analog loopback
;	Format: 'psw' 'port designation'
;	Port designation: 1 to 16 correspond to port 0 - 15,
;			: Zero specified port originated the command
;	************************************************************
	mov	al,0

	jmp	loopj
cmdE	endp
;
cmdF	proc
;	************************************************************
;	Routine performs digital loopback
;	Format: 'psw' 'port designation'
;	Port designation: 1 to 16 correspond to port 0 - 15,
;			: Zero specified port originated the command
;	************************************************************
	mov	al,1
loopj:			 ;al = 0 / analog, 1 / digital
	mov	es:scratch1,al		;save it
	call	chkpsw
	call	prs_come		;get port designation
	mov	ah,al
	call	prs_com
	cmp	al,20h			;port over 9?
	jnz	cmdp02
	mov	al,ah
	xor	ah,ah
cmdp02:
;
	call	findport		;decode port designator, ds in dx
	jnz	loopjq
	jmp	docomer
loopjq:
;				 ds found and stored in dx.
	cli
	cmp	byte ptr es:scratch1,0
	jnz	loopjd		 ;jump if not (digital)
;		Analog loopback
	cmp	word ptr es:comorg,0
	jz	loopa2		;From OS, do not print out messages
	mov	si,msgca
	mov	cl,msgcal
	xor	ch,ch
	call	putstr
loopa2:
;	cli
	call	loopana
	jmp	loop5
loopjd:
	cmp	word ptr es:comorg,0
	jz	loopd2
	mov	si,msgcd
	mov	cl,msgcdl
	xor	ch,ch
	call	putstr
loopd2:
;	cli
	call	loopdig
loop5:
	push	ds
	push	bx			;save returned codes
	mov	ds,dx
	call	port_init_1		;Init I/O register
;	call	wrtbaud 		;check?????
;
	mov	di,baudport
	mov	dx,[di]
	in	al,dx
	call	read_baud
;
;	For fixed and added baud rate 3/june, 1991
	push	ax
	mov	al,ah
	mov	di,acrport
	xor	dh,dh
	mov	dl,[di]
	mov	di,acrdata
	mov	ah,[di] 	;acr value
	cmp	al,80h
	jz	june003
;	1st set of baud rate
	and	al,ah
	jmp	june003a
june003:			 ;2nd set
	or	al,ah
june003a:
	mov	[di],al 	;store back to acr value
	out	dx,al
	pop	ax
;	End bugging of 3/June, 1991
;
	mov	di,csrport
	mov	dl,[di] 	;csrport out
;	xor	dh,dh
	out	dx,al
;
	sti				;interrupt enable
	pop	bx
	pop	ds			;Original data segment of user
	cmp	bl,0
	jnz	looper			;jump if bl not zero, error occured
	cmp	word ptr es:comorg,0	;From OS
	jz	loopq9			;Skip the messages
	mov	si,msglped
	mov	cl,msglpedl
	xor	ch,ch
	call	putstr
	mov	al,0
	jmp	enddo0
looper: 				;Error, send messages
	mov	al,2			;error code
	cmp	word ptr es:comorg,0
	jz	loopq9
	mov	si,msglper
	mov	cl,msglperl
	xor	ch,ch
	call	putstr
	mov	al,2
loopq9:
	jmp	enddo0
loopana:
	ret				;Looking for codes in ROM ?
loopdig:
	ret				;Looking for codes in ROM ?
cmdF	endp
;
cmdH	proc			;jh
;	******************************
;	Print all the commands to user
;	******************************
	mov	si,msgc7	;error message
	mov	cl,msgc7l
	xor	ch,ch
	call	putstr
	jmp	enddo
cmdH	endp
;
cmdI	proc			;jh
;	**********************************
;	 Test the whole RAM, format 'PSW'
;	**********************************
	call	chkpsw		;check passwrod
	mov	cx,es:memsize	;How many page?
mem4:
	cli			;disable inbt
	call	memtest 	;check????
	sti
	cmp	bl,0		;error?
	jnz	memer		;jump if error
	loop	mem4
;
	cmp	word ptr es:comorg,0
	jz	memqq
	mov	si,msgm1
	mov	cl,msgm1l
	xor	ch,ch
	call	putstr
	mov	al,0		;no error, code returned
	jmp	enddo0
memer:
	mov	al,2
	cmp	word ptr es:comorg,0
	jz	memqq
	mov	si,msgm2
	mov	cl,msgm2l
	xor	ch,ch
	call	putstr
	mov	al,2		;no error, code returned
memqq:
	jmp	enddo0
cmdI	endp
;
cmdL	proc			;j+
;	*******************************************************************
;	Routine inverts the state of the baud rate lock for port designator
;	*******************************************************************
;
	cmp	word ptr es:comorg,0
	jz	cmdlq		 ;no lock for 2200 bus
	mov	di,lockk
	test	byte ptr [di],baudlock
	jnz	cmdl1			;locked, go unlock it, jump!
	or	byte ptr [di],baudlock
	mov	si,msgcl
	mov	cl,msgcll
	xor	ch,ch
	jmp	cmdl2
cmdl1:
	and	byte ptr [di],not baudlock
	mov	si,msgcunl
	mov	cl,msgcunll
	xor	ch,ch
cmdl2:
	call	putstr
	jmp	enddo
cmdlq:
	jmp	docomer
cmdL	endp
;
;	********************************************************
cmdQ	proc	;? - query the ports status
	call	mxedata0
	jmp	enddo
;
mxedata0:
	cmp	word ptr es:comorg,0
	jnz	cmdq9		;don't print on screen if 2200
	ret
;	jmp	enddo
cmdq9:
	mov	si,msgml0
	mov	cl,msgml0l
	xor	ch,ch
	call	putstr		;print the version number
	mov	ax,ds
;	mov	dx,ax		;original ds is stored in dx
	mov	es:scratch1,ax
;
;	Input dtr over here
	in	al,ip_2ab
	mov	ah,al
	in	al,ip_2cd
	not	ax
;	Switch 2, 3
	mov	bx,ax
	and	bx,06h
	cmp	bx,06h
	jz	cmdq22
	cmp	bx,0
	jz	cmdq22			;@
	xor	ax,06h
;
cmdq22:
	mov	es:scratch6,ax		;store in temperary place
	mov	bx,0
cmdq1:
	push	bx
	mov	di,dataseg
	mov	ax,es:[di][bx]
;	push	dx			;save the current ds
	mov	ds,ax
	test	es:word ptr scratch6,1	;is terminal on or off
	jnz	cmdq2			;zero is off
	mov	word ptr es:msgml3,'FF'
	jmp	cmdq3
cmdq2:
	mov	word ptr es:msgml3,' N'
cmdq3:
;	mov	si,hwbrate
	mov	si,swbrate
	mov	ax,[si]
	mov	si,ax
	mov	di,msgml4
	mov	cx,5			;total 5 characters
cmdq07:
	mov	al,es:[si]
	mov	es:[di],al
	inc	di
	inc	si
	loop	cmdq07
;
;	rep	movsb
	mov	di,lockk
	test	byte ptr [di],baudlock
	jnz	cmdq4
	mov	es:byte ptr msgml41,' '
	jmp	cmdq5
cmdq4:
	mov	es:byte ptr msgml41,'L'
cmdq5:
;	mov	si,swbrate
	mov	si,hwbrate
	mov	ax,[si]
	mov	si,ax
	mov	di,msgml42
	mov	cx,5
cmdq087:
	mov	al,es:[si]
	mov	es:[di],al
	inc	di
	inc	si
	loop	cmdq087
;
	call	termcon 		;get the loc/rem status; return si point
	mov	di,msgml44		;to the string, cx is the characters no.
termz1:
	mov	al,es:[si]
	mov	es:[di],al
	inc	di
	inc	si
	loop	termz1
;
	call	termtyp 		;get the term type; return si point to
	mov	di,msgml5		;string, cx is the characters no.
termz2:
	mov	al,es:[si]
	mov	es:[di],al
	inc	di
	inc	si
	loop	termz2
;
	mov	ax,ds
	cmp	ax,es:scratch1
	je	cmdq6
	mov	byte ptr es:msgml1,' '
	jmp	cmdq7
cmdq6:
	mov	byte ptr es:msgml1,'*'
cmdq7:
	mov	dx,es:scratch1
	mov	ds,dx
	mov	si,msgml01
	mov	cl,msgml01l
	xor	ch,ch
	call	putstr
;
	mov	si,msgml2
	mov	al,es:[si]
	add	al,1			  ;get next port number check??
	cmp	al,39h			  ;Larger than 9?
	jbe	cmdq01			  ;jump if only one digit
cmdq003:
	mov	byte ptr es:[si],31h
	inc	si
;
	cmp	byte ptr es:[si],20h	  ;space?
	jnz	cmdqv
	mov	byte ptr es:[si],30h
	jmp	cmdq001
cmdqv:
	add	byte ptr es:[si],1
	jmp	cmdq001
cmdq01:
	inc	si
	cmp	byte ptr es:[si],20h
	jz	cmdq002
	dec	si
	jmp	cmdq003
cmdq002:
	dec	si
	mov	es:[si],al		  ;only one digit, erase second digit
	mov	ah,20h
cmdq02:
	inc	si
	mov	es:[si],ah
;
cmdq001:
	shr	word ptr es:scratch6,1	  ;get next connect status
	pop	bx
	add	bx,2
	cmp	bx,32
	jae	cmdqq
;
;	Switch of 2, 3
	cmp	bx,2
	jnz	portb1
;	mov	di,breakmk
;	cmp	byte ptr [di],0ffh	;port 2 done yet?
;	jnz	portb2
	mov	bx,4			;make it to port 1c (port 2)
	jmp	portb9
portb1:
	cmp	bx,4
	jnz	portb5
	mov	bx,6
	jmp	portb9
portb5:
	cmp	bx,6			;port 1c (2)
	jnz	portb9
	mov	bx,2
;
;	End of switch
portb9:
	jmp	cmdq1
cmdqq:
	mov	si,msgml2
	mov	word ptr es:[si],2031h
	mov	ax,es:scratch1		;return to original data segment
	mov	ds,ax
	ret
;	jmp	enddo
cmdQ	endp
;
prs_com 	proc		;j+
;	**************************************************
;	Routine get one byte from com_buf string buffer.
;	Return: al holds data byte.
;	Exit: NZ = successfully access, Z = empty
;	**************************************************
	mov	di,com_len
	cmp	byte ptr [di],0 	;Length of common command buffer
	jz	prs_comz		;return Z if no byte at all
	dec	byte ptr [di]
	mov	di,com_rd
	mov	bx,[di] 		;read pointer
	inc	word ptr [di]
	xor	bh,bh
	add	di,2			;point at buffer
	mov	al,[di][bx]
	or	di,0ffh 		;set NZ flag
prs_comz:
	ret
prs_com 	endp
;
prs_come	proc		;j+
;	************************************************************************
;	Routine gets one byte from com_buf string buffer, when it is called it's
;	assumed that at least one more byte is available. Skip if blank found.
;	Return: al holds the data byte.
;	Exit: NZ = successfully access, Z = none data
;	************************************************************************
	call	prs_com
	jz	prs_comez
	cmp	al,20h		;Blank?
	jz	prs_come	;get next if blank
prs_comez:
	ret
prs_come	endp
;
;mxedata0	 proc		 ;j+
;	*************************************************************
;	Routine prints data on current mxe operation (configuration)
;	*************************************************************
;	 sti
;	 cmp	 word ptr es:comorg,0
;	 jnz	 mxeqq
;	 ret
;mxeqq:
;	 mov	 si,msgml0
;	 mov	 cl,msgml0l
;	 xor	 ch,ch
;	 call	 putstr
;	 mov	 cx,10h 		 ;16 terminals per board
;	 mov	 dx,ds			 ;save the original data segment
;	 mov	 bx,0			 ;First control block
;mxedata1:
;	 push	 cx
;	 push	 bx
;	 mov	 di,dataseg
;	 mov	 ax,es:[di][bx]
;	 mov	 ds,ax
;	 mov	 di,usermask
;	 mov	 ax,[di]
;	 and	 ax,es:connect_byte
;	 jz	 mxedata2		 ;jump if terminal is on
;	Terminal is off ! Output the messages
;	 mov	 word ptr es:msgml3,'FF'
;	 jmp	 mxedata3
;mxedata2:				 ;terminal is on
;	 mov	 word ptr es:msgml3,'N '
;mxedata3:
;	 mov	 si,swbrate
;	si now point at baud string while cl holds the counters
;	 xor	 ch,ch			 ;clear upper byte of counters
;	 mov	 di,msgml4
;	 rep	 movsb
;					 Is baud rate lock?
;	 mov	 di,lockk
;	 test	 byte ptr [di],baudlock
;	 jnz	 mxedt31		 ;jump if lock
;					 ;Unlock, do not print 'L'
;	 mov	 byte ptr es:msgml41,' '
;	 jmp	 mxedt32
;mxedt31:
;	 mov	 byte ptr es:msgml41,'L'
;mxedt32:				 ;Find hardware baudrate, put into string
;	 mov	 si,hwbrate
;	si now point at baud string while cl holds the counters
;	 xor	 ch,ch			 ;clear upper byte of counters
;	 mov	 di,msgml42
;	 rep	 movsb
;	Local or remote terminal?  check?
;	 call	 termcon
;	si now point at string (6 bytes), while cl holds the counter, 6.
;	 xor	 ch,ch			 ;clear upper byte of counters
;	 mov	 di,msgml44
;	 rep	 movsb
;	Get type of support at this port (terminal, TC, etc.. )
;	 call	 termtyp
;	si now point at string, while cl holds the counter
;	 xor	 ch,ch			 ;clear upper byte of counters
;	 mov	 di,msgml5
;	 rep	 movsb
;	Flash the terminal originating this command
;	 mov	 di,usermask
;	 mov	 cx,[di]
;	 cmp	 es:comorg,cx		 ;Original user?
;	 jnz	 mxedata4		 ;jump if not originating user
;	 mov	 byte ptr es:msgml1,'*'
;	 jmp	 mxedata5
;mxedata4:
;	 mov	 byte ptr es:msgml1,' '
;mxedata5:
;	 mov	 ds,dx			 ;restore the original ds
;	 mov	 si,msgml01		 ;output messages, flash attribute
;	 mov	 cl,msgml01l
;	 xor	 ch,ch
;	 call	 putstr
;	 pop	 bx
;	 pop	 cx
;	 add	 byte ptr es:msgml2,1		  ;get next port number check??
;	 add	 bx,2
;	 loop	 mxedqq
;	 ret
;mxedqq:
;	 jmp	 mxedata1
;mxedata0	 endp
;
termcon 	proc		;check? Note!!! Take good care of es segment
;	**************************************************
;	Find out what kind terminal, Local or remote ?
;	Return : si points at the string, cl holds counter
;	**************************************************
;	mov	di,ip_
	mov	cl,3
	mov	si,msgtc1

	ret
termcon 	endp
;
termtyp 	proc		;j+
;	***************************************************
;	Routine finds out type of support at this port
;	Return : si points at the string, cl holds counter
;	***************************************************
	mov	cl,0ah		;length of string
	mov	al,es:porttype
	mov	di,usermask
	and	ax,[di]
	jnz	termtyp2	;jump if support TC
	mov	si,msgtyp1	;Standard Wang Terminal
	ret
termtyp2:			;TC
	mov	si,msgtyp2
	ret
termtyp 	endp
;
chkpsw		proc		;j+
;	**********************************************************************
;	Routine tests inputted password to see if it matches the current psw
;	This routine is used within 'command' mode, and assumed command is in
;	com_buf. All blanks leading up to the beginning of psw will be ignored
;	but imbedded blanks are allowed. Any char, apart from backspace (08h)
;	and return (0dh) are legal in psw.
;	Return: Z = NOT match, NZ = psw match
;	**********************************************************************
	cld
	mov	cx,6		;6 at most
	mov	si,psw
	call	prs_come	;get first byte, ignoring leading zeros if any
	jz	chkpswz 	;no data return with not-match flag
	jmp	chkpsw3
chkpsw2:
	call	prs_com
chkpsw3:
	mov	ah,al
	lods	byte ptr es:[si]
	cmp	al,ah
	jnz	chkpswer	;NOT match!
	loop	chkpsw2
	or	al,0ffh 	;set NZ
	ret
chkpswer:
	cmp	word ptr es:comorg,0
	jz	chkpswz
	mov	si,msger3
	mov	cl,msger3l
	xor	ch,ch
	call	putstr
	and	cx,0		;set Z flag
chkpswz:
	ret
chkpsw		endp
;
findport	proc		;j+
;	************************************************************************
;	Routine finds the data segment corresponding to 'port designator' that
;	passed in al. The rules are as following:
;	0 = comorg, 1 = port 0, 2 = port 1, 3 = port 2,..., 16 = port 15
;	Entry: ax holds the external port designator, decimal and could be ascii.
;	Return: dx holds the segment of that port.
;		Z = illegal port designator, NZ = OK.
;	************************************************************************
	and	al,0fh		;maskoff top bit in case al is ascii!
	and	ah,0fh
	cmp	ax,0		;comorg?
	jnz	port0		;jump if not
	cmp	word ptr es:comorg,0
	jz	finder		;error
	mov	ax,ds
	mov	dx,ax
	or	si,0ffh 	;NZ flag
finder:
	ret
port0:
	cmp	ah,0
	jz	findpt1
	cmp	ah,1
	jnz	port00
	add	al,0ah		;adjust to hex
	cmp	al,10h		;out of bound?
	jbe	findpt1
port00:
	xor	si,si		;Z, error
	ret
findpt1:
;	For the switch of port 2, and 3
	cmp	al,2		;2nd port?
	jnz	porta1
	mov	al,3		;make it the 1c port which in 3rd array
	jmp	porta9
porta1:
	cmp	al,3		;3rd port?
	jnz	porta9		;neither 2 nor 3
	mov	al,2		;it port 1b, make it 2nd in the array
;	End of switching
porta9:
	sub	al,1
	sal	al,1		;index of data segment
	xor	bh,bh
	mov	bl,al
	mov	di,dataseg
	mov	ax,es:[di][bx]
	mov	dx,ax
	or	ax,0ffh
	ret
findport	endp
;
memtest 	proc
	ret
memtest 	endp
;
