;
termint proc			;j+
;	***************************************************
;	These are the entries of interrupts from each port.
;	***************************************************
int_vec60:			;INT service for 1a, 1b
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,0		;Index of dataseg for ports
	mov	dx,isr_1ab	;Addressing the Interrupt status register
	jmp	intrtn		;jump to interrupt service routine
	;---------------------------------------------------------
int_vec61:			;INT service for 1c, 1d
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,4		;Index of dataseg for ports
	mov	dx,isr_1cd	;Addressing the interrupt status register
	jmp	intrtnx 	;jump to interrupt service routine
	;---------------------------------------------------------
;
int_vec62:			;INT service for 1e, 1f
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,8		;Index of dataseg for ports
	mov	dx,isr_1ef	;Addressing the interrupt status register
	jmp	intrtnx 	;jump to interrupt service routine
	;---------------------------------------------------------
;
int_vec63:			;INT service for 1g, 1h
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,12		;Index of dataseg for ports
	mov	dx,isr_1gh	;Addressing the interrupt status register
	jmp	intrtnx 	;jump to interrupt service routine
	;---------------------------------------------------------
;
int_vec64:			;INT service for 2a, 2b
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,16		;Index of dataseg for ports
	mov	dx,isr_2ab	;Addressing the interrupt status register
	jmp	intrtnx 	;jump to interrupt service routine
	;---------------------------------------------------------
;
int_vec65:			;INT service for 2c, 2d
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,20		;Index of dataseg for ports
	mov	dx,isr_2cd	;Addressing the interrupt status register
	jmp	intrtnx
;
int_vec66:			;INT service for 2e, 2f
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,24		;Index of dataseg for ports
	mov	dx,isr_2ef	;Addressing the interrupt status register
	jmp	intrtnx 	;jump to interrupt service routine
	;---------------------------------------------------------
;
int_vec67:			;INT service for 2g, 2h
	cli
	push	ds
	pusha
	mov	ax,060h
	mov	ds,ax
	mov	es,ax
	mov	bx,28		;Index of dataseg for ports
	mov	dx,isr_2gh	;Addressing the interrupt status register
	jmp	intrtnx
	;---------------------------------------------------------
;
intrtn:
	in	al,dx		;Input the interrupt status register
intrtn1:
	test	al,rxrdya	;bit 1, receiver ready, a channel
	jz	intrtn0
	jmp	rxrdy
intrtn0:
	test	al,txrdya	;bit 0, transmission, a channel ready
	jz	intrtn2
	jmp	txrdy
intrtn2:
	test	al,erra 	;bit 2, error condition, a channel
	jz	intrtn3
	jmp	error
intrtn3:
	test	al,pnt1sc	;bit 3, .1 second int comming
	jz	intrtn4x
	jmp	pnt1s
	;--------------------------------------------------------
error:				;some error in line
				;don't care for that; just ignore it
	mov	ax,es:dataseg[bx]	;get the data segment
	mov	ds,ax
	mov	di,rthr
	mov	dl,[di] 	;get the code
	xor	dh,dh
	in	al,dx
;	debug for power on/off of 1st port
	mov	di,crport
	mov	dl,[di]
	mov	al,50h		;reset the break condition bit
	out	dx,al
;
;	debug for power on/off of 1st port, end
;	call	putrx		;put to buffer
;				 clear the error status
	jmp	intret		;that's all
;
;	-------------------------------------------------------------
;	This is the dummy routine only to read in bytes for ports.
intrtnx:
	in	al,dx		;Input the interrupt status register
intrtn1x:
	test	al,rxrdya	;bit 1, receiver ready, a channel
	jz	intrtn0x
	jmp	rxrdyx
intrtn0x:
	test	al,txrdya	;bit 0, transmission, a channel ready
	jz	intrtn2x
	jmp	txrdyx
intrtn2x:
	test	al,erra 	;bit 2, error condition, a channel
	jz	intrtn4x
	jmp	errorx
;intrtn3x:
;	test	al,pnt1sc	;bit 3, .1 second int comming
;	jz	intrtn4x
;	jmp	pnt1s
intrtn4x:
	add	bx,2		;must be second (b) port status
	test	al,rxrdyb	;bit 5, receiver ready, b channel
	jz	intrtn5x
	jmp	rxrdyx
intrtn5x:
	test	al,txrdyb	;bit 4, Transmission ready, b channel
	jz	intrtn6x
	jmp	txrdyx
intrtn6x:
	test	al,errb 	;bit 6, error condition, b channel
	jnz	errorx		;We don't want to use bit 7
	jmp	intret		;nothing else, go back
	;--------------------------------------------------------
errorx: 			;some error in line
				;don't care for that; just ignore it
	mov	ax,es:dataseg[bx]	;get the data segment
	mov	ds,ax
	mov	di,rthr
	mov	dl,[di] 	;get the code
	xor	dh,dh
	in	al,dx
;	debug for power on/off of 1st port
	mov	di,crport
	mov	dl,[di]
	mov	al,50h		;reset the break condition bit
	out	dx,al
;
;	debug for power on/off of 1st port, end
;	call	putrx		;put to buffer
;				 clear the error status
	jmp	intret		;that's all
	;---------------------------------------------------------
rxrdyx:
	mov	ax,es:dataseg[bx]     ;Point to desired data segment
	mov	ds,ax
rxrdycx:
	mov	di,rthr
	mov	dl,[di] 	;Rx the code
	xor	dh,dh
	in	al,dx
	jmp	intret
;
txrdyx:
	mov	ax,es:dataseg[bx]	;Point to desired data segment
	mov	ds,ax
	call	distx
	jmp	intret
;
;	Receiver Ready		**check? Re-enable interrupt?**
;
rxrdy:
	mov	ax,es:dataseg[bx]     ;Point to desired data segment
	mov	ds,ax
rxrdyc:
	mov	di,rthr
	mov	dl,[di] 	;Rx the code
	xor	dh,dh
	in	al,dx
	cmp	al,crtstop	;CRT stop code?
	je	rxrdy2
	cmp	al,prtstop	;Printer stop code?
	je	rxrdy3
rxrdy1:
	call	putrx		;Simply data, put to buffer
	jmp	intret
;
;	Service CRT stop
;
rxrdy2:
	mov	di,dsrbyte
	test	byte ptr [di],rsdb    ;RSD?
	jnz	rxrdy1
	call	chkfrfc 	;Check 'fc' condition!
	jz	rxrdy1		;Probably not stop if NZ is returned.
	mov	di,txbyte
	or	byte ptr [di],crtstopb
	mov	di,cstopcnt
	inc	byte ptr [di]
	jmp	rxrdy1
rxrdy3:
	mov	di,dsrbyte
	test	byte ptr [di],rsdb    ;RSD?
	jnz	rxrdy1
	call	chkfrfc 	;Check 'fc' condition
	jz	rxrdy1		;Probably not stop if NZ is returned.
	mov	di,txbyte
	or	byte ptr [di],prtstopb
	mov	di,pstopcnt
	inc	byte ptr [di]
	jmp	rxrdy1
;
;	Transmission Ready
;
txrdy:
	mov	ax,es:dataseg[bx]	;Point to desired data segment
	mov	ds,ax
cyclone1:
	mov	di,dsrbyte
	test	byte ptr [di],dtb	;RSD in progress?
	jz	txrdy1
	jmp	txrsd
txrdy1:
	test	byte ptr [di],curdsr	;terminal connected?
	jnz	tx24q			;exit if not connected
tx24q1:
	jmp	txdis24
tx24q:
	test	byte ptr [di],timeoutb		;timeout?
	jnz	tx24q1		;go disable Tx
	inc	di		;point to txbyte
	mov	bl,[di]
	and	bl,0fh		;only want buffer bits
	xor	bh,bh
	shl	bx,1		;get the offset, byte -> word
	jmp	cs:txtab[bx]
;
txtab	dw	txdis		;0000  disable transmition
	dw	txout1		;0001  transmit one character to crt
	dw	swbuf		;0010  crt buffer went empty - send esc code to switch buffers
	dw	crtchk		;0011  test for max to crt and possibly sent esc code
	dw	txdis		;0100  buffers empty - disable transmition
	dw	swbuf		;0101  prt buffer went empty - send escape code
	dw	txout2		;0110  transmit one character to prt
	dw	prtchk		;0111  test for max to prt and possibly send esc code
	dw	prtcode1	;1000  switch to PRT buffer
	dw	crtcode1	;1001  switch to CRT buffer
	dw	prtcode1	;1010  switch to PRT buffer
	dw	prtcode1	;1011  switch to PRT buffer
	dw	crtcode1	;1100  switch to CRT buffer
	dw	crtcode1	;1101  switch to CRT buffer
	dw	prtcode1	;1110  switch to PRT buffer
	dw	crtcode1	;1111  switch to CRT buffer
;
cyclone:
;	**************************************************
;	Routine to check status register to see if okay to
;	send next byte.
;	**************************************************
	mov	si,srport
	mov	dl,[si]
	xor	dh,dh
	mov	cx,0ah
cyclone3:
;
	in	al,dx		;get the status from SR
	test	al,01h		;Is Receiver coming?
	jnz	cyclone6
	test	al,04h		;Is Transmission ready?
	jnz	cyclone1
	loop	cyclone3
	jmp	intret
cyclone6:
	jmp	rxrdyc
;
crtchk:
	mov	di,countout
	cmp	byte ptr [di],crtmax
	jnc	jpsw		;Yes, countout > crtmax
	inc	byte ptr [di]	     ;No, go service crt_buf output
;	put out char from crt_buf
txout1:
	mov	di,txbyte
	test	byte ptr [di],crtstopb ;crt stop is in txbyte?
	jnz	tryprt		;yes, try printer
	call	getcrt		;get a byte from crtbuf
	jz	jpint		;buffer empty; go back
;
	mov	di,rthr
	mov	dl,[di] 	;check? get port address
	xor	dh,dh
	out	dx,al		;put out character
jpint:
	jmp	cyclone
;
tryprt:
	mov	di,txbyte
	test	byte ptr [di],prtbit   ;test printer buffer
	jz	txdis
	test	byte ptr [di],prtstopb ;if stop bit is set
	jnz	txdis		;disable transmission
jpsw:
	jmp	swbuf
;
prtchk:
	mov	di,countout
	cmp	byte ptr [di],prtmax
	jnc	swbuf
	inc	byte ptr [di]
;
txout2:
	mov	di,txbyte
	test	byte ptr [di],prtstopb ;prt stop is in txbyte?
	jnz	trycrt		;yes, try crt
	call	getprt		;get a byte from prtbuf
	jz	jpint		;buffer empty; go back
	mov	di,rthr
	mov	dl,[di]
	xor	dh,dh
	out	dx,al		;put out character
	jmp	cyclone
;
trycrt:
	mov	di,txbyte
	test	byte ptr [di],crtbit   ;test crt buffer
	jz	txdis
	test	byte ptr [di],crtstopb ;if stop bit is set
	jnz	txdis		;disable transmission
	jmp	swbuf
;
txdis:
	mov	di,flag2
	test	byte ptr [di],modebit	;command mode bit set?
	jz	txdis211	;jump if not command mode
	mov	di,rbi
	mov	byte ptr [di],0 	  ;reset ready bits since we're in command mode
txdis211:
	mov	di,countout
	mov	byte ptr [di],0
txdis24:
	call	distx
;	jmp	cyclone
	jmp	intret
;
crtcode1:
	mov	di,txbyte
	and	byte ptr [di],not switchb
	and	byte ptr [di],not lastbit
	mov	al,crtcode
	jmp	outbyte
;
prtcode1:
	mov	di,txbyte
	and	byte ptr [di],not switchb
	or	byte ptr [di],lastbit
	mov	al,prtcode
	jmp	outbyte
;
swbuf:
	mov	di,countout
	mov	byte ptr [di],0
	mov	di,txbyte
	or	byte ptr [di],switchb
	mov	al,esccode
outbyte:
	mov	di,rthr
	mov	dl,[di]
	xor	dh,dh
	out	dx,al
	jmp	cyclone
;
txrsd:
;	During the RSD, no byte from the CRT and PRT buffers may be sent to the
;	terminal. The DT buffer is used instead to send controls to the terminal.
;	call	getdt		;output a byte from DT buffer, (no compression!)
;	jz	txrsddis	;jump if last byte
;	or	al,al		;if the byte is zero and abort bit is set
;	jnz	txrsd2
;	mov	di,rsdbyte
;	test	byte ptr [di],rsdabrtb	      ;then switch buffer
;	jnz	txrsdd3 	;i.e. this is the end of the RSD
;txrsd2:
;	mov	di,rthr
;	mov	dl,[di]
;	xor	dh,dh
;	out	dx,al
;	jmp	cyclone
;txrsddis:
;	call	distx		;check? disable transmission
;	mov	di,rsdbyte
;	test	byte ptr [di],rsdabrtb	      ;is end of RSD?
;	jz	txrsdj		;No
;		End of RSD, reset dt flag to allow output from CRT & PRT
;txrsdd3:
;	mov	di,rsdbyte
;	and	byte ptr [di],not rsdabrtb
;	or	byte ptr [di],rsdendb
;	mov	di,dsrbyte
;	and	byte ptr [di],not dtb
;txrsdj:
	jmp	cyclone
;
pnt1s:				;check? the ds=>data0
	push	es
	pop	ds
	or	byte ptr es:tmrbyte,p1secb  ;set .1 second bit
	inc	byte ptr es:p1cnt
	cmp	byte ptr es:p1cnt,10	    ;one second?
	jne	intret			    ;no,
	mov	byte ptr es:p1cnt,0	    ;reset count
	or	byte ptr es:rxbyte,clock_1i ;set one second bit
intret:
	popa
	pop	ds
	sti
	iret
termint endp
;
entx	proc			;j+
;	*****************************************************************
;	Routine that enables the transmitter of UART Regs for that port.
;	*****************************************************************
	pushf			;save the interrupt enable/disable condition
	cli			;disable interrupt
	push	es
	mov	ax,060h
	mov	es,ax
;
;	Test the dtr over here
	in	al,ip_2ab
	mov	ah,al
	in	al,ip_2cd
	mov	di,usermask
	mov	bx,[di]
	test	ax,[di]
	jz	entx_z		;Connected! go ahead enable it.
;
;	20/nov/91, bugging for other cables
	test	bx,05		;port 1a, or 1c
	jz	entxw		;neither, jmp
	test	bx,01
	jz	entx1c
;			 This is port 1a
	in	al,ip_1ab
	test	al,04
	jnz	entxw		;not connected
	jmp	entx_z		;connected
;
entx1c: 		;This is port 1c
	in	al,ip_1cd
	test	al,04
	jz	entx_z		;connected
;	20/nov/91, bugging for other cables, end
;
entxw:
	mov	ax,es:try_dtr
	or	ax,bx		;Mark, this port was disconnected.
	mov	es:try_dtr,ax
	jmp	entx_zz
;				;But try to enable it next time.
entx_z:
	mov	di,crport
	mov	dl,[di]
;	mov	di,crdata
;	and	byte ptr [di],not distxb
;	or	byte ptr [di],entxb
;	mov	al,[di]
	mov	al,04
	xor	dh,dh
	out	dx,al
	mov	di,usermask
	mov	bx,[di]
	not	bx
	mov	ax,es:try_dtr
	and	ax,bx
	mov	es:try_dtr,ax
entx_zz:
	pop	es
	popf
	ret
entx	endp
;
distx	proc			;j+
;	****************************************
;	Disable the Transmitter register of UART
;	****************************************
	pushf			;save the interrupt enable/disable condition
;	cli			;disable interrupt
	mov	di,crport
	mov	dl,[di]
;	mov	di,crdata
;	and	byte ptr [di],not entxb
;	or	byte ptr [di],distxb
;	mov	al,[di]
	mov	al,08h
	xor	dh,dh
	out	dx,al
	popf
disret:
	ret
distx	endp
;
timeout proc			;j+
;	**********************************************************************
;	Routine sets a countdown timeout for the port, the 2-byte count in ax.
;	ax decrements every one second clock, until it reaches zero.
;	**********************************************************************
	mov	di,timedwn
	mov	[di],ax 		;ax is the count will be decremented at
					;each one second clock int until it
	; put routine in bx		;reach zero.
	mov	di,timestrt
	mov	[di],bx        ;di is the routine pointer if counter
					;reach zero, it will be called.
	mov	di,dsrbyte
	and	byte ptr [di],not discimmb
	ret
timeout endp
;
cntdwn	proc				;j+
;	*************************************************************
;	Routine decreases the countdown bytes until it reaches zero.
;	The routine pointed by timestrt will be executed then.
;	*************************************************************
;	Each port has two counters. One counts the timeout at the terminal after
;	a disconnect and the other is a general counter normally used
;	to initiate some action after a given time.  The timeout counter
;	ALWAYS takes precedence!  If the timeout counter is not zero it is
;	decremented (and not the other counter).  When the timeout counter is
;	decremented to zero the routine "CONJ" is called.
	mov	di,timedwnd
	cmp	byte ptr [di],0
	jz	cntdwn3
	cmp	byte ptr [di],0ffh	     ;Infinite, do not decrease
	jz	cntdwnz
	dec	byte ptr [di]
	jnz	cntdwnz
	call	conj
cntdwnz:
	ret
cntdwn3:
	inc	di			;point at timedwn
	cmp	word ptr [di],0
	jz	cntdwnz
	dec	word ptr [di]
	cmp	word ptr [di],0
	jnz	cntdwnz
;				Zero count! Call routine pointed by timestrt


	ret
cntdwn	endp
;
disconj proc				;j+
;	********************************************************************
;	This routine disconects the current port. A 5 second timeout is set
;	which will then allow connections at the port
;	ENTRY: ds = point to the data segment of the port
;	EXIT: the uart for the port drops DTR so modems will hang up and
;	TIMEOUTB is set so bytes will be bitbucketed to and from terminal
;	********************************************************************
	mov	di,dsrbyte
	or	byte ptr [di],timeoutb	      ;set timeout flag
	and	byte ptr [di],not curdsr
	mov	ax,0
	call	timeout
	mov	al,0ffh
	mov	di,dsrbyte
	test	byte ptr [di],disconb	      ;disconnect system in effect?
	jnz	disconj2
	mov	al,5
disconj2:
	mov	di,timedwnd
	mov	[di],al
					;check????? some modem actions

	mov	di,txbyte
	and	byte ptr [di],not rsdreqb      ;reset RSD request in progress flag
	mov	di,rsdbyte
	mov	byte ptr [di],0
	mov	di,termbyte
	mov	byte ptr [di],0
	mov	di,dsrbyte
	test	byte ptr [di],disconb	      ;should we alert 2200?
	jz	disretz 		;no,
	mov	di,usermask
	mov	ax,[di]
	or	es:disconnect_byte,ax	  ;set the status to 2200
disretz:
;	mov	connect_dis,0ffh	;set disconnect flag
	mov	di,outblock
	or	byte ptr [di],disblock
	mov	di,rbimask
	mov	byte ptr [di],32h
	ret
disconj endp
;
conj	proc				;j+
;	********************************************
;	Reinitalize a port which had been timeouted.
;	********************************************
	mov	di,dsrbyte
	test	byte ptr [di],discimmb	      ;check to see if the terminal is to be
	jz	conj2			;disconnected upon connection
	and	byte ptr [di],not discimmb    ;reset the flag
	mov	ax,0
	mov	di,offset disconj
	call	timeout 		;set up a one second connection
conj2:
					;check????? modem actions
	mov	di,dsrbyte
	and	byte ptr [di],not timeoutb    ;reset timeout flag
	call	rstbufc 		;clear the crt buffer
	call	rstbufp 		;clear the prt buffer
	mov	al,esccode
	call	putcrtg
	mov	al,termrst		;hard reset to the terminal
	call	putcrtg
	call	rstterm 		;reset the terminal and wait
	mov	di,outblock
	mov	byte ptr [di],0
	mov	di,rbimask
	mov	byte ptr [di],0ffh
;	mov	connect_dis,0		;current port is connected
	mov	di,usermask
	mov	ax,[di]
	or	es:connect_byte,ax	  ;alert 2200
	ret
conj	endp
;
testdsr proc			;j+
;	*****************************************************************
;	Test current state of the port and alert the condition of Connect
;	or Disconnect. If it's connect, routine will enable tx int's to
;	prevent losses.
;	*****************************************************************
	call	cntdwn
	mov	ax,es:connect_byte
	mov	di,usermask
	test	ax,[di] 	;does current port connect?
	jnz	testdsr5	;no,
	mov	di,dsrbyte
	test	byte ptr [di],timeoutb	      ;is timeout in progress?
	jnz	testdsrret	;exit if port is timeout
	call	entx
	mov	di,dsrbyte
	test	byte ptr [di],rsdb    ;doing RSD?
	jz	testdsr2	;not RSD
	mov	al,esccode	;now, in RSD
	call	putdt
	mov	di,rsdbyte
	test	byte ptr [di],rsdwaitb	      ;terminal stopped?
	jnz	testdsr1	;jmp if not wsit state
	mov	al,rsdgo
	jmp	short testdsr11
testdsr1:
	mov	al,rsdstop
testdsr11:
	call	putdt
	mov	di,curnt_sts
	or	byte ptr [di],rsdint
testdsr2:
	mov	di,dsrbyte
	test	byte ptr [di],curdsr  ;test connect bit
	jnz	testdsrret
	or	byte ptr [di],curdsr
	test	byte ptr [di],conb    ;connection alert set?
	jz	testdsrret	      ;exit if 2200 doesn't want to know
	test	byte ptr [di],disconb ;discon/connection alert on?
	jz	testdsrret	      ;if 2200 doesn't want to know
	mov	di,usermask
	mov	ax,[di]
	or	es:connect_byte,ax
	jmp	short testdsrret
testdsr5:
	mov	di,dsrbyte
	test	byte ptr [di],curdsr  ;is new disconnect
	jz	testdsrret	      ;if not new disconnect
	call	disconj 	      ;set up timeout
	mov	di,dsrbyte
	test	byte ptr [di],disconb ;disconnection alert on?
	jz	testdsrret	      ;if 2200 doesn't want to know
	mov	di,usermask
	mov	ax,[di]
	or	es:disconnect_byte,ax
testdsrret:
	ret
testdsr endp
;
rxin	proc			;j+
;	*******************************************************************
;	Main receiver int service routine THIS ROUTINE IS CALLED!!!
;	(For the service of each buffer of each port)
;	ENTRY: DS points at data segment of current port
;	EXIT: An input char from the currently int ports uart is read and
;	      processed (as stated below).
;	DAMAGE: all registers are restored to their preinteruppt state!
;	*******************************************************************
	call	getrx		;get character, if no char, return zero flag set
	jnz	rxin1		;al holds the incoming data if any.
	ret
rxin1:
	mov	dl,al		;dl holds current byte for security
; The input char could be part of a two byte code or could be a special
; control code requiring immediate action.  Flags must be tested here to
; determine what action must be taken.	The following situations
; are possible:
;
; -The last byte was a X'FC' or X'FD' meaning the current byte is part of a
;  2 byte code in which case the current byte is either stored or ignored.
; -The last byte was NOT a X'FC' or X'FD' meaning the current byte COULD be,
;  or the current byte could be a special 1 byte command to the MXF (such as
;  a terminal buffer full code or terminal buffer empty code), or it
;  could be a RESET or HALT/STEP, or it could have no special meaning and
;  is to be stored.
;
; NOTE: For foreign terminals, the above codes will probably be different
;	and this section of code may have to be modified.
;	.............
; test for timeout and bitbucket bytes from timedout port!
;
	mov	di,dsrbyte
	test	byte ptr [di],timeoutb	      ;timeout?
	jnz	jprx3			      ;jmp if timeout
	test	byte ptr [di],rsdb	      ;RSD in progress?
	jz	rxinq9
	jmp	rxin3
rxinq9:
	xor	cl,cl
	mov	di,flag1
	xchg	cl,[di] 	;get flag1 in al and clear flag1
	and	cl,fdfcmask	;just want fd and fc bits
				;If it set means last byte is either fd or fc.
	jz	rxin1_4 	;jump if either fd, fc is set, so store the byte
	jmp	rxin1_6
rxin1_4:
				;Current byte is not second part of 2-byte-code.
				;Test first byte of a 2 byte code.
	cmp	al,0f0h 	;f0h or above?
	jae	rxin1_45	;jmp if above than efh
;	cmp	al,0e4h 	;RSD support code?  check?
;	jnz	rxin1401	;jmp if not
;	or	termbyte,rsdsuprt	;rsd supports in MXF always.
;jprx3:
;	 jmp	 rxin3
;rxin1401:
	cmp	al,0bdh 	;edit key?
	je	rsdcan		;go look for RSDREQ pending
	cmp	al,0e5h 	;LINE ERASE?
	jne	rxin14q 	;store byte
rxin4q:
	jmp	rxin2
rxin14q:
	cmp	al,0e6h 	;STATEMENT #?
	je	rxin4q
	cmp	al,0e0h 	;between 0e0h and 0f8h
	jae	jprx3		;disregard byte
				;Character is less than e0h
	cmp	al,12h		;RESET code?
	jne	rxin1_42
				;RESET received!
				;set the reset bit in termstat and set status for 2200
rxin140:
;
	call	rstbufk 	;reset key buffer
	call	rstbuf		;reset buffers
	call	moderst 	;go reset command mode
	call	rstlr		;reset line request
;	mov	di,usermask
;	mov	bx,[di]
;	or	es:reset_byte,bx
	mov	di,cmd_sts
	mov	byte ptr [di],77h
;	call	int_386 	;interrupt OS386
jprx3:
	jmp	rxin3
rxin1_42:
	cmp	al,13h		;HALT/STEP code
	jne	rxin4q
	call	rstbufk 	;clear keybuf
	call	moderst 	;go reset command mode
	mov	di,usermask
	mov	bx,[di]
	or	es:halt_step_byte,bx
	jmp	rxin3
rxin1_45:
				;char must be f0h or greater
;	sub	al,0f0h
	xor	bx,bx
	mov	bl,al
	and	bl,0fh		;adjust offset
	shl	bx,1
	jmp	cs:rxtab2[bx]
;
rxtab2	dw	rsdcan		;F0 - cancel pending RSD request (unescaped RSD)
	dw	rxin3		;F1 - nothing special (ignore)
	dw	strtrsd 	;F2 - start of RSD bytes
	dw	setfc		;F3 - request for RSD
	dw	rxin2		;F4 - nothing special
	dw	rxin2		;F5 - nothing special
	dw	rxin2		;F6 - nothing special
	dw	rxin2		;F7 - nothing special
	dw	gocrt1		;F8 - terminal crt buffer empty
	dw	goprt1		;F9 - terminal prt buffer empty
	dw	stopcrt1	;FA - terminal crt buffer full
	dw	stopprt1	;FB - terminal prt buffer full
	dw	setfc		;FC - transparancy code (2 bytes)
	dw	setfd		;FD - special function or atom (2 bytes)
	dw	dead		;FE - dead key - translate to X'FF'
	dw	dead		;FF - treated as dead key
;
;**********************************************************************
rsdcan:
;	A 'bd' or 'fdf0' has been pressed - edit key
;	Cancel pending rsd request if there is one, or store that byte if not.
;
	mov	al,0bdh
	mov	di,txbyte
	test	byte ptr [di],rsdreqb  ;RSD request pending?
	jz	rxin4q		;if not, jump to store this byte, otherwise
				;request is currently pending - cancel it
	and	byte ptr [di],not rsdreqb      ;cancel request bit
	and	byte ptr [di],not crtstopb     ;allow the crt to go
	mov	al,canrsd
;	call	com2200 	;putout cancel command to 2200, check?
	jmp	rxin3
;**********************************************************************
strtrsd:
;	Start of RSD data stream code! switch input to RSDBUF
;
;	mov	di,dsrbyte
;	or	byte ptr [di],rsdb    ;route RSD input to RSDBUF
	jmp	rxin3
;**********************************************************************
rsdreq:
;	The terminal is requesting a RSD. Send the request to CS386 and
;	set the appropriate flags
;
;	mov	di,txbyte
;	or	byte ptr [di],crtstopb ;freeze the CRT
;	or	byte ptr [di],rsdreqb  ;set request bit
;	mov	al,reqrsd
;	call	com2200 	;putout request check?
	jmp	rxin3
;**********************************************************************
gocrt1:
;	F8h received - restart crt transmission
;	if no pending prescanned stop codes
;
	mov	di,cstopcnt
	cmp	byte ptr [di],0      ;is the cnt of stop codes in buffer is 0
	jnz	stopcrt2	     ;buffer still has stop code, do nothing
	mov	di,txbyte
	test	byte ptr [di],rsdreqb	       ;RSD request pending?
	jnz	stopcrt2		       ;yes,
	and	byte ptr [di],not crtstopb     ;reset the stop bit
	test	byte ptr [di],crtbit
	jnz	gocrt12
;
	mov	di,rbi
	or	byte ptr [di],crtrb
	mov	di,curnt_sts
	or	byte ptr [di],crtint
gocrt12:
	call	entx
	jmp	rxin3
;**********************************************************************
stopcrt1:
;	fah received - stop crt transmission
;
	mov	di,txbyte
	or	byte ptr [di],crtstopb ;set the stop bit
	mov	di,cstopcnt
	cmp	byte ptr [di],0
	je	stopcrt2
	cli			;disable interrupt
	dec	byte ptr [di]
	sti			;enable interrupt
stopcrt2:
	jmp	rxin3
;**********************************************************************
goprt1:
;	f9h received - restart prt transmission if no stop codes in buffer
;
	mov	di,pstopcnt
	cmp	byte ptr [di],0      ;any pending stop codes?
	jnz	stopcrt2	;yes, ignore this go code
	mov	di,txbyte
	and	byte ptr [di],not prtstopb     ;reset stop bit
	test	byte ptr [di],prtbit
	jnz	goprt12
;
	mov	di,rbi
	or	byte ptr [di],prtrb
	mov	di,curnt_sts
	or	byte ptr [di],prtint
goprt12:
	call	entx
	jmp	rxin3
;**********************************************************************
stopprt1:
;fbh received - stop prt transmission and update count of pending stop codes
;
	mov	di,txbyte
	or	byte ptr [di],prtstopb ;set the stop bit
	mov	di,pstopcnt
	cmp	byte ptr [di],0
	je	stopprt12
	cli			;disable interrupt
	dec	byte ptr [di]
	sti			;enable interrupt
stopprt12:
	jmp	rxin3
;**********************************************************************
setfc:
;	fch is current char, 'fc''byte' is a 2-byte code denoting that
;	'byte' should not be interpreted as a special code. For example,
;	'12' is reset but 'fc''12' is '12' save in bytesave for storage
;	next time around.
;
	mov	di,bytesave
	mov	[di],al     ;save fc here
	mov	di,flag1
	or	byte ptr [di],fcbit
	jmp	rxin3
;**********************************************************************
setfd:
;	fdh is current char, 'fd''byte' is a 2-byte code denoting that
;	'byte' should not be interpreted as a special code. For example,
;	'12' is reset but 'fd''12' is 'special function 12' save in
;	bytesave for storage next time around.
;
	mov	di,bytesave
	mov	[di],al     ;save fd here
	mov	di,flag1
	or	byte ptr [di],fdbit
	jmp	rxin3
;**********************************************************************
dead:
;	Dead key received. expecting UNDERSCORE+CHAR to follow.
;	Send dead key as 0ffh
;
	mov	di,flag1
	mov	byte ptr [di],fdfcmask	;set fcfd bit
	mov	di,bytesave
	mov	byte ptr [di],deadkey2
	mov	ah,0		;store ffh
	jmp	rxin2_03	;go store byte
;**********************************************************************
rxin1_6:			;j+
;	Last byte was 'fd' or 'fc', so we need to store the
;	contents of bytesave before the current byte.
;	Exit: current code in al.
;
	mov	di,bytesave
	mov	ah,[di]
	cmp	ah,0fdh 	;endi escape?
	jne	rxinq1
;	jne	rxin1_7
;				 case of 0fdh, endi/atom + char
	cmp	al,prtstop	;prt stop code?
	jne	rxin1_62
				;This was confused with a stop code in the Rx int
				;decrement stop counter
	mov	di,pstopcnt
	dec	byte ptr [di]	;dec count of prescanned stops
	jnz	rxin1_67	;jmp if not down to zero
			;the count of prescanned stops now decrements to zero
			;which means that an escaped byte looked like a stop
			;and should not have stopped Tx.
			;It is therefor necessary to restart transmission
	mov	di,txbyte
	and	byte ptr [di],not prtstopb     ;allow transmission
	jmp	rxin1_67	;go store byte
rxin1_62:
	cmp	al,crtstop
	jne	rxin1_67
			;look for false CRT stop code. i.e.
			;escaped stop codes which were confused  with stop codes
	mov	di,cstopcnt
	dec	byte ptr [di]
	jnz	rxin1_67
	mov	di,txbyte
	and	byte ptr [di],not crtstopb
rxin1_67:
	cmp	al,0f0h 	;is edit keys?
	jnz	rxinq1
	jmp	rsdcan
rxinq1:
	mov	al,ah		;ah is last code, al is current (over-written).
rxin1_7:			;case of fch, trans + char
	cmp	al,rqrsd	;RSD request command?
	jne	rxin2_01	;no, go store it
	jmp	rsdreq		;init request if so
;	**********************************************************************
;
rxin2:
	mov	ah,0		;store a status code and the current byte next
rxin2_01:
	mov	al,dl		;ah store status code and al is current byte
	cmp	al,modebyte	;occurance of modebyte?
	je	modeset 	;if so, go count it
	mov	di,count1
rxin2_02:
	mov	byte ptr [di],0ffh	;reset count to inactive mode
rxin2_03:
	call	putkeys 	;store byte
	jz	rxin2_2q	;exit if insertion was not successful
	mov	di,txbyte
	test	byte ptr [di],keybit	;test keyboard bit of current buffer
	jnz	rxin2_2q
	or	byte ptr [di],keybit
	mov	di,lrbyte
	test	byte ptr [di],lrbit	;LR in progress?
	jz	rxin2_2 	;jmp if not,
	mov	di,usermask
	mov	bx,[di]
	or	es:commode,bx	;set the current port bit to service
	jmp	rxin3
rxin2_2:
	mov	di,intbyte
	test	byte ptr [di],keyint
	jz	rxin2_2q
	and	byte ptr [di],not keyint
	mov	di,curnt_sts
;	mov	di,flag9
	or	byte ptr [di],keyint
rxin2_2q:
	jmp	rxin3
modeset:
				;count the occurances of 'modebyte' and
				;enter command mode at designated number
	mov	di,count1
	inc	byte ptr [di]	       ;count of modebyte
	jz	rxin2_02	       ;jmp if bump
;					possible entry into command mode
	cmp	byte ptr [di],mdbytep  ;mdbyte is 3
	jne	rxin2_03	       ;go store byte if not at count
;					 Command mode!
	mov	byte ptr [di],0
	dec	di			;point at flag2
	or	byte ptr [di],modebit	;set command mode flag
	mov	si,msgmd1
	mov	cl,msgmd1l
	xor	ch,ch
	call	putstr
;	jmp	rxin3
;	*********************************************************************
rxin3:
	sti
	or	dh,0ffh 	;NZ flag
	ret
rxin	endp
;
;int_386 proc
;	********************
;	MXF interrupts OS386
;	********************
;	 mov	 dx,8000h	 ;Interrupt address to OS386
;	 mov	 al,0
;	 out	 dx,al		 ;interrupt CS386
;int_386 endp
;
