;
.286c
;       *********************************************************
;       This is the Main program of MXF/PROM of 2200 machine
;                   By J. L. Hong   1th, May. 1990
;       *********************************************************
;
;include diag.asm
;
include table.asm
;
code0   segment public
        assume  cs:code0
;
begin0: cli                     ;j+
        mov     ax,0140h        ;setup stack
        mov     ss,ax
        mov     ax,1feh
        mov     sp,ax
begin:
        mov     ax,060h
        mov     ds,ax
        mov     es,ax
        mov     di,head_rom
        mov     ax,offset begin0
        mov     [di],ax
        add     di,2
        mov     word ptr [di],0f000h
        call    init            ;initial
        sti
main_lop:
        mov     di,0
        mov     ax,es:dataseg[di]  ;point at first user
        mov     ds,ax
cmd_lop:
        mov     si,cmd_sts
        mov     al,[si]
        cmp     al,0fh          ;Is command comming?
        jne     try_next        ;no, try next
        call    port_serv
try_next:
        call    check_dtr
        call    poll_buf        ;see if terminal asking for services.
        inc     byte ptr es:alive
        jmp     cmd_lop
;
;**********************************************************************
;
;       This subroutine try to service commands from CS386.
;       Return error if no command being found on buffer.
;
;**********************************************************************
port_serv       proc
        mov     di,cmd_abs      ;point at cmd_abs
        mov     al,[di]
        cmp     al,4            ;CS requires the slave printer?
        je      abs4            ;yes,
        cmp     al,6            ;CS issue in/out command?
        je      abs60           ;yes,
        cmp     al,7            ;CS requires the crt?
        je      abs7            ;yes,
                                ;Do some error messages back to main
        ret
abs60:
        jmp     abs6
;
;       Send a print-line to slave print
abs4:
        mov     si,rbi
        test    byte ptr [si],prtrb
        jnz     abs42
        ret
abs42:
        mov     di,cmd_parm
        mov     bl,[di]
        xor     bh,bh
        mov     si,prt_count
        mov     ax,[si]
        add     ax,bx
        cmp     ax,03ffh
        jb      abs49
        ret
abs49:
        cld
        mov     si,cmd_parm
        mov     cl,[si]                 ;get the counter
        xor     ch,ch
        inc     si
        mov     di,prt_wrt
;
        mov     bx,[di]
        mov     di,prt_buf
abs7u:
        mov     al,[si]
absprt3:
        mov     [di][bx],al
        inc     bx
        cmp     bx,03ffh
        jbe     absv
        mov     bx,0
absv:
        push    di
        mov     di,prt_count
        inc     word ptr [di]
        pop     di
        cmp     al,esccode
        jnz     absprt2
        mov     al,0d0h
        jmp     absprt3
absprt2:
        inc     si
        loop    abs7u
;
        mov     di,prt_wrt
        mov     [di],bx
        mov     di,txbyte
        or      byte ptr [di],prtbit
        mov     si,cmd_sts
        mov     byte ptr [si],0f1h      ;command complete without returned value
        call    entx
        ret
;
;       Service the CRT, must take care of $GIO condition
;
abs7:
        mov     si,rbi
        test    byte ptr [si],crtrb
        jnz     abs72
        ret
abs72:
        mov     di,cmd_parm
        mov     bl,[di]
        xor     bh,bh
        mov     si,crt_count
        mov     ax,[si]
        add     ax,bx
        cmp     ax,03ffh
        jb      abs79
        ret
abs79:
        cld
        mov     si,cmd_cbs
        mov     ah,[si]
        cmp     ah,0ffh
        jz      abs77                   ;if cbs = 0ffh, then simply data
        mov     al,esccode
        call    putcrtg
        mov     al,ah
        call    putcrtg
abs77:
        mov     si,cmd_parm
        mov     cl,[si]                 ;get the counter
        cmp     cl,0
        jz      abs71
        xor     ch,ch
        inc     si
;
        mov     di,crt_wrt
        mov     bx,[di]
        mov     di,crt_buf
;
abs7m:
        mov     al,[si]
abscrt3:
        mov     [di][bx],al
;
        inc     bx
        cmp     bx,03ffh
        jbe     absv1
        mov     bx,0
absv1:
        push    di
        mov     di,crt_count
        inc     word ptr [di]
        pop     di
;       cmp     bl,crt_size
;       jbe     putcrt1
;       mov     bl,0
;putcrt1:
        cmp     al,esccode
        jnz     abscrt2
        mov     al,0d0h
        jmp     abscrt3
abscrt2:
;
        inc     si
        loop    abs7m
abs71:
        mov     di,crt_wrt
        mov     [di],bx
        mov     di,txbyte
        or      byte ptr [di],crtbit
        mov     si,cmd_sts
        mov     byte ptr [si],0f1h      ;command complete without returned value
        call    entx
        ret
;
;       CS386 sends and receives commands with MXF
;
abs6:
        mov     di,cmd_cbs
        mov     al,[di]
        cmp     al,maxc         ;Limit entry within total entries.
        ja      cret
        xor     ah,ah
        shl     ax,1
        mov     si,ax
        jmp     cs:crtn[si]
cret:
        ret
;       **********************************************************************
crtn    dw      cret            ;00, no operation
        dw      c0601           ;01, power on, an interrupt command
        dw      c0602           ;02, initialize terminal
        dw      cret            ;03, delete line request, an interrupt command
        dw      cret            ;04, not support
        dw      cret            ;05, not support
        dw      c0606           ;06, get key, an interrupt command
        dw      cret            ;07, line request
        dw      cret            ;08, prefill line request
        dw      cret            ;09, refill line request
        dw      cret            ;0a, end of line request
        dw      cret            ;0b, not support
        dw      cret            ;0c, not support
        dw      cret            ;0d, request CRT buffer - Not support
        dw      cret            ;0e, request PRT buffer - Not support
        dw      cret            ;0f, error line request
        dw      cret            ;10, terminate line request
        dw      c0611           ;11, not support
        dw      cret            ;12, not support
        dw      cret            ;13, not support
        dw      cret            ;14, not support
        dw      cret            ;15, undefined
        dw      cret            ;16, undefined
        dw      cret            ;17, undefined
        dw      cret            ;18, undefined
        dw      cret            ;19, undefined
        dw      cret            ;1a, undefined
        dw      cret            ;1b, undefined
        dw      cret            ;1c, undefined
        dw      cret            ;1d, undefined
        dw      cret            ;1e, undefined
        dw      cret            ;1f, undefined
        dw      cret            ;20, $MXF command
        dw      cret            ;21, return results of $MXF command
        dw      cret            ;22, enable connect
        dw      cret            ;23, disable connect
        dw      cret            ;24, enable disconnect
        dw      cret            ;25, disable disconnect
        dw      cret            ;26, Alert CS system to all connected ports
        dw      cret            ;27, clear pending disconnection
        dw      cret            ;28, get ID of terminal
        dw      cret            ;29, initiate remote screen dump
        dw      cret            ;2a, abort remote screen dump
        dw      cret            ;2b, initiate remote screen dump in rewponce to terminal request
        dw      cret            ;2c, reconnect port
        dw      c062d           ;2d, select special package, TC function
        dw      c062e           ;2e, set MXF password
        dw      c062f           ;2f, warm start
        dw      c0630           ;30, jump to the start of RAM 1d600h
maxc    equ     ($ - crtn)/2    ;Total entries
;
c0601:                          ;01,*power on, an interrupt command
;       ********************************************************************
;       Routine issues the power-on command which will restart the machine.
;       Asking the user sure about this?? check?
;       ********************************************************************
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
        mov     si,head_rom
        jmp     dword ptr es:[si]
;
c0602:                      ;j+
;       *****************************************
;       Routine initializes the current terminal
;       *****************************************
        call    rstbufk
        call    rstbufc
        call    rstlr
        call    rstterm         ;check?
                                ;See if prt needs clearing
        mov     di,cmd_parm
        inc     di
        mov     al,[di]         ;get parameter, only one
        cmp     al,0            ;if 01 then clear crt only, 00 then prt also
        jnz     c0602n          ;Leave if not zero
        call    rstbufp
c0602m:
        mov     al,esccode      ;Output escape code
        call    putcrtg
        mov     al,termrst      ;terminal reset code
        call    putcrtg
        call    rstterm1        ;check? waste time to let terminal reset
        mov     al,0ffh         ;change al to skip c0602n
c0602n:
        cmp     al,01
        jz      c0602m
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
        ret
;
c0606:                       ;j+
;       **********************************************************************
;       Routine passes a byte from keyboard to OS, under the waiting condition
;       of OS. So, interrupt OS when the byte is ready.
;       **********************************************************************
        sti
        mov     di,key_count
        cmp     byte ptr [di],0
;       jnz     c0606a          ;Yes, interrupt OS and send the bytes.
        jz      c0606c
        call    getkeyt
        mov     di,cmd_parm
;       inc     di              ;skip the counter
        mov     [di],al         ;move byte to parameter part of command
        inc     di
        mov     [di],ah
        mov     si,sts_byte
        or      byte ptr [si],01h       ;means key buffer not empty
        mov     di,cmd_sts
        mov     byte ptr [di],0f0h      ;return with value
        ret
c0606c:
        mov     si,sts_byte
        and     byte ptr [si],0feh      ;means key buffer empty
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h      ;return without value
        ret
;
c0611:
;       ********************************************************
;       Routine returns a code to tell OS whether in ROM or RAM
;       ********************************************************
        mov     si,cmd_parm
        mov     byte ptr [si],80h
        mov     si,cmd_sts
        mov     byte ptr [si],0f0h      ;return with value
        ret
;
c062d:                      ;j+ 2d, select special package, TC function
;       ********************************************************
;       This block handles the selection of a special package
;       Format :   CBS(  )  OBS(XX)
;                   WHERE XX = 00       NOP
;                              01       STANDARD WANG TERMINAL
;                              02       TC  (2227B REPLACEMENT)
;       MXE responds with ENDI(00) if selection is legal
;                  or ENDI(NZ) if selection is not legal
;       ********************************************************
;
        mov     di,cmd_parm+1
        mov     al,[di]
        cmp     al,0
        jz      c062dm          ;nop
        mov     di,flag2
        and     byte ptr [di],not specpack
        cmp     al,01           ;Wang terminal?
        jz      initdw          ;jmp if yes
        or      byte ptr [di],specpack
        cmp     al,02           ;TC?
;       jz      inittc          ;jmp if yes
c062dm:
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
        ret
;
initdw:         ;Reinitialize a port to support Wang terminal which it was
                ;set as Wang terminal previously
        cli                     ;lock
;       set ready/busy bits
        mov     di,rbi          ;points at R/B byte
        mov     byte ptr [di],18        ;init crt and prt bits to ready state
        mov     di,rbimask      ;special mode ready mask
        mov     byte ptr [di],0ffh      ;set to all ready
;       init connect/disconnect variables
        mov     di,dsrbyte
        mov     byte ptr [di],02        ;init with connect on
;       init LRBUF and pointers
        call    rstlr
;       init CRT and PRT read/write pointers
        call    rstbufc
        call    rstbufp
        mov     di,txbyte
        or      byte ptr [di],prtstopb  ;set prt stop in case no printer
;
        call    port_init_1
        mov     di,dsrbyte
        or      byte ptr [di],curdsr
        mov     di,usermask
        mov     ax,[di]
        not     ax
        and     es:porttype,ax          ;reset the porttype of TC
        jmp     c062dm
;
;
c062e:                       ;j+ check?
;       *********************************************************
;       Accept the system password from OS, and set it as MXE psw
;       *********************************************************
        xor     ah,ah
        mov     si,psw
        mov     di,cmd_parm
c062e1:
        mov     al,[di]
        mov     es:[si],al
        or      al,al
        je      ret062e
        inc     di
        inc     si
        inc     ah
        cmp     ah,6
        jb      c062e1
ret062e:
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
        ret
;
c062f:
;       ******************************************************
;       Warm start, To the start of PROM of MXF w/o diagnostic
;       ******************************************************
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
        jmp     begin
        ret
;
c0630:
;       **********************************************************************
;       Command only in PROM, MXF is informed by that RAM is oaky, so jump RAM
;       **********************************************************************
        mov     di,cmd_sts
        mov     byte ptr [di],0f1h
        mov     si,end_rom
        mov     word ptr [si],0
        inc     si
        inc     si
        mov     word ptr [si],1d60h
        mov     si,end_rom
        jmp     dword ptr [si]
;
port_serv       endp
;
;**********************************************************************
;
check_dtr       proc
        mov     bx,es:try_dtr
        mov     di,usermask
        test    bx,[di]
        jz      port_z
        call    entx
port_z:
        ret
check_dtr       endp
;
poll_buf        proc            ;j+
;*******************************************************************************
;        This block looks for a PORT in need of service.
;        The byte rxbyte contains flags for all 16 ports and bit16, 17 for clock.
;        Rxbyte sets one bit at a time and each flag is
;        serviced as they are found set. Also note that rxbyte in gen_store seg.
;        rxbyte  -  bit0/port0,bit1/port1,...,bit15/port15
;        rxbyte0 -  bit0 = clock service, bit1 = .1 second int flag
;*******************************************************************************
;
        mov     bx,es:rxbyte0
        test    bx,clock_1i
        jnz     polclk
        mov     bx,es:rxbyte
        mov     di,usermask
        test    bx,[di]                 ;Is port asking for service?
        jz      lr_proc                 ;No request, go try lr request?
        call    rxin                    ;Go handling the received buffer
        jnz     lr_proc
        mov     di,usermask             ;no more data, turn off
        mov     bx,[di]
        mov     cx,es:rxbyte
        not     bx
        and     cx,bx
        mov     es:rxbyte,cx
        jmp     lr_proc                 ;Next, polling the lr request
polclk:
        test    cx,clockint             ;one second int bit set?
        jz      polclk2                 ;jump if not set
;       call    clocki3                 ;service clock check?
        cli
        mov     cx,es:rxbyte0
        and     cx,not clock_1i
        and     cx,not clockint         ;turn off both clock bits
        mov     es:rxbyte0,cx
        sti
        jmp     polclk3
polclk2:
        cli
        and     cx,not clock_1i
        mov     es:rxbyte0,cx
        sti
polclk3:
;       call    clk_1                   ;check???
        ret
poll_buf        endp
;
lr_proc         proc                    ;j+
;       **********************************************************************
;
comp:
;       ************************************************
;       ** Execute an $MXF command from this terminal **
;       ************************************************
        mov     cx,es:commode0
        mov     di,usermask
        test    cx,[di]         ;Is port asking for $MXF ?
        jz      comret          ;Exit if not requesting
        call    move_com        ;get a terminal command in "command"
comp2:                          ;For 06 command
        call    do_com          ;Go execute the command
        mov     di,usermask
        mov     dx,[di]
        not     dx
        and     cx,dx
        mov     es:commode0,cx
comret:
        ret
lr_proc         endp
;
cmd_over        proc
;       ***************************************************************
;       Routine that set the bit of int_event to show cmd (06) is over.
;       ***************************************************************
        mov     di,int_event
        or      byte ptr [di],02h       ;Notice OS 386 commands complete
        ret
cmd_over        endp
;
include mxfrini.asm
include mxfrbuf.asm
include mxfrcmd.asm
include mxfrint.asm
include mxfrdat.asm
;
        org     0fff0h
        jmp     begin0
;       jmp     start
;
        code0   ends
        end
;
