        .LIST
        .286
        PAGE 58,132

INCLUDE WANGEQU.ASI

RAMSEG  SEGMENT
        ASSUME  CS:RAMSEG

MAIN:   JMP     MAIN_X
        DB      "*** Wang Laboratories, Inc.  @22C11HS FAST MicroCode Rev 1.18 07/04/92 ***"
MAIN_X:
        CLI
        MOV     WORD PTR DS:[RAM_REVISION],1001H ;RELEASE 1.00

        MOV     BX,PRINT_START_R
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRINT_END_R
        MOV     WORD PTR DS:[BX],PRT_BUFFER_END
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRT_START
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRT_END
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        AND     BYTE PTR DS:[EPROM_MODE],0FH
        OR      BYTE PTR DS:[EPROM_MODE],10H     ;Set EPROM to RAM

        MOV     BYTE PTR DS:[PART_NO],0          ;POLLING FROM PARTITION 0

        MOV     BYTE PTR DS:[RESET_FLAG],0FFH    ;NO RESET COMING ON INIT
        MOV     BYTE PTR DS:[RESET_PRT_FLAG],0FFH    ;NO RESET COMING ON INIT
        MOV     AX,RCB
        MOV     BP,AX
        MOV     CX,64
MAIN1:
        MOV     BYTE PTR DS:[BP].@STATUS,0       ;INIT RCB
        ADD     BP,32
        LOOP    MAIN1

MAIN_PROCESS:
        MOV     BYTE PTR DS:[ACT_PART_NO],0FFH
        CALL    BREAK
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     CL,5
        SHL     AX,CL
        ADD     AX,RCB                          ;CALCULATE RCB
        MOV     BP,AX
        CALL    PROCESS_NEXT1_X

        CMP     BYTE PTR DS:[BP].@STATUS,0      ;CHECK RCB STATUS
        JE      PROCESS_NEXT1                   ;BR, IF NO REQUEST

        MOV     BX,OFFSET JMP_TAB               ;GET JMP TABLE

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@REQCODE    ;GET REQUEST CODE
        CMP     AL,20H
        JAE     PROCESS_NEXT2                   ;ILLEGAL CODE
        SHL     AX,1
        ADD     BX,AX

        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     BYTE PTR DS:[ACT_PART_NO],AL

        JMP     WORD PTR CS:[BX]                ;JMP TO ROUTINE

PROCESS_NEXT1_X:
        CMP     BYTE PTR DS:[BP+1FH],0
        JE      PROCESS_NEXT1_Z
        CMP     BYTE PTR DS:[BP+1FH],0AH
        JNE     PROCESS_NEXT1_Y
        CALL    HOG_DISK
        JMP     PROCESS_NEXT1_Z
PROCESS_NEXT1_Y:
        CMP     BYTE PTR DS:[BP+1FH],0BH
        JNE     PROCESS_NEXT1_Z
        CALL    UNHOG_DISK
PROCESS_NEXT1_Z:
        MOV     BYTE PTR DS:[BP+1FH],0
        RET

PROCESS_NEXT2:
        MOV     BYTE PTR DS:[BP].@ERROR,94H     ;ERROR FOR ILLEGAL REQUEST CODE
PROCESS_NEXT:
        MOV     BYTE PTR DS:[BP].@STATUS,0      ;RESET RCB STATUS

PROCESS_NEXT1:
        INC     BYTE PTR DS:[PART_NO]           ;INCREMENT PARTITION NO
        MOV     AL,BYTE PTR DS:[MAX_PART_NO]
        CMP     BYTE PTR DS:[PART_NO],AL        ;CHECK MAX. PARTITION
        JNE     PROCESS_X
        MOV     BYTE PTR DS:[PART_NO],0         ;RESET PATITION NO IF MAX.
PROCESS_X:
        CALL    SERVICE_PRINT
        JMP     MAIN_PROCESS                    ;PROCESS NEXT

JMP_TAB DW      OFFSET NULL_COMMAND             ;0
        DW      OFFSET READ_SECTOR              ;1
        DW      OFFSET WRITE_SECTOR             ;2
        DW      OFFSET COMPARE_SECTOR           ;3
        DW      OFFSET COPY_SECTOR              ;4
        DW      OFFSET VERIFY_SECTOR            ;5
        DW      OFFSET FORMAT_TRACK             ;6
        DW      OFFSET FORMAT_PLATTER           ;7
        DW      OFFSET READ_STATUS              ;8
        DW      OFFSET TURN_OFF                 ;9
        DW      OFFSET NULL_COMMAND             ;0A
        DW      OFFSET NULL_COMMAND             ;0B
        DW      OFFSET NULL_COMMAND             ;0C
        DW      OFFSET SWITCH_ROM               ;0D
        DW      OFFSET RAM_INIT                 ;0E
        DW      OFFSET GIO_ENABLE               ;0F
        DW      OFFSET NULL_COMMAND             ;10
        DW      OFFSET MULTI_READ               ;11
        DW      OFFSET NULL_COMMAND             ;12
        DW      OFFSET UNHOG_PLAT               ;13
        DW      OFFSET HOG_PLAT                 ;14
        DW      OFFSET NULL_COMMAND             ;15
        DW      OFFSET NULL_COMMAND             ;16
        DW      OFFSET NULL_COMMAND             ;17
        DW      OFFSET NULL_COMMAND             ;18
        DW      OFFSET NULL_COMMAND             ;19
        DW      OFFSET NULL_COMMAND             ;1A
        DW      OFFSET NULL_COMMAND             ;1B
        DW      OFFSET NULL_COMMAND             ;1C
        DW      OFFSET NULL_COMMAND             ;1D
        DW      OFFSET NULL_COMMAND             ;1E
        DW      OFFSET NULL_COMMAND             ;1F

; MULTI READ COMMAND
;

MULTI_READ:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_1         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_1    ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_1           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_1
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_1
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR                         ;GET BUFFER POINTER
        CALL    SET_NEXT_BUFFER_PTR
        CALL    SET_NEXT_BUFFER_PTR
MULTI_READ1:
        CALL    DREAD                                  ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      MULTI_READ_END                         ;BR, IF COMPLEMENT
        MOV     BX,WORD PTR DS:[BUFFER_PTR]
        CMP     BYTE PTR ES:[BX],20H                   ;PROGRAM TRAILOR RECORD
        JE      MULTI_READ_END1
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     MULTI_READ1                            ;BR, TO READ AGAIN
MULTI_READ_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_1,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

MULTI_READ_END1:
        MOV     AX,WORD PTR DS:[SECTOR_COUNT]
        SUB     WORD PTR DS:[BP].@SECTOR_COUNT_1,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; READ MUTI-SECTOR COMMAND
;

READ_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_1         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_1    ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_1           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_1
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_1
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR                         ;GET BUFFER POINTER
READ_AGAIN:
        CALL    DREAD                                  ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      READ_SECTOR_END                        ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     READ_AGAIN                             ;BR, TO READ AGAIN
READ_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_1,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

WRITE_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_2         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_2    ;GET TOTAL SECTOR NO TO BE WRITE
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_2           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_2
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_2
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR
        MOV     BYTE PTR DS:[WRITE_FLAG],0
        CMP     WORD PTR DS:[BP].@SECTOR_COUNT_2,1     ;
        JBE     WRITE_AGAIN
        MOV     BYTE PTR DS:[WRITE_FLAG],1
        CALL    MSWRTBEG
WRITE_AGAIN:
        CALL    DWRITE                                 ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      WRITE_SECTOR_END                       ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     WRITE_AGAIN                            ;BR, TO WRITE AGAIN
WRITE_SECTOR_END:
        CMP     BYTE PTR DS:[WRITE_FLAG],1
        JNE     WRITE_END
        CALL    MSWRTEND
WRITE_END:
        MOV     BYTE PTR DS:[WRITE_FLAG],0             ;RESET MULTI WRITE FLAG
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_2,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

COMPARE_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_3         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_3    ;GET TOTAL SECTOR NO TO BE COMPARE
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_3           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_3
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_3
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR                         ;GET BUFFER POINTER
COMPARE_AGAIN:
        CALL    DCOMPARE
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      COMPARE_SECTOR_END                     ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     COMPARE_AGAIN                          ;BR, TO COMPARE AGAIN
COMPARE_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_3,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

COPY_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER1_4        ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR11_4          ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR12_4
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR13_4
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    DCOPY
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

VERIFY_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_5         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR11_5          ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR12_5
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR13_5
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    DVERIFY
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_5,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

FORMAT_TRACK:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_6
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_6
        MOV     BYTE PTR DS:[ADDR1],AL          ;SET SECTOR ADDRESS
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_6
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_6
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    DTRACK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

FORMAT_PLATTER:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_7
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DFORMAT                         ;SEND FORMAT COMMAND
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_7,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

READ_STATUS:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_8
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DSTATUS
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

TURN_OFF:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_9
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DTURNOFF
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

HOG_DEVICE:
        CALL    HOG_DISK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

UNHOG_DEVICE:
        CALL    UNHOG_DISK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

RESET_DEVICE:
        CALL    RESET_DSK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SWITCH_ROM:
        MOV     BYTE PTR DS:[BP].@STATUS,00H
        MOV     BYTE PTR DS:[BP].@ERROR,00H
        MOV     BX,ROM_ENTRY
        JMP     DWORD PTR DS:[BX]                      ;SWITCH TO ROM

RAM_INIT:
        MOV     AL,BYTE PTR DS:[BP].@CPUID_E
        MOV     BYTE PTR DS:[CPU_ID],AL
        MOV     AX,WORD PTR DS:[BUFFER_SIZE]
        MOV     BX,WORD PTR DS:[BP].@PARTNO_E
        XOR     DX,DX
        DIV     BX

        CMP     AX,88
        JB      RAM_INIT6
        MOV     AX,88
RAM_INIT6:
        MOV     WORD PTR DS:[BUFFER_SIZE],AX
        MOV     CL,8
        SHL     AX,CL
        MOV     BYTE PTR DS:[MAX_PART_NO],BL
        MOV     CX,BX
        MOV     BX,BASE
RAM_INIT4:
        DEC     CX
        JZ      RAM_INIT1
        MOV     DX,WORD PTR DS:[BX+2]
        ADD     DX,AX
        JNC     RAM_INIT2
        MOV     WORD PTR DS:[BX+6],DX
        MOV     DX,WORD PTR DS:[BX]
        ADD     DX,1000H
        MOV     WORD PTR DS:[BX+4],DX
        ADD     BX,4
        JMP     RAM_INIT3
RAM_INIT2:
        MOV     WORD PTR DS:[BX+6],DX
        MOV     DX,WORD PTR DS:[BX]
        MOV     WORD PTR DS:[BX+4],DX
        ADD     BX,4
RAM_INIT3:
        JMP     RAM_INIT4
RAM_INIT1:
        PUSH    ES
        PUSH    DS
        POP     ES
        MOV     CX,64
        MOV     SI,BASE
        MOV     DI,DATA_BASE
RAM_INIT5:
        LODSW
        MOV     BL,AH
        LODSW
        STOSW
        SHR     BL,1
        SHR     BL,1
        SHR     BL,1
        SHR     BL,1
        XOR     BH,BH
        MOV     AX,BX
        STOSW
        LOOP    RAM_INIT5
        POP     ES
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

GIO_ENABLE:
        MOV     BYTE PTR DS:[BP].@ERROR_F,0
        MOV     AL,BYTE PTR DS:[BP].@ABS_F
        CMP     AL,BYTE PTR DS:[PRINTER_ID]
        JNZ     GIO_DISK

        JMP     GIO_PRINT

GIO_DISK:
        MOV     BYTE PTR DS:[BP].@RB_G,1        ;SET R/B TO BUSY

        MOV     AL,0
        OUT     0006H,AL                        ;SELECT MASTER
        TEST    BYTE PTR DS:[BP].@ABS_F,40H
        JZ      GIO_DISK1
        MOV     AL,1
        OUT     0006H,AL
GIO_DISK1:
        CALL    HOG_DISK
        IN      AL,0084H
        TEST    AL,20H
        JZ      DISK_RDY
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@STROBE_G,0    ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@GIO_G,88h     ;SET GIO FLAG
GO_DISKX:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE1_X
        IN      AL,0084H
        TEST    AL,20H
        JZ      DISK_RDY
        JMP     GO_DISKX
DISK_RDY:
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@STROBE_G,0    ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@GIO_G,88h     ;SET GIO FLAG
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY

STROBE_POLLING1:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      STROBE_1
        JMP     GIO_DISABLE1                    ;GIO DISABLE
STROBE_1:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0FH
        JNZ     DISK_STROBE
        call    service_print
        JMP     STROBE_POLLING1
DISK_STROBE:
        MOV     BYTE PTR DS:[BP].@RB_G,1

        TEST    BYTE PTR DS:[BP].@STROBE_G,OBS_STROBE
        JNZ     DISK_STROBE_OBS
        TEST    BYTE PTR DS:[BP].@STROBE_G,CBS_STROBE
        JNZ     DISK_STROBE_CBS
        TEST    BYTE PTR DS:[BP].@STROBE_G,IOB_STROBE
        JNZ     DISK_STROBE_IOB
        JMP     DISK_STROBE_IBS

DISK_STROBE_IOB:
        MOV     AH,BYTE PTR DS:[BP].@DATA_G
        TEST    AH,80H
        JZ      DISK_IOB1
        MOV     AL,1
        OUT     0008H,AL
        JMP     DISK_IOB2
DISK_IOB1:
        MOV     AL,0
        OUT     0008H,AL
DISK_IOB2:
        TEST    AH,20H
        JZ      DISK_IOB3
        MOV     AL,1
        OUT     0004H,AL
        JMP     DISK_IOB4
DISK_IOB3:
        MOV     AL,0
        OUT     0004H,AL
DISK_IOB4:
        JMP     DISK_RDY1

GIO_DISABLE1_X:
        JMP     GIO_DISABLE1

DISK_STROBE_CBS:
        MOV     AH,BYTE PTR DS:[BP].@DATA_G
        TEST    AH,80H
        JZ      DISK_UNHOG
        MOV     AL,1
        OUT     0000H,AL                ;HOG DISK
        JMP     DISK_STROBE_CBS1
DISK_UNHOG:
        MOV     AL,0
        OUT     0000H,AL                ;UNHOG DISK
DISK_STROBE_CBS1:
        TEST    AH,01H
        JZ      DISK_RDY1
        CALL    RESET_DSK
        JMP     DISK_RDY1

DISK_STROBE_OBS:
        MOV     AL,BYTE PTR DS:[BP].@DATA_G
        OUT     0080H,AL                        ;OUT OBS
        call    delay10
        JMP     DISK_RDY1

DISK_STROBE_IBS:
        MOV     AL,01H
        OUT     0002H,AL            ;SET CPU READY FOR ALLOW INPUT
WAIT_IBS:
        IN      AL,0084H
        TEST    AL,02H
        JNZ     GET_IBS
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE1_X
        JMP     WAIT_IBS
GET_IBS:
        MOV     AL,00H
        OUT     0002H,AL
        IN      AL,0082H
        MOV     BYTE PTR DS:[BP].@DATA_G,AL
WAIT_CPB:
        CMP     BYTE PTR DS:[BP].@CPB_G,0
        JE      SET_CPB
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE1_X
        JMP     WAIT_CPB
SET_CPB:
        IN      AL,84H
        TEST    AL,20H
        JZ      SET_CPB1
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE1_X
        JMP     SET_CPB
SET_CPB1:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        JMP     STROBE_POLLING1

DISK_RDY1:
        IN      AL,84H
        TEST    AL,20H
        JZ      GIO_DISK_END
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      DISK_RDY1
        JMP     GIO_DISABLE1_X

GIO_DISK_END:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
        JMP     STROBE_POLLING1

GIO_PRINT:
        MOV     BYTE PTR DS:[BP].@RB_G,1        ;SET R/B TO BUSY

        IN      AL,0084H
        TEST    AL,10H
        JNZ     PRINT_RDY
;;      mov     bx,word ptr ds:[prt_end]
;;      cmp     bx,prt_buffer_end
;;      jne     gio_print1
;;      mov     bx,word ptr ds:[prt_start]
;;      cmp     bx,prt_buffer_start
;;      jne     print_rdy
;;      jmp     gio_print2
gio_print1:
;;      inc     bx
;;      cmp     bx,word ptr ds:[prt_start]
;;      jne     print_rdy
gio_print2:
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@STROBE_G,0    ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@GIO_G,089H    ;SET GIO FLAG
GO_PRINTX:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE2_X

        IN      AL,0084H
        TEST    AL,10H
        JNZ     PRINT_RDY
;;      mov     bx,word ptr ds:[prt_end]
;;      cmp     bx,prt_buffer_end
;;      jne     gio_print3
;;      mov     bx,word ptr ds:[prt_start]
;;      cmp     bx,prt_buffer_start
;;      jne     print_rdy
;;      jmp     gio_print4
gio_print3:
;;      inc     bx
;;      cmp     bx,word ptr ds:[prt_start]
;;      jne     print_rdy
gio_print4:
        call    service_print
        JMP     GO_PRINTX

PRINT_RDY:
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@STROBE_G,0    ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@GIO_G,089H    ;SET GIO FLAG
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY

STROBE_POLLING2:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      STROBE_2
        JMP     GIO_DISABLE2                    ;GIO DISABLE
STROBE_2:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0FH
        JNZ     PRINT_STROBE
        JMP     STROBE_POLLING2
PRINT_STROBE:
        TEST    BYTE PTR DS:[BP].@STROBE_G,OBS_STROBE
        JNZ     PRINT_STROBE_OUT
        TEST    BYTE PTR DS:[BP].@STROBE_G,CBS_STROBE
        JNZ     GIO_PRINT_END
        TEST    BYTE PTR DS:[BP].@STROBE_G,IOB_STROBE
        JNZ     GIO_PRINT_END
DEAD_LOCK_IBS:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE2                    ;GIO DISABLE
        JMP     DEAD_LOCK_IBS

GIO_DISABLE2_X:
        JMP     GIO_DISABLE2

PRINT_STROBE_OUT:
        MOV     AL,BYTE PTR DS:[BP].@DATA_G
        mov     bx,word ptr ds:[prt_end]
        mov     byte ptr ds:[bx],al

        cmp     bx,prt_buffer_end
        jne     gio_print7
        mov     bx,prt_buffer_start
        mov     word ptr ds:[prt_end],bx
        jmp     gio_print8
gio_print7:
        inc     word ptr ds:[prt_end]
gio_print8:
;       MOV     DX,0100H
;       OUT     DX,AL
PRINT_RDY1:

;       IN      AL,84H
;       TEST    AL,10H
;       JNZ     GIO_PRINT_END

        mov     bx,word ptr ds:[prt_end]
        cmp     bx,prt_buffer_end
        jne     gio_print5
        mov     bx,word ptr ds:[prt_start]
        cmp     bx,prt_buffer_start
        jne     gio_print_end
        jmp     gio_print6
gio_print5:
        inc     bx
        cmp     bx,word ptr ds:[prt_start]
        jne     gio_print_end
gio_print6:
        call    service_print

        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE2                    ;GIO DISABLE
        JMP     PRINT_RDY1
GIO_PRINT_END:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
        JMP     STROBE_POLLING2

GIO_DISABLE1:
        MOV     AL,00H
        OUT     0002H,AL
        CMP     BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNE     DISK_STROBE_ABS
;       CALL    UNHOG_DISK
        JMP     GIO_DISABLE3
GIO_DISABLE2:
        CMP     BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNE     DISK_STROBE_ABS
GIO_DISABLE3:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        MOV     BYTE PTR DS:[BP].@GIO_G,0
        JMP     PROCESS_NEXT

DISK_STROBE_ABS:
        JMP     GIO_ENABLE

SERVICE_PRINT:
        pusha
SERVICE_4:
;       CALL    SKIP_MARK_H
;       CALL    SKIP_MARK_T
        MOV     BX,WORD PTR DS:[PRT_START]
        CMP     BX,WORD PTR DS:[PRT_END]
        JE      SERVICE_0
        IN      AL,0084H
        TEST    AL,10H
        JZ      SERVICE_0
        MOV     AL,BYTE PTR DS:[BX]
        cmp     al,0ffh
        je      service_3
        cmp     al,0feh
        je      service_3
        MOV     DX,100H
        OUT     DX,AL
service_3:
        CMP     BX,PRT_BUFFER_END
        JNE     SERVICE_1
        MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
        JMP     SERVICE_4
SERVICE_1:
        INC     WORD PTR DS:[PRT_START]
        JMP     SERVICE_4
SERVICE_0:
        popa
        RET

;SKIP_MARK_H:
;        PUSH    BX
;        MOV     BX,WORD PTR DS:[PRT_START]
;        CMP     BX,WORD PTR DS:[PRT_END]
;        JE      SKIP_MARK_H_END
;        CMP     BYTE PTR DS:[BX],0FFH
;        JNE     SKIP_MARK_H_END
;        CMP     BYTE PTR DS:[BX+1],0FFH
;        JNE     SKIP_MARK_H_END
;        ADD     BX,3
;        CMP     BX,WORD PTR DS:[PRT_END]
;        JA      SKIP_MARK_H_END
;        ADD     WORD PTR DS:[PRT_START],3
;SKIP_MARK_H_END:
;        POP     BX
;        RET
;
;SKIP_MARK_T:
;        PUSH    BX
;        MOV     BX,WORD PTR DS:[PRT_START]
;        CMP     BX,WORD PTR DS:[PRT_END]
;        JE      SKIP_MARK_T_END
;        CMP     BYTE PTR DS:[BX],0FFH
;        JNE     SKIP_MARK_T_END
;        CMP     BYTE PTR DS:[BX+1],0FEH
;        JNE     SKIP_MARK_T_END
;        ADD     BX,3
;        CMP     BX,WORD PTR DS:[PRT_END]
;        JA      SKIP_MARK_T_END
;        ADD     WORD PTR DS:[PRT_START],3
;SKIP_MARK_T_END:
;        POP     BX
;        RET

CLEAR_BUFFER:
        PUSH    BX
CLEAR_2:
        MOV     BX,WORD PTR DS:[PRT_START]
        CMP     BX,WORD PTR DS:[PRT_END]
        JE      CLEAR_0

        CMP     BYTE PTR DS:[BX],0FEH
        JNE     CLEAR_1
        CMP     BX,PRT_BUFFER_END
        JNE     CLEAR_3
        MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
        JMP     CLEAR_4
CLEAR_3:
        INC     WORD PTR DS:[PRT_START]
CLEAR_4:
        JMP     CLEAR_0
CLEAR_1:
        CMP     BX,PRT_BUFFER_END
        JNE     CLEAR_5
        MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
        JMP     CLEAR_6
CLEAR_5:
        INC     WORD PTR DS:[PRT_START]
CLEAR_6:
        JMP     CLEAR_2
CLEAR_0:
        POP     BX
        RET

UNHOG_PLAT:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_13H       ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    CMNDINIT
        CMP     AL,0D0H
        JNE     ERROR_90U

        MOV     AL,00H
        OUT     0004H,AL
        OUT     0008H,AL

        MOV     AX,WORD PTR DS:[ACTDEV]
        TEST    AL,0FH
        JZ      UNHOG_PLAT1
        AND     AL,0FH
        SUB     AL,1
        JMP     UNHOG_PLAT2
UNHOG_PLAT1:
        MOV     AL,10H
UNHOG_PLAT2:
        OR      AL,20H
        CALL    OBSECHO
        CMP     AL,0
        JNZ     ERROR_94U
        MOV     AL,41H
        CALL    OBSECHO
;       CMP     AL,41H
;       JNZ     ERROR_94U
        MOV     BYTE PTR DS:[BP].@ERROR,0
        call    unhog_disk
        JMP     PROCESS_NEXT

ERROR_90U:
        MOV     AL,90H
        JMP     DISKERR

ERROR_94U:
        MOV     AL,94H
        JMP     DISKERR

HOG_PLAT:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_14H       ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    CMNDINIT
        CMP     AL,0D0H
        JNE     ERROR_90U

        MOV     AL,00H
        OUT     0004H,AL
        OUT     0008H,AL

        MOV     AX,WORD PTR DS:[ACTDEV]
        TEST    AL,0FH
        JZ      HOG_PLAT1
        AND     AL,0FH
        SUB     AL,1
        JMP     HOG_PLAT2
HOG_PLAT1:
        MOV     AL,10H
HOG_PLAT2:
        OR      AL,20H
        CALL    OBSECHO
        CMP     AL,0
        JNZ     ERROR_94U
        MOV     AL,40H
        CALL    OBSECHO
        MOV     BYTE PTR DS:[BP].@HOG_PLAT,AL
        MOV     BYTE PTR DS:[BP].@ERROR,0
        call    unhog_disk
        JMP     PROCESS_NEXT

NULL_COMMAND:
        JMP     PROCESS_NEXT2

INCLUDE CSXX.ASM

WRITE_CHAR:
        PUSH    AX
WRITE_CHAR1:
        IN      AL,0084H
        TEST    AL,10H
        JZ      WRITE_CHAR1
        POP     AX

        PUSH    DX
        MOV     DX,0100H
        OUT     DX,AL
        POP     DX
        RET

WRITE_HEX:
        PUSH    AX
        SHR     AL,1
        SHR     AL,1
        SHR     AL,1
        SHR     AL,1
        OR      AL,30H
        CMP     AL,39H
        JBE     WRITE_HEX1
        ADD     AL,07H
WRITE_HEX1:
        CALL    WRITE_CHAR
        POP     AX

        PUSH    AX
        AND     AL,0FH
        OR      AL,30H
        CMP     AL,39H
        JBE     WRITE_HEX2
        ADD     AL,07H
WRITE_HEX2:
        CALL    WRITE_CHAR
        MOV     AL,0DH
        CALL    WRITE_CHAR
        MOV     AL,0AH
        CALL    WRITE_CHAR
        POP     AX
        RET

RAMSEG  ENDS
        END
