
         PAGE      60,132
;---------------------------------------------------------------------------+
;                                                                           !
;  (c) Copyright, Wang Laboratories, Inc.,  1991			    !
;        All rights reserved.                                               !
;                                                                           !
;                                                                           !
;    Program name :  WANG 22C11-HS Power-up Diagnostic Program		    !
;    File name :     HSDIAG.ASM 					    !
;    Support group : Enginerring Service Department                         !
;                    Wang Computer (Taiwan) Ltd.                            !
;                    Taiwan, R.O.C.                                         !
;                                                                           !
;                                                                           !
;    Revision History :                                                     !
;      Date       Programmer       Description               Revision       !
;    07/01/91	 Milton Chen	    Creation		       5170	    !
;                                                                           !
;                                                                           !
;    TEST FLOW : [ 1 ]  22C11'S LED Test                                    !
;                [ 2 ]  80286 CPU test                                      !
;                [ 3 ]  Memory size test                                    !
;                [ 4 ]  Test first 4K byte for Semaphore Area               !
;                [ 5 ]  SRAM data bus test                                  !
;                [ 6 ]  SRAM address line test                              !
;                [ 7 ]  SRAM write/read test                                !
;                [ 8 ]  Initial chip 8255                                   !
;                [ 9 ]  Printer test under run-in test                      !
;                                                                           !
;---------------------------------------------------------------------------+

;CODE	  SEGMENT			    ; ## del, when include other files
;	  ASSUME    CS:CODE,DS:CODE	    ; ##

START:   CLI
         JMP       AFTER_COPY


COPYRIGHT	   DB	     'Copyright, Wang Laboratories, Inc., 1991'
                   DB        20H,20H,20H,20H,20H
REVISION	   DB	     'Rev 5170	'		       ; R0 Version

MSG	 DB	   4 DUP(20H),'22C11-HS  Run-in Test   ---------> PASS ' ,0DH,0AH,00H
PRTINT   DB        ' Printer Interrupt Test Service Routine !! ',00H

;ERR1	  DB	    4 DUP(20H),'80286 CPU Test	------->  ERROR !',0DH,0AH,00H
;ERR2	  DB	    4 DUP(20H),'First 4K Bytes Test  ----->  ERROR !',0DH,0AH,00H
;ERR3	  DB	    4 DUP(20H),'SRAM Data Bus Test  ----->  ERROR !',0DH,0AH,00H
;ERR4	  DB	    4 DUP(20H),'SRAM Address Line Test	----->	ERROR !',0DH,0AH,00H
;ERR5	  DB	    4 DUP(20H),'SRAM Write/Read Test  ------>  ERROR !',0DH,0AH,00H

BOARDMS  DB	   '22C11-HS', 4 DUP (20H)	; board description
BOARDMSL EQU	   $-BOARDMS

PATN	 DW	   55AAH		    ; memory test pattern
	 DW	   0AA55H
         DW        0000H

ON       EQU       01H                      ; led on
OFF      EQU       00H                      ; led off

CLPORT	 EQU	   8002H		    ; clear 386 interrupt port
INTPORT  EQU	   8000H		    ; intrupt 386 port

LEDPORT  EQU	   0EH			    ; LED port
SWPORT	 EQU	   280H 		    ; DIP SW for diag. run in test

;------------------------------------------------------------------

BOARDST  EQU	   404H 		    ; test pass store 'F0"
BOARDID  EQU	   405H 		    ; board ID => 22C11-HS '01'

DESADDR  EQU	   406H 		    ; 406H-415H board description
REV	 EQU	   416H 		    ;

INTBIT	 EQU	   41FH 		    ; interrupt semaphore bit , 0FH
RESULT	 EQU	   420H 		    ; test status bit
SGM	 EQU	   421H 		    ; word store seg.,421H,422H
MSIZE	 EQU	   423H 		    ; memory size, 423H-424H

TSCOM	 EQU	   42AH 		    ; common memory test semaphore
DG	 EQU	   42BH



;-------------------------  TEST 1  LED TEST  ----------------------------+
;                                                                         |
;      LED test, under diagnostic test LED is turn on.                    |
;                                                                         |
;-------------------------------------------------------------------------+

AFTER_COPY:
         MOV       AX,CS
         MOV       DS,AX                    ; DS <= CS

LED      MACRO     ONOFF,PORT               ; LED MACRO
         MOV       AX,ONOFF
         MOV       DX,PORT
         OUT       DX,AX
ENDM

         LED       ON,LEDPORT               ; turn on

	 MOV	   AX,0
	 MOV	   ES,AX
	 MOV	   AL,ES:[DG]
	 CMP	   AL,80H		    ; DG1 set warm boot
	 JNE	   TST2
	 JMP	   DG1


;----------------------   TEST 2   80286 CPU TEST   -----------------------+
;                                                                          |
;        CPU 80286 : Flag - SF,CF,ZF,AF,PF test                            |                                   |
;                    General Reg, & Segment test         error code: 01    |
;                                                                          |
;--------------------------------------------------------------------------+


TST2:    CLI                                ; disable interrupt
         MOV       AH,0D5H                  ; set SF,CF,ZF,AF flags on
         SAHF                               ; store AH to flag reg.
         JNC       FATAL_ERROR              ; error if CF not set
         JNZ       FATAL_ERROR              ; error if ZF not set
         JNP       FATAL_ERROR              ; error if PF not set
         JNS       FATAL_ERROR              ; error if SF not set
         LAHF                               ; load flag to AH
         MOV       CL,5                     ; shift count
         SHR       AH,CL                    ; shift AF into CARRY bit
         JNC       FATAL_ERROR              ; error if no carry
         MOV       AL,40H                   ; set flag on
         SHL       AL,1                     ; set up for test
         JNO       FATAL_ERROR              ; error if overflow
         XOR       AH,AH                    ; AH=0
         SAHF
         JBE       FATAL_ERROR              ; error if CF on
         JS        FATAL_ERROR              ; error if SIGN flag set
         JP        FATAL_ERROR              ; error if EVEN Parity set
         LAHF                               ; load flag to AH
         MOV       CL,5                     ; shift count
         SHR       AH,CL
         JC        FATAL_ERROR              ; error if CF on
         SHL       AH,1                     ; check OF is clear
         JO        FATAL_ERROR              ; error if OF on

         XOR       AX,AX                    ; test reset condition & flags
         JNZ       FATAL_ERROR              ; check zero flag off
         OR        AX,1
         JZ        FATAL_ERROR              ; check zero flag on
         AND       AX,AX
         JC        FATAL_ERROR              ; test carry, error if carry flag not cleared
         STC                                ; set carry flag
         JNC       FATAL_ERROR              ; error if not carry
         CLC                                ; clear carry flag
         JC        FATAL_ERROR              ; error if carry flag is not clear
         CMC                                ; complement carry flag
         JNC       FATAL_ERROR              ; error if no carry

         MOV       AX,1                     ; store 1 to EAX Reg.
         MOV       CX,7                     ; count times
LP1:     AND       AX,AX                    ; set flag
         JZ        FATAL_ERROR              ; error if ZERO flag set
         JS        FATAL_ERROR              ; error if SIGN flag set
         JPE       FATAL_ERROR              ; error if EVEN Parity, b0 - b7
         JC        FATAL_ERROR              ; error if CARRY
         RCL       AX,1
         LOOP      LP1


;---------------- R/W GENERAL AND SEGMENT REGS. ---------------


         MOV       AX,55AAH                 ; AX <= FFFFH, pattern
         STC                                ; set carry flag
LP2:     MOV       DS,AX                    ; write to all regs.
         MOV       BX,DS
         MOV       ES,BX
         MOV       CX,ES
         MOV       SS,CX
         MOV       DX,SS
         MOV       SP,DX
         MOV       BP,SP
         MOV       SI,BP
         MOV       DI,SI
         JNC       LP3
         XOR       AX,DI
         JNZ       FATAL_ERROR
         CLC
         JMP       LP2

LP3:
         OR        AX,DI                    ; zero pattern thru all regs.
         JZ        TST1


FATAL_ERROR:
;	 MOV	   DX,0 		    ; initial stack segment: SS:SP => 0:550
;	 MOV	   SS,DX
;	 MOV	   DX,550H
;	 MOV	   SP,DX

	 MOV	   AL,21H		    ; error code=01
	 MOV	   BP,01H

	 XOR	   SI,SI
         MOV       ES,SI
	 MOV	   ES:[RESULT],AL

	 JMP	   $


;FLASH:   LED	    ON,LEDPORT
;	  XOR	    CX,CX
;ON1:	  AAM
;	  AAM
;	  AAM
;	  LOOP	    ON1

;	  LED	    OFF,LEDPORT
;	  XOR	    CX,CX
;OFF2:	  AAM
;	  AAM
;	  LOOP	    OFF2

;	 MOV	   BX,OFFSET ERR1
;	 CALL	   PRT_MSG
;	 CALL	   ERRMSG

;	  JMP	    FLASH


;---------------------   TEST 3  SRAM SIZE  TEST  ----------------------------+
;                                                                             |
;         BEGIN                                                               |
;             FOR DX = 0000 TO 4000H ( DX : Seg. )                            |
;               FOR DI = 0 TO FFFFH ( DI : Offset )                           |
;                   WRITE memory flood 4K byte ( pattern 55AA )               |
;                   READ  verify content data                                 |
;                     IF equal THEN next bank                                 |
;                       ELSE  detect memory size                              |
;                     ENDIF                                                   |
;               NEXT DI  ( next 4K Bank )                                     |      |
;		INC  SI  ( SI: 4K counter )				      |
;             NEXT DX  ( next 64K )                                           |
;         END  ( BP save memory size => Seg.)                                 |
;                                                                             |
;-----------------------------------------------------------------------------+


TST1:    XOR       SI,SI
         XOR       DI,DI

         CLD
         MOV       DX,0
NXTSEG:  MOV       ES,DX                    ; ES <= 0000:0000

NT4K:    MOV       CX,800H                  ; 2K word, 4K byte
RAD:     MOV       AX,55AAH                 ; pattern 55AA
         MOV       ES:[DI],AX               ; write to SRAM
         MOV       BX,ES:[DI]               ; read from SRAM
	 XOR	   AX,BX		    ; compare
         JNZ       MEMSIZE                  ; not equal, detect memory size
         INC       DI
         INC       DI
         LOOP      RAD

         INC       SI                       ; SI stand for 4K count number
         CMP       DI,0000H                 ; till increase next seg.
         JNZ       NT4K                     ; next 4k bank

         ADD       DX,1000H                 ; increase next seg.
         CMP       DX,4000H
         JNE       NXTSEG

MEMSIZE:
         MOV       AX,SI                    ; AX store units of 4K bank
         MOV       CL,4                     ; memory size = SI * 4k
	 MUL	   CL			    ; 256k or 128k
	 MOV	   SP,AX
	 MOV	   BP,DX		    ; BP : Seg.


;---------------------  TEST 4  4K byte For Semaphore  ----------------------+
;                                                                            |
;      Seg 0 : 8 - B  => 386 identify 286 interface card. 'CRAD'             |
;	   0 : 421H,422H => Seg.					     |
;	   0 : 420 => 20H -- error, 21-25				     |
;		      40H -- run-in mode, pass				     |
;		      80H -- pass					     |
;		      60H -- run-in mode, printer not ready		     |
;	   0 : 41F => 11H -- 386 interrupt 286 flag '11'		     |
;                                                                            |
;          BEGIN                                                             |
;                FOR  J = 4  ( four patterns : 55AA,AA55,C3D6H,0000H )       |
;                      WRITE memory flood 2K words                           |
;                      READ  verify content data                             |
;                NEXT J   ( next pattern )                                   |
;          END                                            error code=02      |
;                                                                            |
;----------------------------------------------------------------------------+

         MOV       AX,CS                    ; DS <= CS
         MOV       DS,AX

         MOV       DX,0                     ; ES <= 0
         MOV       ES,DX

         LEA       BX,PATN                  ; test pattern
	 MOV	   SI,3 		    ; four pattern
NXTPN1:  XOR       DI,DI
         CLD
         MOV       CX,800H                  ; 2k words
         MOV       AX,[BX]
   REP   STOSW

         XOR       DI,DI
         MOV       CX,800H
RDATA1:
         MOV       AX,ES:[DI]
         XOR       AX,[BX]
         JZ        NXTWORD1
         JMP       ERROR

NXTWORD1:
         INC       DI
         INC       DI
         LOOP      RDATA1

         INC       BX
         INC       BX
         DEC       SI                       ; next pattern
         JNZ       NXTPN1

	 JMP	   INIVECT
ERROR:
;	 MOV	   DX,0 		    ; initial stack segment: SS:SP => 0:550
;	 MOV	   SS,DX
;	 MOV	   DX,550H
;	 MOV	   SP,DX

	 MOV	   AL,22H
	 MOV	   BP,02H
	 XOR	   SI,SI
	 MOV	   ES,SI
	 MOV	   ES:[RESULT],AL
	 JMP	   $

;	 MOV	   BX,OFFSET ERR2
;	 CALL	   PRT_MSG
;	 CALL	   ERRMSG

;	  JMP	    FLASH

;-----------------------------------------------------

INIVECT:
	 MOV	   WORD PTR ES:[MSIZE],SP   ; store memory size, 100H or 80H

DG1:	 MOV	   AX,0 		    ; initial stack segment: SS:SP => 0:550
	 MOV	   SS,AX
	 MOV	   AX,550H
	 MOV	   SP,AX

	 XOR	   SI,SI		    ; DS<=0
	 MOV	   DS,SI

	 MOV	   AL,01H		    ; ID:1 22C11HS
	 MOV	   BYTE PTR DS:[BOARDID],AL
	 MOV	   BYTE PTR DS:[REV],AL     ; REV 01.00
	 MOV	   BYTE PTR DS:[REV+1],0

	 MOV	   ES,SI		    ; ES:DI <= DS:SI
	 MOV	   DI,DESADDR
	 LEA	   SI,BOARDMS
	 MOV	   AX,CS
	 MOV	   DS,AX
	 MOV	   CL,BOARDMSL
	 REP	MOVSB


	 XOR	   SI,SI
	 MOV	   DS,SI

	 MOV	   CX,256
LP:	 MOV	   WORD PTR DS:[SI],OFFSET NULRT
	 ADD	   SI,2
	 MOV	   WORD PTR DS:[SI],0F000H
	 ADD	   SI,2
	 LOOP	   LP

	 JMP	   TST4

NULRT:	 IRET


;------------------  TEST 5  SRAM DATA BUS TEST ---------------------------+
;                                                                          |
;       BEGIN                                                              |
;          FOR DX:= Memory size seg.                                       |
;            FOR I:= 2 ( two pattern : 0000-8000, FFFF - 7FFF )            |
;               FOR SI:= 0001                                              |
;                  FOR CX:= 16 times                                       |
;                     BX: current test pattern, AX: next test pattern      |
;                     XCHG DS:SI,test pattern                              |
;                  NEXT CX  ( next pattern )                               |
;               NEXT SI ( next address )                                   |
;            NEXT I                                                        |
;          NEXT DX ( next 64k bank )                                       |
;       END.                                           error code = 03     |
;                                                                          |
;--------------------------------------------------------------------------+


TST4:
         MOV       SI,SI                    ; start address = 0:0001h
         MOV       DI,100H

T4L1:    MOV       AX,DI                    ; start test from the first bank
	 MOV	   DS,AX		    ; 100:0

         MOV       BX,0000H                 ; BX = current test pattern
         MOV       AX,0001H                 ; AX = next test pattern
         MOV       DX,AX                    ; DX = save next test pattern
         MOV       CX,16                    ; CX = pattern counter (0000h - 8000h) = 15
         MOV       DS:[SI],BX               ; write current pattern to current address
T4L2:
         XCHG      DS:[SI],AX               ; read current pattern/write next pattern from/to
         CMP       AX,BX                    ; current address then verify the pattern
         JNE       ERROR4
         MOV       BX,DX                    ; update BX (current pattern) = next pattern
         SHL       DX,1                     ; upgrade the next pattern
         MOV       AX,DX                    ; upgrade AX (next pattern)
         DEC       CX                       ; decrease the pattern counter
         JNZ       T4L2                     ; loop back to test next pattern

	 ADD	   DI,100H		    ; point to next bank
	 CMP	   DI,BP		    ; if 64K memory be tested
         JNZ       T4L1

T3_3:
         XOR       SI,SI                    ; start address = 0:0001h
         MOV       DI,100H

T4L4:    MOV       AX,DI                    ; start test from the first bank
         MOV       DS,AX

         MOV       BX,0FFFFH                ; BX = current test pattern
         MOV       AX,0FFFEH                ; AX = next test pattern
         MOV       DX,AX                    ; DX = save next test pattern
         MOV       CX,16                    ; CX = pattern counter (0FFFFH - 7FFFh) = 15
         MOV       [SI],BX                  ; write current pattern to current address

T4L5:
         XCHG      [SI],AX                  ; read current pattern/write next pattern from/to
         CMP       AX,BX                    ; current address then verify the pattern
         JNE       ERROR4
         MOV       BX,DX                    ; update BX (current pattern) = next pattern
         SHL       DX,1                     ; upgrade the next pattern
         MOV       AX,DX                    ; upgrade AX (next pattern)
         DEC       CX                       ; decrease the pattern counter
         JNZ       T4L5                     ; loop back to test next pattern

         ADD       DI,100H                  ; point to next bank
	 CMP	   DI,BP		    ; if 64K memory be tested
         JNZ       T4L4

         JMP       TST5                     ; TST5

ERROR4:
	 MOV	   AL,23H		    ; error code=03
	 MOV	   BP,03H
	 XOR	   SI,SI
	 MOV	   ES,SI
	 MOV	   ES:[RESULT],AL
	 JMP	   $

;	 MOV	   BX,OFFSET ERR3
;	 CALL	   PRT_MSG
;	 CALL	   ERRMSG

;	  JMP	    FLASH


;----------    TEST 6  SRAM Invalid Memory Address Line (IMA) Test  ---------+
;                                                                            |
;       BEGIN                                                                |
;            FOR DX:= 4K bank                                                |
;               Flood background data '55' to bank                           |
;               write a data '3C' at address ( 0100:003C )                   |
;               FOR  J = 11 ( 100:01, 0:0002, 0004, 0008 .. 400 )            |
;                   read/verify content of current address = '55h'           |
;                   if not then error                                        |
;               NEXT J ( next address )                                      |
;            NEXT DX ( next 4k )                                             |
;       END                                               error code = 04    |
;                                                                            |
;----------------------------------------------------------------------------+


TST5:    MOV       DX,100H
NBK:     MOV       ES,DX
         XOR       DI,DI

         MOV       AL,55H                   ; setup the first pattern = 55h
         MOV       CX,1000H                 ; will test 4kb memory
         CLD
         REP       STOSB                    ; fill memory 0000:0000 - ffff with 55h

         MOV       DI,3CH
         MOV       BL,0AAH
         MOV       ES:[DI],BL               ; fill location 0100:0001 with AAH

         MOV       DI,0001H                 ; point to next location for Ao detect
         MOV       CX,11
LP4:
         MOV       AL,ES:[DI]               ; read data to detect A0 address first
         CMP       AL,55H                   ; if not equal then error occurs
         JNZ       ERROR5
         SHL       DI,1                     ; detect next address line
         LOOP      LP4

         ADD       DX,100H
	 CMP	   DX,BP
         JL        NBK

         JMP       TST6

ERROR5:
	 MOV	   AL,24H		    ; error code=04
	 MOV	   BP,04H		    ; store 0:0E => 24H
	 XOR	   SI,SI
	 MOV	   ES,SI
	 MOV	   ES:[RESULT],AL
	 JMP	   $

;	  MOV	    BX,OFFSET ERR4
;	 CALL	   PRT_MSG
;	 CALL	   ERRMSG
;	  JMP	    FLASH


;--------------------   TEST 7 SRAM WRITE/READ TEST   -----------------------+
;                                                                            |
;          BEGIN                                                             |
;             FOR  I = 6  ( six banks, bank = 64k bytes )                    |
;                FOR  J = 7  ( seven patterns )                              |
;                      WRITE memory flood 32K words                          |
;                      READ  verify content data                             |
;                NEXT J   ( next pattern )                                   |
;             NEXT I  ( next bank  0:0000 - 3:FFFF )                         |
;          END                                            error code=05      |
;                                                                            |
;                                                                            |
;----------------------------------------------------------------------------+


TST6:    PUSH      CS                       ; DS <= CS
         POP       DS

         MOV       DX,100H                  ; 0100:0000
NTBK:    MOV       ES,DX

	 MOV	   BX,OFFSET PATN
	 MOV	   SI,3

NXPN:    XOR       DI,DI
         CLD
         MOV       CX,800H
         MOV       AX,DS:[BX]
     REP       STOSW

         XOR       DI,DI
         MOV       CX,800H
RDA:     MOV       AX,ES:[DI]
         XOR       AX,DS:[BX]
         JZ        NEXTWD
         JMP       ERROR6

NEXTWD:  INC       DI
         INC       DI
         LOOP      RDA

         INC       BX
         INC       BX
         DEC       SI
         JNZ       NXPN

         ADD       DX,100H                  ; next 4K
	 CMP	   DX,BP		    ; BP <= Seg.
         JL        NTBK

         MOV       SI,0
         MOV       ES,SI
	 MOV	   ES:[SGM],BP		    ; save sp, to SEG

         JMP       INISTAK

ERROR6:
	 MOV	   AL,25H		    ; error code=05
	 MOV	   BP,05H		    ; 0:0E error code=25
	 XOR	   SI,SI
	 MOV	   ES,SI
	 MOV	   ES:[RESULT],AL
	 JMP	   $

;	 MOV	   BX,OFFSET ERR5
;	 CALL	   PRT_MSG
;	 CALL	   ERRMSG
;	 JMP	   FLASH


;--------------  Initial Stack & Set up interrupt vector  -----------------



INISTAK:

         MOV       AX,0                     ; point to RAM to set up interrupt vector
         MOV       DS,AX

         MOV       AX,CS

         MOV       BX,40H*4                 ; initial 286 to 386 interrupt vector
         MOV       WORD PTR [BX],OFFSET H286_INT
         MOV       [BX+2],AX

         MOV       BX,50H*4                 ; initial printer interrupt vector
         MOV       WORD PTR [BX],OFFSET PRT_INT
         MOV       [BX+2],AX

         MOV       BX,60H*4                 ; initial data out interrupt vector
         MOV       WORD PTR [BX],OFFSET DTOUT_INT
         MOV       [BX+2],AX

         MOV       BX,70H*4                 ; initial data in interrupt vector
         MOV       WORD PTR [BX],OFFSET DTIN_INT
         MOV       [BX+2],AX

	 MOV	   DS,AX		    ; initial data segment: DS <= CS
	 MOV	   ES,AX		    ; initial extra segment: ES <= CS


;--------------------   Initial chip 8255    --------------------

INIT_BOARD:

         MOV       AL,0AEH                  ; initial 8255 to mode 1
         MOV       DX,0086H
         OUT       DX,AL
         JMP       $+2

         MOV       AL,00H                   ; disable printer interrupt
         MOV       DX,000CH
         OUT       DX,AL
         JMP       $+2

         MOV       AL,04H                   ; disable data in interrupt
         MOV       DX,0086H
         OUT       DX,AL
         JMP       $+2

         MOV       AL,0CH                   ; disable data out interrupt
         OUT       DX,AL
         JMP       $+2

         MOV       AL,00H                   ; select master disk
         MOV       DX,0006H
         OUT       DX,AL
         JMP       $+2

         MOV       AL,00H                   ; reset disk
         MOV       DX,000AH
         OUT       DX,AL
         JMP       $+2


;---------------------    TEST 8  PRINTER TEST    ----------------------------+
;                                                                             |
;       This test is executed under Run-in test, DIP Switch setting OFF(00)   |
;                                                                             |
;-----------------------------------------------------------------------------+


         MOV       DX,0280H                 ; sence dip switch
         IN        AL,DX
         CMP       AL,0                     ; DIP switch all off
         JNE       NORMAL


         MOV       CX,0
CONPTR:  IN        AL,0084H                 ; check print connect
         TEST      AL,10H                   ; print ready
         JNZ       PRT
         AAM
         AAM
         AAM
         LOOP      CONPTR


         MOV       SI,0
         MOV       ES,SI
         MOV       AH,60H
         MOV       ES:[RESULT],AH           ; print not ready ,60H
         JMP       NOPT


PRT:	 MOV	   BP,5 		    ; five lines
PAGN:    MOV       BX,OFFSET COPYRIGHT
         CALL      PRT_MSG
         DEC       BP
         JNZ       PAGN

         MOV       SI,0
         MOV       ES,SI
         MOV       AH,40H                   ; run-in pass '40'
         MOV       ES:[RESULT],AH

NOPT:	 STI
	 LED	   OFF,LEDPORT
         MOV       DX,7                     ; delay time
WTM:     XOR       CX,CX
WATIME:  AAM
         AAM
         AAM
         LOOP      WATIME
         DEC       DX
         JNZ       WTM

	 CLI

         LED       ON,LEDPORT

         MOV       SI,0
         MOV       ES,SI
	 MOV	   BP,ES:[SGM]		    ; retrieve sp

	 JMP	   TST4
NORMAL:  JMP       DSK

;-----------------   Interrup Service Routine   ------------------

H286_INT:                                   ; 386 int 286 service routine
	 PUSH	   ES
	 PUSH	   SI
	 PUSH	   AX
	 PUSH	   DX

         XOR       SI,SI
         MOV       ES,SI
         MOV       AL,11H
         MOV       ES:[INTBIT],AL           ; store 0:0E meaning int occur

         MOV       AL,0                     ; clear 386 int
         MOV       DX,CLPORT
         OUT       DX,AL

         MOV       AX,8000H                 ; int 386
         MOV       DX,INTPORT
         OUT       DX,AX

	 POP	   DX
	 POP	   AX
	 POP	   SI
	 POP	   ES
	 IRET

;-------------------------------------------------------------------------

PRT_INT:
         MOV       BX,OFFSET PRTINT         ; print out message
         CALL      PRT_MSG

         MOV       AL,0H                    ; disable printer interrupt then do printer
         MOV       DX,000CH                 ; interrupt service routine
         OUT       DX,AL

         STI
         IRET

;-----------------------------------------------------------------

DTOUT_INT:
         IRET

;-----------------------------------------------------------------

DTIN_INT:
         CLI
         IN        AL,0082H
         PUSH      AX
         MOV       AL,04H
         OUT       0086H,AL
         POP       AX
         STC
	 STI
         IRET


;---------------------   Print Subroutine   ------------------------

PRT_MSG:
	 MOV	   AL,BYTE PTR CS:[BX]
         CMP       AL,0
         JE        PRT_MSG_END
         INC       BX
         CALL      PRT_OUT
         JMP       PRT_MSG

PRT_MSG_END:
         RET


PRT_OUT:
         PUSH      AX
	 MOV	   CL,0FFH
WAIT_PRT:                                     ; wait printer ready
         IN        AL,0084H
         TEST      AL,10H
	 JZ	   CHK_PRT
	 JMP	   PRTOUT
CHK_PRT: LOOP	   WAIT_PRT

PRTOUT:  POP	   AX			      ; set up data and port
	 PUSH	   DX
	 MOV	   DX,0100H
	 OUT	   DX,AL		      ; print out the data via print port
	 POP	   DX
         RET

;-----------------------------------------------------

ERRMSG:
	 LED	   ON,LEDPORT
	 XOR	   CX,CX
ON11:	 AAM
	 AAM
	 AAM
	 LOOP	   ON11

	 LED	   OFF,LEDPORT
	 XOR	   CX,CX
OFF22:	 AAM
	 AAM
	 LOOP	   OFF22

	 RET


;==================    jmp to dsk microcode   =====================

DSK:
         XOR       SI,SI
         MOV       ES,SI

	 MOV	   AL,ES:[DG]
	 CMP	   AL,80H
	 JE	   WAITDG

	 MOV	   AH,80H		    ; pass code for diag. '80'
	 MOV	   ES:[RESULT],AH

	 STI
	 MOV	   CX,20H
DKOS:	 PUSH	   CX
	 MOV	   CX,0
INT386G: MOV	   AL,ES:[TSCOM]	   ; 0:0F '11'
         CMP       AL,11H
	 JE	   DSKSYS
	 AAM
	 AAM
	 LOOP	   INT386G
	 POP	   CX
	 LOOP	   DKOS
	 JMP	   DSKSYS

WAITDG:  MOV	   AL,ES:[DG]
	 CMP	   AL,88H
	 JNE	   WAITDG

DSKSYS:
         LED       OFF,LEDPORT

	 MOV	   AX,WORD PTR ES:[MSIZE]   ; store memory kb into AX Reg.
	 XOR	   DI,DI
	 MOV	   BL,0F0H		    ; pass code for os, '08'=> 0:0
	 MOV	   DS,DI
	 MOV	   BYTE PTR ES:[BOARDST],BL

;	  JMP	    $			     ; ### del when include DSK microcode

;	      ORG  0FFF0H		     ;
;	  JMP	    START		     ;
;CODE	  ENDS				     ;

;	  END	    START		     ; ###


