        .LIST
        .286
        PAGE 62,132

INCLUDE WANGEQU.ASI

RSTSEG  SEGMENT
        ASSUME  CS:RSTSEG

        ORG     0FFF0H
RESET:  JMP     BEGIN
        ORG     0FFF3H
        JMP     BEGIN1
        DB      9  DUP (00H)

        ORG     0C000H
BEGIN:
        MOV     AX,0
        MOV     DS,AX
        MOV     BYTE PTR DS:[DG],0

BEGIN1:
INCLUDE DSKDIAG.ASM                     ;Diagnostic Code

MAIN:   JMP     MAINX
        DB      "*** 22C11HS Eprom Revision 1.01  10/30/91 ***"
MAINX:  CLI                             ;clear Interrupt
        MOV     AL,0AEH
        OUT     0086H,AL                ;init 8255 to mode 1
        NOP                             ;delay for I/O
        NOP
        NOP
        MOV     AL,00H
        OUT     000CH,AL                ;disable printer interrupt
        NOP                             ;delay for I/O
        NOP
        NOP
        MOV     AL,04H
        OUT     0086H,AL                ;disable data in interrupt
        NOP                             ;delay for I/O
        NOP
        NOP
        MOV     AL,0CH
        OUT     0086H,AL                ;disable data out interrupt

ROM_START:
        MOV     AX,00H
        MOV     DS,AX                   ;set data stack segment for 0
        MOV     SS,AX
        MOV     AX,STACK_BUFFER
        MOV     SP,AX                   ;init stack pointer

        OR      BYTE PTR DS:[EPROM_MODE],0F0H   ;Set to EPROM Mode

        CALL    RESET_DSK               ;reset disk

        MOV     WORD PTR DS:[MEMORY_SIZE],256    ;set memory size 256 KB

        MOV     AX,CS
;       MOV     BX,40H*4
;       MOV     WORD PTR DS:[BX],OFFSET H286_I
;       MOV     WORD PTR DS:[BX+2],AX            ;INIT VECTOR OF 386 TO 286 INTERRUPT

        MOV     BX,50H*4
        MOV     WORD PTR DS:[BX],OFFSET PRINTER_I
        MOV     WORD PTR DS:[BX+2],AX            ;INIT VECTOR OF PRINTER INTERRUPT

        MOV     BX,60H*4
        MOV     WORD PTR DS:[BX],OFFSET DATA_OUT_I
        MOV     WORD PTR DS:[BX+2],AX            ;INIT VECTOR OF DATA OUT INTERRUPT

        MOV     BX,70H*4
        MOV     WORD PTR DS:[BX],OFFSET DATA_IN_I
        MOV     WORD PTR DS:[BX+2],AX            ;INIT VECTOR OF DATA IN INTERRUPT

        MOV     BX,ROM_ENTRY
        MOV     WORD PTR DS:[BX+2],AX
        MOV     AX,OFFSET ROM_START
        MOV     WORD PTR DS:[BX],AX

        MOV     DX,280H
        IN      AL,DX
        MOV     BYTE PTR DS:[PRINTER_ID],AL      ;SET PRINTER SWITCH ID

        MOV     AX,WORD PTR DS:[MEMORY_SIZE]
        SUB     AX,128

        SHL     AX,1                             ;Change to sector
        SHL     AX,1
        MOV     WORD PTR DS:[BUFFER_SIZE],AX

        MOV     BYTE PTR DS:[MAX_PART_NO],1      ;SET MAX PART NO

        MOV     BX,BASE                          ;SET BASE OF BUFFER

        MOV     WORD PTR DS:[BX],1000H           ;BASE SEGMENT
        MOV     WORD PTR DS:[BX+2],0000H         ;BASE OFFSET

        MOV     BX,DATA_BASE                     ;SET DATA BASE FOR 386
        MOV     WORD PTR DS:[BX],BUFFER_START_L
        MOV     WORD PTR DS:[BX+2],BUFFER_START_H

        MOV     BX,PRINT_START_R
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRINT_END_R
        MOV     WORD PTR DS:[BX],PRT_BUFFER_END
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRT_START
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRT_END
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,CMD_BASE
        MOV     WORD PTR DS:[BX],RCB
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,RAM_DL_ENTRY
        MOV     WORD PTR DS:[BX],CODE_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,RAM_ENTRY
        MOV     WORD PTR DS:[BX],0000H
        MOV     AX,CODE_START
        SHR     AX,1
        SHR     AX,1
        SHR     AX,1
        SHR     AX,1
        MOV     WORD PTR DS:[BX+2],AX


        MOV     BYTE PTR DS:[PART_NO],0          ;POLLING FROM PARTITION 0

        MOV     BYTE PTR DS:[RESET_FLAG],0FFH    ;NO RESET COMING ON INIT
        MOV     AX,RCB
        MOV     BP,AX
        MOV     BYTE PTR DS:[BP].@STATUS,0
        MOV     BYTE PTR DS:[BP+1FH],0

MAIN_PROCESS:
        MOV     BYTE PTR DS:[ACT_PART_NO],0FFH
        CALL    BREAK
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     CL,5
        SHL     AX,CL
        ADD     AX,RCB                          ;CALCULATE RCB
        MOV     BP,AX
        CALL    PROCESS_NEXT1_X

        CMP     BYTE PTR DS:[BP].@STATUS,0      ;CHECK RCB STATUS
        JE      PROCESS_NEXT1                   ;BR, IF NO REQUEST

        MOV     BX,OFFSET JMP_TAB               ;GET JMP TABLE

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@REQCODE    ;GET REQUEST CODE
        CMP     AL,20H
        JAE     PROCESS_NEXT2
        SHL     AX,1
        ADD     BX,AX

        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     BYTE PTR DS:[ACT_PART_NO],AL

        JMP     WORD PTR CS:[BX]                ;JMP TO ROUTINE

PROCESS_NEXT1_X:
        CMP     BYTE PTR DS:[BP+1FH],0
        JE      PROCESS_NEXT1_Z
        CMP     BYTE PTR DS:[BP+1FH],0AH
        JNE     PROCESS_NEXT1_Y
        CALL    HOG_DISK
        JMP     PROCESS_NEXT1_Z
PROCESS_NEXT1_Y:
        CMP     BYTE PTR DS:[BP+1FH],0BH
        JNE     PROCESS_NEXT1_Z
        CALL    UNHOG_DISK
PROCESS_NEXT1_Z:
        MOV     BYTE PTR DS:[BP+1FH],0
        RET

PROCESS_NEXT2:
        MOV     BYTE PTR DS:[BP].@ERROR,94H     ;ERROR FOR ILLEGAL REQUEST CODE
PROCESS_NEXT:
        MOV     BYTE PTR DS:[BP].@STATUS,0      ;RESET RCB STATUS
PROCESS_NEXT1:
        INC     BYTE PTR DS:[PART_NO]           ;INCREMENT PARTITION NO
        MOV     AL,BYTE PTR DS:[MAX_PART_NO]
        CMP     BYTE PTR DS:[PART_NO],AL        ;CHECK MAX. PARTITION
        JNE     PROCESS_X
        CALL    SERVICE_PRINT
        MOV     BYTE PTR DS:[PART_NO],0         ;RESET PATITION NO IF MAX.
PROCESS_X:
        JMP     MAIN_PROCESS                    ;PROCESS NEXT

JMP_TAB DW      OFFSET NULL_COMMAND             ;0
        DW      OFFSET READ_SECTOR              ;1
        DW      OFFSET WRITE_SECTOR             ;2
        DW      OFFSET COMPARE_SECTOR           ;3
        DW      OFFSET COPY_SECTOR              ;4
        DW      OFFSET VERIFY_SECTOR            ;5
        DW      OFFSET FORMAT_TRACK             ;6
        DW      OFFSET FORMAT_PLATTER           ;7
        DW      OFFSET READ_STATUS              ;8
        DW      OFFSET TURN_OFF                 ;9
        DW      OFFSET NULL_COMMAND             ;0A
        DW      OFFSET NULL_COMMAND             ;0B
        DW      OFFSET NULL_COMMAND             ;0C
        DW      OFFSET SWITCH_RAM               ;0D
        DW      OFFSET NULL_COMMAND             ;0E
        DW      OFFSET NULL_COMMAND             ;0F
        DW      OFFSET NULL_COMMAND             ;10
        DW      OFFSET NULL_COMMAND             ;11
        DW      OFFSET NULL_COMMAND             ;12
        DW      OFFSET NULL_COMMAND             ;13
        DW      OFFSET NULL_COMMAND             ;14
        DW      OFFSET NULL_COMMAND             ;15
        DW      OFFSET NULL_COMMAND             ;16
        DW      OFFSET NULL_COMMAND             ;17
        DW      OFFSET NULL_COMMAND             ;18
        DW      OFFSET NULL_COMMAND             ;19
        DW      OFFSET NULL_COMMAND             ;1A
        DW      OFFSET NULL_COMMAND             ;1B
        DW      OFFSET NULL_COMMAND             ;1C
        DW      OFFSET NULL_COMMAND             ;1D
        DW      OFFSET NULL_COMMAND             ;1E
        DW      OFFSET WARM_START               ;1F

READ_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_1         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_1    ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_1           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_1
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_1
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR                         ;GET BUFFER POINTER
READ_AGAIN:
        CALL    DREAD                                  ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      READ_SECTOR_END                        ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     READ_AGAIN                             ;BR, TO READ AGAIN
READ_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_1,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

WRITE_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_2         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_2    ;GET TOTAL SECTOR NO TO BE WRITE
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_2           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_2
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_2
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR
        MOV     BYTE PTR DS:[WRITE_FLAG],0
        CMP     WORD PTR DS:[BP].@SECTOR_COUNT_2,1     ;
        JBE     WRITE_AGAIN
        MOV     BYTE PTR DS:[WRITE_FLAG],1
        CALL    MSWRTBEG
WRITE_AGAIN:
        CALL    DWRITE                                 ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      WRITE_SECTOR_END                       ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     WRITE_AGAIN                            ;BR, TO WRITE AGAIN
WRITE_SECTOR_END:
        CMP     BYTE PTR DS:[WRITE_FLAG],1
        JNE     WRITE_END
        CALL    MSWRTEND
WRITE_END:
        MOV     BYTE PTR DS:[WRITE_FLAG],0             ;RESET MULTI WRITE FLAG
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_2,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

COMPARE_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_3         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT_3    ;GET TOTAL SECTOR NO TO BE COMPARE
        MOV     WORD PTR DS:[SECTOR_COUNT],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_3           ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_3
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_3
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    GET_BUFFER_PTR                         ;GET BUFFER POINTER
COMPARE_AGAIN:
        CALL    DCOMPARE
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      COMPARE_SECTOR_END                     ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     COMPARE_AGAIN                          ;BR, TO COMPARE AGAIN
COMPARE_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_3,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

COPY_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER1_4        ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR11_4          ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR12_4
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR13_4
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    DCOPY
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

VERIFY_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_5         ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR11_5          ;GET STARTING SECTOR ADDRESS
        MOV     BYTE PTR DS:[ADDR1],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR12_5
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR13_5
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    DVERIFY
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_5,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

FORMAT_TRACK:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_6
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_6
        MOV     BYTE PTR DS:[ADDR1],AL          ;SET SECTOR ADDRESS
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_6
        MOV     BYTE PTR DS:[ADDR2],AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_6
        MOV     BYTE PTR DS:[ADDR3],AL
        CALL    DTRACK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

FORMAT_PLATTER:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_7
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DFORMAT                         ;SEND FORMAT COMMAND
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_7,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

READ_STATUS:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_8
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DSTATUS
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

TURN_OFF:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_9
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DTURNOFF
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

HOG_DEVICE:
        CALL    HOG_DISK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

UNHOG_DEVICE:
        CALL    UNHOG_DISK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

RESET_DEVICE:
        CALL    RESET_DSK
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SWITCH_RAM:
        MOV     BYTE PTR DS:[BP].@STATUS,00H
        MOV     BYTE PTR DS:[BP].@ERROR,00H
        MOV     BX,RAM_ENTRY
        JMP     DWORD PTR DS:[BX]                      ;SWITCH TO RAM

NULL_COMMAND:
        JMP     PROCESS_NEXT2

SERVICE_PRINT:
;       MOV     BX,WORD PTR DS:[PRT_START]
;       CMP     BX,WORD PTR DS:[PRT_END]
;       JE      SERVICE_0
;       IN      AL,0084H
;       TEST    AL,10H
;       JZ      SERVICE_0
;       MOV     AL,BYTE PTR DS:[BX]
;       MOV     DX,100H
;       OUT     DX,AL
;       CMP     BX,PRT_BUFFER_END
;       JNE     SERVICE_1
;       MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
;       JMP     SERVICE_PRINT
SERVICE_1:
;       INC     WORD PTR DS:[PRT_START]
;       JMP     SERVICE_PRINT
SERVICE_0:
        RET

WARM_START:
        MOV     BYTE PTR DS:[BP].@STATUS,0
        MOV     BYTE PTR DS:[BP].@ERROR,0
        DB      0EAH
        DW      0FFF3H
        DW      0F000H

INCLUDE CSXX.ASM

CLEAR_BUFFER:
        RET

RSTSEG  ENDS
        END
