Public  Cinit
Public  Chk_Cache
Public  CAlloc
Public  CRemove
Public  CInvalPlat
Public  CInvalSec
Public  CHitUpdate
Public  CMissUpdate
Public  Build_Config
Public  Get_PlatNo

Floppy_ID       db 00,00,00,54h,45h,41h,43h,20h

; Cinit: Initializes the Table and List of Cache
;
; Input  : None
; Output : None, Table and List of Cache are initialized.

Cinit:
        cmp     byte ptr es:[Cache_On],0
        je      Cinit_2
        mov     cx,Node_No
        mov     si,0
        mov     ax,Null_Node
        mov     bx,2
Cinit_1:
        mov     word ptr es:Hash_Tbl[si],ax             ;Init Hash Table
        mov     word ptr es:Hash_Lst[si],ax             ;Init Hash List
        mov     word ptr es:Hash_Lst_I[si],ax           ;Init Hash List for Index
        mov     word ptr es:Used_Lst_U[si],ax           ;Init Used List for Up
        mov     word ptr es:Used_Lst_D[si],ax           ;Init Used List for Down
        mov     word ptr es:Free_Lst[si],bx             ;Init Free List
        mov     word ptr es:Cache_Lst[si],0ff00h        ;Init Cache List
        mov     word ptr es:Sector_Lst[si],ax           ;Init Cache List
        add     si,2
        add     bx,2
        loop    Cinit_1

        mov     word ptr es:Free_Lst[si-2],ax           ;Null of Free List
        mov     word ptr es:[Free_Lst_Ptr],0            ;Init Free List Pointer
        mov     word ptr es:[Used_Lst_Hptr],Null_Node   ;Init Used List Hptr
        mov     word ptr es:[Used_Lst_Lptr],Null_Node   ;Init Used List Lptr

Cinit_2:
        ret


; Chk_Cache: Does cache lookup to see if a given sector is cached
;
; Input  : DX:AX =Sector Number, CL = Platter Number
; Output : BX = Cached Node Number (0ffffh for miss)

Chk_Cache:
        cmp     byte ptr es:[Cache_On],0
        je      Cache_Miss
        and     ax,0fffeh               ;set to even for SCSI block
        mov     bx,Node_No*2
        div     bx
        mov     bx,dx
        mov     word ptr es:[Hash_Head],bx
        mov     word ptr es:[Sector_Val],ax
        mov     byte ptr es:[Plat_Val],cl
        cmp     word ptr es:Hash_Tbl[bx],Null_Node      ;Check Null Pointer
        je      Cache_Miss
        mov     word ptr es:[Prv_Hash],Null_Node
        mov     si,word ptr es:Hash_Tbl[bx]
Chk_Again:
        cmp     byte ptr es:Cache_Lst[si+1],cl  ;Check Platter Number
        jne     Chk_Next_Lst
        cmp     word ptr es:Sector_Lst[si],ax   ;Check Sector Number
        je      Cache_Hit
Chk_Next_Lst:
        cmp     word ptr es:Hash_Lst[si],Null_Node    ;Check Next Hash List
        je      Cache_Miss
        mov     word ptr es:[Prv_Hash],si
        mov     si,word ptr es:Hash_Lst[si]
        jmp     Chk_Again

Cache_Hit:
        mov     bx,si
        ret

Cache_Miss:
        mov     bx,Null_Node
        ret


; CAlloc: Allocate dynamic storage
;
; Input  : None
; Output : BX = Node Number

CAlloc:
        cmp     byte ptr es:[Cache_On],0
        je      CAlloc5
        cmp     word ptr es:[Free_Lst_Ptr],Null_Node
        je      CAlloc1                                 ;Br, No Free Node
        mov     bx,word ptr es:[Free_Lst_Ptr]
        mov     ax,word ptr es:Free_Lst[bx]
        mov     word ptr es:[Free_Lst_Ptr],ax           ;Get Node from Free List
        ret

CAlloc1:
        mov     bx,word ptr es:[Used_Lst_Lptr]          ;get Lptr Node
        mov     si,word ptr es:Used_Lst_U[bx]           ;get Uptr of Lptr Node
        mov     word ptr es:[Used_Lst_Lptr],si          ;set Lptr
        mov     word ptr es:Used_Lst_D[si],Null_Node    ;set New Lptr D
        mov     si,word ptr es:Hash_Lst_I[bx]
        cmp     word ptr es:Hash_Tbl[si],bx
        je      CAlloc2
        mov     si,word ptr es:Hash_Tbl[si]
CAlloc3:
        cmp     word ptr es:Hash_Lst[si],bx
        je      CAlloc4
        mov     si,word ptr es:Hash_Lst[si]
        jmp     CAlloc3
CAlloc2:
        mov     di,word ptr es:Hash_Lst[bx]
        mov     word ptr es:Hash_Tbl[si],di
        mov     word ptr es:Cache_Lst[bx],0ff00h
        ret
CAlloc4:
        mov     di,word ptr es:Hash_Lst[bx]
        mov     word ptr es:Hash_Lst[si],di
        mov     word ptr es:Cache_Lst[bx],0ff00h
        ret

CAlloc5:
        mov     bx,0
        ret


; CRemove: Remove a Node Entry from Cache.
;
; Input  : BX = Node Number
; Output : None

CRemove8x:
        jmp     CRemove8

CRemove:
        cmp     byte ptr es:[Cache_On],0
        je      CRemove8x
        mov     si,word ptr es:[Free_Lst_Ptr]
        mov     word ptr es:[Free_Lst_Ptr],bx
        mov     word ptr es:Free_Lst[bx],si
        mov     word ptr es:Cache_Lst[bx],0ff00h

        mov     si,word ptr es:Hash_Lst_I[bx]
        cmp     word ptr es:Hash_Tbl[si],bx
        je      CRemove2
        mov     si,word ptr es:Hash_Tbl[si]

CRemove3:
        cmp     word ptr es:Hash_Lst[si],bx
        je      CRemove4
        mov     si,word ptr es:Hash_Lst[si]
        jmp     CRemove3

CRemove2:
        mov     di,word ptr es:Hash_Lst[bx]
        mov     word ptr es:Hash_Tbl[si],di
        jmp     CRemove1

CRemove4:
        mov     di,word ptr es:Hash_Lst[bx]
        mov     word ptr es:Hash_Lst[si],di

CRemove1:
        cmp     word ptr es:[Used_Lst_Hptr],bx
        jne     CRemove5
        cmp     word ptr es:[Used_Lst_Lptr],bx
        jne     CRemove6
        mov     word ptr es:[Used_Lst_Hptr],Null_Node
        mov     word ptr es:[Used_Lst_Lptr],Null_Node
        ret

CRemove6:
        mov     si,word ptr es:Used_Lst_D[bx]
        mov     word ptr es:[Used_Lst_Hptr],si
        mov     word ptr es:Used_Lst_U[si],Null_Node
        ret

CRemove5:
        cmp     word ptr es:[Used_Lst_Lptr],bx
        jne     CRemove7
        mov     si,word ptr es:Used_Lst_U[bx]
        mov     word ptr es:[Used_Lst_Lptr],si
        mov     word ptr es:Used_Lst_D[si],Null_Node
        ret

CRemove7:
        mov     di,word ptr es:Used_Lst_U[bx]
        mov     si,word ptr es:Used_Lst_D[bx]
        mov     word ptr es:Used_Lst_U[si],di
        mov     word ptr es:Used_Lst_D[di],si
        ret

CRemove8:
        ret


; CInvalPlat: Invalidate all sectors of a platter and Remove from Hash List to
;             Free List
;
; Input  : Al = Platter Number
; Output : None

CInvalPlat:
        cmp     byte ptr es:[Cache_On],0
        je      CInvalPlat3
        mov     cx,Node_No
        mov     bx,0

CInvalPlat2:
        cmp     byte ptr es:Cache_Lst[bx+1],al
        jne     CInvalPlat1
        test    word ptr es:Cache_Lst[bx],Cached_Bit
        jz      CInvalPlat1
        push    ax
        push    cx
        push    bx
        call    CRemove
        pop     bx
        pop     cx
        pop     ax
        add     bx,2
        loop    CInvalPlat2
        ret

CInvalPlat1:
        add     bx,2
        loop    CInvalPlat2
        ret

CInvalPlat3:
        ret


; CInvalPlat_s: Invalidate all sectors of a Drive and Remove from Hash List to
;               Free List
;
; Input  : Al = Drive Number
; Output : None

CInvalPlat_s:
        cmp     byte ptr es:[Cache_On],0
        je      CInvalPlat_s3
        mov     si,0
        mov     bx,0
        mov     cx,32
CInvalPlat_s2:
        push    si
        push    cx
        push    bx
        push    ax
        cmp     byte ptr ds:System_Config2[si].D_Status,0ffh
        je      CInvalPlat_s1
        cmp     byte ptr ds:System_Config2[si].D_id,al
        jne     CInvalPlat_s1
        mov     al,bl
        call    CinvalPlat
CinvalPlat_s1:
        pop     ax
        pop     bx
        pop     cx
        pop     si
        add     si,16
        inc     bx
        loop    CInvalPlat_s2
        ret

CInvalPlat_s3:
        ret


; CInvalSec: Invalidate a sector if it is cached and Remove it to Free List
;
; Input  : DX:AX =Sector Number, CL = Platter Number
; Output : None

CInvalSec:
        cmp     byte ptr es:[Cache_On],0
        je      CInvalSec1
        call    Chk_Cache
        cmp     bx,Null_Node
        je      CInvalSec1
        call    CRemove
CInvalSec1:
        ret


; CHitUpdate: Update use status and used List to reflect cache hit.
;             Move to front of Hash List
;
; Input  : BX = Node Number
; Output : None
CHitUpdate4x:
        jmp     CHitUpdate4

CHitUpdate:
        cmp     byte ptr es:[Cache_On],0
        je      CHitUpdate4x
        mov     si,word ptr es:Hash_Lst_I[bx]
        cmp     word ptr es:Hash_Tbl[si],bx
        je      CHitUpdate2

        mov     di,word ptr es:Hash_Lst[bx]
        mov     si,word ptr es:[Prv_Hash]
        mov     word ptr es:Hash_Lst[si],di
        mov     si,word ptr es:Hash_Lst_I[bx]
        mov     di,word ptr es:Hash_Tbl[si]
        mov     word ptr es:Hash_Tbl[si],bx
        mov     word ptr es:Hash_Lst[bx],di

CHitUpdate2:
        cmp     word ptr es:[Used_Lst_Hptr],bx
        jne     CHitUpdate1
        ret

ChitUpdate1:
        cmp     word ptr es:[Used_Lst_Lptr],bx
        jne     CHitUpdate3
        mov     si,word ptr es:Used_Lst_U[bx]
        mov     word ptr es:[Used_Lst_Lptr],si
        mov     word ptr es:Used_Lst_D[si],Null_Node
        mov     si,word ptr es:[Used_Lst_Hptr]
        mov     word ptr es:[Used_Lst_Hptr],bx
        mov     word ptr es:Used_Lst_U[si],bx
        mov     word ptr es:Used_Lst_D[bx],si
        mov     word ptr es:Used_Lst_U[bx],Null_Node
        ret

CHitUpdate3:
        mov     di,word ptr es:Used_Lst_U[bx]
        mov     si,word ptr es:Used_Lst_D[bx]
        mov     word ptr es:Used_Lst_U[si],bx
        mov     word ptr es:Used_Lst_D[di],bx

        mov     si,word ptr es:[Used_Lst_Hptr]
        mov     word ptr es:[Used_Lst_Hptr],bx
        mov     word ptr es:Used_Lst_U[si],bx
        mov     word ptr es:Used_Lst_D[bx],si
        mov     word ptr es:Used_Lst_U[bx],Null_Node
        ret

CHitUpdate4:
        ret



; CMissUpdate: Add newly read sectors to Cache
;
; Input  : BX = Node Number
; Output : None

CMissUpdate:
        cmp     byte ptr es:[Cache_On],0
        je      CMissUpdate2
        mov     si,word ptr es:[Hash_Head]
        mov     di,word ptr es:Hash_Tbl[si]
        mov     word ptr es:Hash_Tbl[si],bx
        mov     word ptr es:Hash_Lst[bx],di

        mov     di,word ptr es:[Sector_val]
        mov     word ptr es:Sector_Lst[bx],di
        mov     word ptr es:Hash_Lst_I[bx],si
        mov     word ptr es:Cache_Lst[bx],0
        or      word ptr es:Cache_Lst[bx],Cached_Bit
        mov     al,byte ptr es:[Plat_Val]
        mov     byte ptr es:Cache_Lst[bx+1],al

        cmp     word ptr es:[Used_Lst_Hptr],Null_Node
        jne     CMissUpdate1
        mov     word ptr es:[Used_Lst_Hptr],bx
        mov     word ptr es:[Used_Lst_Lptr],bx
        mov     word ptr es:Used_Lst_U[bx],Null_Node
        mov     word ptr es:Used_Lst_D[bx],Null_Node
        ret

CMissUpdate1:
        mov     si,word ptr es:[Used_Lst_Hptr]
        mov     word ptr es:[Used_Lst_Hptr],bx
        mov     word ptr es:Used_Lst_U[si],bx
        mov     word ptr es:Used_Lst_D[bx],si
        mov     word ptr es:Used_Lst_U[bx],Null_Node
        ret

CMissUpdate2:
        ret

check_fd:
        cmp     byte ptr ds:Vendor_Info[di],00h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+1],00h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+2],00h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+3],54h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+4],45h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+5],41h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+6],43h
        jne     check_fd_end
        cmp     byte ptr ds:Vendor_Info[di+7],20h
        jne     check_fd_end
        cmp     byte ptr ds:[V_FDD_ID],0FFH
        jne     check_fd_end
        mov     byte ptr ds:[V_FDD_ID],bl

check_fd_end:
        ret

; Build_Config : Inquery all Device ID and Read Config Block to Build System Config
;
; Input : None
; Output: None

Build_Config:
        mov     si,0
        mov     di,0
        mov     cx,8
Build_Config9:
        push    cx
        mov     cx,64
Build_Config_K:
        mov     byte ptr ds:Vendor_Info[di],20h
        inc     di
        loop    Build_Config_K
        pop     cx

        mov     byte ptr ds:System_Config1[si].D_Status,0ffh
        mov     byte ptr ds:System_Config1[si].D_Config,0
        mov     word ptr ds:System_Config1[si].D_Block_No_L,0
        mov     word ptr ds:System_Config1[si].D_Block_No_H,0
        mov     word ptr ds:System_Config1[si].D_Block_Len_L,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_Len_H,0ffffh
        add     si,16
        loop    Build_Config9

        mov     si,0
        mov     cx,32
Build_Config10:
        mov     byte ptr ds:System_Config2[si].D_Type,0ffh
        mov     byte ptr ds:System_Config2[si].D_Id,0ffh
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,0ffffh
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,0ffffh
        add     si,16
        loop    Build_Config10

        mov     cx,8
        mov     bx,0007h
        mov     word ptr ds:[PLATTER_SLOT],1007h
Build_Config7:
        push    cx
        push    bx
        call    Inquery
        cmp     al,0
        jne     Build_Config41
        pop     bx

        mov     di,bx
        and     di,0fh
        mov     cl,6
        shl     di,cl

        mov     si,BUFFER
        mov     cx,64
        cmp     byte ptr ds:[si+4],64
        jae     Build_Config_Q
        mov     cl,byte ptr ds:[si+4]
Build_Config_Q:
        add     si,5
        push    di
Build_Config_P:
        mov     al,byte ptr ds:[si]
        mov     byte ptr ds:Vendor_Info[di],al
        inc     si
        inc     di
        loop    Build_Config_P
        pop     di

        call    check_fd

        mov     si,BUFFER
        mov     al,byte ptr ds:[si]
        and     al,1fh
        and     byte ptr ds:[si+1],80h
        or      al,byte ptr ds:[si+1]
        mov     ah,al
        and     ah,1fh
        push    ax
        push    bx
        mov     cx,10h
Build_Config991:
        push    cx
        call    test_unit_ready
        pop     cx
        cmp     al,0
        je      Build_Config99
        pop     bx
        push    bx
        loop    Build_Config991
Build_Config99:
        pop     bx
        pop     ax
        push    bx
;       mov     si,BUFFER
;       mov     al,byte ptr ds:[si]
;       and     al,1fh
;       and     byte ptr ds:[si+1],80h
;       or      al,byte ptr ds:[si+1]
;       mov     ah,al
;       and     ah,1fh
        cmp     ah,00h
        je      Build_Config1                   ;Direct Access Device
        cmp     ah,01h
        je      Build_Config1                   ;Sequential Access Device

        jmp     Build_Config2                   ;Not Implemented

Build_Config41:
        jmp     Build_Config4
Build_Config39:
        jmp     Build_Config3
Build_Config29:
        cmp     byte ptr ds:[MASTER_ID],1
        jne     Build_Configkk2
        mov     byte ptr ds:[MASTER_ID],0
        mov     si,BUFFER
        add     si,148
        jmp     Build_Configkk

Build_Configkk2:
        jmp     Build_Config2

Build_Config1:
        test    al,80h
        jnz     Build_Config39

        pop     bx
        push    bx
        push    ax
        mov     bh,03h
        xor     dx,dx
        xor     ax,ax
        mov     cx,1
        call    disk_read
        cmp     al,0
        pop     ax
        jne     Build_Config29
        mov     byte ptr ds:[MASTER_ID],1
        mov     si,BUFFER

Build_Configkk:
        cmp     word ptr ds:[si],'cs'
        jne     Build_Config29
        cmp     byte ptr ds:[si+2],'s'
        jne     Build_Config29
        cmp     byte ptr ds:[si+3],'i'
        jne     Build_Config29

Build_Config29y:
        add     si,4
        pop     bx
        push    bx
        mov     di,bx
        and     di,0fh
        mov     cl,4
        shl     di,cl
        mov     ch,al
        mov     byte ptr ds:System_Config1[di].D_Status,al
        mov     byte ptr ds:System_Config1[di].D_Config,1
        mov     word ptr ds:System_Config1[di].D_Block_No_L,0
        mov     word ptr ds:System_Config1[di].D_Block_No_H,0
        mov     word ptr ds:System_Config1[di].D_Block_Len_L,0ffffh
        mov     word ptr ds:System_Config1[di].D_Block_Len_H,0ffffh

Build_Config53:
        cmp     word ptr ds:[si],0ffffh
        jne     Build_Config5
        cmp     word ptr ds:[si+2],0ffffh
        jne     Build_Config5

        cmp     byte ptr ds:[MASTER_ID],1
        jne     Build_Configkk1
        mov     byte ptr ds:[MASTER_ID],0
        mov     si,BUFFER
        add     si,148

        cmp     word ptr ds:[si],'cs'
        jne     Build_Configkk1
        cmp     byte ptr ds:[si+2],'s'
        jne     Build_Configkk1
        cmp     byte ptr ds:[si+3],'i'
        jne     Build_Configkk1

        jmp     Build_Config53

Build_Configkk1:
        pop     bx
        pop     cx
        dec     bx
        loop    Build_Config71
        jmp     Build_Config8

Build_Config71:
        jmp     Build_Config7

Build_Config5:
        cmp     byte ptr ds:[MASTER_ID],1
        jne     Build_Config51
        mov     ax,bx
        and     ax,0ff00h
        cmp     ax,0000h
        jne     Build_Config52
        pop     ax
        add     bx,0100h
        push    bx
        jmp     Build_Config54

Build_Config51:
        mov     ax,word ptr ds:[PLATTER_SLOT]
        and     ax,0ff00h
        cmp     ax,1000h
        jne     Build_Config52_a
        pop     ax
        add     word ptr ds:[PLATTER_SLOT],0100h
        push    bx
        jmp     Build_Config54_a

Build_Config52:
        cmp     ax,1000h
        jne     Build_Config54
        add     si,8
        pop     bx
        push    bx
        jmp     Build_Config53

Build_Config54:
        mov     di,bx
        mov     cl,8
        shr     di,cl
        mov     cl,4
        shl     di,cl
        mov     byte ptr ds:System_Config2[di].D_Type,ch
        mov     byte ptr ds:System_Config2[di].D_Id,bl
        mov     ax,word ptr ds:[si]
        mov     word ptr ds:System_Config2[di].D_Platter_Start_L,ax
        mov     ax,word ptr ds:[si+2]
        mov     word ptr ds:System_Config2[di].D_Platter_Start_H,ax
        mov     ax,word ptr ds:[si+4]
        mov     word ptr ds:System_Config2[di].D_Platter_Len_L,ax
        mov     ax,word ptr ds:[si+6]
        mov     word ptr ds:System_Config2[di].D_Platter_Len_H,ax
        add     si,8
        pop     bx
        add     bx,0100h
        push    bx
        jmp     Build_Config53

Build_Config52_a:
        cmp     ax,1f00h
        jne     Build_Config54_a
        add     si,8
        pop     bx
        push    bx
        jmp     Build_Config53

Build_Config54_a:
        mov     di,word ptr ds:[PLATTER_SLOT]
        mov     cl,8
        shr     di,cl
        mov     cl,4
        shl     di,cl
        mov     byte ptr ds:System_Config2[di].D_Type,ch
        mov     byte ptr ds:System_Config2[di].D_Id,bl
        mov     ax,word ptr ds:[si]
        mov     word ptr ds:System_Config2[di].D_Platter_Start_L,ax
        mov     ax,word ptr ds:[si+2]
        mov     word ptr ds:System_Config2[di].D_Platter_Start_H,ax
        mov     ax,word ptr ds:[si+4]
        mov     word ptr ds:System_Config2[di].D_Platter_Len_L,ax
        mov     ax,word ptr ds:[si+6]
        mov     word ptr ds:System_Config2[di].D_Platter_Len_H,ax
        add     si,8
        pop     bx
        add     word ptr ds:[PLATTER_SLOT],0100h
        push    bx
        jmp     Build_Config53


Build_Config4:
        pop     bx
        mov     si,bx
        and     si,0fh
        mov     cl,4
        shl     si,cl
        mov     byte ptr ds:System_Config1[si].D_Status,0ffh
        mov     byte ptr ds:System_Config1[si].D_Config,0
        mov     word ptr ds:System_Config1[si].D_Block_No_L,0FFFFH
        mov     word ptr ds:System_Config1[si].D_Block_No_H,0FFFFH
        mov     word ptr ds:System_Config1[si].D_Block_Len_L,0FFFFH
        mov     word ptr ds:System_Config1[si].D_Block_Len_H,0FFFFH
        pop     cx
        dec     bx
        loop    Build_Config72
        jmp     Build_Config8

Build_COnfig72:
        jmp     Build_Config7

disk_err_mg:
        jmp     disk_err_m

Build_Config3x:
        pop     ax
        pop     bx
        mov     di,buffer
        mov     si,bx
        and     si,0fh
        mov     cl,4
        shl     si,cl
        mov     byte ptr ds:System_Config1[si].D_Status,al
        mov     byte ptr ds:System_Config1[si].D_Config,0
        mov     word ptr ds:System_Config1[si].D_Block_No_H,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_No_L,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_Len_H,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_Len_L,0ffffh
        mov     ah,al
        and     ah,7fh
        cmp     ah,01h
        je      Build_Config313x                ;tape

        mov     si,0*16
        cmp     byte ptr ds:System_Config2[si].D_Type,0ffh
        jne     Build_Config33k
        mov     byte ptr ds:System_Config2[si].D_Type,al
        mov     byte ptr ds:System_Config2[si].D_Id,bl
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,0ffffh
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,0ffffh

        jmp     Build_Config32

Build_Config32k:
        jmp     Build_Config32

Build_Config33k:
        mov     si,16*16
        cmp     byte ptr ds:System_Config2[si].D_Type,0ffh
        jne     Build_Config32k
        mov     byte ptr ds:System_Config2[si].D_Type,al
        mov     byte ptr ds:System_Config2[si].D_Id,bl
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,0ffffh
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,0ffffh

        jmp     Build_Config32


Build_Config313x:
        mov     si,31*16
        cmp     byte ptr ds:System_Config2[si].D_Type,0ffh
        jne     Build_Config32k
        mov     byte ptr ds:System_Config2[si].D_Type,al
        mov     byte ptr ds:System_Config2[si].D_Id,bl
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,0ffffh
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,0ffffh

        jmp     Build_Config32

Build_Config3xy:
        jmp     Build_Config3x

Build_Config3:
        pop     bx
        push    bx
        push    ax
;;      and     al,7fh
;;      cmp     al,01h
;;      je      Build_Config3x
        call    capacity
        cmp     al,0
        jne     Build_Config3xy
        pop     ax
        pop     bx
        mov     di,buffer
        mov     si,bx
        and     si,0fh
        mov     cl,4
        shl     si,cl
        mov     byte ptr ds:System_Config1[si].D_Status,al
        mov     byte ptr ds:System_Config1[si].D_Config,0
        mov     cx,word ptr ds:[di]
        xchg    ch,cl
        mov     word ptr ds:System_Config1[si].D_Block_No_H,cx
        mov     cx,word ptr ds:[di+2]
        xchg    ch,cl
        mov     word ptr ds:System_Config1[si].D_Block_No_L,cx

;       add     word ptr ds:System_Config1[si].D_Block_No_L,1
;       adc     word ptr ds:System_Config1[si].D_Block_No_H,0
;
;       clc
;       rcl     word ptr ds:System_Config1[si].D_Block_No_L,1
;       rcl     word ptr ds:System_Config1[si].D_Block_No_H,1

        mov     cx,word ptr ds:[di+4]
        xchg    ch,cl
        mov     word ptr ds:System_Config1[si].D_Block_Len_H,cx
        mov     cx,word ptr ds:[di+6]
        xchg    ch,cl
        mov     word ptr ds:System_Config1[si].D_Block_Len_L,cx
        mov     ah,al
        and     ah,7fh
        cmp     ah,01h
        je      Build_Config313                 ;tape

        mov     si,0*16
        cmp     byte ptr ds:System_Config2[si].D_Type,0ffh
        jne     Build_Config33
        mov     byte ptr ds:System_Config2[si].D_Type,al
        mov     byte ptr ds:System_Config2[si].D_Id,bl
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     cx,word ptr ds:[di]
        xchg    ch,cl
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,cx
        mov     cx,word ptr ds:[di+2]
        xchg    ch,cl
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,cx

        cmp     word ptr ds:[di+4],0
        jne     yyy1
        cmp     word ptr ds:[di+6],0100h
        jne     yyy2
yyy1:

        add     word ptr ds:System_Config2[si].D_Platter_Len_L,1
        adc     word ptr ds:System_Config2[si].D_Platter_Len_H,0

        clc
        rcl     word ptr ds:System_Config2[si].D_Platter_Len_L,1
        rcl     word ptr ds:System_Config2[si].D_Platter_Len_H,1
yyy2:

        jmp     Build_Config32

Build_Config313:
        jmp     Build_Config31

Build_Config33:
        mov     si,16*16
        cmp     byte ptr ds:System_Config2[si].D_Type,0ffh
        jne     Build_Config32
        mov     byte ptr ds:System_Config2[si].D_Type,al
        mov     byte ptr ds:System_Config2[si].D_Id,bl
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     cx,word ptr ds:[di]
        xchg    ch,cl
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,cx
        mov     cx,word ptr ds:[di+2]
        xchg    ch,cl
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,cx

        add     word ptr ds:System_Config2[si].D_Platter_Len_L,1
        adc     word ptr ds:System_Config2[si].D_Platter_Len_H,0

        clc
        rcl     word ptr ds:System_Config2[si].D_Platter_Len_L,1
        rcl     word ptr ds:System_Config2[si].D_Platter_Len_H,1

        jmp     Build_Config32

Build_Config31:
        mov     si,31*16
        cmp     byte ptr ds:System_Config2[si].D_Type,0ffh
        jne     Build_Config32
        mov     byte ptr ds:System_Config2[si].D_Type,al
        mov     byte ptr ds:System_Config2[si].D_Id,bl
        mov     word ptr ds:System_Config2[si].D_Platter_Start_L,0
        mov     word ptr ds:System_Config2[si].D_Platter_Start_H,0
        mov     cx,word ptr ds:[di]
        xchg    ch,cl
        mov     word ptr ds:System_Config2[si].D_Platter_Len_H,cx
        mov     cx,word ptr ds:[di+2]
        xchg    ch,cl
        mov     word ptr ds:System_Config2[si].D_Platter_Len_L,cx

;;      add     word ptr ds:System_Config2[si].D_Platter_Len_L,1
;;      adc     word ptr ds:System_Config2[si].D_Platter_Len_H,0

;;      clc
;;      rcl     word ptr ds:System_Config2[si].D_Platter_Len_L,1
;;      rcl     word ptr ds:System_Config2[si].D_Platter_Len_H,1

Build_Config32:
        pop     cx
        dec     bx
        loop    Build_Config73
        jmp     Build_Config8

Build_COnfig73:
        jmp     Build_Config7

Build_Config2:
        pop     bx
        mov     si,bx
        and     si,0fh
        mov     cl,4
        shl     si,cl
        mov     byte ptr ds:System_Config1[si].D_Status,al
        mov     byte ptr ds:System_Config1[si].D_Config,0
        mov     word ptr ds:System_Config1[si].D_Block_No_L,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_No_H,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_Len_L,0ffffh
        mov     word ptr ds:System_Config1[si].D_Block_Len_H,0ffffh
        pop     cx
        dec     bx
        loop    Build_Config74

Build_Config8:
        ret

Build_COnfig74:
        jmp     Build_Config7


; Get_PlatNo : Convert 2200 Device Type to Seguence Platter Number
;
; Input : DX = 2200 Device Type
; Output: BX = Platter Number

Get_PlatNo:
        mov     al,dh
        and     al,0fh
        cmp     al,0dh
        je      Get_PlatNo1            ;D Type

        mov     ah,dh
        and     ah,0f0h
        cmp     ah,20h
        je      Get_PlatNo2            ;R Type
        cmp     ah,10h
        je      Get_PlatNo3            ;F Type
        cmp     al,0bh
        je      Get_PlatNo2            ;B Type
Get_PlatNo3:
        or      dl,01h                 ;Platter = Fixed
Get_PlatNo2:
        and     dh,0f0h
        or      dh,0dh
Get_PlatNo1:
        test    dh,0f0h
        jz      Get_PlatNo4
        test    dh,10h
        jnz     Get_PlatNo4
Get_PlatNo6:
        mov     bx,0
Get_PlatNo5:
        test    dl,40h
        jz      Get_PlatNo7
        or      bx,10h
Get_PlatNo7:
        cmp     bx,1fh
        jne     Get_PlatNo8
        jmp     error_91
Get_PlatNo8:
        ret

Get_PlatNo4:
        test    dl,0fh
        jz      Get_PlatNo6
        mov     bl,dl
        and     bx,0fh
        jmp     Get_PlatNo5
