        .list
        .286
        Page 62,132

include scsiequ.asi

RamSeg  Segment
        Assume  CS:RamSeg

MAIN:   JMP     MAIN_X
        DB      "*** Wang Laboratories, Inc.  @22C11SS MicroCode Rev 0.92 07/07/92 ***"
DATASEG DW      0
MAIN_X:
        MOV     WORD PTR DS:[RAM_REVISION],9200H ;RELEASE 1.00

        MOV     BYTE PTR DS:[PART_NO],0          ;POLLING FROM PARTITION 0

        MOV     BYTE PTR DS:[RESET_FLAG],0FFH    ;NO RESET COMING ON INIT
        MOV     BYTE PTR DS:[RESET_PRT_FLAG],0FFH    ;NO RESET COMING ON INIT
        mov     byte ptr ds:[V_FDD_ID],0ffh

        call    Build_Config
;       call    scsi_floppy_hdx
;       CALL    Build_Config
        call    Cinit
        call    Init_Print

        MOV     AX,RCB
        MOV     BP,AX
        MOV     CX,64
MAIN1:
        MOV     BYTE PTR DS:[BP].@STATUS,0       ;INIT RCB
        ADD     BP,32
        LOOP    MAIN1

        AND     BYTE PTR DS:[EPROM_MODE],0FH
        OR      BYTE PTR DS:[EPROM_MODE],10H     ;Set EPROM to RAM
        MOV     BYTE PTR DS:[SHIFT_RESET_FLAG],0
        MOV     WORD PTR DS:[READ_COUNT_L],0
        MOV     WORD PTR DS:[READ_COUNT_H],0
        MOV     WORD PTR DS:[READ_HIT_L],0
        MOV     WORD PTR DS:[READ_HIT_H],0

MAIN_PROCESS:
        MOV     BYTE PTR DS:[ACT_PART_NO],0FFH
        CALL    BREAK
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     CL,5
        SHL     AX,CL
        ADD     AX,RCB                          ;CALCULATE RCB
        MOV     BP,AX
        MOV     WORD PTR DS:[SAVE_BP],BP

        CMP     BYTE PTR DS:[BP].@STATUS,0      ;CHECK RCB STATUS
        JE      PROCESS_NEXT1                   ;BR, IF NO REQUEST

        MOV     BX,OFFSET JMP_TAB               ;GET JMP TABLE

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@REQCODE    ;GET REQUEST CODE
        CMP     AL,30H
        JAE     PROCESS_NEXT2                   ;ILLEGAL CODE
        SHL     AX,1
        ADD     BX,AX

        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     BYTE PTR DS:[ACT_PART_NO],AL

        JMP     WORD PTR CS:[BX]                ;JMP TO ROUTINE

PROCESS_NEXT2:
        MOV     BYTE PTR DS:[BP].@ERROR,94H     ;ERROR FOR ILLEGAL REQUEST CODE
PROCESS_NEXT:
        MOV     BYTE PTR DS:[BP].@STATUS,0      ;RESET RCB STATUS

PROCESS_NEXT1:
        INC     BYTE PTR DS:[PART_NO]           ;INCREMENT PARTITION NO
        MOV     AL,BYTE PTR DS:[MAX_PART_NO]
        CMP     BYTE PTR DS:[PART_NO],AL        ;CHECK MAX. PARTITION
        JNE     PROCESS_X
        MOV     BYTE PTR DS:[PART_NO],0         ;RESET PATITION NO IF MAX.
PROCESS_X:
        CALL    SERVICE_PRINT
        JMP     MAIN_PROCESS                    ;PROCESS NEXT


JMP_TAB DW      OFFSET NULL_COMMAND             ;0
        DW      OFFSET READ_SECTOR              ;1
        DW      OFFSET WRITE_SECTOR             ;2
        DW      OFFSET COMPARE_SECTOR           ;3
        DW      OFFSET COPY_SECTOR              ;4
        DW      OFFSET VERIFY_SECTOR            ;5
        DW      OFFSET NULL_COMMAND             ;6
        DW      OFFSET FORMAT_PLATTER           ;7
        DW      OFFSET NULL_COMMAND             ;8
        DW      OFFSET NULL_COMMAND             ;9
        DW      OFFSET NULL_COMMAND             ;0A
        DW      OFFSET NULL_COMMAND             ;0B
        DW      OFFSET NULL_COMMAND             ;0C
        DW      OFFSET SWITCH_ROM               ;0D
        DW      OFFSET RAM_INIT                 ;0E
        DW      OFFSET GIO_ENABLE               ;0F
        DW      OFFSET NULL_COMMAND             ;10
        DW      OFFSET MULTI_READ_SECTOR        ;11
        DW      OFFSET NULL_COMMAND             ;12
        DW      OFFSET NULL_COMMAND             ;13
        DW      OFFSET NULL_COMMAND             ;14
        DW      OFFSET SCSI_INQUERY             ;15
        DW      OFFSET SCSI_CONFIG              ;16
        DW      OFFSET SCSI_READ                ;17
        DW      OFFSET SCSI_WRITE               ;18
        DW      OFFSET SCSI_FORMAT              ;19
        DW      OFFSET SCSI_ENABLE              ;1A
        DW      OFFSET SCSI_DISABLE             ;1B
        DW      OFFSET SCSITAPE_REWIND          ;1C
        DW      OFFSET SCSITAPE_ERASE           ;1D
        DW      OFFSET SCSITAPE_RETENSION       ;1E
        DW      OFFSET SCSITAPE_READ            ;1F
        DW      OFFSET SCSITAPE_WRITE           ;20
        DW      OFFSET SCSITAPE_BACKUP          ;21
        DW      OFFSET SCSITAPE_LOCATE          ;22
        DW      OFFSET SCSITAPE_WRITEFILEMARK   ;23
        DW      OFFSET SCSITAPE_READFILEMARK    ;24
;       DW      OFFSET SCSI_FLOPPY_HD           ;25
;       DW      OFFSET SCSI_FLOPPY_DD           ;26
        DW      OFFSET NULL_COMMAND             ;25
        DW      OFFSET NULL_COMMAND             ;26
        DW      OFFSET SCSITAPE_RESTORE         ;27
        DW      OFFSET SCSITAPE_ENDDATA         ;28
        DW      OFFSET SCSI_ID                  ;29
        DW      OFFSET NULL_COMMAND             ;2A
        DW      OFFSET NULL_COMMAND             ;2B
        DW      OFFSET NULL_COMMAND             ;2C
        DW      OFFSET NULL_COMMAND             ;2D
        DW      OFFSET NULL_COMMAND             ;2E
        DW      OFFSET NULL_COMMAND             ;2F

; READ_SECTOR
;
READ_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT      ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AH,BYTE PTR DS:[BP].@ADDR2
        MOV     AL,BYTE PTR DS:[BP].@ADDR3
        MOV     WORD PTR DS:[ADDR_LOW],AX

        MOV     AX,WORD PTR DS:[BP].@PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX

        MOV     BX,BASE                         ;POINT TO BUFFER BASE OF PART_NO
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        SHL     AX,1
        SHL     AX,1
        ADD     BX,AX
        MOV     AX,WORD PTR DS:[BX]             ;GET SEGMENT OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_SEG],AX
        MOV     AX,WORD PTR DS:[BX+2]           ;GET OFFSET OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_PTR],AX

READ_SECTOR5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      READ_SECTOR3

READ_SECTOR6:
        CALL    DREAD_B
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      READ_SECTOR_END                        ;BR, IF COMPLEMENT
        ADD     WORD PTR DS:[ADDR_LOW],1               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     READ_SECTOR5
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     READ_SECTOR5                           ;BR, TO READ AGAIN

READ_SECTOR3:
        CMP     WORD PTR DS:[SECTOR_COUNT],1
        JE      READ_SECTOR6

        CALL    DREAD_W
        SUB     WORD PTR DS:[SECTOR_COUNT],2
        JZ      READ_SECTOR_END
        ADD     WORD PTR DS:[ADDR_LOW],2               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     READ_SECTOR31
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
READ_SECTOR31:
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     READ_SECTOR5
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     READ_SECTOR5

READ_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT


; MULTI_READ_SECTOR
;
MULTI_READ_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT      ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AH,BYTE PTR DS:[BP].@ADDR2
        MOV     AL,BYTE PTR DS:[BP].@ADDR3
        MOV     WORD PTR DS:[ADDR_LOW],AX

        MOV     AX,WORD PTR DS:[BP].@PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
;       CALL    GET_BUFFER_PTR

        MOV     BX,BASE                         ;POINT TO BUFFER BASE OF PART_NO
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        SHL     AX,1
        SHL     AX,1
        ADD     BX,AX
        MOV     AX,WORD PTR DS:[BX]             ;GET SEGMENT OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_SEG],AX
        MOV     AX,WORD PTR DS:[BX+2]           ;GET OFFSET OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_PTR],AX

        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     MULTI_READ_SECTOR1
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
MULTI_READ_SECTOR1:
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     MULTI_READ_AGAIN
        ADD     WORD PTR DS:[BUFFER_SEG],1000H

MULTI_READ_AGAIN:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      MULTI_READ_SECTOR3

MULTI_READ_SECTOR6:
        CALL    DREAD_B                                ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JNZ     MULTI_READ_SECTOR9
        JMP     MULTI_READ_SECTOR_END                  ;BR, IF COMPLEMENT
MULTI_READ_SECTOR9:
        MOV     BX,WORD PTR DS:[BUFFER_PTR]
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     ES,AX
        CMP     BYTE PTR ES:[BX],20H                   ;PROGRAM TRAILOR RECORD
        MOV     AX,3000H
        MOV     ES,AX
        JNE     MULTI_READ_SECTORC
        JMP     MULTI_READ_SECTOR_END1

MULTI_READ_SECTORC:
        ADD     WORD PTR DS:[ADDR_LOW],1               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JZ      MULTI_READ_SECTORA
        JMP     MULTI_READ_AGAIN
MULTI_READ_SECTORA:
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     MULTI_READ_AGAIN                       ;BR, TO READ AGAIN

MULTI_READ_SECTOR3:
        CMP     WORD PTR DS:[SECTOR_COUNT],1
        JE      MULTI_READ_SECTOR6

        CALL    DREAD_W
        SUB     WORD PTR DS:[SECTOR_COUNT],2
        JZ      MULTI_READ_SECTOR_END

        MOV     BX,WORD PTR DS:[BUFFER_PTR]
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     ES,AX
        CMP     BYTE PTR ES:[BX],20H                   ;PROGRAM TRAILOR RECORD
        MOV     AX,3000H
        MOV     ES,AX
        INC     WORD PTR DS:[SECTOR_COUNT]
        JE      MULTI_READ_SECTOR_END1

        ADD     WORD PTR DS:[ADDR_LOW],2               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     MULTI_READ_SECTOR31
        ADD     WORD PTR DS:[BUFFER_SEG],1000H

MULTI_READ_SECTOR31:
        MOV     BX,WORD PTR DS:[BUFFER_PTR]
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     ES,AX
        CMP     BYTE PTR ES:[BX],20H                   ;PROGRAM TRAILOR RECORD
        MOV     AX,3000H
        MOV     ES,AX
        JE      MULTI_READ_SECTOR_END1

        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JZ      MULTI_READ_SECTORB
        JMP     MULTI_READ_AGAIN
MULTI_READ_SECTORB:
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     MULTI_READ_AGAIN

MULTI_READ_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

MULTI_READ_SECTOR_END1:
        MOV     AX,WORD PTR DS:[SECTOR_COUNT]
        SUB     WORD PTR DS:[BP].@SECTOR_COUNT,AX
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT


; WRITE_SECTOR
;
WRITE_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT      ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AH,BYTE PTR DS:[BP].@ADDR2
        MOV     AL,BYTE PTR DS:[BP].@ADDR3
        MOV     WORD PTR DS:[ADDR_LOW],AX

        MOV     AX,WORD PTR DS:[BP].@PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
;       CALL    GET_BUFFER_PTR

        MOV     BX,BASE                         ;POINT TO BUFFER BASE OF PART_NO
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        SHL     AX,1
        SHL     AX,1
        ADD     BX,AX
        MOV     AX,WORD PTR DS:[BX]             ;GET SEGMENT OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_SEG],AX
        MOV     AX,WORD PTR DS:[BX+2]           ;GET OFFSET OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_PTR],AX

        CMP     WORD PTR DS:[SECTOR_COUNT],1
        JNE     MULTI_WRITE_SECTOR

        CALL    DWRITE
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

DISK_ERR_MK:
        JMP     DISK_ERR_M

MULTI_WRITE_SECTOR:
        MOV     AX,WORD PTR DS:[SECTOR_COUNT]
        MOV     WORD PTR DS:[BLOCK_SECTOR],AX
        CALL    CHK_SECTOR
        MOV     SI,BUF_2M_BASE
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      MULTI_WRITE_SECTOR1

        INC     WORD PTR DS:[BLOCK_SECTOR]
        PUSH    SI
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,01H
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_MK
        POP     SI
        INC     SI

MULTI_WRITE_SECTOR1:
        PUSH    SI
        ADD     SI,WORD PTR DS:[SECTOR_COUNT]
        DEC     SI
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        ADD     AX,WORD PTR DS:[SECTOR_COUNT]
        ADC     DX,0
        SUB     AX,1
        SBB     DX,0
        MOV     WORD PTR DS:[ADDR_LOW],AX
        MOV     WORD PTR DS:[ADDR_HIGH],DX
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JNZ     MULTI_WRITE_SECTOR2

        INC     WORD PTR DS:[BLOCK_SECTOR]
        PUSH    SI
        CALL    CHK_SECTOR
        POP     SI
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,01H
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_MK

MULTI_WRITE_SECTOR2:
        POP     SI
        MOV     BX,SI
        MOV     CX,WORD PTR DS:[SECTOR_COUNT]
        MOV     AL,1
        MOV     DX,BANKPORT
        OUT     DX,AL

        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,CL
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,CH
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10001100B
        OUT     DX,AL

        PUSH    DS
        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     SI,WORD PTR DS:[BUFFER_PTR]
        MOV     DS,AX
        MOV     AX,CX
        MOV     CL,8
        SHL     AX,CL
        MOV     CX,AX
        MOV     DX,1000H
        REP     OUTSB
        POP     DS

        MOV     DX,1202H
        IN      AL,DX
        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1
        MOV     AH,BYTE PTR DS:[BP].@ADDR2
        MOV     AL,BYTE PTR DS:[BP].@ADDR3
        MOV     WORD PTR DS:[ADDR_HIGH],DX
        MOV     WORD PTR DS:[ADDR_LOW],AX
        CALL    CHK_SECTOR
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,1
        MOV     CX,WORD PTR DS:[BLOCK_SECTOR]
        SHR     CX,1
        MOV     SI,BUF_2M_BASE
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        CALL    DISK_WRITE
        CMP     AL,0
        JNE     DISK_ERR_MI

        CALL    GET_BUFFER_PTR
MULTI_WRITE_SECTOR5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      MULTI_WRITE_SECTOR3
MULTI_WRITE_SECTOR6:
        CALL    DWRITE_CACHE_B
        DEC     WORD PTR DS:[SECTOR_COUNT]
        JZ      MULTI_WRITE_SECTOR4
        ADD     WORD PTR DS:[ADDR_LOW],1               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     MULTI_WRITE_SECTOR5
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     MULTI_WRITE_SECTOR5

DISK_ERR_MI:
        JMP     DISK_ERR_M

MULTI_WRITE_SECTOR3:
        CMP     WORD PTR DS:[SECTOR_COUNT],1
        JE      MULTI_WRITE_SECTOR6
        CALL    DWRITE_CACHE_W
        SUB     WORD PTR DS:[SECTOR_COUNT],2
        JZ      MULTI_WRITE_SECTOR4
        ADD     WORD PTR DS:[ADDR_LOW],2               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     MULTI_WRITE_SECTOR31
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
MULTI_WRITE_SECTOR31:
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     MULTI_WRITE_SECTOR5
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     MULTI_WRITE_SECTOR5

MULTI_WRITE_SECTOR4:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; COPY_SECTOR
;
COPY_SECTOR:
        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_E_O
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_E_O
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_E_O
        XOR     CX,CX
        MOV     CL,BYTE PTR DS:[BP].@ADDR1_S_O
        MOV     BH,BYTE PTR DS:[BP].@ADDR2_S_O
        MOV     BL,BYTE PTR DS:[BP].@ADDR3_S_O
        MOV     WORD PTR DS:[ADDR_HIGH_EO],DX
        MOV     WORD PTR DS:[ADDR_LOW_EO],AX
        MOV     WORD PTR DS:[ADDR_HIGH_SO],CX
        MOV     WORD PTR DS:[ADDR_LOW_SO],BX
        SUB     AX,BX
        SBB     DX,CX

        XOR     CX,CX
        MOV     CL,BYTE PTR DS:[BP].@ADDR1_S_D
        MOV     BH,BYTE PTR DS:[BP].@ADDR2_S_D
        MOV     BL,BYTE PTR DS:[BP].@ADDR3_S_D
        MOV     WORD PTR DS:[ADDR_HIGH_SD],CX
        MOV     WORD PTR DS:[ADDR_LOW_SD],BX
        MOV     WORD PTR DS:[ADDR_HIGH_FF],CX
        MOV     WORD PTR DS:[ADDR_LOW_FF],BX

        ADD     BX,AX
        ADC     CX,DX

        MOV     WORD PTR DS:[ADDR_HIGH],CX
        MOV     WORD PTR DS:[ADDR_LOW],BX
        MOV     AX,WORD PTR DS:[BP].@PLATTER_D
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    CHK_SECTOR
        MOV     AL,BYTE PTR DS:[PLAT_NO]
        MOV     BYTE PTR DS:[PLAT_NO_FF],AL
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        MOV     BYTE PTR DS:[DEVICE_ID_D],AL
        MOV     AX,WORD PTR DS:[START_L]
        ADD     WORD PTR DS:[ADDR_LOW_SD],AX
        MOV     AX,WORD PTR DS:[START_H]
        ADC     WORD PTR DS:[ADDR_HIGH_SD],AX

        MOV     AX,WORD PTR DS:[ADDR_HIGH_EO]
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AX,WORD PTR DS:[ADDR_LOW_EO]
        MOV     WORD PTR DS:[ADDR_LOW],AX
        MOV     AX,WORD PTR DS:[BP].@PLATTER_O
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    CHK_SECTOR
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        MOV     BYTE PTR DS:[DEVICE_ID_O],AL

        MOV     AX,WORD PTR DS:[START_L]
        ADD     WORD PTR DS:[ADDR_LOW_SO],AX
        MOV     AX,WORD PTR DS:[START_H]
        ADC     WORD PTR DS:[ADDR_HIGH_SO],AX

        MOV     AX,WORD PTR DS:[START_L]
        ADD     WORD PTR DS:[ADDR_LOW_EO],AX
        MOV     AX,WORD PTR DS:[START_H]
        ADC     WORD PTR DS:[ADDR_HIGH_EO],AX
COPY_SECTOR3:
        MOV     DX,WORD PTR DS:[ADDR_HIGH_EO]
        MOV     AX,WORD PTR DS:[ADDR_LOW_EO]
        SUB     AX,WORD PTR DS:[ADDR_LOW_SO]
        SBB     DX,WORD PTR DS:[ADDR_HIGH_SO]
        CMP     DX,0
        JNE     COPY_SECTOR1
        CMP     AX,85
        JB      COPY_SECTOR2
COPY_SECTOR1:
        MOV     BL,BYTE PTR DS:[DEVICE_ID_O]
        MOV     BH,BYTE PTR DS:[DEVICE_ID_D]
        MOV     DX,WORD PTR DS:[ADDR_HIGH_SO]
        MOV     AX,WORD PTR DS:[ADDR_LOW_SO]
        MOV     DI,WORD PTR DS:[ADDR_HIGH_SD]
        MOV     SI,WORD PTR DS:[ADDR_LOW_SD]
        MOV     CX,85
        CALL    CACHE_FLASH
        CALL    DISK_COPY
        CMP     AL,0
        JNE     DISK_ERR_MJ
        ADD     WORD PTR DS:[ADDR_LOW_SO],85
        ADC     WORD PTR DS:[ADDR_HIGH_SO],0
        ADD     WORD PTR DS:[ADDR_LOW_SD],85
        ADC     WORD PTR DS:[ADDR_HIGH_SD],0
        JMP     COPY_SECTOR3
COPY_SECTOR2:
        MOV     CX,AX
        INC     CX
        MOV     BL,BYTE PTR DS:[DEVICE_ID_O]
        MOV     BH,BYTE PTR DS:[DEVICE_ID_D]
        MOV     DX,WORD PTR DS:[ADDR_HIGH_SO]
        MOV     AX,WORD PTR DS:[ADDR_LOW_SO]
        MOV     DI,WORD PTR DS:[ADDR_HIGH_SD]
        MOV     SI,WORD PTR DS:[ADDR_LOW_SD]
        CALL    CACHE_FLASH
        CALL    DISK_COPY
        CMP     AL,0
        JNE     DISK_ERR_MJ

        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

DISK_ERR_MJ:
        JMP     DISK_ERR_M

; VERIFY_SECTOR
;
VERIFY_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@PLATTER_V       ;GET ACTIVE PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_S
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_S
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_S
        MOV     WORD PTR DS:[ADDR_LOW],AX
        CALL    DVERIFY
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER_V,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; COMPARE_SECTOR
;
COMPARE_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT      ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AH,BYTE PTR DS:[BP].@ADDR2
        MOV     AL,BYTE PTR DS:[BP].@ADDR3
        MOV     WORD PTR DS:[ADDR_LOW],AX

        MOV     AX,WORD PTR DS:[BP].@PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    GET_BUFFER_PTR

COMPARE_AGAIN:
        CALL    DCOMPARE                               ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      COMPARE_SECTOR_END                     ;BR, IF COMPLEMENT
        ADD     WORD PTR DS:[ADDR_LOW],1               ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     COMPARE_AGAIN
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
        JMP     COMPARE_AGAIN                          ;BR, TO READ AGAIN

COMPARE_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT


; FORMAT_PLATTER
;
FORMAT_PLATTER:
        MOV     AX,WORD PTR DS:[BP].@PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX         ;SET PLATTER ADDRESS
        CALL    DFORMAT                         ;SEND FORMAT COMMAND
        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CINVALPLAT
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; SCSI ID
;
SCSI_ID:
        MOV     DX,1C00H                       ;read switch(my bus ID)
        IN      AL,DX                          ;
        xor     al,0ffh
        mov     ah,0
        test    al,01h
        jz      z1
        or      ah,80h
z1:     test    al,02h
        jz      z2
        or      ah,40h
z2:     test    al,04h
        jz      z3
        or      ah,20h
z3:     test    al,08h
        jz      z4
        or      ah,10h
z4:     test    al,10h
        jz      z5
        or      ah,08h
z5:     test    al,20h
        jz      z6
        or      ah,04h
z6:     test    al,40h
        jz      z7
        or      ah,02h
z7:     test    al,80h
        jz      z8
        or      ah,01h
z8:
        mov     cl,ah

        MOV     BX,BASE                         ;POINT TO BUFFER BASE OF PART_NO
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        SHL     AX,1
        SHL     AX,1
        ADD     BX,AX
        MOV     AX,WORD PTR DS:[BX]             ;GET SEGMENT OF BUFFER PTR
        MOV     BX,WORD PTR DS:[BX+2]           ;GET OFFSET OF BUFFER PTR
        PUSH    DX
        MOV     DX,WORD PTR DS:[RAM_REVISION]
        PUSH    DS
        MOV     DS,AX
        MOV     BYTE PTR DS:[BX],CL
        MOV     WORD PTR DS:[BX+1],DX
        POP     DS
        POP     DX

        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; SCSI_INQUERY
;
SCSI_INQUERY:
        CALL    BUILD_CONFIG
        CALL    CINIT
        MOV     WORD PTR DS:[READ_COUNT_L],0
        MOV     WORD PTR DS:[READ_COUNT_H],0
        MOV     WORD PTR DS:[READ_HIT_L],0
        MOV     WORD PTR DS:[READ_HIT_H],0
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; SCSI_FORMAT
;
SCSI_FORMAT:
        MOV     BL,BYTE PTR DS:[BP].@SCSI_ID
        MOV     BYTE PTR DS:[DEVICE_ID],BL
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      SCSI_FORMAT1
        CMP     AL,06H
        JNE     DISK_ERR_MA
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        CALL    CINVALPLAT_S
        JMP     SCSI_FORMAT

SCSI_FORMAT1:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    DISK_FORMAT
        CMP     AL,0
        JNE     DISK_ERR_MA
        MOV     AL,BYTE PTR DS:[BP].@SCSI_ID
        CALL    CINVALPLAT_S
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

DISK_ERR_MA:
        JMP     DISK_ERR_M

; SCSI_READ
;
SCSI_READ:
        MOV     BL,BYTE PTR DS:[BP].@SCSI_ID
        MOV     BYTE PTR DS:[DEVICE_ID],BL
        XOR     BH,BH
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:SYSTEM_CONFIG1[BX].D_STATUS,0FFH
        JZ      ERROR_94H
        TEST    BYTE PTR DS:SYSTEM_CONFIG1[BX].D_STATUS,80H
        JNZ     ERROR_94H
SCSI_READ3:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      SCSI_READ1
        CMP     AL,06H
        JNE     DISK_ERR_MB
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        CALL    CINVALPLAT_S
        JMP     SCSI_READ3

SCSI_READ1:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,3
        XOR     DX,DX
        XOR     AX,AX
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_MB
        CALL    GET_BUFFER_PTR
        MOV     SI,BUFFER
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        MOV     ES,AX
        MOV     CX,100H
        REP     MOVSW
        MOV     AX,3000H
        MOV     ES,AX
SCSI_READ2:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

ERROR_94H:
        JMP     ERROR_94

DISK_ERR_MB:
        JMP     DISK_ERR_M

; SCSI_WRITE
;
SCSI_WRITE:
        MOV     BL,BYTE PTR DS:[BP].@SCSI_ID
        MOV     BYTE PTR DS:[DEVICE_ID],BL
        XOR     BH,BH
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:SYSTEM_CONFIG1[BX].D_STATUS,0FFH
        JZ      ERROR_94H
        TEST    BYTE PTR DS:SYSTEM_CONFIG1[BX].D_STATUS,80H
        JNZ     ERROR_94H

SCSI_WRITE3:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      SCSI_WRITE1
        CMP     AL,06H
        JNE     DISK_ERR_MC
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        CALL    CINVALPLAT_S
        JMP     SCSI_WRITE3

SCSI_WRITE1:
        CALL    GET_BUFFER_PTR
        PUSH    DS
        PUSH    DS
        POP     ES
        MOV     DI,BUFFER
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     SI,WORD PTR DS:[BUFFER_PTR]
        MOV     DS,AX
        MOV     CX,100H
        REP     MOVSW
        POP     DS

        MOV     AX,3000H
        MOV     ES,AX

        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,3
        XOR     DX,DX
        XOR     AX,AX
        MOV     CX,1
        CALL    DISK_WRITE
        CMP     AL,0
        JNE     DISK_ERR_MC
SCSI_WRITE2:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

DISK_ERR_MC:
        JMP     DISK_ERR_M


; SCSI_CONFIG
;
SCSI_CONFIG1X:
        JMP     SCSI_CONFIG1

SCSI_CONFIG:
        MOV     CX,8
SCSI_CONFIG6:
        PUSH    CX
        MOV     BX,CX
        DEC     BX
        MOV     BYTE PTR DS:[DEVICE_ID],BL
        MOV     SI,BX
        SHL     SI,1
        SHL     SI,1
        SHL     SI,1
        SHL     SI,1
        CMP     BYTE PTR DS:SYSTEM_CONFIG1[SI].D_STATUS,0FFH
        JE      SCSI_CONFIG1X
        TEST    BYTE PTR DS:SYSTEM_CONFIG1[SI].D_STATUS,80H
        JZ      SCSI_CONFIG2
SCSI_CONFIG5:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        PUSH    SI
        CALL    TEST_UNIT_READY
        POP     SI
        CMP     AL,0
        JE      SCSI_CONFIG2
        CMP     AL,06H
        JNE     SCSI_CONFIG4
        MOV     AL,BYTE PTR DS:[DEVICE_ID]  ;@
        PUSH    SI                          ;@
        CALL    CINVALPLAT                  ;@
        POP     SI                          ;@
        JMP     SCSI_CONFIG5
SCSI_CONFIG4:
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_L,0FFFFH
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_H,0FFFFH
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_LEN_L,0FFFFH
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_LEN_H,0FFFFH
        JMP     SCSI_CONFIG1
SCSI_CONFIG2:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        PUSH    SI
        CALL    CAPACITY
        POP     SI
        CMP     AL,0
        JNE     SCSI_CONFIG2X         ;NOT READY
        MOV     DI,BUFFER
        MOV     AX,WORD PTR DS:[DI]
        XCHG    AH,AL
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_H,AX
        MOV     AX,WORD PTR DS:[DI+2]
        XCHG    AH,AL
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_L,AX

;        CMP     WORD PTR DS:[DI+4],0
;        JNE     KKK1
;        CMP     WORD PTR DS:[DI+6],0100H
;        JE      KKK2
;KKK1:
;
;        ADD     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_L,1
;        ADC     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_H,0
;
;        clc
;        rcl     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_L,1
;        rcl     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_H,1
;
;KKK2:
        MOV     AX,WORD PTR DS:[DI+4]
        XCHG    AH,AL
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_LEN_H,AX
        MOV     AX,WORD PTR DS:[DI+6]
        XCHG    AH,AL
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_LEN_L,AX
        JMP     SCSI_CONFIG1

SCSI_CONFIG2X:
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_H,0FFFFH
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_NO_L,0FFFFH

        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_LEN_H,0FFFFH
        MOV     WORD PTR DS:SYSTEM_CONFIG1[SI].D_BLOCK_LEN_L,0FFFFH

SCSI_CONFIG1:
        POP     CX
        LOOP    SCSI_CONFIG61
        CALL    GET_BUFFER_PTR

        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        MOV     CX,8

        MOV     BX,SYSTEM_CONFIG1
        MOV     DX,VENDOR_INFO

SCSI_CONFIG_Q:
        PUSH    CX

        MOV     CX,16
        MOV     SI,BX
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     ES,AX
        REP     MOVSB
        ADD     BX,16

        MOV     CX,32
        MOV     SI,DX
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     ES,AX
        REP     MOVSB
        ADD     DX,64

        POP     CX
        LOOP    SCSI_CONFIG_Q


        MOV     AX,32
        MOV     SI,SYSTEM_CONFIG2
SCSI_CONFIG3:
        MOV     CX,10
        PUSH    SI
        REP     MOVSB
        POP     SI
        ADD     SI,16
        DEC     AX
        JNZ     SCSI_CONFIG3
        MOV     AX,3000H
        MOV     ES,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSI_CONFIG61:
        JMP     SCSI_CONFIG6

; SCSI_ENABLE
;
SCSI_ENABLE:
        MOV     BYTE PTR ES:[CACHE_ON],1
        CALL    CINIT
        MOV     WORD PTR DS:[READ_COUNT_L],0
        MOV     WORD PTR DS:[READ_COUNT_H],0
        MOV     WORD PTR DS:[READ_HIT_L],0
        MOV     WORD PTR DS:[READ_HIT_H],0
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; SCSI_DISABLE
;
SCSI_DISABLE:
        MOV     BYTE PTR ES:[CACHE_ON],0
        MOV     WORD PTR DS:[READ_COUNT_L],0
        MOV     WORD PTR DS:[READ_COUNT_H],0
        MOV     WORD PTR DS:[READ_HIT_L],0
        MOV     WORD PTR DS:[READ_HIT_H],0
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

ERROR_91G:
        JMP     ERROR_91

; SCSI_FLOPPY_HD
;
;SCSI_FLOPPY_HD:
;        CALL    SCSI_FLOPPY_HDX
;        JMP     SCSI_INQUERY
;
;SCSI_FLOPPY_HDX:
;        XOR     BX,BX
;        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
;        JE      SCSI_FLOPPY_HD5
;
;SCSI_FLOPPY_HD2:
;        XOR     BX,BX
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        CALL    TEST_UNIT_READY
;        CMP     AL,00H
;        JE      SCSI_FLOPPY_HD1
;        CMP     AL,06H
;        JNE     SCSI_FLOPPY_HD1
;        MOV     AL,0
;        CALL    CINVALPLAT
;        JMP     SCSI_FLOPPY_HD2
;SCSI_FLOPPY_HD1:
;        XOR     BX,BX
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        MOV     BH,01H
;        CALL    SET_FLOPPY
;
;        MOV     BX,256
;        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
;        JE      SCSI_FLOPPY_HD5
;
;SCSI_FLOPPY_HD4:
;        MOV     BX,256
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        CALL    TEST_UNIT_READY
;        CMP     AL,00H
;        JE      SCSI_FLOPPY_HD3
;        CMP     AL,06H
;        JNE     SCSI_FLOPPY_HD3
;        MOV     AL,10H
;        CALL    CINVALPLAT
;        JMP     SCSI_FLOPPY_HD4
;SCSI_FLOPPY_HD3:
;        MOV     BX,256
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        MOV     BH,01H
;        CALL    SET_FLOPPY
;SCSI_FLOPPY_HD5:
;        RET
;

DISK_ERR_M8Y:
        JMP     DISK_ERR_M

ERROR_91F:
        JMP     ERROR_91

; SCSI_FLOPPY_DD
;
;SCSI_FLOPPY_DD:
;        CALL    SCSI_FLOPPY_DDX
;        JMP     SCSI_INQUERY
;
;SCSI_FLOPPY_DDX:
;        XOR     BX,BX
;        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
;        JE      SCSI_FLOPPY_DD5
;
;SCSI_FLOPPY_DD2:
;        XOR     BX,BX
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        CALL    TEST_UNIT_READY
;        CMP     AL,00H
;        JE      SCSI_FLOPPY_DD1
;        CMP     AL,06H
;        JNE     SCSI_FLOPPY_DD1
;        MOV     AL,0
;        CALL    CINVALPLAT
;        JMP     SCSI_FLOPPY_DD2
;SCSI_FLOPPY_DD1:
;        XOR     BX,BX
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        MOV     BH,00H
;        CALL    SET_FLOPPY
;
;        MOV     BX,256
;        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
;        JE      SCSI_FLOPPY_DD5
;
;SCSI_FLOPPY_DD4:
;        MOV     BX,256
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        CALL    TEST_UNIT_READY
;        CMP     AL,00H
;        JE      SCSI_FLOPPY_DD3
;        CMP     AL,06H
;        JNE     SCSI_FLOPPY_DD3
;        MOV     AL,10H
;        CALL    CINVALPLAT
;        JMP     SCSI_FLOPPY_DD4
;SCSI_FLOPPY_DD3:
;        MOV     BX,256
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        MOV     BH,00H
;        CALL    SET_FLOPPY
;SCSI_FLOPPY_DD5:
;        RET
;

DISK_ERR_M8Z:
        JMP     DISK_ERR_M


; SWITCH_ROM
;
SWITCH_ROM:
        MOV     BYTE PTR DS:[BP].@STATUS,00H
        MOV     BYTE PTR DS:[BP].@ERROR,00H
        CALL    CINIT
        MOV     BX,ROM_ENTRY
        JMP     DWORD PTR DS:[BX]                      ;SWITCH TO ROM


; RAM_INIT
;
RAM_INIT:
        MOV     AL,BYTE PTR DS:[BP].@CPUID_I
        MOV     BYTE PTR DS:[CPU_ID],AL
        MOV     AX,WORD PTR DS:[BUFFER_SIZE]
        MOV     BX,WORD PTR DS:[BP].@PARTNO_I
        XOR     DX,DX
        DIV     BX
        CMP     AX,88
        JB      RAM_INIT6
        MOV     AX,88
RAM_INIT6:
        MOV     WORD PTR DS:[BUFFER_SIZE],AX
        MOV     CL,8
        SHL     AX,CL
        MOV     BYTE PTR DS:[MAX_PART_NO],BL
        MOV     CX,BX
        MOV     BX,BASE
RAM_INIT4:
        DEC     CX
        JZ      RAM_INIT1
        MOV     DX,WORD PTR DS:[BX+2]
        ADD     DX,AX
        JNC     RAM_INIT2
        MOV     WORD PTR DS:[BX+6],DX
        MOV     DX,WORD PTR DS:[BX]
        ADD     DX,1000H
        MOV     WORD PTR DS:[BX+4],DX
        ADD     BX,4
        JMP     RAM_INIT3
RAM_INIT2:
        MOV     WORD PTR DS:[BX+6],DX
        MOV     DX,WORD PTR DS:[BX]
        MOV     WORD PTR DS:[BX+4],DX
        ADD     BX,4
RAM_INIT3:
        JMP     RAM_INIT4
RAM_INIT1:
        PUSH    ES
        PUSH    DS
        POP     ES
        MOV     CX,64
        MOV     SI,BASE
        MOV     DI,DATA_BASE
RAM_INIT5:
        LODSW
        MOV     BL,AH
        LODSW
        STOSW
        SHR     BL,1
        SHR     BL,1
        SHR     BL,1
        SHR     BL,1
        XOR     BH,BH
        MOV     AX,BX
        STOSW
        LOOP    RAM_INIT5
        POP     ES
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

; Wait_Strobe_OBS: Wait Strobe from 2200 and is OBS
;
Wait_Strobe_OBS:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
Wait_Strobe_OBS1:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      Wait_Strobe_OBS2
        JMP     GIO_DISABLE1                    ;GIO DISABLE
Wait_Strobe_OBS2:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0FH
        JNZ     Wait_Strobe_OBS3
        call    service_print
        JMP     Wait_Strobe_OBS1
Wait_Strobe_OBS3:
        MOV     BYTE PTR DS:[BP].@RB_G,1
        TEST    BYTE PTR DS:[BP].@STROBE_G,IBS_STROBE
        JNZ     Command_Idle_x
        TEST    BYTE PTR DS:[BP].@STROBE_G,OBS_STROBE
        JNZ     Wait_Strobe_OBS4
        TEST    BYTE PTR DS:[BP].@STROBE_G,CBS_STROBE
        JNZ     Wait_Strobe_OBS
        test    byte ptr ds:[bp].@data_g,80h
        jz      Wait_Strobe_OBS
        test    byte ptr ds:[bp].@data_g,20h
        jz      Wait_Strobe_OBS
        pop     ax
        jmp     Reinit

Command_Idle_x:
        jmp     Command_Idle

Wait_Strobe_OBS4:
        mov     al,byte ptr ds:[bp].@data_g
        ret

; Wait_Strobe: Wait Strobe from 2200
;
Wait_Strobe_IBS:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
Wait_Strobe_IBS1:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      Wait_Strobe_IBS2
        JMP     GIO_DISABLE1                    ;GIO DISABLE
Wait_Strobe_IBS2:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0FH
        JNZ     Wait_Strobe_IBS3
        call    service_print
        JMP     Wait_Strobe_IBS1
Wait_Strobe_IBS3:
        MOV     BYTE PTR DS:[BP].@RB_G,1

        TEST    BYTE PTR DS:[BP].@STROBE_G,IBS_STROBE
        JNZ     Wait_Strobe_IBS4
        TEST    BYTE PTR DS:[BP].@STROBE_G,OBS_STROBE
        JNZ     Command_Idle_x
        TEST    BYTE PTR DS:[BP].@STROBE_G,CBS_STROBE
        JNZ     Wait_Strobe_IBS
        test    byte ptr ds:[bp].@data_g,80h
        jz      Wait_Strobe_IBS
        test    byte ptr ds:[bp].@data_g,20h
        jz      Wait_Strobe_IBS
        pop     ax
        jmp     Reinit

Wait_Strobe_IBS4:
        ret

; Send_Strobe: Send AL data out by IBS
;
Send_Strobe:
        MOV     BYTE PTR DS:[BP].@DATA_G,AL
Send_Strobe1:
        CMP     BYTE PTR DS:[BP].@CPB_G,0
        JE      Send_Strobe2
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE1q
        call    service_print
        JMP     Send_Strobe1
Send_Strobe2:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        ret

Gio_Disable1q:
        jmp     Gio_Disable1


Reinit:
        MOV     SP,STACK_PTR
        call    Wait_Strobe_OBS
        call    Wait_Strobe_IBS
        mov     al,0d0h
        call    Send_Strobe

Request:
        call    Wait_Strobe_OBS
        mov     bl,al
        and     bl,1fh
        cmp     bl,10h
        jne     Request1
        mov     bl,0
        jmp     Request2
Request1:
        inc     bl
Request2:
;       add     byte ptr ds:[Plat_No],bl
;       mov     bl,al
;       and     bl,0e0h
;       cmp     bl,20h
;       je      Command_Extended_x
;       cmp     bl,40h
;       je      Command_Write_x
;       cmp     bl,80h
;       je      Command_Compare_x
;       cmp     bl,0
;       je      Command_Read

        call    Wait_Strobe_IBS
        xor     al,0ffh
        call    Send_Strobe
        jmp     Reinit

Command_Compare_x:
        jmp     Command_Compare
Command_Write_x:
        jmp     Command_Write
Command_Extended_x:
        jmp     Command_Extended

Command_Read:
        call    Wait_Strobe_IBS
        call    Send_Strobe

        call    Wait_Strobe_OBS
        xor     dx,dx
        mov     dl,al
        mov     word ptr ds:[Addr_High],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        mov     dh,al
        mov     word ptr ds:[Addr_Low],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        mov     dx,word ptr ds:[Addr_Low]
        mov     dl,al
        mov     word ptr ds:[Addr_Low],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    chk_plat_sector      ;err code 00,01,02
        cmp     al,0
        je      Command_Read1
        jmp     Command_Error

Command_Read1:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS

        call    gio_read_sector           ;err code 00,01,02,04
        cmp     al,0
        je      Command_Read2
        jmp     Command_Error

Command_Read2:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        mov     si,buffer
        mov     cx,256
        mov     ah,0
Command_Read3:
        lodsb
        add     ah,al
        call    Wait_Strobe_IBS
        call    Send_Strobe
        loop    Command_Read3
        mov     al,ah
        call    Wait_Strobe_IBS
        call    Send_STrobe
        jmp     Reinit

Command_Write:
        call    Wait_Strobe_IBS
        call    Send_Strobe

        call    Wait_Strobe_OBS
        xor     dx,dx
        mov     dl,al
        mov     word ptr ds:[Addr_High],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        mov     dh,al
        mov     word ptr ds:[Addr_Low],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        mov     dx,word ptr ds:[Addr_Low]
        mov     dl,al
        mov     word ptr ds:[Addr_Low],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    chk_plat_sector      ;err code 00,01,02
        cmp     al,0
        je      Command_Write1
        jmp     Command_Error

Command_Write1:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        mov     cx,256
        mov     si,buffer
        mov     ah,0
Command_Write2:
        call    Wait_Strobe_OBS
        mov     byte ptr ds:[si],al
        inc     si
        add     ah,al
        loop    Command_Write2
        call    Wait_Strobe_OBS
        cmp     ah,al
        je      Command_Write3
        mov     al,04
        jmp     Command_Error

Command_Write3:
        call    gio_write_sector           ;err code 00,01,02,04
        cmp     al,0
        je      Command_Write4
        jmp     Command_Error

Command_Write4:
        call    Wait_Strobe_IBS
        call    Send_STrobe
        jmp     Reinit


Command_Compare:
        call    Wait_Strobe_IBS
        call    Send_Strobe

        call    Wait_Strobe_OBS
        xor     dx,dx
        mov     dl,al
        mov     word ptr ds:[Addr_High],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        mov     dh,al
        mov     word ptr ds:[Addr_Low],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        mov     dx,word ptr ds:[Addr_Low]
        mov     dl,al
        mov     word ptr ds:[Addr_Low],dx
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    chk_plat_sector      ;err code 00,01,02
        cmp     al,0
        je      Command_Compare1
        jmp     Command_Error

Command_Compare1:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS

        call    gio_read_sector           ;err code 00,01,02,04
        cmp     al,0
        je      Command_Compare2x
        jmp     Command_Error

Command_Compare2x:
        call    Wait_Strobe_IBS
        call    Send_Strobe

        mov     cx,256
        mov     ah,0
        mov     si,buffer+256

Command_Compare2:
        call    Wait_Strobe_OBS
        mov     byte ptr ds:[si],al
        inc     si
        add     ah,al
        loop    Command_Compare2
        call    Wait_Strobe_OBS
        cmp     ah,al
        je      Command_Compare3
        mov     al,04
        jmp     Command_Error

Command_Compare3:
        call    gio_compare_sector          ;err code 00,08
        cmp     al,0
        je      Command_Compare4
        jmp     Command_Error

Command_Compare4:
        call    Wait_Strobe_IBS
        call    Send_STrobe
        jmp     Reinit

Command_Error:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        jmp     Reinit

Command_Idle:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
Command_Idle1:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      Command_Idle1
        JMP     GIO_DISABLE1                    ;GIO DISABLE


; Routine for  GIO
;
Chk_Plat_Sector:
        XOR     BX,BX
        MOV     BL,BYTE PTR DS:[PLAT_NO]
        CMP     BL,1FH
        JA      CHK_PLAT_SECTOR1

        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
        JE      CHK_PLAT_SECTOR1

        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        CMP     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        JA      CHK_PLAT_SECTOR2
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        JB      CHK_PLAT_SECTOR3
        CMP     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        JAE     CHK_PLAT_SECTOR2

CHK_PLAT_SECTOR3:
        ADD     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        ADC     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     WORD PTR DS:[BLOCK_HIGH],DX
        MOV     WORD PTR DS:[BLOCK_LOW],AX
        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      CHK_PLAT_SECTOR4

CHK_PLAT_SECTOR5:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      CHK_PLAT_SECTOR4
        CMP     AL,06H
        JNE     CHK_PLAT_SECTOR1

        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CINVALPLAT
        JMP     CHK_PLAT_SECTOR5

CHK_PLAT_SECTOR4:
        MOV     AL,00H
        RET
CHK_PLAT_SECTOR1:
        MOV     AL,02H
        RET
CHK_PLAT_SECTOR2:
        MOV     AL,01H
        RET

Gio_Read_Sector:
        ADD     WORD PTR DS:[READ_COUNT_L],1
        ADC     WORD PTR DS:[READ_COUNT_H],0
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      Gio_Read1

        ADD     WORD PTR DS:[READ_HIT_L],1
        ADC     WORD PTR DS:[READ_HIT_H],0
        CALL    CHITUPDATE
Gio_Read5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      Gio_Read2
        INC     BX
Gio_Read2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      Gio_Read3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
Gio_Read3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10000100B
        OUT     DX,AL

        MOV     AX,DS
        MOV     ES,AX
        MOV     DI,BUFFER

        MOV     CX,100H
        MOV     DX,1000H
        REP     INSB

        MOV     DX,1202H
        IN      AL,DX

        MOV     AX,3000H
        MOV     ES,AX
        MOV     AL,00H
        RET


Gio_READ1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      Gio_READ4
        SUB     SI,4096
        MOV     BH,1
Gio_READ4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        POP     BX
        CMP     AL,0
        JNE     Gio_READ6
        JMP     Gio_READ5

Gio_READ6:
        mov     al,02h
        ret

Gio_Write1_x:
        jmp     Gio_Write1

Gio_Write_Sector:
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      Gio_Write1_x
        CALL    CHITUPDATE
Gio_Write5:
        PUSH    BX
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      Gio_Write2
        INC     BX
Gio_Write2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      Gio_Write3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
Gio_Write3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10001100B
        OUT     DX,AL

        MOV     SI,BUFFER
        MOV     CX,100H
        MOV     DX,1000H
        REP     OUTSB

        MOV     DX,1202H
        IN      AL,DX

        POP     SI
        MOV     BH,0
        CMP     SI,4096
        JB      Gio_Write6
        SUB     SI,4096
        MOV     BH,1
Gio_Write6:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_WRITE
        CMP     AL,0
        JNE     Gio_Write7
        RET

Gio_Write7:
        mov     al,02h
        ret

Gio_Write1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      Gio_Write4
        SUB     SI,4096
        MOV     BH,1
Gio_Write4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        POP     BX
        CMP     AL,0
        JNE     Gio_Write7
        JMP     Gio_Write5


Gio_Compare_Sector:
        mov     si,buffer
        mov     di,buffer+256
        mov     cx,256
        push    ds
        pop     es
        rep     cmpsb
        mov     ax,3000h
        mov     es,ax
        mov     al,0
        cmp     cx,0
        je      Gio_Compare_Sector1
        mov     al,08h
Gio_Compare_Sector1:
        ret

Command_Extended:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        cmp     al,4fh
        jbe     Command_extended1
        jmp     illegal
Command_Extended1:
        xor     bx,bx
        mov     bl,al
        shl     bx,1
        mov     cx,offset extjump
        add     bx,cx
        jmp     word ptr cs:[bx]

extjump:
        dw      offset  illegal                 ;00
        dw      offset  command_copy            ;01
        dw      offset  command_format          ;02
        dw      offset  illegal                 ;03
        dw      offset  illegal                 ;04
        dw      offset  illegal                 ;05
        dw      offset  illegal                 ;06
        dw      offset  illegal                 ;07
        dw      offset  illegal                 ;08
        dw      offset  illegal                 ;09
        dw      offset  illegal                 ;0a
        dw      offset  illegal                 ;0b
        dw      offset  illegal                 ;0c
        dw      offset  illegal                 ;0d
        dw      offset  illegal                 ;0e
        dw      offset  illegal                 ;0f
        dw      offset  command_startMSW        ;10
        dw      offset  command_endMSW          ;11
        dw      offset  command_verify          ;12
        dw      offset  illegal                 ;13
        dw      offset  illegal                 ;14
        dw      offset  illegal                 ;15
        dw      offset  Command_Sendstat        ;16
        dw      offset  illegal                 ;17
        dw      offset  illegal                 ;18
        dw      offset  illegal                 ;19
        dw      offset  illegal                 ;1a
        dw      offset  illegal                 ;1b
        dw      offset  illegal                 ;1c
        dw      offset  illegal                 ;1d
        dw      offset  illegal                 ;1e
        dw      offset  illegal                 ;1f
        dw      offset  illegal                 ;20
        dw      offset  illegal                 ;21
        dw      offset  illegal                 ;22
        dw      offset  illegal                 ;23
        dw      offset  illegal                 ;24
        dw      offset  illegal                 ;25
        dw      offset  command_ghitrate        ;26
        dw      offset  illegal                 ;27
        dw      offset  illegal                 ;28
        dw      offset  illegal                 ;29
        dw      offset  illegal                 ;2a
        dw      offset  illegal                 ;2b
        dw      offset  illegal                 ;2c
        dw      offset  illegal                 ;2d
        dw      offset  illegal                 ;2e
        dw      offset  illegal                 ;2f
        dw      offset  illegal                 ;30
        dw      offset  illegal                 ;31
        dw      offset  illegal                 ;32
        dw      offset  illegal                 ;33
        dw      offset  illegal                 ;34
        dw      offset  illegal                 ;35
        dw      offset  illegal                 ;36
        dw      offset  illegal                 ;37
        dw      offset  illegal                 ;38
        dw      offset  illegal                 ;39
        dw      offset  illegal                 ;3a
        dw      offset  illegal                 ;3b
        dw      offset  illegal                 ;3c
        dw      offset  illegal                 ;3d
        dw      offset  illegal                 ;3e
        dw      offset  illegal                 ;3f
        dw      offset  illegal                 ;40
        dw      offset  illegal                 ;41
        dw      offset  illegal                 ;42
        dw      offset  illegal                 ;43
        dw      offset  illegal                 ;44
        dw      offset  illegal                 ;45
        dw      offset  illegal                 ;46
        dw      offset  illegal                 ;47
        dw      offset  illegal                 ;48
        dw      offset  illegal                 ;49
        dw      offset  illegal                 ;4a
        dw      offset  illegal                 ;4b
        dw      offset  illegal                 ;4c
        dw      offset  illegal                 ;4d
        dw      offset  illegal                 ;4e
        dw      offset  illegal                 ;4f

illegal:
        xor     al,0ffh
        call    Wait_Strobe_IBS
        call    Send_Strobe
        jmp     Reinit

Command_Format:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        call    Gio_Format
        call    Wait_Strobe_IBS
        call    Send_Strobe
        jmp     Reinit

Gio_Format:
        XOR     BX,BX
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
        JE      Gio_Format5

        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      Gio_Format1

Gio_Format2:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      Gio_Format3
        CMP     AL,06H
        JNE     Gio_Format5
        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CINVALPLAT
        JMP     Gio_Format2

Gio_Format5:
        MOV     AL,01h
        RET

Gio_Format3:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    CAPACITY
        CMP     AL,0
        JNE     Gio_Format5
        mov     al,byte ptr ds:[plat_no]
        call    CinvalPlat
        MOV     SI,BUFFER
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        MOV     AX,WORD PTR DS:[SI]
        XCHG    AH,AL
        MOV     DI,AX
        MOV     CX,WORD PTR DS:[SI+2]
        XCHG    CH,CL
        ADD     CX,1
        ADC     DI,0
        XOR     DX,DX
        XOR     AX,AX
        CALL    DISK_FILL
        CMP     AL,0
        JNE     Gio_Format6
        mov     al,0
        RET

Gio_Format1:
        mov     al,byte ptr ds:[plat_no]
        call    CinvalPlat

        MOV     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        MOV     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     CX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        MOV     DI,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        CLC
        RCR     DI,1
        RCR     CX,1
        MOV     BH,0
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    DISK_FILL
        CMP     AL,0
        JNE     Gio_Format6
        mov     al,0
        RET

Gio_Format6:
        mov     al,02h
        ret


Command_startMSW:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        jmp     Reinit

Command_endMSW:
        call    Wait_Strobe_IBS
        call    Send_Strobe
        call    Wait_Strobe_OBS
        call    Wait_Strobe_IBS
        mov     al,0
        call    Send_Strobe
        jmp     Reinit

Command_Copy:
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    Wait_Strobe_OBS
;       xor     dx,dx
;       mov     dl,al
;       mov     word ptr ds:[Addr_High_SO],dx
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    Wait_Strobe_OBS
;       mov     dh,al
;       mov     word ptr ds:[Addr_Low_SO],dx
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    Wait_Strobe_OBS
;       mov     dx,word ptr ds:[Addr_Low_SO]
;       mov     dl,al
;       mov     word ptr ds:[Addr_Low_SO],dx
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    chk_plat_sector
;       cmp     al,0
;       jne     command_copy1
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    Wait_Strobe_OBS
;       xor     dx,dx
;       mov     dl,al
;       mov     word ptr ds:[Addr_High_EO],dx
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    Wait_Strobe_OBS
;       mov     dh,al
;       mov     word ptr ds:[Addr_Low_EO],dx
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;
;       call    Wait_Strobe_OBS
;       mov     dx,word ptr ds:[Addr_Low_EO]
;       mov     dl,al
;       mov     word ptr ds:[Addr_Low_EO],dx
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;       call    chk_plat_sector
;       cmp     al,0
;       jne     command_copy1


Command_SendStat:
;       call    Wait_Strobe_IBS
;       call    Send_Strobe
;       call    Wait_Strobe_OBS
;
;       call    Wait_Strobe_IBS
;       mov     al,08h
;       call    Send_Strobe
;       call    Wait_Strobe_IBS
;       mov     al,34h
;       call    Send_Strobe


Command_Verify:
Command_GhitRate:


; GIO_ENABLE:
;
GIO_ENABLE:
        MOV     BYTE PTR DS:[BP].@ERROR_F,0
        MOV     AL,BYTE PTR DS:[BP].@ABS_F
        CMP     AL,BYTE PTR DS:[PRINTER_ID]
        JNZ     GIO_DISK

        JMP     GIO_PRINT

GIO_DISK:
        MOV     BYTE PTR DS:[BP].@RB_G,1        ;SET R/B TO BUSY

        MOV     BYTE PTR DS:[PLAT_NO],00H
        TEST    BYTE PTR DS:[BP].@ABS_F,40H
        JZ      GIO_DISK1
        MOV     BYTE PTR DS:[PLAT_NO],10H
GIO_DISK1:
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@GIO_G,88h     ;SET GIO FLAG
        jmp     Reinit


GIO_PRINT:
        MOV     BYTE PTR DS:[BP].@RB_G,1        ;SET R/B TO BUSY

        mov     bx,word ptr ds:[prt_end]
        cmp     bx,prt_buffer_end
        jne     gio_print1
        mov     bx,word ptr ds:[prt_start]
        cmp     bx,prt_buffer_start
        jne     print_rdy
        jmp     gio_print2
gio_print1:
        inc     bx
        cmp     bx,word ptr ds:[prt_start]
        jne     print_rdy
gio_print2:
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@STROBE_G,0    ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@GIO_G,089H    ;SET GIO FLAG
GO_PRINTX:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE2_X

        mov     bx,word ptr ds:[prt_end]
        cmp     bx,prt_buffer_end
        jne     gio_print3
        mov     bx,word ptr ds:[prt_start]
        cmp     bx,prt_buffer_start
        jne     print_rdy
        jmp     gio_print4
gio_print3:
        inc     bx
        cmp     bx,word ptr ds:[prt_start]
        jne     print_rdy
gio_print4:
        call    service_print
        JMP     GO_PRINTX

PRINT_RDY:
        MOV     BYTE PTR DS:[BP].@CPB_G,1       ;SET CPB TO BUSY
        MOV     BYTE PTR DS:[BP].@DATA_G,0      ;SET DATA BUS TO 0
        MOV     BYTE PTR DS:[BP].@STROBE_G,0    ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@GIO_G,089H    ;SET GIO FLAG
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY

STROBE_POLLING2:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JZ      STROBE_2
        JMP     GIO_DISABLE2                    ;GIO DISABLE
STROBE_2:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0FH
        JNZ     PRINT_STROBE
        JMP     STROBE_POLLING2
PRINT_STROBE:
        TEST    BYTE PTR DS:[BP].@STROBE_G,OBS_STROBE
        JNZ     PRINT_STROBE_OUT
        TEST    BYTE PTR DS:[BP].@STROBE_G,CBS_STROBE
        JNZ     GIO_PRINT_END
        TEST    BYTE PTR DS:[BP].@STROBE_G,IOB_STROBE
        JNZ     GIO_PRINT_END
DEAD_LOCK_IBS:
        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE2                    ;GIO DISABLE
        JMP     DEAD_LOCK_IBS

GIO_DISABLE2_X:
        JMP     GIO_DISABLE2

PRINT_STROBE_OUT:
        MOV     AL,BYTE PTR DS:[BP].@DATA_G
        mov     bx,word ptr ds:[prt_end]
        mov     byte ptr ds:[bx],al

        cmp     bx,prt_buffer_end
        jne     gio_print7
        mov     bx,prt_buffer_start
        mov     word ptr ds:[prt_end],bx
        jmp     gio_print8
gio_print7:
        inc     word ptr ds:[prt_end]
gio_print8:
PRINT_RDY1:

        mov     bx,word ptr ds:[prt_end]
        cmp     bx,prt_buffer_end
        jne     gio_print5
        mov     bx,word ptr ds:[prt_start]
        cmp     bx,prt_buffer_start
        jne     gio_print_end
        jmp     gio_print6
gio_print5:
        inc     bx
        cmp     bx,word ptr ds:[prt_start]
        jne     gio_print_end
gio_print6:
        call    service_print

        TEST    BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNZ     GIO_DISABLE2                    ;GIO DISABLE
        JMP     PRINT_RDY1
GIO_PRINT_END:
        AND     BYTE PTR DS:[BP].@STROBE_G,0F0H ;SET STROBE TO NONE
        MOV     BYTE PTR DS:[BP].@RB_G,0        ;SET R/B TO READY
        JMP     STROBE_POLLING2

GIO_DISABLE1:
        CMP     BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNE     DISK_STROBE_ABS
        JMP     GIO_DISABLE3
GIO_DISABLE2:
        CMP     BYTE PTR DS:[BP].@STROBE_G,0F0H
        JNE     DISK_STROBE_ABS
GIO_DISABLE3:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        MOV     BYTE PTR DS:[BP].@GIO_G,0
        JMP     PROCESS_NEXT

DISK_STROBE_ABS:
        JMP     GIO_ENABLE

ERROR_34:
        MOV     AL,34H
        JMP     DISK_ERR
ERROR_90:
        MOV     AL,90H
        JMP     DISK_ERR
ERROR_91:
        MOV     AL,91H
        JMP     DISK_ERR
ERROR_93:
        MOV     AL,93H
        JMP     DISK_ERR
ERROR_94:
        MOV     AL,94H
        JMP     DISK_ERR
ERROR_95:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_96:
        MOV     AL,96H
        JMP     DISK_ERR
ERROR_98:
        MOV     AL,98H
        JMP     DISK_ERR

DISK_ERR:
        MOV     BYTE PTR DS:[BP].@ERROR,AL
        MOV     SP,STACK_PTR
        JMP     PROCESS_NEXT

flash_r_w_c:
        PUSHA
        mov     cx,word ptr ds:[bp].@sector_count
        xor     dx,dx
        mov     dl,byte ptr ds:[bp].@addr1
        mov     word ptr ds:[Addr_High],dx
        mov     ah,byte ptr ds:[bp].@addr2
        mov     al,byte ptr ds:[bp].@addr3
        mov     word ptr ds:[Addr_Low],ax
flash_r_w_c1:
        PUSH    CX
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CInvalSec
        ADD     WORD PTR DS:[ADDR_LOW],1
        ADC     WORD PTR DS:[ADDR_HIGH],0
        POP     CX
        LOOP    flash_r_w_c1
        POPA
        RET

disk_err_mx:
        cmp     byte ptr ds:[bp].@code,01h
        je      disk_err_mx_w1
        cmp     byte ptr ds:[bp].@code,02h
        je      disk_err_mx_w1
        cmp     byte ptr ds:[bp].@code,03h
        je      disk_err_mx_w1
        jmp     disk_err_mx_w2
disk_err_mx_w1:
        call    flash_r_w_c
disk_err_mx_w2:
        cmp     al,10h
        jbe     diskx_err1
        mov     al,11h
diskx_err1:
        XOR     AH,AH
        SHL     AX,1
        MOV     BX,OFFSET ERRx_JUMP
        ADD     BX,AX
        JMP     WORD PTR CS:[BX]

ERRx_JUMP:
        DW      OFFSET ERRORx_00                 ;00
        DW      OFFSET ERRORx_01                 ;01
        DW      OFFSET ERRORx_02                 ;02
        DW      OFFSET ERRORx_03                 ;03
        DW      OFFSET ERRORx_04                 ;04
        DW      OFFSET ERRORx_05                 ;05
        DW      OFFSET ERRORx_06                 ;06
        DW      OFFSET ERRORx_07                 ;07
        DW      OFFSET ERRORx_08                 ;08
        DW      OFFSET ERRORx_09                 ;09
        DW      OFFSET ERRORx_0A                 ;0A
        DW      OFFSET ERRORx_0B                 ;0B
        DW      OFFSET ERRORx_0C                 ;0C
        DW      OFFSET ERRORx_0D                 ;0D
        DW      OFFSET ERRORx_0E                 ;0E
        DW      OFFSET ERRORx_0F                 ;0F
        DW      OFFSET ERRORx_10                 ;10
        DW      OFFSET ERRORx_11                 ;11

ERRORx_00:
        MOV     AL,00H          ;*
        JMP     DISK_ERR
ERRORx_01:
        MOV     AL,01H          ;***
        JMP     DISK_ERR
ERRORx_02:
        MOV     AL,02H
        JMP     DISK_ERR
ERRORx_03:
        MOV     AL,03H
        JMP     DISK_ERR
ERRORx_04:
        MOV     AL,04H
        JMP     DISK_ERR
ERRORx_05:
        MOV     AL,05H          ;***
        JMP     DISK_ERR
ERRORx_06:
        MOV     AL,06H          ;***
        JMP     DISK_ERR
ERRORx_07:
        MOV     AL,07H
        JMP     DISK_ERR
ERRORx_08:
        MOV     AL,08H
        JMP     DISK_ERR
ERRORx_09:
        MOV     AL,09H          ;*
        JMP     DISK_ERR
ERRORx_0A:
        MOV     AL,10H          ;*
        JMP     DISK_ERR
ERRORx_0B:
        MOV     AL,11H          ;*
        JMP     DISK_ERR
ERRORx_0C:
        MOV     AL,12H          ;*
        JMP     DISK_ERR
ERRORx_0D:
        MOV     AL,13H          ;*
        JMP     DISK_ERR
ERRORx_0E:
        MOV     AL,14H
        JMP     DISK_ERR
ERRORx_0F:
        MOV     AL,15H          ;*
        JMP     DISK_ERR
ERRORx_10:
        MOV     AL,16H          ;*
        JMP     DISK_ERR
ERRORx_11:
        MOV     AL,17H          ;*
        JMP     DISK_ERR


DISK_ERR_M:
        cmp     byte ptr ds:[bp].@code,01h
        je      disk_err_m_w1
        cmp     byte ptr ds:[bp].@code,02h
        je      disk_err_m_w1
        cmp     byte ptr ds:[bp].@code,03h
        je      disk_err_m_w1
        jmp     disk_err_m_w2
disk_err_m_w1:
        call    flash_r_w_c
disk_err_m_w2:
        cmp     al,0fh
        jbe     disk_err1
        mov     al,0
disk_err1:
        XOR     AH,AH
        SHL     AX,1
        MOV     BX,OFFSET ERR_JUMP
        ADD     BX,AX
        JMP     WORD PTR CS:[BX]

ERR_JUMP:
        DW      OFFSET ERROR_00                 ;00
        DW      OFFSET ERROR_01                 ;01
        DW      OFFSET ERROR_02                 ;02
        DW      OFFSET ERROR_03                 ;03
        DW      OFFSET ERROR_04                 ;04
        DW      OFFSET ERROR_05                 ;05
        DW      OFFSET ERROR_06                 ;06
        DW      OFFSET ERROR_07                 ;07
        DW      OFFSET ERROR_08                 ;08
        DW      OFFSET ERROR_09                 ;09
        DW      OFFSET ERROR_0A                 ;0A
        DW      OFFSET ERROR_0B                 ;0B
        DW      OFFSET ERROR_0C                 ;0C
        DW      OFFSET ERROR_0D                 ;0D
        DW      OFFSET ERROR_0E                 ;0E
        DW      OFFSET ERROR_0F                 ;0F

ERROR_00:
        MOV     AL,95H          ;*
        JMP     DISK_ERR
ERROR_01:
        MOV     AL,96H          ;***
        JMP     DISK_ERR
ERROR_02:
        MOV     AL,98H
        JMP     DISK_ERR
ERROR_03:
        MOV     AL,98H
        JMP     DISK_ERR
ERROR_04:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_05:
        MOV     AL,94H          ;***
        JMP     DISK_ERR
ERROR_06:
        MOV     AL,94H          ;***
        JMP     DISK_ERR
ERROR_07:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_08:
        MOV     AL,93H
        JMP     DISK_ERR
ERROR_09:
        MOV     AL,95H          ;*
        JMP     DISK_ERR
ERROR_0A:
        MOV     AL,95H          ;*
        JMP     DISK_ERR
ERROR_0B:
        MOV     AL,95H          ;*
        JMP     DISK_ERR
ERROR_0C:
        MOV     AL,95H          ;*
        JMP     DISK_ERR
ERROR_0D:
        MOV     AL,95H          ;*
        JMP     DISK_ERR
ERROR_0E:
        MOV     AL,96H
        JMP     DISK_ERR
ERROR_0F:
        MOV     AL,95H          ;*
        JMP     DISK_ERR


;GET_BUFFER_PTR : GET BUFFER POINTER ACCORDING TO PART_NO
;

GET_BUFFER_PTR:
        MOV     BX,BASE                         ;POINT TO BUFFER BASE OF PART_NO
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        SHL     AX,1
        SHL     AX,1
        ADD     BX,AX
        MOV     AX,WORD PTR DS:[BX]             ;GET SEGMENT OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_SEG],AX
        MOV     AX,WORD PTR DS:[BX+2]           ;GET OFFSET OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_PTR],AX
        RET

;SET_NEXT_BUFFER_PTR : ADD 256 OF CURRENT BUFFER POINTER
;

SET_NEXT_BUFFER_PTR:
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     SET_RET
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
SET_RET:
        RET

; ADD_SECTOR_ADDR: INCREMENT SECTOR ADDRESS
;

ADD_SECTOR_ADDR:
        ADD     WORD PTR DS:[ADDR_LOW],1       ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        RET

; Init_Print:
;
Init_Print:
        mov     al,10h
        mov     dx,prtcrl       ;initial printer, using polling to print out
        out     dx,al           ;force int bit to non floating status
        mov     al,08h          ;initial slin bit
        out     dx,al
        mov     al,0ch          ;initial slin and init bit
        out     dx,al
        ret

; SERVICE_PRINT
;
SERVICE_PRINT:
        PUSHA
        MOV     CX,10H
SERVICE_5:
        MOV     DX,PRTST       ;is printer here?
        IN      AL,DX
        TEST    AL,40H
        JNZ     SERVICE_4      ;if printer here, start to print
        LOOP    SERVICE_5
        JMP     SERVICE_0

SERVICE_4:
        MOV     BX,WORD PTR DS:[PRT_START]
        CMP     BX,WORD PTR DS:[PRT_END]
        JE      SERVICE_0
        MOV     DX,PRTST
        IN      AL,DX
        TEST    AL,80H
        JZ      SERVICE_0
        MOV     AL,BYTE PTR DS:[BX]
        CMP     AL,0FFH
        JE      SERVICE_3
        CMP     AL,0FEH
        JE      SERVICE_3
        MOV     DX,PRTRW
        OUT     DX,AL
        NOP
        NOP
        NOP
        MOV     DX,PRTCRL
        MOV     AL,1DH
        OUT     DX,AL
        NOP
        NOP
        NOP
        MOV     AL,1CH
        OUT     DX,AL
SERVICE_3:
        CMP     BX,PRT_BUFFER_END
        JNE     SERVICE_1
        MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
        JMP     SERVICE_4
SERVICE_1:
        INC     WORD PTR DS:[PRT_START]
        JMP     SERVICE_4
SERVICE_0:
        POPA
        RET


; CLEAR_BUFFER
;
CLEAR_BUFFER:
        PUSH    BX
CLEAR_2:
        MOV     BX,WORD PTR DS:[PRT_START]
        CMP     BX,WORD PTR DS:[PRT_END]
        JE      CLEAR_0

        CMP     BYTE PTR DS:[BX],0FEH
        JNE     CLEAR_1
        CMP     BX,PRT_BUFFER_END
        JNE     CLEAR_3
        MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
        JMP     CLEAR_4
CLEAR_3:
        INC     WORD PTR DS:[PRT_START]
CLEAR_4:
        JMP     CLEAR_0
CLEAR_1:
        CMP     BX,PRT_BUFFER_END
        JNE     CLEAR_5
        MOV     WORD PTR DS:[PRT_START],PRT_BUFFER_START
        JMP     CLEAR_6
CLEAR_5:
        INC     WORD PTR DS:[PRT_START]
CLEAR_6:
        JMP     CLEAR_2
CLEAR_0:
        POP     BX
        RET

; BREAK: BREAK FOR CHECK INTERUPT FROM CS/386
;
BREAK:
        CMP     BYTE PTR DS:[RESET_PRT_FLAG],0FFH
        JE      BREAK6
        CALL    CLEAR_BUFFER
        MOV     BYTE PTR DS:[RESET_PRT_FLAG],0FFH
BREAK6:
        CMP     BYTE PTR DS:[RESET_FLAG],0FFH
        JNE     BREAK11
        JMP     BREAK1
BREAK11:
        CMP     BYTE PTR DS:[RESET_FLAG],80H
        JNE     BREAK44
        JMP     BREAK4
BREAK44:
        PUSH    AX
        PUSH    BX
        XOR     BX,BX
        MOV     BL,BYTE PTR DS:[RESET_FLAG]
        MOV     BYTE PTR DS:[RESET_FLAG],0FFH
        CMP     BL,BYTE PTR DS:[ACT_PART_NO]
        JNE     BREAK2

        mov     bp,word ptr ds:[save_bp]
        mov     byte ptr ds:[bp].@status,0
        CMP     BYTE PTR DS:[SHIFT_RESET_FLAG],0
        JE      BREAK2X
        CALL    SHIFT_RESET
        MOV     BYTE PTR Ds:[SHIFT_RESET_FLAG],0
        mov     bp,word ptr ds:[save_bp]

        MOV     AX,STACK_PTR
        MOV     SP,AX
        mov     ax,3000h
        mov     es,ax
        mov     ax,0
        mov     ds,ax

        cmp     byte ptr ds:[bp].@code,01h
        je      break2y
        cmp     byte ptr ds:[bp].@code,02h
        je      break2y
        cmp     byte ptr ds:[bp].@code,03h
        je      break2y
        jmp     break2z
break2y:
        call    flash_r_w_c
break2z:

BREAK2X:
        MOV     BX,STACK_PTR
        MOV     SP,BX
        XOR     AX,AX
        MOV     DS,AX
        MOV     AX,3000H
        MOV     ES,AX
        JMP     PROCESS_NEXT1

BREAK2: CMP     BYTE PTR DS:[ACT_PART_NO],0FFH
        JNE     BREAK3
        POP     BX
        POP     AX
        RET
BREAK3:
        SHL     BX,1
        SHL     BX,1
        SHL     BX,1
        SHL     BX,1
        SHL     BX,1
        ADD     BX,RCB
        MOV     BYTE PTR DS:[BX].@STATUS,0
        POP     BX
        POP     AX
BREAK1:
        RET
BREAK4:
        MOV    WORD PTR DS:[PRT_START],PRT_BUFFER_START
        MOV    WORD PTR DS:[PRT_END],PRT_BUFFER_END
        MOV    CX,40H
        MOV    BX,RCB
BREAK5:
        MOV    BYTE PTR DS:[BX].@STATUS,0
        ADD    BX,20H
        LOOP   BREAK5
        MOV    BYTE PTR DS:[RESET_FLAG],0FFH
        CMP    BYTE PTR DS:[SHIFT_RESET_FLAG],0
        JE     BREAK5X

        mov    bp,word ptr ds:[save_bp]
        mov    byte ptr ds:[bp].@status,0

        CALL   SHIFT_RESET
        MOV    BYTE PTR Ds:[SHIFT_RESET_FLAG],0
        mov    bp,word ptr ds:[save_bp]

BREAK5X:
        MOV    BX,STACK_PTR
        MOV    SP,BX
        XOR    AX,AX
        MOV    DS,AX
        MOV    AX,3000H
        MOV    ES,AX
        JMP    PROCESS_NEXT1


; NULL_COMMAND
;
NULL_COMMAND:
        JMP     PROCESS_NEXT2


; ---------------------- For Read ---------------------------------------------;
DREAD_B:
        CALL    CHK_SECTOR
;       ADD     WORD PTR DS:[READ_COUNT_L],1
;       ADC     WORD PTR DS:[READ_COUNT_H],0
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DREAD_B1
;       ADD     WORD PTR DS:[READ_HIT_L],1
;       ADC     WORD PTR DS:[READ_HIT_H],0
        CALL    CHITUPDATE
DREAD_B5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      DREAD_B2
        INC     BX
DREAD_B2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DREAD_B3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DREAD_B3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10000100B
        OUT     DX,AL

        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     ES,AX
        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        MOV     CX,100H
        MOV     DX,1000H
        REP     INSB

        MOV     DX,1202H
        IN      AL,DX

        MOV     AX,3000H
        MOV     ES,AX
        RET

DREAD_B1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DREAD_B4
        SUB     SI,4096
        MOV     BH,1
DREAD_B4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_M11
        POP     BX
        JMP     DREAD_B5

DISK_ERR_M11:
        JMP     DISK_ERR_M

DREAD_W:
        CALL    CHK_SECTOR
;       ADD     WORD PTR DS:[READ_COUNT_L],2
;       ADC     WORD PTR DS:[READ_COUNT_H],0
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DREAD_W1
;       ADD     WORD PTR DS:[READ_HIT_L],2
;       ADC     WORD PTR DS:[READ_HIT_H],0
        CALL    CHITUPDATE
DREAD_W5:
;       TEST    WORD PTR DS:[ADDR_LOW],01H
;       JZ      DREAD_W2
;       INC     BX
;DREAD_W2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DREAD_W3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DREAD_W3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,2
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10000100B
        OUT     DX,AL

        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        cmp     di,0ff00h
        jne     dread_w_x
        add     ax,0ff0h
        mov     di,0
dread_w_x:
        MOV     ES,AX
        MOV     CX,200H
        MOV     DX,1000H
        REP     INSB

        MOV     DX,1202H
        IN      AL,DX

        MOV     AX,3000H
        MOV     ES,AX
        RET

DREAD_W1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DREAD_W4
        SUB     SI,4096
        MOV     BH,1
DREAD_W4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_M1
        POP     BX
        JMP     DREAD_W5

DISK_ERR_M1:
        JMP     DISK_ERR_M
; ---------------------- For Read ---------------------------------------------;



; ---------------------- For Write --------------------------------------------;
; DWRITE
;
DWRITE1_X:
        JMP     DWRITE1
DWRITE:
;       push    ax
;       push    dx
;       mov     dx,1e0ah
;       mov     al,0
;       out     dx,al
;       pop     dx
;       pop     ax
        CALL    CHK_SECTOR
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DWRITE1_X
        CALL    CHITUPDATE
DWRITE5:
        PUSH    BX
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      DWRITE2
        INC     BX
DWRITE2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DWRITE3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DWRITE3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10001100B
        OUT     DX,AL

        PUSH    DS
        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     SI,WORD PTR DS:[BUFFER_PTR]
        MOV     DS,AX
        MOV     CX,100H
        MOV     DX,1000H
        REP     OUTSB
        POP     DS

        MOV     DX,1202H
        IN      AL,DX

        POP     SI
        MOV     BH,0
        CMP     SI,4096
        JB      DWRITE6
        SUB     SI,4096
        MOV     BH,1
DWRITE6:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
;       push    ax
;       push    dx
;       mov     dx,1e0ah
;       mov     al,1
;       out     dx,al
;       pop     dx
;       pop     ax
        CALL    DISK_WRITE
;       push    ax
;       push    dx
;       mov     dx,1e0ah
;       mov     al,0
;       out     dx,al
;       pop     dx
;       pop     ax
;       push    ax
;       push    dx
;       mov     dx,1e0ah
;       mov     al,1
;       out     dx,al
;       pop     dx
;       pop     ax
        CMP     AL,0
        JNE     DISK_ERR_M2
        RET

DWRITE1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DWRITE4
        SUB     SI,4096
        MOV     BH,1
DWRITE4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
;       push    ax
;       push    dx
;       mov     dx,1e0ah
;       mov     al,1
;       out     dx,al
;       pop     dx
;       pop     ax
        CALL    DISK_READ
;       push    ax
;       push    dx
;       mov     dx,1e0ah
;       mov     al,0
;       out     dx,al
;       pop     dx
;       pop     ax
        CMP     AL,0
        JNE     DISK_ERR_M2
        POP     BX
        JMP     DWRITE5

DISK_ERR_M2:
        JMP     DISK_ERR_M


; DWRITE_CACHE_B & DWRITE_CACHE_W
;
DWRITE_CACHE_B:
        XOR     BX,BX
        MOV     BL,BYTE PTR DS:[PLAT_NO]
        MOV     CL,4
        SHL     BX,CL
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        ADD     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        ADC     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     WORD PTR DS:[BLOCK_HIGH],DX
        MOV     WORD PTR DS:[BLOCK_LOW],AX

        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      DWRITE_CACHEB6

DWRITE_CACHEB7:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      DWRITE_CACHEB6
        CMP     AL,06H
        JNE     DISK_ERR_M3
        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CINVALPLAT
        JMP     DWRITE_CACHEB7

DISK_ERR_M3:
        JMP     DISK_ERR_M

DWRITE_CACHEB6:
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DWRITE_CACHEB1
        CALL    CHITUPDATE
DWRITE_CACHEB5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      DWRITE_CACHEB2
        INC     BX
DWRITE_CACHEB2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DWRITE_CACHEB3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DWRITE_CACHEB3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10001100B
        OUT     DX,AL

        PUSH    DS
        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     SI,WORD PTR DS:[BUFFER_PTR]
        MOV     DS,AX
        MOV     CX,100H
        MOV     DX,1000H
        REP     OUTSB
        POP     DS

        MOV     DX,1202H
        IN      AL,DX

        RET

DWRITE_CACHEB1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DWRITE_CACHEB4
        SUB     SI,4096
        MOV     BH,1
DWRITE_CACHEB4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_M4
        POP     BX
        JMP     DWRITE_CACHEB5

DISK_ERR_M4:
        JMP     DISK_ERR_M


DWRITE_CACHE_W:
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DWRITE_CACHEW1
        CALL    CHITUPDATE
DWRITE_CACHEW5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      DWRITE_CACHEW2
        INC     BX
DWRITE_CACHEW2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DWRITE_CACHEW3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DWRITE_CACHEW3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,2
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10001100B
        OUT     DX,AL

        PUSH    DS
        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     SI,WORD PTR DS:[BUFFER_PTR]
        cmp     si,0ff00h
        jne     dwrite_cachew3_x
        add     ax,0ff0h
        mov     si,0
dwrite_cachew3_x:
        MOV     DS,AX
        MOV     CX,200H
        MOV     DX,1000H
        REP     OUTSB
        POP     DS

        MOV     DX,1202H
        IN      AL,DX

        RET

DWRITE_CACHEW1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DWRITE_CACHEW4
        SUB     SI,4096
        MOV     BH,1
DWRITE_CACHEW4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        POP     BX
        JMP     DWRITE_CACHEW5
; ---------------------- For Write --------------------------------------------;

; ---------------------- For Compare ------------------------------------------;
DCOMPARE:
        CALL    CHK_SECTOR
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DCOMPARE1
        CALL    CHITUPDATE
DCOMPARE5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      DCOMPARE2
        INC     BX
DCOMPARE2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DCOMPARE3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DCOMPARE3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10000100B
        OUT     DX,AL

        MOV     AX,DS
        MOV     ES,AX
        MOV     DI,BUFFER

        MOV     CX,100H
        MOV     DX,1000H
        REP     INSB

        MOV     DX,1202H
        IN      AL,DX

        MOV     CX,100H
        MOV     SI,BUFFER
        MOV     AX,WORD PTR DS:[BUFFER_SEG]
        MOV     ES,AX
        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        REP     CMPSB

        MOV     AX,3000H
        MOV     ES,AX

        CMP     CX,0
        JNE     ERROR_96U

        RET

ERROR_96U:
        JMP     ERROR_96

DCOMPARE1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DCOMPARE4
        SUB     SI,4096
        MOV     BH,1
DCOMPARE4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_M96
        POP     BX
        JMP     DCOMPARE5

DISK_ERR_M96:
        JMP     DISK_ERR_M
; ---------------------- For Compare ------------------------------------------;


; ---------------------- For Format -------------------------------------------;
; DFORMAT
;
DFORMAT:
        MOV     DX,WORD PTR DS:[ACTDEV]
        CALL    GET_PLATNO
        MOV     WORD PTR DS:[ACTDEV],DX
        MOV     BYTE PTR DS:[PLAT_NO],BL
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
        JE      ERROR_91Z

        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      DFORMAT1

DFORMAT2:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      DFORMAT3
        CMP     AL,06H
        JNE     DISK_ERR_M5
        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CINVALPLAT
        JMP     DFORMAT2

ERROR_91Z:
        MOV     AL,91H
        JMP     DISK_ERR

DISK_ERR_M5:
        JMP     ERROR_93

DFORMAT3:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    CAPACITY
        CMP     AL,0
        JNE     DISK_ERR_M5

        mov     al,byte ptr ds:[plat_no]
        call    cinvalplat

        MOV     SI,BUFFER
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        MOV     AX,WORD PTR DS:[SI]
        XCHG    AH,AL
        MOV     DI,AX
        MOV     CX,WORD PTR DS:[SI+2]
        XCHG    CH,CL
        ADD     CX,1
        ADC     DI,0
        XOR     DX,DX
        XOR     AX,AX
        CALL    DISK_FILL
        CMP     AL,0
        JNE     DISK_ERR_M5
        RET

DFORMAT1:
        push    bx
        mov     al,byte ptr ds:[plat_no]
        call    cinvalplat
        pop     bx

        MOV     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        MOV     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     CX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        MOV     DI,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        CLC
        RCR     DI,1
        RCR     CX,1
        MOV     BH,0
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    DISK_FILL
        CMP     AL,0
        JNE     DISK_ERR_M5
        RET
; ---------------------- For Format -------------------------------------------;


; ---------------------- For Verify -------------------------------------------;
; DVERIFY
;
DVERIFY:
        MOV     DX,WORD PTR DS:[ACTDEV]
        CALL    GET_PLATNO
        MOV     WORD PTR DS:[ACTDEV],DX
        MOV     BYTE PTR DS:[PLAT_NO],BL
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
        JE      ERROR_91Y

        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      DVERIFY7

DVERIFY8:
        PUSH    BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        POP     BX
        CMP     AL,00H
        JE      DVERIFY7
        CMP     AL,06H
        JNE     DISK_ERR_M6
        JMP     DVERIFY8

ERROR_91Y:
        MOV     AL,91H
        JMP     DISK_ERR

DISK_ERR_M6:
        JMP     DISK_ERR_M

DVERIFY3_X:
        JMP     DVERIFY3

DVERIFY1_X:
        JMP     DVERIFY1

DVERIFY7:
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        CMP     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        JA      DVERIFY1_X
        JB      DVERIFY2
        CMP     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        JAE     DVERIFY1_X
DVERIFY2:
        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_E
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_E
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_E

        CMP     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        JA      DVERIFY3_X
        JB      DVERIFY4
        CMP     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        JAE     DVERIFY3_X
        MOV     BYTE PTR DS:[V_FLAG],0

DVERIFY4:
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]

        ADD     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        ADC     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     WORD PTR DS:[BLOCK_HIGH],DX
        MOV     WORD PTR DS:[BLOCK_LOW],AX

        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_E
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_E
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_E
        ADD     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        ADC     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        SUB     AX,WORD PTR DS:[BLOCK_LOW]
        SBB     DX,WORD PTR DS:[BLOCK_HIGH]
        XOR     CX,CX
        ADD     AX,1
        ADC     DX,CX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     DI,DX
        MOV     CX,AX
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        CALL    DISK_VERIFY
        CMP     AL,0
        JE      DVERIFY5
        CMP     AL,0EH
        JNE     DISK_ERR_M7
        CLC
        MOV     AX,CX
        RCL     AX,1
        RCL     DX,1
        XOR     BX,BX
        MOV     BL,BYTE PTR DS:[PLAT_NO]
        MOV     CL,4
        SHL     BX,CL
        SUB     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        SBB     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        JMP     DVERIFY1

DISK_ERR_M7:
        JMP     DISK_ERR_M

DVERIFY5:
        CMP     BYTE PTR DS:[V_FLAG],1
        JE      DVERIFY5X
        MOV     AL,BYTE PTR DS:[BP].@ADDR1_E
        MOV     BYTE PTR DS:[BP].@ADDR1_R,AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR2_E
        MOV     BYTE PTR DS:[BP].@ADDR2_R,AL
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_E
        MOV     BYTE PTR DS:[BP].@ADDR3_R,AL
        RET

DVERIFY5X:
        XOR     BX,BX
        MOV     BL,BYTE PTR DS:[PLAT_NO]
        MOV     CL,4
        SHL     BX,CL
        MOV     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        MOV     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        ADD     AX,1
        ADC     DX,0
        MOV     BYTE PTR DS:[BP].@ADDR1_R,DL
        MOV     BYTE PTR DS:[BP].@ADDR2_R,AH
        MOV     BYTE PTR DS:[BP].@ADDR3_R,AL
        JMP     ERROR_95


DVERIFY1:
        MOV     BYTE PTR DS:[BP].@ADDR1_R,DL
        MOV     BYTE PTR DS:[BP].@ADDR2_R,AH
        MOV     BYTE PTR DS:[BP].@ADDR3_R,AL
        JMP     ERROR_95

DVERIFY3:
        MOV     BYTE PTR DS:[V_FLAG],1
        MOV     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        MOV     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        MOV     BYTE PTR DS:[BP].@ADDR1_E,DL
        MOV     BYTE PTR DS:[BP].@ADDR2_E,AH
        MOV     BYTE PTR DS:[BP].@ADDR3_E,AL
        JMP     DVERIFY4
; ---------------------- For Verify -------------------------------------------;


; ---------------------- For General ------------------------------------------;
ERROR_91XX:
        JMP     ERROR_91

; CHK_SECTOR
;
CHK_SECTOR:
        MOV     DX,WORD PTR DS:[ACTDEV]
        CALL    GET_PLATNO
        MOV     WORD PTR DS:[ACTDEV],DX
        MOV     BYTE PTR DS:[PLAT_NO],BL
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
        JE      ERROR_91XX
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        CMP     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        JA      ERROR_98X
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        JB      CHK_SECTOR3
        CMP     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        JAE     ERROR_98X
CHK_SECTOR3:
        MOV     CX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        MOV     WORD PTR DS:[START_L],CX
        MOV     CX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        MOV     WORD PTR DS:[START_H],CX
        ADD     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        ADC     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     WORD PTR DS:[BLOCK_HIGH],DX
        MOV     WORD PTR DS:[BLOCK_LOW],AX
        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      CHK_SECTOR1
CHK_SECTOR2:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      CHK_SECTOR1
        CMP     AL,06H
        JNE     DISK_ERR_M8
        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CINVALPLAT
        JMP     CHK_SECTOR2
CHK_SECTOR1:
        RET

CACHE_FLASH:
        PUSHA
CACHE_FLASH1:
        PUSH    CX
        MOV     DX,WORD PTR DS:[ADDR_HIGH_FF]
        MOV     AX,WORD PTR DS:[ADDR_LOW_FF]
        MOV     CL,BYTE PTR DS:[PLAT_NO_FF]
        CALL    CInvalSec
        ADD     WORD PTR DS:[ADDR_LOW_FF],1
        ADC     WORD PTR DS:[ADDR_HIGH_FF],0
        POP     CX
        LOOP    CACHE_FLASH1
        POPA
        RET

ERROR_91X:
        MOV     AL,91H
        JMP     DISK_ERR
ERROR_98X:
        MOV     AL,98H
        JMP     DISK_ERR

DISK_ERR_M8:
        JMP     DISK_ERR_M

include cache.asm
include scsib.asm

error_91a:
        jmp     error_91

chk_tape:
        mov     bx,1fh
        mov     cl,4
        shl     bx,cl
        cmp     byte ptr ds:System_Config2[bx].D_status,0ffh
        je      error_91a
        mov     bl,byte ptr ds:System_config2[bx].D_ID
        mov     byte ptr ds:[DEVICE_ID],BL
chk_tape1:
        mov     bl,byte ptr ds:[DEVICE_ID]
        call    test_unit_ready
        cmp     al,06h
        je      chk_tape1
        cmp     al,0
        je      chk_tape2
        jmp     disk_err_mx
chk_tape2:
        ret

SCSITAPE_REWIND:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        call    rewind
        cmp     al,0
        je      scsitape_rewind1
        jmp     disk_err_mx
scsitape_rewind1:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSITAPE_ERASE:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        call    rewind
        cmp     al,0
        je      scsitape_erase2
        jmp     disk_err_mx
scsitape_erase2:
        mov     bl,byte ptr ds:[DEVICE_ID]
        call    erase
        cmp     al,0
        je      scsitape_erase1
        jmp     disk_err_mx
scsitape_erase1:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSITAPE_RETENSION:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        mov     bh,0
        MOV     dl,0
        MOV     dh,03h
        call    SPACE
;;      cmp     al,0
;;      je      scsitape_retension1
;;      jmp     disk_err_mx
scsitape_retension1:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    REWIND
        CMP     AL,0
        JE      SCSITAPE_RETENSION2
        JMP     DISK_ERR_Mx
SCSITAPE_RETENSION2:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSITAPE_READ:
        call    chk_tape
        MOV     CX,WORD PTR DS:[BP].@SECTOR_COUNT
        MOV     WORD PTR DS:[SECTOR_COUNT],CX
        shr     cx,1
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TAPE_READ
        CMP     AL,0
        JE      SCSITAPE_READ1
        JMP     DISK_ERR_Mx
SCSITAPE_READ1:
        CALL    GET_BUFFER_PTR

        MOV     AL,1
        MOV     DX,BANKPORT
        OUT     DX,AL

        MOV     BX,BUF_2M_BASE
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     CX,WORD PTR DS:[SECTOR_COUNT]
        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,CL
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,CH
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10000100B
        OUT     DX,AL

        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     ES,AX
        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        MOV     AX,WORD PTR DS:[SECTOR_COUNT]
        MOV     CL,8
        SHL     AX,CL
        MOV     CX,AX
        MOV     DX,1000H
        REP     INSB

        MOV     DX,1202H
        IN      AL,DX

        MOV     AX,3000H
        MOV     ES,AX

        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT


SCSITAPE_WRITE:
        call    chk_tape
        MOV     CX,WORD PTR DS:[BP].@SECTOR_COUNT
        MOV     WORD PTR DS:[SECTOR_COUNT],CX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]

        CALL    GET_BUFFER_PTR

        MOV     AL,1
        MOV     DX,BANKPORT
        OUT     DX,AL

        MOV     BX,BUF_2M_BASE
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     CX,WORD PTR DS:[SECTOR_COUNT]
        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,CL
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,CH
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10001100B
        OUT     DX,AL

        PUSH    DS
        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     SI,WORD PTR DS:[BUFFER_PTR]
        mov     bx,word ptr ds:[sector_count]
        MOV     DS,AX
        mov     cl,8
        shl     bx,cl
        mov     cx,bx
        MOV     DX,1000H
        REP     OUTSB
        POP     DS

        MOV     DX,1202H
        IN      AL,DX

        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     CX,WORD PTR DS:[SECTOR_COUNT]
        shr     cx,1
        MOV     SI,BUF_2M_BASE
        CALL    TAPE_WRITE
        CMP     AL,0
        JE      SCSITAPE_WRITE1
        JMP     DISK_ERR_Mx

SCSITAPE_WRITE1:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSITAPE_WRITEFILEMARK:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        MOV     BH,0
        MOV     CX,1
        MOV     DL,0
        call    WRITE_FILEMARKS
        cmp     al,0
        je      scsitape_writefilemarks1
        jmp     disk_err_mx
scsitape_writefilemarks1:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSITAPE_READFILEMARK:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        mov     bh,00h
        mov     dh,01h
        mov     dl,BYTE PTR DS:[BP].@ADDR1
        MOV     CH,BYTE PTR DS:[BP].@ADDR2
        MOV     CL,BYTE PTR DS:[BP].@ADDR3
        call    SPACE
        cmp     al,0
        je      scsitape_readfilemarks1
        jmp     disk_err_mx
scsitape_readfilemarks1:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SCSITAPE_ENDDATA:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        mov     bh,00h
        mov     dh,03h
        call    SPACE
        cmp     al,0
        je      scsitape_ENDDATA1
        jmp     disk_err_mx
scsitape_ENDDATA1:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT


SCSITAPE_LOCATE:
        call    chk_tape
        mov     bl,byte ptr ds:[DEVICE_ID]
        CALL    REWIND
        CMP     AL,0
        JE      SCSITAPE_LOCATE1
        JMP     DISK_ERR_Mx
SCSITAPE_LOCATE1:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        mov     bh,00h
        mov     dh,00h
        mov     dl,BYTE PTR DS:[BP].@ADDR1
        MOV     CH,BYTE PTR DS:[BP].@ADDR2
        MOV     CL,BYTE PTR DS:[BP].@ADDR3
        call    SPACE
        cmp     al,0
        je      scsitape_locate2
        jmp     disk_err_mx
scsitape_locate2:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

ERROR_34X:
        JMP     ERROR_34

SCSITAPE_BACKUP:
        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_S_O
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_S_O
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_S_O
        MOV     WORD PTR DS:[ADDR_LOW],AX
        MOV     WORD PTR DS:[ADDR_HIGH],DX
        TEST    AX,01H
        JNZ     ERROR_34X
        MOV     WORD PTR DS:[ADDR_LOW_SO],AX
        MOV     WORD PTR DS:[ADDR_HIGH_SO],DX
        MOV     AX,WORD PTR DS:[BP].@PLATTER_O
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    CHK_SECTOR
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        MOV     BYTE PTR DS:[DEVICE_ID_O],AL

        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_E_O
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_E_O
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_E_O
        MOV     WORD PTR DS:[ADDR_LOW],AX
        MOV     WORD PTR DS:[ADDR_HIGH],DX
        TEST    AX,01H
        JZ      ERROR_34X
        MOV     WORD PTR DS:[ADDR_LOW_EO],AX
        MOV     WORD PTR DS:[ADDR_HIGH_EO],DX
        CALL    CHK_SECTOR

        CALL    CHK_TAPE

SCSITAPE_BACKUPF:
        MOV     AX,WORD PTR DS:[ADDR_LOW_SO]
        MOV     DX,WORD PTR DS:[ADDR_HIGH_SO]

        MOV     BX,WORD PTR DS:[ADDR_LOW_EO]
        MOV     CX,WORD PTR DS:[ADDR_HIGH_EO]

        SUB     BX,AX
        SBB     CX,DX

        CMP     CX,0
        JNE     SCSITAPE_BACKUP4
        CMP     BX,88
        JB      SCSITAPE_BACKUP5


SCSITAPE_BACKUP4:

        ADD     AX,WORD PTR DS:[START_L]
        ADC     DX,WORD PTR DS:[START_H]
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     CX,43
        MOV     SI,BUF_2M_BASE
        MOV     BL,BYTE PTR DS:[DEVICE_ID_O]
        MOV     BH,1
        CALL    DISK_READ
        CMP     AL,0
        JE      SCSITAPE_BACKUP7
        JMP     DISK_ERR_Mx
SCSITAPE_BACKUP7:
        MOV     SI,BUF_2M_BASE
        MOV     CX,43
        TEST    WORD PTR DS:[ADDR_LOW_SO],01H
        JZ      SCSITAPE_BACKUP6
        INC     SI
        DEC     CX
SCSITAPE_BACKUP6:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        PUSH    CX
        CALL    TAPE_WRITE
        POP     CX
        CMP     AL,0
        JE      SCSITAPE_BACKUP8
        JMP     DISK_ERR_Mx
SCSITAPE_BACKUP8:
        SHL     CX,1
        ADD     WORD PTR DS:[ADDR_LOW_SO],CX
        ADC     WORD PTR DS:[ADDR_HIGH_SO],0
        JMP     SCSITAPE_BACKUPF

SCSITAPE_BACKUP5:
        ADD     BX,1
        MOV     CX,BX
        TEST    CX,1
        JZ      SCSITAPE_BACKUP9
        INC     CX
SCSITAPE_BACKUP9:
        SHR     CX,1

        ADD     AX,WORD PTR DS:[START_L]
        ADC     DX,WORD PTR DS:[START_H]
        CLC
        RCR     DX,1
        RCR     AX,1

        MOV     SI,BUF_2M_BASE
        TEST    WORD PTR DS:[ADDR_LOW_SO],01H
        JZ      SCSITAPE_BACKUPA
        TEST    BX,01H
        JNZ     SCSITAPE_BACKUPA
        INC     CX
SCSITAPE_BACKUPA:
        MOV     BL,BYTE PTR DS:[DEVICE_ID_O]
        MOV     BH,1
        PUSH    CX
        CALL    DISK_READ
        POP     CX
        CMP     AL,0
        JE      SCSITAPE_BACKUPB
        JMP     DISK_ERR_Mx
SCSITAPE_BACKUPB:
        MOV     SI,BUF_2M_BASE
        TEST    WORD PTR DS:[ADDR_LOW_SO],01H
        JZ      SCSITAPE_BACKUPC
        INC     SI
        DEC     CX
SCSITAPE_BACKUPC:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        PUSH    CX
        CALL    TAPE_WRITE
        POP     CX
        CMP     AL,0
        JE      SCSITAPE_BACKUPD
        JMP     DISK_ERR_Mx

SCSITAPE_BACKUPD:
        mov     bl,byte ptr ds:[DEVICE_ID]
        MOV     BH,0
        MOV     CX,1
        MOV     DL,0
        call    WRITE_FILEMARKS
        cmp     al,0
        je      scsitape_backupe
        jmp     disk_err_mx
scsitape_backupe:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT


ERROR_34Y:
        JMP     ERROR_34

SCSITAPE_RESTORE:
        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_S_O
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_S_O
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_S_O
        MOV     WORD PTR DS:[ADDR_LOW],AX
        MOV     WORD PTR DS:[ADDR_HIGH],DX
        TEST    AX,01H
        JNZ     ERROR_34Y
        MOV     WORD PTR DS:[ADDR_LOW_SO],AX
        MOV     WORD PTR DS:[ADDR_HIGH_SO],DX
        MOV     AX,WORD PTR DS:[BP].@PLATTER_O
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    CHK_SECTOR
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        MOV     BYTE PTR DS:[DEVICE_ID_O],AL

        XOR     DX,DX
        MOV     DL,BYTE PTR DS:[BP].@ADDR1_E_O
        MOV     AH,BYTE PTR DS:[BP].@ADDR2_E_O
        MOV     AL,BYTE PTR DS:[BP].@ADDR3_E_O
        MOV     WORD PTR DS:[ADDR_LOW],AX
        MOV     WORD PTR DS:[ADDR_HIGH],DX
        TEST    AX,01H
        JZ      ERROR_34Y
        MOV     WORD PTR DS:[ADDR_LOW_EO],AX
        MOV     WORD PTR DS:[ADDR_HIGH_EO],DX
        CALL    CHK_SECTOR

        CALL    CHK_TAPE

        MOV     AL,BYTE PTR DS:[PLAT_NO]
        CALL    CinvalPlat
SCSITAPE_RESTOREF:
        MOV     AX,WORD PTR DS:[ADDR_LOW_SO]
        MOV     DX,WORD PTR DS:[ADDR_HIGH_SO]

        MOV     BX,WORD PTR DS:[ADDR_LOW_EO]
        MOV     CX,WORD PTR DS:[ADDR_HIGH_EO]

        SUB     BX,AX
        SBB     CX,DX

        CMP     CX,0
        JNE     SCSITAPE_RESTORE4
        CMP     BX,88
        JB      SCSITAPE_RESTORE5

SCSITAPE_RESTORE4:
        MOV     CX,43
        MOV     SI,BUF_2M_BASE
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TAPE_READ
        CMP     AL,0
        JE      SCSITAPE_RESTORE7
        JMP     DISK_ERR_Mx

SCSITAPE_RESTORE7:

        MOV     SI,BUF_2M_BASE
        MOV     CX,43
        MOV     AX,WORD PTR DS:[ADDR_LOW_SO]
        MOV     DX,WORD PTR DS:[ADDR_HIGH_SO]
        ADD     AX,WORD PTR DS:[START_L]
        ADC     DX,WORD PTR DS:[START_H]
        CLC
        RCR     DX,1
        RCR     AX,1

        MOV     BL,BYTE PTR DS:[DEVICE_ID_O]
        MOV     BH,1
        PUSH    CX
        CALL    DISK_WRITE
        POP     CX
        CMP     AL,0
        JE      SCSITAPE_RESTORE8
        JMP     DISK_ERR_Mx

SCSITAPE_RESTORE8:

        SHL     CX,1
        ADD     WORD PTR DS:[ADDR_LOW_SO],CX
        ADC     WORD PTR DS:[ADDR_HIGH_SO],0
        JMP     SCSITAPE_RESTOREF


SCSITAPE_RESTORE5:
        ADD     BX,1
        MOV     CX,BX
        SHR     CX,1

        MOV     SI,BUF_2M_BASE
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        PUSH    CX
        CALL    TAPE_READ
        POP     CX
        CMP     AL,0
        JE      SCSITAPE_RESTOREB
        JMP     DISK_ERR_Mx

SCSITAPE_RESTOREB:
        MOV     SI,BUF_2M_BASE
        MOV     AX,WORD PTR DS:[ADDR_LOW_SO]
        MOV     DX,WORD PTR DS:[ADDR_HIGH_SO]
        ADD     AX,WORD PTR DS:[START_L]
        ADC     DX,WORD PTR DS:[START_H]
        CLC
        RCR     DX,1
        RCR     AX,1

        MOV     BL,BYTE PTR DS:[DEVICE_ID_O]
        MOV     BH,1
        CALL    DISK_WRITE
        CMP     AL,0
        JE      SCSITAPE_RESTORED
        JMP     DISK_ERR_Mx

SCSITAPE_RESTORED:
        mov     bl,byte ptr ds:[DEVICE_ID]
        mov     bh,00h
        mov     dh,01h
        mov     dl,0
        MOV     CH,0
        MOV     CL,1
        call    SPACE
        cmp     al,0
        je      scsitape_restoree
        jmp     disk_err_mx
scsitape_restoree:
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

WRITE_CHAR:
        PUSH    AX
        PUSH    DX
WRITE_CHAR1:
        MOV     DX,PRTST
        IN      AL,DX
        TEST    AL,80H
        JZ      WRITE_CHAR1
        POP     DX
        POP     AX

        PUSH    DX
        MOV     DX,PRTRW
        OUT     DX,AL
        NOP
        NOP
        NOP
        MOV     DX,PRTCRL
        MOV     AL,1DH
        OUT     DX,AL
        NOP
        NOP
        NOP
        MOV     AL,1CH
        OUT     DX,AL
        POP     DX
        RET

WRITE_HEX:
        PUSH    AX
        SHR     AL,1
        SHR     AL,1
        SHR     AL,1
        SHR     AL,1
        OR      AL,30H
        CMP     AL,39H
        JBE     WRITE_HEX1
        ADD     AL,07H
WRITE_HEX1:
        CALL    WRITE_CHAR
        POP     AX

        PUSH    AX
        AND     AL,0FH
        OR      AL,30H
        CMP     AL,39H
        JBE     WRITE_HEX2
        ADD     AL,07H
WRITE_HEX2:
        CALL    WRITE_CHAR
        MOV     AL,0DH
        CALL    WRITE_CHAR
        MOV     AL,0AH
        CALL    WRITE_CHAR
        POP     AX
        RET

RamSeg  ends
        end
