
;Sense Key descriptions(error code)
;       00h: no sense,successful command
;       01h: recovered error
;       02h: not ready,logical unit addressed cannot be accessed.
;       03h: medium error
;       04h: hardware error
;       05h: illegal request,illegal parameter in the CDB
;       06h: unit attention,removable medium may have been changed or the
;            target has been reset.
;       07h: data protect. block is protected
;       08h: blank check
;       09h: vender specific
;       0ah: copy aborted
;       0bh: aborted command,target abort the command
;       0ch: equal,a search data command has satisfied an equal comparison
;       0dh: volumn overflow
;       0eh: miscompare,source data did not match the data read from the
;            medium
;       0fh: reserved
;       10h: time out error
;       15h: cannot open the specificed platt
;       16h: cannot open all
JMP_LABEL       LABEL   WORD
                DW      OFFSET PHASE_DATA_OUT
                DW      OFFSET PHASE_DATA_IN
                DW      OFFSET ERROR_PHASE
                DW      OFFSET PHASE_STATUS
                DW      OFFSET ERROR_PHASE
                DW      OFFSET ERROR_PHASE
                DW      OFFSET PHASE_MSG_OUT
                DW      OFFSET PHASE_MSG_IN
                DW      OFFSET PHASE_DATA_OUT
                DW      OFFSET PHASE_DATA_IN
                DW      OFFSET ERROR_PHASE
                DW      OFFSET PHASE_STATUS
                DW      OFFSET ERROR_PHASE
                DW      OFFSET ERROR_PHASE
                DW      OFFSET PHASE_MSG_OUT
                DW      OFFSET PHASE_MSG_IN

FLP_TYPE        LABEL   WORD
                ;------ 1.2M -----------------------------------------
                DB      00H,1BH,00H,08H                  ;4 byte header
                DB      00H,00H,00H,00H,00H,00H,02H,00H  ;8 byte block
                                                         ;descriptor
                DB      05h,1EH,01H,0F4H,02H,0FH,02H,00H ;32 byte page code 5
                DB      00H,50H,00H,00H,00H,50H,00H,1EH
                DB      00H,00H,0DCH,05H,46H,60H,01H,02H
                DB      00H,00H,2DH,00H,00H,00H,00H,00H

                ;------ 360K -----------------------------------------
;               DB      00H,1AH,00H,08H                  ;4 byte header
;               DB      00H,00H,00H,00H,00H,00H,02H,00H  ;8 byte block
                                                         ;descriptor
;               DB      05H,1EH,00H,0FAH,02H,08H,02H,00H ;32 byte page code 5
;               DB      00H,50H,00H,50H,00H,50H,00H,28H
;               DB      00H,01H,18H,04H,46H,60H,01H,00H
;               DB      00H,00H,20H,00H,00H,00H,00H,00H

                DB      00H,27H,00H,08H                  ;4 byte header
                DB      00H,00H,00H,00H,00H,00H,01H,00H  ;8 byte block
                                                         ;descriptor
                DB      05h,1EH,00H,0FAH,02H,09H,02H,00H ;32 byte page code 5
                DB      00H,28H,00H,00H,00H,00H,00H,3CH
                DB      00H,00H,96H,05H,46H,60H,02H,00H
                DB      00H,00H,25H,00H,00H,00H,00H,00H

                ;------ 320K -----------------------------------------
                DB      00H,27H,00H,08H                  ;4 byte header
                DB      00H,00H,00H,00H,00H,00H,01H,00H  ;8 byte block
                                                         ;descriptor
                DB      05h,1EH,00H,0FAH,02H,10H,01H,00H ;32 byte page code 5
                DB      00H,28H,00H,00H,00H,00H,00H,3CH
                DB      00H,00H,96H,05H,46H,60H,02H,00H
                DB      00H,00H,25H,00H,00H,00H,00H,00H

                ;------ 1.0M -----------------------------------------
                DB      00H,1BH,00H,08H                 ;4 byte header
                DB      00H,00H,00H,00H,00H,00H,01H,00H ;8 byte block

                DB      05H,1EH,01H,0F4H,02H,1AH,01H,00H
                DB      00H,50H,00H,00H,00H,00H,00H,1EH
                DB      00H,00H,96H,05H,46H,60H,01H,00H
                DB      00H,00H,2DH,00H,00H,00H,00H,00H
                DB      0FFH

;**************************************************
;        INITIALIZE SCSI CHIP
;
;**************************************************
SCSI_INIT:

        MOV     AX,0
        MOV     DS,AX

        MOV    SI,32H                          ;set SCSI intr vector
        SHL    SI,02H
        MOV    WORD PTR [SI],OFFSET SCSI_ISR   ;
        MOV    WORD PTR [SI+2],0F000H

        MOV    AX,CS:[DATASEG]
        MOV    DS,AX

        MOV    BYTE PTR DS:[INTR_OK],0       ;initialize INTR semphore
                                             ;to zero
        MOV     AL,08H                       ;disable serial port 0
        MOV     DX,1608H                     ;
        OUT     DX,AL

        MOV     AL,00H
        MOV     DX,1602H
        OUT     DX,AL

        MOV     AL,08H                       ;disable serial port 1
        MOV     DX,1808H                     ;
        OUT     DX,AL

        MOV       AL,0
        MOV       DX,1e08h                   ; CPU access bank0
        OUT       DX,AL

        MOV     AL,00H                       ;
        MOV     DX,1802H                     ;
        OUT     DX,AL

        MOV     AL,10H                       ;disable printer port
        MOV     DX,1A04H                     ;
        OUT     DX,AL

        MOV     AL,02H                       ;issue RESET CHIP command
        MOV     DX,reg_CMD
        OUT     DX,AL

        MOV     AL,00H                       ;issue NOP command
        MOV     DX,reg_CMD                   ;
        OUT     DX,AL

         MOV     DX,reg_TIMEOUT
         MOV     AL,99H
         OUT     DX,AL                          ;250 ms time out

         MOV     DX,reg_SYNC_OFF                ;synchronous offset register
         MOV     AL,0                           ;zero indicate asynchronous
         OUT     DX,AL                          ;transfer

         MOV     DX,1C00H                       ;read switch(my bus ID)
         IN      AL,DX                          ;
         xor     al,0ffh
         mov     ah,0
         test    al,01h
         jz      x1
         or      ah,80h
x1:      test    al,02h
         jz      x2
         or      ah,40h
x2:      test    al,04h
         jz      x3
         or      ah,20h
x3:      test    al,08h
         jz      x4
         or      ah,10h
x4:      test    al,10h
         jz      x5
         or      ah,08h
x5:      test    al,20h
         jz      x6
         or      ah,04h
x6:      test    al,40h
         jz      x7
         or      ah,02h
x7:      test    al,80h
         jz      x8
         or      ah,01h
x8:
         mov     al,ah

         and     al,0e0h
         mov     cl,5
         shr     al,cl

         MOV     BYTE PTR DS:[MY_BUS_ID],AL     ;
         MOV     DX,reg_CONFIG1                 ;config register 1
         OR      AL,40H                         ;no intr when RST SCSI BUS
         OUT     DX,AL

         MOV     DX,reg_CONFIG2                 ;config register 2
         MOV     AL,00000000B
         OUT     DX,AL

         MOV     DX,reg_CCF                     ;clock conversion factor
         MOV     AL,05H                         ;register,clock frequency
         OUT     DX,AL                          ;set to 20.01 to 25 MHz

;-------- initialize DMA --------
         MOV    DX,DMA_config                   ;initialize DMA reg.
         MOV    AL,30H
         OUT    DX,AL

         MOV    DX,DMA_refresh
         MOV    AL,5BH
         OUT    DX,AL

         MOV    DX,DMA_ram_speed
         MOV    AL,01H
         OUT    DX,AL                           ;85 ns

         MOV    DX,DMA_timer_processor
         MOV    AL,10H
         OUT    DX,AL
;--------- initialize DMA ---------

         MOV     DX,1E04H                     ;set 53C90A intr enable
         MOV     AL,1
         OUT     DX,AL

         MOV    DX,1E02H                      ;DMA disable,we don't need this
         MOV    AL,0                          ;intr,because 53C90 will intr
         OUT    DX,AL                         ;us when transfer completed
         RET
;*********************************************************************
;       SCSI interrupt service routine
;
;*********************************************************************
SCSI_ISR:
        PUSH    DS
        PUSH    DX
        PUSH    AX

        MOV     AX,CS:[DATASEG]
        MOV     DS,AX

        MOV     DX,reg_STATUS
        IN      AL,DX                           ;save register value
        MOV     BYTE PTR DS:[STATUS_BYTE],AL

        MOV     DX,reg_SEQ
        IN      AL,DX
        MOV     BYTE PTR DS:[SEQUENCE_BYTE],AL

        MOV     DX,reg_INTR                  ;intr byte reg must read lastly
        IN      AL,DX
        MOV     BYTE PTR DS:[INTR_BYTE],AL    ;otherwise the STATUS and SEQ
                                             ;byte reg value will be destoried
        MOV     BYTE PTR DS:[INTR_OK],1                    ;indicate that SCSI intr has

        POP     AX
        POP     DX
        POP     DS
        IRET                                 ;occurred
;*********************************************************************
;       wait til SCSI intr occur
;
;*********************************************************************
WAIT_INT:
       CMP      BYTE PTR DS:[INTR_OK],1
       JE       WAIT_INT_1
WAIT_INT_2:
       MOV      BYTE PTR DS:[SHIFT_RESET_FLAG],1
       CALL     BREAK
       MOV      BYTE PTR DS:[SHIFT_RESET_FLAG],0
       call     service_print
       JMP      WAIT_INT
WAIT_INT_1:
       MOV      BYTE PTR DS:[INTR_OK],0
       RET

;*********************************************************************
;      TEST UNIT READY
;       BL=SCSI device ID
;       (the returned data will be put on offset BUFFER)
;       AL:0  if unit ready
;         <>0 if unit not ready
;*********************************************************************
TEST_UNIT_READY:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD
        MOV     BYTE PTR [SI],00H               ;operation code
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET
;*********************************************************************
;      REQUEST SENSE COMMAND
;       BL=SCSI device ID
;      RETURN:
;       AL=sense key
;       DL=additional sense key(byte 12)
;       DH=additional sense key(byte 13)
;*********************************************************************
RQST_SENSE:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;# into physical sector
        MOV     BYTE PTR [SI],03H               ;operation code
        MOV     WORD PTR [SI+4],12H             ;request sense data length

        PUSH    DS
        POP     ES
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        MOV     AL,BYTE PTR DS:[BUFFER+2]       ;sense key
        MOV     DX,WORD PTR DS:[BUFFER+12]      ;addition sense key

        POP     ES
        POP     DS
        RET
;*********************************************************************
;       CAPACITY COMMAND
;        BL=SCSI device ID
;       RETURN:
;        DX=the largest block number MSW
;        CX=the largest block number LSW
;*********************************************************************
CAPACITY:
        PUSH    DS
        PUSH    ES
        PUSH    BP

;------ TSAI,04-28-92 ------
        MOV     BP,CS:[DATASEG]
        MOV     DS,BP

        CMP     BL,BYTE PTR DS:[V_FDD_ID]   ;
        JNE     CAPACITYA                   ;br,if not FDD

;       PUSH    AX
        CALL    FLOPPY_TYPE                 ;check the medium type
        CMP     AL,0                        ;
        JNE     CAPC_RET
;       POP     AX
;       JE      CAPACITYA                   ;error,if cannot find

;       MOV     AL,BYTE PTR DS:[V_MSG]      ;error code
;       POP     BP
;       POP     ES
;       POP     DS
;       RET
;------ TSAI,04-28-92 ------
CAPACITYA:
        CALL    CLEAR_CMD                       ;
        MOV     BYTE PTR [SI],25H               ;operation code
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],10
        CALL    SCSI_MAIN

CAPC_RET:
        POP     BP
 ;      MOV     AL,BYTE PTR DS:[V_CSB]          ;
        MOV     DX,WORD PTR DS:[BUFFER]
        XCHG    DH,DL
        MOV     CX,WORD PTR DS:[BUFFER+2]
        XCHG    CH,CL
        POP     ES
        POP     DS
        RET


;*********************************************************************
;       INQUERY COMMAND
;       BL=SCSI device ID
;       DS:SI=buffer adr
;*********************************************************************
INQUERY:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;# into physical sector
        MOV     BYTE PTR [SI],12H               ;operation code
        MOV     WORD PTR [SI+4],24H             ;inquery data length

        PUSH    DS
        POP     ES

        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
;       MOV     AL,BYTE PTR DS:[V_CSB]          ;
        POP     ES
        POP     DS
        RET

;*********************************************************************
;      read the desired sector into memory
;        BL=SCSI device ID
;        BH=memory bank switch(0,1 if buffer in 2M area,3 if in 256K SRAM
;        DX:AX=logical block address
;        SI=buffer address
;        CX=number of blk to be read
;*********************************************************************
DISK_READ:

;       push    dx
;       push    ax
;       mov     dx,1e0ah
;       mov     al,0
;       out     dx,al
;       pop     ax
;       pop     dx
;------ TSAI,04-28-92 ------
        PUSH    DS
        PUSH    ES
        PUSH    BP

        MOV     BP,CS:[DATASEG]
        MOV     DS,BP

        MOV     BYTE PTR DS:[V_BLK_SIZE],02 ;default 1 blk=512byte
        CMP     BL,BYTE PTR DS:[V_FDD_ID]   ;
        JNE     DISK_READB                  ;br,if not FDD

        PUSH    AX
        CALL    FLOPPY_TYPE                 ;check the medium type
        CMP     AL,0                        ;
        MOV     BYTE PTR DS:[V_MSG],AL      ;
        POP     AX
        JNE     DISK_READC                  ;error,if cannot find

        CMP     BYTE PTR DS:[V_BLK_SIZE],2
        JE      DISK_READB
        CMP     BYTE PTR DS:[V_BLK_SIZE],01
        JE      DISK_READD
        MOV     AL,03
        JMP     READ_RET
DISK_READD:
        SHL     CX,1                        ;blk len=256 byte,need adjusted
        SAL     AX,1                        ;(DX:AX)*2
        RCL     DX,1
        JMP     DISK_READB                  ;
DISK_READC:
        MOV     AL,BYTE PTR DS:[V_MSG]      ;error code
        JMP     READ_RET

DISK_READB:
;------ TSAI,04-28-92 ------
        MOV     BP,SI
        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],28H               ;operation code
        XCHG    DH,DL
        XCHG    AH,AL
        XCHG    CH,CL
        MOV     WORD PTR [SI+2],DX              ;logical block adr MSB,DX
        MOV     WORD PTR [SI+4],AX              ;logical block adr LSB,BX
        MOV     WORD PTR [SI+7],CX              ;transfer length,CX
        XCHG    CH,CL
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],10

        CMP     BH,3                            ;
        JE      DISK_READ2

DISK_READ1:
        MOV     AL,BH                           ;select memory bank
        MOV     DX,1E08H
        OUT     DX,AL

        CMP     BYTE PTR DS:[V_BLK_SIZE],02          ;BR,if blk size=512
        JE      DISK_READ3
        SHR     CX,1

DISK_READ3:
        MOV     SI,BP                           ;buffer adress
        CALL    INIT_DMA

DISK_READ2:
        CALL    SCSI_MAIN
READ_RET:
        POP     BP
        POP     ES
        POP     DS
;       push    dx
;       push    ax
;       mov     dx,1e0ah
;       mov     al,1
;       out     dx,al
;       pop     ax
;       pop     dx
        RET

;*********************************************************************
;     write the desired sector from memory(by block address)
;        BL:SCSI device ID
;        BH=memory bank switch(0,1 if buffer in 2M area,3 if in 256K SRAM
;        DX:AX=blk adr
;        CX=blk count
;        SI=buffer adr
;*********************************************************************
DISK_WRITE:
;------ TSAI,04-28-92 ------
        PUSH    DS
        PUSH    ES
        PUSH    BP

        MOV     BP,CS:[DATASEG]
        MOV     DS,BP

        MOV     BYTE PTR DS:[V_BLK_SIZE],02 ;default 1 blk=512byte
        CMP     BL,BYTE PTR DS:[V_FDD_ID]   ;
        JNE     DISK_WRITEA                 ;br,if not FDD

        PUSH    AX
        CALL    FLOPPY_TYPE                 ;check the medium type
        CMP     AL,0                        ;
        MOV     BYTE PTR DS:[V_MSG],AL      ;
        POP     AX
        JNE     DISK_WRITEC                 ;error,if cannot find

        CMP     BYTE PTR DS:[V_BLK_SIZE],02
        JE      DISK_WRITEA
        CMP     BYTE PTR DS:[V_BLK_SIZE],01
        JE      DISK_WRITED
        MOV     AL,03
        JMP     WRITE_RET

DISK_WRITED:
        SHL     CX,1                        ;blk len=256,need adjusted
        SAL     AX,1                        ;(DX:AX)*2
        RCL     DX,1                        ;
        JMP     DISK_WRITEA                 ;
DISK_WRITEC:
        MOV     AL,BYTE PTR DS:[V_MSG]      ;error code
        JMP     WRITE_RET
;------ TSAI,04-28-92 ------
DISK_WRITEA:
        MOV     BP,SI
        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],2AH               ;operation code
        XCHG    DH,DL
        XCHG    AH,AL
        XCHG    CH,CL
        MOV     WORD PTR [SI+2],DX              ;logical block adr MSB,DX
        MOV     WORD PTR [SI+4],AX              ;logical block adr LSB,BX
        MOV     WORD PTR [SI+7],CX              ;transfer length,CX
        XCHG    CH,CL
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],10

        CMP     BH,3                            ;
        JE      DISK_WRITE2

DISK_WRITE1:
        MOV     AL,BH                           ;select memory bank
        MOV     DX,1E08H
        OUT     DX,AL

;------ TSAI,04-28-92 ------
        CMP     BYTE PTR DS:[V_BLK_SIZE],02     ;BR,if blk size=512
        JE      DISK_WRITE3
        SHR     CX,1
;------ TSAI,04-28-92 ------

DISK_WRITE3:
        MOV     SI,BP                           ;buffer adress
        CALL    INIT_DMA

DISK_WRITE2:
        CALL    SCSI_MAIN
WRITE_RET:
        POP     BP
        POP     ES
        POP     DS
        RET
;*********************************************************************
;     set floppy type to high density or double density
;       BL: SCSI device ID
;       BH: 0,double density
;           1,high density
;*********************************************************************
SET_FLOPPY:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        PUSH    BX
        CALL    MODE_SENSE                      ;read the sense data
        POP     BX

        CMP     AL,00H
        JE      FLOPPY_1
        JMP     FLOPPY_RET
FLOPPY_1:
        MOV     BP,CS:[DATASEG]
        MOV     DS,BP
        MOV     SI,BUFFER
        MOV     AL,BYTE PTR DS:[SI+01H]
        CMP     AL,1AH
        JE      FLOPPY_3                        ;
FLOPPY_2:                                       ;
        CMP     AL,1BH                          ;
        JE      FLOPPY_3                        ;
        MOV     AL,12H                          ;
        JMP     FLOPPY_RET                      ;indicate not a floppy drive
FLOPPY_3:
        MOV     AL,1AH                          ;medium type for double density
        CMP     BH,0
        JE      FLOPPY_4
        MOV     AL,1BH                          ;medium type for high density
FLOPPY_4:
        MOV     BYTE PTR DS:[SI+1],AL           ;medium type
        MOV     CL,BYTE PTR DS:[SI]             ;
        INC     CL                              ;sense data length
        MOV     BYTE PTR DS:[SI],0              ;this byte is reserved
        CALL    MODE_SELECT                     ;
FLOPPY_RET:
        POP     BP
        POP     ES
        POP     DS
        RET
;------ TSAI,04-28-92 ------
;**********************************************************************
;      decide the diskette type in the floppy driver
;**********************************************************************

FLOPPY_TYPE:
        PUSH    DS
        PUSH    ES
        PUSH    BP
        PUSH    BX
        PUSH    CX
        PUSH    DX
        PUSH    SI
        PUSH    DI

        MOV     DI,OFFSET FLP_TYPE
FLP_NEXT:
        MOV     CX,1                            ;read 1 block
        MOV     BL,BYTE PTR DS:[V_FDD_ID]   ;
        MOV     BH,03H                          ;read into 256k BUFFER
        MOV     DX,0
        MOV     AX,0

        MOV     BP,SI
        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],28H               ;read blk command code
        XCHG    DH,DL
        XCHG    AH,AL
        XCHG    CH,CL
        MOV     WORD PTR [SI+2],DX              ;logical block adr MSB,DX
        MOV     WORD PTR [SI+4],AX              ;logical block adr LSB,BX
        MOV     WORD PTR [SI+7],CX              ;transfer length,CX
        XCHG    CH,CL
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],10

        PUSH    DI
        CALL    SCSI_MAIN
        POP     DI

        CMP     AL,00H                          ;if read OK,current type
        JE      FLP_OK                          ;match,no need to change
        CMP     AL,02H                          ;end,if driver not ready
        JE      FLP_RET

        CMP     BYTE PTR CS:[DI],0FFH
        JNE     FLP_2
        MOV     AL,08H                          ;all types have checked
        JMP     FLP_RET                         ;indicate medium error
FLP_2:
        MOV     SI,BUFFER
        PUSH    DS
        POP     ES                              ;ES=DS
        PUSH    DS                              ;save DS

        XCHG    DI,SI
        PUSH    CS                              ;DS=CS
        POP     DS

        MOV     CX,2CH
        REP     MOVSB
        POP     DS
        XCHG    SI,DI

        MOV     CL,2CH
        PUSH    DI
        MOV     BL,BYTE PTR DS:[V_FDD_ID]       ;
        CALL    MODE_SELECT                     ;
        POP     DI
        JMP     FLP_NEXT
FLP_OK:
        MOV     BL,BYTE PTR DS:[V_FDD_ID]   ;
        CALL    MODE_SENSE
        CMP     AL,0
        JNE     FLP_RET
        MOV     SI,BUFFER
        MOV     AL,BYTE PTR DS:[SI+10]      ;if blk len=512 byte
        MOV     BYTE PTR DS:[V_BLK_SIZE],AL
        MOV     AL,0
FLP_RET:
        POP     DI
        POP     SI
        POP     DX
        POP     CX
        POP     BX
        POP     BP
        POP     ES
        POP     DS
        RET
;------ TSAI,04-28-92 ------
;*********************************************************************
;     preformat the SCSI disk
;       BL:SCSI device ID
;*********************************************************************
DISK_FORMAT:
        PUSH    DS
        PUSH    ES
        PUSH    BP
;------ 04-28-92 ,TSAI ------------
        MOV     BP,CS:[DATASEG]
        MOV     DS,BP

        CMP     BL,BYTE PTR DS:[V_FDD_ID]   ;
        JNE     FORMAT_A                    ;br,if not FDD

        CALL    FLOPPY_TYPE                 ;check the medium type
        CMP     AL,0
        JE      FORMAT_2
                                            ;we cannot find any type to
        MOV     CX,2CH                      ;match this floppy,assume it
        MOV     SI,OFFSET FLP_TYPE          ;is a 1.2M one
        MOV     DI,OFFSET BUFFER
        PUSH    DS
        POP     ES

        MOV     AX,CS
        MOV     DS,AX
        REP     MOVSB

        MOV     CL,2CH
        MOV     BL,BYTE PTR DS:[V_FDD_ID]       ;
        CALL    MODE_SELECT                     ;

        CMP     AL,0
        JNE     FORMAT_RET
        JMP     FORMAT_2
;------ 04-28-92 ,TSAI ------------
FORMAT_A:
        CALL    MODE_SENSE                  ;read the sense data
        CMP     AL,00H
        JE      FORMAT_1
        JMP     FORMAT_RET

FORMAT_1:
        MOV     BP,CS:[DATASEG]
        MOV     DS,BP
        MOV     SI,BUFFER
        MOV     AX,WORD PTR DS:[SI+0AH]
        MOV     BH,BYTE PTR DS:[SI+09H]
        CMP     BH,00H
        JNE     FORMAT_3
        XCHG    AH,AL
        CMP     AX,200H
        JE      FORMAT_2                        ;if blk size is 512 byte ?

FORMAT_3:
        MOV     WORD PTR DS:[SI+0AH],0002H      ;
        MOV     BYTE PTR DS:[SI+9H],0
        MOV     CL,BYTE PTR DS:[SI]
        INC     CL
        MOV     BYTE PTR DS:[SI],0              ;this byte is reserved for
        CALL    MODE_SELECT                     ;MODE SELECT command
        CMP     AL,00H
        JE      FORMAT_2
        MOV     AL,11H                          ;tanget provide no change
        JMP     FORMAT_RET                      ;on block size

FORMAT_2:
        CALL    CLEAR_CMD
        MOV     BYTE PTR [SI],04H               ;operation code
;       MOV     WORD PTR [SI+3],0               ;interleave
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN                       ;

FORMAT_RET:
        POP     BP
        POP     ES
        POP     DS
        RET

;*********************************************************************
;      DISK COPY  COMMAND
;        BL: source id
;        BH: dest id
;     DX:AX: source sector adr
;     DI:SI: dest sector adr
;        CX: num of sector to be copied
;*********************************************************************
DISK_COPY:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        MOV     BP,CS:[DATASEG]
        MOV     DS,BP

;------- first read the source data into 2M memory --------
        MOV     WORD PTR DS:[V_TEMP1],CX
        MOV     WORD PTR DS:[V_TEMP2],DI
        MOV     WORD PTR DS:[V_TEMP3],SI

        MOV     BP,buf_2M_base+1
        TEST    AL,01H
        JE      DISK_COPY1
        MOV     BP,buf_2M_base+2

DISK_COPY1:
        MOV     DI,DX
        MOV     SI,AX
        DEC     CX
        ADD     SI,CX
        ADC     DI,0

        SAR     DX,1                    ;(DX:AX)/2
        RCR     AX,1

        SAR     DI,1                    ;(DI:SI)/2
        RCR     SI,1

        SUB     SI,AX
;       SBB     DI,DX                   ;(DI:SI)-(DX:AX)

        MOV     CX,SI                   ;
        INC     CX                      ;CX=num of blk to be read
        PUSH    BX
        MOV     SI,buf_2M_base+1
        MOV     BH,01H                  ;BANK 01
        CALL    DISK_READ
        POP     BX
        CMP     AL,0
        JE      DISK_COPY8
        JMP     COPY_RET

DISK_COPY8:

        MOV     DX,WORD PTR DS:[V_TEMP2]   ;restore dest start logical blk adr
        MOV     AX,WORD PTR DS:[V_TEMP3]
        MOV     CX,WORD PTR DS:[V_TEMP1]   ;restore sector count
        MOV     WORD PTR DS:[V_TEMP2],BP   ;temporary save 2M buffer start
        MOV     WORD PTR DS:[V_TEMP6],BX   ;save source ID,dest ID

        MOV     BL,AL
        AND     BL,01H
        SHL     BL,1
                                                ;BL= b1 b0 <==> Lblkadr  blknum
        MOV     BH,CL                           ;     0  0        even    even
        AND     BH,01H                          ;     0  1        even     odd
        ADD     BL,BH                           ;     1  0         odd    even
                                                ;     1  1         odd     odd
        ;------ calculate dest last blk adr and blk count -------
        MOV     DI,DX
        MOV     SI,AX
        DEC     CX
        ADD     SI,CX
        ADC     DI,0

        SAR     DX,1                     ;(DX:AX)/2
        RCR     AX,1

        SAR     DI,1                     ;(DI:SI)/2
        RCR     SI,1

        MOV     WORD PTR DS:[V_TEMP4],DI ;DI:SI last blk adr of dest
        MOV     WORD PTR DS:[V_TEMP5],SI ;
        SUB     SI,AX                    ;(DI:SI)-(DX:AX)
;       SBB     DI,DX

        MOV     CX,SI                    ;
        INC     CX                       ;CX=number of blk to be wrote
        MOV     WORD PTR DS:[V_TEMP3],CX

        CMP     BL,00H
        JNE     DISK_COPY9
        JMP     DISK_COPY2                      ;no addition read
DISK_COPY9:
        CMP     BL,01H                          ;
        JE      DISK_COPY3                      ;additional read last blk

        ;------ additional read first ----------------
        PUSH    DX
        PUSH    CX
        PUSH    BX
        PUSH    AX
        MOV     CX,1                            ;read 1 block
        MOV     BX,WORD PTR DS:[V_TEMP6]        ;restore SCSI BUS ID
        MOV     BL,BH                           ;dest ID
        MOV     BH,03H                          ;read into 256k BUFFER
        CALL    DISK_READ
        CMP     AL,00H                          ;if read OK
        JE      DISK_COPY4
        MOV     WORD PTR DS:[V_TEMP1],AX        ;temporay save error code
        POP     AX
        POP     BX
        POP     CX
        POP     DX
        MOV     AX,WORD PTR DS:[V_TEMP1]
        JMP     COPY_RET                        ;

DISK_COPY4:
        MOV     AL,01H                          ;memory bank 1
        MOV     BL,0                            ;write to 2M memory
        PUSH    DS
        POP     ES
        MOV     SI,BUFFER                       ;even sector are concerned
        MOV     CX,1                            ;mov 1 sector
        DEC     BP
        CALL    MOV_DATA
        POP     AX
        POP     BX
        POP     CX
        POP     DX
        CMP     BL,03H                          ;no additional read last
        JE      DISK_COPY2                      ;needed

DISK_COPY3:
        ;------- additional read last blk ------------
        XCHG    DX,WORD PTR DS:[V_TEMP4]        ;DX:AX now dest last blk adr
        XCHG    AX,WORD PTR DS:[V_TEMP5]
                                                ;and save dest start blk adr
        MOV     CX,1                            ;read 1 block
        MOV     BX,WORD PTR DS:[V_TEMP6]        ;restore SCSI id
        MOV     BL,BH
        MOV     BH,3                            ;read into 256K memory area
        CALL    DISK_READ
        CMP     AL,00H                          ;if read OK
        JE      DISK_COPY7
        JMP     COPY_RET                        ;

DISK_COPY7:
        XCHG    BP,WORD PTR DS:[V_TEMP2]        ;BP now 2M buffer start
        ADD     BP,WORD PTR DS:[V_TEMP1]        ;calculate the adr where
                                                ;to move
        MOV     AL,01H                          ;memory bank 1
        MOV     BL,0                            ;write to 2M memory
        MOV     SI,BUFFER+100H                  ;odd sector are concerned
        MOV     CX,1                            ;mov 1 sector
        PUSH    DS                              ;ES:SI point to data buf to be
        POP     ES                              ;moved
        CALL    MOV_DATA
        XCHG    BP,WORD PTR DS:[V_TEMP2]        ;restore BP

DISK_COPY6:
        MOV     DX,WORD PTR DS:[V_TEMP4]        ;DX:AX dest start blk adr
        MOV     AX,WORD PTR DS:[V_TEMP5]        ;
        MOV     CX,WORD PTR DS:[V_TEMP3]        ;blk count to be wrote

DISK_COPY2:
        MOV     SI,BP                           ;buffer start adr
        MOV     BX,WORD PTR DS:[V_TEMP6]
        MOV     BL,BH                           ;dest SCSI id
        MOV     BH,01H                          ;memory bank 1
        CALL    DISK_WRITE

COPY_RET:
        POP     BP
        POP     ES
        POP     DS
        RET
;*********************************************************************
;      DISK COMPARE COMMAND
;       BL=logical unit no
;       DX:AX=sector address
;       CX=sector count
;       DS:SI=buffer which store the contains to be compared
;*********************************************************************
DISK_COMPARE:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        PUSH    DS
        POP     ES
        MOV     DI,SI

        MOV     BP,CS:[DATASEG]
        MOV     DS,BP

        MOV     BP,CX                           ;BP=sector count
        MOV     BYTE PTR DS:[V_SCSI_ID],BL

        MOV     CX,100H                         ;check if the begin
        MOV     SI,BUFFER                       ;sector address is odd
        TEST    AX,1                            ;or even
        JE      DISK_COMP3                      ;
        ADD     SI,100H                         ;
        MOV     CX,80H                          ;

DISK_COMP3:
        SAR     DX,1                            ;change sector adr to block
        RCR     AX,1                            ;adr

COMP_LOOP:
        PUSH    CX
        MOV     CX,1                            ;read 1 block
        MOV     BH,3                            ;read into 256K memory area
        MOV     BL,BYTE PTR DS:[V_SCSI_ID]      ;
        PUSH    AX
        PUSH    DI
        PUSH    SI
        CALL    DISK_READ
        CMP     AL,00H                          ;if read OK ?
        POP     SI
        POP     DI
        POP     AX
        POP     CX
        JE      DISK_COMP1
        MOV     AL,11H
        JMP     COMP_RET                        ;

DISK_COMP1:
        MOV     BX,CX
        REPZ    CMPSW
        JZ      DISK_COMP2
        MOV     AL,11H                          ;indicate compare not OK
        JMP     COMP_RET                        ;

DISK_COMP2:
        SHR     BX,07H                          ;BX=1,last compare is 1 sector
        SUB     BP,BX                           ;  =2,last compare is 2 sector
        JZ      COMP_RET0                       ;end of compare
        MOV     SI,BUFFER                       ;
        MOV     CX,100H                         ;default compare 1 block
        CMP     BP,1                            ;if only 1 sector left
        JNE     DISK_COMP4                      ;let compare count = 1 sector
        MOV     CX,80H                          ;

DISK_COMP4:
        ADD     AX,1                            ;compare next block
        ADC     DX,0
        JMP     COMP_LOOP

COMP_RET0:
        MOV     AL,0

COMP_RET:
        POP     BP
        POP     ES
        POP     DS
        RET

;*********************************************************************
;     Verify the desired sector
;        BL:SCSI bus id
;        DX:AX=block adr(1 SCSI BLOCK = 2  2200 sector=512byte)
;        DI:CX=block count
;     RETURN:
;        AL=0 OK
;        AL<>0
;          DX:CX the blk adr which cause verify error first
;*********************************************************************
DISK_VERIFY:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        MOV     BP,CS:[DATASEG]
        MOV     DS,BP
        MOV     WORD PTR DS:[V_TEMP2],DI

        MOV     BYTE PTR DS:[V_BLK_SIZE],02
;------ TSAI,04-28-92 ----------------------------------
        CMP     BL,BYTE PTR DS:[V_FDD_ID]   ;
        JNE     DSK_VERY1                   ;br,if not FDD

        PUSH    AX
        CALL    FLOPPY_TYPE                 ;check the medium type
        CMP     AL,0                        ;
        MOV     BYTE PTR DS:[V_MSG],AL      ;
        POP     AX
        JNE     DSK_VERYB                   ;error,if cannot find

        CMP     BYTE PTR DS:[V_BLK_SIZE],02
        JE      DSK_VERY1                   ;BR,if blk size=512k

        CMP     BYTE PTR DS:[V_BLK_SIZE],01      ;
        JE      DSK_VERYA                   ;
        MOV     AL,03                       ;
        JMP     VERY_RET                    ;

DSK_VERYA:
        SAL     CX,1
        RCL     DI,1
                                            ;blk len=256 byte,need adjusted
        SAL     AX,1                        ;(DX:AX)*2
        RCL     DX,1
        MOV     WORD PTR DS:[V_TEMP2],DI
        JMP     DSK_VERY1                   ;

DSK_VERYB:
        MOV     AL,BYTE PTR DS:[V_MSG]      ;error code
        JMP     VERY_RET
;------ TSAI,04-28-92 ----------------------------------

DSK_VERY1:
        PUSH    DX
        PUSH    AX
        PUSH    CX
        PUSH    DI
        CALL    DISK_VERY
        CMP     AL,0
        POP     DI
        POP     CX
        POP     AX
        POP     DX
        JNE     VERY_RET                      ;return,if error during filling
        ADD     AX,CX                         ;next start blk adr
        ADC     DX,0
        CMP     DI,0
        JNE     DSK_VERY2                     ;other 64K blk to be verified
        MOV     CX,WORD PTR DS:[V_TEMP2]      ;
        CMP     CX,0
        JE      DSK_VERY3
        MOV     WORD PTR DS:[V_TEMP2],0
        JMP     DSK_VERY1
DSK_VERY3:
        MOV     AL,0
        JMP     VERY_RET                       ;return,if all done
DSK_VERY2:
        DEC     DI
        MOV     CX,0FFFFH
        JMP     DSK_VERY1

VERY_RET:
        POP     BP
        POP     ES
        POP     DS
        RET

        ;----------------------------------------
DISK_VERY:
        CALL    CLEAR_CMD
        MOV     BYTE PTR [SI],2FH               ;operation code
        XCHG    DH,DL
        XCHG    AH,AL
        XCHG    CH,CL
        MOV     WORD PTR [SI+2],DX              ;logical block adr MSB
        MOV     WORD PTR [SI+4],AX              ;logical block adr LSB
        MOV     WORD PTR [SI+7],CX              ;verification length

;       MOV     BYTE PTR [SI+1],02H             ;byte by byte verification
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],10
        CALL    SCSI_MAIN
        CMP     AL,00H
        JE      VERIFY_RET
VERIFY_ERR:
        MOV     DX,WORD PTR DS:[BUFFER+3]
        XCHG    DH,DL
        MOV     CX,WORD PTR DS:[BUFFER+5]
        XCHG    CH,CL
VERIFY_RET:
        RET
;*********************************************************************
;      MODE SENSE COMMAND
;       BL=SCSI device ID
;*********************************************************************
MODE_SENSE:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;# into physical sector
        MOV     BYTE PTR [SI],1AH               ;operation code

        MOV     WORD PTR [SI+4],32H             ;request sense data length
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET
;*********************************************************************
;      MODE SELECT COMMAND
;       BL=SCSI device ID
;       CL=parameter list length
;*********************************************************************
MODE_SELECT:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD
        MOV     BYTE PTR [SI],15H               ;operation code

        MOV     BYTE PTR [SI+4],CL              ;parameter list length
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET

;*********************************************************************
;      fill the desired blocks with specified data
;        BL=SCSI device ID
;        DX:AX=logical block address
;        DI: transfer length(block count MSW)
;        CX: transfer length(block count LSW)
;*********************************************************************
DISK_FILL:
        PUSH    DS
        PUSH    ES
        PUSH    BP
        MOV     BP,CS:[DATASEG]
        MOV     DS,BP
        MOV     WORD PTR DS:[V_TEMP2],DI
        MOV     BYTE PTR DS:[V_BLK_SIZE],02
;------ TSAI,04-28-92 ----------------------------------
        CMP     BL,BYTE PTR DS:[V_FDD_ID]   ;
        JNE     DSK_FIL1                    ;br,if not FDD

        PUSH    AX
        CALL    FLOPPY_TYPE                 ;check the medium type
        CMP     AL,0                        ;
        MOV     BYTE PTR DS:[V_MSG],AL      ;
        POP     AX
        JNE     DSK_FILB                    ;error,if cannot find
                                            ;medium type to fit it
;       CMP     BYTE PTR DS:[V_BLK_SIZE],02
;       JE      DSK_FIL1                    ;BR,if blk size=512k

;       CMP     BYTE PTR DS:[V_BLK_SIZE],01      ;
;       JE      DSK_FILA                    ;
;       MOV     AL,03                       ;
;       JMP     FIL_RET                     ;

DSK_FILA:
;       SAL     CX,1                        ;(DI:CX)*2
;       RCL     DI,1
                                            ;blk len=256 byte,need adjusted
;       SAL     AX,1                        ;(DX:AX)*2
;       RCL     DX,1
;       MOV     WORD PTR DS:[V_TEMP2],DI
        JMP     DSK_FIL1                    ;

DSK_FILB:
        MOV     AL,BYTE PTR DS:[V_MSG]      ;error code
        JMP     FIL_RET
;------ TSAI,04-28-92 ----------------------------------


DSK_FIL1:
        PUSH    DX
        PUSH    AX
        PUSH    CX
        PUSH    DI
        CALL    DSK_FIL
        MOV     BYTE PTR DS:[V_CSB],AL
        CMP     AL,0
        POP     DI
        POP     CX
        POP     AX
        POP     DX
        MOV     AL,BYTE PTR DS:[V_CSB]
        JNE     FIL_RET                       ;return,if error during filling
        ADD     AX,CX                         ;next start blk adr
        ADC     DX,0
        CMP     DI,0                          ;any other 64K blk to be moved
        JNE     DSK_FIL2
        MOV     CX,WORD PTR DS:[V_TEMP2]
        CMP     CX,0
        JE      DSK_FIL3                      ;
        MOV     WORD PTR DS:[V_TEMP2],0       ;
        JMP     DSK_FIL1                      ;
DSK_FIL3:
        MOV     AL,0
        JMP     FIL_RET                       ;return,if all done
DSK_FIL2:
        DEC     DI
        MOV     CX,0FFFFH
        JMP     DSK_FIL1

FIL_RET:

        POP     BP
        POP     ES
        POP     DS
        RET

;===========================================================
DSK_FIL:
        CALL    CLEAR_CMD                    ;clear command buffer block
        MOV     WORD PTR DS:[V_TEMP1],CX

        MOV     BYTE PTR [SI],2AH            ;operation code
        XCHG    DH,DL
        XCHG    AH,AL
        MOV     WORD PTR [SI+2],DX           ;logical block adr MSB,DX
        MOV     WORD PTR [SI+4],AX           ;logical block adr LSB,BX

        XCHG    CH,CL
        MOV     WORD PTR [SI+7],CX           ;transfer length,CX

        MOV     DX,reg_BUS_ID
        MOV     AL,BL                        ;SCSI bus ID
        OUT     DX,AL

        MOV     DX,reg_CMD                   ;flush the FIFO
        MOV     AL,01H                       ;
        OUT     DX,AL

        MOV     SI,CMD_BLOCK                 ;load NCR-53C90 FIFO
        MOV     DX,reg_FIFO                  ;with command block

        MOV     CX,10
FILL_1:
        LODSB
        OUT     DX,AL
        LOOP    FILL_1

        MOV     AL,41H                       ;issue SELECT without ATN
        MOV     DX,reg_CMD                   ;command
        OUT     DX,AL

        CALL    WAIT_INT                     ;wait till SCSI intr
FILL_X:
        MOV     AL,BYTE PTR DS:[INTR_BYTE]
        TEST    AL,20H                       ;check if time out intr
        JZ      FILL_BEG
        MOV     AL,10H                       ;indicate SCSI time out error
        JMP     FILL_RET

FILL_BEG:
        MOV     AL,BYTE PTR DS:[STATUS_BYTE] ;read in status byte
FILL_LOOP:
        AND     AL,07H                       ;only phase bits are concerned
        CMP     AL,00H                       ;check if phase in data out
        JE      FILL_LOOP1

FILL_LOOP3:
        CMP     AL,03
        JNE     FILL_LOOP2
        CALL    PHASE_STATUS
        JMP     FILL_RET                    ;return if all done
FILL_LOOP2:
        MOV     AL,12H                      ;error occurs
        JMP     FILL_RET

FILL_LOOP1:
        MOV     AX,WORD PTR DS:[V_TEMP1]    ;num of blk to be wrote
;------ TSAI,04-28-92 -----------------
        CMP     BYTE PTR DS:[V_BLK_SIZE],02
        JE      FILL_LOOP4                  ;BR,if blk size=512byte
        AND     AX,00FFH                    ;BLK size=256byte
        SHL     AX,08                       ;*256

        MOV     CX,WORD PTR DS:[V_TEMP1]
        SHR     CX,8
        INC     CX
        JMP     FLA
;------ TSAI,04-28-92 -----------------
FILL_LOOP4:
        AND     AX,007FH                    ;*512
        SHL     AX,9                        ;AX=byte count that is not
                                            ;enough to form a 64k blk
        MOV     CX,WORD PTR DS:[V_TEMP1]    ;
        SHR     CX,7                        ;num of 64k blk to be wrote
        INC     CX                          ;
FLA:
        ;------- initial 53C90 transfer counter reg
        MOV     DX,reg_XFER_CNT_LO          ;load 53C90 counter reg with
        OUT     DX,AL                       ;byte counts to be transferd

        MOV     DX,reg_XFER_CNT_HI
        MOV     AL,AH
        OUT     DX,AL

        MOV     AL,98H                       ;issue TRANSFER PAD command
        MOV     DX,reg_CMD                   ;
        OUT     DX,AL
        CALL    WAIT_INT
FLK:
        MOV     AL,BYTE PTR DS:[STATUS_BYTE] ;read in status byte
        AND     AL,07H                       ;only phase bits are concerned
        CMP     AL,00H                       ;still in data out phase ?
        JE      FLB
        JMP     FILL_LOOP3
FLB:
        MOV     AX,0                         ;from now on the next to be
        LOOP    FLA                          ;transfered is 64K
FILL_RET:
        RET
;*************************************************************************
;      request that the target transfer one or more block of data to
;      to the initiator begging with the next block on the logical
;      unit
;      BL= SCSI bus ID
;      CX= transfer length LSW
;*************************************************************************
TAPE_READ:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],08H               ;operation code
        MOV     BYTE PTR [SI+1],01H             ;fixed bit=1,the transfer
        MOV     BYTE PTR [SI+2],0               ;lengths are specified in
        XCHG    CH,CL                           ;block
        MOV     WORD PTR [SI+3],CX
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6

        MOV     AL,1                            ;select memory bank
        MOV     DX,1E08H
        OUT     DX,AL

        XCHG    CH,CL                           ;blk count
        MOV     SI,BUF_2M_BASE                  ;buffer adress
        CALL    INIT_DMA

TAPE_READ2:
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET

;*************************************************************************
;      request that the target write the data that is transfered from
;      the initiator to the current position on the logical unit
;      SI= STARTING ADDRESS
;      BL= SCSI bus ID
;      CX= transfer length
;*************************************************************************
TAPE_WRITE:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        PUSH    DS
        POP     ES

        MOV     DI,CS:[DATASEG]
        MOV     DS,DI
        MOV     DI,SI                           ;temporary save SI in DI

        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],0AH               ;operation code
        MOV     BYTE PTR [SI+1],01H             ;fixed bit=1,the transfer
                                                ;lengths are specified in
                                                ;blk
        MOV     BYTE PTR [SI+2],0               ;transfer length MSB=0
        XCHG    CH,CL                           ;transfer length low word
        MOV     WORD PTR [SI+3],CX              ;
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6    ;

        MOV     AL,1                            ;select memory bank
        MOV     DX,1E08H
        OUT     DX,AL

        XCHG    CH,CL                           ;blk count

        MOV     SI,DI
        CALL    INIT_DMA

        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET

;*************************************************************************
;      request that the target write the specified number of filemarks or
;      setmarks to the current position on the logical unit
;      BL= SCSI bus ID
;      DL= FileMarks Counts,MSB
;      CX= FileMarks Counts,LSW
;*************************************************************************
WRITE_FILEMARKS:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;clear command buffer block
        MOV     BYTE PTR [SI],10H               ;operation code
;       MOV     BYTE PTR [SI+1],01H             ;WSmk(bit 1)=
                                                ; 1:setmarks
                                                ; 0:filemarks
        MOV     BYTE PTR [SI+2],DL              ;lengths are specified in
        XCHG    CH,CL                           ;block
        MOV     WORD PTR [SI+3],CX
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET
;*********************************************************************
;      REWIND the tape
;      BL: SCSI bus ID
;*********************************************************************
REWIND:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],01H               ;operation code
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET
;*************************************************************************
;      request that the target write the data that is transfered from
;      the initiator to the current position on the logical unit
;      BL= SCSI bus ID
;      BH= direction to SPACE(0:forward,1:backward
;      DL= count MSB,0
;      CX= count LSW
;      DH= code
;*************************************************************************
SPACE:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;clear command buffer block

        CMP     BH,0                            ;BR,if space forward
        JE      SPACE_1

        XOR     CX,0FFFFH                       ;2'complement if space backward
        XOR     DL,0FFH
        ADD     CX,1
        ADC     DL,0
        AND     DH,03H

SPACE_1:
        MOV     BYTE PTR DS:[SI],11H            ;operation code
        MOV     BYTE PTR DS:[SI+1],DH           ;0:space by blocks
                                                ;1:space by filemarks
                                                ;2:space by seqential filemarks
                                                ;3:space by end-of-data
        MOV     BYTE PTR DS:[SI+2],DL           ;count MSB
        XCHG    CH,CL
        MOV     WORD PTR DS:[SI+3],CX             ;operation code
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],06H
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET

;*********************************************************************
;      ERASE the tape
;      BL: SCSI bus ID
;*********************************************************************
ERASE:
        PUSH    DS
        PUSH    ES
        PUSH    BP

        CALL    CLEAR_CMD                       ;clear command buffer block

        MOV     BYTE PTR [SI],19H               ;operation code
        MOV     BYTE PTR [SI+1],01H             ;immed=0,Long=1
        MOV     BYTE PTR DS:[SCSI_CMD_LEN],6
        CALL    SCSI_MAIN

        POP     BP
        POP     ES
        POP     DS
        RET
;*********************************************************************
;       SCSI main routine
;
;*********************************************************************
SCSI_MAIN:
       ;program the destination bus ID reg
        MOV     DX,reg_BUS_ID
        MOV     AL,BYTE PTR DS:[V_SCSI_ID]
        OUT     DX,AL

        MOV     DX,reg_CMD                   ;flush the FIFO
        MOV     AL,01H                       ;
        OUT     DX,AL

        MOV     SI,CMD_BLOCK                 ;load NCR-53C90 FIFO
        MOV     DX,reg_FIFO                  ;with command block

        XOR     CH,CH
        MOV     CL,BYTE PTR DS:[SCSI_CMD_LEN]
MAIN_1:
        LODSB
        OUT     DX,AL
        LOOP    MAIN_1

        MOV     AL,41H                       ;issue SELECT without ATN
        MOV     DX,reg_CMD                   ;command
        OUT     DX,AL

        CALL    WAIT_INT                     ;wait till SCSI intr
CHK_PHS:
        MOV     AL,BYTE PTR DS:[INTR_BYTE]
        TEST    AL,20H                       ;check if time out intr
        JZ      CHECK_PHASE
        MOV     AL,10H                       ;indicate SCSI time out error
        JMP     RET2                         ;
CHECK_PHASE:
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[STATUS_BYTE]               ;read in status byte
        AND     AL,07H                       ;only phase bits are concerned

        MOV     SI,AX                        ;according to the phase
        SHL     SI,1                         ;jmp to proper point
        MOV     SI,CS:[SI+OFFSET JMP_LABEL]     ;
        JMP     SI

;===========================================================================

PHASE_DATA_OUT:
        CMP     BYTE PTR DS:[DMA_MODE],01
        JE      DMA_DATA_OUT

        ;------- non DMA mode to transfer data
        MOV     SI,BUFFER
DATAOUT1:
        MOV     AL,BYTE PTR DS:[STATUS_BYTE]
        AND     AL,07H
        CMP     AL,00H                      ;check if phase in data out
        JNE     CHECK_PHASE

        LODSB                               ;prepare data to be wrote in FIFO
        MOV     DX,reg_FIFO
        OUT     DX,AL

        MOV     AL,10H                       ;issue TRANSFER INFORMATION
        MOV     DX,reg_CMD                   ;
        OUT     DX,AL

        CALL    WAIT_INT                     ;wait till SCSI intr
        JMP     DATAOUT1

        ;------- DMA mode to transfer data ----------
DMA_DATA_OUT:
        MOV     AL,80H                       ;issue NOP cmd(DMA mode)
        MOV     DX,reg_CMD
        OUT     DX,AL

        MOV     AL,90H                       ;issue TRANSFER INFORMATION
        MOV     DX,reg_CMD                   ;cmd,ie enable DMA
        OUT     DX,AL

        MOV     DX,DMA_control_B             ;load the adr & length  reg
        MOV     AL,10000101B                 ;value into adr & length counter
        OUT     DX,AL                        ;buffer read ,no intr if parity
        CALL    WAIT_INT                     ;wait till DMA complete
DATAOUT2:
        JMP     CHECK_PHASE
;===========================================================================

PHASE_DATA_IN:

        CMP     BYTE PTR DS:[DMA_MODE],1
        JE      DMA_DATA_IN

        ;------- non DMA mode to transfer data ------
        PUSH    DS
        POP     ES

        MOV     DI,BUFFER
DATAIN1:
        MOV     AL,BYTE PTR DS:[STATUS_BYTE]
        AND     AL,07H
        CMP     AL,01H                      ;check if phase in data in
        JNE     CHECK_PHASE

        MOV     AL,10H                       ;issue TRANSFER INFORMATION
        MOV     DX,reg_CMD                   ;cmd,ie enable DMA
        OUT     DX,AL

        CALL    WAIT_INT                     ;wait till SCSI intr
        MOV     DX,reg_FIFO
        IN      AL,DX                        ;read the byte
        STOSB                                ;store into buffer
        JMP     DATAIN1

        ;------- use DMA to transfer data ------
DMA_DATA_IN:
        MOV     AL,80H                       ;issue NOP cmd(DMA mode)
        MOV     DX,reg_CMD
        OUT     DX,AL

        MOV     AL,90H                       ;issue TRANSFER INFORMATION
        MOV     DX,reg_CMD                   ;cmd,ie enable DMA
        OUT     DX,AL

        MOV     DX,DMA_control_B             ;load the adr & length  reg
        MOV     AL,10001101B                 ;value into adr & length counter
        OUT     DX,AL                        ;buffer write,no intr if parity

        CALL    WAIT_INT                     ;wait till DMA complete
        JMP     CHECK_PHASE
;===========================================================================

PHASE_MSG_OUT:
        JMP     CHECK_PHASE
;===========================================================================

PHASE_MSG_IN:
        MOV     DX,reg_CMD                   ;issue transfer info command
        MOV     AL,10H
        OUT     DX,AL

        CALL    WAIT_INT                     ;wait till SCSI intr

        MOV     DX,reg_FIFO
        IN      AL,DX                        ;read in message

        CMP     AL,02
        JNE     MSG_1                        ;SAVE PTRS message
        MOV     DX,reg_CMD                   ;issue accept message
        MOV     AL,12H
        OUT     DX,AL

        CALL    WAIT_INT
        JMP     CHECK_PHASE
MSG_1:
        CMP     AL,04H
        JE      MSG_2
        JMP     CHECK_PHASE
MSG_2:
                                             ;DISCONNECT message
        MOV     DX,reg_CMD                   ;issue accept message
        MOV     AL,12H
        OUT     DX,AL
        CALL    WAIT_INT

        MOV     DX,reg_CMD
        MOV     AL,44H
        OUT     DX,AL                        ;issue enable selection command

        CALL    WAIT_INT

        MOV     DX,reg_FIFO                  ;
        IN      AL,DX                        ;get reselection ID
        JMP     $+2                          ;delay
        IN      AL,DX                        ;get identify msg

        MOV     DX,reg_CMD                   ;issue accept message
        MOV     AL,12H
        OUT     DX,AL
        CALL    WAIT_INT

        JMP     CHECK_PHASE
;===========================================================================

PHASE_STATUS:
        MOV     DX,reg_CMD
        MOV     AL,11H                          ;issue cmd complete command
        OUT     DX,AL
PHS_STA:
        CALL    WAIT_INT                        ;wait till SCSI intr occured

        MOV     DX,reg_FIFO
        IN      AL,DX                           ;read in status byte
        MOV     BYTE PTR DS:[V_CSB],AL                        ;save it

        JMP     $+2                             ;delay
        IN      AL,DX                           ;read in MSG byte
        MOV     BYTE PTR DS:[V_MSG],AL          ;save it

        MOV     DX,reg_CMD
        MOV     AL,12H
        OUT     DX,AL                           ;issue MSG accept command
PHS_STA1:
        CALL    WAIT_INT                        ;wait till SCSI intr occurred
RET1:
        MOV     AL,BYTE PTR DS:[V_CSB]
        CMP     AL,00H
        JE      RET2
        MOV     BL,BYTE PTR DS:[V_SCSI_ID]
        CALL    RQST_SENSE
RET2:
        RET
;===========================================================================
SHIFT_RESET:                                    ;SHIFT RESET detected
        MOV     DX,reg_CMD                      ;handle it
        MOV     AL,03H                          ;issue SCSI BUS RESET
        OUT     DX,AL

        MOV     CX,0
        LOOP    $

        MOV     CX,0
        LOOP    $

        MOV     CX,0
        LOOP    $

        MOV     CX,0
        LOOP    $

;       MOV     BL,BYTE PTR DS:[V_SCSI_ID]
        MOV     BL,0
        MOV     CX,08H
SHF_RSTC:
        PUSH    CX
        MOV     CX,05H
SHF_RSTA:
        PUSH    BX
        PUSH    CX
        CALL    TEST_UNIT_READY
        POP     CX
        POP     BX
        CMP     AL,00H                 ;BR,if unit ready
        JE      SHF_RSTB
        PUSH    BX
        PUSH    CX
        CALL    RQST_SENSE             ;read out error code
        POP     CX
        POP     BX
        LOOP    SHF_RSTA               ;try again

SHF_RSTB:
        POP     CX
        INC     BL
        LOOP    SHF_RSTC
        RET
ERROR_PHASE:
        HLT

;********************************************************************
;       clear command block,and set DS to DATA
;*********************************************************************
CLEAR_CMD:

        MOV     SI,CS:[DATASEG]
        MOV     DS,SI

        MOV     BYTE PTR DS:[DMA_MODE],00H
        MOV     BYTE PTR DS:[V_SCSI_ID],BL          ;temporary save SCSI ID
CLEAR_CMD1:
        MOV     SI,CMD_BLOCK
        MOV     WORD PTR DS:[SI],0
        MOV     WORD PTR DS:[SI+2],0
        MOV     WORD PTR DS:[SI+4],0
        MOV     WORD PTR DS:[SI+6],0
        MOV     WORD PTR DS:[SI+8],0
        RET
;*********************************************************************
;       init DMA for data transfer
;       SI=buffer address
;       CX=transfer length
;*********************************************************************
INIT_DMA:
        ;------- initial DMA adr reg -----------
        MOV     AL,0                         ;lo byte always 0
        MOV     DX,DMA_adr_lo_B              ;write the starting buffer adr
        OUT     DX,AL                        ;to DMA

        MOV     AX,SI
        MOV     DX,DMA_adr_mid_B
        OUT     DX,AL

        MOV     DX,DMA_adr_hi_B
        MOV     AL,AH
        OUT     DX,AL

        ;------- initial DMA length reg -------
        SHL     CX,09H                      ;blk num*512=byte num
        MOV     DX,DMA_len_lo_B
        MOV     AL,CL
        OUT     DX,AL

        MOV     DX,DMA_len_mid_B
        MOV     AL,CH
        OUT     DX,AL

        MOV     DX,DMA_len_hi_B
        MOV     AL,00H
        OUT     DX,AL

        ;------- initial 53C90 transfer counter reg
        MOV     DX,reg_XFER_CNT_LO
        MOV     AL,CL
        OUT     DX,AL

        MOV     DX,reg_XFER_CNT_HI
        MOV     AL,CH
        OUT     DX,AL
        MOV     BYTE PTR DS:[DMA_MODE],1
        RET

;*********************************************************************
;       mov data between 256K RAM  and cache 2M
;       AL: memory bank no
;       CX: num of sector be moved
;       ES: buffer segment in 256K RAM area
;       SI: buffer offset in 256K ram area
;       BP: buffer offset in 2M ram area
;       BL=0,from 256K RAM to 2M cache
;          1,from 2M cache to 256K RAM
;*********************************************************************
MOV_DATA:
         MOV       DX,1E08H
         OUT       DX,AL

         MOV       AL,00H                   ; start address low
         MOV       DX,1208h                 ;
         OUT       DX,AL

         MOV       AX,BP                    ; start address middle
         MOV       DX,120ah
         OUT       DX,AL

         MOV       AL,AH                    ; start address hi
         MOV       DX,120ch
         OUT       DX,AL

         SHL       CX,8                     ;*256
         MOV       AX,CX

         MOV       DX,120eh                 ;length lo
         OUT       DX,AL

         MOV       AL,AH
         MOV       DX,1210H                 ;length middle
         OUT       DX,AL

         MOV       AL,00H                   ;length hi
         MOV       DX,1212h
         OUT       DX,AL

         CMP       BL,1
         JE        WATB

         PUSH      DS

         PUSH      ES
         POP       DS

         MOV       DX,1206h                 ; b7:1, addr.& length counter to be
         MOV       AL,10001100B             ;       loaded from their
         OUT       DX,AL                    ; b6:0, addr counter to be copied to the addr regs
                                            ; b5:0, length counter NOT to be copied to the addr regs.
                                            ; b4:0, CTR Hold
                                            ; b3:1, write ; b2:1, enable
                                            ; b1:0, disable, b0:0 interrupt disable
STADR:   MOV       DX,1000H
         REP       OUTSB
         POP       DS

         MOV       DX,1202H                 ;read in status byte
         IN        AL,DX
;        TEST      AL,10H                   ; read b4:1 block transfer complete
;        JZ        WATA
         RET

WATB:
         MOV       DX,1206H                 ; b7:1, addr.& length counter to be
         MOV       AL,10000100B             ;       loaded from their
                                            ;       espective regs.
         OUT       DX,AL                    ; b6:1, addr counter to be copied to the addr regs

         MOV       DI,SI
         MOV       DX,1000H
         REP       INSB
         MOV       DX,1202H
         IN        AL,DX
         RET
