        .list
        .286
        Page 62,132

include ..\REL\scsiequ.asi

Rstseg  Segment
        Assume  CS:Rstseg

        org     0fff0h
Reset:  jmp     Begin1
        jmp     Begin
        db      9 dup (00h)

        org     0c000h
Begin1:
        mov     ax,0
        mov     ds,ax
        mov     byte ptr ds:[DG],0
Begin:

include scsidiag.asm                    ;Diagnostic Code

MAIN:   JMP     START1                  ;clear Interrupt
DATASEG DW      0000H
START1: CLI                             ;clear Interrupt
        CALL    SCSI_INIT               ;Init SCSI Controller
        STI
ROM_START:
        MOV     AX,0000H
        MOV     DS,AX                   ;set data stack segment for 0
        MOV     AX,3000H
        MOV     ES,AX
        MOV     SS,AX
        MOV     AX,Stack_Ptr
        MOV     SP,AX                   ;init stack pointer

        OR      BYTE PTR DS:[EPROM_MODE],0F0H   ;Set to EPROM Mode

        MOV     WORD PTR DS:[MEMORY_SIZE],256    ;set memory size 256 KB

        MOV     AX,CS

        MOV     BX,ROM_ENTRY
        MOV     WORD PTR DS:[BX+2],AX
        MOV     AX,OFFSET ROM_START
        MOV     WORD PTR DS:[BX],AX

        MOV     DX,1C00H
        IN      AL,DX
        xor     al,0ffh
        mov     ah,0
        test    al,01h
        jz      y1
        or      ah,80h
y1:     test    al,02h
        jz      y2
        or      ah,40h
y2:     test    al,04h
        jz      y3
        or      ah,20h
y3:     test    al,08h
        jz      y4
        or      ah,10h
y4:     test    al,10h
        jz      y5
        or      ah,08h
y5:     test    al,20h
        jz      y6
        or      ah,04h
y6:     test    al,40h
        jz      y7
        or      ah,02h
y7:     test    al,80h
        jz      y8
        or      ah,01h
y8:
        mov     al,ah
        and     al,0fh
        or      al,10h

        MOV     BYTE PTR DS:[PRINTER_ID],AL      ;SET PRINTER SWITCH ID
        MOV     BYTE PTR ES:[CACHE_ON],1         ;SET CACHE ON
        TEST    AH,10H
        JZ      MAIN1
        MOV     BYTE PTR ES:[CACHE_ON],0         ;SET CACHE OFF
MAIN1:

        MOV     AX,WORD PTR DS:[MEMORY_SIZE]
        SUB     AX,128

        SHL     AX,1                             ;Change to sector
        SHL     AX,1
        MOV     WORD PTR DS:[BUFFER_SIZE],AX

        MOV     BYTE PTR DS:[MAX_PART_NO],1      ;SET MAX PART NO

        MOV     BX,BASE                          ;SET BASE OF BUFFER

        MOV     WORD PTR DS:[BX],1000H           ;BASE SEGMENT
        MOV     WORD PTR DS:[BX+2],0000H         ;BASE OFFSET

        MOV     BX,DATA_BASE                     ;SET DATA BASE FOR 386
        MOV     WORD PTR DS:[BX],BUFFER_START_L
        MOV     WORD PTR DS:[BX+2],BUFFER_START_H

        MOV     BX,PRINT_START_R
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRINT_END_R
        MOV     WORD PTR DS:[BX],PRT_BUFFER_END
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRT_START
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,PRT_END
        MOV     WORD PTR DS:[BX],PRT_BUFFER_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,CMD_BASE
        MOV     WORD PTR DS:[BX],RCB
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,RAM_DL_ENTRY
        MOV     WORD PTR DS:[BX],CODE_START
        MOV     WORD PTR DS:[BX+2],0000H

        MOV     BX,RAM_ENTRY
        MOV     WORD PTR DS:[BX],0000H
        MOV     AX,CODE_START
        SHR     AX,1
        SHR     AX,1
        SHR     AX,1
        SHR     AX,1
        MOV     WORD PTR DS:[BX+2],AX

        MOV     BYTE PTR DS:[PART_NO],0          ;POLLING FROM PARTITION 0

        MOV     BYTE PTR DS:[RESET_FLAG],0FFH    ;NO RESET COMING ON INIT
        MOV     AX,RCB
        MOV     BP,AX
        MOV     WORD PTR DS:[SAVE_BP],BP
        MOV     BYTE PTR DS:[BP].@STATUS,0
        MOV     BYTE PTR DS:[BP+1FH],0
        mov     byte ptr ds:[V_FDD_ID],0ffh

        CALL    Build_Config
;       CALL    Scsi_Floppy_HDX
;       CALL    Build_Config
        CALL    CINIT

MAIN_PROCESS:
        MOV     BYTE PTR DS:[ACT_PART_NO],0FFH
        CALL    BREAK
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     CL,5
        SHL     AX,CL
        ADD     AX,RCB                          ;CALCULATE RCB
        MOV     BP,AX
        MOV     WORD PTR DS:[SAVE_BP],BP

        CMP     BYTE PTR DS:[BP].@STATUS,0      ;CHECK RCB STATUS
        JE      PROCESS_NEXT1                   ;BR, IF NO REQUEST

        MOV     BX,OFFSET JMP_TAB               ;GET JMP TABLE

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@REQCODE    ;GET REQUEST CODE
        CMP     AL,20H
        JAE     PROCESS_NEXT2
        SHL     AX,1
        ADD     BX,AX

        MOV     AL,BYTE PTR DS:[PART_NO]
        MOV     BYTE PTR DS:[ACT_PART_NO],AL

        JMP     WORD PTR CS:[BX]                ;JMP TO ROUTINE

PROCESS_NEXT2:
        MOV     BP,WORD PTR DS:[SAVE_BP]
        MOV     BYTE PTR DS:[BP].@ERROR,94H     ;ERROR FOR ILLEGAL REQUEST CODE
PROCESS_NEXT:
        MOV     BP,WORD PTR DS:[SAVE_BP]
        MOV     BYTE PTR DS:[BP].@STATUS,0      ;RESET RCB STATUS
PROCESS_NEXT1:
        MOV     BP,WORD PTR DS:[SAVE_BP]
        INC     BYTE PTR DS:[PART_NO]           ;INCREMENT PARTITION NO
        MOV     AL,BYTE PTR DS:[MAX_PART_NO]
        CMP     BYTE PTR DS:[PART_NO],AL        ;CHECK MAX. PARTITION
        JNE     PROCESS_X
        MOV     BYTE PTR DS:[PART_NO],0         ;RESET PATITION NO IF MAX.
PROCESS_X:
        JMP     MAIN_PROCESS                    ;PROCESS NEXT

JMP_TAB DW      OFFSET NULL_COMMAND             ;0
        DW      OFFSET READ_SECTOR              ;1
        DW      OFFSET NULL_COMMAND             ;2
        DW      OFFSET NULL_COMMAND             ;3
        DW      OFFSET NULL_COMMAND             ;4
        DW      OFFSET NULL_COMMAND             ;5
        DW      OFFSET NULL_COMMAND             ;6
        DW      OFFSET NULL_COMMAND             ;7
        DW      OFFSET NULL_COMMAND             ;8
        DW      OFFSET NULL_COMMAND             ;9
        DW      OFFSET NULL_COMMAND             ;0A
        DW      OFFSET NULL_COMMAND             ;0B
        DW      OFFSET NULL_COMMAND             ;0C
        DW      OFFSET SWITCH_RAM               ;0D
        DW      OFFSET NULL_COMMAND             ;0E
        DW      OFFSET NULL_COMMAND             ;0F
        DW      OFFSET NULL_COMMAND             ;10
        DW      OFFSET NULL_COMMAND             ;11
        DW      OFFSET NULL_COMMAND             ;12
        DW      OFFSET NULL_COMMAND             ;13
        DW      OFFSET NULL_COMMAND             ;14
        DW      OFFSET NULL_COMMAND             ;15
        DW      OFFSET NULL_COMMAND             ;16
        DW      OFFSET NULL_COMMAND             ;17
        DW      OFFSET NULL_COMMAND             ;18
        DW      OFFSET NULL_COMMAND             ;19
        DW      OFFSET NULL_COMMAND             ;1A
        DW      OFFSET NULL_COMMAND             ;1B
        DW      OFFSET NULL_COMMAND             ;1C
        DW      OFFSET NULL_COMMAND             ;1D
        DW      OFFSET NULL_COMMAND             ;1E
        DW      OFFSET WARM_START               ;1F

READ_SECTOR:
        MOV     AX,WORD PTR DS:[BP].@SECTOR_COUNT      ;GET TOTAL SECTOR NO TO BE READ
        MOV     WORD PTR DS:[SECTOR_COUNT],AX

        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[BP].@ADDR1
        MOV     WORD PTR DS:[ADDR_HIGH],AX
        MOV     AH,BYTE PTR DS:[BP].@ADDR2
        MOV     AL,BYTE PTR DS:[BP].@ADDR3
        MOV     WORD PTR DS:[ADDR_LOW],AX

        MOV     AX,WORD PTR DS:[BP].@PLATTER
        MOV     WORD PTR DS:[ACTDEV],AX
        CALL    GET_BUFFER_PTR

READ_AGAIN:
        CALL    DREAD                                  ;DO READ SECTOR ACTION
        DEC     WORD PTR DS:[SECTOR_COUNT]             ;DECREMENT SECTOR COUNT
        JZ      READ_SECTOR_END                        ;BR, IF COMPLEMENT
        CALL    ADD_SECTOR_ADDR                        ;INCREMENT SECTOR ADDRESS
        CALL    SET_NEXT_BUFFER_PTR                    ;SET NEXT BUFFER POINTER
        JMP     READ_AGAIN                             ;BR, TO READ AGAIN

READ_SECTOR_END:
        MOV     AX,WORD PTR DS:[ACTDEV]
        MOV     WORD PTR DS:[BP].@PLATTER,AX
        MOV     BYTE PTR DS:[BP].@ERROR,0
        JMP     PROCESS_NEXT

SWITCH_RAM:
        MOV     BYTE PTR DS:[BP].@STATUS,00H
        MOV     BYTE PTR DS:[BP].@ERROR,00H
        CALL    CINIT
        MOV     BX,RAM_ENTRY
        JMP     DWORD PTR DS:[BX]                      ;SWITCH TO RAM

WARM_START:
        MOV     BYTE PTR DS:[BP].@STATUS,0
        MOV     BYTE PTR DS:[BP].@ERROR,0
        CALL    CINIT
        DB      0EAH
        DW      0FFF3H
        DW      0F000H

NULL_COMMAND:
        JMP     PROCESS_NEXT2


DREAD:
        CALL    CHK_SECTOR
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        MOV     CL,BYTE PTR DS:[PLAT_NO]
        CALL    CHK_CACHE
        CMP     BX,NULL_NODE
        JE      DREAD1
        CALL    CHITUPDATE
DREAD5:
        TEST    WORD PTR DS:[ADDR_LOW],01H
        JZ      DREAD2
        INC     BX
DREAD2:
        MOV     AL,0
        MOV     DX,BANKPORT
        OUT     DX,AL
        CMP     BX,4096
        JB      DREAD3
        SUB     BX,4096
        MOV     AL,1
        OUT     DX,AL
DREAD3:
        MOV     AL,00H          ;SET ADDRESS
        MOV     DX,1208H
        OUT     DX,AL
        MOV     AL,BL
        MOV     DX,120AH
        OUT     DX,AL
        MOV     AL,BH
        MOV     DX,120CH
        OUT     DX,AL

        MOV     AL,0            ;SET LENGTH
        MOV     DX,120EH
        OUT     DX,AL
        MOV     AL,1
        MOV     DX,1210H
        OUT     DX,AL
        MOV     AL,0
        MOV     DX,1212H
        OUT     DX,AL

        MOV     DX,1206H        ;LOAD REGISTER
        MOV     AL,10000100B
        OUT     DX,AL

        MOV     AX,WORD PTR DS:[BUFFER_SEG]     ;START TRANSFER
        MOV     ES,AX
        MOV     DI,WORD PTR DS:[BUFFER_PTR]
        MOV     CX,100H
        MOV     DX,1000H
        REP     INSB

        MOV     DX,1202H
        IN      AL,DX

        MOV     AX,3000H
        MOV     ES,AX
        RET

DREAD1:
        CALL    CALLOC
        CALL    CMISSUPDATE
        PUSH    BX
        MOV     SI,BX
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        MOV     BH,0
        CMP     SI,4096
        JB      DREAD4
        SUB     SI,4096
        MOV     BH,1
DREAD4:
        MOV     DX,WORD PTR DS:[BLOCK_HIGH]
        MOV     AX,WORD PTR DS:[BLOCK_LOW]
        MOV     CX,1
        CALL    DISK_READ
        CMP     AL,0
        JNE     DISK_ERR_M1
        POP     BX
        JMP     DREAD5


CHK_SECTOR:
        MOV     DX,WORD PTR DS:[ACTDEV]
        CALL    GET_PLATNO
        MOV     WORD PTR DS:[ACTDEV],DX
        MOV     BYTE PTR DS:[PLAT_NO],BL
        MOV     CL,4
        SHL     BX,CL
        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
        JE      ERROR_91
        MOV     DX,WORD PTR DS:[ADDR_HIGH]
        CMP     DX,WORD PTR DS:System_Config2[bx].D_Platter_Len_H
        JA      ERROR_98
        MOV     AX,WORD PTR DS:[ADDR_LOW]
        JB      CHK_SECTOR3
        CMP     AX,WORD PTR DS:System_Config2[bx].D_Platter_Len_L
        JA      ERROR_98
CHK_SECTOR3:
        ADD     AX,WORD PTR DS:System_Config2[bx].D_Platter_Start_L
        ADC     DX,WORD PTR DS:System_Config2[bx].D_Platter_Start_H
        CLC
        RCR     DX,1
        RCR     AX,1
        MOV     WORD PTR DS:[BLOCK_HIGH],DX
        MOV     WORD PTR DS:[BLOCK_LOW],AX
        MOV     AL,BYTE PTR DS:System_Config2[bx].D_Id
        MOV     BYTE PTR DS:[DEVICE_ID],AL
        TEST    BYTE PTR DS:System_Config2[bx].D_Type,80h
        JZ      CHK_SECTOR1
CHK_SECTOR2:
        MOV     BL,BYTE PTR DS:[DEVICE_ID]
        CALL    TEST_UNIT_READY
        CMP     AL,00H
        JE      CHK_SECTOR1
        CMP     AL,06H
        JNE     DISK_ERR_M
        MOV     AL,BYTE PTR DS:[DEVICE_ID]
        CALL    CINVALPLAT
        JMP     CHK_SECTOR2
CHK_SECTOR1:
        RET

disk_err_m1:
        jmp     disk_err_m

ERROR_91:
        MOV     AL,91H
        JMP     DISK_ERR
ERROR_98:
        MOV     AL,98H
        JMP     DISK_ERR

DISK_ERR:
        MOV     BYTE PTR DS:[BP].@ERROR,AL
        MOV     SP,STACK_PTR
        JMP     PROCESS_NEXT

DISK_ERR_M:
        CMP     AL,0FH
        JBE     DISK_ERR_M9
        MOV     AL,0
DISK_ERR_M9:
        XOR     AH,AH
        SHL     AX,1
        MOV     BX,OFFSET ERR_JUMP
        ADD     BX,AX
        JMP     WORD PTR CS:[BX]

ERR_JUMP:
        DW      OFFSET ERROR_00                 ;00
        DW      OFFSET ERROR_01                 ;01
        DW      OFFSET ERROR_02                 ;02
        DW      OFFSET ERROR_03                 ;03
        DW      OFFSET ERROR_04                 ;04
        DW      OFFSET ERROR_05                 ;05
        DW      OFFSET ERROR_06                 ;06
        DW      OFFSET ERROR_07                 ;07
        DW      OFFSET ERROR_08                 ;08
        DW      OFFSET ERROR_09                 ;09
        DW      OFFSET ERROR_0A                 ;0A
        DW      OFFSET ERROR_0B                 ;0B
        DW      OFFSET ERROR_0C                 ;0C
        DW      OFFSET ERROR_0D                 ;0D
        DW      OFFSET ERROR_0E                 ;0E
        DW      OFFSET ERROR_0F                 ;0F

ERROR_00:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_01:
        MOV     AL,96H
        JMP     DISK_ERR
ERROR_02:
        MOV     AL,98H
        JMP     DISK_ERR
ERROR_03:
        MOV     AL,98H
        JMP     DISK_ERR
ERROR_04:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_05:
        MOV     AL,94H
        JMP     DISK_ERR
ERROR_06:
        MOV     AL,94H
        JMP     DISK_ERR
ERROR_07:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_08:
        MOV     AL,93H
        JMP     DISK_ERR
ERROR_09:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_0A:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_0B:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_0C:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_0D:
        MOV     AL,95H
        JMP     DISK_ERR
ERROR_0E:
        MOV     AL,96H
        JMP     DISK_ERR
ERROR_0F:
        MOV     AL,95H
        JMP     DISK_ERR

ERROR_91G:
        JMP     ERROR_91

;SCSI_FLOPPY_HDX:
;        XOR     BX,BX
;        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
;        JE      SCSI_FLOPPY_HD5
;
;SCSI_FLOPPY_HD2:
;        XOR     BX,BX
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        CALL    TEST_UNIT_READY
;        CMP     AL,00H
;        JE      SCSI_FLOPPY_HD1
;        CMP     AL,06H
;        JNE     SCSI_FLOPPY_HD1
;        MOV     AL,0
;        CALL    CINVALPLAT
;        JMP     SCSI_FLOPPY_HD2
;SCSI_FLOPPY_HD1:
;        XOR     BX,BX
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        MOV     BH,01H
;        CALL    SET_FLOPPY
;
;        MOV     BX,256
;        CMP     BYTE PTR DS:System_Config2[bx].D_Type,0FFH
;        JE      SCSI_FLOPPY_HD5
;
;SCSI_FLOPPY_HD4:
;        MOV     BX,256
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        CALL    TEST_UNIT_READY
;        CMP     AL,00H
;        JE      SCSI_FLOPPY_HD3
;        CMP     AL,06H
;        JNE     SCSI_FLOPPY_HD3
;        MOV     AL,10H
;        CALL    CINVALPLAT
;        JMP     SCSI_FLOPPY_HD4
;SCSI_FLOPPY_HD3:
;        MOV     BX,256
;        MOV     BL,BYTE PTR DS:System_Config2[bx].D_Id
;        MOV     BH,01H
;        CALL    SET_FLOPPY
;SCSI_FLOPPY_HD5:
;        RET
;

DISK_ERR_M8Y:
        JMP     DISK_ERR_M


; BREAK: BREAK FOR CHECK INTERUPT FROM CS/386
;

BREAK:
        CMP     BYTE PTR DS:[RESET_FLAG],0FFH
        JE      BREAK1
        PUSH    AX
        PUSH    BX
        XOR     BX,BX
        MOV     BL,BYTE PTR DS:[RESET_FLAG]
        MOV     BYTE PTR DS:[RESET_FLAG],0FFH
        CMP     BL,BYTE PTR DS:[ACT_PART_NO]
        JNE     BREAK2
        CMP     BYTE PTR DS:[SHIFT_RESET_FLAG],0
        JE      BREAK2X
        MOV     BP,WORD PTR DS:[SAVE_BP]
        MOV     BYTE PTR DS:[BP].@STATUS,0
        CALL    SHIFT_RESET

        MOV     BYTE PTR DS:[SHIFT_RESET_FLAG],0
BREAK2X:
        MOV     BX,Stack_Ptr
        MOV     SP,BX
        MOV     AX,3000H
        MOV     ES,AX
        JMP     PROCESS_NEXT

BREAK2: CMP     BYTE PTR DS:[ACT_PART_NO],0FFH
        JNE     BREAK3
        POP     BX
        POP     AX
        RET
BREAK3:
        SHL     BX,1
        SHL     BX,1
        SHL     BX,1
        SHL     BX,1
        SHL     BX,1
        ADD     BX,RCB
        MOV     BYTE PTR DS:[BX].@STATUS,0
        POP     BX
        POP     AX
BREAK1:
        RET

SERVICE_PRINT:
        RET


;GET_BUFFER_PTR : GET BUFFER POINTER ACCORDING TO PART_NO
;

GET_BUFFER_PTR:
        MOV     BX,BASE                         ;POINT TO BUFFER BASE OF PART_NO
        XOR     AX,AX
        MOV     AL,BYTE PTR DS:[PART_NO]
        SHL     AX,1
        SHL     AX,1
        ADD     BX,AX
        MOV     AX,WORD PTR DS:[BX]             ;GET SEGMENT OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_SEG],AX
        MOV     AX,WORD PTR DS:[BX+2]           ;GET OFFSET OF BUFFER PTR
        MOV     WORD PTR DS:[BUFFER_PTR],AX
        RET

;SET_NEXT_BUFFER_PTR : ADD 256 OF CURRENT BUFFER POINTER
;

SET_NEXT_BUFFER_PTR:
        ADD     WORD PTR DS:[BUFFER_PTR],256
        CMP     WORD PTR DS:[BUFFER_PTR],0
        JNE     SET_RET
        ADD     WORD PTR DS:[BUFFER_SEG],1000H
SET_RET:
        RET

; ADD_SECTOR_ADDR: INCREMENT SECTOR ADDRESS
;

ADD_SECTOR_ADDR:
        ADD     WORD PTR DS:[ADDR_LOW],1       ;INCREMENT SECTOR ADDRESS
        ADC     WORD PTR DS:[ADDR_HIGH],0
        RET

include ..\REL\cache.asm
include ..\REL\scsi.asm

Rstseg  ends
        end
