NAME    TESTDISK
STACK   STACKSEG        100
taskdummy    segment  rw
        db      1
taskdummy       ends
;
gdtdummy    segment  rw
        db      1
gdtdummy       ends
;
ldtdummy    segment  rw
        db      1
ldtdummy       ends
;
ldtdata    segment  rw
        db      1
ldtdata       ends
;
        public  datastart
;
DATA     SEGMENT   RW
        org     8
;        CS-386 REGISTERS
;
R0        DB       11h          ; Note the order of these registers.
R1        DB       22h          ; We give the value of R0,R1 for looking map
R2        DB       0            ; These followed the Intel convention.
R3        DB       0
R4        DB       0            ; R0 - R7 are actually F0 - F7.
R5        DB       0
R6        DB       0
R7        DB       0

SL        DB       0            ; SH & SL will possibly be seperated.
SH        DB       0            ; SH could be memory mapped I/O port.
K         DB       0            ; K register replacement.

AUX00     DW       0
AUX01     DW       0
AUX02     DW       0
AUX03     DW       0
AUX04     DW       0
AUX05     DW       0
AUX06     DW       0
AUX07     DW       0
AUX08     DW       0
AUX09     DW       0
AUX0A     DW       0
AUX0B     DW       0
AUX0C     DW       0
AUX0D     DW       0
AUX0E     DW       0
AUX0F     DW       0
AUX10     DW       0
AUX11     DW       0
AUX12     DW       0
AUX13     DW       0
AUX14     DW       0
AUX19     DW       0
AUX1A     DW       0
AUX1D     DW       0

;
;        CS-386 MEMORY MAP I/O
;
; we set (FS).base=0ffff8000h and the i/o port all relative to (FS)
;
TIMSET   EQU       000H            ;8 BIT VALUE EACH UNIT WITH 120 US
CPUST    EQU       002H            ;READ BACK CPU AND IO STATUS
                                         ;D0 = 5US PULSE
                                         ;D1 = CPU BUSY
                                         ;D2 = KEY BOARD FUNCTION
                                         ;D3 = I/O READY
                                         ;D4 = TIME OUT ( 30MS)
                                         ;D5 = CPU HALT
                                         ;D6 = SRAM PARITY ERROR
                                         ;D7 = DRAM PARITY ERROR

CPUFLG   EQU       004H  ;CPU FLAG
CPURDY   EQU       006H  ;RELEASE CPU BUSY
RTCADDR  EQU       008H
RTCDATA  EQU       00AH
IBGET    EQU       00CH  ;GET INPUT BUS DATA
_ABS     EQU       012H  ;ADDRESS BUS STROBE
OBS      EQU       014H  ;OUTPUT DATA BUS STROBE
CBS      EQU       018H  ;COMMAND DATA BUS STROBE
IOBS     EQU       00eH  ;DISK LATCH

;*         BOOT EQUATES
;
FF              EQU     0FFH    ;CONSTANT FF
ZERO            EQU     0000H   ;ZERO PC'S
_50MS           EQU     5B01H   ;WAIT 50 MILLISECONDS
_5SEC           EQU     6B5BH

;*  SL USAGE:
;*
INPUTDUN        EQU     10H     ;INPUT 3 CHARACTERS ALREADY; NO MORE
;INPTDUN         EQU     1H      ;(INPUTDUN HIGH)
NAMEMODE        EQU     08H     ;NAME MODE
;MIDINPUT        EQU     INPUTDUN+NAMEMODE
;FSMODE          EQU     04H     ;FIELD SERVICE MODE
;CMBLOCK         EQU     02H     ;CONTROL MEMORY BLOCK LOADED
;CMDMBLOK        EQU     01H     ;CONTROL/DATA MEMORY BLOCK LOADED

;*SH USAGE:
;*
NOPARITY        EQU     80H     ;INHIBIT PARITY ERROR TRAPS
PE              EQU     40H     ;PARITY ERROR DETECTED
PARERR          EQU     4H      ;(PE HIGH)
DR              EQU     08H     ;DEVICE READY
ENDI            EQU     04H     ;ENDI INPUT BIT
CPB             EQU     02H     ;CPU BUSY (INHIBIT INPUT)
CA              EQU     01H     ;CARRY

;*  AUX REGISTER EQUATES
;*      The following equates are required to agree with
;*      the programs loaded by this bootstrap.
ACTDEV          EQU     AUX1A   ;ACT DEVICE = AUX 1A
X1D             EQU     AUX1D   ;function key pressed during F.S. menu

;*    The following equates are local to the bootstrap
X0      EQU     AUX00   ;LOCAL VALUE, WCM LOW PART OF INSTRUCTION
X1      EQU     AUX01   ;USED BY INIT24, WRTRAPS
X2      EQU     AUX02   ;end oF VERIFY SECTION
X3      EQU     AUX03   ;end oF MEMORY
XC      EQU     AUX0C   ;SIZE OF INDEX, READ ADDRESS DURING LOAD
XD      EQU     AUX0D   ;WRITE ADDRESS DURING LOAD
XF      EQU     AUX0F   ;USED FOR SECTOR ADDRESS

;message         equ     500h
;DISKWORK        EQU     600H              ;DISK LOAD SECTOR AREA
;DISKWORK256     EQU     700H
message         equ     700h
DISKWORK        EQU     800H              ;DISK LOAD SECTOR AREA
DISKWORK256     EQU     900H
xdata           equ    1000h            ;@boot load here, now will be 4K large
bootdev equ     28h
resetproc       dd   0
index1          dw   0

mxfbuf_sts	dd   0		       ;M  Milton Chen modify sign 'M',06/28/91
mxfbuf_abs	dd   0		       ;M
mxfbuf_parm	dd   0		       ;M


ROOTNODE DB       '@BOOT'

;XDATA    DB        512 DUP(0)


INSTRMSG DB        23H,'Select item with SPACE & BACKSPACE.'

mountmsg db        03h,05h,'MOUNT SYSTEM PLATTER',0dh,0ah       ;22 char.
         db        'PRESS RESET',0dh,0ah                        ;13 char. = 35
mountmsg_len equ $ - mountmsg

sfkeymsg db        03h,05h,'KEY SF',27h,'? '                    ;11 char.
sfkeymsg_len equ $ - sfkeymsg

;loadmsg in @MVP file

;menumsg in @@ file

filemsg0 db        03h,07h,'*** SYSTEM ERROR (DISK 0090) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg1 db        03h,07h,'*** SYSTEM ERROR (DISK 0091) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg2 db        03h,07h,'*** SYSTEM ERROR (DISK 0092) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg3 db        03h,07h,'*** SYSTEM ERROR (DISK 0093) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg4 db        03h,07h,'*** SYSTEM ERROR (DISK 0094) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg5 db        03h,07h,'*** SYSTEM ERROR (DISK 0095) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg6 db        03h,07h,'*** SYSTEM ERROR (DISK 0096) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg7 db        03h,07h,'*** SYSTEM ERROR (DISK 0097) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg8 db        03h,07h,'*** SYSTEM ERROR (DISK 0098) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg9 db        03h,07h,'*** SYSTEM ERROR (DISK 0099) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg  db        03h,07h,'*** SYSTEM ERROR (DISK 0082) ***',0dh,0ah ;36
         db        'PRESS RESET',0dh,0ah                              ;13 =49
filemsg_len equ $ - filemsg

TABLE    DB       210 DUP(?)  ;INTERNAL FORM TABLE FOR EACH DATA STATEMENT
_LENGTH  DB       210 DUP(?)  ;MAX ITEM LENGTH FOR EACH COLUMN
                                        ;the entry of @boot can't large 30
                                        ;the file size of @boot can't large 4k

                                        ;Anita
idt_test  db 43,'(((((((((( IDT SERVICE ROUTINE ))))))))))',0dh,0ah
hscboard  db 0
rcbaddr   dd 0      ;22c11-2 command buffer start address
dskbuf    dd 0      ;disk data transfer area start address
rstaddr   dd 0      ;reset 22c11-II flag address
mxfbit    equ 01b
dskbit    equ 10b
devmsg    db        '@@'
devmsg2   db        ' /'
devname   db        24h dup (20h),'(BOOTSTRAP=R1)',0dh,0ah
devmsg_len equ $ - devmsg
devmsg2_len equ $ - devmsg2
attrmsg   db        02,04,02,00,0eh
attrmsg_len equ $ - attrmsg

memmsg    db        'MEMORY'
mpostar   db        5 dup (20h)
mempos    db        20h
          db        'K ',0DH,0AH,'Key RUN to Execute, CLEAR '
memmsg_hlf equ $ - memmsg
          db        'or PREV SCRN '
sndmsg    db        'for previous screen.'
memmsg_len equ $ - memmsg
sndmsg_len equ $ - sndmsg

termmsg   db        'TERMINAL 1'
termmsg_len equ $ - termmsg
filmsg    db        'FILE '
filmsg_len equ $ - filmsg
nofndmsg  db        'NOT FOUND'
nofndmsg_len equ $ - nofndmsg
nopgmmsg  db        'NOT A PROGRAM RECORD'
nopgmmsg_len equ $ - nopgmmsg
att1msg   db        07,02,04,04,00,0eh
att1msg_len equ $ - att1msg
smallmsg  db        'Screen too small -- reduce length or number of node item'
smallmsg_len equ $ - smallmsg

mxfmemo   equ       400400h             ;first mxf board, check area
dskmemo   equ       100000h             ;first dsk board, start address
test_addr equ       000400h             ;disk check area


;mxfbuf_sts equ      401602h		;M ;first mxf board, first port cmd buffer
;mxfbuf_abs equ      401603h		;M
;mxfbuf_parm equ     401605h		;M
mxfbase   equ	     430h		;M 1st mxf diplay base

abs7      equ       0ff07h              ;abs 07, to display
keyin     equ       0606h               ;abs06, cbs06, get key code
testdata  equ       55aah
hscsel    equ       4ch                 ;hsc selector is 9th of LDT.(01001100b)
hscsel_offset equ   9*8                 ;hsc selector is 9th of LDT
hscsel1   equ       00000fffh           ;base=70000000h, limit=0ffffffh
hscsel2   equ       70c09200h

idt_pword label     pword
          dw        800h                ;idt limit by byte
          dd        160h                ;idt base address
                                        ;Anita

        stsec           dw ?              ;  the begin sector of file found
        file_l          dd ?              ;  file length in sectors =( end sector - start sector + 1)

        gdt_alias       dw 0008h          ;gdt(1) --- gdt alias
        ldt_alias       dw 000ch          ;ldt(1) --- ldt alias

        data_right      dw 4092h
        tss_right       dw 0089h
        ldt_right       dw 0082h

        task_entry      label pword       ;reserve gdt entries for loaded task
        task_offs       dd   0h           ;   gdt(7) for ldt
        task_slot       dw   38h          ;   gdt(8) for tss

        desc_slot       dw 034h           ;reserve ldt entry  for loading process
        segm_slot       dw 03ch           ;   ldt(6) for task's descriptors
                                          ;   ldt(7) for task's segment

        data_alias      dw 044h           ;for copy the writable data pointed
        data_entry      dw 024h           ;   by data_entry (ldt(4)) (base in prom)
                                          ;   to data_alias (ldt(8)) (base in ram )

        os_code         dw 014h           ;


;*************************************************************************
;* Up to now we can see the ldt table structrue
;   0   null
;   1   alias
;   2   code
;   3   i/o port addressing
;   4   data
;   5   stack
;   6   reserve for processing
;   7   reserve fo rprocessing
;   8   data alias
;   9   high speed channel board common memory
;  10   high speed channel board interrupt generate I/O port address
;*************************************************************************

        desc_count      dd 8              ; seven descriptors including null
        desc_loc        dd 70h            ; descriptor's relative location from stl_for label
        tss_loc         dd 0h             ; tss's relative location from stl_for label


                                                ; x  --- null
                                                ; x  --- ldt alias
        text_loc        dd 20h,10h,30h,30h,40h  ; 20 --- code segment
                        dd 50h                  ; 10 --- i/o portion        (TOTAL 7 DESCRPTORS)
                                                ; 30 --- stack alias
                                                ; 30 --- data alias
                                                ; 40 --- specially code segmnet for $init"system"
                                                ; 50 --- high speed channel memory area

        stl_for         db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h    ; 0 - F
                        db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h    ;10 - 1F
                        db 000h,000h,000h,000h,000h,002h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h    ;20 - 2F
                        db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h    ;30 - 3F
                        db 000h,000h,000h,000h,000h,000h,000h,000h,02Ch,000h,000h,000h,014h,000h,000h,000h    ;40 - 4F
                        db 024h,000h,000h,000h,02Ch,000h,000h,000h,01Ch,000h,000h,000h,03Ch,000h,000h,000h    ;50 - 5F
                        db 018h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,028h,000h,000h,000h    ;60 - 6F
;
                        db 000h,000h,000h,000h,000h,000h,000h,000h,037h,000h,000h,000h,000h,092h,000h,000h
                        db 0ffh,020h,000h,000h,000h,09ah,0c0h,000h,032h,000h,000h,000h,000h,092h,040h,000h
                        db 0ffh,020h,000h,000h,000h,092h,0c0h,000h,0ffh,020h,000h,000h,000h,092h,0c0h,000h
                        db 0ffh,0ffh,000h,000h,000h,09ah,000h,000h,0ffh,00fh,000h,000h,000h,092h,0c6h,070h

;;
;cs_ldt                  db 000h,000h,000h,000h,000h,000h,000h,000h, 040h,000h,0a0h,000h,000h,092h,000h,000h
;                        db 0feh,0ffh,060h,009h,000h,09ah,0c6h,000h, 032h,000h,000h,000h,0ffh,092h,040h,0ffh
;cs_data_sel             db 0feh,0ffh,060h,009h,000h,092h,0c6h,000h, 0feh,0ffh,060h,009h,000h,092h,0c6h,000h
;                        db 0ffh,0ffh,000h,000h,000h,09ah,000h,000h, 0ffh,00fh,000h,000h,000h,092h,0c6h,070h
;cs_ldt_len   equ   ($ - cs_ldt)/4       ;we'll using movsd instruction
;csldt_in_gdt equ 38h                    ;select of 7th entry of gdt

;         *******   LDT OF OS CONTANT   *******
;  DESCRIPTION          TYPE    BASE     LIMIT      P DPL C  R (E W) G  D (B)
;
; LDT(0) = NULL          x
; LDT(1) = LDT ALIAS    DATA    0A0         37      1  0  x  x  0 1  0  x  0
; LDT(2) = CODE         CODE    960      20ff(fff)  1  0  0  1  x x  1  1  x
; LDT(3) = I/O PORT     DATA  80000000      32      1  0  x  x  0 1  0  x  1
; LDT(4) = STACK        DATA    960      20ff(fff)  1  0  x  x  0 1  1  x  1
; LDT(5) = DATA         DATA    960      20ff(fff)  1  0  x  x  0 1  1  x  1
; LDT(6) = $INIT        CODE  ffff0000     0ffff    1  0  0  1  x x  0  0  x
; LDT(7) = COMMON MEM   DATA  72000000   20ff(fff)  1  0  x  x  0 1  1  x  1

data    ends
data1   segment  rw
        db      30h dup(?)      ;data1 segment for i/o addressing
data1   ends
code      segment   er
          assume ds:data,es:data,fs:data1
start:

        mov     ax,data
        mov     ds,ax           ;(ds),(es) all point to data segment
        mov     es,ax

        mov     ax,data_entry
        mov     si,ax
        and     esi,0000ffffh
        call    find_alias
        mov     ds,ax           ;ds has been altered to ldt alias
        shr     esi,3
        mov     ecx,[esi*8]
        and     ecx,0000ffffh   ;get limit 15-0
        mov     ebx,[esi*8+4]
        and     ebx,000f0000h   ;get limit 19-16
        or      ecx,ebx         ;ecx = limit of writable data
        push    ecx
                                        ;Anita Lin for high speed channel board
          mov       esi,hscsel_offset   ;high speed channel board common memory
          mov       dword ptr [esi],hscsel1
          mov       dword ptr [esi+4],hscsel2
                                        ;Anita

        mov     ax,data
        mov     ds,ax
        mov     ax,data_entry   ;ds,es has been altered
        mov     bx,data_alias
        mov     ds,ax
        mov     es,bx
        xor     esi,esi
        xor     edi,edi
        cld
        rep     movsb           ;copy write data from eprom to ram

        pop     ecx
        mov     ax,data         ;reset ds,es
        mov     ds,ax
        mov     es,ax

        mov     ax,data_entry   ;push selector
        push    ax
        mov     ax,data_alias
        call    get_base
        push    eax             ;push base address
        mov     ax,4092h        ;push light
        push    ax
        push    ecx             ;push limit
        call    point_at        ;alter the data_entry same as data_alias

;*******************************************************
; The foloowing codes copyed from andy chun
;*******************************************************
mastinit:
        mov     ax,data
        mov     ds,ax
        mov     es,ax
        mov     ax,data1
        mov     fs,ax
        mov     esp,0
        mov     ebp,0
        mov     edx,0
        mov     edi,0
        mov     eax,offset mastinit
        mov     resetproc,eax
                                        ;Anita Lin for high speed channel board
          mov       ax,hscsel
          mov       gs,ax
          mov       ebx,mxfmemo         ;start from mxf micro-code
          mov       word ptr gs:[ebx],testdata  ;testdata is 55aah
          cmp       word ptr gs:[ebx],testdata  ;does first mxf board exist?
          jne       notmxf1             ;no,

	  mov	    ebp,0			 ;M
	  mov	    edi,400000H 		 ;M 1st mxf addr.
	  mov	    bp,word ptr gs:[edi+mxfbase] ;M access 1st mxf display addr.
	  add	    edi,ebp			 ;M
	  add	    edi,2			 ;M
	  mov	    mxfbuf_sts,edi		 ;M
	  inc	    edi 			 ;M
	  mov	    mxfbuf_abs,edi		 ;M
	  add	    edi,2			 ;M
	  mov	    mxfbuf_parm,edi		 ;M

          or        hscboard,mxfbit
          cld
          mov       esi,offset mountmsg
          mov       ecx,mountmsg_len
          call      mxfdsply
          mov       eax,offset restart_1
	  mov	    resetproc,eax
get_key:
          call      waitcp_mxf          ;will jmp to restart_1 if user hit sft-press
          jmp       get_key
notmxf1:
                                        ;Anita
        mov     ebx,2
        mov     ax,word ptr fs:[ebx]
        mov     ebx,4
        mov     byte ptr fs:[ebx],00h
        mov     ecx,040000H
        loop    $
        call    enable5

        mov     esi,offset mountmsg     ;clear screen, cursor on
        mov     ecx,37                  ;display "MOUNT SYSTEM PLATTER"
mountloop:
        mov     al,byte ptr [esi]
        mov     k,al
        call    obstrobe
        inc     esi
        loop    mountloop
        mov     eax,offset restart_1
        mov     resetproc,eax
;!!!    insert the routine << chkpary >> to check memory parity error !!!
;       call    chkpary

;       GET << SHIFT+RESET >> KEY
restart:
        mov     k,1
        call    enable
        call    waitcpb
        jmp     restart
restart_1:
        mov     ax,data
        mov     ds,ax
        mov     es,ax
        mov     ax,data1
        mov     fs,ax
        mov     eax,offset restart_1
        mov     resetproc,eax
                                        ;Anita Lin for high speed channel board
          mov       ax,hscsel
          mov       gs,ax
          test      hscboard,dskbit     ;is 22c11_II?
          jz        norestdsk
          mov       edi,rstaddr
          mov       byte ptr gs:[edi],0 ;tell 22c11-II to reset 0th partition
norestdsk:
          test      hscboard,mxfbit     ;
          jz        notmxf2
          mov       esi,offset sfkeymsg
          mov       ecx,sfkeymsg_len
          call      mxfdsply
          jmp       input
notmxf2:
                                        ;Anita
        call    enable5
        mov     esi,offset sfkeymsg     ;clear screen, cursor on
        mov     ecx,11                  ;display "KEY SF'? "
sfkeyloop:
        mov     al,byte ptr [esi]
        mov     k,al
        call    obstrobe
        inc     esi
        loop    sfkeyloop

input:
        mov     word ptr r5,2020h       ;blank out name before taking from KB.
        mov     r7,20h
        mov     dx,0
        mov     aux1d,dx        ;default function key = 00

        mov     sl,0            ;clear all attribute
        call    waitink         ;wait for 1st character
        mov     al,k
        mov     r7,al
        call    waitink         ;wait for 2nd character
        mov     al,k
        mov     r6,al
        call    waitink         ;wait for 3rd character
        mov     al,k
        mov     r5,al
        or      sl,inputdun     ;set flag 'OVERFLOW' (enough characters)
        call    waitink         ;wait for SF
        jmp     mastinit        ;(should never get here)

;       each 30 ms break here:
;       1) reset key pressed  => reset time counter, and jmp to reset
;       2) reset key not pressed  => reset time counter, and return
;
breakpt_:
          test      hscboard,mxfbit     ;if mxf board
          jz        breakpt
          push      edx
	  mov	    edi,mxfbuf_sts
          cmp       byte ptr gs:[edi],077h      ;check for shift-reset key
          jne       breakp9             ;no, return to caller
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx
          mov       edx,resetproc       ;shift-reset pressed, jmp to initial
          pop       eax                 ;just for stack balance, return cs:ip
          jmp       edx
breakpt:
        push    edx
        mov     edx,cpust
;       test    byte ptr fs:[edx],10h
;       jz      breakp9                 ;branch if not timeout
        test    byte ptr fs:[edx+1],01h
        jz      breakp8                 ;branch if reset key not pressed
        mov     edx,cpuflg
        mov     byte ptr fs:[edx],0  ;allow next reset key been pressed
        pop     edx
        mov     edx,resetproc
        pop     eax                     ;banlance the stack
        jmp     edx                     ;restart from the place it should be

breakp8:
        mov     edx,timset
        mov     al,0ffh                 ;reset time counter
        mov     byte ptr fs:[edx],al
breakp9:
        pop     edx
        ret

;       OBSKHL : OUTPUT K, THEN PH, THEN PL
;       OBSHL  : OUTPUT PH, THEN PL
OBSKHL:
        CALL    OBSTROBE
OBSHL:
        MOV     K,DH
        CALL    OBSTROBE
        MOV     K,DL
        JMP     OBSTROBE
;*
;*        PRTBYTE: output the 2 hex characters of any byte
;*                 stored in register F0.
;*
;*        MODIFIED REGISTERS: F2-F0, K
;*
;*        SUBROUTINES USED: OBSTROBE, DELAY5 AND PRTBYT1.
;*
;*        ENTRY: F0 contains the byte to be outputted.
;*
;*        PRTBYT1: examines each hex character to be
;*                 outputted to determine whether it is a
;*                 digit or needs to be converted to a
;*                 letter (A - F).
;*
;*        HEXPR:  HEXPRINT PC'S
;*

HEXPR:   MOV       R0,DH
         CALL      PRTBYTE   ;HEXPRINT HIGH BYTE
HEXPRPL: MOV       R0,DL
;*   FALL THROUGH AND HEXPRINT LOW BYTE

PRTBYTE:
         MOV       AL,R0     ;MOVE 3,HIGH OF F0 TO F2
         SHR       AL,1
         SHR       AL,1
         SHR       AL,1
         SHR       AL,1
         OR        AL,30H
         MOV       R2,AL
         CALL      PRTBYT1
         MOV       AL,R0     ;MOVE 3,HIGH OF F0 TO F2
         AND       AL,0FH
         OR        AL,30H
         MOV       R2,AL

PRTBYT1:
         CMP       R2,39H
         JBE       JSS1_01
         ADD       R2,07
JSS1_01:
         MOV       AL,R2
         MOV       K,AL
         JMP       OBSTROBE

;*      OBSTROBN:  output same byte many times
;*
;*      ENTRY:  PH = byte to repeat
;*              PL = count (>= 0)
OBSTROBN:
         CMP       DL,0
         JZ        OBSTROBN1
         MOV       K,DH
         CALL      OBSTROBE  ;OUTPUT 1 BYTE
         DEC       DL        ;LOOP IF NONZERO COUNT
         JMP       OBSTROBN
OBSTROBN1:
         RET                 ;RETURN

;*  WAITINK: WAIT FOR IBS FROM KEYBOARD
;*
;*  NOTE: THIS IS EXPANDED FROM EARLIER INPUT LOGIC.
;*     IT ACCEPTS REGULAR CHARACTERS AS WELL AS FUNCTION KEYS
;*
waitink:
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxf3
          jmp       waitink_mxf
notmxf3:
                                        ;Anita
        mov     k,01
        call    enable          ;enable keyboard
        call    waitcpb         ;wait key
        mov     al,k
        mov     r0,al
        call    enable5         ;enable crt
        mov     al,r0           ;restore k
        mov     k,al
        test    sh,endi         ;skip if endi
        jnz     waitin50
        test    al,0f0h         ;ignore 00 - 0F
        jz      waitink
        test    sl,inputdun     ;ignore if already got 3 bytes
        jnz     waitink
        cmp     al,80h
        ja      waitink         ;ignore > 80
        test    sl,namemode
        jz      waitin20
        jmp     obstrobe        ;display if namemode
waitin20:
        mov     k,'@'
        cmp     r0,'@'          ;1st character must be '@'
        jne     waitink
        call    obstrobe
        or      sl,namemode     ;turn on nama mode
        jmp     waitink

;*  ENDI ON
waitin50:
        test    al,0f0h         ;branch if not 00 - 0F
        jNZ     waitink
        test    sl,namemode
        jnz     waitin80
        cmp     al,0fh          ;0F - continue execution
        jne     waitin52
        jmp     continue
waitin52:
        mov     al,k
        and     al,6
        cmp     al,6            ;06,07,0E -- ignore
        je      waitink
        call    diskadr         ;figure disk addr
        mov     r7,'@'
        jmp     waitin90
;*  MENU MODE
waitin90:
        mov     dh,'@'
        mov     dl,r7           ;output @ and r7
        call    obshl
waitin95:
        mov     dx,' /'         ;space/
        call    obshl
        mov     dx,actdev
        mov     al,dh
        or      al,30h
        mov     r2,al
        call    prtbyt1         ;hexprint type digit
        call    hexprpl         ;hexprint disk addr
        mov     dx,2021h
        call    obstrobn
        mov     k,'('
        mov     dx,'BO'         ;(BO
        call    obskhl
        mov     k,'O'
        mov     dx,'TS'         ;OTS
        call    obskhl
        mov     k,'T'           ;TRA
        mov     dx,'RA'
        call    obskhl
        mov     dx,'P='         ;P=
        call    obshl
        mov     k,'R'
        mov     dx,'1)'         ;R1)
        call    obskhl
        mov     dx,0d0ah
        call    obshl
        jmp     disk4
waitin80:
        cmp     al,0fh          ;0F - continue execution
        je      continue
        mov     al,k
        and     al,6
        cmp     al,6            ;06,07,0E -- ignore
        jne     waitin81
        jmp     waitink
waitin81:
        call    diskadr         ;figure disk addr
        jmp     waitin95

continue:
        pop     ax              ;throw away return addr
        jmp     mastinit
                                        ;Anita Lin for high speed channel board
waitink_mxf:
          call      waitcp_mxf          ;get key, key return in al
          mov       k,al
          test      sh,endi             ;jmp if endi
          jnz       waitin50_mxf
          test      al,0f0h             ;ignore 00-0fh
          jz        waitink_mxf
          test      sl,inputdun         ;ignore if already got 3 byte
          jnz       waitink_mxf
          cmp       al,80h
          ja        waitink_mxf         ;ignore > 80h
          test      sl,namemode
          jz        waitin20_mxf
          call      mxfshwone
          ret
                                        ;display one character to mxf cmd buffer
mxfshwone:                              ;input is al
          mov       edi,mxfbuf_sts
chk_sts2:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_sts21           ;no, check complete
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;dummy pop, just for stack balance
          mov       edx,resetproc
          jmp       edx
chk_sts21:
          and       ah,0f0h
          cmp       ah,0f0h             ;does cmd complete ?
          jne       chk_sts2
          mov       edi,mxfbuf_abs      ;edi point to mxf 1st port cmd buffer
          mov       word ptr gs:[edi],abs7       ;display command
          mov       edi,mxfbuf_parm
          mov       byte ptr gs:[edi],1          ;first byte is count of msg
          inc       edi
          mov       byte ptr gs:[edi],al
          mov       edi,mxfbuf_sts
          mov       byte ptr gs:[edi],0fh        ;tell mxf this is a completely cmd
          ret
waitin20_mxf:
          cmp       al,'@'
          jne       waitink_mxf
          call      mxfshwone
          or        sl,namemode
          jmp       waitink_mxf
waitin50_mxf:
          test      al,0f0h             ;br, if not 00-0fh
          jnz       waitink_mxf
          test      sl,namemode
          jnz       waitin80_mxf        ;br, if namemode
          cmp       al,0fh              ;0fh, continue execution
          jne       waitin52_mxf
          jmp       continue
waitin52_mxf:
          and       al,06
          cmp       al,06               ;ignore 06,07,0eh
          je        waitink_mxf
          call      diskadr             ;calculate disk addr. and save to actdev
          mov       r7,'@'
          mov       esi,offset devmsg
          mov       ecx,devmsg_len
waitin95_mxf:
          mov       ax,actdev           ;get the active device
          or        ah,30h
          cmp       ah,39h
          jbe       af1
          add       ah,7
af1:
          mov       devname,ah
          mov       ah,al
          shr       ah,4                ;get high nibble
          or        ah,30h
          cmp       ah,39h
          jbe       af2
          add       ah,7
af2:
          mov       devname[1],ah
          and       al,0fh              ;get low nibble
          or        al,30h
          cmp       al,39h
          jbe       af3
          add       al,7
af3:
          mov       devname[2],al
          call      mxfdsply
          jmp       disk5
waitin80_mxf:
          cmp       al,0fh              ;0fh, continue execution
          je        continue
          and       al,6
          cmp       al,06               ;ignore 06,07,0eh
          jne       waitin81_mxf
          jmp       waitink_mxf
waitin81_mxf:
          call      diskadr             ;calculate disk addr. and save to actdev
          mov       esi,offset devmsg2
          mov       ecx,devmsg2_len
          jmp       waitin95_mxf
mxfdsply:				;input is esi and ecx
                                        ;display a string to mxf command buffer
          mov       edi,mxfbuf_sts
chk_sts1:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_sts11
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;just for stack balance, pop cs:ip
          mov       edx,resetproc
          jmp       edx
chk_sts11:
          and       ah,0f0h
          cmp       ah,0f0h             ;does cmd complete ?
          jne       chk_sts1
          mov       edi,mxfbuf_abs      ;edi point to mxf 1st port cmd buffer
          mov       word ptr gs:[edi],abs7       ;display command
          mov       edi,mxfbuf_parm
          mov       byte ptr gs:[edi],cl         ;first byte is count of msg
          inc       edi
          push      es
          push      gs
          pop       es
          rep       movsb
          pop       es
          mov       edi,mxfbuf_sts
          mov       byte ptr gs:[edi],0fh        ;tell mxf this is a completely cmd
          ret
mxfblnk:                                ;input is cx
                                        ;display cx space to mxf command buffer
          mov       al,20h
mxfrpt:                                 ;input is cx and al
                                        ;display cx al code to mxf
          mov       edi,mxfbuf_sts
chk_sts4:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_sts41
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;dummy pop, just for stack balance
          mov       edx,resetproc
          jmp       edx
chk_sts41:
          and       ah,0f0h
          cmp       ah,0f0h             ;does cmd complete ?
          jne       chk_sts4
          mov       edi,mxfbuf_abs      ;edi point to mxf 1st port cmd buffer
          mov       word ptr gs:[edi],abs7       ;display command
          mov       edi,mxfbuf_parm
          mov       byte ptr gs:[edi],cl         ;first byte is count of msg
          inc       edi
          push      es
          push      gs
          pop       es
          rep       stosb
          pop       es
          mov       edi,mxfbuf_sts
          mov       byte ptr gs:[edi],0fh        ;tell mxf this is a completely cmd
          ret
mxfshw234:                              ;input is cx and eax
                                        ;display eax code to mxf
          mov       edi,mxfbuf_sts
chk_sts5:
          mov       bh,byte ptr gs:[edi]
          cmp       bh,077h             ;is shft-reset pressed?
          jne       chk_sts51
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;just for stack balance, pop cs:ip
          mov       edx,resetproc
          jmp       edx
chk_sts51:
          and       bh,0f0h
          cmp       bh,0f0h             ;does cmd complete ?
          jne       chk_sts5
          mov       edi,mxfbuf_abs      ;edi point to mxf 1st port cmd buffer
          mov       word ptr gs:[edi],abs7       ;display command
          mov       edi,mxfbuf_parm
          mov       byte ptr gs:[edi],cl         ;first byte is count of msg
          inc       edi
          mov       dword ptr gs:[edi],eax
          mov       edi,mxfbuf_sts
          mov       byte ptr gs:[edi],0fh        ;tell mxf this is a completely cmd
          ret
                                        ;Anita
;*************************************************************
;* jmp to disk4 label from above codes
;*************************************************************
NXTENTRY:
         ADD       R0,10H    ;INCREMENT READ ADDRESS
         CMP       R0,0      ;BR IF SECTR NOT EXHAUSTED
         JNE       READENTY
NXTSECT: MOV       DX,AUX0C  ;RECALL SIZE OF INDEX
         MOV       R4,DL     ;MOVE TO FILE REG FOR TEST
         MOV       DX,AUX0F  ;RECALL NEXT SECTOR TO READ
         CMP       R4,DL     ;ERR 82 IF NO MORE SECTORS
         JE        ERROR_82xxx
         MOV       AUX10,DISKWORK
         CALL      DREAD     ;READ NEW SECTOR
         MOV       DX,DISKWORK
         JMP       READENTX
error_82xxx:
        mov     al,82h
        jmp     error_82

DISK4:
         call      enabled
         mov       eax,cbs
         mov       byte ptr fs:[eax],01h
         call      enabnull
disk5:
         MOV       EAX,OFFSET MASTINIT
         MOV       RESETPROC,EAX
         CALL      ENABLED
         MOV       DX,ZERO
         MOV       AUX0F,DX  ;START  SECTOR  = 00 00
         MOV       AUX10,DISKWORK
         CALL      DREAD     ;READ SECTOR 0000
         MOV       DX,DISKWORK          ;CERTIFY HIGH WORD OF EDX IS ZERO
         MOV       CX,[EDX]  ;PC'S = 1F 00
         XCHG      CH,CL
         MOV       DL,CL     ;MOVE # INDEX SECTORS TO PL
         MOV       AUX0C,DX  ;STORE # INDEX SECTORS

;*
;*       SET-UP CONSTANTS AND COUNTERS
;*
         MOV       DX,DISKWORK+10H
READENTX:
         MOV       WORD PTR R0,DX
READENTY:
         MOV       DX,WORD PTR R0    ;MOVE READ ADDR TO PC'S
         MOV       CX,[EDX]  ;READ ENTRY USAGE CODE
         XCHG      CH,CL
         CMP       CH,10H    ;BR IF USAGE <> 10
         JNE       NXTENTRY
         TEST      CL,0FH    ;BR IF NOT A DATA FILE
         JNZ       NXTENTRY
         ADD       DL,08     ;PT AT BEGIN OF NAME
         MOV       CX,[EDX]
         XCHG      CH,CL
         INC       DX
         CMP       CH,40H    ;COMPARE TO :
         JNE       NXTENTRY  ;@
         CMP       CL,R7     ;F7
         JNE       NXTENTRY
         INC       DX
         MOV       CX,[EDX]
         XCHG      CH,CL
         INC       DX
         INC       DX
         CMP       CH,R6     ;F6
         JNE       NXTENTRY
         CMP       CL,R5     ;F5
         JNE       NXTENTRY
READENT2:
         MOV       CX,[EDX]
         XCHG      CH,CL
         INC       DX
         CMP       CH,20H
         JNE       NXTENTRY  ;SKIP IF NOT BLANK
         TEST      CL,0FH    ;LOOP TILL END OF NAME
         JNZ       READENT2

;*        FILE FOUND
;*
FILEFOND:
         ADD       R0,2      ;START OF FILE ADDRESS
         MOV       DX,WORD PTR R0    ;MOVE ADDRESS TO PC'S
         MOV       CX,[EDX]  ;READ START ADDRESS
         XCHG      CH,CL
         MOV       AUX0F,CX  ;STORE START AT AUX F
         MOV       STSEC,CX  ;STORE START SECTOR ADDRESS
         XOR       ECX,ECX
         MOV       CX,[EDX+2]
         XCHG      CH,CL     ;CX= END OF SECTOR
         SUB       CX,STSEC
         INC       ECX       ;ECX=END SECTOR - START SECTOR + 1
         MOV       FILE_L,ECX
         TEST      SL,NAMEMODE
         JNZ       HORSE
         JMP       LOAD@@
ERROR_82:
          cmp      al,90h
          jne      error_82_0
          mov      esi,offset filemsg0
          jmp      error_82_e
error_82_0:
          cmp      al,91h
          jne      error_82_1
          mov      esi,offset filemsg1
          jmp      error_82_e
error_82_1:
          cmp      al,92h
          jne      error_82_2
          mov      esi,offset filemsg2
          jmp      error_82_e
error_82_2:
          cmp      al,93h
          jne      error_82_3
          mov      esi,offset filemsg3
          jmp      error_82_e
error_82_3:
          cmp      al,94h
          jne      error_82_4
          mov      esi,offset filemsg4
          jmp      error_82_e
error_82_4:
          cmp      al,95h
          jne      error_82_5
          mov      esi,offset filemsg5
          jmp      error_82_e
error_82_5:
          cmp      al,96h
          jne      error_82_6
          mov      esi,offset filemsg6
          jmp      error_82_e
error_82_6:
          cmp      al,97h
          jne      error_82_7
          mov      esi,offset filemsg7
          jmp      error_82_e
error_82_7:
          cmp      al,98h
          jne      error_82_8
          mov      esi,offset filemsg8
          jmp      error_82_e
error_82_8:
          cmp      al,99h
          jne      error_82_9
          mov      esi,offset filemsg9
          jmp      error_82_e
error_82_9:
          mov      esi,offset filemsg
                                        ;Anita Lin for high speed channel board
error_82_e:
          test      hscboard,mxfbit
          jz        error_82_           ;jmp if not mxf board
;         mov       esi,offset filemsg
          mov       ecx,49
          call      mxfdsply
error_820:
          mov       eax,offset restart_1
          mov       resetproc,eax
error_82a_:
          mov       edi,mxfbuf_sts
chk_sts3:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_sts3
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          mov       edx,resetproc
          jmp       edx
error_82_:
                                        ;Anita
        push    esi
        call    enable5
        pop     esi
;       mov     esi,offset filemsg      ;clear screen, beep
        mov     ecx,49                  ;display "*** SYSTEM ERROR ..."
fileloop:
        mov     al,byte ptr [esi]
        mov     k,al
        call    obstrobe
        inc     esi
        loop    fileloop

        mov     eax,offset restart_1
        mov     resetproc,eax
ERROR_82A:
        CALL    BREAKPT_
        JMP     ERROR_82A

;* the main menu program
;*
;*     PATCH TO CLEAR CHAAIN MODE FLAG OF BILL SMITH'S VERSION
;*                   MICROCODE DIAGNOSTICS
;*

LOAD@@:
        call    enabled
        mov     aux10,message
        call    dread
;
        mov     esi,message
        cmp     byte ptr [esi+4],0
        jnz     start1

                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        menuloop_
          add       esi,0ah             ;get the start address
          mov       word ptr [esi+3ch],0d0ah    ;one sector for one line
          mov       ecx,3eh             ;count is 3ch+2
          call      mxfdsply            ;display the string
          jmp       load@@              ;get next sector
menuloop_:
                                        ;Anita
         call      enable5
         add       esi,0ah
         mov       ecx,03ch             ;display "LOADING: ..."
menuloop:
         mov       al,byte ptr [esi]
         mov       k,al
         call      obstrobe
         inc       esi
         loop      menuloop
         mov       k,0dh
         call      obstrobe
         mov       k,0ah
         call      obstrobe
         jmp       load@@
;
START1:
        MOV     EDX,OFFSET ROOTNODE
        MOV     AUX05,DX                ;STORE FILENAME ADDRESS IN AUX05
        MOV     SL,5                    ;STORE FILE LENGTH IN SL
LOAD0:
        MOV     R5,0                    ;R5=0 INDICATES Menu TYPE
LOAD:
        CALL    DISK
;
NOPREV:
         MOV       DX,0H
         MOV       AUX19,DX
;*
;*        GET CRT SIZE
;*
;&&&&&&&&&&&&&&&&&&&&&&&
         MOV       EDX,CPURDY
         MOV       BYTE PTR FS:[EDX],0
         CALL      ENABLE5   ;ENABLE CRT
         MOV       K,0
         MOV       EDX,CPUST
         CALL      DELAY10   ;DELAY 10US
         CALL      DELAY10   ;DELAY 10US
         MOV       EDX,IBGET
         MOV       AL,BYTE PTR FS:[EDX]
         MOV       K,AL
         MOV       R4,18H    ;F4=# CRT ROWS=24
         MOV       R3,50H    ;F3=# CRT COLUMNS=80
                                        ;temp. code, Anita Lin
          test      hscboard,mxfbit     ;if mxf, we said 24*80 screen
          jnz       _title

         TEST      K,10H
         JNZ       _TITLE
         MOV       R4,10H    ;F4=# CRT ROWS=16
         MOV       R3,40H    ;F3=# CRT COLUMNS=64
;&&&&&&&&&&&&&&&&&&&&&
;*
;*        DISPLAY NODE TITLE
;*
_TITLE:
        MOV     EDX,XDATA
        CALL    SEARCH97        ;SEARCH FOR A DATA LINE
        CALL    NEXTITEM        ;GET START ADDRESS OF TITLE
        MOV     AUX00,DX        ;AUX00 = START ADDRESS OF TITLE
        MOV     WORD PTR R6,DX  ;R7R6 = START ADDRESS OF TITLE
        CALL    SEARCH22
        SUB     WORD PTR R6,DX
        XOR     R6,0FFH         ;R6=LENGTH OF TITLE
        CALL    SEARCH97        ;SEARCH FOR THE 1ST NODE
        MOV     AUX01,DX        ;AUX01 = START ADDR. OF THE 1ST NODE
                                        ;Anita Lin for high speed channel board
          mov       esi,offset mempos
          mov       eax,0               ;clear eax
                                        ;get the high byte
          mov       al,1fh
          mov       edx,rtcaddr
          mov       byte ptr fs:[edx],al        ;select rtc port addr=1fh
          nop
          nop
          nop
          nop
          mov       edx,rtcdata
          mov       ah,byte ptr fs:[edx];get the memory size from rtc ram
                                        ;get the low byte
          mov       al,1eh
          mov       edx,rtcaddr
          mov       byte ptr fs:[edx],al;select rtc port addr=1eh
          nop
          nop
          nop
          nop
          mov       edx,rtcdata
          mov       al,byte ptr fs:[edx];get the memory size from rtc ram
          mov       cx,64               ;the unit of memory size is 64K
          mul       cx                  ;memory size by K
          mov       cx,10               ;convert to base by 10
memm:
          mov       dx,0
          div       cx
          add       dl,30h              ;dl must be 0-9, convert to ascii
          mov       byte ptr [esi],dl   ;move to display string
          dec       esi
          cmp       ax,0
          jne       memm
          test      hscboard,mxfbit
          jz        notmxf4
          mov       ax,0306h
          mov       ecx,2
          call      mxfshw234
          mov       al,r3
          sub       al,r6
          mov       r0,al
          mov       r1,2
          call      division            ;F2=(# CRT COL - LENGTH OF TITLE)/2
          mov       ecx,0
          mov       cl,r2
          mov       al,09h              ;back r2 times
          call      mxfrpt
          mov       esi,offset attrmsg  ;change the crt attribute
          mov       ecx,attrmsg_len
          call      mxfdsply            ;displey the attribute string
          mov       eax,0
          mov       ax,aux00
          mov       esi,eax
          mov       ecx,0
          mov       cl,r6
          call      mxfdsply
          mov       eax,0a0a0f0dh      ;bright off, cr, down two line
          mov       ecx,4
          call      mxfshw234
          mov       esi,offset instrmsg
          xor       ecx,ecx
          mov       cl,[esi]
          inc       esi
          call      mxfdsply
          mov       ecx,0
          mov       cl,r3
          sub       cl,34h
          call      mxfblnk             ;display cx spaces
          mov       esi,offset memmsg
          mov       ecx,memmsg_len
          mov       r0,4bh              ;supporse is 24 by 80 screen
          cmp       r3,50h
          je        showmem
          mov       ecx,memmsg_hlf      ;if 16 by 64 screen
          mov       r0,3eh
          call      mxfdsply
          mov       ecx,sndmsg_len
          mov       esi,offset sndmsg
showmem:
          call      mxfdsply
          mov       ecx,0
          mov       cl,r3
          dec       cl
          sub       cl,r0
          call      mxfblnk
          mov       esi,offset termmsg
          mov       ecx,termmsg_len
          call      mxfdsply
          jmp       setable
notmxf4:
        MOV     DX,0306H
        CALL    OBSHL           ;CLEAR SCREEN ,CURSOR OFF

;*
;*      CALCULATE COORDINATES TO DISPLAY TITLE
;*

        MOV     AL,R3
        SUB     AL,R6
        MOV     R0,AL
        MOV     R1,2
        CALL    DIVISION        ;F2=(# CRT COL - LENGTH OF TITLE)/2
        MOV     DL,R2
        MOV     DH,09H
        CALL    OBSTROBN        ;MOVE CURSOR RIGHT F2
        MOV     DX,0204H
        CALL    OBSHL
        MOV     DX,0200H
        CALL    OBSHL
        MOV     DX,0E01H
        CALL    OBSTROBN        ;DISPLAY ATTRIBUTE BRIGHT(020402000E)
        MOV     AL,R6
        MOV     R0,AL
        MOV     DX,AUX00        ;DX=START ADDRESS OF TITLE,R0=LENGTH OF TITLE
        CALL    SDISPLA1
        MOV     DX,0F0DH        ;"BRIGHT" OFF,CARRIAGE RETURN
        CALL    OBSHL
        MOV     DX,0A02H        ;CURSOR DOWN TWO LINES
        CALL    OBSTROBN

;*
;*        DISPLAY INSTRUCTIONS
;*
         MOV       ESI,OFFSET INSTRMSG
         XOR       ECX,ECX
         MOV       CL,[ESI]
         INC       ESI
INSTLOOP:
         MOV       AL,BYTE PTR [ESI]
         MOV       K,AL
         CALL      OBSTROBE
         INC       ESI
         LOOP      INSTLOOP ;DISPLAY "Select item with SPACE & BACKSPACE."

         MOV       DL,R3
         SUB       DL,34H
         MOV       DH,20H    ;MOVE CURSOR RIGHT (48/64)
         CALL      OBSTROBN
         MOV       DX,4D45H  ;ME
         CALL      OBSHL
         MOV       DX,4D4FH  ;MO
         CALL      OBSHL
         MOV       DX,5259H  ;RY
         CALL      OBSHL
;*
;*        GET MEMORY SIZE
;*
;*        CALCULATE DISPLAY MEMORY SIZE
;*
                                        ;Anita for 33M cpu board
;         mov       al,1fh
;         mov       edx,rtcaddr
;         mov       byte ptr fs:[edx],al;select rtc port addr=1fh
;         mov       ecx,1000
;         loop      $
;         mov       edx,rtcdata
;         mov       ah,byte ptr fs:[edx];get the high byte of memory size
;         mov       al,1eh
;         mov       edx,rtcaddr
;         mov       byte ptr fs:[edx],al;select rtc port addr=1eh
;         mov       ecx,1000
;         loop      $
;         mov       edx,rtcdata
;         mov       al,byte ptr fs:[edx];get the low byte of memory size
;         mov       cx,64               ;the unit of memory size is 64K
;         mul       cx                  ;memory size by K
;         mov       cx,10               ;convert to base by 10
;         mov       esi,offset mempos
;etm:
;         mov       dx,0
;         div       cx
;         add       dl,30h              ;dl must be 0-9, convert to ascii
;         mov       byte ptr [esi],dl   ;move to display string
;         dec       esi
;         cmp       ax,0
;         jne       getm
          mov       dx,word ptr mpostar
          xchg      dl,dh
;         add       esi,2
          call      obshl
          mov       dx,word ptr mpostar[2]
          xchg      dl,dh
;         add       esi,2
          mov       bx,word ptr mpostar[4]
          xchg      bl,bh
                                        ;Anita
         CALL      OBSHL     ;10, 20, 40, 81
         MOV       DX,BX     ;
         CALL      OBSHL     ;24, 48, 96, 92
         MOV       DX,' K'   ;K
         CALL      OBSHL
         CALL      OBSSP

STARTA2:

         CALL      ENABLE5
         MOV       DX,0D0AH  ;CARRIAGE RETURN, CURSOR DOWN
         CALL      OBSHL
         MOV       DX,4B65H  ;Ke
         CALL      OBSHL
         MOV       DX,7920H  ;y
         CALL      OBSHL
         MOV       DX,5255H  ;RU
         CALL      OBSHL
         MOV       DX,4E20H  ;N
         CALL      OBSHL
         MOV       DX,746FH  ;to
         CALL      OBSHL
         MOV       DX,2065H  ;E
         CALL      OBSHL
         MOV       DX,7865H  ;xe
         CALL      OBSHL
         MOV       DX,6375H  ;cu
         CALL      OBSHL
         MOV       DX,7465H  ;te
         CALL      OBSHL
         MOV       DX,2C20H  ;,
         CALL      OBSHL
         MOV       DX,434CH  ;CL
         CALL      OBSHL
         MOV       DX,4541H  ;EA
         CALL      OBSHL
         MOV       DX,5220H  ;R
         CALL      OBSHL
         CMP       R3,50H    ;BR IF 16 BY 64 SCREEN
         JNE       STARTA3
         MOV       DX,6F72H  ;or
         CALL      OBSHL
         MOV       DX,2050H  ;P
         CALL      OBSHL
         MOV       DX,5245H  ;RE
         CALL      OBSHL
         MOV       DX,5620H  ;V
         CALL      OBSHL
         MOV       DX,5343H  ;SC
         CALL      OBSHL
         MOV       DX,524EH  ;RN
         CALL      OBSHL
         MOV       R0,4BH    ;POS CURSOR TO COL 64
         MOV       K,20H     ;SPACE
         CALL      OBSTROBE
         JMP       STARTA3_1
STARTA3: MOV       R0,3EH    ;POS CURSOR TO COL 48
STARTA3_1:
         MOV       DX,666FH  ;fo
         CALL      OBSHL
         MOV       DX,7220H  ;r
         CALL      OBSHL
         MOV       DX,7072H  ;pr
         CALL      OBSHL
         MOV       DX,6576H  ;ev
         CALL      OBSHL
         MOV       DX,696FH  ;io
         CALL      OBSHL
         MOV       DX,7573H  ;us
         CALL      OBSHL
         MOV       DX,2073H  ; s
         CALL      OBSHL
         MOV       DX,6372H  ;cr
         CALL      OBSHL
         MOV       DX,6565H  ;ee
         CALL      OBSHL
         MOV       DX,6E2EH  ;n.
         CALL      OBSHL
         MOV       DL,R3
         DEC       DL
         SUB       DL,R0
         MOV       DH,20H
         CALL      OBSTROBN
         MOV       DX,5445H  ;TE
         CALL      OBSHL
         MOV       DX,524DH  ;RM
         CALL      OBSHL
         MOV       DX,494EH  ;IN
         CALL      OBSHL
         MOV       DX,414CH  ;AL
         CALL      OBSHL
         MOV       DX,2031H  ; 1
         CALL      OBSHL
;*
;*        SET UP "TABLE"
;*
;* "TABLE" IS AN INTERNAL FORM TABLE,IN WHICH
;* EACH ENTRY IS 7 BYTES LONG,AND REPRESENTS
;* A DATA STATEMENT ,PROVIDED THE NODE IS "M","P",OR "B" TYPE
;*
;*-------------------------------------------------------------
;* NODENAME ADDR.! LENGTH! NODE DESCRIPTION ADDR.! LENGTH! TYPE
;*---------------!-------!-----------------------!-------!-----
;*       (2B)    !  (1B) !           (2B)        !  (1B) ! (1B)
;*---------------!-------!-----------------------!-------!-----
;*
;*        UP TO NOW  F3=# CRT COL.
;*                   F4=# CRT ROWS
;*                   AUX 1=START ADDRESS OF THE 1ST NODE
;*
setable:
         MOV       R5,0      ;F5=COUNT OF NODES
         MOV       EDX,OFFSET TABLE
         MOV       AUX02,DX  ;AUX 2=POINTER OF "TABLE"
         MOV       DX,AUX01  ;GET START ADDR. OF THE 1ST NODE
SETTABLE:
         MOV       R1,2      ;LOOP TWICE
SETTABL1:
         MOV       WORD PTR R6,DX    ;F7F6=READ ADDR.
         MOV       DX,AUX02  ;PC'S=WRITE ADDR.
         MOV       AL,R7     ;WRITE LEFT HALF OF ADDR.
         MOV       AH,R6     ;WRITE RIGHT HALF OF ADDR.
         MOV       [EDX],AL
         MOV       [EDX+1],AH
         ADD       DX,2
         MOV       AUX02,DX  ;STORE POINTER
         MOV       DX,WORD PTR R6
         CALL      SEARCH22  ;SEARCH NEXT ITEM
         MOV       AX,DX     ;CALCULATE LENGTH
         SUB       AX,WORD PTR R6
         DEC       AL
         MOV       K,AL      ;K=LENGTH OF ITEM
         CALL      SEARCH22
         XCHG      DX,AUX02  ;PC'S=WRITE ADDR.,AUX2=ADDR. OF NEXT ITEM
         MOV       AL,K      ;WRITE LENGTH
         MOV       BYTE PTR [EDX],AL
         INC       DX
         XCHG      DX,AUX02
         DEC       R1        ;F1=F1-1
         JNZ       SETTABL1  ;LOOP BACK IF F1 NOT 0
;        ASSUME THE NODE IS "M","P" OR "B"
;        SET F1=0, AND INCREMENT F5
         INC       R5        ;INCREMENT # OF NODES
         MOV       CH,BYTE PTR [EDX]
         mov       k,'M'
         CMP       CH,'M'    ;BRANCH IF "M" TYPE
         JE        MPB

         mov       k,'P'
         CMP       CH,'P'    ;BRANCH IF "P" TYPE
         JE        MPB

         mov       k,'B'
         CMP       CH,'B'    ;BRANCH IF "B" TYPE
         JE        MPB

         MOV       R1,0FFH   ;INDICATE NOT "M","P","B" TYPE
         DEC       R5        ;DECREMENT # OF NODES
         CMP       CH,20H    ;BRANCH IF END OF DATA
         JE        CALCULAT
MPB:     XCHG      DX,AUX02  ;PC'S=WRITE ADDR.
         MOV       AL,K      ;WRITE TYPE
         MOV       BYTE PTR [EDX],AL
         INC       DX
         XCHG      DX,AUX02
         CMP       R1,0      ;BRANCH IF "M","P","B" TYPE
         JE        ENDFILE?
         CALL      AUX2SUB7  ;REMOVE THE ENTRY IF NOT "M","P","B"
         MOV       R0,0      ;SEARCH "00", MAKE SURE AT END OF DATA STATEMENT
         CALL      CMPBYTE
ENDFILE?:
         INC       DX
         MOV       CH,BYTE PTR [EDX] ;CHECK IF END OF FILE
         CMP       CH,0FEH
         JE        CALCULAT
         CALL      SEARCH97  ;SEARCH NEXT DATA STATEMENT
         JMP       SETTABLE

;         TITLE     # ROWS/COL.
;*
;*        CALCULATE # ROWS PER COL.
;*
;*        UP TO NOW F3=# CRT COL.
;*                  F4=# CRT ROWS
;*                  F5=# OF NODES
;*                  AUX 1=START ADDR. OF 1ST NODE
;*                  AUX 2=POINTER OF "TABLE"
;*
CALCULAT:
         MOV       AL,R5     ;F0=# NODES
         ADD       AL,R4     ;F0=#NODES+# CRT ROWS
         ADD       AL,0FAH   ;F0=F0-6
         MOV       R0,AL
         MOV       AL,R4     ;F1=# CRT ROWS
         ADD       AL,0FBH   ;F1=# CRT ROWS-5
         MOV       R1,AL
         CALL      DIVISION  ;F2=COLUMN #
         MOV       AH,R2
         MOV       SL,AH
         MOV       AL,R5
         MOV       WORD PTR R0,AX
         CALL      DIVISION
         CMP       R0,0
         JE        JSM1_01
         INC       R2
JSM1_01:
         MOV       AL,R2
         MOV       R6,AL     ;F6=# ROWS PER COL.
;*
;*        CALCULATE MAX ITEM LENGTH OF EACH COL.
;*
         MOV       EDX,OFFSET _LENGTH
         MOV       AUX03,DX  ;AUX 3= POINTER OF LENGTH TABLE
         MOV       AL,R5
         MOV       R1,AL
         MOV       EDX,OFFSET TABLE+5   ;PC'S POINT TO DESCRIPTION LENGTH
ROWSCOL: MOV       AL,R6     ;F2= # ROWS PER COL.
         MOV       R2,AL     ;F2= # ROWS PER COL.
         MOV       R7,0      ;F7=MAX ITEM LENGTH FOR EACH COL.

;*        CALCULATE MAX ITEM LENGTH OF ONE COL.
ROWSCOL1:
         MOV       CH,BYTE PTR [EDX]
         CMP       CH,R7     ;BRANCH IF NOT LONGER
         JbE       JSM1_02
         MOV       R7,CH     ;CHANGE MAX ITEM LENGTH
JSM1_02:
         XCHG      DX,AUX02  ;ADD 7 TO PC'S,POINT TO NEXT NODE'S DESCRIPTION LENGTH
         CALL      AUX2ADD7
         XCHG      DX,AUX02
         DEC       R1
         JZ        ROWSCOL2  ;BRANCH IF THE LAST COLUMN HAS LESS ROWS
         DEC       R2
         JNZ       ROWSCOL1  ;BRANCH IF ONE COLUMN IS DONE
ROWSCOL2:
         XCHG      DX,AUX03  ;PC'S POINT TO "LENGTH" TABLE
         MOV       AL,R7
         MOV       BYTE PTR [EDX],AL
         INC       DX        ;STORE MAX ITEM LENGTH
         XCHG      DX,AUX03
         CMP       R1,0
         JNE       ROWSCOL

;         TITLE     DISPLAY NODE ITEMS
;*
;*        UP TO NOW SL=COLUMN #
;*                  F3=# CRT COL
;*                  F4=# CRT ROWS
;*                  F5=# NODES
;*                  F6=# ROWS PER COL.
;*                  AUX 1=START ADDR. OF 1ST NODE
;*                  AUX 2=POINTER OF "TABLE"
;*                  AUX 3=POINTER OF "LENGTH" TABLE
;*
;*        HANDLE DISPLAY OF NODES
;*
         MOV       AL,R4     ;F0=# CRT ROWS
         ADD       AL,0FBH   ;F0=F0-5
         SUB       AL,R6
         MOV       R0,AL
         MOV       R1,2
         CALL      DIVISION  ;F2=INT((# CRT ROWS - 5 -# ROWS PER COL) / 2)
         MOV       AL,R2     ;F7=1ST ROW POSITION
         ADD       AL,5
         MOV       R7,AL
         MOV       AL,R3     ;F0=# CRT COL
         MOV       R0,AL
         MOV       AL,SL     ;F1=COLUMN #
         MOV       R1,AL
         MOV       EDX,OFFSET _LENGTH
HANDLE:  mov       ch,byte ptr [edx]
         INC       DX        ;READ MAX ITEM LENGTH OF EACH COL.
         SUB       R0,CH
         DEC       R1
         JNZ       HANDLE
         MOV       AL,SL     ;F1=COLUMN #
         MOV       R1,AL
         INC       R1
         CALL      DIVISION  ;F2=SPACE BETWEEN TWO COLUMNS
         MOV       R1,5      ;MINIMUM SPACE BETWEEN TWO COLUMNS
         MOV       AL,R1
         CMP       AL,R2     ;BRANCH IF ENOUGH SPACE
         JBE       DISPLAY
         CALL      ATTRIBUT
         CALL      WIPE
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxf5
          mov       esi,offset smallmsg
          mov       ecx,smallmsg_len
          call      mxfdsply
          jmp       error_820
notmxf5:
                                        ;Anita
         MOV       DX,5363H  ;Sc
         CALL      OBSHL
         MOV       DX,7265H  ;re
         CALL      OBSHL
         MOV       DX,656EH  ;en
         CALL      OBSHL
         MOV       DX,2074H  ; t
         CALL      OBSHL
         MOV       DX,6F6FH  ;oo
         CALL      OBSHL
         MOV       DX,2073H  ; s
         CALL      OBSHL
         MOV       DX,6D61H  ;ma
         CALL      OBSHL
         MOV       DX,6C6CH  ;ll
         CALL      OBSHL
         MOV       DX,202DH  ; -
         CALL      OBSHL
         MOV       DX,2D20H  ;-
         CALL      OBSHL
         MOV       DX,7265H  ;re
         CALL      OBSHL
         MOV       DX,6475H  ;du
         CALL      OBSHL
         MOV       DX,6365H  ;ce
         CALL      OBSHL
         MOV       DX,206CH  ; l
         CALL      OBSHL
         MOV       DX,656EH  ;en
         CALL      OBSHL
         MOV       DX,6774H  ;gt
         CALL      OBSHL
         MOV       DX,6820H  ;h
         CALL      OBSHL
         MOV       DX,6F72H  ;or
         CALL      OBSHL
         MOV       DX,206EH  ; n
         CALL      OBSHL
         MOV       DX,756DH  ;um
         CALL      OBSHL
         MOV       DX,6265H  ;be
         CALL      OBSHL
         MOV       DX,7220H  ;r
         CALL      OBSHL
         MOV       DX,6F66H  ;of
         CALL      OBSHL
         MOV       DX,206EH  ; n
         CALL      OBSHL
         MOV       DX,6F64H  ;od
         CALL      OBSHL
         MOV       DX,6520H  ;e
         CALL      OBSHL
         MOV       DX,6974H  ;it
         CALL      OBSHL
         MOV       DX,656DH  ;em
         CALL      OBSHL
         MOV       DX,7301H  ;s
         CALL      OBSTROBN
         mov       eax,offset restart_1
         mov       resetproc,eax
         jmp       error_82a

;*
;*        DISPLAY NODE DESCRIPTIONS
;*
;*        UP TO NOW F2=SPACE BETWEEN TWO COLUMNS
;*                  F5=# NODES
;*                  F6=# ROWS PER COL.
;*                  F7=1ST ROW POSITION
;*
DISPLAY: MOV       AL,R2
         MOV       R3,AL     ;F3=SPACE BETWEEN TWO COLUMNS
         MOV       EDX,OFFSET TABLE+3
         MOV       AUX02,DX  ;AUX 2 POINTS TO NODE DESCRIPTION FIELD IN "TABLE"
         MOV       EDX,OFFSET _LENGTH
         MOV       AUX03,DX  ;AUX 3 POINTS TO "LENGTH" TABLE
         MOV       DX,WORD PTR R5    ;STORE # ROWS PER COL.  AND # NODES IN AUX 4
         MOV       AUX04,DX
DISPLAY1:
         MOV       R4,0
         CALL      CURSOR
DISPLAY2:
         MOV       DX,AUX02
         MOV       CH,BYTE PTR [EDX]
         INC       DX

         MOV       R1,CH
         MOV       CH,BYTE PTR [EDX]
         INC       DX

         MOV       R0,CH
         MOV       CH,BYTE PTR [EDX]
         INC       DX        ;READ ADDR. WHERE DESCRIPTION ADDR. IS STORED

         MOV       SL,CH     ;SL=DESCRIPTION LENGTH,CH=TYPE
         MOV       CH,BYTE PTR [EDX]
         INC       DX

         MOV       AUX02,DX  ;AUX 2 POINTS TO NEXT DESCRIPTION ADDR.
         ADD       AUX02,3
         MOV       DX,WORD PTR R0    ;PC'S=START ADDR. OF DESCRIPTION
         MOV       AL,SL     ;F0=LENGTH OF DESCRIPTION
         MOV       R0,AL
         MOV       R1,AL     ;F1=LENGTH OF DESCRIPTION
         INC       R4        ;F4 COUNTS ROWS OF EACH COL.
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxf6
          cmp       ch,'B'
          jne       display21
          mov       r1,0feh
          jmp       display22
display21:
          mov       ax,202eh
          mov       ecx,2               ;display 2 code to mxf crt
          call      mxfshw234
          mov       esi,edx
          mov       ecx,0
          mov       cl,r0
          call      mxfdsply
display22:
          dec       r5                  ;decrement nodes
          jz        display4
          dec       r6                  ;decrement one row
          jz        display3
          cmp       r1,0feh             ;should we need to back?
          je        display23
          mov       al,08h
          mov       ecx,0
          mov       cl,r1               ;backword r1+2 character
          add       cl,2
          call      mxfrpt
display23:
          mov       al,0ah
          call      mxfshwone
          jmp       display2
                                        ;Anita
notmxf6:
         CALL      SDISPLA0  ;DISPLAY DESCRIPTION
         DEC       R5        ;DECREMENT NODES
         JZ        DISPLAY4  ;BRANCH IF DISPLAY COMPLETED
         DEC       R6        ;DECREMENT ONE ROW
         JZ        DISPLAY3  ;BRANCH IF ONE COLUMN COMPLETED
;*        UPDATE CURSOR POSITION FOR NEXT NODE
         MOV       DH,08     ;MOVE CURSOR BACKWARD
         MOV       DL,R1
         ADD       DL,2
         CALL      OBSTROBN
         MOV       DH,0AH    ;MOVE CURSOR DOWN
         MOV       DL,01
         CALL      OBSTROBN
         JMP       DISPLAY2
;*        ONE COLUMN IS DONE , PREPARE FOR NEXT COLUMN
DISPLAY3:
         MOV       DX,AUX04
         MOV       R6,DH     ;RECALL # ROWS PER COL.
         MOV       DX,AUX03
         MOV       CH,[EDX]
         INC       DX        ;READ MAX LENGTH OF CURRENT COLUMN
         MOV       AUX03,DX  ;UPDATE AUX 3
         ADD       R2,CH     ;CALCULATE HORIZONTAL DISPLACEMENT FOR NEXT COL.
         MOV       AL,R3
         ADD       R2,AL
         JMP       DISPLAY1
DISPLAY4:
         MOV       DL,R2     ;PL=HORIZONTAL DISPLACEMENT OF THE LAST NODE
         MOV       DH,R4     ;PH=VERTICAL DISPLACEMENT OF THE LAST NODE
         MOV       AUX05,DX  ;STORE COORDINATES OF THE LAST NODE
         MOV       DX,AUX03
         MOV       AUX07,DX  ;STORE THE LAST "LENGTH" TABLE POINTER VALUE
         CALL      AUX2SUB7
         MOV       DX,AUX02
         MOV       AUX06,DX  ;STORE THE LAST "TABLE" POINTER VALUE
         MOV       DX,AUX04
         MOV       WORD PTR R5,DX    ;RECALL # ROWS PER COL. AND # NODES
         MOV       AL,R3     ;F3,2=SPACE BETWEEN TWO COLUMNS
         MOV       R2,AL
         MOV       EDX,OFFSET TABLE+3
         MOV       AUX02,DX  ;AUX 2 POINTS TO DESCRIPTION ADDR. FIELD IN "TABLE"
         MOV       EDX,OFFSET _LENGTH
         MOV       AUX03,DX  ;AUX 3 POINTS TO "LENGTH" TABLE
         MOV       R4,1      ;F4=CURRENT NODE # = 1
         MOV       R1,1      ;F1=CURRENT ROW # IN COL. = 1
         CALL      CURSOR
;*        DISPLAY CURSOR POSITION
DISPLAY5:
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxf9
          mov       ax,8b0eh
          mov       ecx,2               ;display 2 code
          call      mxfshw234
          call      onenode
          call      waitcp_mxf
          mov       r0,al
          jmp       request1
notmxf9:
                                        ;Anita
         MOV       DX,0E8BH  ;BRIGHT ON,(8B)
         CALL      OBSHL
         CALL      ONENODE   ;DISPLAY ONE NODE DESCRIPTION

;*        USER'S REQUEST
;*
;*        UP TO NOW F1=CURRENT ROW # IN COLUMN
;*                  F2=HORIZONTAL DISPLACEMENT
;*                  F3=SPACE BETWEEN TWO COLUMNS
;*                  F4=CURRENT NODE #
;*                  F5=# NODES
;*                  F6=# NODES PER COLUMN
;*                  F7=1ST ROW POSITION
;*                  AUX 2 POINTS TO CURRENT DESC. ADDR. FIELD
;*                  AUX 3 POINTS TO CURRENT COL. MAX LENGTH
;*                  AUX 5=COORDINATES OF THE LAST NODE
;*                  AUX 6=THE LAST NODE'S DESC. ADDR.
;*                  AUX 7=THE LAST COLUMN LENGTH
;*
REQUEST: MOV       K,1
         CALL      ENABLE    ;ENABLE KEYBOARD
         CALL      WAITCPB   ;WAIT A KEY
         MOV       AL,K
         MOV       R0,AL     ;STORE INPUT CHARACTER
         CALL      ENABLE5   ;ENABLE CRT
request1:
         CMP       R0,'a'    ;BRANCH IF NOT SMALL LETTER
         Jb        KEY?0
         MOV       AL,R0
         MOV       SL,AL     ;STORE INPUT CHARACTER
         CMP       SL,'z'    ;BRANCH IF NOT SMALL LETTER
         JA        KEY?
         ADD       AL,0E0H   ;CHANGE SMALL LETTER TO CAPITAL LETTER
         MOV       SL,AL
         JMP       KEY?
KEY?0:   MOV       AL,R0
         MOV       SL,AL     ;RESTORE INPUT CHARACTER
KEY?:
         CMP       SL,82H
         JNE       JSM2_02   ;BRANCH IF NOT "RUN"
         JMP       RUN
JSM2_02:
         TEST      SH,ENDI   ;BR IF NOT ENDI
         JZ        KEY?1
         CMP       SL,43H    ;NEXT SCREEN=RUN
         JE        JSM2_03
         CMP       SL,53H    ;SHIFTED NEXT SCREEN = RUN
         JNE       JSM2_04
JSM2_03:
         JMP       RUN
JSM2_04:
         CMP       SL,42H    ;PREV SCREEN = CLEAR
         JE        JSM2_05
         CMP       SL,52H    ;SHIFTED PREV SCREEN = CLEAR
         JNE       JSM2_06
JSM2_05:
         JMP       CLEAR
JSM2_06:
         JMP       DISPLAY5  ;INVALID ENDI KEY
KEY?1:
         CMP       SL,81H    ;BRANCH IF NOT "CLEAR"
         JNE       JSM2_07
         JMP       CLEAR
JSM2_07:
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfa
          mov       al,2eh
          call      mxfshwone
          jmp       short jsm207
notmxfa:
                                        ;Anita
         MOV       DX,2E01H  ;PRINT "."
         CALL      OBSTROBN
jsm207:
         CALL      ONENODE   ;DISPLAY ONE NODE DESCRIPTION
         CMP       SL,20H    ;BRANCH IF NOT "SPACE"
         JNE       JSM2_08
         JMP       SPACE
JSM2_08:
         CMP       SL,08H    ;BRANCH IF NOT "BACKSPACE"
         JNE       JSM2_09
         JMP       BACKSPAC
;        TITLE     STARTING CHAR.?
;        STARTING CHARACTER?
JSM2_09:
         MOV       AL,R4
         MOV       R0,AL     ;F0=CURRENT NODE #
STARTCHR:
         MOV       AL,R0
         CMP       AL,R5     ;BRANCH IF IN THE REAR SECTION
         Jb        STARTCH1
         MOV       EDX,OFFSET TABLE-4   ;SEARCH FROM THE BEGINNING
         MOV       AUX02,DX
         MOV       EDX,OFFSET _LENGTH
         MOV       AUX03,DX
         MOV       R0,0      ;F0=CURRENT NODE #
         MOV       R1,0      ;F1=CURRENT ROW # IN COL.
         MOV       AL,R3     ;F2=HORIZONTAL DISPLACEMENT
         MOV       R2,AL     ;F2=HORIZONTAL DISPLACEMENT
         CALL      CURSOR    ;MOVE CURSOR TO THE BEGINNING
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfb
          mov       al,0ch
          call      mxfshwone
          jmp       short startch1
notmxfb:
                                        ;Anita
         MOV       DX,0C01H
         CALL      OBSTROBN
STARTCH1:
         INC       R0        ;INCREMENT CURRENT NODE #
         INC       R1        ;INCREMENT CURRENT NODE # IN COL.
         CALL      AUX2ADD7  ;UPDATE "TABLE" POINTER
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfc
          mov       al,0ah
          call      mxfshwone
          jmp       short startch1_
notmxfc:
                                        ;Anita
         MOV       DX,0A01H  ;MOVE CURSOR DOWN
         CALL      OBSTROBN
startch1_:
         MOV       AL,R1     ;BRANCH IF NOT FINISHED SEARCHING ONE COL.
         CMP       AL,R6
         JbE       STARTCH2
         MOV       R1,1
         MOV       DX,AUX03
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         MOV       AUX03,DX  ;UPDATE "LENGTH" TABLE POINTER
         MOV       AL,R2
         ADD       AL,CH     ;UPDATE HORIZONTAL DISPLACEMENT
         ADD       AL,R3
         MOV       R2,AL
         CALL      CURSOR    ;UPDATE CURSOR POSITION
STARTCH2:
         MOV       AL,R0
         CMP       AL,R4
         JE        DISPLAY5  ;BRANCH IF SEARCH FAIL
         MOV       AL,SL     ;RESTORE INPUT CHARACTER
         MOV       K,AL
         MOV       DX,AUX02
         MOV       CH,BYTE PTR [EDX]
         INC       DX        ;READ DESC. ADDR.
         MOV       SL,CH
         MOV       CH,BYTE PTR [EDX]
         MOV       DL,CH
         MOV       DH,SL     ;PC'=DESCRIPTION ADDR.
         MOV       CH,BYTE PTR [EDX] ;READ 1ST CHARACTER IN DESCRIPTION
         MOV       AL,K
         MOV       SL,AL
         CMP       CH,K      ;BRANCH IF NOT EQUAL
         JNE       STARTCHR
;*        SUCCESSFUL SEARCH
         MOV       AL,R0     ;F4=CURRENT NODE #
         MOV       R4,AL     ;F4=CURRENT NODE #
         JMP       DISPLAY5  ;WAIT FOR NEXT REQUEST

;*
;*        SPACE
;*
SPACE:   MOV       AL,R4     ;BRANCH IF NOT THE LAST NODE
         CMP       AL,R5
         JNE       SPACE2
         MOV       AL,R3
         MOV       R2,AL
         MOV       EDX,OFFSET TABLE+3
         MOV       AUX02,DX
         MOV       EDX,OFFSET _LENGTH
         MOV       AUX03,DX
         MOV       R4,1
         MOV       R1,1
         CALL      CURSOR
         JMP       SPACE4    ;CHECK IF NEXT NODEC IS "B" TYPE
SPACE2:  INC       R4        ;INCREMENT CURRENT NODE #
         CALL      AUX2ADD7  ;AUX 2 POINTS TO NEXT NODE
         MOV       AL,R1     ;BRANCH IF NOT END OF ONE COLUMN
         CMP       AL,R6
         JNE       SPACE3
         MOV       DX,AUX03
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         MOV       AUX03,DX  ;AUX 3 POINTS TO NEXT COL. LENGTH
         MOV       AL,R2
         ADD       AL,CH     ;UPDATE HORIZONTAL DISPLACEMENT
         ADD       AL,R3
         MOV       R2,AL
         MOV       R1,1
         CALL      CURSOR
         JMP       SPACE4    ;CHECK IF NEXT NODE IS "B" TYPE
SPACE3:
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfd
          mov       al,0ah
          call      mxfshwone
          inc       r1
          jmp       short space4
notmxfd:
                                        ;Anita
         MOV       DX,0A01H  ;CURSOR DOWN
         CALL      OBSTROBN
         INC       R1        ;INCREMENT CURRENT ROW # IN COL.
SPACE4:  MOV       DX,AUX02
         ADD       DL,3
         MOV       CH,BYTE PTR [EDX]  ;READ TYPE
         CMP       CH,42H    ;BRANCH IF "B" TYPE
         JE        SPACE
         JMP       DISPLAY5  ;WAIT FOR NEXT REQUEST

;*
;*        BACKSPACE
;*
BACKSPAC:
         DEC       R4        ;DECREMENT CURRENT NODE #
         JNZ       BACKSPA2  ;BRANCH IF NOT FIRST NODE
         MOV       DX,AUX05  ;GET DISPLAY COORDINATES OF THE LAST NODE
         MOV       R1,DH     ;F1=VERTICAL DISPLACEMENT
         MOV       R2,DL     ;F2=HORIZONTAL DISPLACEMENT
         MOV       DX,AUX06  ;GET "TABLE" POINTER VALUE
         MOV       AUX02,DX
         MOV       DX,AUX07  ;GET "LENGTH" POINTER VALUE
         MOV       AUX03,DX
         MOV       AL,R5     ;F4=CURRENT NODE #
         MOV       R4,AL
backspa:
         CALL      CURSOR    ;MOVE CURSOR
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfe
          mov       al,0ah
          mov       ecx,0
          mov       cl,r1
          dec       cl
          call      mxfrpt
          jmp       backspa4
notmxfe:
                                        ;Anita
         MOV       DH,0AH
         MOV       DL,R1
         DEC       DL
         CALL      OBSTROBN  ;MOVE CURSOR DOWM TO THE LAST NODE
         JMP       BACKSPA4  ;CHECK IF THE NODE IS "B" TYPE
BACKSPA2:
         CALL      AUX2SUB7
         DEC       R1        ;DECREMENT CURRENT ROW # IN COL.
         JNZ       BACKSPA3  ;BRANCH IF NOT THE 1ST NODE OF A COL.
         MOV       DX,AUX03
         DEC       DX
         MOV       CH,BYTE PTR [EDX]
         MOV       AUX03,DX  ;UPDATE "LENGTH" POINTER
         MOV       AL,R2
         SUB       AL,CH     ;UPDATE HORIZONTAL DISPLACEMENT
         DEC       AL
         SUB       AL,R3
         DEC       AL
         MOV       R2,AL
         MOV       AL,R6     ;F1=THE LAST ROW # IN THE COL.
         MOV       R1,AL
          jmp       backspa
;        CALL      CURSOR    ;MOVE CURSOR
;        MOV       DH,0AH
;        MOV       DL,R1
;        DEC       DL
;        CALL      OBSTROBN  ;MOVE CURSOR TO THE NODE
;        JMP       BACKSPA4  ;CHECK IF THE NODE IS "B" TYPE
BACKSPA3:
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxff
          mov       al,0ch
          call      mxfshwone
          jmp       backspa4
notmxff:
                                        ;Anita
         MOV       DX,0C01H  ;MOVE CURSOR UP
         CALL      OBSTROBN
BACKSPA4:
         MOV       DX,AUX02
         ADD       DL,3
         MOV       CH,BYTE PTR [EDX] ;READ TYPE
         CMP       CH,42H    ;BRANCH IF "B" TYPE
         JE        BACKSPAC
         JMP       DISPLAY5  ;WAIT FOR NEXT REQUEST

;*
;*        RUN
;*
RUN:     MOV       DX,AUX02
         SUB       DX,3
         MOV       CH,BYTE PTR [EDX] ;READ NODENAME ADDR.
         INC       DX

         MOV       R6,CH
         MOV       CH,BYTE PTR [EDX]
         INC       DX

         MOV       R5,CH
         MOV       CH,BYTE PTR [EDX] ;READ NODENAME LENGTH
         INC       DX

         MOV       SL,CH     ;SL=NODENAME LENGTH
         MOV       DX,WORD PTR R5
         MOV       AUX05,DX  ;AUX 5=NODENAME ADDR.
         MOV       DX,AUX02
         ADD       DX,3
         MOV       AUX02,DX
         MOV       CH,BYTE PTR [EDX] ;READ TYPE
         CMP       CH,50H    ;BRANCH IF NOT P TYPE
         JZ        RUN1
         MOV       R5,0      ;SET F5=0 IF M TYPE
         JMP       LOAD

RUN1:    MOV       DX,AUX05
         INC       DX        ;THE FIRST BYTE MUST BE "@"
         DEC       SL        ;DECREMENT SL
         CALL      END?
         MOV       R7,CH
         CALL      END?
         MOV       R6,CH
         CALL      END?
         MOV       R5,CH
         CALL      WIPE      ;WIPE OUT UNNEEDED MESSAGES ON SCREEN
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfl
          mov       al,05
          call      mxfshwone           ;cursor on
          or        sl,namemode
          jmp       disk5
notmxfl:
         MOV       DX,0501H  ;CURSOR ON
         CALL      OBSTROBN
         OR        SL,NAMEMODE
         JMP       DISK5     ;RESTART BOOTSTRAP
END?:    TEST      SL,0FH
         JZ        END?1
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         DEC       SL
         RET
END?1:   MOV       R0,20H
         MOV       AL,R0
         MOV       BYTE PTR [EDX],AL
         MOV       CH,BYTE PTR [EDX]
         RET
;*
;*        CLEAR
;*
CLEAR:
        MOV     EDX,XDATA
        MOV     K,4
        MOV     R0,22H
CLEAR_1:
        CALL    CMPBYTE
        DEC     K
        JNZ     CLEAR_1
        ADD     EDX,3
        MOV     CH,[EDX]
        INC     EDX
        CMP     CH,30H
        JZ      REQUEST
        ADD     EDX,2
        MOV     AUX05,DX
        MOV     R0,22H
        CALL    CMPBYTE
        MOV     EBX,EDX
        SUB     BX,AUX05
        DEC     BX
        MOV     R7,BL
        MOV     SL,BL
        JMP     LOAD0

AUX2ADD7:
         ADD       AUX02,7
         RET

AUX2SUB7:
         SUB       AUX02,7
         RET
;*
;*        ONENODE: DISPLAY ONE NODE DESCRIPTION
;*
;*          ENTRY: AUX 2 POINTS TO DESCRIPTION ADDRESS FIELD IN "TABLE"
;*          REGISTERS USED: K,CH,CL,PH,PL,AUX 4
;*          SUBROUTINES USED: OBSTROBN,SDISPLA2
;*
ONENODE: MOV       DX,WORD PTR R1    ;STORE F2,F1
         MOV       AUX04,DX
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxf7
          mov       al,20h              ;display space
          call      mxfshwone
          jmp       onenode1
notmxf7:
                                        ;Anita
         MOV       DX,2001H  ;PRINT " "
         CALL      OBSTROBN
onenode1:
         MOV       DX,AUX02
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         MOV       R2,CH     ;F2=HIGH ADDR.
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         MOV       R1,CH     ;F1=LOW ADDR.
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         MOV       R0,CH     ;F0=LENGTH
         MOV       CH,BYTE PTR [EDX]
         MOV       DX,WORD PTR R1    ;PC'S=DESCRIPTION ADDR.
         MOV       AL,R0     ;F2=# OF BACKSPACE
         ADD       AL,2
         MOV       R2,AL
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxf8
          mov       esi,edx             ;display space
          mov       ecx,0
          mov       cl,r0
          call      mxfdsply
          mov       al,0fh              ;bright off
          call      mxfshwone
          mov       al,08h              ;back space r2 times
          mov       ecx,0
          mov       cl,r2
          call      mxfrpt
          mov       dx,aux04
          mov       word ptr r1,dx
          ret
notmxf8:
                                        ;Anita
         CALL      SDISPLA1  ;DISPLAY DESCRIPTION
         MOV       DX,0F01H  ;BRIGHT OFF
         CALL      OBSTROBN
         MOV       DH,08H    ;BACKSPACE
         MOV       DL,R2     ;PL=# OF BACKSPACE
         CALL      OBSTROBN
         MOV       DX,AUX04  ;RESTORE F2,F1
         MOV       WORD PTR R1,DX
         RET
;*
;*   DISK: LOAD A FILE TO MEMORY
;*
;*       ENTRY: SL=FILENAME LENGTH
;*              F5=00 IF Menu TYPE FILE
;*                 FF IF Program TYPE FILE (F5 IS SET BEFORE 'LOAD' OR 'RUN1')
;*              AUX 5=ADDRESS OF THE AREA WHERE FILENAME IS
;*       REGISTERS MODIFIED: SH,CH,CL,PC'S,F0,F1,F2,F3,F4,F7
;*                           AUX C, AUX D, AUX F
;*       SUBROUTINES USED: ENABLED, DREAD WVDMCH (IN BOOTSTRAP)
;*                         ENABLE5,OBSHL (IN BOOTSTRAP)
;*                         OBSTROBN,OBSTROBE (IN BOOTSTRAP)
;*                         CMPBYTE
;*

DISK:
        CALL    ENABLED         ;ENABLE DISK
        MOV     AUX10,DISKWORK
        MOV     AUX0F,0
        CALL    DREAD           ;READ SECTOR 0 TO DISKWORK BUFFER
        MOV     EDX,DISKWORK
        MOV     CL,[EDX+1]
        MOV     AUX0C,CX        ;CL = # INDEX SECTOR
;*
;*        SET UP CONSTANTS AND COUNTERS
;*
        ADD     EDX,10H
READENTX1:
        MOV     WORD PTR R0,DX
READENTY1:
        MOV     DX,WORD PTR R0
        CMP     BYTE PTR [EDX],10H      ;BR IF USAGE <> 10H
        JNZ     NXTENTRY1
        ADD     EDX,8                   ;POINT TO BEGIN OF FILENAME
        XOR     ECX,ECX
        MOV     CL,SL                   ;ECX = COMPARE LENGTH
        MOV     ESI,EDX
          mov       edi,0
        MOV     DI,AUX05
        CLD
        REPZ    CMPSB
        JNZ     NXTENTRY1                ;BR IF FILENAME NOT EQUAL

;*
;*        FILE FOUND
;*
        CMP     R5,0
        JZ      MENUTYPE
        POP     EDX             ;POP RETURN ADDRESS FOR STACK BALANCE
        JMP     RUN1
MENUTYPE:
        MOV     DX,WORD PTR R0
        MOV     CX,[EDX+2]
        XCHG    CH,CL
        MOV     AUX0F,CX        ;START SECTOR ADDRESS OF FILENAME

;*
;*        COPY FILE FROM DISK TO DATA MEMORY
;*
;;        MOV     R3,0FDH         ;END OF SECTOR
;;        MOV     EDX,OFFSET XDATA
;;        MOV     AUX0D,DX
          mov       edi,xdata
MOVESECA:
        MOV     AUX10,DISKWORK
        CALL    DREAD
          mov       esi,diskwork
          cmp       byte ptr [esi],40h  ;is header sector?
          je        moveseca            ;read next sector
          mov       dl,0fdh             ;end of sector
          cmp       byte ptr [esi],20h  ;is trailer sector?
          jne       movesec1
          mov       dl,0feh             ;end of file
movesec1:
          lodsb
          stosb
          cmp       al,dl
          jne       movesec1
          cmp       dl,0fdh             ;is end of file?
          je        moveseca            ;no,
;;        MOV     EDX,DISKWORK
;;        MOV     CH,[EDX]
;;        CMP     CH,40H
;;        JZ      HEADER          ;HEADER SECTOR
;;        CMP     CH,00H
;;        JZ      MOVESEC1        ;INTERMEDIATE SECTOR
;;                                ;TRAILER SECTOR
;;        MOV     R3,0FEH         ;END OF FILE
;;MOVESEC1:
;;        MOV     AUX0C,DX
;;        INC     AUX0C
;;        MOV     DX,AUX0D
;;        XCHG    DX,AUX0C        ;AFTER EXCHANGE, DX= READ ADDRESS & AUX0C = WRITE ADDRESS
;;READDATA:
;;        MOV     CH,[EDX]
;;        XCHG    DX,AUX0C
;;        INC     AUX0C
;;        MOV     [EDX],CH
;;        XCHG    DX,AUX0C
;;        INC     AUX0C
;;        CMP     CH,R3
;;        JNZ     READDATA
;;        XCHG    DX,AUX0C
;;        MOV     AUX0D,DX
;;
;;;*        HEADER SECTOR
;;HEADER:                                 ;IGNORE HEADER
;;        MOV     AL,0FEH
;;        CMP     AL,R3
;;        JNZ     MOVESECA
        RET
;*
;*        NEXT ENTRY FOR FILE SEARCH
;*
NXTENTRY1:
        ADD     R0,10H
        CMP     R0,0
        JNZ     READENTY1
NXTSECT1:
        MOV     DX,AUX0C
        MOV     R4,DL
        MOV     DX,AUX0F
        CMP     DL,R4
        JZ      NOTFOUND
        MOV     AUX10,DISKWORK
        CALL    DREAD
        MOV     EDX,DISKWORK
        JMP     READENTX1
NOTFOUND:
         CALL      WIPE      ;WIPE OUT UNNEEDED MESSAGES ON SCREEN
         CALL      ATTRIBUT  ;BEEP,ATTRIBUTE BRIGHT AND BLINK
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfg
          mov       esi,offset filmsg
          mov       ecx,filmsg_len
          call      mxfdsply
          mov       esi,0
          mov       si,aux05            ;get the start address
          mov       ecx,0
          mov       cl,sl
          call      mxfdsply
          mov       esi,offset nofndmsg
          mov       ecx,nofndmsg_len
          call      mxfdsply
          jmp       error_820
notmxfg:
                                        ;Anita
         MOV       DX,4649H  ;FI
         CALL      OBSHL
         MOV       DX,4C45H  ;LE
         CALL      OBSHL
         MOV       K,20H     ;BLANK
         CALL      OBSTROBE  ;STROBE THE CHAR. IN K TO CRT
         MOV       DX,AUX05  ;PC'S POINT TO THE FILENAME
         MOV       AL,SL     ;F0=FILENAME LENGTH
         MOV       R0,AL
         CALL      SDISPLA1  ;DISPLAY FILENAME
         MOV       DX,204EH  ;N
         CALL      OBSHL
         MOV       DX,4F54H  ;OT
         CALL      OBSHL
         MOV       DX,2046H  ; F
         CALL      OBSHL
         MOV       DX,4F55H  ;OU
         CALL      OBSHL
         MOV       DX,4E44H  ;ND
         CALL      OBSHL
         mov       eax,offset restart_1
         mov       resetproc,eax
         jmp       error_82a

ERROR1:  CALL      ATTRIBUT
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfh
          mov       esi,offset nopgmmsg
          mov       ecx,nopgmmsg_len
          call      mxfdsply
          jmp       error_820
notmxfh:
                                        ;Anita
         MOV       DX,4E4FH  ;NO
         CALL      OBSHL
         MOV       DX,5420H  ;T
         CALL      OBSHL
         MOV       DX,4120H  ;A
         CALL      OBSHL
         MOV       DX,5052H  ;PR
         CALL      OBSHL
         MOV       DX,4F47H  ;OG
         CALL      OBSHL
         MOV       DX,5241H  ;RA
         CALL      OBSHL
         MOV       DX,4D20H  ;M
         CALL      OBSHL
         MOV       DX,5245H  ;RE
         CALL      OBSHL
         MOV       DX,434FH  ;CO
         CALL      OBSHL
         MOV       DX,5244H  ;RD
         CALL      OBSHL
         mov       eax,offset restart_1
         mov       resetproc,eax
         jmp       error_82a

;        TITLE     SUBROUTINES
ATTRIBUT:
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfi
          mov       esi,offset att1msg
          mov       ecx,att1msg_len
          call      mxfdsply
          ret
notmxfi:
                                        ;Anita
         CALL      ENABLE5   ;ENABLE CRT
         MOV       DX,0702H  ;BEEP, BRIGHT, BLINK
         CALL      OBSHL
         MOV       DX,0404H
         CALL      OBSHL
         MOV       DX,000EH
         CALL      OBSHL
         RET
;*
;*        SEARCH97: SEARCH THR "DATA" KEY CODE 97
;*
;*          ENTRY: PC'S=ADDRESS TO START SEARCHING
;*          REGISTERS MODIFIED: CH,CL,PC'S,F0,F1
;*          SUBROUTINE USED: CMPBYTE
;*          RETURN: PC'S POINT TO THE 2ND BYTE AFTER 97,
;*                  (SKIP THE 1ST QUOTE)
;*
SEARCH97:
         MOV       R1,97H
         MOV       R0,0FFH
_CMP:    CALL      CMPBYTE
         MOV       CH,BYTE PTR [EDX]
         INC       DX        ;READ LINE #
         MOV       AL,CH
         AND       AL,0F0H
         CMP       AL,90H
         JNE       _CMP
         INC       DX
         MOV       CH,BYTE PTR [EDX]
         INC       DX        ;READ KEY CODE
         CMP       R1,CH
         JNE       _CMP
         INC       DX        ;INCREMENT PC'S (SKIP THE 1ST QUOTE)
         RET
;*
;*        NEXTITEM: FIND THE STARTING ADDRESS
;*                  OF NEXT ITEM
;*
;*          ENTRY: PC'S=ADDRESS TO START SEARCHING
;*          REGISTERS MODIFIED: CH,CL,F0
;*          SUBROUTINE USED: CMPBYTE
;*          RETURN: PC'S POINT TO START ADDRESS OF NEXT ITEM
;*                  (SKIP THE QUOTE)
;*
NEXTITEM:
         CALL      SEARCH22  ;SEARCH FOR QUOTE MARK
SEARCH22:
         MOV       R0,22H
         CALL      CMPBYTE
         RET

;*
;*        CMPBYTE: COMPARE ONE BYTE
;*
;*          ENTRY: F0=THE BYTE TO BE COMPARED
;*                 PC'S=START ADDRESS TO COMPARE
;*          REGISTERS MODIFIED: CH,CL,PC'S
;*          RETURN: PC'S POINT TO THE NEXT BYTE
;*                  AFTER THE BYTE FOUND
;*
CMPBYTE: MOV       CH,BYTE PTR [EDX]
         INC       DX
         CMP       CH,R0
         JNE       CMPBYTE
         RET
;*
;*        DIVISION
;*             ENTRY: F0=DIVIDENT, F1=DIVISOR
;*             REGISTERS MODIFIED: F0,F2
;*             RETURN: F2=RESULT
;*
DIVISION:
         MOV       R2,0
DIVISIO1:
         MOV       AL,R1
         CMP       R0,AL
         Jb        DIVISIO2
         INC       R2
         SUB       R0,AL
         Jmp       DIVISIO1  ;BRANCH IF CARRY SET
DIVISIO2:
         RET
;*
;*        SDISPLAY: SEND A BLOCK OF BYTES TO CRT
;*
;*          ENTRY: CRT IS ENABLED
;*                 F0=# BYTES TO DISPLAY
;*                 PC'S=START ADDRESS OF THE BLOCK OF BYTES
;*          REGISTERS MODIFIED: CH,CL,K,PC'S,F0,F1,AUX 5
;*          SUBROUTINE USED: OBSTROBE,OBSHL (IN BOOTSTRAP)
;*          RETURN: F0=0
;*
SDISPLA0:
         MOV       K,'B'
         CMP       CH,K      ;BRANCH IF NOT 'B' TYPE
         JNE       SDISPLAY
         MOV       R1,0FEH   ;SET F1=FE FOR LATER USE
         JMP       SDISPLA2
SDISPLAY:
         MOV       AUX05,DX  ;STORE PC'S
         MOV       DX,2E20H  ;PRINT ". "
         CALL      OBSHL     ;
         MOV       DX,AUX05
SDISPLA1:
         MOV       CH,BYTE PTR [EDX]
         INC       DX
         MOV       K,CH
         CALL      OBSTROBE  ;SEND THE CHARACTER TO CRT
         DEC       R0
         JNZ       SDISPLA1
SDISPLA2:
         RET
;*
;*        CURSOR: MOVE CURSOR TO THE 1ST NODE OF CERTAIN COLUMN
;*
;*          ENTRY: CRT IS ENABLED
;*                 F2=HORIZONTAL DISPLACEMENT FROM LEFTMOST
;*                 F7=1ST ROW POSITION
;*          REGISTERS MODIFIED: K,PC'S
;*          SUBROUTINE USED: OBSTROBN (IN BOOTSYRAP)
;*
CURSOR:
                                        ;Anita Lin for high speed channle board
          test      hscboard,mxfbit
          jz        notmxfj
          mov       al,01
          call      mxfshwone           ;home cursor
          mov       al,0ah
          mov       ecx,0
          mov       cl,r7
          call      mxfrpt              ;move cursor vertically
          mov       al,09h
          mov       cl,r2
          call      mxfrpt              ;move cursor vertically
          ret
notmxfj:
                                        ;Anita
         MOV       DX,0101H  ;HOME CURSOR
         CALL      OBSTROBN
;*        MOVE CURSOR VERTICALLY
         MOV       DH,0AH
         MOV       DL,R7
         CALL      OBSTROBN
;*        MOVE CURSOR HORIZONTALLY
         MOV       DH,09
         MOV       DL,R2
         CALL      OBSTROBN
         RET

;*
;*        WIPE: WIPE OUT UNNEEDED MESSAGES ON SCREEN
;*
WIPE:    MOV       EDX,CPURDY
         MOV       BYTE PTR FS:[EDX],0
         CALL      ENABLE5   ;ENABLE CRT
         MOV       K,0       ;DETERMINE CRT SIZE FOR ERASE
         MOV       EDX,IBGET
         MOV       AL,BYTE PTR FS:[EDX]
         MOV       K,AL
;        CIO       SRS
         CALL      DELAY10
         CALL      DELAY10
         MOV       DH,20H
         MOV       DL,3FH
                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jnz       menu_01_
          jmp       notmxfk
menu_01_:
          mov       edi,mxfbuf_sts
chk_stsk:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_stsk1           ;no, check complete
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;for stack balance, pop cs:ip
          mov       edx,resetproc
          jmp       edx
chk_stsk1:
          and       ah,0f0h
          cmp       ah,0f0h             ;does cmd complete ?
          jne       chk_stsk
          mov       edi,mxfbuf_abs      ;edi point to mxf 1st port cmd buffer
          mov       word ptr gs:[edi],abs7       ;display command
          mov       edi,mxfbuf_parm
          inc       edi
          mov       ah,0                ;initial count
          mov       dword ptr byte ptr gs:[edi],0a0a0106h;cursor off, home cursor, down 2 line
          add       edi,4
          add       ah,4
          mov       al,dh
          mov       ecx,0
          mov       cl,dl               ;count
          push      es
          push      gs
          pop       es
          rep       stosb
          pop       es
          add       ah,dl
          mov       word ptr gs:[edi],0a0dh     ;cursor off, home cursor, down 2 line
          add       ah,2
          add       edi,2
          mov       al,dh
          mov       cl,dl               ;count
          push      es
          push      gs
          pop       es
          rep       stosb
          pop       es
          add       ah,dl
          mov       byte ptr gs:[edi],0dh       ;cursor off, home cursor, down 2 line
          inc       ah
          mov       edi,mxfbuf_parm
          mov       byte ptr gs:[edi],ah         ;move counter here
          mov       edi,mxfbuf_sts
          mov       byte ptr gs:[edi],0fh        ;tell mxf this is a completely cmd
          ret
notmxfk:
                                        ;Anita
         TEST      K,10H
         JNZ       MENU_01
         MOV       DL,2FH
MENU_01:
         PUSH      DX
         MOV       DX,0601H  ;CURSOR OFF, HOME CURSOR
         CALL      OBSHL
         MOV       DX,0A0AH  ;MOVE CURSOR DOWN 2 LINES
         CALL      OBSHL
         POP       DX        ;GET ERASE SIZE
         PUSH      DX
         CALL      OBSTROBN
         MOV       DX,0D0AH  ;CARRIAGE RETURN, LINE FEED
         CALL      OBSHL
         POP       DX
         CALL      OBSTROBN
         MOV       K,0DH     ;CARRIAGE RETURN
         JMP       OBSTROBE

;*****************************************************
; main program
;*****************************************************
horse:                          ;loader really begins here

        mov     ax,data         ;ds,es both point to data
        mov     ds,ax
        mov     es,ax

        call    enabled
        mov     aux10,message
        call    dread
        inc     stsec
        dec     file_l

                                        ;Anita Lin for high speed channel board
          test      hscboard,mxfbit
          jz        notmxfm
          mov       ecx,4bh
          call      mxfblnk
          mov       esi,message
          mov       cl,[esi]
          inc       esi
          call      mxfdsply
          jmp       enter_os
notmxfm:
                                        ;Anita
        call    enable5
        mov     dx,204bh
        call    obstrobn
        mov     esi,message
        xor     ecx,ecx
        mov     cl,[esi]
        inc     esi
                                ;display "Loading Multi-User Basic-2 ......"
loadloop:
        mov     al,byte ptr [esi]
        mov     k,al
        call    obstrobe
        inc     esi
        loop    loadloop
                                        ;Anita
enter_os:
          push      ds                  ;create idt alias entry in gdt table
          mov       ax,gdt_alias        ;get gdt alias
          mov       ds,ax               ;now ds point to gdt table
          mov       edx,2*8             ;gdt entry 2 is idt alias
          mov       word ptr [edx],800h ;limit 0-15 of idt table, largest
          add       edx,2               ;
          mov       word ptr [edx],160h ;base 15-0 of idt table
          add       edx,2
          mov       byte ptr [edx],0    ;base 23-16 of idt table
          inc       edx
          mov       word ptr [edx],4092h;data access right
          add       edx,2
          mov       word ptr [edx],0    ;base 31-24
          mov       ax,ds               ;get the gdt alias
          add       ax,8                ;get idt alias selector
          mov       ds,ax               ;now, ds point to idt table
          mov       ax,cs               ;get code selector in high word of eax
          shl       eax,16
          mov       ebx,offset int_proc ;get offset of interrupt service routine
          and       ebx,0ffffh
          or        eax,ebx
          mov       ebx,offset int_proc
          and       ebx,0ffff0000h
          or        ebx,8e00h
          mov       edx,0               ;from entry 0, fill every descriptor
          mov       ecx,0ffh            ;
put_null:                               ;initialize all entry to a iret proc.
          mov       dword ptr [edx],eax
          mov       dword ptr [edx+4],ebx
          add       edx,8
          loop      put_null
        mov     ax,cs
        shl     eax,16
        mov     ebx,offset idt_dsp
        and     ebx,0ffffh
        or      eax,ebx
        mov     ebx,offset idt_dsp
        and     ebx,0ffff0000h
        or      ebx,8e00h
        mov     esi,2fh*8
        mov     dword ptr [esi],eax
        mov     dword ptr [esi+4],ebx
          pop       ds                  ;restore data segment
          lidt      idt_pword           ;now, idtr point to idt table
;         int       2fh

                                        ;Anita
        mov     edx,offset stl_for
        add     edx,bootdev
        mov     ax,actdev
        mov     [edx],ax

        mov     ax,task_slot
        mov     ecx,desc_count
        call    create_ldt
        call    load_desc
        call    load_segment
        mov     ax,task_slot
        add     ax,8h
        call    create_tss
        push    task_slot
        push    ldt_right
        call    change_at
        mov     ax,task_slot
        add     ax,8
        mov     task_slot,ax
        jmp     task_entry
                                        ;Anita
int_proc  proc
          iretd
int_proc  endp

;+++++ INT 2F  Service Routine ..
idt_dsp:
        push    eax
        push    ecx
        push    esi
        cli
        call    enable5
        mov     esi,offset idt_test
        xor     ecx,ecx
        mov     cl,[esi]
        inc     esi
testloop:
        mov     al,byte ptr [esi]
        mov     k,al
        call    obstrobe
        inc     esi
        loop    testloop
        pop     esi
        pop     ecx
        pop     eax
        sti
        iretd
                                        ;Anita

;*        TITLE     DREAD DREADB
;*     DREAD: READ ONE SECTOR FROM DISK
;*            (DLOAD1 ON 2200T, 41A4)
;*
;*          ENTRY: PHASE = EXECUTION
;*                 DISK ENABLED.
;*              AUX10   = ADDRESS OF WHERE TO STORE DATA
;*              AUX F   = SECTOR ADDRESS OF SECTOR TO READ
;*
;*          RETURN: AUXF = ADDRESS OF SECTOR ACCESSED +1
;*
;*          TRANSFER RATE:
;*
;*               2600 MAX. TRANSFER RATE = 3.7 USEC./CHAR.
;*                                  (.95MS FOR 256 BYTES)
;*
;*               TYPICAL TRANSFER RATE = 2MS FOR 56 BYTES
;*                    (SINCE IBS FROM DISK IS 8USEC.)
;*
;*               2200 MAX. TRANSFER RATE = 19.8 USEC./CHAR
;*                                   (5.1MS FOR 256 BYTES)
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,F0-F2,K,AUX0,F
;*
;*
;*DREAD    EQU       ;*
;*        SB        CMNDINIT  INITIALIZE DISK CONTROLLER
;*        MVI       0,F0
;*        SB        DISKCMND  SEND READ COMMAND WITH SECTOR ADDRESS TO DISK
;*        BNR       F0,,DREAD BRANCH IF ECHO ERROR >>> DIFFERENT THAN 2200<<
;*        SB        AKN       GET ACKNOWLEDGEMENT FOR VALID SECTOR ADDRESS
;*        SB        OBSNR     SIGNAL DISK TO CHECK IOB'S TO INSURE NOT TRYING

dread:
                                        ;Anita Lin for high speed channel board
          test      hscboard,dskbit
          jz        not_22c11_II
          push      esi
          push      edi
          mov       esi,rcbaddr
chkcmd:
          call      breakpt_
          cmp       byte ptr gs:[esi],0          ;does 22c11 ready to get command?
          jne       chkcmd
          inc       esi
          mov       byte ptr gs:[esi],01;read command
          inc       esi
          mov       byte ptr gs:[esi],0 ;dummy byte for feature
          inc       esi
          mov       ax,actdev
          mov       word ptr gs:[esi],ax;platter address
          add       esi,2
          mov       byte ptr gs:[esi],0 ;high byte of starting sector addr.
          inc       esi
          mov       ax,aux0f            ;get the starting sector address
          xchg      ah,al               ;low byte in 9th byte
          mov       word ptr gs:[esi],ax
          add       esi,2
          mov       word ptr gs:[esi],1 ;no. of sectors to be read
          add       esi,2
          mov       byte ptr gs:[esi],0 ;no. of sectors to be read
          mov       esi,rcbaddr
          mov       byte ptr gs:[esi],80h       ;now do command
chkcmd1:                                ;now, check command completely
          call      breakpt_
          cmp       byte ptr gs:[esi],0         ;does 22c11 ready to get command?
          jne       chkcmd1
          cmp       byte ptr gs:[esi+2],0       ;is return no error?
          je        get_dskdata
          mov       al,byte ptr gs:[esi+2]      ;put error code to AL
          jmp       error_82
get_dskdata:
          mov       edi,0
          mov       di,aux10
          mov       esi,dskbuf
          mov       ecx,256
          push      es
          push      ds
          push      ds
          pop       es
          push      gs
          pop       ds
          rep       movsb
          pop       ds
          pop       es
          inc       aux0f
          pop       edi
          pop       esi
          ret
not_22c11_II:
          push      edi
                                        ;Anita
        call    cmndinit
        mov     r0,0
        call    diskcmnd
        cmp     r0,0
        jne     dread
        call    akn
        call    obsnr

;*      TO RESTART. (2200 DOES NOT WAIT FOR READY BEFORE
;*      STROBE AND NEITHER DOES THIS NEW BOOTSTRAP)
;*        SB        AKN1      WAIT FOR ACKNOWLEDGEMENT FROM DISK (UP TO 5SEC.)
;*      DATA TRANSFER
;*        LPI       DISKWORK  PC'S POINT TO AREA TO STORE DATA READ
;*        MVI       0,F2      LRC (F2) = 00

        call    akn1
        mov     dx,aux10

;*DREADB1  SB        WAITCPB   ACCEPT INPUT, CARRY OFF
;*        AC,,0     F2,K,F2   ADD CHARACTER TO LRC
;*        MV        K,F1      SAVE HIGH BYTE OF PAIR
;*        SB        WAITCPB   ACCEPT INPUT, CARRY OFF
;*        AC,,0     F2,K,F2   ADD CHARACTER TO LRC

          mov       bl,0                ;Anita for cs/386-II

dreadb1:
        call    waitcpb
        mov     al,k
          add       bl,al               ;Anita for cs/386-II
        mov     r1,al
        call    waitcpb
        mov     al,k
          add       bl,al               ;Anita for cs/386-II

;*        MV        K,F0      SAVE LOW BYTE OF PAIR
;*        SB        WVDM16    WRITE AND VERIFY 2 BYTES
;*        OR        +,,       INCREMENT PC'S BY 2
;*        OR        +,,F0     F0 = 00
;*        BNR       F0,PL,DREADB1       BRANCH IF < 256 CHARACTERS READ

        mov     r0,al
        call    wvdm16
        mov     r0,0
        add     dx,2
        cmp     r0,dl           ;notice the diskwork =500
        jne     dreadb1         ; if diskwork = 5xx then don't work

;*        SPACE
;*        SB        WAITCPB   ACCEPT INPUT (LRC), CARRY OFF
;*        BER       F2,K,ENDFR  RETURN IF LRC OKAY

        call    waitcpb
        mov     al,k    ;pseudo statement for jmp endfr
;       cmp     al,k
        cmp     al,bl                   ;Anita for cs/386-II
          pop       edi
        je      endfr
          jmp       mastinit            ;Anita for cs/386-II

;*        TITLE     CMNDINIT CMNDREAD
;*     CMNDINIT: INITIALIZE DISK CONTROLLER TO RECEIVE A
;*               COMMAND.  (CKENDV ON 2200T, 4600)
;*
;*          ENTRY: DISK ENABLED
;*
;*          MODIFIED REGISTERS: PC'S,K,CH,CL,F2
;*
;*CMNDINIT BFL       DR,SH, *   WAIT TILL DISK READY (DISK MICROPROCESSOR
;*                              MAY BE ACCESSING DISK)
;*        ORI       CPB,SH,SH INHIBIT INPUT (CRB = 1) ??? SHOULD ALREADY BE 1
;*CMNDINT2 MVI       0A0,K

cmndinit:
        call    breakpt_
        push    edx
        mov     edx,cpust
        test    byte ptr fs:[edx],08h
        pop     edx
        jz      cmndinit
        push    edx
        mov     edx,cpuflg
        mov     byte ptr fs:[edx],04h   ;inhibit input
        pop     edx
cmndint2:
;       mov     k,0a0h      ; replace by immediate addressing mode
;*        CIO       IOBS      SET IOB'S = START OF DISK COMMAND
        push    edx
        mov     edx,iobs
        mov     byte ptr fs: [edx],0a0h
        pop     edx

;*        MVI       0,K
;*        SB        OBSTROBE  STROBE COMMAND TO DISK
;*        SB        WAIT50MS  WAIT UP TO 50MS FOR RESPONSE (IBS) FROM DISK
;*        BTL       CA,SH,CMNDINT2      BRANCH IF NO RESPONSE
;*        MVI       0,F2      FLAG = USE DIABLE SEQUENCE

        mov     k,0
        call    obstrobe    ;signal disk processor to check iobs
        call    wait50ms
;       test    sh,ca
;       jnz     cmndint2
        jc      cmndint2        ;carry off if ibs received, otherwise

;*        BEQH      0C,K,CMNDINT3       OKAY IF RESPONSE = X'C0' (DIABLO/FLOPPY)
;*        BNEH      0D,K,ERROR_90       ERROR IF RESPONSE NOT X'D0'
;*        MVI       01,F2     FLAG = USE PHOENIX SEQUENCE
;*CMNDINT3 SR

cmndint5:
        push    edx             ; input data will be automatically put in K
        mov     edx,ibget       ; now, we must get the data in ibget port
        mov     al,fs:[edx]        ; ourselives
        pop     edx             ;
        cmp     al,0c0h
        je      cmndint3        ; C0 denote diable sequence,(r2)=0
        cmp     al,0d0h
        je      cmndint4
        mov     al,90h         ;90h error
        jmp     error_82

;       push    edx
;       mov     edx,cpuflg
;       mov     byte ptr fs:[edx],0
;       mov     edx,cpurdy
;       mov     byte ptr fs:[edx],0
;       pop     edx
;       jmp     cmndint5
cmndint4:
        mov     r2,1            ;(r2)=1 denote phoenix sequence
        ret
cmndint3:
        mov     r2,0            ;(r2)=0 denote diable sequence
        ret

;*        TITLE     DISKCMND
;*     DISKCMND: SEND COMMAND WITH SECTOR ADDRESS
;*               TO DISK (SKADR ON 2200T, 41D3)
;*
;*          COMMAND FORMAT:
;*                 BYTE1       BYTE2       BYTE3
;*               XX0X XXXX   XXXX XXXX   XXXX XXXX
;*               -- - ----------------------------
;*               !  !         !
;*               !  !         _____ SECTOR ADDRESS (2600
;*               !  !               USED LOW 15 BITS ONLY)
;*               !  !
;*               !  !_____ PLATTER (0 = FIXED, 1 = REMVBL)
;*               !
;*               !________ COMMAND: 00 = READ
;*                                  01 = WRITE
;*                                  10 = COMPARE
;*
;*          ENTRY: DISK ENABLED AND INITIALIZED
;*                AUX F = SECTOR ADDRESS
;*                 F0 = COMMAND:  00 IF READ
;*                                40 IF WRITE
;*                                80 IF COMPARE
;*
;*
;*          RETURN: F0 = 0 IF COMMAND REC'D OK
;*                     <>0 IF ECHO ERROR
;*                  AUX F INCREMENTED TO NEXT SECTOR
;*
;*          NOTE: IF ECHO ERROR OCCURS ON 3RD BYTE OF
;*                COMMAND, 2600 MUST WAIT FOR ACK TO BE
;*                RECEIVED FROM DISK PROCESSOR BEFORE
;*                RE-INITIALIZING DISK PROCESSOR.
;*                (THIS IS BUG ON 2200)
;*
;*          MODIFIED REGISTERS: K,F0
;*
;*DISKCMND MVI       40,K
;*        CIO       IOBS      SET IOBS
;*        TAP       ,ACTDEV
;*        BEQL      3,PH,DISKCMD3
;*        ORI       10,F0,F0  PLATTER = 0 (TYPE 3), 1 (TYPE B)
;*        TPA       ,ACTDEV

diskcmnd:
;       mov     k,40h
        push    edx
        mov     edx,iobs
        mov     byte ptr fs:[edx],40h      ; disk operation in progress
        pop     edx
        mov     dx,actdev
        mov     al,dh
        and     al,0fh
        cmp     al,3
        je      diskcmd3
        or      r0,10h
        mov     actdev,dx

;*DISKCMD3 TAP       ,XF       PC'S = SECTOR ADDRESS
;*        TPA+1     ,XF       INCREMENT SECTOR ADDRESS
;*        SB        OBSECHO   SEND 1ST ADDRESS BYTES
;*        BNR       F0,,DISKCMD1        EXIT IF ECHO ERROR
;*       BFL       1,F2,DISKCMD4       BRANCH IF DIABLO SEQUENCE

diskcmd3:
        mov     dx,xf
        inc     xf
        call    obsecho
        cmp     r0,0
        jne     diskcmd1
        test    r2,1
        jz      diskcmd4

;*        MVI       0,F0
;*        SB        OBSECHO   HIGH BYTE OF SECTOR ADDRESS = 0 (PHOENIX)
;*        BNR       F0,,DISKCMD1        BRANCH IF ECHO ERROR
;*        MV        PH,F0     F0 = 2ND BYTE OF SECTOR ADDR. (DON'T STRIP HIGH BIT)
;*        B         DISKCMD2

        mov     r0,0
        call    obsecho
        cmp     r0,0
        jne     diskcmd1
        mov     r0,dh
        jmp     diskcmd2

;          ANDI      7F,PH,F0  STRIP OFF HIGH BIT OF ADDRESS
diskcmd4: mov    al,dh
        and     al,07fh
        mov     r0,al

;*DISKCMD2 SB        OBSECHO   SEND 2ND ADDRESS BYTE
;*        BNR       F0,,DISKCMD1        EXIT IF ECHO ERROR
;*        MV        PL,F0
;*        SB        OBSECHO   SEND 3RD ADDRESS BYTE
;*        BER       F0,,DISKCMD1        BRANCH IF NO ECHO ERROR

diskcmd2:
        call    obsecho
        cmp     r0,0
        jne     diskcmd1
        mov     r0,dl
        call    obsecho
        cmp     r0,0
        je      diskcmd1

;*AKN5S    EQU       *         (NOTE, 5 SECOND TIMEOUT IS NO MORE)
;*WAITCPB  ANDI      FF-CPB-ENDI-CA,SH,SH   TURN OFF ENDI, CARRY,
;*        BFL       CPB,SH,*  AND WAIT FOR IBS
;*DISKCMD1 SR

akn5s:
waitcpb:
                                        ;Anita Lin for high speed channel board
;         test      hscboard,mxfbit
;         jnz       waitcp_mxf
                                        ;Anita
        push    edx
        mov     edx,cpuflg
        mov     byte ptr fs:[edx],0
        mov     edx,cpurdy
        mov     byte ptr fs:[edx],0
jss8_01:
;	call	breakpt_		;Anita 12/17/90 +, 7/17/91 -, for keyboard
					;;function signal will be destroied
	mov	edx,cpust
	mov	ax,fs:[edx]
					;Anita 12/17/90
					;fixed the bug that old 22c11+mxf
					;; no disk inside will hung.
					;Anita 7/17/91 +,
	  test	    hscboard,mxfbit	;if mxf board
	  jz	    jss8_012
	  mov	    edi,mxfbuf_sts
	  cmp	    byte ptr gs:[edi],077h	;check for shift-reset key
	  jne	    jss8_11		;no, check the keyboard function
	  mov	    byte ptr gs:[edi],0f0h	;reset to command complete
	  pop	    edx
	  mov	    edx,resetproc	;shift-reset pressed, jmp to initial
	  pop	    eax 		;just for stack balance, return cs:ip
	  jmp	    edx
jss8_012:
	test	ah,01h		;reset key pressed ?
	jz	jss8_11 	;no, then check if any other key
	call	delay10
	mov	bx,fs:[edx]
	mov	byte ptr fs:[edx+2],10h
	mov	byte ptr fs:[edx+2],00h
	POP	EDX
	POP	EAX
	MOV	EDX,RESETPROC
	JMP	EDX
				;Anita 12/17/90 -, end of 7/17/91 +
jss8_11:
        test    ah,04h          ;ENDI on ?
        jz      jss8_12
        or      sh,endi         ;set endi flag
        jmp     jss8_13
jss8_12:
        and     sh,0ffh-endi    ;clear endi flag
jss8_13:
        test    al,cpb
        jz      jss8_01
        mov     edx,ibget
        mov     al,fs:[edx]
        mov     k,al
jss8_15:
        pop     edx
diskcmd1:
        ret
                                        ;Anita Lin for high speed channel board
waitcp_mxf:
          mov       edi,mxfbuf_sts
chk_stsc:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_stsc1           ;no, check complete
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;for stack balance, pop cs:ip
          mov       edx,resetproc
          jmp       edx
chk_stsc1:
          and       ah,0f0h
          cmp       ah,0f0h             ;does cmd complete ?
          jne       chk_stsc
          mov       edi,mxfbuf_abs      ;ebx point to mxf 1st port cmd buffer
          mov       word ptr gs:[edi],keyin     ;get one key code
          mov       edi,mxfbuf_sts
          mov       byte ptr gs:[edi],0fh
chk_stsp:
          mov       ah,byte ptr gs:[edi]
          cmp       ah,077h             ;is shft-reset pressed?
          jne       chk_stsp1           ;no, check complete
          mov       byte ptr gs:[edi],0f0h      ;reset to command complete
          pop       edx                 ;for stack balance, pop cs:ip
	  mov	    edx,resetproc
          jmp       edx
chk_stsp1:
          cmp       ah,0f1h             ;does cmd complete without value?
          je        waitcp_mxf          ;yes, get key again
          cmp       ah,0f0h             ;does cmd complete with value?
          jne       chk_stsp
          mov       edi,mxfbuf_parm
          mov       ax,gs:[edi]
          and       sh,0ffh-endi        ;assume not endi, clear endi flag
          test      ah,01               ;with endi ?
          jz        waitcp_ret          ;no, just return with value
          or        sh,endi             ;set endi flag
waitcp_ret:
          mov       k,al
          ret

;*        TITLE     AKN AKN1
;*     AKN: GET ACKNOWLEDGEMENT (IBS) FROM DISK OF
;*          VALID SECTOR ADDRESS (2200T, 4184)
;*
;*          ACKNOWLEDGEMENT CODE:
;*             K      = 0 IF OK
;*             K,BIT0 = 1 IF ERROR#98 (ADDRESSING ERROR)
;*             K,BIT1 = 1 IF ERROR#91 (DISK HARDWARE ERROR
;*             K,BIT2 = 1 IF ERROR#94 (FORMAT KEY ENGAGED)
;*
;*          MODIFIED REGISTERS: K
;*
;*     AKN1: GET ACKNOWLEDGEMENT (IBS) FROM DISK. ERROR IF
;*           NOT RECEIVED WITHIN 5SEC.
;*           (WAIT500MS ON 2200T, 40E5)
;*
;*          ACKNOWLEDGEMENT CODE:
;*            K     = 0 IF OK
;*            K,BIT0 = 1 IF ERROR#95 (SEEK ERROR)
;*            K,BIT1 = 1 IF ERROR#93 (DISK FORMAT ERROR)
;*            K,BIT2 = 1 IF ERROR#96 (CRC ERROR)
;*
;*          MODIFIED REGISTERS: K,F0,CH,CL,AUX0
;*
;*AKN      EQU       *
akn:
;*        SB        WAITCPB   WAIT FOR IBS FROM DISK
;*        BTL       1,K,ERROR#98
;*        BTL       2,K,ERROR#91
;*        BTL       4,K,ERROR#94
;*        B         DELAY5    MUX HAS COMMON I/O DATA LINES
        call    waitcpb
        test    k,01h
        jnz     err_98
        test    k,02h
        jnz     err_91
        test    k,04h
        jnz     err_94
        jmp     delay5
err_98:
        mov     al,98h
        jmp     error_82
err_91:
        mov     al,91h
        jmp     error_82
err_94:
        mov     al,94h
        jmp     error_82

;*AKN1     SB        AKN5S     WAIT FOR ACK FROM DISK (USED TO BE 5 SEC I92)
;*        BTL       1,K,ERROR_95
;*        BTL       2,K,ERROR#93
;*        BTL       4,K,ERROR#96
;*        SR
akn1:   call    akn5s
        test    k,01h
        jnz     err_95
        test    k,02h
        jnz     err_93
        test    k,04h
        jnz     err_96
        ret
err_95:
        mov     al,95h
        jmp     error_82
err_93:
        mov     al,93h
        jmp     error_82
err_96:
        mov     al,96h
        jmp     error_82

;*        TITLE     WAIT50MS
;*     WAIT50MS: WAITS UP TO 50MS FOR AN IBS STROBE
;*               (CRB = 1).   (WAIT50 ON 2200T, 4100)
;*
;*          RETURN: CARRY 0FF IF IBS RECEIVED
;*                  CARRY ON IF IBS NOT RECEIVED
;*                  CRB = 1
;*
;*          MODIFIED REGISTERS: PC'S,CH,CL,K
;*
;*WAIT50MS LPI       #50MS     PC'S = 50MS COUNT
;*        ANDI      FF-CPB-CA,SH,SH     ALLOW INPUT CARRY OFF
;*        SPACE
;*        BTL       CPB,SH,WAIT50M1     BRANCH IF IBS RECEIVED
;*        ACX,1     DD,PHPL,PHPL        INCREMENT COUNT
;*        BFL       CA,SH,;*-2 BRANCH IF < 50MS ELAPSED
;*        SPACE
;*        ORI       CPB,SH,SH INHIBIT INPUT
;*WAIT50M1 SR
wait50ms:
        push    edx
        mov     edx,cpuflg
        mov     byte ptr fs:[edx],0        ;allow input
	mov	edx,cpurdy
        mov     byte ptr fs:[edx],0
        pop     edx
        mov     dx,_50ms
        clc                     ;clear carry
jss8_02:push    edx
	mov	edx,cpust
        test    byte ptr fs:[edx],02h  ;cpu busy in d1 bit of cpust port
        pop     edx
        jnz     wait50m1
        add     dx,1
        jnc     jss8_02         ; carry off if ibs received
        push    edx
        mov     edx,cpuflg
        mov     byte ptr fs:[edx],04h   ;inhibit input
        pop     edx
wait50m1:
        ret
;*        TITLE     OBSECHO
;*     OBSECHO: STROBES (OBS) THE CONTENTS OF F0
;*             AND CHECKS ECHO (IBS)  (STRC ON 2200T,41E8)
;*
;*          ENTRY: F0 = CHARACTER TO STROBE
;*
;*          RETURN: F0 = 0 IF ECHO = CHARACTER
;*                    <> 0 IF ECHO INCORRECT CHARACTER
;*                  K = CHARACTER ECHOED
;*
;*          MODIFIED REGISTERS: K,F0
;*
;*OBSECHO  ORI       CPB,SH,SH INHIBIT INPUT ??? SHOULD ALREADY BE 1 ??
;*        MV        F0,K      K = CHARACTER TO STROBE
;*        SB        OBSTROBE  STROBE CHARACTER (OBS)
;*        SB        WAITCPB   WAIT FOR ECHO
;*        XOR       F0,K,F0   F0 = 0 IFF ECHO = CHARACTER STROBED
;*        B         DELAY10   MUX HAS COMMON I/O DATA LINES
obsecho:
        push    edx
        mov     edx,cpuflg
        mov     byte ptr fs:[edx],04h   ;inhibit input
        pop     edx
        mov     al,r0
        mov     k,al
        call    obstrobe
        call    waitcpb
        mov     al,k
        xor     r0,al
        jmp     delay10

;TITLE     OBSTROBE
;*
;*        OBSTROBE: wait for ready, then output the character
;*                  in K with an OBS strobe.
;*
;*        OBSNR:  OBS the character without waiting for ready.
;*
;*        OBSSP: output a space with an OBS strobe.
;*
;*               SUBROUTINES USED: DELAY5

OBSSP:   MOV       K,20H     ;K = SPACE
OBSTROBE:                    ;WAIT UNTIL DEVICE READY
         call      breakpt_
         push      edx
         MOV       EDX,CPUST
         TEST      BYTE PTR fs:[EDX],08H ;WAIT UNTIL DEVICE READY
         pop       edx
         JZ        OBSTROBE
OBSNR:   CALL      DELAY5    ;FOR DISK 04/22/76
         push      edx
         MOV       EDX,OBS
         MOV       AL,K
         MOV       BYTE PTR fs:[EDX],AL  ;STROBE CHARACTER
         pop       edx
         JMP       DELAY5    ;WAIT FOR 5 USEC


;        FILE = JSSUTIL2,08/19/1982    TITLE     ENABLE
;*
;*        ENABLE: enable the device whose address is
;*                stored in K with an ABS.
;*
;*        ENABLE5: enable the CRT (device address 05)
;*
;*        MODIFIED REGISTERS: K
;*        SUBROUTINES USED: NONE
;*
;*        ENABLED:  enable the 'disk' device (ACTDEV)
;*
ENABLED:
                                        ;Anita Lin for high speed channel board
          test      hscboard,dskbit
          jz        not22c11_II
          ret
not22c11_II:
                                        ;Anita
         XCHG      DX,ACTDEV
         MOV       K,DL
         XCHG      DX,ACTDEV
         JMP       ENABLE

enabnull:
         mov       k,0
         jmp       enable

ENABLE5: MOV       K,5       ;K = 005

enable: push    edx
         MOV       EDX,_ABS   ;ADDRESS STROBE
         MOV       AL,K
         MOV       BYTE PTR fs:[EDX],AL
        pop     edx

;*        TITLE     DELAYS
;*
;*        DELAY10: wait for 10 usec.
;*
;*        DELAY5: wait for 5 usec.
;*
DELAY10: CALL      DELAY5

DELAY5:
                                        ;Anita for 33M cpu
;        push   edx
;        push   ax
;        mov    edx,02h
;jss8_03:
;        mov    al,byte ptr fs:[edx]
;        test   al,01h
;        jz     jss8_03
;        pop    ax
;        pop    edx
                                        ;Anita
         ret
;******************************************************************************
;*WVDM16:
;*      just write r1 & r0 pair to memory location pointed by edx
;******************************************************************************
wvdm16: mov     al,r1
        mov     [edx],al
        mov     al,r0
        mov     [edx+1],al
endfr:
        ret

diskadr:
        mov     al,k
        and     al,0fh
        mov     bl,8
        mul     bl
        mov     dl,al
        and     al,08
        mov     dh,al
        and     dl,70h
        add     dh,3
        add     dl,10h
        mov     actdev,dx
                                        ;Anita Lin for high speed channel board
          shr       dl,4                ;get the board address fist no.
          cmp       dl,3                ;can't large then 3
          jbe       right_addr
          mov       dl,3
right_addr:
          mov       ebx,0
          mov       bl,dl
          mov       eax,dskmemo         ;start from 22c11 micro-code
          mul       ebx
          mov       ebx,eax
          add       ebx,test_addr       ;now add 2
          mov       word ptr gs:[ebx],testdata  ;testdata is 55aah
          and       hscboard,not dskbit ;reset the disk status
          cmp       word ptr gs:[ebx],testdata  ;does first 22c11-II board exist?
          jne       we_know             ;no,
          or        hscboard,dskbit
          mov       ebx,eax
          mov       eax,dword ptr gs:[ebx][434h];get cmd buffer start address
          add       eax,ebx
          mov       rcbaddr,eax         ;save here
          mov       eax,549h            ;549h from board start is reset flag
          add       eax,ebx
          mov       rstaddr,eax
          mov       eax,dword ptr gs:[ebx][438h]        ;get data buffer start address
          add       ebx,eax             ;add by board base address
          mov       dskbuf,ebx
we_know:
                                        ;Anita
        ret
mem_alloc       proc near
;*******************************************************************
;  goal: allocate memeory for the users
;  input: ecx ----- memory size needed
;  output: eax ---- memory location ----positive correct
;                                   ----negative fail
;******************************************************************
        cmp     esi,1
        jnz     mem_01
        mov     eax,0a0h        ; cs-386 ldt
        jmp     mem_04
mem_01:
        cmp     esi,2
        jnz     mem_02
        mov     eax,53000h      ;temporary area
        jmp     mem_04
mem_02:
        cmp     esi,3
        jnz     mem_03
        mov     eax,960h        ; cs-386 system
        jmp     mem_04
mem_03:
        cmp     esi,4
        jnz     mem_04
        mov     eax,0e0h        ; cs-386 tss
mem_04:
        ret
mem_alloc       endp
;
find_alias      proc    near
;***********************************************************
; goal: find the gdt alias or the current ldt alias
; input: ax ----- some selector
; output: ax ---- alias selector
;***********************************************************
        push    bx
        push    ds
        mov     bx,data
        mov     ds,bx
        and     ax,0004h                ;check ldt or gdt descriptor
        jz      gdta                    ;ldt portion
        mov     ax,ldt_alias
        pop     ds
        pop     bx
        ret
gdta:
        mov     ax,gdt_alias            ;gdt portion
        pop     ds
        pop     bx
        ret
find_alias      endp
;
point_at        proc    near
;********************************************************
; goal: put the rights,address,limit in some slot
; method: call by value
;               4  ebp  <----ebp
;               4  eip
;               4  limit
;               2  rights
;               4  address
;               2  slot
; input: put the parameters in the above sequence
; output: none
;************************************************************
        push    ebp
        mov     ebp,esp
        push    ds
        pushad
        mov     ax,[ebp+18]             ;take out slot
        mov     esi,00
        mov     si,ax
        call    find_alias
        mov     ds,ax
        shr     si,03
        mov     bx,[ebp+12]             ;take out rights
        shl     ebx,16                  ;chinese ouzzle rotate
        mov     edx,[ebp+14]            ;take out address
        rol     edx,16                  ;put high byte into byte regs
        mov     bl,dh                   ;base 31..24
        mov     bh,dl                   ;base 23..16
        ror     ebx,8                   ;rotate to final alignment
        mov     eax,[ebp+08]            ;take out limit
        mov     dx,ax                   ;limit 15..0 with base 15..0
        and     eax,000f0000h           ;mask limit 19..16
        or      ebx,eax                 ;or into high order word
        mov     [esi*8],edx             ;store low word
        mov     [esi*8+4],ebx           ;store high word
        popad
        pop     ds
        pop     ebp
        ret     12                      ;clear all parameters
point_at        endp
;
change_at       proc near
;****************************************************
; goal: change the rights of some descriptor
; method: call by value
;               4  ebp  <---ebp
;               4  eip
;               2  rights
;               2  selector
;*****************************************************
        push    ebp
        mov     ebp,esp
        pushad
        push    ds
        mov     ax,[ebp+10]             ;take out selector
        mov     si,ax
        call    find_alias
        mov     ds,ax
        and     esi,0000ffffh
        shr     esi,3                   ;(esi)= entry number
        mov     bx,[ebp+8]              ;take out rights
        or      bx,0f00h                ; the rights occupy 2 bytes
        mov     ax,[esi*8+5]            ; including the limit 19..16
        or      ax,0f0ffh               ; (ingore). the original limit
        and     ax,bx                   ; can't be altered.
        mov     [esi*8+5],ax
        pop     ds
        popad
        pop     ebp
        ret     4
change_at       endp

create_ldt      proc near
;******************************************************
; goal: create a ldt descriptor in th gdt table
;       but its type is still data, not system
; input: ax ----- slot
;       ecx ----- numbers of descriptor in ldt
;****************************************************
        push    bx
        shl     ecx,3
        mov     bx,data_right
        push    esi
        mov     esi,1
        call    allocate
        pop     esi
        pop     bx
        ret
create_ldt      endp

allocate        proc    near
;*****************************************************
; goal: use the point_at and mem_alloc procedures to
;       put information user-independently
; input: ax ---- some slot
;        ecx --- size
;        bx ---- rights
;*****************************************************
        pushad
        bt      bx,2            ; expand up or down
        push    ax
        jc      down
        call    mem_alloc
more:
        push    eax
        push    bx
        push    ecx
        call    point_at
        popad
        ret
down:
        mov     eax,000fffffh   ;adjust the size and address
        bt      bx,14           ; use16 or use32 segment
        jc      u32
        mov     eax,0000ffffh
u32:    sub     eax,ecx         ;
        mov     ecx,eax
        call    mem_alloc
        add     eax,ecx
        jmp     more
allocate        endp
;
get_base        proc    near
;**********************************************************
; goal: obtain the base address pointed by some selector
; input: ax ---- selector
; output: eax ---- base address
;*********************************************************
        push    ds
        push    esi
        push    edx
        mov     si,ax
        and     esi,0000ffffh
        call    find_alias
        mov     ds,ax               ;find the gdt or ldt alias
        shr     si,3
        mov     eax,[esi*8]         ;retrieve the base address
        mov     edx,[esi*8+4]
        shrd    eax,edx,16
        and     eax,00ffffffh
        and     edx,0ff000000h
        or      eax,edx
        pop     edx
        pop     esi
        pop     ds
        ret
get_base        endp

load_desc       proc    near
;*********************************************************
; goal: load the descriptor portion from file
;       to the segment pointed by desc_slot
; input: get from file
;*********************************************************
        push    ds
        push    es
        pushad
        mov     ax,desc_slot
        mov     bx,data_right
        mov     ecx,desc_count
        shl     ecx,3
        push    esi
        mov     esi,2
        call    allocate
        pop     esi
        mov     es,ax
        mov     esi,offset stl_for
        add     esi,desc_loc
        mov     edi,0
        cld
        rep     movsb
        popad
        pop     es
        pop     ds
        ret
load_desc       endp

dqread  proc    near
;***************************************************************
; goal:  read from  one block in memory
;        to another segment pointed by some selector
; method: call by address
;              4  ebp  <------ ebp
;              4  eip
;              4  count
;              4  destination offset
;              2  destination segment
;              4  source offset
;              2  source segment
;************************************************************************
        push    ebp
        mov     ebp,esp
        pushad
        push    ds
        push    es
        mov     ax,[ebp+22]
        mov     ds,ax
        mov     esi,[ebp+18]
        mov     ax,[ebp+16]
        mov     es,ax
        mov     edi,[ebp+12]
        mov     ecx,[ebp+8]
        cld
        rep     movsb
        pop     es
        pop     ds
        popad
        pop     ebp
        ret     16
dqread  endp
;
create_tss      proc    near
;**********************************************************
; goal: create a tss segment and read information from
;       file to this segment
; input: ax --- tss selector
;***********************************************************
        pushad
        push    ax
        mov     ecx,104
        mov     bx,data_right
        push    esi
        mov     esi,4
        call    allocate
        pop     esi
        pop     ax
        mov     bx,ds                   ;strange ! push ds  --- four byte operation
        push    bx
        mov     esi,offset stl_for
        add     esi,tss_loc
        push    esi
        push    ax
        push    00000000h
        push    00000068h
        call    dqread
        mov     ds,ax                   ; ds equal the tss selector
        sub     ax,8                    ; point to ldt selector
        mov     esi,60h
        mov     [esi],ax                ;set the tss's ldt entry = ldt selctor
        add     ax,8
        push    ax
        mov     ax,data
        mov     ds,ax
        push    tss_right
        call    change_at
        popad
        ret
create_tss      endp

load_ldt        proc     near
;*****************************************************
; goal: copy a descriptor form segm_slot
;                         to a entry in predefined segment (task_slot
; input: ax ----- corresponding (ax)-th descriptor
;*****************************************************
        pushad
        push    ds
        push    es
        mov     bx,task_slot
        mov     es,bx
        and     eax,0000ffffh
        shl     eax,3
        mov     edi,eax
        mov     ax,segm_slot
        mov     si,ax
        call    find_alias
        mov     ds,ax
        and     esi,0000fff8h
        cld
        mov     ecx,8
        rep     movsb
        pop     es
        pop     ds
        popad
        ret
load_ldt        endp
;
get_limit       proc    near
;************************************************************
; goal: get limit from the predefined segment
;       pointed by desc_slot
; input: ax ----- (ax)-th descriptor
; output: ecx --- limit
;************************************************************
        push    ds
        push    ebx
        push    esi
        mov     bx,desc_slot
        mov     ds,bx
        mov     si,ax
        and     esi,0000ffffh
        shl     si,3
        mov     ecx,[si]
        and     ecx,0000ffffh
        mov     ebx,[si+4]
        and     ebx,000f0000h
        or      ecx,ebx
        pop     esi
        pop     ebx
        pop     ds
        ret
get_limit       endp

;************************************************
; goal: for create a code alias ,we get it's base address
; input:
; output: eax --- base
;************************************************
get_l_bas       proc
        push    ds
        push    esi
        push    edx
        mov     ax,data
        mov     ds,ax
        mov     si,os_code
        and     esi,0000ffffh
        mov     ax,task_slot
        mov     ds,ax               ;find the gdt or ldt alias
        shr     si,3
        mov     eax,[esi*8]         ;retrieve the base address
        mov     edx,[esi*8+4]
        shrd    eax,edx,16
        and     eax,00ffffffh
        and     edx,0ff000000h
        or      eax,edx
        pop     edx
        pop     esi
        pop     ds
        ret
get_l_bas       endp

get_right       proc    near
;*********************************************************
; goal: get right from predefined segment pointed by desc_slot
; input: ax --- (ax)-th descriptor
; output: bx -- rights
;*********************************************************
        push    ds
        push    esi
        mov     bx,desc_slot
        mov     ds,bx
        mov     si,ax
        and     esi,0000ffffh
        mov     bx,[esi*8+5]
        pop     esi
        pop     ds
        ret
get_right       endp

load_segment    proc near
;**************************************************************
; goal: create segment and copy data from file if necessary
; input: get from file
;**************************************************************
        push    ds
        push    es
        pushad
; null  descriptor
        push    segm_slot
        push    00000000h
        mov     ax,0000h
        push    ax
        push    00000000h
        call    point_at
        mov     ax,0
        call    load_ldt
; ldt alias
        mov     ax,task_slot
        call    get_base
        push    segm_slot
        push    eax
        mov     ax,1
        call    get_right
        push    bx
        mov     ax,1
        call    get_limit
        push    ecx
        call    point_at
        mov     ax,1
        call    load_ldt
; other descriptor
        mov     edx,2
        mov     esi,0
head:
        mov     ebx,offset text_loc
        mov     eax,[ebx+esi]
        cmp     eax,00000010h           ;       i/o portion (base=0ffff8000h, limit=32h)
        jz      iosub
        cmp     eax,00000040h           ;       $init portition (base=0ffff0000h ,limit=0ffffh)
        jz      initsub
        cmp     eax,00000050h           ;high speed channel memory area
        jz      hscsub
        cmp     eax,00000030h           ;       code alias poriton (base = memory allocator give, limit = code size)
        jz      code_a
        push    eax                     ;       stack and code portion (base= same as code segment, limit = same as)
        mov     eax,edx
        call    get_limit
        call    get_right
        and     bx,0004h
        or      bx,0c092h
        mov     ax,segm_slot
        push    esi
        mov     esi,3
        call    allocate
        pop     esi
        pop     eax
        cmp     eax,00h
        jnz     fixed
        jmp     remain
initsub:
        push    segm_slot
        mov     eax,0ffff0000h
        jmp     lab1
hscsub:   push      segm_slot
          mov       eax,70000000h
          jmp       lab1
iosub:
        push    segm_slot
        mov     eax,080000000h
lab1:
        push    eax
        mov     eax,edx
        call    get_right
        push    bx
        call    get_limit
        push    ecx
        call    point_at
        jmp     goto
code_a:
        push    segm_slot
        call    get_l_bas
        jmp     short   lab1
fixed:
        mov     eax,edx
;       call    get_limit
        MOV     ECX,FILE_L      ; system = ?
        push    ecx
        push    segm_slot
        call    dbread
remain:
        mov     eax,edx
        call    get_right
        push    segm_slot
        push    bx
        call    change_at
goto:
        mov     eax,edx
        call    load_ldt
        inc     edx
        cmp     edx,desc_count
        jz      ende
        add     esi,4
        jmp     head
ende:
        popad
        pop     es
        pop     ds
        ret
load_segment    endp

;************************************************************
;* goal: read data from disk to destination place
;* method:
;*          4 ebp <-----ebp
;*          4 eip
;*          2 destination selector
;*          4 sector # to read
;*************************************************************
dbread:
        push    ebp
        mov     ebp,esp
        pushad
        push    es
        call    enabled
        mov     ax,[ebp+8]      ;take out the destination selector
        mov     es,ax
        mov     eax,[ebp+10]    ;take out the sector #
        mov     aux11,ax        ;aux11=ax=sector # to read(must be even)
        mov     bx,stsec
        mov     xf,bx           ;xf=bx=first sector address of cs-386 system
        mov     edi,0           ;es:base= xxxxxxxx ;edi=0
        mov     aux12,0         ;aux12=counter=0(initial)
dbr1:
        mov     ax,aux12
        cmp     ax,aux11
        jae     oneok
        mov     aux10,diskwork256
        call    dread           ;read 256 data in diskwork + 256  place
        mov     aux10,diskwork
        call    dread           ;read 256 data in diskwork place
;
        cmp     aux13,1         ;aux13 = 1 swap bit on
        jnz     noswap
        mov     esi,diskwork
        mov     ebx,0
        mov     edx,255
        mov     ecx,128
swap:
        mov     al,byte ptr [esi+ebx]
        mov     ah,byte ptr [esi+edx]
        mov     byte ptr [esi+ebx],ah
        mov     byte ptr [esi+edx],al
        add     ebx,1
        sub     edx,1
        loop    swap
        mov     aux13,0
noswap:
        mov     esi,diskwork     ;si = the address of first byte for read
        mov     ecx,512
        cld
        rep     movsb
;
        add     aux12,2
;
        cmp     aux12,256
        jb      dbr1
        mov     aux13,1
        mov     aux12,0
        sub     aux11,256
        jmp     dbr1
oneok:
        pop     es
        popad
        pop     ebp
        ret     6
datastart:
code    ends
        end     start,ds:data,ss:stack
