          .386
          .LIST
          PAGE 52,132

CGROUP    GROUP CODE
DGROUP    GROUP DATA,CONST,STACK

CODE      SEGMENT PUBLIC  DWORD  'CODE'
CODE      ENDS
DATA      SEGMENT PUBLIC  PARA   'DATA'
DATA      ENDS
CONST     SEGMENT PUBLIC  DWORD  'CONST'
CONST     ENDS
STACK     SEGMENT STACK   DWORD  'STACK'
STACK     ENDS

INCLUDE   MVPEQU.ASI

CODE      SEGMENT USE32
          ASSUME CS:CODE,DS:CODE,ES:CODE

; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
; ::                                                                          ::
; ::                    m a t h p a k 1                                       ::
; ::                                                                          ::
; ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

; .......... procedures callable from outside mathpack programs ..............................

PUBLIC    MATHADD
PUBLIC    MATHADD1
PUBLIC    MATHADD2
PUBLIC    MATHSUB
PUBLIC    MATHSUB1
PUBLIC    MATHSUB2
PUBLIC    MATHMUL
PUBLIC    MATHMUL1
PUBLIC    MATHMUL2
PUBLIC    MATHDIV
PUBLIC    MATHDIV1
PUBLIC    MATHDIV2
PUBLIC    MATHCMP
PUBLIC    MATHCMP1
PUBLIC    MATHINT
PUBLIC    MATHFIX
PUBLIC    MATHABS
PUBLIC    MATHSGN
PUBLIC    MATHMOD
PUBLIC    MATHRD
PUBLIC    MATHRND0
PUBLIC    MATHRNDX
PUBLIC    MATHNRND
PUBLIC    MATHSQR
PUBLIC    MATHLGT
PUBLIC    MATHSIN
PUBLIC    MATHCOS
PUBLIC    MATHATAN
PUBLIC    MATHASIN
PUBLIC    MATHACOS
PUBLIC    MATHEXP
PUBLIC    MATHLOG
PUBLIC    MATHX2Y
PUBLIC    MATHTAN
PUBLIC    MATHMAX
PUBLIC    MATHMIN
PUBLIC    maxvalue
PUBLIC    maxnvalue
PUBLIC    chk_max
PUBLIC    chk_maxn
PUBLIC    temp_ptr
PUBLIC	  MANREG
PUBLIC	  MAlg
PUBLIC	  PRE_FLG

INCLUDE   MVPREGS.ASI

EXTRN	  CPBASE  :DWORD
EXTRN	  PART_   :BYTE
EXTRN	  PMODE   :NEAR
EXTRN	  SAVESEED:BYTE
EXTRN	  TIMED   :BYTE

PUSHREGS        MACRO
        .xlist
                PUSH    EBX
                PUSH    ECX
                PUSH    EDX
                PUSH    ESI
                PUSH    EDI
                PUSH    EBP
        .list
ENDM

POPREGS         MACRO
        .xlist
                POP     EBP
                POP     EDI
                POP     ESI
                POP     EDX
		POP	ECX
                POP     EBX
        .list
ENDM

INCLUDE 	.\MATH\M1DATA.ASM
INCLUDE 	.\MATH\M2DATA.ASM
INCLUDE 	.\MATH\M3DATA.ASM
INCLUDE 	.\MATH\M4DATA.ASM



MATHCMP1:
                EVEN
                PUSHREGS
                MOV     EDI,EDX                 ;GET OPR_Y
                MOV     ESI,AUX01               ;    OPR_X
                JMP     mcmp_6

MATHCMP:
                EVEN
                PUSHREGS
                MOV     AUX02,EDX               ;
                MOV     EDI,EDX                 ;GET OPR_Y
                ADD     EDX,8                   ;PT TO OPR_X
                MOV     AUX01,EDX
                MOV     ESI,EDX                 ;    OPR_X
MCMP_6:
                MOV     EBX,[ESI+4]
                MOV     EAX,[ESI]               ;EXP_X IN AX
                MOV     EBP,[EDI+4]             ;
                MOV     ECX,[EDI]               ;EXP_Y IN CX
                CMP     AX,CX                   ;CMP EXPONENTS
                JNE     MCMP1                   ;NEEDS ALIGNMENT

                AND     EAX,0FFFF0000H          ;MASK OFF EXP_X
                AND     ECX,0FFFF0000H          ;MASK OFF EXP_Y
                SUB     EAX,ECX                 ;
                SBB     EBX,EBP
                JL      MCMPL
                JG      MCMPG
                OR      EAX,EBX                 ;IS X = Y ?
                JZ      MCMPE                   ;BR, YES
                JNZ     MCMPG

MCMP1:
                XOR     EBX,EBP                 ;CHK SIGN OF THESE TWO VALUE
                JNS     MCMP2                   ;BOTH HAVE SAME SIGN
                OR      EBP,EBP                 ;
                JNS     MCMPL                   ;X IS NEGATIVE VALUE
                JMP     MCMPG                   ;Y IS NEGATIVE VALUE
MCMP2:
                MOV     EBX,EDI                 ;
                CALL    MALG                    ;ALIGNMENT
                MOV     EDI,EBX                 ;
                JMP     MCMP_6                  ;

MCMPL:          MOV     R7,1                    ;A < B
                POPREGS
                RET

MCMPG:          MOV     R7,4                    ;A > B
                POPREGS
                RET
MCMPE:          MOV     R7,2                    ;A = B
                POPREGS
                RET

INCLUDE 	.\MATH\M1ADD.ASM
INCLUDE 	.\MATH\M1MUL.ASM
INCLUDE 	.\MATH\M1DIV.ASM
INCLUDE 	.\MATH\LGT.ASM
INCLUDE 	.\MATH\SQR.ASM
INCLUDE 	.\MATH\EXP.ASM
INCLUDE 	.\MATH\SIN.ASM
INCLUDE 	.\MATH\M1INT.ASM
INCLUDE 	.\MATH\ALG.ASM

CODE            ENDS
		END
