;-----------------------------------------------------------------------
; M1ADD.ASM

MADD_1: 	SUB	ESI,2		    ;PT BACK TO EXP_B
		CALL	MALG		    ;CALL ADDALIGN
		JMP	MADD_2		    ;CONTINUE ADD WITH ALIGNED EXP

SUBRET:
ADDRET:
		MOV	ESI,OFFSET MATHAREA
		CMP	R0,0		;BR, IF DEFAULT ERROR VALUE
		JNE	ADDRET0
		CALL	MANREG
ADDRET0:
		POP	EDI
		MOVSD
		MOVSD
ret_0:
		CMP	ESC_FLAG,-1		;CALLING FROM MATH INTERNAL
		JE	ADDRET1

		AND	EAX,0FFFFH
                POPREGS
ADDRET1:
                RET
ovr_0:
chk_ov_0:
ovr_1:
ovr_2:

MATHADD1:
		EVEN
		PUSHREGS

		MOV	R0,0		    ;NORMAL RETURN FLAG
		MOV	ESI,EDX 	    ;GET OPERAND B PTR
		MOV	EBX,AUX01	    ;GET OPERAND A PTR
		PUSH	EBX		    ;RETURN VALUE LOC
		JMP	ADD_MATH

MATHADD2:
		EVEN
		PUSHREGS

		MOV	R0,0		    ;NORMAL RETURN FLAG
		MOV	ESI,EDX 	    ;GET OPERAND B PTR
		MOV	EBX,AUX01	    ;GET OPERAND A PTR
		PUSH	AUX03		    ;RETURN VALUE LOC
		POP	AUX01		    ;RETURN VALUE LOC
		PUSH	AUX03		    ;RETURN VALUE LOC
		JMP	ADD_MATH

		EVEN
ADD_MATH1:
		PUSH	EDI		;RETURN VALUE BFR
		JMP	ADD_MATH	;
MATHADD:
		EVEN
		MOV	R0,0		    ;NORMAL RETURN FLAG
		ADD	EDX,8		    ;DX RETURN PTR
                PUSHREGS
		MOV	EBX,EDX 	    ;GET OPERAND A PTR
		SUB	EDX,8
		MOV	ESI,EDX 	    ;GET OPERAND B PTR
ADD_MATH0:
		PUSH	EBX		    ;RETURN VALUE LOC

ADD_MATH:
		MOV	EDI,OFFSET MATHAREA
		PUSH	EDI		    ;SAVE MATHAREA PTR

MADD_2:
		LODSW			    ;EXP_B
		CMP	AX,[EBX]	    ;EXP_B = EXP_A ?
		JNZ	MADD_1		    ;NO
		STOSW			    ;YES, SAVE IN MATHAREA

		LODSD
		ADD	EAX,DWORD PTR [EBX+2]
		STOSD

                LODSW                       ;GET M3_B
		ADC	AX,[EBX+6]	    ;ADD M3_B, M3_A WITH CARRY

		STOSW			    ;SAVE M3 IN MATHAREA
		JO	MADD_3		    ;IF OVERFLOW ?
MADD_31:
		POP	EDI		    ;**** CHECK
                JMP     ADDRET              ;NO, RETURN

MADD_30:				;CHK FOR NEG LIMIT
;** IF RESULT OVERFLOW JMP HERE !!

MADD_3:
		POP	EAX		    ;FOR STACK BALANCE
		SUB	EDI,8		    ;DI PT BACK TO BEG OF MATHAREA
		CALL	MANADJ		    ;CALL MANTISSA NORMALIZE
		ADD	EDI,8		    ;DI PT TO END OF MATHAREA
		JMP	ADDRET		    ;RETURN

;---------------------------------------------------------------------------
;MATHSUB ROUTINE
;

MSUB_1:
		SUB	ESI,2		    ;
		CALL	MALG		    ;CALL ALIGNMENT FOR OPERATION
		JMP	MSUB_2		    ;CONTINUE SUB WITH ALIGNED EXP

MATHSUB1:
		PUSHREGS

		MOV	R0,0
		MOV	EBX,EDX 	    ;GET OPR_B
		MOV	ESI,AUX01	    ;GET OPR_A
		PUSH	ESI		    ;RETURN VALUE LOC
		JMP	SUB_MATH

MATHSUB2:
		PUSHREGS

		MOV	R0,0
		MOV	EBX,EDX 	    ;GET OPR_B
		MOV	ESI,AUX01	    ;GET OPR_A
		PUSH	AUX03		    ;RETURN VALUE LOC
		POP	AUX01		    ;RETURN VALUE LOC
		PUSH	AUX03		    ;RETURN VALUE LOC
		JMP	SUB_MATH
		EVEN
SUB_MATH1:
		PUSH	EDI	;RETURN VALUE BFR
		JMP	SUB_MATH
MATHSUB:
		ADD	EDX,8		    ;**
                PUSHREGS

		MOV	R0,0
		MOV	EBX,EDX 	    ;GET OPR_B
		SUB	EBX,8		    ;
		MOV	ESI,EDX 	    ;GET OPR_A
SUB_MATH0:
		PUSH	ESI		    ;RETURN VALUE LOC
SUB_MATH:
		MOV	EDI,OFFSET MATHAREA ;
		PUSH	EDI		    ;SAVE MATHAREA PTR

msub_2: 	LODSW			    ;GET EXP_A
		CMP	AX,[EBX]	    ;EXP_A = EXP_B ?
		JNZ	msub_1		    ;NO
		STOSW			    ;SAVE EXP_RES
		LODSD
		SUB	EAX,DWORD PTR [EBX+2]
		STOSD

                LODSW                       ;GET M3_A
		SBB	AX,[EBX+6]	    ;M3_A - M3_B WITH BORROW
                STOSW                       ;SAVE M3_RES
		JO	MADD_3		    ;IF MANTISSA OVERFLOW ?
MSUB_31:
		POP	EDI		    ;
                JMP     SUBRET              ;NO, RETURN

;---------------------------------------------------------------------------
;ROUTINE FOR ADJUST MANTISSA TO MAKE SURE WITHIN PROPER LIMITS
;
MANADJ:
		EVEN
		MOV	SI,[EDI+6]	    ;SI = M3
		MOV	EBP,DWORD PTR [EDI+2] ;EBP = M1,M2

		PUSH	ESI		    ;SAVE M3
                OR      SI,SI               ;NEG ?
		JS	MOV_2		    ;YES,
                NOT     SI                  ;NO, 2' COMPL M3M2M1
		NEG	EBP			;
		JNZ	MOV_2		    ;
                INC     SI                  ;
MOV_2:
		PUSH	EDI		    ;SAVE MATHAREA PTR

		MOV	EDX,0		    ;SETUP FOR DIVIDE
		MOV	EDI,10		    ;DIVISOR = 10

                MOV     AX,SI               ;START FROM M3
                DIV     DI                  ;
                MOV     SI,AX               ;SAVE NEW M3

		MOV	EAX,EBP 	    ;REMAINDER,M2 / 10
		DIV	EDI		    ;
		MOV	EBP,EAX 	    ;SAVE NEW M2

		TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING
		JNZ	MOV_3		    ;NO,
		CMP	EDX,5		    ;YES, REMAINDER < 5?
		JB	MOV_3		    ;YES,

		INC	EBP		    ;ADD 1 TO M1
		JNZ	MOV_3		    ;CARRY IN?
                INC     SI                  ;YES, ADD 1 TO M3

MOV_3:
		POP	EDI		    ;RESTORE MATHAREA PTR
		POP	EAX		    ;RESTORE ORIGINAL M3
                OR      AX,AX               ;NEG?
		JS	MOV_4		    ;YES,
                NOT     SI                  ;NO, 2' COMPL BACK
		NEG	EBP		    ;
		JNZ	MOV_4		    ;
                INC     SI                  ;

MOV_4:
		MOV	DWORD PTR [EDI+2],EBP  ;PUT NEW M1 IN MATHAREA
		MOV	[EDI+6],SI	   ;	NEW M3

		ADD	WORD PTR [EDI],1    ;ADD 1 IN EXP
		JO	MADJ		    ;JMP IF OVERFLOW
                RET                         ;

;
;ROUTINE TO ADJUEST MANTISSA AND EXPONENT, ENTRY HERE EITHER EXP OR MANTISSA
;IS OVER THE LEGAL BOUND....
;
MADJ:
		PUSH	ECX		    ;SAVE REGS
		PUSH	ESI		    ;
		PUSH	EBX		    ;
		PUSH	EBP		    ;
		MOV	CX,[EDI]	    ;CX = EXP
		MOV	EBP,DWORD PTR [EDI+2]  ;EBP = M1,M2
		MOV	SI,[EDI+6]	    ;SI = M3
		PUSH	ESI		    ;SAVE M3

		OR	SI,SI		    ;MANTISSA NEG?
		JNS	MOV_6		    ;NO, JMP
                NOT     SI                  ;2' COMPL
		NEG	EBP		    ;
		JNZ	MOV_6		    ;
                INC     SI                  ;

MOV_6:
		PUSH	EDX		    ;SAVE REGS
		PUSH	EAX		    ;
		PUSH	EDI		    ;
                OR      CX,CX               ;EXP NEG?
		JNS	MOV_E		    ;NO, JMP
MOV_7:
;		CMP	SI,0918H	    ;MAX VALUE BEFORE * 10
		CMP	SI,0CCCH	    ;MAX VALUE BEFORE * 10
		JNB	MOV_C		    ;JMP, IF >= 0918H

MOV_8:		MOV	EDI,EBP 	    ;MANTISSA * 10
                MOV     DX,SI               ;
		SHL	EBP,1		    ;
                RCL     SI,1                ;
		SHL	EBP,1		    ;
                RCL     SI,1                ;
		ADD	EBP,EDI 	    ;
                ADC     SI,DX               ;
		SHL	EBP,1		    ;
                RCL     SI,1                ;
                DEC     CX                  ;EXP - 1
		JS	MOV_7		    ;JMP, IF EXP NEG

MOV_9:		POP	EDI		    ;RESTORE REGS
		POP	EAX		    ;
		POP	EDX		    ;
		MOV	[EDI],CX	    ;SAVE NEW EXP IN MATHAREA
		POP	ECX		    ;RESTORE ORIGINAL EXP
                OR      CX,CX               ;JMP, IF ORI M3 POS
		JNS	MOV_A		    ;
                NOT     SI                  ;2' COMPL MANTISSA
		NEG	EBP		    ;
		JNZ	MOV_A		    ;
                INC     SI                  ;

MOV_A:		MOV	DWORD PTR [EDI+2],EBP  ;PUT NEW M1 IN MATHAREA
		MOV	[EDI+6],SI	    ;	     M3
MOV_B:
		POP	EBP		    ;RESTORE REGS
		POP	EBX		    ;
		POP	ESI		    ;
		POP	ECX		    ;
                RET                         ;

;** IF M3 >= 0918H .........  ( COULDN'T * 10 WITH VALUE 9999 9999 9999 9)

MOV_C:		JNZ	MOV_D		    ;JMP, IF > 0918H
;		CMP	EBP,04E729FFFH	    ;JMP, IF OVER MAX VALUE COULD REP
		CMP	EBP,0CCCCCCCCH	    ;JMP, IF OVER MAX VALUE COULD REP
		JBE	MOV_8		    ;
MOV_D:
		MOV	R0,61H
		POP	EDI		;RETURN BUFFER PTR
		POP	EAX
		POP	EAX
		POP	EAX		;ORI M3
		MOV	ESI,OFFSET MAXVALUE
		OR	AX,AX		;
		JNS	MO37X_2 	;BR, IF POS
		MOV	ESI,OFFSET MAXNVALUE
MO37X_2:
		MOVSD			;
		MOVSD			;
		JMP	MOV_B

MOV_E:		MOV	EDI,10

MOV_F:		XOR	EDX,EDX
                MOV     AX,SI
                DIV     DI
                MOV     SI,AX
		MOV	EAX,EBP
		DIV	EDI
		MOV	EBP,EAX
		OR	EAX,EAX
		OR	SI,SI
		JZ	MOV_H
                INC     CX
		JNS	MOV_F
		TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING
		JNZ	MOV_G
		CMP	EDX,5
		JB	MOV_G
		INC	EBP
		JNZ	MOV_G
                INC     SI
MOV_G:		JMP	MOV_9

MOV_H:
		MOV	R0,60H
		POP	EDI		;GET RETURN BUFFER PTR
		POP	EAX
		POP	EAX
		POP	EAX
		MOV	ESI,OFFSET ARG_0
		MOVSD
		MOVSD
		JMP	MOV_B

;---------------------------------------------------------------------------
;ROUTINE FOR ADJUST MANTISSA TO MAKE SURE WITHIN PROPER BOUNDARY
;     ENTRY -- ESI PT TO VALUE TO BE REGRESSED..
;
EVEN
MANREG:
	CMP	PRE_FLG,-1
	JE	MANREG_X
	MOV	AX,WORD PTR [ESI+6]	;GET M3
	MOV	EBP,DWORD PTR [ESI+2]	;GET M1, M2
	PUSH	AX			;SAVE M3
	OR	AX,AX			;
	JNS	MANREG_3		;BR, IF POS
	NOT	AX			;NO, 2' COMPL M3M2M1
	NEG	EBP			;
	JNZ	MANREG_3
	INC	AX

MANREG_3:
	MOV	E_CUNT,1		;EXP = 1 (DEFAULT)
	MOV	EDI,10			;
	CMP	AX,0918H		;13 DIGITS?
	JB	MANREG_0
	JA	MANREG_2
	CMP	EBP,04E729FFFH
	JBE	MANREG_0
MANREG_2:
	CMP	AX,05AF3H		;14 DIGITS ?
	JB	MANREG_20
;	JA	MANREG_21		;BR, IF 15 DIGITS
	CMP	EBP,0107A3FF6H		;
	JBE	MANREG_20
	MOV	E_CUNT,2
	MOV	EDI,100 		;
;MANREG_21:
;	 MOV	 E_CUNT,3
;	 MOV	 EDI,1000		 ;
MANREG_20:
	XOR	EDX,EDX 		;
	DIV	DI			;
	MOV	BX,AX			;
	MOV	EAX,EBP 		;
	DIV	EDI			;
	MOV	EBP,EAX 		;

	TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING ?
	JNZ	MANREG_1

	SHR	EDI,1
	CMP	EDX,EDI 		;YES, REMAINDER < 1/2 DIVISOR
	JB	MANREG_1		;YES,

	INC	EBP			;ADD 1 TO M1
	JNZ	MANREG_1		;CARRY IN?
	INC	BX			;YES, ADD 1 TO M3
MANREG_1:
	POP	AX			;GET OLD M3
	OR	AX,AX			;
	JNS	MANREG_5		;BR, IF POS
	NOT	BX			;NO, 2' COMPL M3M2M1
	NEG	EBP			;
	JNZ	MANREG_5
	INC	BX

MANREG_5:
	MOV	WORD PTR [ESI+6],BX	;
	MOV	DWORD PTR [ESI+2],EBP	;
	MOV	BX,E_CUNT		;GET EXP
	ADD	WORD PTR [ESI],BX	;
	RET
MANREG_0:
	POP	AX
MANREG_X:
	RET
