;------------------------------------------------------
;Routine for evaluate N1*X^m+N2*X^(m-1)+N3*X^(m-2)......
;
;	Upon entry: ESI pt to table of coeficients
;		    ECX has # of coeficient in table
;		    EBX pt to the value X
;		    EDI pt to the result parameter
;
PLYEV:
	PUSH	EDI			;SAVE RETURN ADDRESS
	MOV	EDX,ESI 		;EDX - TABLE PTR
	MOV	EAX,DWORD PTR [ESI]	;GET 1ST ENTRY IN TABLE
	MOV	DWORD PTR TEMP_X1,EAX	;
	MOV	EAX,DWORD PTR [ESI+4]	;GET 1ST ENTRY IN TABLE
	MOV	DWORD PTR TEMP_X1+4,EAX ;
PLYEV_1:
	PUSH	ECX			;SAVE COUNT
	PUSH	EBX			;SAVE X PTR
	PUSH	EDX			;SAVE CURRENT TABLE PTR
	MOV	EDI,OFFSET TEMP_X1	;TEMPORY BUFFER
	MOV	EDX,EDI 		;
	CALL	MUL_MATH1		;X * COEFICIENT
	POP	EDX			;RESTORE TABLE PTR
	ADD	EDX,8			;PT TO NEXT ENTRY OF TABLE
	PUSH	EDX			;
	MOV	ESI,OFFSET TEMP_X1	;RESULT OF MUL
	MOV	EBX,EDX 		;TEMPORY BUFFER FOR ADD
	MOV	EDI,ESI 		;
	CALL	ADD_MATH1		;
	POP	EDX			;RESTORE CURRENT TABLE PTR
	POP	EBX			;RESTORE X PTR
	POP	ECX			;RESTORE COUNT
	LOOP	PLYEV_1 		;LOOP AGAIN
	POP	EDI			;RESTORE RETURN LOC
	MOV	ESI,OFFSET TEMP_X1	;
	MOVSD				;
	MOVSD				;
	RET				;

MPLY:
	PUSH	EDI			;
	PUSH	EBX			;
	MOV	EDX,EBX 		;
	MOV	EDI,OFFSET TEMP_Y1	;
	CALL	MUL_MATH1		;CALL MUL FUNCTION
	MOV	EBX,OFFSET TEMP_Y1	;
	MOV	ESI,OFFSET SIN_CO	;
	MOV	ECX,10
	MOV	EDI,EBX 		;
	CALL	PLYEV			;EVAL POLYNOMIAL WITH CORR COE TAB PTR
	MOV	EDX,OFFSET TEMP_Y1	;
	POP	EBX			;
	POP	EDI			;
	PUSH	EDI
	CALL	MUL_MATH1		;CALL MUL FUNCTION
	POP	ESI
	CMP	ESC_FLAG1,-1		;
	JE	MSIN_A			;
	MOV	ESC_FLAG,0
	MOV	PRE_FLG,0
	CALL	MANREG
	POPREGS
	RET

;****************************************************************
;MATHTAN - Find the tangent of value x
;
MATHTAN:
	MOV	R0,0
	MOV	PRE_FLG,-1
	PUSHREGS
	MOV	ESC_FLAG,-1
	MOV	ESC_FLAG1,-1
	PUSH	EDX			;SAVE X PTR
	MOV	ESI,EDX 		;X PTR
	MOV	EDI,OFFSET TEMP_Z2	;
	MOVSD
	MOVSD
	MOV	EDX,OFFSET TEMP_Z2	;
	CALL	SIN_MATH1
	POP	ESI			;GET X PTR
	PUSH	ESI			;
	MOV	EDI,OFFSET TEMP_N	;
	MOVSD
	MOVSD
	MOV	EDX,OFFSET TEMP_N	;
	CALL	COS_MATH1		;
	MOV	EDX,OFFSET TEMP_N	;GET COS(X)
	MOV	EBX,OFFSET TEMP_Z2	;    SIN(X)
	POP	EDI			;RETURN BUFFER PTR
	MOV	EAX,DWORD PTR [EDX+2]	;
	OR	EAX,EAX 		;
	JZ	MTAN_1			;BR, COULD BE ZERO,
MTAN_0:
	PUSH	EDI
	CALL	DIV_MATH0
	POP	ESI
	MOV	ESC_FLAG1,0		;
	MOV	ESC_FLAG,0		;
	MOV	PRE_FLG,0
	CALL	MANREG
	POPREGS
	RET
MTAN_1:
	OR	AX,WORD PTR [EDX+6]	;MAKE SURE ZERO
	JNZ	MTAN_0			;BR, IF NOT
	MOV	ESI,OFFSET MAXVALUE	;GET MAX VALUE
;doesn't make sense!
;	MOV	AX,WORD PTR [EBX+6]	;GET SIN(X) SIGN
;	OR	AX,AX			;
;	JNS	MTAN_2			;BR, IF POS
;	MOV	ESI,OFFSET MAXNVALUE	;GET NEG MAX VALUE
MTAN_2:
	CLD
	MOVSD
	MOVSD
	MOV	R0,62H			;ERROR CODE
	MOV	ESC_FLAG1,0		;
	MOV	ESC_FLAG,0		;
	MOV	PRE_FLG,0
	POPREGS
	RET


;****************************************************************
;MATHSIN - Find the sine of value x
;
MATHSIN:
	MOV	R0,0
	PUSHREGS
	MOV	ESC_FLAG,-1
	MOV	PRE_FLG,-1

SIN_MATH1:

	MOV	AL,0			;FLAG SOMETHING
	JMP	MSIN_1			;

;****************************************************************
;MATHCOS - Find the cosine of value x
;
MATHCOS:
	MOV	R0,0
	PUSHREGS
	MOV	ESC_FLAG,-1
	MOV	PRE_FLG,-1
COS_MATH1:
	MOV	AL,1			;
MSIN_1:
	PUSH	EAX			;SAVE OPERATION FLAG
	MOV	TEMP_PTR,EDX		;SAVE RESULT BUFR PTR
	MOV	EDI,EDX 		;
	MOV	EBX,EDX 		;
	CALL	TMOD			;CONVERT X TO QUADS

;4/24/89 could be a bug here!
;	MOV	MANREG_F,0		;RESET MANREG FLAG
;
	MOV	ESI,OFFSET TEMP_X	;
	MOV	EDI,OFFSET TEMP_Y	;
	CALL	MREG			;REGRESSION
	MOV	ESI,OFFSET TEMP_X	;
	MOV	EBX,OFFSET TEMP_Y	;
	MOV	EDI,ESI 		;
	CALL	SUB_MATH1		;
	POP	EAX			;RESTORE OPERATION FLAG
	OR	AL,AL			;
	JZ	MSIN_2			;BR, IF SIN
	MOV	ESI,OFFSET TEMP_X	;
	MOV	EBX,OFFSET CON_P25	;
	MOV	EDI,ESI 		;
	CALL	ADD_MATH1		;CALL ADD FUNCTION

;3/22/89 ++
MSIN_2:
	MOV	ESI,OFFSET TEMP_X	;COMPARE X WITH .25
	MOV	EDI,OFFSET CON_P25	;
	CALL	PCMP			;
	CMP	AL,1			;BR, IF X < .25
	JE	MSIN_6			;
	CMP	AL,2			;
	JE	MSIN_7			;BR, IF X = .25
MSIN_3:
	MOV	ESI,OFFSET TEMP_X	;COMPARE X WITH .75
	MOV	EDI,OFFSET CON_P75	;
	CALL	PCMP			;
	CMP	AL,1			;x < .75 ?
	JE	MSIN_5			;
	CMP	AL,2			;X = .75
	JE	MSIN_8			;

MSIN_4:
	MOV	ESI,OFFSET TEMP_X	;
	MOV	EBX,OFFSET CON_M1	;
	MOV	EDI,ESI 		;
	CALL	ADD_MATH1		;CALL ADD FUNCTION
	JMP	MSIN_6			;
MSIN_5:
	MOV	ESI,OFFSET CON_P5	;
	MOV	EBX,OFFSET TEMP_X	;
	MOV	EDI,EBX 		;
	CALL	SUB_MATH1		;CALL SUB FUNCTION
MSIN_6:
	MOV	EBX,OFFSET TEMP_X	;
	MOV	EDI,TEMP_PTR		;
	JMP	MPLY			;TO EVAL POLYNORMIAL
MSIN_7:
	MOV	ESI,OFFSET CON_1	;
	JMP	MSIN_9			;
MSIN_8:
	MOV	ESI,OFFSET CON_M1	;
MSIN_9:
	MOV	EDI,TEMP_PTR		;
	MOVSD				;
	MOVSD				;
	CMP	ESC_FLAG1,-1		;
	JE	MSIN_A

	MOV	PRE_FLG,0
	MOV	ESI,TEMP_PTR
	CALL	MANREG			;
	MOV	ESC_FLAG,0
	POPREGS
MSIN_A:
	RET

TMOD:
	MOV	EDX,030H		;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	AND	EDX,MATHMODE		;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	SHR	EDX,1			;
;Could be a bug here !
	MOV	MANREG_F,-1		;TURN FLAG ON TO HAVE MORE PRECISION
;4/24/89
					;FROM CONVERSION
	ADD	EDX,OFFSET TRI_CONV	;
	MOV	EDI,OFFSET TEMP_X	;
	JMP	DIV_MATH0		;JMP TO DIV_MATH0 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF RES BUFFR
					;WHEN RETURN FROM DIV, DIRECTLY TO THE
					;CALLER


;**********************************************
;For some value regression ......
;
MREG:
	LODSW				;
	OR	AX,AX			;
	JS	MREG_1			;
	STOSW				;
	MOVSW				;
	MOVSW				;
	MOVSW				;
	RET
MREG_1:
	MOV	EBX,ESI 		;
	SUB	EBX,2			;
	MOV	AX,1			;
	JMP	mint_2			;CALL INT FUNCTION
	RET

;**********************************************
;MATHATAN - Find the arctangent of X
;
;The algorithm:
;
;	If |x| >= 1, let x' = 1/x, else , x'=x
;	Let z = (2*x')**2
;	Let f(z) = sum ( cn * z**n) where n=0 to 14
;	    arctan(x') = (2*x') * f(z)
;	If x' = 1/x then |arctan(x)| = pi/2 - |arctan(x')|
;	else arctan(x) = arctan(x')
EVEN
MATHATAN:
	MOV	R0,0
	PUSHREGS
	MOV	ESC_FLAG,-1
	mov	esc_flag2,-1
	MOV	PRE_FLG,-1
EVEN
ATAN_MATH:

	PUSH	EDX			;SAVE X PTR
	MOV	AX,WORD PTR [EDX+6]	;CHECK SIGN OF X
	PUSH	EAX			;SAVE SIGN
	OR	AX,AX			;
	JNS	MATAN_1 		;BR, IF POSITIVE

;** ABS(X) ..			IN TEMP_Y1

	NOT	WORD PTR [EDX+6]	;2' COMPLEMENT
	NOT	WORD PTR [EDX+4]	;
	NEG	WORD PTR [EDX+2]	;
	JNZ	MATAN_1 		;
	INC	WORD PTR [EDX+4]	;
	JNZ	MATAN_1 		;
	INC	WORD PTR [EDX+6]	;

MATAN_1:
	MOV	ESI,EDX 		;SET UP FOR COMPARE X AND 1
	PUSH	ESI			;
	MOV	EDI,OFFSET CON_1	;
	CALL	PCMP			;
	POP	ESI			;

	POP	EBX			;RESTORE SIGN OF X
	OR	BX,BX			;
	JNS	MATAN_2 		;BR, IF POSITIVE


	NOT	WORD PTR [ESI+6]	;2' COMPLEMENT
	NOT	WORD PTR [ESI+4]	;
	NEG	WORD PTR [ESI+2]	;
	JNZ	MATAN_2 		;
	INC	WORD PTR [ESI+4]	;
	JNZ	MATAN_2 		;
	INC	WORD PTR [ESI+6]	;
MATAN_2:
	PUSH	EAX			;SAVE COMPARE RESULT
	TEST	AL,1			;X < 1 ?
	JNZ	MATAN_3 		;BR, IF X < 1

;** X'= 1/X .....

	MOV	EBX,OFFSET CON_1	;SET UP CALLING PARAMETERS
	MOV	EDX,ESI 		;
	MOV	EDI,OFFSET TEMP_Y	;TEMP_Y CONTAINS X'
	push	edi
	CALL	DIV_MATH0		;
	pop	esi

;** NOW X' PT BY ESI ....	IN TEMP_X

MATAN_3:
	MOV	EDI,OFFSET TEMP_X	;PUT X' INTO TEMP_X
	MOVSD				;
	MOVSD				;

;** ( 2 * X' ) ......		IN TEMP_Y

	MOV	EBX,OFFSET TEMP_X	;SET UP FOR CALLING MUL
	MOV	EDX,OFFSET CON_2	;
	MOV	EDI,OFFSET TEMP_Y	;
	CALL	MUL_MATH1		;

;** Z = ( 2 * X' ) ** 2 ...	    IN TEMP_X1

	MOV	EBX,OFFSET TEMP_Y	;
	mov	esi,ebx
	mov	edi,offset temp_y2
	movsd
	movsd
	mov	edx,offset temp_y2

	MOV	EDI,OFFSET TEMP_X1	;
	CALL	MUL_MATH1		;

;** EVALUATE F(Z) = SUM ( Cn * ( Z**n ) ..  IN TEMP_Y1
;					       TEMP_X1 -- CURRNET POWER OF Z
;					       TEMP_X2 -- TEMPORY STORAGE
;					       TEMP_Y2 -- VALUE OF Z

	MOV	ESI,OFFSET TEMP_X1	;VALUE OF Z
	MOV	EDI,OFFSET TEMP_Y2	;
	MOVSD
	MOVSD

	MOV	ESI,OFFSET COE_ATAN	;C0
	MOV	EDI,OFFSET TEMP_Y1	;
	MOVSD
	MOVSD
	MOV	EBX,ESI 		;EBX PT TO CURRENT COEFFICIENT
MATAN_4:
	PUSH	EBX			;SAVE COE LIST PTR
	MOV	EDX,OFFSET TEMP_X1	;EDX PT TO CURRENT Z
	MOV	EDI,OFFSET TEMP_X2	;TEMP BUFFER
	CALL	MUL_MATH1		;

	MOV	EBX,OFFSET TEMP_Y1	;
	MOV	EDI,EBX 		;
	MOV	ESI,OFFSET TEMP_X2	;
	CALL	ADD_MATH1		;ADD TO LAST ITEM

	MOV	EBX,OFFSET TEMP_Y2	;ONE MORE POWER
	MOV	EDX,OFFSET TEMP_X1	;EDX PT TO CURRENT Z
	MOV	EDI,OFFSET TEMP_X1	;UPDATE CURRENT Z
	CALL	MUL_MATH1		;
	POP	EBX			;
	ADD	EBX,8			;PT TO NEXT COE
	CMP	EBX,OFFSET COE_ATAN+8*16;
	JNE	MATAN_4

;** ARCTAN(X') = (2*X') * F(Z)
;   WHERE			 (2*X') IN TEMP_Y
;				 F(Z)	IN TEMP_Y1

	MOV	EBX,OFFSET TEMP_Y1
	MOV	EDX,OFFSET TEMP_Y
	MOV	EDI,OFFSET TEMP_Y1
	CALL	MUL_MATH1
	POP	EAX			;RESTORE X|1 COMPARE RESULT
	TEST	AL,1			;X < 1 ?
	JNZ	MATAN_9 		;EXIT
	MOV	EDI,OFFSET TEMP_Y1	;
	MOV	AX,WORD PTR [EDI+6]	;GET MSW OF ARCATAN(X')
	OR	AX,AX			;
	JS	MATAN_5 		;BR, IF NEG

;** ARCATAN (X) = PI/2 - ARCATAN(X') ..

	MOV	ESI,OFFSET PI_2 	;
	MOV	EBX,OFFSET TEMP_Y1	;
	POP	EDI			;GET OLD X PTR
	CALL	SUB_MATH1		;
	SUB	EDI,8			;PT BACK TO X PTR
	JMP	MATAN_7 		;

;** IF ARCATAN(X') IS NEG ..
MATAN_5:
	MOV	ESI,OFFSET PI_2 	;
	MOV	EBX,OFFSET TEMP_Y1	;
	NOT	WORD PTR [EBX+6]	;2' COMPLEMENT
	NOT	WORD PTR [EBX+4]	;
	NEG	WORD PTR [EBX+2]	;
	JNZ	MATAN_6 		;
	INC	WORD PTR [EBX+4]	;
	JNZ	MATAN_6 		;
	INC	WORD PTR [EBX+6]	;
MATAN_6:
	POP	EDI			;RESTORE OLD X PTR
	PUSH	EDI			;
	CALL	SUB_MATH1		;
	POP	EDI			;

	NOT	WORD PTR [EDI+6]	;2' COMPLEMENT
	NOT	WORD PTR [EDI+4]	;
	NEG	WORD PTR [EDI+2]	;
	JNZ	MATAN_7 		;
	INC	WORD PTR [EDI+4]	;
	JNZ	MATAN_7 		;
	INC	WORD PTR [EDI+6]	;
MATAN_7:
	cmp	esc_flag2,0		;needs tri_conv now
	je	atan_x0 		;br, if no

	mov	edx,030H		;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and	edx,mathmode		;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr	edx,1			;
	jz	atan_x0 		;if it's radian then return

	push	edi
	mov	ebx,edi 		;get the result ptr
	add	edx,offset atri_conv-8	;
	call	mul_math1		;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop	edi
atan_x0:
	mov	esc_flag2,0		;reset the flag
	CMP	ESC_FLAG1,-1		;CALLING FROM OTHER MATH
	JE	MATAN_8 		;BR, YES
	MOV	ESC_FLAG,0		;

	MOV	PRE_FLG,0
	POPREGS
MATAN_8:
	RET


MATAN_9:
	POP	EDI
	MOV	ESI,OFFSET TEMP_Y1
	MOVSD
	MOVSD
	SUB	EDI,8			;PREPARE FOR ADJUSTMENT
	JMP	MATAN_7

;**********************************************
;MATHASIN - Find the arcsine of X
;
;The algorithm:
;
;	If |x| > 1, error 69 (argument too large)
;	If |x| = 1, arcsin(x) = sgn(x) * pi/2
;	If |x| < 1, arcsin(x) = arctan(x/sqr(1-x*x))
;
EVEN
MATHASIN:
	MOV	ESC_FLAG3,-1		;
	MOV	PRE_FLG,-1
ASINMATH:
	PUSHREGS
	MOV	R0,0			;
	MOV	ESC_FLAG,-1
	MOV	ESC_FLAG1,-1
	PUSH	EDX			;SAVE X PTR
	MOV	AX,WORD PTR [EDX+6]	;CHECK SIGN OF X
	PUSH	EAX			;SAVE SIGN
	OR	AX,AX			;
	JNS	MASIN_1 		;BR, IF POSITIVE

;** ABS(X) ..			IN TEMP_Y1

	NOT	WORD PTR [EDX+6]	;2' COMPLEMENT
	NOT	WORD PTR [EDX+4]	;
	NEG	WORD PTR [EDX+2]	;
	JNZ	MASIN_1 		;
	INC	WORD PTR [EDX+4]	;
	JNZ	MASIN_1 		;
	INC	WORD PTR [EDX+6]	;

MASIN_1:
	MOV	ESI,EDX 		;SET UP FOR COMPARE X AND 1
	PUSH	ESI			;
	MOV	EDI,OFFSET CON_1	;
	CALL	PCMP			;
	POP	ESI			;

	POP	EBX			;RESTORE SIGN OF X
	OR	BX,BX			;
	JNS	MASIN_2 		;BR, IF POSITIVE


	NOT	WORD PTR [ESI+6]	;2' COMPLEMENT
	NOT	WORD PTR [ESI+4]	;
	NEG	WORD PTR [ESI+2]	;
	JNZ	MASIN_2 		;
	INC	WORD PTR [ESI+4]	;
	JNZ	MASIN_2 		;
	INC	WORD PTR [ESI+6]	;
MASIN_2:
	TEST	AL,1			;X < 1 ?
	JNZ	MASIN_5 		;BR, IF X < 1
	TEST	AL,4			;X > 1 ?
	JNZ	MASIN_4 		;BR, IF X > 1 (ERROR 69)

;** |X| = 1 --> ARCSIN(X) = SGN(X) * PI/2 ..
;
	POP	EDI			;GET THE PTR OF X
	MOV	ESI,OFFSET PI_2 	;ESI PT TO CONSTANT PI/2
	MOVSD				;
	MOVSD				;
	SUB	EDI,8			;
	OR	BX,BX			;X < 0 ?
	JNS	MASIN_3 		;BR, IF POSITIVE
	NOT	WORD PTR [EDI+6]	;2' COMPLEMENT
	NOT	WORD PTR [EDI+4]	;
	NEG	WORD PTR [EDI+2]	;
	JNZ	MASIN_3 		;
	INC	WORD PTR [EDI+4]	;
	JNZ	MASIN_3 		;
	INC	WORD PTR [EDI+6]	;
MASIN_3:
	CMP	ESC_FLAG3,-1
	JNE	ASIN_X0 		;BR, IF NOT FROM BEGINING
	mov	edx,030H		;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and	edx,mathmode		;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr	edx,1			;
	jz	asin_xx 		;if it's radian then return

	push	edi
	mov	ebx,edi 		;get the result ptr
	add	edx,offset atri_conv-8	;
	call	mul_math1		;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop	edi
asin_xx:
	MOV	ESC_FLAG3,0		;RESET
asin_x0:
	MOV	ESC_FLAG,0		;
	MOV	ESC_FLAG1,0		;
	MOV	PRE_FLG,0		;
	POPREGS
	RET

;** |X| > 1 --> ERROR 69 ....
;
MASIN_4:
	POP	EDX			;RESTORE X PTR
	MOV	R0,69H			;FLAG ERROR
	MOV	DWORD PTR [ESI],0	;PUT VALUE = 0
	MOV	DWORD PTR [ESI+4],0	;
	JMP	ASIN_XX 		;EXIT

;** |X| < 1 --> ARCSIN(X) = ARCTAN(X/SQR(1-X*X)) ..
;
MASIN_5:
	PUSH	ESI			;SAVE X PTR
	MOV	EDI,OFFSET TEMP_X	;
	MOVSD				;
	MOVSD				;TEMP_X = X
	MOV	EBX,ESI 		;SET UP FOR MUL_MATH1
	sub	ebx,8			;
	MOV	EDX,OFFSET TEMP_X	;
	MOV	EDI,EDX 		;
	CALL	MUL_MATH1		;TEMP_X = X*X
	MOV	ESI,OFFSET CON_1	;ESI PT TO VALUE 1
	MOV	EBX,OFFSET TEMP_X	;
	MOV	EDI,EBX 		;
	CALL	SUB_MATH1		;TEMP_X = 1 - X*X
	MOV	EDX,OFFSET TEMP_X	;
	CALL	SQR_MATH1		;TEMP_X = SQR(1-X*X)
	POP	EBX			;RESTORE X PTR
	PUSH	EBX			;SAVE X PTR
	MOV	EDX,OFFSET TEMP_X	;
	MOV	EDI,OFFSET TEMP_Z	;
	CALL	DIV_MATH0		;TEMP_Z = X/SQR(1-X*X)
	MOV	EDX,OFFSET TEMP_Z	;

	CALL	ATAN_MATH		;TEMP_Z = ARCTAN(X/SQR(1-X*X))

	POP	EDI			;RESTORE X PTR
	POP	EDI			;RESTORE X PTR
	MOV	ESI,OFFSET TEMP_Z	;
	MOVSD
	MOVSD

	SUB	EDI,8
	CMP	ESC_FLAG3,-1
	JNE	ASIN_X1 		;BR, IF NOT FROM BEGINING
	mov	edx,030H		;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and	edx,mathmode		;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr	edx,1			;
	jz	asin_xx1		;if it's radian then return
	push	edi
	mov	ebx,edi 		;get the result ptr
	add	edx,offset atri_conv-8	;
	call	mul_math1		;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop	edi
asin_xx1:
	MOV	ESC_FLAG3,0		;RESET
ASIN_X1:
	MOV	ESC_FLAG,0
	MOV	ESC_FLAG1,0
	MOV	PRE_FLG,0
	POPREGS
	RET

;**********************************************
;MATHACOS - Find the arccosine of X
;
;The algorithm:
;
;	If |x| > 1, error 69 (argument too large)
;	else arccos(x) = pi/2 - arcsin(x), in radians

EVEN
MATHACOS:
	PUSH	EDX			;SAVE X PTR
	MOV	ESI,EDX 		;
	MOV	EDI,OFFSET TEMP_Z1	;DUPLICATE X
	MOVSD
	MOVSD
	MOV	EDX,OFFSET TEMP_Z1	;
	CALL	ASINMATH		;
	POP	EDX			;RESTORE X PTR
	CMP	R0,0			;BR, IF ERROR
	JNE	MACOS_1 		;ERROR EXIT
	PUSHREGS
	MOV	ESC_FLAG,-1		;
	MOV	EBX,OFFSET TEMP_Z1	;TEMP_Z1 = ARCSIN(X)
	MOV	ESI,OFFSET PI_2 	;PT TO VALUE OF PI_2
	MOV	EDI,EDX 		;RETURN BUFFER
	CALL	SUB_MATH1		;ARCCOS(X) =PI/2 - ARCSIN(X)

	mov	edx,030H		;PREPARE TO TAKE TRIG MODE FROM MATHMODE
	and	edx,mathmode		;GET ARGUMENT MODE
					;RADIANS - 0, DEGREES - 1, GRADS - 2
	shr	edx,1			;
	jz	asin_xx1		;if it's radian then return
	SUB	EDI,8
	push	edi
	mov	ebx,edi 		;get the result ptr
	add	edx,offset atri_conv-8	;
	call	mul_math1		;call  MUL_MATH1 WITH
					;EBX - PTR OF X, EDX - PTR OF Y
					;EDI - PTR OF X
	pop	edi
	MOV	ESC_FLAG,0		;
	POPREGS
MACOS_1:
	RET
