
;**********************************************************************
;MATHMAX -- Finds the max. value of X or Y
;       Input :         EDX + 8 - X ptr
;                       EDX     - Y ptr
;
MATHMAX:
        ADD     EDX,8                   ;EDX PT TO X
        PUSHREGS
        MOV     ESI,EDX                 ;ESI PT TO X
        SUB     EDX,8                   ;
        MOV     EDI,EDX                 ;EDI PT TO Y
        PUSH    EDX                     ;
        CALL    PCMP                    ;COMPARE X AND Y
        POP     EDX                     ;
        TEST    AL,1                    ;X < Y ?
        JNZ     MAX_Y                   ;
MAX_RET:
        POPREGS
        RET
MAX_Y:
        MOV     ESI,EDX                 ;PT TO Y
        ADD     EDX,8                   ;PT TO X
        MOV     EDI,EDX                 ;
        MOVSD
        MOVSD
        JMP     MAX_RET

;**********************************************************************
;MATHMIN -- Finds the min. value of X or Y
;       Input :         EDX + 8 - X ptr
;                       EDX     - Y ptr
;
MATHMIN:
        ADD     EDX,8                   ;EDX PT TO X
        PUSHREGS
        MOV     ESI,EDX                 ;ESI PT TO X
        SUB     EDX,8                   ;
        MOV     EDI,EDX                 ;EDI PT TO Y
        PUSH    EDX                     ;
        CALL    PCMP                    ;COMPARE X AND Y
        POP     EDX                     ;
        TEST    AL,4                    ;X > Y ?
        JNZ     MIN_Y                   ;BR, IF YES
MIN_RET:
        POPREGS
        RET
MIN_Y:
        MOV     ESI,EDX                 ;PT TO Y
        ADD     EDX,8                   ;PT TO X
        MOV     EDI,EDX                 ;
        MOVSD
        MOVSD
        JMP     MIN_RET

;**********************************************************************
;MATHEXP -- RAISES e TO THE POWER X, I.E. FIND THE NATUAL ANTILOG OF X
;               e**X = 10 ** (X* LGT e)
;
MATHEXP:
        MOV     R0,0
        PUSHREGS
        MOV     ESC_FLAG,-1
EXP_MATH1:

        MOV     RS_PTR,EDX              ;SAVE RESULT BUFFER PTR
        MOV     EBX,EDX                 ;SET UP FOR MATHMUL
        MOV     EDX,OFFSET LGT_E        ;
        MOV     EDI,OFFSET TEMP_Z       ;
        CALL    MUL_MATH1               ;TEMP_Z = X * LGT e
        MOV     ESI,OFFSET TEMP_Z       ;
        MOV     EDI,ESI
        CALL    MREG                    ;TAKE INTEGER PART OF TEMP_Z

        MOV     AX,TEMP_Z               ;GET EXPONENT
        OR      AX,AX                   ;
        JNZ     MEXP_1                  ;

        MOV     AX,TEMP_Z+6             ;GET M3
        OR      AX,AX                   ;
        JS      MEXP_10                 ;BR, IF NEG
        CMP     DWORD PTR TEMP_Z+4,0    ;MAKE SURE ONE WORD VALUE
        JNE     MEXP_1                  ;BR, IF NOT
MEXP_3:
        MOV     EBX,OFFSET TEMP_Z       ;SET UP FOR MATHMUL
        MOV     EDX,OFFSET LN_10        ;CONSTANT LN10 = 2.3025850929941
        MOV     EDI,OFFSET TEMP_Z1      ;
        CALL    MUL_MATH1               ;

        MOV     ESI,RS_PTR              ;GET X PTR
        MOV     EBX,OFFSET TEMP_Z1      ;
        MOV     EDI,EBX                 ;
        CALL    SUB_MATH1               ;

;!      MOV     EDX,OFFSET COE_EXP      ;COEFICIENTS OF EXP
        MOV     EBX,OFFSET TEMP_Z1      ;
        MOV     EDI,RS_PTR              ;
        MOV     ESI,OFFSET COE_EXP      ;
        MOV     ECX,24                  ;
        CALL    PLYEV                   ;EVALUATE POLYNOMIAL
        MOV     AX,TEMP_Z+2             ;
        MOV     EDI,RS_PTR              ;
        ADD     WORD PTR [EDI],AX       ;
        JNO     MEXP_4
        CALL    MADJ
MEXP_4:
        CMP     ESC_FLAG1,-1            ;
        JE      MEXP_5                  ;

        MOV     ESC_FLAG,0
        POPREGS
MEXP_5:
        RET

MEXP_10:
        CMP     DWORD PTR TEMP_Z+4,-1   ;MAKE SURE ONE WORD VALUE
        JE      MEXP_3                  ;BR, IF NOT

MEXP_1:
        MOV     AX,TEMP_Z+6             ;CHECK SIGN
        OR      AX,AX                   ;
        JS      MEXP_2                  ;

public  qqq2
qqq2:
; ERROR PROCESSING ....
        MOV     R0,61H                  ;OVERFLOW
        MOV     ESI,OFFSET MAXVALUE     ;GET VALUE PTR OF 9.999999999999E99
        MOV     EDI,RS_PTR              ;RETURN VALUE ADDRESS
        MOVSD
        MOVSD
        JMP     MEXP_4                  ;EXIT
MEXP_2:
        MOV     R0,60H                  ;UNDERFLOW
        MOV     ESI,OFFSET MAXNVALUE    ;GET VALUE PTR OF -9.999999999999E99
        MOV     EDI,RS_PTR              ;RETURN VALUE ADDRESS
        MOVSD
        MOVSD
        JMP     MEXP_4                  ;EXIT
