;******************************************************************
;MATHLGT - Find the logorithm (base 10) of X
;       Input:  EDX pt to value of X
;       Ouput:  X is replace by logorithm of X
;	possible error : X = 0,  ERROR 67 ( LGT(X) = 9.999999999 E99)
;                        X < 0,  ERROR 68 ( LGT(X) = LOG(ABS(X))
;
MATHLGT:
	MOV	R0,0
        PUSHREGS
	MOV	ESC_FLAG,-1
	MOV	PRE_FLG,-1
        MOV     EBX,EDX                 ;
        MOV     EDI,EDX                 ;

LGT_MATH1:
        MOV     TEMP_PTR,EDI            ;RESULT PTR
	CALL	MLGT_3			;ROUTINE TO PROCESS LGT
	OR	AL,AL
	JNZ	MLGT_1			;RETURN FLAG

	MOV	EBX,OFFSET LGT_E	;VALUE OF LGT (E)
        MOV     EDX,OFFSET TEMP_Y       ;
	MOV	EDI,TEMP_PTR
        CALL    MUL_MATH1               ;
	MOV	ESI,TEMP_PTR		;
        MOV     EBX,OFFSET TEMP_Z1
        MOV     EDI,ESI
        CALL    ADD_MATH1               ;
MLGT_1:
	CMP	ESC_FLAG1,-1		;
	JE	MLGT_2			;
	MOV	PRE_FLG,0		;
	MOV	ESI,TEMP_PTR		;
	CALL	MANREG			;TO 12 DIGIT ACCRACY
	MOV	ESC_FLAG,0		;
	POPREGS 			;
MLGT_2:
        RET
MLGT_3:
        MOV     AX,WORD PTR [EBX+6]     ;GET M3_X
        OR      AX,AX                   ;CHECK SIGN
	JS	MLGT_4			;BR, IF NEGATIVE
        OR      AX,WORD PTR [EBX+4]     ;IF X = 0 ?
        OR      AX,WORD PTR [EBX+2]     ;
	JNZ	MLGT_6			;BR, IF NOT ZERO

;** X = 0  --> ERROR 67 LGT(X) = -9.9999999..E99
;
	MOV	R0,67H			;
	MOV	ESI,OFFSET MAXNVALUE	;
	MOV	EDI,TEMP_PTR		;
	MOVSD
	MOVSD
	MOV	AL,1
        RET

;** X < 0 --> ERROR 68, LGT(X) = LGT(ABS(X))
;
MLGT_4:
        MOV     R0,68H                  ;
        MOV     ESI,EBX                 ;
        MOV     EDI,OFFSET TEMP_Z2      ;

	MOV	AX,[ESI]		;GET EXP_X
	MOV	[EDI],AX		;
	MOV	EAX,[ESI+2]		;GET M1,M2
	MOV	CX,[ESI+6]		;M3
	NEG	EAX
	JNZ	MLGT_41
	INC	CX
MLGT_41:
	MOV	[EDI+2],EAX		;
	MOV	[EDI+6],CX		;
	JNO	MLGT_5			;BR, IF MANTISSA STILL WITHIN LIMIT
	CALL	MANADJ			;
MLGT_5:
	MOV	EBX,OFFSET TEMP_Z2	;
;
;TEMP_Z  -- the power of mantissa (in radix 10), mantissa
;TEMP_Z1 -- the exponent of old X
;
MLGT_6:
	XOR	EAX,EAX
	MOV	ESI,EBX 		;
	MOV	AX,[ESI]		;GET EXP_X

	MOV	WORD PTR TEMP_Z,0	;
	MOV	WORD PTR TEMP_Z1,0	;
	MOV	WORD PTR TEMP_Z1+2,AX	;
	MOV	DWORD PTR TEMP_Z1+4,0	;
	OR	AX,AX			;EXP_X IS NEG ?
	JNS	MLGT_61 		;BR, IF POS
	MOV	DWORD PTR TEMP_Z1+4,-1	;MAKE SIGN EXTEND
MLGT_61:
	MOV	ECX,[ESI+2]		;GET M1,M2 OF X
	MOV	DWORD PTR TEMP_Z+2,ECX	;
	MOV	AX,[ESI+6]		;GET M3
	MOV	WORD PTR TEMP_Z+6,AX

	MOV	EDI,OFFSET CON_10+2	;START TO CHECK THE POWER OF MANTISSA
MLGT_8:
	CMP	AX,[EDI+4]		;COMPARE WITH 10^N CONSTANT MANTISSA
	JB	MLGT_9			;BR, WE KNOW WHAT WE ARE
	JA	MLGT_7			;GET 10^(N+1) TO COMPARE
	CMP	ECX,[EDI]		;
	JBE	MLGT_9
MLGT_7:
	ADD	EDI,8			;PT TO NEXT 10^N CONSTANT MANTISSA
	DEC	WORD PTR TEMP_Z 	;
	INC	DWORD PTR TEMP_Z1+2	;
	JNZ	MLGT_8			;
	INC	WORD PTR TEMP_Z1+6	;
	JMP	MLGT_8

MLGT_9:
	MOV	ESI,OFFSET TEMP_Z	;
	MOV	EDI,OFFSET CON_1778	;
	CALL	PCMP			;
	CMP	AL,1			;
	JE	MLGT_C			;

	MOV	ESI,OFFSET TEMP_Z
	MOV	EDI,OFFSET CON_5623
	CALL	PCMP
	CMP	AL,1
	JE	MLGT_A

	DEC	WORD PTR TEMP_Z 	;
	MOV	EBX,OFFSET CON_1	;
	JMP	MLGT_B			;

MLGT_A:
	MOV	EBX,OFFSET CON_3162	;
	MOV	EDX,OFFSET TEMP_Z	;
	MOV	EDI,EDX
	CALL	MUL_MATH1		;

	MOV	EBX,OFFSET ARG_5	;
MLGT_B:
	MOV	ESI,OFFSET TEMP_Z1	;
	MOV	EDI,ESI 		;
	CALL	ADD_MATH1		;
MLGT_C:
	MOV	ESI,OFFSET TEMP_Z	;
	MOV	EBX,OFFSET CON_1	;
	MOV	EDI,ESI 		;
	CALL	ADD_MATH1		;
	MOV	EBX,OFFSET CON_2	;
	MOV	EDX,OFFSET TEMP_Z	;
	MOV	EDI,EDX 		;
	CALL	DIV_MATH0		;

	MOV	ESI,OFFSET CON_1	;
	MOV	EBX,OFFSET TEMP_Z	;
	MOV	EDI,EBX 		;
	CALL	SUB_MATH1		;

	MOV	EDX,OFFSET TEMP_Z	;
	MOV	EBX,EDX 		;
	MOV	EDI,OFFSET TEMP_Y1	;
	CALL	MUL_MATH1		;CALL MUL FUNCTION
	MOV	ESI,OFFSET COE_LGT	;
	MOV	ECX,15			;
	MOV	EDI,OFFSET TEMP_Y1	;
	MOV	EBX,EDI 		;
	CALL	PLYEV			;EVAL POLYNOMIAL WITH CORR COE TAB PTR
	MOV	EDI,OFFSET TEMP_Y	;
	MOV	EBX,OFFSET TEMP_Z	;
	MOV	EDX,OFFSET TEMP_Y1	;
	CALL	MUL_MATH1		;CALL MUL FUNCTION
	MOV	AL,0
        RET

;******************************************************************
;MATHLOG - Find the natural logorithm (base e) of X
;	Input:	EDX pt to value of X
;	Ouput:	X is replace by logorithm of X
;	possible error : X = 0,  ERROR 67 ( LOG(X) = 9.999999999 E99)
;			 X < 0,  ERROR 68 ( LOG(X) = LOG(ABS(X))
;
MATHLOG:
	MOV	R0,0
	PUSHREGS
	MOV	ESC_FLAG,-1
	MOV	PRE_FLG,-1
	MOV	EBX,EDX 		;
	MOV	EDI,EDX 		;
LOG_MATH1:
	MOV	TEMP_PTR,EDI		;RESULT PTR
	CALL	MLGT_3			;ROUTINE TO PROCESS LGT
	JB	MLOG_1			;RETURN FLAG

	MOV	EBX,OFFSET TEMP_Z1	;
	MOV	EDX,OFFSET LN_10	;
	MOV	EDI,OFFSET TEMP_Z2
	CALL	MUL_MATH1		;
	MOV	ESI,OFFSET TEMP_Y	;
	MOV	EBX,OFFSET TEMP_Z2
	MOV	EDI,TEMP_PTR
	CALL	ADD_MATH1		;
MLOG_1:
	CMP	ESC_FLAG1,-1		;
	JE	MLOG_2
	MOV	PRE_FLG,0
	MOV	ESI,TEMP_PTR
	CALL	MANREG
	MOV	ESC_FLAG,0		;
	POPREGS 			;
MLOG_2:
	RET

;******************************************************************
;MATHX2Y - Raise X to the Y power
;	Input:	EDX pt to value of Y, EDX+8 pt to value X
;	Ouput:	X is replace by logorithm of X
;
;	possible error : IF Y = 0 - IF X =  0 THEN ERROR 63, R = 0
;				    IF X <> 0 THEN R = 1.0000
;			 IF X = 0 - IF Y < 0  THEN ERROR 64, R = 9.9999...E99
;				    IF Y > 0  THEN R = 0
;			 IF Y = NONZERO INTEGER -
;

MATHX2Y:
	MOV	R0,0			;
	ADD	EDX,8			;
	PUSHREGS
	MOV	ESC_FLAG,-1
	MOV	PRE_FLG,-1
	MOV	ESI,EDX 		;
	SUB	ESI,8			;ESI - PTR OF Y

	PUSH	EDX			;SAVE RESULT PTR

	MOV	TEMP_PTR,EDX		;TEMP_PTR =  X PTR
	MOV	TEMP_PTR1,ESI		;TEMP_PTR1 = Y PTR
	MOV	EAX,DWORD PTR [EDX+2]	;GET M1,M2_X
	OR	EAX,EAX 		;M1,M2_X = 0 ?
	JNZ	MXY_1
	OR	AX,WORD PTR [EDX+6]	;M3_X = 0 ?
	JNZ	MXY_1
	JMP	MXY_B
MXY_1:
	XOR	ECX,ECX 		;
	MOV	AX,WORD PTR [ESI]	;GET EXP_Y
	MOV	CX,WORD PTR [ESI+6]	;M3_Y
	MOV	EBX,DWORD PTR [ESI+2]	;M1,M2_Y
	OR	AX,AX			;
	JZ	MXY_3			;BR, IF EXP_Y = 0
	OR	EBX,EBX 		;
	JNZ	MXY_11			;BR, IF M1,M2_Y <> 0
	OR	ECX,ECX 		;
	JZ	MXY_3			;BR, IF MANTISSA_Y = 0
MXY_11:
	MOV	ESI,TEMP_PTR1		;GET Y PTR
	MOV	EDI,OFFSET TEMP_Z2	;
	CALL	MREG			;REGRESSION
	MOV	ESI,OFFSET TEMP_Z2	;COMPARE Y AND REG(Y)
	MOV	EDI,TEMP_PTR1		;
	CALL	PCMP			;

	CMP	AL,2			;Y = INTEGER ?
	JNE	MXY_E			;BR, IF NOT

MXY_2:
	XOR	ECX,ECX
	MOV	CX,WORD PTR [TEMP_Z2+6]
	MOV	EBX,DWORD PTR [TEMP_Z2+2]

	MOV	AX,TEMP_Z2		;AX = EXP
	OR	AX,AX			;= 0 ?
	JZ	MXY_3			;BR, YES

	CALL	ALIGN_0

	MOV	CX,AX
	MOV	EBX,EBX
MXY_3:
	MOV	TEMP_Z2,CX		;
	OR	CX,CX			;NEEDS COMPLEMENT ?
	JNS	MXY_4			;BR, NO
	NOT	CX
	NEG	EBX
	JNZ	MXY_4
	INC	CX

MXY_4:

	MOV	DWORD PTR TEMP_Z2+2,EBX
	MOV	WORD PTR TEMP_Z2+6,CX

	MOV	ESI,OFFSET ARG_1	;GET VALUE 1
	MOV	EDI,OFFSET TEMP_Z	;SET RESULT BUFFER PTR
	MOVSD
	MOVSD

	MOV	ESI,TEMP_PTR		;GET X PTR
	MOV	EDI,OFFSET TEMP_Z1	;WORK BUFFER PTR
	MOVSD
	MOVSD
MXY_5:
	SHR	WORD PTR TEMP_Z2+6,1	;CHECK BIT BY BIT
	RCR	DWORD PTR TEMP_Z2+2,1	;
	JNB	MXY_6			;BR, IF BIT IS ZERO

	MOV	EBX,OFFSET TEMP_Z1	;DO THE MULTIPLICATION OF X
	MOV	EDX,OFFSET TEMP_Z	;
	MOV	EDI,EDX 		;
	CALL	MUL_MATH1		;
MXY_6:
	MOV	EAX,DWORD PTR TEMP_Z2+2 ;CHK Y = 0 ?
	OR	EAX,EAX 		;
	JNZ	MXY_61			;
	OR	AX,WORD PTR TEMP_Z2+6	;
	JZ	MXY_7			;

MXY_61:
	MOV	EBX,OFFSET TEMP_Z1	;MULTIPLY CURRENT BY ITSELF
	MOV	EDX,EBX 		;(BASED ON THE ALGORITHM CHECKING Y BIT
	MOV	EDI,EBX 		; BY BIT FROM LEFT TO RIGHT!)
	CALL	MUL_MATH1		;
	JMP	MXY_5
MXY_7:
	MOV	AX,TEMP_Z2		;GET SIGN
	OR	AX,AX			;
	JNS	MXY_9			;BR, IF POSITIVE
	MOV	EBX,OFFSET ARG_1	;
	MOV	EDX,OFFSET TEMP_Z
	POP	EDI			;GET RETURN BUFFER PTR
	PUSH	EDI
	CALL	DIV_MATH0		;
	POP	EDI
MXY_8:
	MOV	PRE_FLG,0
	MOV	ESI,EDI
	CALL	MANREG
	MOV	ESC_FLAG,0		;
	POPREGS
	RET
MXY_9:
	MOV	ESI,OFFSET TEMP_Z	;
MXY_A:
	POP	EDI			;GET RETURN BUFFER PTR
	PUSH	EDI
	MOVSD				;
	MOVSD				;
	POP	EDI
	JMP	MXY_8			;

;** X = 0 ...
;
MXY_B:
	MOV	ESI,TEMP_PTR1		;GET Y PTR
	CMP	WORD PTR [ESI+6],0	;
	JS	MXY_D			;BR, IF Y < 0
	JNZ	MXY_C			;BR, IF Y > 0
	MOV	EAX,DWORD PTR [ESI+2]	;
	OR	EAX,EAX 		;
	JNZ	MXY_C			;
	MOV	R0,63H			;ERROR 63
MXY_C:
	MOV	ESI,OFFSET ARG_0	;CONSTANT 0 PTR
	JMP	MXY_A
MXY_D:
	MOV	R0,64H			;ERROR 64
	MOV	ESI,OFFSET MAXVALUE	 ;MAX VALUE PTR
	JMP	MXY_A

;** X <> 0 AND Y = NON-INTEGER ..
;
MXY_E:
	MOV	EDI,TEMP_PTR		;GET X PTR
	MOV	CX,WORD PTR [EDI+6]	;CHECK X < 0 ?
	OR	CX,CX			;
	JNS	MXY_F0			;BR, IF NOT

	MOV	R0,65H			;ERROR 65

	MOV	ESI,TEMP_PTR		;MAKE RESULT = 10 ** (Y*LGT(|X|))
	MOV	EBX,DWORD PTR [ESI+2]	;
	MOV	CX,WORD PTR [ESI+6]	;
	NOT	CX			; -> |X|
	NEG	EBX			;
	JNZ	MXY_F
	INC	CX
MXY_F:
	MOV	DWORD PTR TEMP_ZZ1+2,EBX;SAVE |X| IN TEMP_ZZ1
	MOV	WORD PTR TEMP_ZZ1+6,CX	;
	MOV	EDI,TEMP_PTR		;
	MOV	AX,WORD PTR [EDI]	;GET EXP_X
	MOV	WORD PTR TEMP_ZZ1,AX	;
	MOV	EDI,OFFSET TEMP_ZZ1	;
MXY_F0:
	MOV	ESC_FLAG1,-1		;
	MOV	EBX,EDI 		;
	MOV	EDI,OFFSET TEMP_N	;
	PUSH	DWORD PTR TEMP_PTR1
	CALL	LOG_MATH1		;
	POP	DWORD PTR TEMP_PTR1
	MOV	EBX,OFFSET TEMP_N	;
	MOV	EDX,TEMP_PTR1		;
	MOV	EDI,OFFSET TEMP_N	;
	CALL	MUL_MATH1		;Y * LGT(|X|)
	MOV	EBX,OFFSET TEMP_N	;
	POP	EDI			;RESTORE RETURN BUFFER PTR
	MOV	EDX,EDI 		;
	MOV	EAX,DWORD PTR [EBX]	;
	STOSD
	MOV	EAX,DWORD PTR [EBX+4]	;
	STOSD
	CALL	EXP_MATH1		;
	MOV	ESC_FLAG1,0		;
	JMP	MXY_8

ALIGN_0:
        PUSH    ECX
        PUSH    EDX
        PUSH    ESI
        PUSH    EDI
	XOR	ECX,ECX 		;
	MOV	EBX,OFFSET TEMP_Z2
        MOV     CX,WORD PTR [EBX]       ;GET EXPONENT PART
	MOV	EDI,DWORD PTR [EBX+2]	;GET LOWER DWORD
	MOV	SI,WORD PTR [EBX+6]	;GET MANTISSA
        MOV     BYTE PTR [POS],0                   ;FLAG MANTISSA > 0
        OR      SI,SI                   ;CHECK SIGN OF MANTISSA
        JNS     SGN_EXP                 ;BR, IF POSITIVE
        MOV     BYTE PTR [POS],-1                  ;FLAG MANTISSA < 0
        NOT     SI                      ;2' COMP
        NEG     EDI                     ;
	JNZ	SGN_EXP 		;BR, IF NO CARRY IN
        INC     SI                      ;CARRY IN
SGN_EXP:
        OR      CX,CX                   ;CHECK EXP SIGN
        JNS     TIMEBY10                ;MANTISSA * 10 LOOP CX TIME
        NEG     CX                      ;
DIVBY10:
	MOV	EBX,10			;PREPARE DIVISOR (10/100/1000/10000)
        DEC     CX                      ;
        JZ      DIV10_0                 ;
	MOV	EBX,100 		;
        DEC     CX                      ;
        JZ      DIV10_0                 ;
	MOV	EBX,1000		;
        DEC     CX                      ;
        JZ      DIV10_0                 ;
	MOV	EBX,10000		;
        DEC     CX                      ;
DIV10_0:
        MOV     EDX,0                   ;
        MOV     EAX,0                   ;
        MOV     AX,SI                   ;START FROM M3
        DIV     BX                      ; M3/10
        MOV     SI,AX                   ;SAVE NEW M3
        MOV     EAX,EDI                 ; M2/10
        DIV     EBX                     ;
        MOV     EDI,EAX                 ;SAVE NEW M2

        OR      CX,CX                   ;MORE DIVIDE TO DO?
        JNZ     DIVBY10                 ;YES
        JMP     ALIGN_SGN               ;

TIMEBY10:
        MOV     DX,SI                   ;DUPLICATE ORI MANTISSA
        MOV     EAX,EDI                 ;
        SHL     EDI,1                   ;MANTISSA * 10
        RCL     SI,1                    ;
        SHL     EDI,1                   ;
        RCL     SI,1                    ;
        ADD     EDI,EAX                 ;
        ADC     SI,DX                   ;
        SHL     EDI,1                   ;
        RCL     SI,1                    ;
        LOOP    TIMEBY10                ;

ALIGN_SGN:
	CMP	BYTE PTR [POS],0		   ;MANTISSA NEED 2'COM ?
        JE      ALGN0_RET               ;NO
        NOT     SI                      ;2' COMP
        NEG     EDI                     ;
	JNZ	ALGN0_RET		;BR, IF NO CARRY IN
        INC     SI                      ;CARRY IN

ALGN0_RET:

MOVE_RES:
	MOV	AX,SI
	MOV	EBX,EDI

        POP     EDI
        POP     ESI
        POP     EDX
        POP     ECX
        RET

POS	DB	0			;FLAG USED BY ALIGN_0, NUMBER POS OR NEG
