;-----------------------------------------------------------------------
;M1DIV.ASM
;

DIVRET:
	MOV	ESI,OFFSET MATHAREA

			;Could be a bug here to generate 14 digits result
			;4/24/89

	CMP	MANREG_F,-1		;IF COMING FROM TRI_CONV
	JE	DIVRET0 		;BR, IF YES
	CMP	R0,0			;BR, IF DEFAULT ERROR VALUE
	JNE	DIVRET0 		;
	CALL	MANREG
DIVRET0:
	POP	EDI
	MOVSD
	MOVSD
	CMP	ESC_FLAG,-1	     ;
	JE	DIVRET1
	POPREGS
DIVRET1:
	RET

MATHDIV1:
	PUSHREGS
	MOV	R0,0			;DX PT TO OPR_Y ( DIVISOR )
	MOV	EBX,AUX01		;BX PT TO OPR_X ( DIVIDEND )
	PUSH	EBX			;RETURN VALUE LOC
	JMP	DIV_MATH

MATHDIV2:
	PUSHREGS
	MOV	R0,0			;DX PT TO OPR_Y ( DIVISOR )
	MOV	EBX,AUX01		;BX PT TO OPR_X ( DIVIDEND )
	PUSH	AUX03			;RETURN VALUE LOC
	POP	AUX01			;RETURN VALUE LOC
	PUSH	AUX03			;RETURN VALUE LOC
	JMP	DIV_MATH

DIV_MATH0:	;The entry pt used by any other MATH routine.....
		;Input : EBX - ptr of X, EDX - ptr of Y, EDI - ptr of return
		;	 buffer

	PUSH	EDI			;SAVE RET VALUE BUFFER
	JMP	DIV_MATH		;

MATHDIV:
	ADD	EDX,8			;**
	PUSHREGS
	MOV	R0,0			;
	MOV	EBX,EDX 		;DX PT TO OPR_Y ( DIVISOR )
	SUB	EDX,8			;BX PT TO OPR_X ( DIVIDEND )
	PUSH	EBX			;RETURN VALUE LOC
DIV_MATH:
	MOV	EDI,OFFSET MATHAREA	;
;!	PUSH	EDI			;SAVE MATHAREA PTR
	CALL	MDIV			;CALL MATH ROUTINE
;!	POP	EDI			;**** CHECK
	JMP	DIVRET			;RETURN

MDIV:
	MOV	ESI,EDX 		;SI PT TO OPR_Y
	MOV	AX,[EBX]		;GET EXP_X
	MOV	EXP_A ,AX		;SAVE IT
	MOV	AX,[ESI]		;GET EXP_Y
	MOV	EXP_B ,AX		;SAVE IT

	MOV	WORD PTR E_CUNT,0	;COUNTER OF EXP_ADJ  ( 10**X )

	mov	cx,[ebx+6]		;get mantissa of opr_x
	mov	ebx,[ebx+2]		;
	mov	ptr_flp,0		;assume x, y both positive
	or	cx,cx			;x < 0 ?
	jns	MDIV_1			;br, if > 0
	not	ptr_flp 		;
	not	cx			;2's complement
	neg	ebx			;
	jnz	MDIV_1			;
	inc	cx			;


MDIV_1:
	mov	dword ptr m1_x,ebx	;save mantissa of x
	mov	m3_x,cx 		;


	mov	dx,[esi+6]		;get mantissa of y
	mov	ebp,[esi+2]		;
	or	dx,dx			;y < 0 ?
	jns	MDIV_2			;
	not	ptr_flp 		;flag y has different sign
	not	dx			;2's complement
	neg	ebp			;
	jnz	MDIV_2			;
	inc	dx			;

MDIV_2:

	mov	dword ptr m1_y,ebp	;save mantissa of y
	mov	m3_y,dx 		;
	or	dx,dx			;m3_y = 0 ?
	jnz	MDIV_3			;
	test	ebp,0ffff0000h		;m2_y = 0 ?
	jnz	MDIV_3			;
	test	ebp,0ffffh		;m1_y = 0 ?
	jnz	MDIV_A			;br to special rotine for simple divisor

	jmp	MDIV_G			;mantissa_y = 0

MDIV_3:
	or	ebx,ebx 		;m1,m2_x = 0 ?
	jnz	MDIV_4			;
	or	cx,cx			;m3_x = 0 ?
	jz	MDIV_9			;mantissa_x = 0


MDIV_4: CALL	MDIV_K			;CALL CON_SUB ROUTINE

MDIV_5:
	test	ptr_flp,1		;oprnds has same sign?
	jz	MDIV_6			;br, if no
	not	dx			;2's complement
	neg	ebp			;
	jnz	MDIV_6			;
	inc	dx			;

MDIV_6:
	mov	[edi+2],ebp		;save m1,m2_quo back
	mov	[edi+6],dx		;     m3_quo

	MOV	AX,EXP_A		;GET EXP_X
	SUB	AX,EXP_B		;SUB BY EXP_Y
	MOV	[EDI],AX		;SAVE EXP_RES BACK

	JNO	MDIV_7			;EXP_RES OVERFLOW ?
	CALL	MADJ			;ADJUST EXP - MANTISSA

MDIV_7: MOV	AX,E_CUNT		;GET COUNTER OF ADJU EXP DIFF
	ADD	[EDI],AX		;ADD TO EXP_RES
	JNO	MDIV_8			;EXP_RES OVERFLOW ?
	CALL	MADJ			;ADJUST EXP - MANTISSA
MDIV_8: RET

MDIV_9:
	MOV	DX,0			;zero result or underflow
	mov	EBP,0			;
	jmp	MDIV_5

;---------------------------------------------------------------------------
;     ( SIMPLE DIVIDE ROUTINE )
;
;IF DIVISOR IS A SINGLE WORD MANTISSA, PROCESS CAN BE SIMPLIFIED AS FOLLOWS
;

MDIV_A: MOV	DX,0			;
	MOV	AX,M3_X 		;GET M3_X
	OR	AX,AX			;= 0 ?
	JNZ	MDIV_B			;NO
	MOV	M3_QUO,AX		;M3_QUO = 0

	MOV	AX,M2_X 		;GET M2_X
	OR	AX,AX			;= 0 ?
	JNZ	MDIV_C			;NO
	MOV	M2_QUO,AX		;M2_QUO = 0

	MOV	AX,M1_X 		;GET M1_X
	OR	AX,AX			;= 0 ?
	JNZ	MDIV_D			;NO
	JMP	MDIV_9			;YES, RESULT = 0

MDIV_B: DIV	BP			;DIVIDED BY SINGLE WORD DIVISOR
	MOV	M3_QUO,AX		;SAVE M3_QUO
	MOV	AX,M2_X 		;GET M2_X
MDIV_C: DIV	BP			;
	MOV	M2_QUO,AX		;SAVE M2_QUO
	MOV	AX,M1_X 		;GET M1_X
MDIV_D: DIV	BP			;
	MOV	M1_QUO,AX		;SAVE M1_QUO
	OR	DX,DX			;REMAINDER = 0 ?
	JZ	MDIV_F			;YES

	CMP	WORD PTR M3_QUO,0CCCH	;M3 OVER MAX LIMIT BEFORE *10 ?
	JAE	MDIV_E			;YES
	JMP	MDIV_3			;NO,  MAKE SURE PRECISION IS ENOUGH

MDIV_E: TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING ?
	JNZ	MDIV_F			;NO
	SHL	DX,1			;
	CMP	DX,BP			;
	JB	MDIV_F			;
	INC	WORD PTR M1_QUO 	;
	JNZ	MDIV_F			;
	INC	WORD PTR M2_QUO 	;
	JNZ	MDIV_F			;
	INC	WORD PTR M3_QUO 	;

MDIV_F:
	mov	ebp,dword ptr m1_quo	;get m1,m2_quo
	MOV	DX,M3_QUO		;    M3_QUO
	JMP	MDIV_5

;-------------------------------------------------------------------------
;THE ABNORMAL CONDITION -- DIVIDED BY ZERO ..................
;
MDIV_G:
	MOV	AX,M1_X
	OR	AX,M2_X
	JNZ	MDIV_I
	OR	AX,M3_X
	JNZ	MDIV_I

	mov	r0,63h			;math error 63

MDIV_H:
	mov	dx,0			;result = 0
	mov	ebp,0			;
	mov	exp_A,0 		;
	mov	exp_b,0 		;
	jmp	MDIV_5			;


;-------------------------------------------------------------------------
;THE ABNORMAL CONDITION -- OVERFLOW .................
;
MDIV_I:
	mov	r0,62h			;math error 62

	mov	ax,m3_x
	or	ax,ax			;
	js	MDIV_I1 		;br, if neg
	mov	exp_a,0057h		;
	mov	exp_b,0 		;
	mov	ebp,04e729fffh		;set default value 9.999999999999e99
	mov	dx,00918h		;
	jmp	MDIV_5			;

MDIV_I1:
	mov	exp_a,0057h		;
	mov	exp_b,0 		;
	mov	ebp,0b18d6001h		;set default value -9.999999999999e99
	mov	dx,0f6e7h		;
	jmp	MDIV_5			;



MDIV_J:
	mov	ebp,1			;
	mov	dx,0			;
	jmp	MDIV_X			;


MDIV_K:
	MOV	WORD PTR E_CUNT,0000	;INIT COUNTER OF EXP ADJU DIFF
	PUSH	EDI			;SAVE MATHAREA PTR

	mov	ebp,dword ptr m1_x	;get m1,m2_x
	mov	dx,m3_x 		;    m3_x

	CMP	DX,M3_Y 		;M3_X > M3_Y ?
	JA	MDIV_M			;YES
	JB	MDIV_Q			;M3_X < M3_Y

	cmp	ebp,dword ptr m1_y	;m1,m2_x > m1,m2_y ?
	jb	MDIV_Q			;br, x < y
	je	MDIV_J			;br, if x = y


MDIV_M:
	mov	ebp,dword ptr m1_y	;get m1,m2_y
	mov	dx,m3_y 		;    m3_y


	MOV	DI,0			;M4_Y = 0
	MOV	M4_X  ,DI		;M4_X = 0
	JMP	MDIV_O

MDIV_N:
	mov	dword ptr m1_y,ebp	;save new m1,m2_y
	mov	m3_y,dx 		;	  m3_y


;---------------------------------------------------------------------------
;IF MANTISSA_A > MANTISSA_B ................
;MANTISSA_B WILL KEEP * 10 UNTIL ( M4_B > 0 ) OR ( > MANTISSA_A )
;
;note: When terminate loop, the last iteration result has not been saved back
;      and the counter of ( * 10 ) will be decrement by 1.
;      The purpose of this loop is make divisor as large as possible.
;

MDIV_O: INC	WORD PTR E_CUNT 	;INC COUNTER OF ( *10 )

	SHL	EBP,1			;MANTISSA_Y * 10
	RCL	DX,1			;
	RCL	DI,1			;
	SHL	EBP,1
	RCL	DX,1			;
	RCL	DI,1			;
	ADD	EBP,DWORD PTR M1_Y
	ADC	DX,M3_Y 		;
	ADC	DI,0			;
	SHL	EBP,1
	RCL	DX,1			;
	ADC	DI,DI			;M4_B = 0 ?
	JNZ	MDIV_P			;NO

	CMP	DX,M3_X 		;M3_Y > M3_X ?
	JA	MDIV_P			;YES
	JB	MDIV_N			;NO, MANTISSA_B * 10 AGAIN



	CMP	EBP,DWORD PTR M1_X	;M1,M2_Y > M1,M2_X ?
	JB	MDIV_N			;Y < X
	JE	MDIV_J			;Y = X

;---------------------------------------------------------------------------
;MANTISSA_Y * 10 UNTIL ( M4_Y NOT EQUAL 0 ) OR ( MAN_Y > MAN_X )
;

MDIV_P: DEC	WORD PTR E_CUNT 	;DEC COUNTER OF ( *10 )
	JMP	MDIV_S			;TO START CON_SUB

;---------------------------------------------------------------------------
;IF MANTISSA_X < MANTISSA_Y WILL COME HERE
;MANTISSA_X WILL KEEP * 10 UNTIL ( M4_X > 0 ) OR ( > MANTISSA_Y )
;

MDIV_Q: MOV	DI,0			;INIT M4_X = 0
MDIV_R: DEC	WORD PTR E_CUNT 	;DEC COUNTER OF ( *10 )

	SHL	EBP,1			;MANTISSA_X * 10
	RCL	DX,1			;
	RCL	DI,1			;
	SHL	EBP,1
	RCL	DX,1			;
	RCL	DI,1			;
	ADD	EBP,DWORD PTR M1_X
	ADC	DX,M3_X 		;
	ADC	DI,0			;
	SHL	EBP,1
	RCL	DX,1			;
	ADC	DI,DI			;
	MOV	DWORD PTR M1_X,EBP
	MOV	M3_X,DX 		;
	MOV	M4_X,DI 		;
	JNZ	MDIV_S			;M4_X = 0 ?

	CMP	DX,M3_Y 		;YES, M3_X < M3_Y ?
	JB	MDIV_R			;YES, AGAIN
	JA	MDIV_S			;NO

	CMP	EBP,DWORD PTR M1_Y	;M1,M2_X > M1,M2_Y ?
	JB	MDIV_R			;X < Y
	JE	MDIV_J			;X = Y

;------------------------------------------------------------------------
;Note: The mantissa of dividend will be expanded from 3 words to 6 words,
;      mantissa = mantissa * 10 **13 and exp = exp -13.
;

MDIV_S: SUB	WORD PTR E_CUNT,13	;EXP_X - 13


	MOV	EBP,DWORD PTR M1_X	;GET M1,M2_X
	MOV	DX,M3_X 		;    M3_X
	MOV	DI,M4_X 		;    M4_X

	MOV	ESI,0			;INIT M5,M6_X

	MOV	ECX,0033H		;MAKE MANTISSA_X * 2*10**13
	CLC				;
MDIV_T:
	RCR	ESI,1
	RCR	DI,1			;
	RCR	DX,1			;
	RCR	EBP,1
	JNB	MDIV_U			;
	ADD	ESI,48C27395H
MDIV_U: LOOP	MDIV_T			;

	MOV	ECX,0030H		;DOES 48 TIMES BINARY SUB

MDIV_V:
	SUB	DI,M1_Y 		;M4_X - M1_Y
	SBB	ESI,DWORD PTR M2_Y	;M5,M6_Y - M2,M3_Y
	JNB	MDIV_W			;JMP, IF NOT BORROW
	ADD	DI,M1_Y 		;RESTORE M4_X
	ADC	ESI,DWORD PTR M2_Y	;RESTOER M5,M6_X

MDIV_W:
	RCL	EBP,1			;ROTATE FOR NEXT BIT SUB
	RCL	DX,1			;
	RCL	DI,1			;
	RCL	ESI,1			;
	LOOP	MDIV_V			;

	NOT	EBP			;GET M1,M2_QUO
	NOT	DX			;    M3_QUO

	TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ	MDIV_X			;NO
	SUB	DI,M1_Y 		;DO MORE BINARY SUB ON M4,M5,M6
	SBB	ESI,DWORD PTR M2_Y
	JB	MDIV_X			;
	INC	EBP
	JNZ	MDIV_X			;
	INC	DX			;
MDIV_X: POP	EDI			;RESTORE MATHAREA PTR
	RET

