;-------------------------------------------------------------
;M1MUL.ASM
;

;-------------------------------------------------------------
;MANTISSA MUL ROUTINE
;

		 EVEN

;-------------------------------------------------------------
;MATHMUL ROUTINE
;
MULRET:
		MOV	ESI,OFFSET MATHAREA	;PREPARE FOR TRANSFER FINAL VAL
		CMP	R0,0			;BR, IF DEFAULT ERROR VALUE
		JNE	MULRET0
		CALL	MANREG
MULRET0:
		POP	EDI
		movsd
		movsd
mulret_0:
		CMP	ESC_FLAG,-1		;BR, IF CALLING FROM MATH INTERNAL
		JE	MULRET1
                POPREGS
MULRET1:
                RET

mulovr_0:
		jmp	mulret_0		;
chk_mulov_0:

mulovr_1:

mulovr_2:

MATHMUL1:
		EVEN
		PUSHREGS
		MOV	R0,0
						;DX PT TO OPR_B
		MOV	EBX,AUX01		;BX PT TO OPR_A
		PUSH	EBX			;RETURN VALUE LOC
		JMP	MUL_MATH

MATHMUL2:
		EVEN
		PUSHREGS
		MOV	R0,0
						;DX PT TO OPR_B
		MOV	EBX,AUX01		;BX PT TO OPR_A
		PUSH	AUX03			;RETURN VALUE LOC
		POP	AUX01			;RETURN VALUE LOC
		PUSH	AUX03			;RETURN VALUE LOC
		JMP	MUL_MATH

MUL_MATH1:
		PUSH	EDI			;RETURN VALUE BFR
		JMP	MUL_MATH		;

MATHMUL:
		EVEN
		MOV	R0,0
		ADD	EDX,8			;**
		PUSHREGS
		MOV	EBX,EDX 		;DX PT TO OPR_B
		SUB	EDX,8			;BX PT TO OPR_A
MUL_MATH0:
		PUSH	EBX			;RETURN VALUE LOC
MUL_MATH:
		MOV	EDI,OFFSET MATHAREA

		CALL	mmul			;CALL MATH ROUTINE
		JMP	MULRET			;

mmul:
	mov	esi,0			;init
	mov	ebp,0			;
	mov	ax,[ebx]		;get exp_a
	mov	exp_a,ax		;save exp_a
	mov	si,word ptr [ebx+6]	;get m3_a
	mov	ebx,dword ptr [ebx+2]	;get m1,m2_a
	mov	ax,[edx]		;get exp_b
	mov	exp_b,ax		;save exp_b
	mov	bp,word ptr [edx+6]	;get m3_b
	mov	ecx,dword ptr [edx+2]	;get m1,m2_b
	mov	ptr_flp,0		;assume same opr_a, opr_b both positive
	or	si,si			;opr_a neg?
	jns	mmul_1			;br, if positive
	not	ptr_flp 		;flag different sign
	not	si			;2's complement opr_a
	neg	ebx			;
	jnz	mmul_1			;
	inc	si			;
mmul_1:
	or	bp,bp			;opr_b neg?
	jns	mmul_2			;br, if positive
	not	ptr_flp 		;flag sign different
	not	bp			;2's complement opr_b
	neg	ecx			;
	jnz	mmul_2			;
	inc	bp
mmul_2:
	xor	edx,edx 		;init
	mov	dword ptr m1_res,0	;
	mov	dword ptr m3_res,0	;
	mov	dword ptr m5_res,0	;

	or	ecx,ecx 		;m1,m2_b = 0 ?
	jz	mmul_4			;br, yes

	or	ebx,ebx 		;m1,m2_a = 0 ?
	jz	mmul_3			;br, yes

	mov	eax,ebx 		;
	mul	ecx			;m1,m2_a * m1,m2_b
	mov	dword ptr m3_res,edx	;
	mov	dword ptr m1_res,eax	;

mmul_3:
	or	esi,esi 		;m3_a = 0 ?
	jz	mmul_5			;br, yes
	mov	eax,esi 		;
	mul	ecx			;m3_a * m1,m2_b
	add	dword ptr m3_res,eax	;
	mov	dword ptr m5_res,edx	;
	jnc	mmul_5			;
	inc	dword ptr m5_res	;
mmul_5:

mmul_4:
	or	ebx,ebx 		;m1,m2_a = 0 ?
	jz	mmul_6			;br, yes
	mov	eax,ebp 		;
	mul	ebx			;m3_b * m1,m2_a
	add	dword ptr m3_res,eax	;
	adc	dword ptr m5_res,edx	;
mmul_6:
	or	esi,esi 		;m3_a = 0 ?
	jz	mmul_7			;br, yes
	mov	eax,esi 		;
	mul	ebp			;m3_a * m3_b
	add	dword ptr m5_res,eax	;
mmul_7:
	mov	ebx,dword ptr m4_res	;check high order mantissa = 0 ?
	or	ebx,ebx 		;
	jnz	mmul_9			;br, if not 0
	or	bx,word ptr m6_res	;
	jnz	mmul_9			;br, if not 0

	mov	bp,0			;for test
	MOV	DX,M3_RES		;GET M3_RES
	CMP	DX,07FFFH		;OVER MAX LIMIT ?
	JBE	MMUL_A			;NO,

MMUL_9: CALL	PMUL_F			;CALL ADJ MANTISSA
	MOV	DX,M3_RES		;GET M3_RES
	JMP	MMUL_B
MMUL_A: MOV	BP,0000
;
MMUL_B:

	mov	ecx,dword ptr m1_res	;get m1,m2 reslut
	cmp	ptr_flp,0		;same sign or not ?
	je	MMUL_C
	mov	ptr_flp,0		;reset
	NOT	DX			;2' COMPL
	neg	ecx
	JNZ	MMUL_C			;
	INC	DX			;

MMUL_C:
	mov	dword ptr [edi+2],ecx	;put m1,m2,m3_res to matharea
	MOV	[EDI+6],DX		;
	MOV	BX,BP			;BP = COUNTER OF ( *10 )
	ADD	BX,EXP_B		;ADD EXP_B
	JNO	MMUL_D			;OVERFLOW ?

	MOV	[EDI],BX		;YES, SAVE CURRENT EXP_RES
	CALL	MADJ			;ADJUST VALUE
	MOV	BX,[EDI]		;GET ADJUSTED EXP_RES

MMUL_D: ADD	BX,EXP_A		;ADD EXP_A TO EXP_RES
	MOV	[EDI],BX		;PUT IN MATHAREA
	JNO	MMUL_E			;OVERFLOW ?
	CALL	MADJ			;YES, ADJUST VALUE
MMUL_E: RET				;


PMUL_F:
	MOV	EBP,0		;COUNT OF EXP CHANGED
PMUL_G:
	MOV	EDX,0		;INIT FOR DIV
	MOV	ECX,1000000	;DIVISOR

	MOV	EAX,DWORD PTR M5_RES
	OR	EAX,EAX 	;IS M5,M6_RES = 0 ?
	JZ	PMUL_GA 	;BR, IF YES
	MOV	EBP,6;6 	;STARTING FROM MIDDLE

	CMP	EAX,100000	;
	JB	PMUL_G5 	;BR, IF LESS

	CMP	EAX,1000000	;
	JB	PMUL_G9 	;BR, IF FIND THE RIGHT DIVISOR, EBP = 6
	INC	EBP
	MOV	ECX,10000000
	CMP	EAX,10000000	;
	JB	PMUL_G9 	;BR, IF FIND THE RIGHT DIVISOR , EBP = 7
	INC	EBP		;
	MOV	ECX,100000000	;DIVISOR
	CMP	EAX,100000000	;
	JB	PMUL_G9 	;BR, EBP = 8
	INC	EBP		;
	MOV	ECX,1000000000	;DIVISOR
	JMP	PMUL_G9 	;

PMUL_G5:
	MOV	ECX,100000	;
	MOV	EBP,5;5 	;
	CMP	EAX,10000	;
	JA	PMUL_G9 	;BR, IF FIND THE RIGHT DIVISOR, EBP = 5
	DEC	EBP
	MOV	ECX,10000
	CMP	EAX,1000	;
	JA	PMUL_G9 	;BR, IF FIND THE RIGHT DIVISOR , EBP = 4
	DEC	EBP
	MOV	ECX,1000
	CMP	EAX,100 	;
	JA	PMUL_G9 	;BR, IF FIND THE RIGHT DIVISOR , EBP = 3
	DEC	EBP
	MOV	ECX,100
	CMP	EAX,10		;
	JA	PMUL_G9 	;BR, IF FIND THE RIGHT DIVISOR , EBP = 2
	DEC	EBP
	MOV	ECX,10		;EBP = 1

PMUL_G9:
	DIV	ECX
	MOV	DWORD PTR M5_RES,EAX	;PUT QUOTIENT (0) BACK
	MOV	EAX,DWORD PTR M3_RES	;
	DIV	ECX			;
	MOV	DWORD PTR M3_RES,EAX	;PUT QUOTIENT BACK
	MOV	EAX,DWORD PTR M1_RES	;
	DIV	ECX			;
	MOV	DWORD PTR M1_RES,EAX	;PUT QUOTIENT BACK

	TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ	PMUL_GA 		;NO
	SHL	EDX,1			;REMAINDER * 2
	CMP	EDX,ECX 		;= DIVISOR ?
	JB	PMUL_GA 		;NO
	INC	DWORD PTR M1_RES	;YES, INC
	JNC	PMUL_GA 		;CARRY ?
	INC	DWORD PTR M3_RES	;
	JNC	PMUL_GA 		;
	INC	DWORD PTR M5_RES	;

;CHECK IF M5,M6 ARE REALLY = 0 HERE !!
;
PMUL_GA:
	XOR	EDX,EDX
	MOV	DX,WORD PTR M5_RES	;
	OR	EDX,EDX 		;
	JZ	PMUL_H			;BR, IF ZERO
	MOV	ECX,10			;
	MOV	AX,DX			;
	XOR	EDX,EDX 		;
	DIV	CX			;DIVIDE BY 10
	MOV	WORD PTR M5_RES,AX	;
	MOV	EAX,DWORD PTR M3_RES	;
	DIV	ECX			;
	MOV	DWORD PTR M3_RES,EAX	;
	MOV	EAX,DWORD PTR M1_RES	;
	DIV	ECX			;
	MOV	DWORD PTR M1_RES,EAX	;
	INC	EBP
	TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ	PMUL_GA 		;NO
	SHL	EDX,1			;REMAINDER * 2
	CMP	EDX,ECX 		;= DIVISOR ?
	JB	PMUL_H			;NO
	INC	DWORD PTR M1_RES	;YES, INC
	JNC	PMUL_H			;CARRY ?
	INC	DWORD PTR M3_RES	;
	JNC	PMUL_H			;
	INC	DWORD PTR M5_RES	;

PMUL_H:
	MOV	EDX,0		;INIT FOR DIV

	MOV	EAX,DWORD PTR M3_RES
	OR	EAX,EAX 	;IS M3,M4_RES = 0 ?
	JZ	PMUL_I		;BR, IF YES

	MOV	ECX,100;	;DIVISOR
	CMP	EAX,100000	;
	JB	PMUL_H5 	;BR, IF LESS
	ADD	EBP,2;3  ;	;

	CMP	EAX,1000000	;
	JB	PMUL_H9 	;BR, IF FIND THE RIGHT DIVISOR, EBP +3
				;    LEAVE  |EAX| < 999
	INC	EBP		;
	MOV	ECX,1000;	;
	CMP	EAX,10000000	;
	JB	PMUL_H9 	;BR, IF FIND THE RIGHT DIVISOR , EBP + 4
	INC	EBP		;
	MOV	ECX,10000;	;DIVISOR
	CMP	EAX,100000000	;
	JB	PMUL_H9 	;BR, EBP + 5
	INC	EBP		;
	MOV	ECX,100000;	;DIVISOR
	CMP	EAX,1000000000	;
	JB	PMUL_H9 	;BR, EBP + 6
	INC	EBP		;
	MOV	ECX,1000000;	;DIVISOR
	JMP	PMUL_H9 	;EBP + 7

PMUL_H5:
	MOV	ECX,10; 	;
	ADD	EBP,1;2 	;EBP + 2
	CMP	EAX,10000	;
	JA	PMUL_H9 	;BR, IF FIND THE RIGHT DIVISOR, EBP + 2

	DEC	EBP		;NO NEED TO ADJUST
	RET
PMUL_H9:
	DIV	ECX
	MOV	DWORD PTR M3_RES,EAX	;PUT QUOTIENT (0) BACK
	MOV	EAX,DWORD PTR M1_RES	;
	DIV	ECX			;
	MOV	DWORD PTR M1_RES,EAX	;PUT QUOTIENT BACK

	TEST	DWORD PTR MATHMODE,0C0H ;ROUNDING
	JNZ	PMUL_I			;NO
	SHL	EDX,1			;REMAINDER * 2
	CMP	EDX,ECX 		;= DIVISOR ?
	JB	PMUL_I			;NO
	INC	DWORD PTR M1_RES	;YES, INC
	JNC	PMUL_I			;CARRY ?
	INC	DWORD PTR M3_RES	;
	JNC	PMUL_I			;
	INC	DWORD PTR M5_RES	;
PMUL_I:
	RET
