;*******************************************************
;MATHSQR - Find the square root of X
;	Input:	EDX pt to value of X
;	Ouput:	X is replace by square root of X
;
EXTRN	MATHPAGE:BYTE
msqr_0:
;	  If X = 0 then square root = 0
	XOR	EAX,EAX
	STOSD
	STOSD
	cmp	esc_flag1,-1		;calling from higher math routine?
	je	msqr_d
	mov	esc_flag,0
	MOV	PRE_FLG,0
	POPREGS
	RET

MATHSQR:
	MOV	R0,0
	PUSHREGS
	mov	esc_flag,-1
	MOV	PRE_FLG,-1		;FLAG WE NEED HIGHER PRECISION
sqr_math1:
	MOV	EDI,EDX 		;EDI PT TO X
	MOV	EBX,EDX 		;EBX PT TO X
	MOV	TEMP_PTR,EDI		;SAVE OUTPUT PTR
	MOV	AX,[EDX+6]		;GET M3_X
	OR	AX,AX			;ERROR, IF X < 0
	JS	msqr_b			;
msqr_2:
	OR	AX,[EDX+4]		;BR, IF X <> 0
	OR	AX,[EDX+2]		;
	JNZ	msqr_3			;
	JMP	msqr_0

msqr_3:
	MOV	ESI,EDX 		;ESI PT TO X (THE GIVEN VALUE)
	MOV	AX,WORD PTR [ESI]	;GET EXP

	PUSH	AX			;save exp

	xor	edx,edx 		;
	mov	dx,[esi+6]		;get m3_x
	mov	ebx,dword ptr [esi+2]	;    m1,m2_x

	mov	eexm,0			;prepare 96 bits buffer for operation
	mov	edxm,edx		;
	mov	ebxm,ebx		;

	mov	ecx,5fh 		;loop counter  (95 times)
	xor	ebp,ebp 		;Initial value
	mov	esi,0			;EBX:EAX:ESI = Xold
	mov	edi,0			;EDX:EBP:EDI = Xnew
	mov	eax,0			;
	mov	ebx,0			;
	mov	edx,0			;

sqr_loop:

	shl	ebxm,1			;
	rcl	edxm,1			;
	rcl	eexm,1			;
	rcl	edi,1			;
	rcl	ebp,1			;
	rcl	ebx,1			;
					;
	shl	ebxm,1			;
	rcl	edxm,1			;
	rcl	eexm,1			;
	rcl	edi,1			;
	rcl	ebp,1			;
	rcl	ebx,1			;
					;
	stc				;
	rcl	esi,1			;
	rcl	eax,1			;
	rcl	edx,1			;
					;
	sub	edi,esi 		;
	sbb	ebp,eax 		;
	sbb	ebx,edx 		;
					;
	jnc	sqr_100 		;
					;
	add	edi,esi 		;
	adc	ebp,eax 		;
	adc	ebx,edx 		;
					;
	dec	esi			;
					;
	dec	ecx			;
	jnz	sqr_loop

sqr_200:


	mov	ebx,offset mathpage+8	;only the integer part been process
	mov	word ptr [ebx],0	;exp should be 0

	mov	edi,1			;scaling factor
	xor	ebp,ebp 		;

sqr_122:
	bsr	ecx,edx 		;make sure we has enough precision
	cmp	ecx,0EH 		;check where the first bit in proper pos?
	je	sqr_123 		;br, if yes
	shl	edi,1			;shift scaling factor
	shl	esi,1			;shift result into proper position
	rcl	eax,1			;
	rcl	edx,1			;
	jmp	sqr_122 		;again

sqr_100:
	inc	esi			;
	dec	ecx			;
	jnz	sqr_loop		;
	jmp	sqr_200 		;

sqr_123:
	mov	word ptr [ebx+6],dx	;put the result into temp buffer
	mov	dword ptr [ebx+2],eax	;

	mov	word ptr con_8f+2,0	;save scaling factor
	mov	dword ptr con_8f+4,edi	;

	POP	AX			;RESTORE EXP
	OR	AX,AX			;
	JZ	msqr_a			;BR, IF EXP = 0
	JS	msqr_8			;BR, IF EXP < 0

	MOV	EBX,OFFSET ODD_COE	;54BC5DC0C21C
	MOV	CX,0FFF3H		;
	TEST	AX,1			;CHECK IF ODD NUMBER
	JNZ	msqr_4			;BR, IF YES
	MOV	EBX,OFFSET EVEN_COE	;00A0724E1809
msqr_4:
	SHR	AX,1			;
	ADD	AX,CX			;
	MOV	WORD PTR [EBX],AX	;
msqr_5:
	MOV	EDX,OFFSET MATHPAGE+8
	MOV	EDI,offset mathpage
	CALL	MUL_MATH1

	MOV	EBX,offset mathpage	;XNEW
	MOV	EDX,OFFSET CON_8F	;scaling factor
	MOV	EDI,temp_ptr		;RESULT BUFFER
	CALL	DIV_MATH0		;
msqr_6:
	cmp	esc_flag1,-1		;calling from higher order math routine?
	je	msqr_7			;br, yes

	MOV	PRE_FLG,0		;
	MOV	ESI,TEMP_PTR		;
	CALL	MANREG			;
	mov	esc_flag,0		;
	POPREGS
        RET
msqr_7:
	ret

msqr_8:
	MOV	EDI,OFFSET ODD_COE	;54BC5DC0C21C
	TEST	AX,1			;CHECK IF ODD NUMBER
	JNZ	msqr_9			;BR, IF YES
	MOV	EDI,OFFSET EVEN_MCOE	;010000000000
msqr_9:
	NEG	AX			;
	MOV	EBX,OFFSET EXP_T	;
	XLAT
	MOV	AH,0FFH 		;
	MOV	EBX,EDI 		;
	MOV	WORD PTR [EBX],AX	;
	JMP	msqr_5			;

msqr_a:
	MOV	EBX,OFFSET MATHPAGE+8	;XNEW
	MOV	EDX,OFFSET CON_8F	;4294967295
	MOV	EDI,TEMP_PTR		;RESULT BUFFER
	CALL	DIV_MATH0		;XNEW = N/XOLD
	JMP	msqr_6
	MOV	EDI,TEMP_PTR
	MOVSD
	MOVSD
	JMP	msqr_6

;	  If parameter < 0 then report error-66 !
msqr_b:
	PUSH	EDI		;SAVE A BIT
	PUSH	EBX
	ADD	EDX,2		;SKIP EXP PORTION
	MOV	EDI,EDX 	;EDI PT TO ?????????DR TO OPERATE
	MOV	ESI,EDX 	;EBX PT TO SOURCE VALUE

	LODSW			;GET M1
	NOT	AX		;COMPLEMENT
	INC	AX		;
	STOSW			;SAVE IN BUFFER
	LODSW			;GET M2
	NOT	AX		;
	ADC	AX,0		;
	STOSW			;
	LODSW			;GET M3
	NOT	AX		;
	ADC	AX,0		;
	STOSW			;
	JNO	msqr_c		;IF VALUE STILL WITHIN THE LIMITS
	SUB	EDI,8		;PT TO THE BEG OF VALUE
	CALL	MANADJ		;NORMALIZATION ROUTINE
msqr_c:
	MOV	R0,66H
	POP	EBX
	POP	EDI
	JMP	msqr_2

msqr_d:
	ret

